(function (root, factory) {
    if (typeof define === "function" && define.amd) {
        define(["exports"], factory);
    } else if (typeof exports === 'object' &&
               typeof exports.nodeName !== 'string') {
        factory(exports);
    } else {
        factory(root.libsodium = {});
    }
})(this, function (exports) {
    "use strict";
    var Module = exports;
    Object.defineProperty(exports, '__esModule', { value: true });
var Module;if(!Module)Module=(typeof Module!=="undefined"?Module:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_WEB=typeof window==="object";var ENVIRONMENT_IS_WORKER=typeof importScripts==="function";var ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;var ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER;if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=function print(x){process["stdout"].write(x+"\n")};if(!Module["printErr"])Module["printErr"]=function printErr(x){process["stderr"].write(x+"\n")};var nodeFS=require("fs");var nodePath=require("path");Module["read"]=function read(filename,binary){filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);if(!ret&&filename!=nodePath["resolve"](filename)){filename=path.join(__dirname,"..","src",filename);ret=nodeFS["readFileSync"](filename)}if(ret&&!binary)ret=ret.toString();return ret};Module["readBinary"]=function readBinary(filename){return Module["read"](filename,true)};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));Module["inspect"]=(function(){return"[Emscripten Module object]"})}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function read(){throw"no read() available (jsc?)"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function printErr(x){console.log(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){throw"NO_DYNAMIC_EXECUTION was set, cannot eval"}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}var Runtime={setTempRet0:(function(value){tempRet0=value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){if(!args.splice)args=Array.prototype.slice.call(args);args.splice(0,0,ptr);return Module["dynCall_"+sig].apply(null,args)}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[null,null,null,null,null,null,null,null],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 2*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-2)/2]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,arguments)}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=DYNAMICTOP;DYNAMICTOP=DYNAMICTOP+size|0;DYNAMICTOP=DYNAMICTOP+15&-16;if(DYNAMICTOP>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){DYNAMICTOP=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var __THREW__=0;var ABORT=false;var EXITSTATUS=0;var undef=0;var tempValue,tempInt,tempBigInt,tempInt2,tempBigInt2,tempPair,tempBigIntI,tempBigIntR,tempBigIntS,tempBigIntP,tempBigIntD,tempDouble,tempFloat;var tempI64,tempI64b;var tempRet0,tempRet1,tempRet2,tempRet3,tempRet4,tempRet5,tempRet6,tempRet7,tempRet8,tempRet9;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}var globalScope=this;function getCFunc(ident){var func=Module["_"+ident];if(!func){abort("NO_DYNAMIC_EXECUTION was set, cannot eval - ccall/cwrap are not functional")}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){ret=Runtime.stackAlloc((str.length<<2)+1);writeStringToMemory(str,ret)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};cwrap=function cwrap(ident,returnType,argTypes){return(function(){return ccall(ident,returnType,argTypes,arguments)})}}))();Module["ccall"]=ccall;Module["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[_malloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(typeof _sbrk!=="undefined"&&!_sbrk.called||!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}Module["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;function UTF8ArrayToString(u8Array,idx){var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;function UTF16ToString(ptr){var i=0;var str="";while(1){var codeUnit=HEAP16[ptr+i*2>>1];if(codeUnit==0)return str;++i;str+=String.fromCharCode(codeUnit)}}Module["UTF16ToString"]=UTF16ToString;function stringToUTF16(str,outPtr,maxBytesToWrite){if(maxBytesToWrite===undefined){maxBytesToWrite=2147483647}if(maxBytesToWrite<2)return 0;maxBytesToWrite-=2;var startPtr=outPtr;var numCharsToWrite=maxBytesToWrite<str.length*2?maxBytesToWrite/2:str.length;for(var i=0;i<numCharsToWrite;++i){var codeUnit=str.charCodeAt(i);HEAP16[outPtr>>1]=codeUnit;outPtr+=2}HEAP16[outPtr>>1]=0;return outPtr-startPtr}Module["stringToUTF16"]=stringToUTF16;function lengthBytesUTF16(str){return str.length*2}Module["lengthBytesUTF16"]=lengthBytesUTF16;function UTF32ToString(ptr){var i=0;var str="";while(1){var utf32=HEAP32[ptr+i*4>>2];if(utf32==0)return str;++i;if(utf32>=65536){var ch=utf32-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}else{str+=String.fromCharCode(utf32)}}}Module["UTF32ToString"]=UTF32ToString;function stringToUTF32(str,outPtr,maxBytesToWrite){if(maxBytesToWrite===undefined){maxBytesToWrite=2147483647}if(maxBytesToWrite<4)return 0;var startPtr=outPtr;var endPtr=startPtr+maxBytesToWrite-4;for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);if(codeUnit>=55296&&codeUnit<=57343){var trailSurrogate=str.charCodeAt(++i);codeUnit=65536+((codeUnit&1023)<<10)|trailSurrogate&1023}HEAP32[outPtr>>2]=codeUnit;outPtr+=4;if(outPtr+4>endPtr)break}HEAP32[outPtr>>2]=0;return outPtr-startPtr}Module["stringToUTF32"]=stringToUTF32;function lengthBytesUTF32(str){var len=0;for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);if(codeUnit>=55296&&codeUnit<=57343)++i;len+=4}return len}Module["lengthBytesUTF32"]=lengthBytesUTF32;function demangle(func){var hasLibcxxabi=!!Module["___cxa_demangle"];if(hasLibcxxabi){try{var buf=_malloc(func.length);writeStringToMemory(func.substr(1),buf);var status=_malloc(4);var ret=Module["___cxa_demangle"](buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}}var i=3;var basicTypes={"v":"void","b":"bool","c":"char","s":"short","i":"int","l":"long","f":"float","d":"double","w":"wchar_t","a":"signed char","h":"unsigned char","t":"unsigned short","j":"unsigned int","m":"unsigned long","x":"long long","y":"unsigned long long","z":"..."};var subs=[];var first=true;function dump(x){if(x)Module.print(x);Module.print(func);var pre="";for(var a=0;a<i;a++)pre+=" ";Module.print(pre+"^")}function parseNested(){i++;if(func[i]==="K")i++;var parts=[];while(func[i]!=="E"){if(func[i]==="S"){i++;var next=func.indexOf("_",i);var num=func.substring(i,next)||0;parts.push(subs[num]||"?");i=next+1;continue}if(func[i]==="C"){parts.push(parts[parts.length-1]);i+=2;continue}var size=parseInt(func.substr(i));var pre=size.toString().length;if(!size||!pre){i--;break}var curr=func.substr(i+pre,size);parts.push(curr);subs.push(curr);i+=pre+size}i++;return parts}function parse(rawList,limit,allowVoid){limit=limit||Infinity;var ret="",list=[];function flushList(){return"("+list.join(", ")+")"}var name;if(func[i]==="N"){name=parseNested().join("::");limit--;if(limit===0)return rawList?[name]:name}else{if(func[i]==="K"||first&&func[i]==="L")i++;var size=parseInt(func.substr(i));if(size){var pre=size.toString().length;name=func.substr(i+pre,size);i+=pre+size}}first=false;if(func[i]==="I"){i++;var iList=parse(true);var iRet=parse(true,1,true);ret+=iRet[0]+" "+name+"<"+iList.join(", ")+">"}else{ret=name}paramLoop:while(i<func.length&&limit-->0){var c=func[i++];if(c in basicTypes){list.push(basicTypes[c])}else{switch(c){case"P":list.push(parse(true,1,true)[0]+"*");break;case"R":list.push(parse(true,1,true)[0]+"&");break;case"L":{i++;var end=func.indexOf("E",i);var size=end-i;list.push(func.substr(i,size));i+=size+2;break};case"A":{var size=parseInt(func.substr(i));i+=size.toString().length;if(func[i]!=="_")throw"?";i++;list.push(parse(true,1,true)[0]+" ["+size+"]");break};case"E":break paramLoop;default:ret+="?"+c;break paramLoop}}}if(!allowVoid&&list.length===1&&list[0]==="void")list=[];if(rawList){if(ret){list.push(ret+"?")}return list}else{return ret+flushList()}}var parsed=func;try{if(func=="Object._main"||func=="_main"){return"main()"}if(typeof func==="number")func=Pointer_stringify(func);if(func[0]!=="_")return func;if(func[1]!=="_")return func;if(func[2]!=="Z")return func;switch(func[3]){case"n":return"operator new()";case"d":return"operator delete()"}parsed=parse()}catch(e){parsed+="?"}if(parsed.indexOf("?")>=0&&!hasLibcxxabi){Runtime.warnOnce("warning: a problem occurred in builtin C++ name demangling; build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling")}return parsed}function demangleAll(text){return text.replace(/__Z[\w\d_]+/g,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){return demangleAll(jsStackTrace())}Module["stackTrace"]=stackTrace;var PAGE_SIZE=4096;function alignMemoryPage(x){if(x%4096>0){x+=4096-x%4096}return x}var HEAP;var HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;var STATIC_BASE=0,STATICTOP=0,staticSealed=false;var STACK_BASE=0,STACKTOP=0,STACK_MAX=0;var DYNAMIC_BASE=0,DYNAMICTOP=0;function enlargeMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value "+TOTAL_MEMORY+", (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.")}var TOTAL_STACK=Module["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||33554432;var totalMemory=64*1024;while(totalMemory<TOTAL_MEMORY||totalMemory<2*TOTAL_STACK){if(totalMemory<16*1024*1024){totalMemory*=2}else{totalMemory+=16*1024*1024}}if(totalMemory!==TOTAL_MEMORY){Module.printErr("increasing TOTAL_MEMORY to "+totalMemory+" to be compliant with the asm.js spec (and given that TOTAL_STACK="+TOTAL_STACK+")");TOTAL_MEMORY=totalMemory}assert(typeof Int32Array!=="undefined"&&typeof Float64Array!=="undefined"&&!!(new Int32Array(1))["subarray"]&&!!(new Int32Array(1))["set"],"JS engine does not provide full typed array support");var buffer;buffer=new ArrayBuffer(TOTAL_MEMORY);HEAP8=new Int8Array(buffer);HEAP16=new Int16Array(buffer);HEAP32=new Int32Array(buffer);HEAPU8=new Uint8Array(buffer);HEAPU16=new Uint16Array(buffer);HEAPU32=new Uint32Array(buffer);HEAPF32=new Float32Array(buffer);HEAPF64=new Float64Array(buffer);HEAP32[0]=255;assert(HEAPU8[0]===255&&HEAPU8[3]===0,"Typed arrays 2 must be run on a little-endian system");Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Runtime.dynCall("v",func)}else{Runtime.dynCall("vi",func,[callback.arg])}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){var array=intArrayFromString(string,dontAddNull);var i=0;while(i<array.length){var chr=array[i];HEAP8[buffer+i>>0]=chr;i=i+1}}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){for(var i=0;i<array.length;i++){HEAP8[buffer++>>0]=array[i]}}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;function unSign(value,bits,ignore){if(value>=0){return value}return bits<=32?2*Math.abs(1<<bits-1)+value:Math.pow(2,bits)+value}function reSign(value,bits,ignore){if(value<=0){return value}var half=bits<=32?Math.abs(1<<bits-1):Math.pow(2,bits-1);if(value>=half&&(bits<=32||value>half)){value=-2*half+value}return value}if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_min=Math.min;var Math_clz32=Math.clz32;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function getUniqueRunDependency(id){return id}function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var memoryInitializer=null;var ASM_CONSTS=[(function(){{return Module.getRandomValue()}}),(function(){{if(Module.getRandomValue===undefined){try{var window_="object"===typeof window?window:self,crypto_=typeof window_.crypto!=="undefined"?window_.crypto:window_.msCrypto,randomValuesStandard=(function(){var buf=new Uint32Array(1);crypto_.getRandomValues(buf);return buf[0]>>>0});randomValuesStandard();Module.getRandomValue=randomValuesStandard}catch(e){try{var crypto=require("crypto"),randomValueIOJS=(function(){var buf=crypto.randomBytes(4);return(buf[0]<<24|buf[1]<<16|buf[2]<<8|buf[3])>>>0});randomValueIOJS();Module.getRandomValue=randomValueIOJS}catch(e){throw"No secure random number generator found"}}}}})];function _emscripten_asm_const_0(code){return ASM_CONSTS[code]()|0}STATIC_BASE=8;STATICTOP=STATIC_BASE+34944;__ATINIT__.push();allocate([8,201,188,243,103,230,9,106,59,167,202,132,133,174,103,187,43,248,148,254,114,243,110,60,241,54,29,95,58,245,79,165,209,130,230,173,127,82,14,81,31,108,62,43,140,104,5,155,107,189,65,251,171,217,131,31,121,33,126,19,25,205,224,91,103,230,9,106,133,174,103,187,114,243,110,60,58,245,79,165,127,82,14,81,140,104,5,155,171,217,131,31,25,205,224,91,133,59,140,1,189,241,36,255,248,37,195,1,96,220,55,0,183,76,62,255,195,66,61,0,50,76,164,1,225,164,76,255,76,61,163,255,117,62,31,0,81,145,64,255,118,65,14,0,162,115,214,255,6,138,46,0,124,230,244,255,10,138,143,0,52,26,194,0,184,244,76,0,129,143,41,1,190,244,19,255,123,170,122,255,98,129,68,0,121,213,147,0,86,101,30,255,161,103,155,0,140,89,67,255,239,229,190,1,67,11,181,0,198,240,137,254,238,69,188,255,67,151,238,0,19,42,108,255,229,85,113,1,50,68,135,255,17,106,9,0,50,103,1,255,80,1,168,1,35,152,30,255,16,168,185,1,56,89,232,255,101,210,252,0,41,250,71,0,204,170,79,255,14,46,239,255,80,77,239,0,189,214,75,255,17,141,249,0,38,80,76,255,190,85,117,0,86,228,170,0,156,216,208,1,195,207,164,255,150,66,76,255,175,225,16,255,141,80,98,1,76,219,242,0,198,162,114,0,46,218,152,0,155,43,241,254,155,160,104,255,51,187,165,0,2,17,175,0,66,84,160,1,247,58,30,0,35,65,53,254,69,236,191,0,45,134,245,1,163,123,221,0,32,110,20,255,52,23,165,0,186,214,71,0,233,176,96,0,242,239,54,1,57,89,138,0,83,0,84,255,136,160,100,0,92,142,120,254,104,124,190,0,181,177,62,255,250,41,85,0,152,130,42,1,96,252,246,0,151,151,63,254,239,133,62,0,32,56,156,0,45,167,189,255,142,133,179,1,131,86,211,0,187,179,150,254,250,170,14,255,210,163,78,0,37,52,151,0,99,77,26,0,238,156,213,255,213,192,209,1,73,46,84,0,20,65,41,1,54,206,79,0,201,131,146,254,170,111,24,255,177,33,50,254,171,38,203,255,78,247,116,0,209,221,153,0,133,128,178,1,58,44,25,0,201,39,59,1,189,19,252,0,49,229,210,1,117,187,117,0,181,179,184,1,0,114,219,0,48,94,147,0,245,41,56,0,125,13,204,254,244,173,119,0,44,221,32,254,84,234,20,0,249,160,198,1,236,126,234,255,47,99,168,254,170,226,153,255,102,179,216,0,226,141,122,255,122,66,153,254,182,245,134,0,227,228,25,1,214,57,235,255,216,173,56,255,181,231,210,0,119,128,157,255,129,95,136,255,110,126,51,0,2,169,183,255,7,130,98,254,69,176,94,255,116,4,227,1,217,242,145,255,202,173,31,1,105,1,39,255,46,175,69,0,228,47,58,255,215,224,69,254,207,56,69,255,16,254,139,255,23,207,212,255,202,20,126,255,95,213,96,255,9,176,33,0,200,5,207,255,241,42,128,254,35,33,192,255,248,229,196,1,129,17,120,0,251,103,151,255,7,52,112,255,140,56,66,255,40,226,245,255,217,70,37,254,172,214,9,255,72,67,134,1,146,192,214,255,44,38,112,0,68,184,75,255,206,90,251,0,149,235,141,0,181,170,58,0,116,244,239,0,92,157,2,0,102,173,98,0,233,137,96,1,127,49,203,0,5,155,148,0,23,148,9,255,211,122,12,0,34,134,26,255,219,204,136,0,134,8,41,255,224,83,43,254,85,25,247,0,109,127,0,254,169,136,48,0,238,119,219,255,231,173,213,0,206,18,254,254,8,186,7,255,126,9,7,1,111,42,72,0,111,52,236,254,96,63,141,0,147,191,127,254,205,78,192,255,14,106,237,1,187,219,76,0,175,243,187,254,105,89,173,0,85,25,89,1,162,243,148,0,2,118,209,254,33,158,9,0,139,163,46,255,93,70,40,0,108,42,142,254,111,252,142,255,155,223,144,0,51,229,167,255,73,252,155,255,94,116,12,255,152,160,218,255,156,238,37,255,179,234,207,255,197,0,179,255,154,164,141,0,225,196,104,0,10,35,25,254,209,212,242,255,97,253,222,254,184,101,229,0,222,18,127,1,164,136,135,255,30,207,140,254,146,97,243,0,129,192,26,254,201,84,33,255,111,10,78,255,147,81,178,255,4,4,24,0,161,238,215,255,6,141,33,0,53,215,14,255,41,181,208,255,231,139,157,0,179,203,221,255,255,185,113,0,189,226,172,255,113,66,214,255,202,62,45,255,102,64,8,255,78,174,16,254,133,117,68,255,182,120,89,255,133,114,211,0,189,110,21,255,15,10,106,0,41,192,1,0,152,232,121,255,188,60,160,255,153,113,206,255,0,183,226,254,180,13,72,255,176,160,14,254,211,201,134,255,158,24,143,0,127,105,53,0,96,12,189,0,167,215,251,255,159,76,128,254,106,101,225,255,30,252,4,0,146,12,174,0,89,241,178,254,10,229,166,255,123,221,42,254,30,20,212,0,82,128,3,0,48,209,243,0,119,121,64,255,50,227,156,255,0,110,197,1,103,27,144,0,133,59,140,1,189,241,36,255,248,37,195,1,96,220,55,0,183,76,62,255,195,66,61,0,50,76,164,1,225,164,76,255,76,61,163,255,117,62,31,0,81,145,64,255,118,65,14,0,162,115,214,255,6,138,46,0,124,230,244,255,10,138,143,0,52,26,194,0,184,244,76,0,129,143,41,1,190,244,19,255,123,170,122,255,98,129,68,0,121,213,147,0,86,101,30,255,161,103,155,0,140,89,67,255,239,229,190,1,67,11,181,0,198,240,137,254,238,69,188,255,234,113,60,255,37,255,57,255,69,178,182,254,128,208,179,0,118,26,125,254,3,7,214,255,241,50,77,255,85,203,197,255,211,135,250,255,25,48,100,255,187,213,180,254,17,88,105,0,83,209,158,1,5,115,98,0,4,174,60,254,171,55,110,255,217,181,17,255,20,188,170,0,146,156,102,254,87,214,174,255,114,122,155,1,233,44,170,0,127,8,239,1,214,236,234,0,175,5,219,0,49,106,61,255,6,66,208,255,2,106,110,255,81,234,19,255,215,107,192,255,67,151,238,0,19,42,108,255,229,85,113,1,50,68,135,255,17,106,9,0,50,103,1,255,80,1,168,1,35,152,30,255,16,168,185,1,56,89,232,255,101,210,252,0,41,250,71,0,204,170,79,255,14,46,239,255,80,77,239,0,189,214,75,255,17,141,249,0,38,80,76,255,190,85,117,0,86,228,170,0,156,216,208,1,195,207,164,255,150,66,76,255,175,225,16,255,141,80,98,1,76,219,242,0,198,162,114,0,46,218,152,0,155,43,241,254,155,160,104,255,178,9,252,254,100,110,212,0,14,5,167,0,233,239,163,255,28,151,157,1,101,146,10,255,254,158,70,254,71,249,228,0,88,30,50,0,68,58,160,255,191,24,104,1,129,66,129,255,192,50,85,255,8,179,138,255,38,250,201,0,115,80,160,0,131,230,113,0,125,88,147,0,90,68,199,0,253,76,158,0,28,255,118,0,113,250,254,0,66,75,46,0,230,218,43,0,229,120,186,1,148,68,43,0,136,124,238,1,187,107,197,255,84,53,246,255,51,116,254,255,51,187,165,0,2,17,175,0,66,84,160,1,247,58,30,0,35,65,53,254,69,236,191,0,45,134,245,1,163,123,221,0,32,110,20,255,52,23,165,0,186,214,71,0,233,176,96,0,242,239,54,1,57,89,138,0,83,0,84,255,136,160,100,0,92,142,120,254,104,124,190,0,181,177,62,255,250,41,85,0,152,130,42,1,96,252,246,0,151,151,63,254,239,133,62,0,32,56,156,0,45,167,189,255,142,133,179,1,131,86,211,0,187,179,150,254,250,170,14,255,68,113,21,255,222,186,59,255,66,7,241,1,69,6,72,0,86,156,108,254,55,167,89,0,109,52,219,254,13,176,23,255,196,44,106,255,239,149,71,255,164,140,125,255,159,173,1,0,51,41,231,0,145,62,33,0,138,111,93,1,185,83,69,0,144,115,46,0,97,151,16,255,24,228,26,0,49,217,226,0,113,75,234,254,193,153,12,255,182,48,96,255,14,13,26,0,128,195,249,254,69,193,59,0,132,37,81,254,125,106,60,0,214,240,169,1,164,227,66,0,210,163,78,0,37,52,151,0,99,77,26,0,238,156,213,255,213,192,209,1,73,46,84,0,20,65,41,1,54,206,79,0,201,131,146,254,170,111,24,255,177,33,50,254,171,38,203,255,78,247,116,0,209,221,153,0,133,128,178,1,58,44,25,0,201,39,59,1,189,19,252,0,49,229,210,1,117,187,117,0,181,179,184,1,0,114,219,0,48,94,147,0,245,41,56,0,125,13,204,254,244,173,119,0,44,221,32,254,84,234,20,0,249,160,198,1,236,126,234,255,143,62,221,0,129,89,214,255,55,139,5,254,68,20,191,255,14,204,178,1,35,195,217,0,47,51,206,1,38,246,165,0,206,27,6,254,158,87,36,0,217,52,146,255,125,123,215,255,85,60,31,255,171,13,7,0,218,245,88,254,252,35,60,0,55,214,160,255,133,101,56,0,224,32,19,254,147,64,234,0,26,145,162,1,114,118,125,0,248,252,250,0,101,94,196,255,198,141,226,254,51,42,182,0,135,12,9,254,109,172,210,255,197,236,194,1,241,65,154,0,48,156,47,255,153,67,55,255,218,165,34,254,74,180,179,0,218,66,71,1,88,122,99,0,212,181,219,255,92,42,231,255,239,0,154,0,245,77,183,255,94,81,170,1,18,213,216,0,171,93,71,0,52,94,248,0,18,151,161,254,197,209,66,255,174,244,15,254,162,48,183,0,49,61,240,254,182,93,195,0,199,228,6,1,200,5,17,255,137,45,237,255,108,148,4,0,90,79,237,255,39,63,77,255,53,82,207,1,142,22,118,255,101,232,18,1,92,26,67,0,5,200,88,255,33,168,138,255,149,225,72,0,2,209,27,255,44,245,168,1,220,237,17,255,30,211,105,254,141,238,221,0,128,80,245,254,111,254,14,0,222,95,190,1,223,9,241,0,146,76,212,255,108,205,104,255,63,117,153,0,144,69,48,0,35,228,111,0,192,33,193,255,112,214,190,254,115,152,151,0,23,102,88,0,51,74,248,0,226,199,143,254,204,162,101,255,208,97,189,1,245,104,18,0,230,246,30,255,23,148,69,0,110,88,52,254,226,181,89,255,208,47,90,254,114,161,80,255,33,116,248,0,179,152,87,255,69,144,177,1,88,238,26,255,58,32,113,1,1,77,69,0,59,121,52,255,152,238,83,0,52,8,193,0,231,39,233,255,199,34,138,0,222,68,173,0,91,57,242,254,220,210,127,255,192,7,246,254,151,35,187,0,195,236,165,0,111,93,206,0,212,247,133,1,154,133,209,255,155,231,10,0,64,78,38,0,122,249,100,1,30,19,97,255,62,91,249,1,248,133,77,0,197,63,168,254,116,10,82,0,184,236,113,254,212,203,194,255,61,100,252,254,36,5,202,255,119,91,153,255,129,79,29,0,103,103,171,254,237,215,111,255,216,53,69,0,239,240,23,0,194,149,221,255,38,225,222,0,232,255,180,254,118,82,133,255,57,209,177,1,139,232,133,0,158,176,46,254,194,115,46,0,88,247,229,1,28,103,191,0,221,222,175,254,149,235,44,0,151,228,25,254,218,105,103,0,142,85,210,0,149,129,190,255,213,65,94,254,117,134,224,255,82,198,117,0,157,221,220,0,163,101,36,0,197,114,37,0,104,172,166,254,11,182,0,0,81,72,188,255,97,188,16,255,69,6,10,0,199,147,145,255,8,9,115,1,65,214,175,255,217,173,209,0,80,127,166,0,247,229,4,254,167,183,124,255,90,28,204,254,175,59,240,255,11,41,248,1,108,40,51,255,144,177,195,254,150,250,126,0,138,91,65,1,120,60,222,255,245,193,239,0,29,214,189,255,128,2,25,0,80,154,162,0,77,220,107,1,234,205,74,255,54,166,103,255,116,72,9,0,228,94,47,255,30,200,25,255,35,214,89,255,61,176,140,255,83,226,163,255,75,130,172,0,128,38,17,0,95,137,152,255,215,124,159,1,79,93,0,0,148,82,157,254,195,130,251,255,40,202,76,255,251,126,224,0,157,99,62,254,207,7,225,255,96,68,195,0,140,186,157,255,131,19,231,255,42,128,254,0,52,219,61,254,102,203,72,0,141,7,11,255,186,164,213,0,31,122,119,0,133,242,145,0,208,252,232,255,91,213,182,255,143,4,250,254,249,215,74,0,165,30,111,1,171,9,223,0,229,123,34,1,92,130,26,255,77,155,45,1,195,139,28,255,59,224,78,0,136,17,247,0,108,121,32,0,79,250,189,255,96,227,252,254,38,241,62,0,62,174,125,255,155,111,93,255,10,230,206,1,97,197,40,255,0,49,57,254,65,250,13,0,18,251,150,255,220,109,210,255,5,174,166,254,44,129,189,0,235,35,147,255,37,247,141,255,72,141,4,255,103,107,255,0,247,90,4,0,53,44,42,0,2,30,240,0,4,59,63,0,88,78,36,0,113,167,180,0,190,71,193,255,199,158,164,255,58,8,172,0,77,33,12,0,65,63,3,0,153,77,33,255,172,254,102,1,228,221,4,255,87,30,254,1,146,41,86,255,138,204,239,254,108,141,17,255,187,242,135,0,210,208,127,0,68,45,14,254,73,96,62,0,81,60,24,255,170,6,36,255,3,249,26,0,35,213,109,0,22,129,54,255,21,35,225,255,234,61,56,255,58,217,6,0,143,124,88,0,236,126,66,0,209,38,183,255,34,238,6,255,174,145,102,0,95,22,211,0,196,15,153,254,46,84,232,255,117,34,146,1,231,250,74,255,27,134,100,1,92,187,195,255,170,198,112,0,120,28,42,0,209,70,67,0,29,81,31,0,29,168,100,1,169,173,160,0,107,35,117,0,62,96,59,255,81,12,69,1,135,239,190,255,220,252,18,0,163,220,58,255,137,137,188,255,83,102,109,0,96,6,76,0,234,222,210,255,185,174,205,1,60,158,213,255,13,241,214,0,172,129,140,0,93,104,242,0,192,156,251,0,43,117,30,0,225,81,158,0,127,232,218,0,226,28,203,0,233,27,151,255,117,43,5,255,242,14,47,255,33,20,6,0,137,251,44,254,27,31,245,255,183,214,125,254,40,121,149,0,186,158,213,255,89,8,227,0,69,88,0,254,203,135,225,0,201,174,203,0,147,71,184,0,18,121,41,254,94,5,78,0,224,214,240,254,36,5,180,0,251,135,231,1,163,138,212,0,210,249,116,254,88,129,187,0,19,8,49,254,62,14,144,255,159,76,211,0,214,51,82,0,109,117,228,254,103,223,203,255,75,252,15,1,154,71,220,255,23,13,91,1,141,168,96,255,181,182,133,0,250,51,55,0,234,234,212,254,175,63,158,0,39,240,52,1,158,189,36,255,213,40,85,1,32,180,247,255,19,102,26,1,84,24,97,255,69,21,222,0,148,139,122,255,220,213,235,1,232,203,255,0,121,57,147,0,227,7,154,0,53,22,147,1,72,1,225,0,82,134,48,254,83,60,157,255,145,72,169,0,34,103,239,0,198,233,47,0,116,19,4,255,184,106,9,255,183,129,83,0,36,176,230,1,34,103,72,0,219,162,134,0,245,42,158,0,32,149,96,254,165,44,144,0,202,239,72,254,215,150,5,0,42,66,36,1,132,215,175,0,86,174,86,255,26,197,156,255,49,232,135,254,103,182,82,0,253,128,176,1,153,178,122,0,245,250,10,0,236,24,178,0,137,106,132,0,40,29,41,0,50,30,152,255,124,105,38,0,230,191,75,0,143,43,170,0,44,131,20,255,44,13,23,255,237,255,155,1,159,109,100,255,112,181,24,255,104,220,108,0,55,211,131,0,99,12,213,255,152,151,145,255,238,5,159,0,97,155,8,0,33,108,81,0,1,3,103,0,62,109,34,255,250,155,180,0,32,71,195,255,38,70,145,1,159,95,245,0,69,229,101,1,136,28,240,0,79,224,25,0,78,110,121,255,248,168,124,0,187,128,247,0,2,147,235,254,79,11,132,0,70,58,12,1,181,8,163,255,79,137,133,255,37,170,11,255,141,243,85,255,176,231,215,255,204,150,164,255,239,215,39,255,46,87,156,254,8,163,88,255,172,34,232,0,66,44,102,255,27,54,41,254,236,99,87,255,41,123,169,1,52,114,43,0,117,134,40,0,155,134,26,0,231,207,91,254,35,132,38,255,19,102,125,254,36,227,133,255,118,3,113,255,29,13,124,0,152,96,74,1,88,146,206,255,167,191,220,254,162,18,88,255,182,100,23,0,31,117,52,0,81,46,106,1,12,2,7,0,69,80,201,1,209,246,172,0,12,48,141,1,224,211,88,0,116,226,159,0,122,98,130,0,65,236,234,1,225,226,9,255,207,226,123,1,89,214,59,0,112,135,88,1,90,244,203,255,49,11,38,1,129,108,186,0,89,112,15,1,101,46,204,255,127,204,45,254,79,255,221,255,51,73,18,255,127,42,101,255,241,21,202,0,160,227,7,0,105,50,236,0,79,52,197,255,104,202,208,1,180,15,16,0,101,197,78,255,98,77,203,0,41,185,241,1,35,193,124,0,35,155,23,255,207,53,192,0,11,125,163,1,249,158,185,255,4,131,48,0,21,93,111,255,61,121,231,1,69,200,36,255,185,48,185,255,111,238,21,255,39,50,25,255,99,215,163,255,87,212,30,255,164,147,5,255,128,6,35,1,108,223,110,255,194,76,178,0,74,101,180,0,243,47,48,0,174,25,43,255,82,173,253,1,54,114,192,255,40,55,91,0,215,108,176,255,11,56,7,0,224,233,76,0,209,98,202,254,242,25,125,0,44,193,93,254,203,8,177,0,135,176,19,0,112,71,213,255,206,59,176,1,4,67,26,0,14,143,213,254,42,55,208,255,60,67,120,0,193,21,163,0,99,164,115,0,10,20,118,0,156,212,222,254,160,7,217,255,114,245,76,1,117,59,123,0,176,194,86,254,213,15,176,0,78,206,207,254,213,129,59,0,233,251,22,1,96,55,152,255,236,255,15,255,197,89,84,255,93,149,133,0,174,160,113,0,234,99,169,255,152,116,88,0,144,164,83,255,95,29,198,255,34,47,15,255,99,120,134,255,5,236,193,0,249,247,126,255,147,187,30,0,50,230,117,255,108,217,219,255,163,81,166,255,72,25,169,254,155,121,79,255,28,155,89,254,7,126,17,0,147,65,33,1,47,234,253,0,26,51,18,0,105,83,199,255,163,196,230,0,113,248,164,0,226,254,218,0,189,209,203,255,164,247,222,254,255,35,165,0,4,188,243,1,127,179,71,0,37,237,254,255,100,186,240,0,5,57,71,254,103,72,73,255,244,18,81,254,229,210,132,255,238,6,180,255,11,229,174,255,227,221,192,1,17,49,28,0,163,215,196,254,9,118,4,255,51,240,71,0,113,129,109,255,76,240,231,0,188,177,127,0,125,71,44,1,26,175,243,0,94,169,25,254,27,230,29,0,15,139,119,1,168,170,186,255,172,197,76,255,252,75,188,0,137,124,196,0,72,22,96,255,45,151,249,1,220,145,100,0,64,192,159,255,120,239,226,0,129,178,146,0,0,192,125,0,235,138,234,0,183,157,146,0,83,199,192,255,184,172,72,255,73,225,128,0,77,6,250,255,186,65,67,0,104,246,207,0,188,32,138,255,218,24,242,0,67,138,81,254,237,129,121,255,20,207,150,1,41,199,16,255,6,20,128,0,159,118,5,0,181,16,143,255,220,38,15,0,23,64,147,254,73,26,13,0,87,228,57,1,204,124,128,0,43,24,223,0,219,99,199,0,22,75,20,255,19,27,126,0,157,62,215,0,110,29,230,0,179,167,255,1,54,252,190,0,221,204,182,254,179,158,65,255,81,157,3,0,194,218,159,0,170,223,0,0,224,11,32,255,38,197,98,0,168,164,37,0,23,88,7,1,164,186,110,0,96,36,134,0,234,242,229,0,250,121,19,0,242,254,112,255,3,47,94,1,9,239,6,255,81,134,153,254,214,253,168,255,67,124,224,0,245,95,74,0,28,30,44,254,1,109,220,255,178,89,89,0,252,36,76,0,24,198,46,255,76,77,111,0,134,234,136,255,39,94,29,0,185,72,234,255,70,68,135,255,231,102,7,254,77,231,140,0,167,47,58,1,148,97,118,255,16,27,225,1,166,206,143,255,110,178,214,255,180,131,162,0,143,141,225,1,13,218,78,255,114,153,33,1,98,104,204,0,175,114,117,1,167,206,75,0,202,196,83,1,58,64,67,0,138,47,111,1,196,247,128,255,137,224,224,254,158,112,207,0,154,100,255,1,134,37,107,0,198,128,79,255,127,209,155,255,163,254,185,254,60,14,243,0,31,219,112,254,29,217,65,0,200,13,116,254,123,60,196,255,224,59,184,254,242,89,196,0,123,16,75,254,149,16,206,0,69,254,48,1,231,116,223,255,209,160,65,1,200,80,98,0,37,194,184,254,148,63,34,0,139,240,65,255,217,144,132,255,56,38,45,254,199,120,210,0,108,177,166,255,160,222,4,0,220,126,119,254,165,107,160,255,82,220,248,1,241,175,136,0,144,141,23,255,169,138,84,0,160,137,78,255,226,118,80,255,52,27,132,255,63,96,139,255,152,250,39,0,188,155,15,0,232,51,150,254,40,15,232,255,240,229,9,255,137,175,27,255,75,73,97,1,218,212,11,0,135,5,162,1,107,185,213,0,2,249,107,255,40,242,70,0,219,200,25,0,25,157,13,0,67,82,80,255,196,249,23,255,145,20,149,0,50,72,146,0,94,76,148,1,24,251,65,0,31,192,23,0,184,212,201,255,123,233,162,1,247,173,72,0,162,87,219,254,126,134,89,0,159,11,12,254,166,105,29,0,73,27,228,1,113,120,183,255,66,163,109,1,212,143,11,255,159,231,168,1,255,128,90,0,57,14,58,254,89,52,10,255,253,8,163,1,0,145,210,255,10,129,85,1,46,181,27,0,103,136,160,254,126,188,209,255,34,35,111,0,215,219,24,255,212,11,214,254,101,5,118,0,232,197,133,255,223,167,109,255,237,80,86,255,70,139,94,0,158,193,191,1,155,15,51,255,15,190,115,0,78,135,207,255,249,10,27,1,181,125,233,0,95,172,13,254,170,213,161,255,39,236,138,255,95,93,87,255,190,128,95,0,125,15,206,0,166,150,159,0,227,15,158,255,206,158,120,255,42,141,128,0,101,178,120,1,156,109,131,0,218,14,44,254,247,168,206,255,212,112,28,0,112,17,228,255,90,16,37,1,197,222,108,0,254,207,83,255,9,90,243,255,243,244,172,0,26,88,115,255,205,116,122,0,191,230,193,0,180,100,11,1,217,37,96,255,154,78,156,0,235,234,31,255,206,178,178,255,149,192,251,0,182,250,135,0,246,22,105,0,124,193,109,255,2,210,149,255,169,17,170,0,0,96,110,255,117,9,8,1,50,123,40,255,193,189,99,0,34,227,160,0,48,80,70,254,211,51,236,0,45,122,245,254,44,174,8,0,173,37,233,255,158,65,171,0,122,69,215,255,90,80,2,255,131,106,96,254,227,114,135,0,205,49,119,254,176,62,64,255,82,51,17,255,241,20,243,255,130,13,8,254,128,217,243,255,162,27,1,254,90,118,241,0,246,198,246,255,55,16,118,255,200,159,157,0,163,17,1,0,140,107,121,0,85,161,118,255,38,0,149,0,156,47,238,0,9,166,166,1,75,98,181,255,50,74,25,0,66,15,47,0,139,225,159,0,76,3,142,255,14,238,184,0,11,207,53,255,183,192,186,1,171,32,174,255,191,76,221,1,247,170,219,0,25,172,50,254,217,9,233,0,203,126,68,255,183,92,48,0,127,167,183,1,65,49,254,0,16,63,127,1,254,21,170,255,59,224,127,254,22,48,63,255,27,78,130,254,40,195,29,0,250,132,112,254,35,203,144,0,104,169,168,0,207,253,30,255,104,40,38,254,94,228,88,0,206,16,128,255,212,55,122,255,223,22,234,0,223,197,127,0,253,181,181,1,145,102,118,0,236,153,36,255,212,217,72,255,20,38,24,254,138,62,62,0,152,140,4,0,230,220,99,255,1,21,212,255,148,201,231,0,244,123,9,254,0,171,210,0,51,58,37,255,1,255,14,255,244,183,145,254,0,242,166,0,22,74,132,0,121,216,41,0,95,195,114,254,133,24,151,255,156,226,231,255,247,5,77,255,246,148,115,254,225,92,81,255,222,80,246,254,170,123,89,255,74,199,141,0,29,20,8,255,138,136,70,255,93,75,92,0,221,147,49,254,52,126,226,0,229,124,23,0,46,9,181,0,205,64,52,1,131,254,28,0,151,158,212,0,131,64,78,0,206,25,171,0,0,230,139,0,191,253,110,254,103,247,167,0,64,40,40,1,42,165,241,255,59,75,228,254,124,243,189,255,196,92,178,255,130,140,86,255,141,89,56,1,147,198,5,255,203,248,158,254,144,162,141,0,11,172,226,0,130,42,21,255,1,167,143,255,144,36,36,255,48,88,164,254,168,170,220,0,98,71,214,0,91,208,79,0,159,76,201,1,166,42,214,255,69,255,0,255,6,128,125,255,190,1,140,0,146,83,218,255,215,238,72,1,122,127,53,0,189,116,165,255,84,8,66,255,214,3,208,255,213,110,133,0,195,168,44,1,158,231,69,0,162,64,200,254,91,58,104,0,182,58,187,254,249,228,136,0,203,134,76,254,99,221,233,0,75,254,214,254,80,69,154,0,64,152,248,254,236,136,202,255,157,105,153,254,149,175,20,0,22,35,19,255,124,121,233,0,186,250,198,254,132,229,139,0,137,80,174,255,165,125,68,0,144,202,148,254,235,239,248,0,135,184,118,0,101,94,17,255,122,72,70,254,69,130,146,0,127,222,248,1,69,127,118,255,30,82,215,254,188,74,19,255,229,167,194,254,117,25,66,255,65,234,56,254,213,22,156,0,151,59,93,254,45,28,27,255,186,126,164,255,32,6,239,0,127,114,99,1,219,52,2,255,99,96,166,254,62,190,126,255,108,222,168,1,75,226,174,0,230,226,199,0,60,117,218,255,252,248,20,1,214,188,204,0,31,194,134,254,123,69,192,255,169,173,36,254,55,98,91,0,223,42,102,254,137,1,102,0,157,90,25,0,239,122,64,255,252,6,233,0,7,54,20,255,82,116,174,0,135,37,54,255,15,186,125,0,227,112,175,255,100,180,225,255,42,237,244,255,244,173,226,254,248,18,33,0,171,99,150,255,74,235,50,255,117,82,32,254,106,168,237,0,207,109,208,1,228,9,186,0,135,60,169,254,179,92,143,0,244,170,104,255,235,45,124,255,70,99,186,0,117,137,183,0,224,31,215,0,40,9,100,0,26,16,95,1,68,217,87,0,8,151,20,255,26,100,58,255,176,165,203,1,52,118,70,0,7,32,254,254,244,254,245,255,167,144,194,255,125,113,23,255,176,121,181,0,136,84,209,0,138,6,30,255,89,48,28,0,33,155,14,255,25,240,154,0,141,205,109,1,70,115,62,255,20,40,107,254,138,154,199,255,94,223,226,255,157,171,38,0,163,177,25,254,45,118,3,255,14,222,23,1,209,190,81,255,118,123,232,1,13,213,101,255,123,55,123,254,27,246,165,0,50,99,76,255,140,214,32,255,97,65,67,255,24,12,28,0,174,86,78,1,64,247,96,0,160,135,67,0,66,55,243,255,147,204,96,255,26,6,33,255,98,51,83,1,153,213,208,255,2,184,54,255,25,218,11,0,49,67,246,254,18,149,72,255,13,25,72,0,42,79,214,0,42,4,38,1,27,139,144,255,149,187,23,0,18,164,132,0,245,84,184,254,120,198,104,255,126,218,96,0,56,117,234,255,13,29,214,254,68,47,10,255,167,154,132,254,152,38,198,0,66,178,89,255,200,46,171,255,13,99,83,255,210,187,253,255,170,45,42,1,138,209,124,0,214,162,141,0,12,230,156,0,102,36,112,254,3,147,67,0,52,215,123,255,233,171,54,255,98,137,62,0,247,218,39,255,231,218,236,0,247,191,127,0,195,146,84,0,165,176,92,255,19,212,94,255,17,74,227,0,88,40,153,1,198,147,1,255,206,67,245,254,240,3,218,255,61,141,213,255,97,183,106,0,195,232,235,254,95,86,154,0,209,48,205,254,118,209,241,255,240,120,223,1,213,29,159,0,163,127,147,255,13,218,93,0,85,24,68,254,70,20,80,255,189,5,140,1,82,97,254,255,99,99,191,255,132,84,133,255,107,218,116,255,112,122,46,0,105,17,32,0,194,160,63,255,68,222,39,1,216,253,92,0,177,105,205,255,149,201,195,0,42,225,11,255,40,162,115,0,9,7,81,0,165,218,219,0,180,22,0,254,29,146,252,255,146,207,225,1,180,135,96,0,31,163,112,0,177,11,219,255,133,12,193,254,43,78,50,0,65,113,121,1,59,217,6,255,110,94,24,1,112,172,111,0,7,15,96,0,36,85,123,0,71,150,21,255,208,73,188,0,192,11,167,1,213,245,34,0,9,230,92,0,162,142,39,255,215,90,27,0,98,97,89,0,94,79,211,0,90,157,240,0,95,220,126,1,102,176,226,0,36,30,224,254,35,31,127,0,231,232,115,1,85,83,130,0,210,73,245,255,47,143,114,255,68,65,197,0,59,72,62,255,183,133,173,254,93,121,118,255,59,177,81,255,234,69,173,255,205,128,177,0,220,244,51,0,26,244,209,1,73,222,77,255,163,8,96,254,150,149,211,0,158,254,203,1,54,127,139,0,161,224,59,0,4,109,22,255,222,42,45,255,208,146,102,255,236,142,187,0,50,205,245,255,10,74,89,254,48,79,142,0,222,76,130,255,30,166,63,0,236,12,13,255,49,184,244,0,187,113,102,0,218,101,253,0,153,57,182,254,32,150,42,0,25,198,146,1,237,241,56,0,140,68,5,0,91,164,172,255,78,145,186,254,67,52,205,0,219,207,129,1,109,115,17,0,54,143,58,1,21,248,120,255,179,255,30,0,193,236,66,255,1,255,7,255,253,192,48,255,19,69,217,1,3,214,0,255,64,101,146,1,223,125,35,255,235,73,179,255,249,167,226,0,225,175,10,1,97,162,58,0,106,112,171,1,84,172,5,255,133,140,178,255,134,245,142,0,97,90,125,255,186,203,185,255,223,77,23,255,192,92,106,0,15,198,115,255,217,152,248,0,171,178,120,255,228,134,53,0,176,54,193,1,250,251,53,0,213,10,100,1,34,199,106,0,151,31,244,254,172,224,87,255,14,237,23,255,253,85,26,255,127,39,116,255,172,104,100,0,251,14,70,255,212,208,138,255,253,211,250,0,176,49,165,0,15,76,123,255,37,218,160,255,92,135,16,1,10,126,114,255,70,5,224,255,247,249,141,0,68,20,60,1,241,210,189,255,195,217,187,1,151,3,113,0,151,92,174,0,231,62,178,255,219,183,225,0,23,23,33,255,205,181,80,0,57,184,248,255,67,180,1,255,90,123,93,255,39,0,162,255,96,248,52,255,84,66,140,0,34,127,228,255,194,138,7,1,166,110,188,0,21,17,155,1,154,190,198,255,214,80,59,255,18,7,143,0,72,29,226,1,199,217,249,0,232,161,71,1,149,190,201,0,217,175,95,254,113,147,67,255,138,143,199,255,127,204,1,0,29,182,83,1,206,230,155,255,186,204,60,0,10,125,85,255,232,96,25,255,255,89,247,255,213,254,175,1,232,193,81,0,28,43,156,254,12,69,8,0,147,24,248,0,18,198,49,0,134,60,35,0,118,246,18,255,49,88,254,254,228,21,186,255,182,65,112,1,219,22,1,255,22,126,52,255,189,53,49,255,112,25,143,0,38,127,55,255,226,101,163,254,208,133,61,255,137,69,174,1,190,118,145,255,60,98,219,255,217,13,245,255,250,136,10,0,84,254,226,0,201,31,125,1,240,51,251,255,31,131,130,255,2,138,50,255,215,215,177,1,223,12,238,255,252,149,56,255,124,91,68,255,72,126,170,254,119,255,100,0,130,135,232,255,14,79,178,0,250,131,197,0,138,198,208,0,121,216,139,254,119,18,36,255,29,193,122,0,16,42,45,255,213,240,235,1,230,190,169,255,198,35,228,254,110,173,72,0,214,221,241,255,56,148,135,0,192,117,78,254,141,93,207,255,143,65,149,0,21,18,98,255,95,44,244,1,106,191,77,0,254,85,8,254,214,110,176,255,73,173,19,254,160,196,199,255,237,90,144,0,193,172,113,255,200,155,136,254,228,90,221,0,137,49,74,1,164,221,215,255,209,189,5,255,105,236,55,255,42,31,129,1,193,255,236,0,46,217,60,0,138,88,187,255,226,82,236,255,81,69,151,255,142,190,16,1,13,134,8,0,127,122,48,255,81,64,156,0,171,243,139,0,237,35,246,0,122,143,193,254,212,122,146,0,95,41,255,1,87,132,77,0,4,212,31,0,17,31,78,0,39,45,173,254,24,142,217,255,95,9,6,255,227,83,6,0,98,59,130,254,62,30,33,0,8,115,211,1,162,97,128,255,7,184,23,254,116,28,168,255,248,138,151,255,98,244,240,0,186,118,130,0,114,248,235,255,105,173,200,1,160,124,71,255,94,36,164,1,175,65,146,255,238,241,170,254,202,198,197,0,228,71,138,254,45,246,109,255,194,52,158,0,133,187,176,0,83,252,154,254,89,189,221,255,170,73,252,0,148,58,125,0,36,68,51,254,42,69,177,255,168,76,86,255,38,100,204,255,38,53,35,0,175,19,97,0,225,238,253,255,81,81,135,0,210,27,255,254,235,73,107,0,8,207,115,0,82,127,136,0,84,99,21,254,207,19,136,0,100,164,101,0,80,208,77,255,132,207,237,255,15,3,15,255,33,166,110,0,156,95,85,255,37,185,111,1,150,106,35,255,166,151,76,0,114,87,135,255,159,194,64,0,12,122,31,255,232,7,101,254,173,119,98,0,154,71,220,254,191,57,53,255,168,232,160,255,224,32,99,255,218,156,165,0,151,153,163,0,217,13,148,1,197,113,89,0,149,28,161,254,207,23,30,0,105,132,227,255,54,230,94,255,133,173,204,255,92,183,157,255,88,144,252,254,102,33,90,0,159,97,3,0,181,218,155,255,240,114,119,0,106,214,53,255,165,190,115,1,152,91,225,255,88,106,44,255,208,61,113,0,151,52,124,0,191,27,156,255,110,54,236,1,14,30,166,255,39,127,207,1,229,199,28,0,188,228,188,254,100,157,235,0,246,218,183,1,107,22,193,255,206,160,95,0,76,239,147,0,207,161,117,0,51,166,2,255,52,117,10,254,73,56,227,255,152,193,225,0,132,94,136,255,101,191,209,0,32,107,229,255,198,43,180,1,100,210,118,0,114,67,153,255,23,88,26,255,89,154,92,1,220,120,140,255,144,114,207,255,252,115,250,255,34,206,72,0,138,133,127,255,8,178,124,1,87,75,97,0,15,229,92,254,240,67,131,255,118,123,227,254,146,120,104,255,145,213,255,1,129,187,70,255,219,119,54,0,1,19,173,0,45,150,148,1,248,83,72,0,203,233,169,1,142,107,56,0,247,249,38,1,45,242,80,255,30,233,103,0,96,82,70,0,23,201,111,0,81,39,30,255,161,183,78,255,194,234,33,255,68,227,140,254,216,206,116,0,70,27,235,255,104,144,79,0,164,230,93,254,214,135,156,0,154,187,242,254,188,20,131,255,36,109,174,0,159,112,241,0,5,110,149,1,36,165,218,0,166,29,19,1,178,46,73,0,93,43,32,254,248,189,237,0,102,155,141,0,201,93,195,255,241,139,253,255,15,111,98,255,108,65,163,254,155,79,190,255,73,174,193,254,246,40,48,255,107,88,11,254,202,97,85,255,253,204,18,255,113,242,66,0,110,160,194,254,208,18,186,0,81,21,60,0,188,104,167,255,124,166,97,254,210,133,142,0,56,242,137,254,41,111,130,0,111,151,58,1,111,213,141,255,183,172,241,255,38,6,196,255,185,7,123,255,46,11,246,0,245,105,119,1,15,2,161,255,8,206,45,255,18,202,74,255,83,124,115,1,212,141,157,0,83,8,209,254,139,15,232,255,172,54,173,254,50,247,132,0,214,189,213,0,144,184,105,0,223,254,248,0,255,147,240,255,23,188,72,0,7,51,54,0,188,25,180,254,220,180,0,255,83,160,20,0,163,189,243,255,58,209,194,255,87,73,60,0,106,24,49,0,245,249,220,0,22,173,167,0,118,11,195,255,19,126,237,0,110,159,37,255,59,82,47,0,180,187,86,0,188,148,208,1,100,37,133,255,7,112,193,0,129,188,156,255,84,106,129,255,133,225,202,0,14,236,111,255,40,20,101,0,172,172,49,254,51,54,74,255,251,185,184,255,93,155,224,255,180,249,224,1,230,178,146,0,72,57,54,254,178,62,184,0,119,205,72,0,185,239,253,255,61,15,218,0,196,67,56,255,234,32,171,1,46,219,228,0,208,108,234,255,20,63,232,255,165,53,199,1,133,228,5,255,52,205,107,0,74,238,140,255,150,156,219,254,239,172,178,255,251,189,223,254,32,142,211,255,218,15,138,1,241,196,80,0,28,36,98,254,22,234,199,0,61,237,220,255,246,57,37,0,142,17,142,255,157,62,26,0,43,238,95,254,3,217,6,255,213,25,240,1,39,220,174,255,154,205,48,254,19,13,192,255,244,34,54,254,140,16,155,0,240,181,5,254,155,193,60,0,166,128,4,255,36,145,56,255,150,240,219,0,120,51,145,0,82,153,42,1,140,236,146,0,107,92,248,1,189,10,3,0,63,136,242,0,211,39,24,0,19,202,161,1,173,27,186,255,210,204,239,254,41,209,162,255,182,254,159,255,172,116,52,0,195,103,222,254,205,69,59,0,53,22,41,1,218,48,194,0,80,210,242,0,210,188,207,0,187,161,161,254,216,17,1,0,136,225,113,0,250,184,63,0,223,30,98,254,77,168,162,0,59,53,175,0,19,201,10,255,139,224,194,0,147,193,154,255,212,189,12,254,1,200,174,255,50,133,113,1,94,179,90,0,173,182,135,0,94,177,113,0,43,89,215,255,136,252,106,255,123,134,83,254,5,245,66,255,82,49,39,1,220,2,224,0,97,129,177,0,77,59,89,0,61,29,155,1,203,171,220,255,92,78,139,0,145,33,181,255,169,24,141,1,55,150,179,0,139,60,80,255,218,39,97,0,2,147,107,255,60,248,72,0,173,230,47,1,6,83,182,255,16,105,162,254,137,212,81,255,180,184,134,1,39,222,164,255,221,105,251,1,239,112,125,0,63,7,97,0,63,104,227,255,148,58,12,0,90,60,224,255,84,212,252,0,79,215,168,0,248,221,199,1,115,121,1,0,36,172,120,0,32,162,187,255,57,107,49,255,147,42,21,0,106,198,43,1,57,74,87,0,126,203,81,255,129,135,195,0,140,31,177,0,221,139,194,0,3,222,215,0,131,68,231,0,177,86,178,254,124,151,180,0,184,124,38,1,70,163,17,0,249,251,181,1,42,55,227,0,226,161,44,0,23,236,110,0,51,149,142,1,93,5,236,0,218,183,106,254,67,24,77,0,40,245,209,255,222,121,153,0,165,57,30,0,83,125,60,0,70,38,82,1,229,6,188,0,109,222,157,255,55,118,63,255,205,151,186,0,227,33,149,255,254,176,246,1,227,177,227,0,34,106,163,254,176,43,79,0,106,95,78,1,185,241,122,255,185,14,61,0,36,1,202,0,13,178,162,255,247,11,132,0,161,230,92,1,65,1,185,255,212,50,165,1,141,146,64,255,158,242,218,0,21,164,125,0,213,139,122,1,67,71,87,0,203,158,178,1,151,92,43,0,152,111,5,255,39,3,239,255,217,255,250,255,176,63,71,255,74,245,77,1,250,174,18,255,34,49,227,255,246,46,251,255,154,35,48,1,125,157,61,255,106,36,78,255,97,236,153,0,136,187,120,255,113,134,171,255,19,213,217,254,216,94,209,255,252,5,61,0,94,3,202,0,3,26,183,255,64,191,43,255,30,23,21,0,129,141,77,255,102,120,7,1,194,76,140,0,188,175,52,255,17,81,148,0,232,86,55,1,225,48,172,0,134,42,42,255,238,50,47,0,169,18,254,0,20,147,87,255,14,195,239,255,69,247,23,0,238,229,128,255,177,49,112,0,168,98,251,255,121,71,248,0,243,8,145,254,246,227,153,255,219,169,177,254,251,139,165,255,12,163,185,255,164,40,171,255,153,159,27,254,243,109,91,255,222,24,112,1,18,214,231,0,107,157,181,254,195,147,0,255,194,99,104,255,89,140,190,255,177,66,126,254,106,185,66,0,49,218,31,0,252,174,158,0,188,79,230,1,238,41,224,0,212,234,8,1,136,11,181,0,166,117,83,255,68,195,94,0,46,132,201,0,240,152,88,0,164,57,69,254,160,224,42,255,59,215,67,255,119,195,141,255,36,180,121,254,207,47,8,255,174,210,223,0,101,197,68,255,255,82,141,1,250,137,233,0,97,86,133,1,16,80,69,0,132,131,159,0,116,93,100,0,45,141,139,0,152,172,157,255,90,43,91,0,71,153,46,0,39,16,112,255,217,136,97,255,220,198,25,254,177,53,49,0,222,88,134,255,128,15,60,0,207,192,169,255,192,116,209,255,106,78,211,1,200,213,183,255,7,12,122,254,222,203,60,255,33,110,199,254,251,106,117,0,228,225,4,1,120,58,7,255,221,193,84,254,112,133,27,0,189,200,201,255,139,135,150,0,234,55,176,255,61,50,65,0,152,108,169,255,220,85,1,255,112,135,227,0,162,26,186,0,207,96,185,254,244,136,107,0,93,153,50,1,198,97,151,0,110,11,86,255,143,117,174,255,115,212,200,0,5,202,183,0,237,164,10,254,185,239,62,0,236,120,18,254,98,123,99,255,168,201,194,254,46,234,214,0,191,133,49,255,99,169,119,0,190,187,35,1,115,21,45,255,249,131,72,0,112,6,123,255,214,49,181,254,166,233,34,0,92,197,102,254,253,228,205,255,3,59,201,1,42,98,46,0,219,37,35,255,169,195,38,0,94,124,193,1,156,43,223,0,95,72,133,254,120,206,191,0,122,197,239,255,177,187,79,255,254,46,2,1,250,167,190,0,84,129,19,0,203,113,166,255,249,31,189,254,72,157,202,255,208,71,73,255,207,24,72,0,10,16,18,1,210,81,76,255,88,208,192,255,126,243,107,255,238,141,120,255,199,121,234,255,137,12,59,255,36,220,123,255,148,179,60,254,240,12,29,0,66,0,97,1,36,30,38,255,115,1,93,255,96,103,231,255,197,158,59,1,192,164,240,0,202,202,57,255,24,174,48,0,89,77,155,1,42,76,215,0,244,151,233,0,23,48,81,0,239,127,52,254,227,130,37,255,248,116,93,1,124,132,118,0,173,254,192,1,6,235,83,255,110,175,231,1,251,28,182,0,129,249,93,254,84,184,128,0,76,181,62,0,175,128,186,0,100,53,136,254,109,29,226,0,221,233,58,1,20,99,74,0,0,22,160,0,134,13,21,0,9,52,55,255,17,89,140,0,175,34,59,0,84,165,119,255,224,226,234,255,7,72,166,255,123,115,255,1,18,214,246,0,250,7,71,1,217,220,185,0,212,35,76,255,38,125,175,0,189,97,210,0,114,238,44,255,41,188,169,254,45,186,154,0,81,92,22,0,132,160,193,0,121,208,98,255,13,81,44,255,203,156,82,0,71,58,21,255,208,114,191,254,50,38,147,0,154,216,195,0,101,25,18,0,60,250,215,255,233,132,235,255,103,175,142,1,16,14,92,0,141,31,110,254,238,241,45,255,153,217,239,1,97,168,47,255,249,85,16,1,28,175,62,255,57,254,54,0,222,231,126,0,166,45,117,254,18,189,96,255,228,76,50,0,200,244,94,0,198,152,120,1,68,34,69,255,12,65,160,254,101,19,90,0,167,197,120,255,68,54,185,255,41,218,188,0,113,168,48,0,88,105,189,1,26,82,32,255,185,93,164,1,228,240,237,255,66,182,53,0,171,197,92,255,107,9,233,1,199,120,144,255,78,49,10,255,109,170,105,255,90,4,31,255,28,244,113,255,74,58,11,0,62,220,246,255,121,154,200,254,144,210,178,255,126,57,129,1,43,250,14,255,101,111,28,1,47,86,241,255,61,70,150,255,53,73,5,255,30,26,158,0,209,26,86,0,138,237,74,0,164,95,188,0,142,60,29,254,162,116,248,255,187,175,160,0,151,18,16,0,209,111,65,254,203,134,39,255,88,108,49,255,131,26,71,255,221,27,215,254,104,105,93,255,31,236,31,254,135,0,211,255,143,127,110,1,212,73,229,0,233,67,167,254,195,1,208,255,132,17,221,255,51,217,90,0,67,235,50,255,223,210,143,0,179,53,130,1,233,106,198,0,217,173,220,255,112,229,24,255,175,154,93,254,71,203,246,255,48,66,133,255,3,136,230,255,23,221,113,254,235,111,213,0,170,120,95,254,251,221,2,0,45,130,158,254,105,94,217,255,242,52,180,254,213,68,45,255,104,38,28,0,244,158,76,0,161,200,96,255,207,53,13,255,187,67,148,0,170,54,248,0,119,162,178,255,83,20,11,0,42,42,192,1,146,159,163,255,183,232,111,0,77,229,21,255,71,53,143,0,27,76,34],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([246,136,47,255,219,39,182,255,92,224,201,1,19,142,14,255,69,182,241,255,163,118,245,0,9,109,106,1,170,181,247,255,78,47,238,255,84,210,176,255,213,107,139,0,39,38,11,0,72,21,150,0,72,130,69,0,205,77,155,254,142,133,21,0,71,111,172,254,226,42,59,255,179,0,215,1,33,128,241,0,234,252,13,1,184,79,8,0,110,30,73,255,246,141,189,0,170,207,218,1,74,154,69,255,138,246,49,255,155,32,100,0,125,74,105,255,90,85,61,255,35,229,177,255,62,125,193,255,153,86,188,1,73,120,212,0,209,123,246,254,135,209,38,255,151,58,44,1,92,69,214,255,14,12,88,255,252,153,166,255,253,207,112,255,60,78,83,255,227,124,110,0,180,96,252,255,53,117,33,254,164,220,82,255,41,1,27,255,38,164,166,255,164,99,169,254,61,144,70,255,192,166,18,0,107,250,66,0,197,65,50,0,1,179,18,255,255,104,1,255,43,153,35,255,80,111,168,0,110,175,168,0,41,105,45,255,219,14,205,255,164,233,140,254,43,1,118,0,233,67,195,0,178,82,159,255,138,87,122,255,212,238,90,255,144,35,124,254,25,140,164,0,251,215,44,254,133,70,107,255,101,227,80,254,92,169,55,0,215,42,49,0,114,180,85,255,33,232,27,1,172,213,25,0,62,176,123,254,32,133,24,255,225,191,62,0,93,70,153,0,181,42,104,1,22,191,224,255,200,200,140,255,249,234,37,0,149,57,141,0,195,56,208,255,254,130,70,255,32,173,240,255,29,220,199,0,110,100,115,255,132,229,249,0,228,233,223,255,37,216,209,254,178,177,209,255,183,45,165,254,224,97,114,0,137,97,168,255,225,222,172,0,165,13,49,1,210,235,204,255,252,4,28,254,70,160,151,0,232,190,52,254,83,248,93,255,62,215,77,1,175,175,179,255,160,50,66,0,121,48,208,0,63,169,209,255,0,210,200,0,224,187,44,1,73,162,82,0,9,176,143,255,19,76,193,255,29,59,167,1,24,43,154,0,28,190,190,0,141,188,129,0,232,235,203,255,234,0,109,255,54,65,159,0,60,88,232,255,121,253,150,254,252,233,131,255,198,110,41,1,83,77,71,255,200,22,59,254,106,253,242,255,21,12,207,255,237,66,189,0,90,198,202,1,225,172,127,0,53,22,202,0,56,230,132,0,1,86,183,0,109,190,42,0,243,68,174,1,109,228,154,0,200,177,122,1,35,160,183,255,177,48,85,255,90,218,169,255,248,152,78,0,202,254,110,0,6,52,43,0,142,98,65,255,63,145,22,0,70,106,93,0,232,138,107,1,110,179,61,255,211,129,218,1,242,209,92,0,35,90,217,1,182,143,106,255,116,101,217,255,114,250,221,255,173,204,6,0,60,150,163,0,73,172,44,255,239,110,80,255,237,76,153,254,161,140,249,0,149,232,229,0,133,31,40,255,174,164,119,0,113,51,214,0,129,228,2,254,64,34,243,0,107,227,244,255,174,106,200,255,84,153,70,1,50,35,16,0,250,74,216,254,236,189,66,255,153,249,13,0,230,178,4,255,221,41,238,0,118,227,121,255,94,87,140,254,254,119,92,0,73,239,246,254,117,87,128,0,19,211,145,255,177,46,252,0,229,91,246,1,69,128,247,255,202,77,54,1,8,11,9,255,153,96,166,0,217,214,173,255,134,192,2,1,0,207,0,0,189,174,107,1,140,134,100,0,158,193,243,1,182,102,171,0,235,154,51,0,142,5,123,255,60,168,89,1,217,14,92,255,19,214,5,1,211,167,254,0,44,6,202,254,120,18,236,255,15,113,184,255,184,223,139,0,40,177,119,254,182,123,90,255,176,165,176,0,247,77,194,0,27,234,120,0,231,0,214,255,59,39,30,0,125,99,145,255,150,68,68,1,141,222,248,0,153,123,210,255,110,127,152,255,229,33,214,1,135,221,197,0,137,97,2,0,12,143,204,255,81,41,188,0,115,79,130,255,94,3,132,0,152,175,187,255,124,141,10,255,126,192,179,255,11,103,198,0,149,6,45,0,219,85,187,1,230,18,178,255,72,182,152,0,3,198,184,255,128,112,224,1,97,161,230,0,254,99,38,255,58,159,197,0,151,66,219,0,59,69,143,255,185,112,249,0,119,136,47,255,123,130,132,0,168,71,95,255,113,176,40,1,232,185,173,0,207,93,117,1,68,157,108,255,102,5,147,254,49,97,33,0,89,65,111,254,247,30,163,255,124,217,221,1,102,250,216,0,198,174,75,254,57,55,18,0,227,5,236,1,229,213,173,0,201,109,218,1,49,233,239,0,30,55,158,1,25,178,106,0,155,111,188,1,94,126,140,0,215,31,238,1,77,240,16,0,213,242,25,1,38,71,168,0,205,186,93,254,49,211,140,255,219,0,180,255,134,118,165,0,160,147,134,255,110,186,35,255,198,243,42,0,243,146,119,0,134,235,163,1,4,241,135,255,193,46,193,254,103,180,79,255,225,4,184,254,242,118,130,0,146,135,176,1,234,111,30,0,69,66,213,254,41,96,123,0,121,94,42,255,178,191,195,255,46,130,42,0,117,84,8,255,233,49,214,254,238,122,109,0,6,71,89,1,236,211,123,0,244,13,48,254,119,148,14,0,114,28,86,255,75,237,25,255,145,229,16,254,129,100,53,255,134,150,120,254,168,157,50,0,23,72,104,255,224,49,14,0,255,123,22,255,151,185,151,255,170,80,184,1,134,182,20,0,41,100,101,1,153,33,16,0,76,154,111,1,86,206,234,255,192,160,164,254,165,123,93,255,1,216,164,254,67,17,175,255,169,11,59,255,158,41,61,255,73,188,14,255,195,6,137,255,22,147,29,255,20,103,3,255,246,130,227,255,122,40,128,0,226,47,24,254,35,36,32,0,152,186,183,255,69,202,20,0,195,133,195,0,222,51,247,0,169,171,94,1,183,0,160,255,64,205,18,1,156,83,15,255,197,58,249,254,251,89,110,255,50,10,88,254,51,43,216,0,98,242,198,1,245,151,113,0,171,236,194,1,197,31,199,255,229,81,38,1,41,59,20,0,253,104,230,0,152,93,14,255,246,242,146,254,214,169,240,255,240,102,108,254,160,167,236,0,154,218,188,0,150,233,202,255,27,19,250,1,2,71,133,255,175,12,63,1,145,183,198,0,104,120,115,255,130,251,247,0,17,212,167,255,62,123,132,255,247,100,189,0,155,223,152,0,143,197,33,0,155,59,44,255,150,93,240,1,127,3,87,255,95,71,207,1,167,85,1,255,188,152,116,255,10,23,23,0,137,195,93,1,54,98,97,0,240,0,168,255,148,188,127,0,134,107,151,0,76,253,171,0,90,132,192,0,146,22,54,0,224,66,54,254,230,186,229,255,39,182,196,0,148,251,130,255,65,131,108,254,128,1,160,0,169,49,167,254,199,254,148,255,251,6,131,0,187,254,129,255,85,82,62,0,178,23,58,255,254,132,5,0,164,213,39,0,134,252,146,254,37,53,81,255,155,134,82,0,205,167,238,255,94,45,180,255,132,40,161,0,254,111,112,1,54,75,217,0,179,230,221,1,235,94,191,255,23,243,48,1,202,145,203,255,39,118,42,255,117,141,253,0,254,0,222,0,43,251,50,0,54,169,234,1,80,68,208,0,148,203,243,254,145,7,135,0,6,254,0,0,252,185,127,0,98,8,129,255,38,35,72,255,211,36,220,1,40,26,89,0,168,64,197,254,3,222,239,255,2,83,215,254,180,159,105,0,58,115,194,0,186,116,106,255,229,247,219,255,129,118,193,0,202,174,183,1,166,161,72,0,201,107,147,254,237,136,74,0,233,230,106,1,105,111,168,0,64,224,30,1,1,229,3,0,102,151,175,255,194,238,228,255,254,250,212,0,187,237,121,0,67,251,96,1,197,30,11,0,183,95,204,0,205,89,138,0,64,221,37,1,255,223,30,255,178,48,211,255,241,200,90,255,167,209,96,255,57,130,221,0,46,114,200,255,61,184,66,0,55,182,24,254,110,182,33,0,171,190,232,255,114,94,31,0,18,221,8,0,47,231,254,0,255,112,83,0,118,15,215,255,173,25,40,254,192,193,31,255,238,21,146,255,171,193,118,255,101,234,53,254,131,212,112,0,89,192,107,1,8,208,27,0,181,217,15,255,231,149,232,0,140,236,126,0,144,9,199,255,12,79,181,254,147,182,202,255,19,109,182,255,49,212,225,0,74,163,203,0,175,233,148,0,26,112,51,0,193,193,9,255,15,135,249,0,150,227,130,0,204,0,219,1,24,242,205,0,238,208,117,255,22,244,112,0,26,229,34,0,37,80,188,255,38,45,206,254,240,90,225,255,29,3,47,255,42,224,76,0,186,243,167,0,32,132,15,255,5,51,125,0,139,135,24,0,6,241,219,0,172,229,133,255,246,214,50,0,231,11,207,255,191,126,83,1,180,163,170,255,245,56,24,1,178,164,211,255,3,16,202,1,98,57,118,255,141,131,89,254,33,51,24,0,243,149,91,255,253,52,14,0,35,169,67,254,49,30,88,255,179,27,36,255,165,140,183,0,58,189,151,0,88,31,0,0,75,169,66,0,66,101,199,255,24,216,199,1,121,196,26,255,14,79,203,254,240,226,81,255,94,28,10,255,83,193,240,255,204,193,131,255,94,15,86,0,218,40,157,0,51,193,209,0,0,242,177,0,102,185,247,0,158,109,116,0,38,135,91,0,223,175,149,0,220,66,1,255,86,60,232,0,25,96,37,255,225,122,162,1,215,187,168,255,158,157,46,0,56,171,162,0,232,240,101,1,122,22,9,0,51,9,21,255,53,25,238,255,217,30,232,254,125,169,148,0,13,232,102,0,148,9,37,0,165,97,141,1,228,131,41,0,222,15,243,255,254,18,17,0,6,60,237,1,106,3,113,0,59,132,189,0,92,112,30,0,105,208,213,0,48,84,179,255,187,121,231,254,27,216,109,255,162,221,107,254,73,239,195,255,250,31,57,255,149,135,89,255,185,23,115,1,3,163,157,255,18,112,250,0,25,57,187,255,161,96,164,0,47,16,243,0,12,141,251,254,67,234,184,255,41,18,161,0,175,6,96,255,160,172,52,254,24,176,183,255,198,193,85,1,124,121,137,255,151,50,114,255,220,203,60,255,207,239,5,1,0,38,107,255,55,238,94,254,70,152,94,0,213,220,77,1,120,17,69,255,85,164,190,255,203,234,81,0,38,49,37,254,61,144,124,0,137,78,49,254,168,247,48,0,95,164,252,0,105,169,135,0,253,228,134,0,64,166,75,0,81,73,20,255,207,210,10,0,234,106,150,255,94,34,90,255,254,159,57,254,220,133,99,0,139,147,180,254,24,23,185,0,41,57,30,255,189,97,76,0,65,187,223,255,224,172,37,255,34,62,95,1,231,144,240,0,77,106,126,254,64,152,91,0,29,98,155,0,226,251,53,255,234,211,5,255,144,203,222,255,164,176,221,254,5,231,24,0,179,122,205,0,36,1,134,255,125,70,151,254,97,228,252,0,172,129,23,254,48,90,209,255,150,224,82,1,84,134,30,0,241,196,46,0,103,113,234,255,46,101,121,254,40,124,250,255,135,45,242,254,9,249,168,255,140,108,131,255,143,163,171,0,50,173,199,255,88,222,142,255,200,95,158,0,142,192,163,255,7,117,135,0,111,124,22,0,236,12,65,254,68,38,65,255,227,174,254,0,244,245,38,0,240,50,208,255,161,63,250,0,60,209,239,0,122,35,19,0,14,33,230,254,2,159,113,0,106,20,127,255,228,205,96,0,137,210,174,254,180,212,144,255,89,98,154,1,34,88,139,0,167,162,112,1,65,110,197,0,241,37,169,0,66,56,131,255,10,201,83,254,133,253,187,255,177,112,45,254,196,251,0,0,196,250,151,255,238,232,214,255,150,209,205,0,28,240,118,0,71,76,83,1,236,99,91,0,42,250,131,1,96,18,64,255,118,222,35,0,113,214,203,255,122,119,184,255,66,19,36,0,204,64,249,0,146,89,139,0,134,62,135,1,104,233,101,0,188,84,26,0,49,249,129,0,208,214,75,255,207,130,77,255,115,175,235,0,171,2,137,255,175,145,186,1,55,245,135,255,154,86,181,1,100,58,246,255,109,199,60,255,82,204,134,255,215,49,230,1,140,229,192,255,222,193,251,255,81,136,15,255,179,149,162,255,23,39,29,255,7,95,75,254,191,81,222,0,241,81,90,255,107,49,201,255,244,211,157,0,222,140,149,255,65,219,56,254,189,246,90,255,178,59,157,1,48,219,52,0,98,34,215,0,28,17,187,255,175,169,24,0,92,79,161,255,236,200,194,1,147,143,234,0,229,225,7,1,197,168,14,0,235,51,53,1,253,120,174,0,197,6,168,255,202,117,171,0,163,21,206,0,114,85,90,255,15,41,10,255,194,19,99,0,65,55,216,254,162,146,116,0,50,206,212,255,64,146,29,255,158,158,131,1,100,165,130,255,172,23,129,255,125,53,9,255,15,193,18,1,26,49,11,255,181,174,201,1,135,201,14,255,100,19,149,0,219,98,79,0,42,99,143,254,96,0,48,255,197,249,83,254,104,149,79,255,235,110,136,254,82,128,44,255,65,41,36,254,88,211,10,0,187,121,187,0,98,134,199,0,171,188,179,254,210,11,238,255,66,123,130,254,52,234,61,0,48,113,23,254,6,86,120,255,119,178,245,0,87,129,201,0,242,141,209,0,202,114,85,0,148,22,161,0,103,195,48,0,25,49,171,255,138,67,130,0,182,73,122,254,148,24,130,0,211,229,154,0,32,155,158,0,84,105,61,0,177,194,9,255,166,89,86,1,54,83,187,0,249,40,117,255,109,3,215,255,53,146,44,1,63,47,179,0,194,216,3,254,14,84,136,0,136,177,13,255,72,243,186,255,117,17,125,255,211,58,211,255,93,79,223,0,90,88,245,255,139,209,111,255,70,222,47,0,10,246,79,255,198,217,178,0,227,225,11,1,78,126,179,255,62,43,126,0,103,148,35,0,129,8,165,254,245,240,148,0,61,51,142,0,81,208,134,0,15,137,115,255,211,119,236,255,159,245,248,255,2,134,136,255,230,139,58,1,160,164,254,0,114,85,141,255,49,166,182,255,144,70,84,1,85,182,7,0,46,53,93,0,9,166,161,255,55,162,178,255,45,184,188,0,146,28,44,254,169,90,49,0,120,178,241,1,14,123,127,255,7,241,199,1,189,66,50,255,198,143,101,254,189,243,135,255,141,24,24,254,75,97,87,0,118,251,154,1,237,54,156,0,171,146,207,255,131,196,246,255,136,64,113,1,151,232,57,0,240,218,115,0,49,61,27,255,64,129,73,1,252,169,27,255,40,132,10,1,90,201,193,255,252,121,240,1,186,206,41,0,43,198,97,0,145,100,183,0,204,216,80,254,172,150,65,0,249,229,196,254,104,123,73,255,77,104,96,254,130,180,8,0,104,123,57,0,220,202,229,255,102,249,211,0,86,14,232,255,182,78,209,0,239,225,164,0,106,13,32,255,120,73,17,255,134,67,233,0,83,254,181,0,183,236,112,1,48,64,131,255,241,216,243,255,65,193,226,0,206,241,100,254,100,134,166,255,237,202,197,0,55,13,81,0,32,124,102,255,40,228,177,0,118,181,31,1,231,160,134,255,119,187,202,0,0,142,60,255,128,38,189,255,166,201,150,0,207,120,26,1,54,184,172,0,12,242,204,254,133,66,230,0,34,38,31,1,184,112,80,0,32,51,165,254,191,243,55,0,58,73,146,254,155,167,205,255,100,104,152,255,197,254,207,255,173,19,247,0,238,10,202,0,239,151,242,0,94,59,39,255,240,29,102,255,10,92,154,255,229,84,219,255,161,129,80,0,208,90,204,1,240,219,174,255,158,102,145,1,53,178,76,255,52,108,168,1,83,222,107,0,211,36,109,0,118,58,56,0,8,29,22,0,237,160,199,0,170,209,157,0,137,71,47,0,143,86,32,0,198,242,2,0,212,48,136,1,92,172,186,0,230,151,105,1,96,191,229,0,138,80,191,254,240,216,130,255,98,43,6,254,168,196,49,0,253,18,91,1,144,73,121,0,61,146,39,1,63,104,24,255,184,165,112,254,126,235,98,0,80,213,98,255,123,60,87,255,82,140,245,1,223,120,173,255,15,198,134,1,206,60,239,0,231,234,92,255,33,238,19,255,165,113,142,1,176,119,38,0,160,43,166,254,239,91,105,0,107,61,194,1,25,4,68,0,15,139,51,0,164,132,106,255,34,116,46,254,168,95,197,0,137,212,23,0,72,156,58,0,137,112,69,254,150,105,154,255,236,201,157,0,23,212,154,255,136,82,227,254,226,59,221,255,95,149,192,0,81,118,52,255,33,43,215,1,14,147,75,255,89,156,121,254,14,18,79,0,147,208,139,1,151,218,62,255,156,88,8,1,210,184,98,255,20,175,123,255,102,83,229,0,220,65,116,1,150,250,4,255,92,142,220,255,34,247,66,255,204,225,179,254,151,81,151,0,71,40,236,255,138,63,62,0,6,79,240,255,183,185,181,0,118,50,27,0,63,227,192,0,123,99,58,1,50,224,155,255,17,225,223,254,220,224,77,255,14,44,123,1,141,128,175,0,248,212,200,0,150,59,183,255,147,97,29,0,150,204,181,0,253,37,71,0,145,85,119,0,154,200,186,0,2,128,249,255,83,24,124,0,14,87,143,0,168,51,245,1,124,151,231,255,208,240,197,1,124,190,185,0,48,58,246,0,20,233,232,0,125,18,98,255,13,254,31,255,245,177,130,255,108,142,35,0,171,125,242,254,140,12,34,255,165,161,162,0,206,205,101,0,247,25,34,1,100,145,57,0,39,70,57,0,118,204,203,255,242,0,162,0,165,244,30,0,198,116,226,0,128,111,153,255,140,54,182,1,60,122,15,255,155,58,57,1,54,50,198,0,171,211,29,255,107,138,167,255,173,107,199,255,109,161,193,0,89,72,242,255,206,115,89,255,250,254,142,254,177,202,94,255,81,89,50,0,7,105,66,255,25,254,255,254,203,64,23,255,79,222,108,255,39,249,75,0,241,124,50,0,239,152,133,0,221,241,105,0,147,151,98,0,213,161,121,254,242,49,137,0,233,37,249,254,42,183,27,0,184,119,230,255,217,32,163,255,208,251,228,1,137,62,131,255,79,64,9,254,94,48,113,0,17,138,50,254,193,255,22,0,247,18,197,1,67,55,104,0,16,205,95,255,48,37,66,0,55,156,63,1,64,82,74,255,200,53,71,254,239,67,125,0,26,224,222,0,223,137,93,255,30,224,202,255,9,220,132,0,198,38,235,1,102,141,86,0,60,43,81,1,136,28,26,0,233,36,8,254,207,242,148,0,164,162,63,0,51,46,224,255,114,48,79,255,9,175,226,0,222,3,193,255,47,160,232,255,255,93,105,254,14,42,230,0,26,138,82,1,208,43,244,0,27,39,38,255,98,208,127,255,64,149,182,255,5,250,209,0,187,60,28,254,49,25,218,255,169,116,205,255,119,18,120,0,156,116,147,255,132,53,109,255,13,10,202,0,110,83,167,0,157,219,137,255,6,3,130,255,50,167,30,255,60,159,47,255,129,128,157,254,94,3,189,0,3,166,68,0,83,223,215,0,150,90,194,1,15,168,65,0,227,83,51,255,205,171,66,255,54,187,60,1,152,102,45,255,119,154,225,0,240,247,136,0,100,197,178,255,139,71,223,255,204,82,16,1,41,206,42,255,156,192,221,255,216,123,244,255,218,218,185,255,187,186,239,255,252,172,160,255,195,52,22,0,144,174,181,254,187,100,115,255,211,78,176,255,27,7,193,0,147,213,104,255,90,201,10,255,80,123,66,1,22,33,186,0,1,7,99,254,30,206,10,0,229,234,5,0,53,30,210,0,138,8,220,254,71,55,167,0,72,225,86,1,118,190,188,0,254,193,101,1,171,249,172,255,94,158,183,254,93,2,108,255,176,93,76,255,73,99,79,255,74,64,129,254,246,46,65,0,99,241,127,254,246,151,102,255,44,53,208,254,59,102,234,0,154,175,164,255,88,242,32,0,111,38,1,0,255,182,190,255,115,176,15,254,169,60,129,0,122,237,241,0,90,76,63,0,62,74,120,255,122,195,110,0,119,4,178,0,222,242,210,0,130,33,46,254,156,40,41,0,167,146,112,1,49,163,111,255,121,176,235,0,76,207,14,255,3,25,198,1,41,235,213,0,85,36,214,1,49,92,109,255,200,24,30,254,168,236,195,0,145,39,124,1,236,195,149,0,90,36,184,255,67,85,170,255,38,35,26,254,131,124,68,255,239,155,35,255,54,201,164,0,196,22,117,255,49,15,205,0,24,224,29,1,126,113,144,0,117,21,182,0,203,159,141,0,223,135,77,0,176,230,176,255,190,229,215,255,99,37,181,255,51,21,138,255,25,189,89,255,49,48,165,254,152,45,247,0,170,108,222,0,80,202,5,0,27,69,103,254,204,22,129,255,180,252,62,254,210,1,91,255,146,110,254,255,219,162,28,0,223,252,213,1,59,8,33,0,206,16,244,0,129,211,48,0,107,160,208,0,112,59,209,0,109,77,216,254,34,21,185,255,246,99,56,255,179,139,19,255,185,29,50,255,84,89,19,0,74,250,98,255,225,42,200,255,192,217,205,255,210,16,167,0,99,132,95,1,43,230,57,0,254,11,203,255,99,188,63,255,119,193,251,254,80,105,54,0,232,181,189,1,183,69,112,255,208,171,165,255,47,109,180,255,123,83,165,0,146,162,52,255,154,11,4,255,151,227,90,255,146,137,97,254,61,233,41,255,94,42,55,255,108,164,236,0,152,68,254,0,10,140,131,255,10,106,79,254,243,158,137,0,67,178,66,254,177,123,198,255,15,62,34,0,197,88,42,255,149,95,177,255,152,0,198,255,149,254,113,255,225,90,163,255,125,217,247,0,18,17,224,0,128,66,120,254,192,25,9,255,50,221,205,0,49,212,70,0,233,255,164,0,2,209,9,0,221,52,219,254,172,224,244,255,94,56,206,1,242,179,2,255,31,91,164,1,230,46,138,255,189,230,220,0,57,47,61,255,111,11,157,0,177,91,152,0,28,230,98,0,97,87,126,0,198,89,145,255,167,79,107,0,249,77,160,1,29,233,230,255,150,21,86,254,60,11,193,0,151,37,36,254,185,150,243,255,228,212,83,1,172,151,180,0,201,169,155,0,244,60,234,0,142,235,4,1,67,218,60,0,192,113,75,1,116,243,207,255,65,172,155,0,81,30,156,255,80,72,33,254,18,231,109,255,142,107,21,254,125,26,132,255,176,16,59,255,150,201,58,0,206,169,201,0,208,121,226,0,40,172,14,255,150,61,94,255,56,57,156,255,141,60,145,255,45,108,149,255,238,145,155,255,209,85,31,254,192,12,210,0,99,98,93,254,152,16,151,0,225,185,220,0,141,235,44,255,160,172,21,254,71,26,31,255,13,64,93,254,28,56,198,0,177,62,248,1,182,8,241,0,166,101,148,255,78,81,133,255,129,222,215,1,188,169,129,255,232,7,97,0,49,112,60,255,217,229,251,0,119,108,138,0,39,19,123,254,131,49,235,0,132,84,145,0,130,230,148,255,25,74,187,0,5,245,54,255,185,219,241,1,18,194,228,255,241,202,102,0,105,113,202,0,155,235,79,0,21,9,178,255,156,1,239,0,200,148,61,0,115,247,210,255,49,221,135,0,58,189,8,1,35,46,9,0,81,65,5,255,52,158,185,255,125,116,46,255,74,140,13,255,210,92,172,254,147,23,71,0,217,224,253,254,115,108,180,255,145,58,48,254,219,177,24,255,156,255,60,1,154,147,242,0,253,134,87,0,53,75,229,0,48,195,222,255,31,175,50,255,156,210,120,255,208,35,222,255,18,248,179,1,2,10,101,255,157,194,248,255,158,204,101,255,104,254,197,255,79,62,4,0,178,172,101,1,96,146,251,255,65,10,156,0,2,137,165,255,116,4,231,0,242,215,1,0,19,35,29,255,43,161,79,0,59,149,246,1,251,66,176,0,200,33,3,255,80,110,142,255,195,161,17,1,228,56,66,255,123,47,145,254,132,4,164,0,67,174,172,0,25,253,114,0,87,97,87,1,250,220,84,0,96,91,200,255,37,125,59,0,19,65,118,0,161,52,241,255,237,172,6,255,176,191,255,255,1,65,130,254,223,190,230,0,101,253,231,255,146,35,109,0,250,29,77,1,49,0,19,0,123,90,155,1,22,86,32,255,218,213,65,0,111,93,127,0,60,93,169,255,8,127,182,0,17,186,14,254,253,137,246,255,213,25,48,254,76,238,0,255,248,92,70,255,99,224,139,0,184,9,255,1,7,164,208,0,205,131,198,1,87,214,199,0,130,214,95,0,221,149,222,0,23,38,171,254,197,110,213,0,43,115,140,254,215,177,118,0,96,52,66,1,117,158,237,0,14,64,182,255,46,63,174,255,158,95,190,255,225,205,177,255,43,5,142,255,172,99,212,255,244,187,147,0,29,51,153,255,228,116,24,254,30,101,207,0,19,246,150,255,134,231,5,0,125,134,226,1,77,65,98,0,236,130,33,255,5,110,62,0,69,108,127,255,7,113,22,0,145,20,83,254,194,161,231,255,131,181,60,0,217,209,177,255,229,148,212,254,3,131,184,0,117,177,187,1,28,14,31,255,176,102,80,0,50,84,151,255,125,31,54,255,21,157,133,255,19,179,139,1,224,232,26,0,34,117,170,255,167,252,171,255,73,141,206,254,129,250,35,0,72,79,236,1,220,229,20,255,41,202,173,255,99,76,238,255,198,22,224,255,108,198,195,255,36,141,96,1,236,158,59,255,106,100,87,0,110,226,2,0,227,234,222,0,154,93,119,255,74,112,164,255,67,91,2,255,21,145,33,255,102,214,137,255,175,230,103,254,163,246,166,0,93,247,116,254,167,224,28,255,220,2,57,1,171,206,84,0,123,228,17,255,27,120,119,0,119,11,147,1,180,47,225,255,104,200,185,254,165,2,114,0,77,78,212,0,45,154,177,255,24,196,121,254,82,157,182,0,90,16,190,1,12,147,197,0,95,239,152,255,11,235,71,0,86,146,119,255,172,134,214,0,60,131,196,0,161,225,129,0,31,130,120,254,95,200,51,0,105,231,210,255,58,9,148,255,43,168,221,255,124,237,142,0,198,211,50,254,46,245,103,0,164,248,84,0,152,70,208,255,180,117,177,0,70,79,185,0,243,74,32,0,149,156,207,0,197,196,161,1,245,53,239,0,15,93,246,254,139,240,49,255,196,88,36,255,162,38,123,0,128,200,157,1,174,76,103,255,173,169,34,254,216,1,171,255,114,51,17,0,136,228,194,0,110,150,56,254,106,246,159,0,19,184,79,255,150,77,240,255,155,80,162,0,0,53,169,255,29,151,86,0,68,94,16,0,92,7,110,254,98,117,149,255,249,77,230,255,253,10,140,0,214,124,92,254,35,118,235,0,89,48,57,1,22,53,166,0,184,144,61,255,179,255,194,0,214,248,61,254,59,110,246,0,121,21,81,254,166,3,228,0,106,64,26,255,69,232,134,255,242,220,53,254,46,220,85,0,113,149,247,255,97,179,103,255,190,127,11,0,135,209,182,0,95,52,129,1,170,144,206,255,122,200,204,255,168,100,146,0,60,144,149,254,70,60,40,0,122,52,177,255,246,211,101,255,174,237,8,0,7,51,120,0,19,31,173,0,126,239,156,255,143,189,203,0,196,128,88,255,233,133,226,255,30,125,173,255,201,108,50,0,123,100,59,255,254,163,3,1,221,148,181,255,214,136,57,254,222,180,137,255,207,88,54,255,28,33,251,255,67,214,52,1,210,208,100,0,81,170,94,0,145,40,53,0,224,111,231,254,35,28,244,255,226,199,195,254,238,17,230,0,217,217,164,254,169,157,221,0,218,46,162,1,199,207,163,255,108,115,162,1,14,96,187,255,118,60,76,0,184,159,152,0,209,231,71,254,42,164,186,255,186,153,51,254,221,171,182,255,162,142,173,0,235,47,193,0,7,139,16,1,95,164,64,255,16,221,166,0,219,197,16,0,132,29,44,255,100,69,117,255,60,235,88,254,40,81,173,0,71,190,61,255,187,88,157,0,231,11,23,0,237,117,164,0,225,168,223,255,154,114,116,255,163,152,242,1,24,32,170,0,125,98,113,254,168,19,76,0,17,157,220,254,155,52,5,0,19,111,161,255,71,90,252,255,173,110,240,0,10,198,121,255,253,255,240,255,66,123,210,0,221,194,215,254,121,163,17,255,225,7,99,0,190,49,182,0,115,9,133,1,232,26,138,255,213,68,132,0,44,119,122,255,179,98,51,0,149,90,106,0,71,50,230,255,10,153,118,255,177,70,25,0,165,87,205,0,55,138,234,0,238,30,97,0,113,155,207,0,98,153,127,0,34,107,219,254,117,114,172,255,76,180,255,254,242,57,179,255,221,34,172,254,56,162,49,255,83,3,255,255,113,221,189,255,188,25,228,254,16,88,89,255,71,28,198,254,22,17,149,255,243,121,254,255,107,202,99,255,9,206,14,1,220,47,153,0,107,137,39,1,97,49,194,255,149,51,197,254,186,58,11,255,107,43,232,1,200,6,14,255,181,133,65,254,221,228,171,255,123,62,231,1,227,234,179,255,34,189,212,254,244,187,249,0,190,13,80,1,130,89,1,0,223,133,173,0,9,222,198,255,66,127,74,0,167,216,93,255,155,168,198,1,66,145,0,0,68,102,46,1,172,90,154,0,216,128,75,255,160,40,51,0,158,17,27,1,124,240,49,0,236,202,176,255,151,124,192,255,38,193,190,0,95,182,61,0,163,147,124,255,255,165,51,255,28,40,17,254,215,96,78,0,86,145,218,254,31,36,202,255,86,9,5,0,111,41,200,255,237,108,97,0,57,62,44,0,117,184,15,1,45,241,116,0,152,1,220,255,157,165,188,0,250,15,131,1,60,44,125,255,65,220,251,255,75,50,184,0,53,90,128,255,231,80,194,255,136,129,127,1,21,18,187,255,45,58,161,255,71,147,34,0,174,249,11,254,35,141,29,0,239,68,177,255,115,110,58,0,238,190,177,1,87,245,166,255,190,49,247,255,146,83,184,255,173,14,39,255,146,215,104,0,142,223,120,0,149,200,155,255,212,207,145,1,16,181,217,0,173,32,87,255,255,35,181,0,119,223,161,1,200,223,94,255,70,6,186,255,192,67,85,255,50,169,152,0,144,26,123,255,56,243,179,254,20,68,136,0,39,140,188,254,253,208,5,255,200,115,135,1,43,172,229,255,156,104,187,0,151,251,167,0,52,135,23,0,151,153,72,0,147,197,107,254,148,158,5,255,238,143,206,0,126,153,137,255,88,152,197,254,7,68,167,0,252,159,165,255,239,78,54,255,24,63,55,255,38,222,94,0,237,183,12,255,206,204,210,0,19,39,246,254,30,74,231,0,135,108,29,1,179,115,0,0,117,118,116,1,132,6,252,255,145,129,161,1,105,67,141,0,82,37,226,255,238,226,228,255,204,214,129,254,162,123,100,255,185,121,234,0,45,108,231,0,66,8,56,255,132,136,128,0,172,224,66,254,175,157,188,0,230,223,226,254,242,219,69,0,184,14,119,1,82,162,56,0,114,123,20,0,162,103,85,255,49,239,99,254,156,135,215,0,111,255,167,254,39,196,214,0,144,38,79,1,249,168,125,0,155,97,156,255,23,52,219,255,150,22,144,0,44,149,165,255,40,127,183,0,196,77,233,255,118,129,210,255,170,135,230,255,214,119,198,0,233,240,35,0,253,52,7,255,117,102,48,255,21,204,154,255,179,136,177,255,23,2,3,1,149,130,89,255,252,17,159,1,70,60,26,0,144,107,17,0,180,190,60,255,56,182,59,255,110,71,54,255,198,18,129,255,149,224,87,255,223,21,152,255,138,22,182,255,250,156,205,0,236,45,208,255,79,148,242,1,101,70,209,0,103,78,174,0,101,144,172,255,152,136,237,1,191,194,136,0,113,80,125,1,152,4,141,0,155,150,53,255,196,116,245,0,239,114,73,254,19,82,17,255,124,125,234,255,40,52,191,0,42,210,158,255,155,132,165,0,178,5,42,1,64,92,40,255,36,85,77,255,178,228,118,0,137,66,96,254,115,226,66,0,110,240,69,254,151,111,80,0,167,174,236,255,227,108,107,255,188,242,65,255,183,81,255,0,57,206,181,255,47,34,181,255,213,240,158,1,71,75,95,0,156,40,24,255,102,210,81,0,171,199,228,255,154,34,41,0,227,175,75,0,21,239,195,0,138,229,95,1,76,192,49,0,117,123,87,1,227,225,130,0,125,62,63,255,2,198,171,0,254,36,13,254,145,186,206,0,148,255,244,255,35,0,166,0,30,150,219,1,92,228,212,0,92,198,60,254,62,133,200,255,201,41,59,0,125,238,109,255,180,163,238,1,140,122,82,0,9,22,88,255,197,157,47,255,153,94,57,0,88,30,182,0,84,161,85,0,178,146,124,0,166,166,7,255,21,208,223,0,156,182,242,0,155,121,185,0,83,156,174,254,154,16,118,255,186,83,232,1,223,58,121,255,29,23,88,0,35,125,127,255,170,5,149,254,164,12,130,255,155,196,29,0,161,96,136,0,7,35,29,1,162,37,251,0,3,46,242,255,0,217,188,0,57,174,226,1,206,233,2,0,57,187,136,254,123,189,9,255,201,117,127,255,186,36,204,0,231,25,216,0,80,78,105,0,19,134,129,255,148,203,68,0,141,81,125,254,248,165,200,255,214,144,135,0,151,55,166,255,38,235,91,0,21,46,154,0,223,254,150,255,35,153,180,255,125,176,29,1,43,98,30,255,216,122,230,255,233,160,12,0,57,185,12,254,240,113,7,255,5,9,16,254,26,91,108,0,109,198,203,0,8,147,40,0,129,134,228,255,124,186,40,255,114,98,132,254,166,132,23,0,99,69,44,0,9,242,238,255,184,53,59,0,132,129,102,255,52,32,243,254,147,223,200,255,123,83,179,254,135,144,201,255,141,37,56,1,151,60,227,255,90,73,156,1,203,172,187,0,80,151,47,255,94,137,231,255,36,191,59,255,225,209,181,255,74,215,213,254,6,118,179,255,153,54,193,1,50,0,231,0,104,157,72,1,140,227,154,255,182,226,16,254,96,225,92,255,115,20,170,254,6,250,78,0,248,75,173,255,53,89,6,255,0,180,118,0,72,173,1,0,64,8,206,1,174,133,223,0,185,62,133,255,214,11,98,0,197,31,208,0,171,167,244,255,22,231,181,1,150,218,185,0,247,169,97,1,165,139,247,255,47,120,149,1,103,248,51,0,60,69,28,254,25,179,196,0,124,7,218,254,58,107,81,0,184,233,156,255,252,74,36,0,118,188,67,0,141,95,53,255,222,94,165,254,46,61,53,0,206,59,115,255,47,236,250,255,74,5,32,1,129,154,238,255,106,32,226,0,121,187,61,255,3,166,241,254,67,170,172,255,29,216,178,255,23,201,252,0,253,110,243,0,200,125,57,0,109,192,96,255,52,115,238,0,38,121,243,255,201,56,33,0,194,118,130,0,75,96,25,255,170,30,230,254,39,63,253,0,36,45,250,255,251,1,239,0,160,212,92,1,45,209,237,0,243,33,87,254,237,84,201,255,212,18,157,254,212,99,127,255,217,98,16,254,139,172,239,0,168,201,130,255,143,193,169,255,238,151,193,1,215,104,41,0,239,61,165,254,2,3,242,0,22,203,177,254,177,204,22,0,149,129,213,254,31,11,41,255,0,159,121,254,160,25,114,255,162,80,200,0,157,151,11,0,154,134,78,1,216,54,252,0,48,103,133,0,105,220,197,0,253,168,77,254,53,179,23,0,24,121,240,1,255,46,96,255,107,60,135,254,98,205,249,255,63,249,119,255,120,59,211,255,114,180,55,254,91,85,237,0,149,212,77,1,56,73,49,0,86,198,150,0,93,209,160,0,69,205,182,255,244,90,43,0,20,36,176,0,122,116,221,0,51,167,39,1,231,1,63,255,13,197,134,0,3,209,34,255,135,59,202,0,167,100,78,0,47,223,76,0,185,60,62,0,178,166,123,1,132,12,161,255,61,174,43,0,195,69,144,0,127,47,191,1,34,44,78,0,57,234,52,1,255,22,40,255,246,94,146,0,83,228,128,0,60,78,224,255,0,96,210,255,153,175,236,0,159,21,73,0,180,115,196,254,131,225,106,0,255,167,134,0,159,8,112,255,120,68,194,255,176,196,198,255,118,48,168,255,93,169,1,0,112,200,102,1,74,24,254,0,19,141,4,254,142,62,63,0,131,179,187,255,77,156,155,255,119,86,164,0,170,208,146,255,208,133,154,255,148,155,58,255,162,120,232,254,252,213,155,0,241,13,42,0,94,50,131,0,179,170,112,0,140,83,151,255,55,119,84,1,140,35,239,255,153,45,67,1,236,175,39,0,54,151,103,255,158,42,65,255,196,239,135,254,86,53,203,0,149,97,47,254,216,35,17,255,70,3,70,1,103,36,90,255,40,26,173,0,184,48,13,0,163,219,217,255,81,6,1,255,221,170,108,254,233,208,93,0,100,201,249,254,86,36,35,255,209,154,30,1,227,201,251,255,2,189,167,254,100,57,3,0,13,128,41,0,197,100,75,0,150,204,235,255,145,174,59,0,120,248,149,255,85,55,225,0,114,210,53,254,199,204,119,0,14,247,74,1,63,251,129,0,67,104,151,1,135,130,80,0,79,89,55,255,117,230,157,255,25,96,143,0,213,145,5,0,69,241,120,1,149,243,95,255,114,42,20,0,131,72,2,0,154,53,20,255,73,62,109,0,196,102,152,0,41,12,204,255,122,38,11,1,250,10,145,0,207,125,148,0,246,244,222,255,41,32,85,1,112,213,126,0,162,249,86,1,71,198,127,255,81,9,21,1,98,39,4,255,204,71,45,1,75,111,137,0,234,59,231,0,32,48,95,255,204,31,114,1,29,196,181,255,51,241,167,254,93,109,142,0,104,144,45,0,235,12,181,255,52,112,164,0,76,254,202,255,174,14,162,0,61,235,147,255,43,64,185,254,233,125,217,0,243,88,167,254,74,49,8,0,156,204,66,0,124,214,123,0,38,221,118,1,146,112,236,0,114,98,177,0,151,89,199,0,87,197,112,0,185,149,161,0,44,96,165,0,248,179,20,255,188,219,216,254,40,62,13,0,243,142,141,0,229,227,206,255,172,202,35,255,117,176,225,255,82,110,38,1,42,245,14,255,20,83,97,0,49,171,10,0,242,119,120,0,25,232,61,0,212,240,147,255,4,115,56,255,145,17,239,254,202,17,251,255,249,18,245,255,99,117,239,0,184,4,179,255,246,237,51,255,37,239,137,255,166,112,166,255,81,188,33,255,185,250,142,255,54,187,173,0,208,112,201,0,246,43,228,1,104,184,88,255,212,52,196,255,51,117,108,255,254,117,155,0,46,91,15,255,87,14,144,255,87,227,204,0,83,26,83,1,159,76,227,0,159,27,213,1,24,151,108,0,117,144,179,254,137,209,82,0,38,159,10,0,115,133,201,0,223,182,156,1,110,196,93,255,57,60,233,0,5,167,105,255,154,197,164,0,96,34,186,255,147,133,37,1,220,99,190,0,1,167,84,255,20,145,171,0,194,197,251,254,95,78,133,255,252,248,243,255,225,93,131,255,187,134,196,255,216,153,170,0,20,118,158,254,140,1,118,0,86,158,15,1,45,211,41,255,147,1,100,254,113,116,76,255,211,127,108,1,103,15,48,0,193,16,102,1,69,51,95,255,107,128,157,0,137,171,233,0,90,124,144,1,106,161,182,0,175,76,236,1,200,141,172,255,163,58,104,0,233,180,52,255,240,253,14,255,162,113,254,255,38,239,138,254,52,46,166,0,241,101,33,254,131,186,156,0,111,208,62,255,124,94,160,255,31,172,254,0,112,174,56,255,188,99,27,255,67,138,251,0,125,58,128,1,156,152,174,255,178,12,247,255,252,84,158,0,82,197,14,254,172,200,83,255,37,39,46,1,106,207,167,0,24,189,34,0,131,178,144,0,206,213,4,0,161,226,210,0,72,51,105,255,97,45,187,255,78,184,223,255,176,29,251,0,79,160,86,255,116,37,178,0,82,77,213,1,82,84,141,255,226,101,212,1,175,88,199,255,245,94,247,1,172,118,109,255,166,185,190,0,131,181,120,0,87,254,93,255,134,240,73,255,32,245,143,255,139,162,103,255,179,98,18,254,217,204,112,0,147,223,120,255,53,10,243,0,166,140,150,0,125,80,200,255,14,109,219,255,91,218,1,255,252,252,47,254,109,156,116,255,115,49,127,1,204,87,211,255,148,202,217,255,26,85,249,255,14,245,134,1,76,89,169,255,242,45,230,0,59,98,172,255,114,73,132,254,78,155,49,255,158,126,84,0,49,175,43,255,16,182,84,255,157,103,35,0,104,193,109,255,67,221,154,0,201,172,1,254,8,162,88,0,165,1,29,255,125,155,229,255,30,154,220,1,103,239,92,0,220,1,109,255,202,198,1,0,94,2,142,1,36,54,44,0,235,226,158,255,170,251,214,255,185,77,9,0,97,74,242,0,219,163,149,255,240,35,118,255,223,114,88,254,192,199,3,0,106,37,24,255,201,161,118,255,97,89,99,1,224,58,103,255,101,199,147,254,222,60,99,0,234,25,59,1,52,135,27,0,102,3,91,254,168,216,235,0,229,232,136,0,104,60,129,0,46,168,238,0,39,191,67,0,75,163,47,0,143,97,98,255,56,216,168,1,168,233,252,255,35,111,22,255,92,84,43,0,26,200,87,1,91,253,152,0,202,56,70,0,142,8,77,0,80,10,175,1,252,199,76,0,22,110,82,255,129,1,194,0,11,128,61,1,87,14,145,255,253,222,190,1,15,72,174,0,85,163,86,254,58,99,44,255,45,24,188,254,26,205,15,0,19,229,210,254,248,67,195,0,99,71,184,0,154,199,37,255,151,243,121,255,38,51,75,255,201,85,130,254,44,65,250,0,57,147,243,254,146,43,59,255,89,28,53,0,33,84,24,255,179,51,18,254,189,70,83,0,11,156,179,1,98,134,119,0,158,111,111,0,119,154,73,255,200,63,140,254,45,13,13,255,154,192,2,254,81,72,42,0,46,160,185,254,44,112,6,0,146,215,149,1,26,176,104,0,68,28,87,1,236,50,153,255,179,128,250,254,206,193,191,255,166,92,137,254,53,40,239,0,210,1,204,254,168,173,35,0,141,243,45,1,36,50,109,255,15,242,194,255,227,159,122,255,176,175,202,254,70,57,72,0,40,223,56,0,208,162,58,255,183,98,93,0,15,111,12,0,30,8,76,255,132,127,246,255,45,242,103,0,69,181,15,255,10,209,30,0,3,179,121,0,241,232,218,1,123,199,88,255,2,210,202,1,188,130,81,255,94,101,208,1,103,36,45,0,76,193,24,1,95,26,241,255,165,162,187,0,36,114,140,0,202,66,5,255,37,56,147,0,152,11,243,1,127,85,232,255,250,135,212,1,185,177,113,0,90,220,75,255,69,248,146,0,50,111,50,0,92,22,80,0,244,36,115,254,163,100,82,255,25,193,6,1,127,61,36,0,253,67,30,254,65,236,170,255,161,17,215,254,63,175,140,0,55,127,4,0,79,112,233,0,109,160,40,0,143,83,7,255,65,26,238,255,217,169,140,255,78,94,189,255,0,147,190,255,147,71,186,254,106,77,127,255,233,157,233,1,135,87,237,255,208,13,236,1,155,109,36,255,180,100,218,0,180,163,18,0,190,110,9,1,17,63,123,255,179,136,180,255,165,123,123,255,144,188,81,254,71,240,108,255,25,112,11,255,227,218,51,255,167,50,234,255,114,79,108,255,31,19,115,255,183,240,99,0,227,87,143,255,72,217,248,255,102,169,95,1,129,149,149,0,238,133,12,1,227,204,35,0,208,115,26,1,102,8,234,0,112,88,143,1,144,249,14,0,240,158,172,254,100,112,119,0,194,141,153,254,40,56,83,255,121,176,46,0,42,53,76,255,158,191,154,0,91,209,92,0,173,13,16,1,5,72,226,255,204,254,149,0,80,184,207,0,100,9,122,254,118,101,171,255,252,203,0,254,160,207,54,0,56,72,249,1,56,140,13,255,10,64,107,254,91,101,52,255,225,181,248,1,139,255,132,0,230,145,17,0,233,56,23,0,119,1,241,255,213,169,151,255,99,99,9,254,185,15,191,255,173,103,109,1,174,13,251,255,178,88,7,254,27,59,68,255,10,33,2,255,248,97,59,0,26,30,146,1,176,147,10,0,95,121,207,1,188,88,24,0,185,94,254,254,115,55,201,0,24,50,70,0,120,53,6,0,142,66,146,0,228,226,249,255,104,192,222,1,173,68,219,0,162,184,36,255,143,102,137,255,157,11,23,0,125,45,98,0,235,93,225,254,56,112,160,255,70,116,243,1,153,249,55,255,129,39,17,1,241,80,244,0,87,69,21,1,94,228,73,255,78,66,65,255,194,227,231,0,61,146,87,255,173,155,23,255,112,116,219,254,216,38,11,255,131,186,133,0,94,212,187,0,100,47,91,0,204,254,175,255,222,18,215,254,173,68,108,255,227,228,79,255,38,221,213,0,163,227,150,254,31,190,18,0,160,179,11,1,10,90,94,255,220,174,88,0,163,211,229,255,199,136,52,0,130,95,221,255,140,188,231,254,139,113,128,255,117,171,236,254,49,220,20,255,59,20,171,255,228,109,188,0,20,225,32,254,195,16,174,0,227,254,136,1,135,39,105,0,150,77,206,255,210,238,226],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+10240);allocate([55,212,132,254,239,57,124,0,170,194,93,255,249,16,247,255,24,151,62,255,10,151,10,0,79,139,178,255,120,242,202,0,26,219,213,0,62,125,35,255,144,2,108,255,230,33,83,255,81,45,216,1,224,62,17,0,214,217,125,0,98,153,153,255,179,176,106,254,131,93,138,255,109,62,36,255,178,121,32,255,120,252,70,0,220,248,37,0,204,88,103,1,128,220,251,255,236,227,7,1,106,49,198,255,60,56,107,0,99,114,238,0,220,204,94,1,73,187,1,0,89,154,34,0,78,217,165,255,14,195,249,255,9,230,253,255,205,135,245,0,26,252,7,255,84,205,27,1,134,2,112,0,37,158,32,0,231,91,237,255,191,170,204,255,152,7,222,0,109,192,49,0,193,166,146,255,232,19,181,255,105,142,52,255,103,16,27,1,253,200,165,0,195,217,4,255,52,189,144,255,123,155,160,254,87,130,54,255,78,120,61,255,14,56,41,0,25,41,125,255,87,168,245,0,214,165,70,0,212,169,6,255,219,211,194,254,72,93,164,255,197,33,103,255,43,142,141,0,131,225,172,0,244,105,28,0,68,68,225,0,136,84,13,255,130,57,40,254,139,77,56,0,84,150,53,0,54,95,157,0,144,13,177,254,95,115,186,0,117,23,118,255,244,166,241,255,11,186,135,0,178,106,203,255,97,218,93,0,43,253,45,0,164,152,4,0,139,118,239,0,96,1,24,254,235,153,211,255,168,110,20,255,50,239,176,0,114,41,232,0,193,250,53,0,254,160,111,254,136,122,41,255,97,108,67,0,215,152,23,255,140,209,212,0,42,189,163,0,202,42,50,255,106,106,189,255,190,68,217,255,233,58,117,0,229,220,243,1,197,3,4,0,37,120,54,254,4,156,134,255,36,61,171,254,165,136,100,255,212,232,14,0,90,174,10,0,216,198,65,255,12,3,64,0,116,113,115,255,248,103,8,0,231,125,18,255,160,28,197,0,30,184,35,1,223,73,249,255,123,20,46,254,135,56,37,255,173,13,229,1,119,161,34,255,245,61,73,0,205,125,112,0,137,104,134,0,217,246,30,255,237,142,143,0,65,159,102,255,108,164,190,0,219,117,173,255,34,37,120,254,200,69,80,0,31,124,218,254,74,27,160,255,186,154,199,255,71,199,252,0,104,81,159,1,17,200,39,0,211,61,192,1,26,238,91,0,148,217,12,0,59,91,213,255,11,81,183,255,129,230,122,255,114,203,145,1,119,180,66,255,72,138,180,0,224,149,106,0,119,82,104,255,208,140,43,0,98,9,182,255,205,101,134,255,18,101,38,0,95,197,166,255,203,241,147,0,62,208,145,255,133,246,251,0,2,169,14,0,13,247,184,0,142,7,254,0,36,200,23,255,88,205,223,0,91,129,52,255,21,186,30,0,143,228,210,1,247,234,248,255,230,69,31,254,176,186,135,255,238,205,52,1,139,79,43,0,17,176,217,254,32,243,67,0,242,111,233,0,44,35,9,255,227,114,81,1,4,71,12,255,38,105,191,0,7,117,50,255,81,79,16,0,63,68,65,255,157,36,110,255,77,241,3,255,226,45,251,1,142,25,206,0,120,123,209,1,28,254,238,255,5,128,126,255,91,222,215,255,162,15,191,0,86,240,73,0,135,185,81,254,44,241,163,0,212,219,210,255,112,162,155,0,207,101,118,0,168,72,56,255,196,5,52,0,72,172,242,255,126,22,157,255,146,96,59,255,162,121,152,254,140,16,95,0,195,254,200,254,82,150,162,0,119,43,145,254,204,172,78,255,166,224,159,0,104,19,237,255,245,126,208,255,226,59,213,0,117,217,197,0,152,72,237,0,220,31,23,254,14,90,231,255,188,212,64,1,60,101,246,255,85,24,86,0,1,177,109,0,146,83,32,1,75,182,192,0,119,241,224,0,185,237,27,255,184,101,82,1,235,37,77,255,253,134,19,0,232,246,122,0,60,106,179,0,195,11,12,0,109,66,235,1,125,113,59,0,61,40,164,0,175,104,240,0,2,47,187,255,50,12,141,0,194,139,181,255,135,250,104,0,97,92,222,255,217,149,201,255,203,241,118,255,79,151,67,0,122,142,218,255,149,245,239,0,138,42,200,254,80,37,97,255,124,112,167,255,36,138,87,255,130,29,147,255,241,87,78,255,204,97,19,1,177,209,22,255,247,227,127,254,99,119,83,255,212,25,198,1,16,179,179,0,145,77,172,254,89,153,14,255,218,189,167,0,107,233,59,255,35,33,243,254,44,112,112,255,161,127,79,1,204,175,10,0,40,21,138,254,104,116,228,0,199,95,137,255,133,190,168,255,146,165,234,1,183,99,39,0,183,220,54,254,255,222,133,0,162,219,121,254,63,239,6,0,225,102,54,255,251,18,246,0,4,34,129,1,135,36,131,0,206,50,59,1,15,97,183,0,171,216,135,255,101,152,43,255,150,251,91,0,38,145,95,0,34,204,38,254,178,140,83,255,25,129,243,255,76,144,37,0,106,36,26,254,118,144,172,255,68,186,229,255,107,161,213,255,46,163,68,255,149,170,253,0,187,17,15,0,218,160,165,255,171,35,246,1,96,13,19,0,165,203,117,0,214,107,192,255,244,123,177,1,100,3,104,0,178,242,97,255,251,76,130,255,211,77,42,1,250,79,70,255,63,244,80,1,105,101,246,0,61,136,58,1,238,91,213,0,14,59,98,255,167,84,77,0,17,132,46,254,57,175,197,255,185,62,184,0,76,64,207,0,172,175,208,254,175,74,37,0,138,27,211,254,148,125,194,0,10,89,81,0,168,203,101,255,43,213,209,1,235,245,54,0,30,35,226,255,9,126,70,0,226,125,94,254,156,117,20,255,57,248,112,1,230,48,64,255,164,92,166,1,224,214,230,255,36,120,143,0,55,8,43,255,251,1,245,1,106,98,165,0,74,107,106,254,53,4,54,255,90,178,150,1,3,120,123,255,244,5,89,1,114,250,61,255,254,153,82,1,77,15,17,0,57,238,90,1,95,223,230,0,236,52,47,254,103,148,164,255,121,207,36,1,18,16,185,255,75,20,74,0,187,11,101,0,46,48,129,255,22,239,210,255,77,236,129,255,111,77,204,255,61,72,97,255,199,217,251,255,42,215,204,0,133,145,201,255,57,230,146,1,235,100,198,0,146,73,35,254,108,198,20,255,182,79,210,255,82,103,136,0,246,108,176,0,34,17,60,255,19,74,114,254,168,170,78,255,157,239,20,255,149,41,168,0,58,121,28,0,79,179,134,255,231,121,135,255,174,209,98,255,243,122,190,0,171,166,205,0,212,116,48,0,29,108,66,255,162,222,182,1,14,119,21,0,213,39,249,255,254,223,228,255,183,165,198,0,133,190,48,0,124,208,109,255,119,175,85,255,9,209,121,1,48,171,189,255,195,71,134,1,136,219,51,255,182,91,141,254,49,159,72,0,35,118,245,255,112,186,227,255,59,137,31,0,137,44,163,0,114,103,60,254,8,213,150,0,162,10,113,255,194,104,72,0,220,131,116,255,178,79,92,0,203,250,213,254,93,193,189,255,130,255,34,254,212,188,151,0,136,17,20,255,20,101,83,255,212,206,166,0,229,238,73,255,151,74,3,255,168,87,215,0,155,188,133,255,166,129,73,0,240,79,133,255,178,211,81,255,203,72,163,254,193,168,165,0,14,164,199,254,30,255,204,0,65,72,91,1,166,74,102,255,200,42,0,255,194,113,227,255,66,23,208,0,229,216,100,255,24,239,26,0,10,233,62,255,123,10,178,1,26,36,174,255,119,219,199,1,45,163,190,0,16,168,42,0,166,57,198,255,28,26,26,0,126,165,231,0,251,108,100,255,61,229,121,255,58,118,138,0,76,207,17,0,13,34,112,254,89,16,168,0,37,208,105,255,35,201,215,255,40,106,101,254,6,239,114,0,40,103,226,254,246,127,110,255,63,167,58,0,132,240,142,0,5,158,88,255,129,73,158,255,94,89,146,0,230,54,146,0,8,45,173,0,79,169,1,0,115,186,247,0,84,64,131,0,67,224,253,255,207,189,64,0,154,28,81,1,45,184,54,255,87,212,224,255,0,96,73,255,129,33,235,1,52,66,80,255,251,174,155,255,4,179,37,0,234,164,93,254,93,175,253,0,198,69,87,255,224,106,46,0,99,29,210,0,62,188,114,255,44,234,8,0,169,175,247,255,23,109,137,255,229,182,39,0,192,165,94,254,245,101,217,0,191,88,96,0,196,94,99,255,106,238,11,254,53,126,243,0,94,1,101,255,46,147,2,0,201,124,124,255,141,12,218,0,13,166,157,1,48,251,237,255,155,250,124,255,106,148,146,255,182,13,202,0,28,61,167,0,217,152,8,254,220,130,45,255,200,230,255,1,55,65,87,255,93,191,97,254,114,251,14,0,32,105,92,1,26,207,141,0,24,207,13,254,21,50,48,255,186,148,116,255,211,43,225,0,37,34,162,254,164,210,42,255,68,23,96,255,182,214,8,255,245,117,137,255,66,195,50,0,75,12,83,254,80,140,164,0,9,165,36,1,228,110,227,0,241,17,90,1,25,52,212,0,6,223,12,255,139,243,57,0,12,113,75,1,246,183,191,255,213,191,69,255,230,15,142,0,1,195,196,255,138,171,47,255,64,63,106,1,16,169,214,255,207,174,56,1,88,73,133,255,182,133,140,0,177,14,25,255,147,184,53,255,10,227,161,255,120,216,244,255,73,77,233,0,157,238,139,1,59,65,233,0,70,251,216,1,41,184,153,255,32,203,112,0,146,147,253,0,87,101,109,1,44,82,133,255,244,150,53,255,94,152,232,255,59,93,39,255,88,147,220,255,78,81,13,1,32,47,252,255,160,19,114,255,93,107,39,255,118,16,211,1,185,119,209,255,227,219,127,254,88,105,236,255,162,110,23,255,36,166,110,255,91,236,221,255,66,234,116,0,111,19,244,254,10,233,26,0,32,183,6,254,2,191,242,0,218,156,53,254,41,60,70,255,168,236,111,0,121,185,126,255,238,142,207,255,55,126,52,0,220,129,208,254,80,204,164,255,67,23,144,254,218,40,108,255,127,202,164,0,203,33,3,255,2,158,0,0,37,96,188,255,192,49,74,0,109,4,0,0,111,167,10,254,91,218,135,255,203,66,173,255,150,194,226,0,201,253,6,255,174,102,121,0,205,191,110,0,53,194,4,0,81,40,45,254,35,102,143,255,12,108,198,255,16,27,232,255,252,71,186,1,176,110,114,0,142,3,117,1,113,77,142,0,19,156,197,1,92,47,252,0,53,232,22,1,54,18,235,0,46,35,189,255,236,212,129,0,2,96,208,254,200,238,199,255,59,175,164,255,146,43,231,0,194,217,52,255,3,223,12,0,138,54,178,254,85,235,207,0,232,207,34,0,49,52,50,255,166,113,89,255,10,45,216,255,62,173,28,0,111,165,246,0,118,115,91,255,128,84,60,0,167,144,203,0,87,13,243,0,22,30,228,1,177,113,146,255,129,170,230,254,252,153,129,255,145,225,43,0,70,231,5,255,122,105,126,254,86,246,148,255,110,37,154,254,209,3,91,0,68,145,62,0,228,16,165,255,55,221,249,254,178,210,91,0,83,146,226,254,69,146,186,0,93,210,104,254,16,25,173,0,231,186,38,0,189,122,140,255,251,13,112,255,105,110,93,0,251,72,170,0,192,23,223,255,24,3,202,1,225,93,228,0,153,147,199,254,109,170,22,0,248,101,246,255,178,124,12,255,178,254,102,254,55,4,65,0,125,214,180,0,183,96,147,0,45,117,23,254,132,191,249,0,143,176,203,254,136,183,54,255,146,234,177,0,146,101,86,255,44,123,143,1,33,209,152,0,192,90,41,254,83,15,125,255,213,172,82,0,215,169,144,0,16,13,34,0,32,209,100,255,84,18,249,1,197,17,236,255,217,186,230,0,49,160,176,255,111,118,97,255,237,104,235,0,79,59,92,254,69,249,11,255,35,172,74,1,19,118,68,0,222,124,165,255,180,66,35,255,86,174,246,0,43,74,111,255,126,144,86,255,228,234,91,0,242,213,24,254,69,44,235,255,220,180,35,0,8,248,7,255,102,47,92,255,240,205,102,255,113,230,171,1,31,185,201,255,194,246,70,255,122,17,187,0,134,70,199,255,149,3,150,255,117,63,103,0,65,104,123,255,212,54,19,1,6,141,88,0,83,134,243,255,136,53,103,0,169,27,180,0,177,49,24,0,111,54,167,0,195,61,215,255,31,1,108,1,60,42,70,0,185,3,162,255,194,149,40,255,246,127,38,254,190,119,38,255,61,119,8,1,96,161,219,255,42,203,221,1,177,242,164,255,245,159,10,0,116,196,0,0,5,93,205,254,128,127,179,0,125,237,246,255,149,162,217,255,87,37,20,254,140,238,192,0,9,9,193,0,97,1,226,0,29,38,10,0,0,136,63,255,229,72,210,254,38,134,92,255,78,218,208,1,104,36,84,255,12,5,193,255,242,175,61,255,191,169,46,1,179,147,147,255,113,190,139,254,125,172,31,0,3,75,252,254,215,36,15,0,193,27,24,1,255,69,149,255,110,129,118,0,203,93,249,0,138,137,64,254,38,70,6,0,153,116,222,0,161,74,123,0,193,99,79,255,118,59,94,255,61,12,43,1,146,177,157,0,46,147,191,0,16,255,38,0,11,51,31,1,60,58,98,255,111,194,77,1,154,91,244,0,140,40,144,1,173,10,251,0,203,209,50,254,108,130,78,0,228,180,90,0,174,7,250,0,31,174,60,0,41,171,30,0,116,99,82,255,118,193,139,255,187,173,198,254,218,111,56,0,185,123,216,0,249,158,52,0,52,180,93,255,201,9,91,255,56,45,166,254,132,155,203,255,58,232,110,0,52,211,89,255,253,0,162,1,9,87,183,0,145,136,44,1,94,122,245,0,85,188,171,1,147,92,198,0,0,8,104,0,30,95,174,0,221,230,52,1,247,247,235,255,137,174,53,255,35,21,204,255,71,227,214,1,232,82,194,0,11,48,227,255,170,73,184,255,198,251,252,254,44,112,34,0,131,101,131,255,72,168,187,0,132,135,125,255,138,104,97,255,238,184,168,255,243,104,84,255,135,216,226,255,139,144,237,0,188,137,150,1,80,56,140,255,86,169,167,255,194,78,25,255,220,17,180,255,17,13,193,0,117,137,212,255,141,224,151,0,49,244,175,0,193,99,175,255,19,99,154,1,255,65,62,255,156,210,55,255,242,244,3,255,250,14,149,0,158,88,217,255,157,207,134,254,251,232,28,0,46,156,251,255,171,56,184,255,239,51,234,0,142,138,131,255,25,254,243,1,10,201,194,0,63,97,75,0,210,239,162,0,192,200,31,1,117,214,243,0,24,71,222,254,54,40,232,255,76,183,111,254,144,14,87,255,214,79,136,255,216,196,212,0,132,27,140,254,131,5,253,0,124,108,19,255,28,215,75,0,76,222,55,254,233,182,63,0,68,171,191,254,52,111,222,255,10,105,77,255,80,170,235,0,143,24,88,255,45,231,121,0,148,129,224,1,61,246,84,0,253,46,219,255,239,76,33,0,49,148,18,254,230,37,69,0,67,134,22,254,142,155,94,0,31,157,211,254,213,42,30,255,4,228,247,254,252,176,13,255,39,0,31,254,241,244,255,255,170,45,10,254,253,222,249,0,222,114,132,0,255,47,6,255,180,163,179,1,84,94,151,255,89,209,82,254,229,52,169,255,213,236,0,1,214,56,228,255,135,119,151,255,112,201,193,0,83,160,53,254,6,151,66,0,18,162,17,0,233,97,91,0,131,5,78,1,181,120,53,255,117,95,63,255,237,117,185,0,191,126,136,255,144,119,233,0,183,57,97,1,47,201,187,255,167,165,119,1,45,100,126,0,21,98,6,254,145,150,95,255,120,54,152,0,209,98,104,0,143,111,30,254,184,148,249,0,235,216,46,0,248,202,148,255,57,95,22,0,242,225,163,0,233,247,232,255,71,171,19,255,103,244,49,255,84,103,93,255,68,121,244,1,82,224,13,0,41,79,43,255,249,206,167,255,215,52,21,254,192,32,22,255,247,111,60,0,101,74,38,255,22,91,84,254,29,28,13,255,198,231,215,254,244,154,200,0,223,137,237,0,211,132,14,0,95,64,206,255,17,62,247,255,233,131,121,1,93,23,77,0,205,204,52,254,81,189,136,0,180,219,138,1,143,18,94,0,204,43,140,254,188,175,219,0,111,98,143,255,151,63,162,255,211,50,71,254,19,146,53,0,146,45,83,254,178,82,238,255,16,133,84,255,226,198,93,255,201,97,20,255,120,118,35,255,114,50,231,255,162,229,156,255,211,26,12,0,114,39,115,255,206,212,134,0,197,217,160,255,116,129,94,254,199,215,219,255,75,223,249,1,253,116,181,255,232,215,104,255,228,130,246,255,185,117,86,0,14,5,8,0,239,29,61,1,237,87,133,255,125,146,137,254,204,168,223,0,46,168,245,0,154,105,22,0,220,212,161,255,107,69,24,255,137,218,181,255,241,84,198,255,130,122,211,255,141,8,153,255,190,177,118,0,96,89,178,0,255,16,48,254,122,96,105,255,117,54,232,255,34,126,105,255,204,67,166,0,232,52,138,255,211,147,12,0,25,54,7,0,44,15,215,254,51,236,45,0,190,68,129,1,106,147,225,0,28,93,45,254,236,141,15,255,17,61,161,0,220,115,192,0,236,145,24,254,111,168,169,0,224,58,63,255,127,164,188,0,82,234,75,1,224,158,134,0,209,68,110,1,217,166,217,0,70,225,166,1,187,193,143,255,16,7,88,255,10,205,140,0,117,192,156,1,17,56,38,0,27,124,108,1,171,215,55,255,95,253,212,0,155,135,168,255,246,178,153,254,154,68,74,0,232,61,96,254,105,132,59,0,33,76,199,1,189,176,130,255,9,104,25,254,75,198,102,255,233,1,112,0,108,220,20,255,114,230,70,0,140,194,133,255,57,158,164,254,146,6,80,255,169,196,97,1,85,183,130,0,70,158,222,1,59,237,234,255,96,25,26,255,232,175,97,255,11,121,248,254,88,35,194,0,219,180,252,254,74,8,227,0,195,227,73,1,184,110,161,255,49,233,164,1,128,53,47,0,82,14,121,255,193,190,58,0,48,174,117,255,132,23,32,0,40,10,134,1,22,51,25,255,240,11,176,255,110,57,146,0,117,143,239,1,157,101,118,255,54,84,76,0,205,184,18,255,47,4,72,255,78,112,85,255,193,50,66,1,93,16,52,255,8,105,134,0,12,109,72,255,58,156,251,0,144,35,204,0,44,160,117,254,50,107,194,0,1,68,165,255,111,110,162,0,158,83,40,254,76,214,234,0,58,216,205,255,171,96,147,255,40,227,114,1,176,227,241,0,70,249,183,1,136,84,139,255,60,122,247,254,143,9,117,255,177,174,137,254,73,247,143,0,236,185,126,255,62,25,247,255,45,64,56,255,161,244,6,0,34,57,56,1,105,202,83,0,128,147,208,0,6,103,10,255,74,138,65,255,97,80,100,255,214,174,33,255,50,134,74,255,110,151,130,254,111,84,172,0,84,199,75,254,248,59,112,255,8,216,178,1,9,183,95,0,238,27,8,254,170,205,220,0,195,229,135,0,98,76,237,255,226,91,26,1,82,219,39,255,225,190,199,1,217,200,121,255,81,179,8,255,140,65,206,0,178,207,87,254,250,252,46,255,104,89,110,1,253,189,158,255,144,214,158,255,160,245,54,255,53,183,92,1,21,200,194,255,146,33,113,1,209,1,255,0,235,106,43,255,167,52,232,0,157,229,221,0,51,30,25,0,250,221,27,1,65,147,87,255,79,123,196,0,65,196,223,255,76,44,17,1,85,241,68,0,202,183,249,255,65,212,212,255,9,33,154,1,71,59,80,0,175,194,59,255,141,72,9,0,100,160,244,0,230,208,56,0,59,25,75,254,80,194,194,0,18,3,200,254,160,159,115,0,132,143,247,1,111,93,57,255,58,237,11,1,134,222,135,255,122,163,108,1,123,43,190,255,251,189,206,254,80,182,72,255,208,246,224,1,17,60,9,0,161,207,38,0,141,109,91,0,216,15,211,255,136,78,110,0,98,163,104,255,21,80,121,255,173,178,183,1,127,143,4,0,104,60,82,254,214,16,13,255,96,238,33,1,158,148,230,255,127,129,62,255,51,255,210,255,62,141,236,254,157,55,224,255,114,39,244,0,192,188,250,255,228,76,53,0,98,84,81,255,173,203,61,254,147,50,55,255,204,235,191,0,52,197,244,0,88,43,211,254,27,191,119,0,188,231,154,0,66,81,161,0,92,193,160,1,250,227,120,0,123,55,226,0,184,17,72,0,133,168,10,254,22,135,156,255,41,25,103,255,48,202,58,0,186,149,81,255,188,134,239,0,235,181,189,254,217,139,188,255,74,48,82,0,46,218,229,0,189,253,251,0,50,229,12,255,211,141,191,1,128,244,25,255,169,231,122,254,86,47,189,255,132,183,23,255,37,178,150,255,51,137,253,0,200,78,31,0,22,105,50,0,130,60,0,0,132,163,91,254,23,231,187,0,192,79,239,0,157,102,164,255,192,82,20,1,24,181,103,255,240,9,234,0,1,123,164,255,133,233,0,255,202,242,242,0,60,186,245,0,241,16,199,255,224,116,158,254,191,125,91,255,224,86,207,0,121,37,231,255,227,9,198,255,15,153,239,255,121,232,217,254,75,112,82,0,95,12,57,254,51,214,105,255,148,220,97,1,199,98,36,0,156,209,12,254,10,212,52,0,217,180,55,254,212,170,232,255,216,20,84,255,157,250,135,0,157,99,127,254,1,206,41,0,149,36,70,1,54,196,201,255,87,116,0,254,235,171,150,0,27,163,234,0,202,135,180,0,208,95,0,254,123,156,93,0,183,62,75,0,137,235,182,0,204,225,255,255,214,139,210,255,2,115,8,255,29,12,111,0,52,156,1,0,253,21,251,255,37,165,31,254,12,130,211,0,106,18,53,254,42,99,154,0,14,217,61,254,216,11,92,255,200,197,112,254,147,38,199,0,36,252,120,254,107,169,77,0,1,123,159,255,207,75,102,0,163,175,196,0,44,1,240,0,120,186,176,254,13,98,76,255,237,124,241,255,232,146,188,255,200,96,224,0,204,31,41,0,208,200,13,0,21,225,96,255,175,156,196,0,247,208,126,0,62,184,244,254,2,171,81,0,85,115,158,0,54,64,45,255,19,138,114,0,135,71,205,0,227,47,147,1,218,231,66,0,253,209,28,0,244,15,173,255,6,15,118,254,16,150,208,255,185,22,50,255,86,112,207,255,75,113,215,1,63,146,43,255,4,225,19,254,227,23,62,255,14,255,214,254,45,8,205,255,87,197,151,254,210,82,215,255,245,248,247,255,128,248,70,0,225,247,87,0,90,120,70,0,213,245,92,0,13,133,226,0,47,181,5,1,92,163,105,255,6,30,133,254,232,178,61,255,230,149,24,255,18,49,158,0,228,100,61,254,116,243,251,255,77,75,92,1,81,219,147,255,76,163,254,254,141,213,246,0,232,37,152,254,97,44,100,0,201,37,50,1,212,244,57,0,174,171,183,255,249,74,112,0,166,156,30,0,222,221,97,255,243,93,73,254,251,101,100,255,216,217,93,255,254,138,187,255,142,190,52,255,59,203,177,255,200,94,52,0,115,114,158,255,165,152,104,1,126,99,226,255,118,157,244,1,107,200,16,0,193,90,229,0,121,6,88,0,156,32,93,254,125,241,211,255,14,237,157,255,165,154,21,255,184,224,22,255,250,24,152,255,113,77,31,0,247,171,23,255,237,177,204,255,52,137,145,255,194,182,114,0,224,234,149,0,10,111,103,1,201,129,4,0,238,142,78,0,52,6,40,255,110,213,165,254,60,207,253,0,62,215,69,0,96,97,0,255,49,45,202,0,120,121,22,255,235,139,48,1,198,45,34,255,182,50,27,1,131,210,91,255,46,54,128,0,175,123,105,255,198,141,78,254,67,244,239,255,245,54,103,254,78,38,242,255,2,92,249,254,251,174,87,255,139,63,144,0,24,108,27,255,34,102,18,1,34,22,152,0,66,229,118,254,50,143,99,0,144,169,149,1,118,30,152,0,178,8,121,1,8,159,18,0,90,101,230,255,129,29,119,0,68,36,11,1,232,183,55,0,23,255,96,255,161,41,193,255,63,139,222,0,15,179,243,0,255,100,15,255,82,53,135,0,137,57,149,1,99,240,170,255,22,230,228,254,49,180,82,255,61,82,43,0,110,245,217,0,199,125,61,0,46,253,52,0,141,197,219,0,211,159,193,0,55,121,105,254,183,20,129,0,169,119,170,255,203,178,139,255,135,40,182,255,172,13,202,255,65,178,148,0,8,207,43,0,122,53,127,1,74,161,48,0,227,214,128,254,86,11,243,255,100,86,7,1,245,68,134,255,61,43,21,1,152,84,94,255,190,60,250,254,239,118,232,255,214,136,37,1,113,76,107,255,93,104,100,1,144,206,23,255,110,150,154,1,228,103,185,0,218,49,50,254,135,77,139,255,185,1,78,0,0,161,148,255,97,29,233,255,207,148,149,255,160,168,0,0,91,128,171,255,6,28,19,254,11,111,247,0,39,187,150,255,138,232,149,0,117,62,68,255,63,216,188,255,235,234,32,254,29,57,160,255,25,12,241,1,169,60,191,0,32,131,141,255,237,159,123,255,94,197,94,254,116,254,3,255,92,179,97,254,121,97,92,255,170,112,14,0,21,149,248,0,248,227,3,0,80,96,109,0,75,192,74,1,12,90,226,255,161,106,68,1,208,114,127,255,114,42,255,254,74,26,74,255,247,179,150,254,121,140,60,0,147,70,200,255,214,40,161,255,161,188,201,255,141,65,135,255,242,115,252,0,62,47,202,0,180,149,255,254,130,55,237,0,165,17,186,255,10,169,194,0,156,109,218,255,112,140,123,255,104,128,223,254,177,142,108,255,121,37,219,255,128,77,18,255,111,108,23,1,91,192,75,0,174,245,22,255,4,236,62,255,43,64,153,1,227,173,254,0,237,122,132,1,127,89,186,255,142,82,128,254,252,84,174,0,90,179,177,1,243,214,87,255,103,60,162,255,208,130,14,255,11,130,139,0,206,129,219,255,94,217,157,255,239,230,230,255,116,115,159,254,164,107,95,0,51,218,2,1,216,125,198,255,140,202,128,254,11,95,68,255,55,9,93,254,174,153,6,255,204,172,96,0,69,160,110,0,213,38,49,254,27,80,213,0,118,125,114,0,70,70,67,255,15,142,73,255,131,122,185,255,243,20,50,254,130,237,40,0,210,159,140,1,197,151,65,255,84,153,66,0,195,126,90,0,16,238,236,1,118,187,102,255,3,24,133,255,187,69,230,0,56,197,92,1,213,69,94,255,80,138,229,1,206,7,230,0,222,111,230,1,91,233,119,255,9,89,7,1,2,98,1,0,148,74,133,255,51,246,180,255,228,177,112,1,58,189,108,255,194,203,237,254,21,209,195,0,147,10,35,1,86,157,226,0,31,163,139,254,56,7,75,255,62,90,116,0,181,60,169,0,138,162,212,254,81,167,31,0,205,90,112,255,33,112,227,0,83,151,117,1,177,224,73,255,174,144,217,255,230,204,79,255,22,77,232,255,114,78,234,0,224,57,126,254,9,49,141,0,242,147,165,1,104,182,140,255,167,132,12,1,123,68,127,0,225,87,39,1,251,108,8,0,198,193,143,1,121,135,207,255,172,22,70,0,50,68,116,255,101,175,40,255,248,105,233,0,166,203,7,0,110,197,218,0,215,254,26,254,168,226,253,0,31,143,96,0,11,103,41,0,183,129,203,254,100,247,74,255,213,126,132,0,210,147,44,0,199,234,27,1,148,47,181,0,155,91,158,1,54,105,175,255,2,78,145,254,102,154,95,0,128,207,127,254,52,124,236,255,130,84,71,0,221,243,211,0,152,170,207,0,222,106,199,0,183,84,94,254,92,200,56,255,138,182,115,1,142,96,146,0,133,136,228,0,97,18,150,0,55,251,66,0,140,102,4,0,202,103,151,0,30,19,248,255,51,184,207,0,202,198,89,0,55,197,225,254,169,95,249,255,66,65,68,255,188,234,126,0,166,223,100,1,112,239,244,0,144,23,194,0,58,39,182,0,244,44,24,254,175,68,179,255,152,118,154,1,176,162,130,0,217,114,204,254,173,126,78,255,33,222,30,255,36,2,91,255,2,143,243,0,9,235,215,0,3,171,151,1,24,215,245,255,168,47,164,254,241,146,207,0,69,129,180,0,68,243,113,0,144,53,72,254,251,45,14,0,23,110,168,0,68,68,79,255,110,70,95,254,174,91,144,255,33,206,95,255,137,41,7,255,19,187,153,254,35,255,112,255,9,145,185,254,50,157,37,0,11,112,49,1,102,8,190,255,234,243,169,1,60,85,23,0,74,39,189,0,116,49,239,0,173,213,210,0,46,161,108,255,159,150,37,0,196,120,185,255,34,98,6,255,153,195,62,255,97,230,71,255,102,61,76,0,26,212,236,255,164,97,16,0,198,59,146,0,163,23,196,0,56,24,61,0,181,98,193,0,251,147,229,255,98,189,24,255,46,54,206,255,234,82,246,0,183,103,38,1,109,62,204,0,10,240,224,0,146,22,117,255,142,154,120,0,69,212,35,0,208,99,118,1,121,255,3,255,72,6,194,0,117,17,197,255,125,15,23,0,154,79,153,0,214,94,197,255,185,55,147,255,62,254,78,254,127,82,153,0,110,102,63,255,108,82,161,255,105,187,212,1,80,138,39,0,60,255,93,255,72,12,186,0,210,251,31,1,190,167,144,255,228,44,19,254,128,67,232,0,214,249,107,254,136,145,86,255,132,46,176,0,189,187,227,255,208,22,140,0,217,211,116,0,50,81,186,254,139,250,31,0,30,64,198,1,135,155,100,0,160,206,23,254,187,162,211,255,16,188,63,0,254,208,49,0,85,84,191,0,241,192,242,255,153,126,145,1,234,162,162,255,230,97,216,1,64,135,126,0,190,148,223,1,52,0,43,255,28,39,189,1,64,136,238,0,175,196,185,0,98,226,213,255,127,159,244,1,226,175,60,0,160,233,142,1,180,243,207,255,69,152,89,1,31,101,21,0,144,25,164,254,139,191,209,0,91,25,121,0,32,147,5,0,39,186,123,255,63,115,230,255,93,167,198,255,143,213,220,255,179,156,19,255,25,66,122,0,214,160,217,255,2,45,62,255,106,79,146,254,51,137,99,255,87,100,231,255,175,145,232,255,101,184,1,255,174,9,125,0,82,37,161,1,36,114,141,255,48,222,142,255,245,186,154,0,5,174,221,254,63,114,155,255,135,55,160,1,80,31,135,0,126,250,179,1,236,218,45,0,20,28,145,1,16,147,73,0,249,189,132,1,17,189,192,255,223,142,198,255,72,20,15,255,250,53,237,254,15,11,18,0,27,211,113,254,213,107,56,255,174,147,146,255,96,126,48,0,23,193,109,1,37,162,94,0,199,157,249,254,24,128,187,255,205,49,178,254,93,164,42,255,43,119,235,1,88,183,237,255,218,210,1,255,107,254,42,0,230,10,99,255,162,0,226,0,219,237,91,0,129,178,203,0,208,50,95,254,206,208,95,255,247,191,89,254,110,234,79,255,165,61,243,0,20,122,112,255,246,246,185,254,103,4,123,0,233,99,230,1,219,91,252,255,199,222,22,255,179,245,233,255,211,241,234,0,111,250,192,255,85,84,136,0,101,58,50,255,131,173,156,254,119,45,51,255,118,233,16,254,242,90,214,0,94,159,219,1,3,3,234,255,98,76,92,254,80,54,230,0,5,228,231,254,53,24,223,255,113,56,118,1,20,132,1,255,171,210,236,0,56,241,158,255,186,115,19,255,8,229,174,0,48,44,0,1,114,114,166,255,6,73,226,255,205,89,244,0,137,227,75,1,248,173,56,0,74,120,246,254,119,3,11,255,81,120,198,255,136,122,98,255,146,241,221,1,109,194,78,255,223,241,70,1,214,200,169,255,97,190,47,255,47,103,174,255,99,92,72,254,118,233,180,255,193,35,233,254,26,229,32,255,222,252,198,0,204,43,71,255,199,84,172,0,134,102,190,0,111,238,97,254,230,40,230,0,227,205,64,254,200,12,225,0,166,25,222,0,113,69,51,255,143,159,24,0,167,184,74,0,29,224,116,254,158,208,233,0,193,116,126,255,212,11,133,255,22,58,140,1,204,36,51,255,232,30,43,0,235,70,181,255,64,56,146,254,169,18,84,255,226,1,13,255,200,50,176,255,52,213,245,254,168,209,97,0,191,71,55,0,34,78,156,0,232,144,58,1,185,74,189,0,186,142,149,254,64,69,127,255,161,203,147,255,176,151,191,0,136,231,203,254,163,182,137,0,161,126,251,254,233,32,66,0,68,207,66,0,30,28,37,0,93,114,96,1,254,92,247,255,44,171,69,0,202,119,11,255,188,118,50,1,255,83,136,255,71,82,26,0,70,227,2,0,32,235,121,1,181,41,154,0,71,134,229,254,202,255,36,0,41,152,5,0,154,63,73,255,34,182,124,0,121,221,150,255,26,204,213,1,41,172,87,0,90,157,146,255,109,130,20,0,71,107,200,255,243,102,189,0,1,195,145,254,46,88,117,0,8,206,227,0,191,110,253,255,109,128,20,254,134,85,51,255,137,177,112,1,216,34,22,255,131,16,208,255,121,149,170,0,114,19,23,1,166,80,31,255,113,240,122,0,232,179,250,0,68,110,180,254,210,170,119,0,223,108,164,255,207,79,233,255,27,229,226,254,209,98,81,255,79,68,7,0,131,185,100,0,170,29,162,255,17,162,107,255,57,21,11,1,100,200,181,255,127,65,166,1,165,134,204,0,104,167,168,0,1,164,79,0,146,135,59,1,70,50,128,255,102,119,13,254,227,6,135,0,162,142,179,255,160,100,222,0,27,224,219,1,158,93,195,255,234,141,137,0,16,24,125,255,238,206,47,255,97,17,98,255,116,110,12,255,96,115,77,0,91,227,232,255,248,254,79,255,92,229,6,254,88,198,139,0,206,75,129,0,250,77,206,255,141,244,123,1,138,69,220,0,32,151,6,1,131,167,22,255,237,68,167,254,199,189,150,0,163,171,138,255,51,188,6,255,95,29,137,254,148,226,179,0,181,107,208,255,134,31,82,255,151,101,45,255,129,202,225,0,224,72,147,0,48,138,151,255,195,64,206,254,237,218,158,0,106,29,137,254,253,189,233,255,103,15,17,255,194,97,255,0,178,45,169,254,198,225,155,0,39,48,117,255,135,106,115,0,97,38,181,0,150,47,65,255,83,130,229,254,246,38,129,0,92,239,154,254,91,99,127,0,161,111,33,255,238,217,242,255,131,185,195,255,213,191,158,255,41,150,218,0,132,169,131,0,89,84,252,1,171,70,128,255,163,248,203,254,1,50,180,255,124,76,85,1,251,111,80,0,99,66,239,255,154,237,182,255,221,126,133,254,74,204,99,255,65,147,119,255,99,56,167,255,79,248,149,255,116,155,228,255,237,43,14,254,69,137,11,255,22,250,241,1,91,122,143,255,205,249,243,0,212,26,60,255,48,182,176,1,48,23,191,255,203,121,152,254,45,74,213,255,62,90,18,254,245,163,230,255,185,106,116,255,83,35,159,0,12,33,2,255,80,34,62,0,16,87,174,255,173,101,85,0,202,36,81,254,160,69,204,255,64,225,187,0,58,206,94,0,86,144,47,0,229,86,245,0,63,145,190,1,37,5,39,0,109,251,26,0,137,147,234,0,162,121,145,255,144,116,206,255,197,232,185,255,183,190,140,255,73,12,254,255,139,20,242,255,170,90,239,255,97,66,187,255,245,181,135,254,222,136,52,0,245,5,51,254,203,47,78,0,152,101,216,0,73,23,125,0,254,96,33,1,235,210,73,255,43,209,88,1,7,129,109,0,122,104,228,254,170,242,203,0,242,204,135,255,202,28,233,255,65,6,127,0,159,144,71,0,100,140,95,0,78,150,13,0,251,107,118,1,182,58,125,255,1,38,108,255,141,189,209,255,8,155,125,1,113,163,91,255,121,79,190,255,134,239,108,255,76,47,248,0,163,228,239,0,17,111,10,0,88,149,75,255,215,235,239,0,167,159,24,255,47,151,108,255,107,209,188,0,233,231,99,254,28,202,148,255,174,35,138,255,110,24,68,255,2,69,181,0,107,102,82,0,102,237,7,0,92,36,237,255,221,162,83,1,55,202,6,255,135,234,135,255,24,250,222,0,65,94,168,254,245,248,210,255,167,108,201,254,255,161,111,0,205,8,254,0,136,13,116,0,100,176,132,255,43,215,126,255,177,133,130,255,158,79,148,0,67,224,37,1,12,206,21,255,62,34,110,1,237,104,175,255,80,132,111,255,142,174,72,0,84,229,180,254,105,179,140,0,64,248,15,255,233,138,16,0,245,67,123,254,218,121,212,255,63,95,218,1,213,133,137,255,143,182,82,255,48,28,11,0,244,114,141,1,209,175,76,255,157,181,150,255,186,229,3,255,164,157,111,1,231,189,139,0,119,202,190,255,218,106,64,255,68,235,63,254,96,26,172,255,187,47,11,1,215,18,251,255,81,84,89,0,68,58,128,0,94,113,5,1,92,129,208,255,97,15,83,254,9,28,188,0,239,9,164,0,60,205,152,0,192,163,98,255,184,18,60,0,217,182,139,0,109,59,120,255,4,192,251,0,169,210,240,255,37,172,92,254,148,211,245,255,179,65,52,0,253,13,115,0,185,174,206,1,114,188,149,255,237,90,173,0,43,199,192,255,88,108,113,0,52,35,76,0,66,25,148,255,221,4,7,255,151,241,114,255,190,209,232,0,98,50,199,0,151,150,213,255,18,74,36,1,53,40,7,0,19,135,65,255,26,172,69,0,174,237,85,0,99,95,41,0,3,56,16,0,39,160,177,255,200,106,218,254,185,68,84,255,91,186,61,254,67,143,141,255,13,244,166,255,99,114,198,0,199,110,163,255,193,18,186,0,124,239,246,1,110,68,22,0,2,235,46,1,212,60,107,0,105,42,105,1,14,230,152,0,7,5,131,0,141,104,154,255,213,3,6,0,131,228,162,255,179,100,28,1,231,123,85,255,206,14,223,1,253,96,230,0,38,152,149,1,98,137,122,0,214,205,3,255,226,152,179,255,6,133,137,0,158,69,140,255,113,162,154,255,180,243,172,255,27,189,115,255,143,46,220,255,213,134,225,255,126,29,69,0,188,43,137,1,242,70,9,0,90,204,255,255,231,170,147,0,23,56,19,254,56,125,157,255,48,179,218,255,79,182,253,255,38,212,191,1,41,235,124,0,96,151,28,0,135,148,190,0,205,249,39,254,52,96,136,255,212,44,136,255,67,209,131,255,252,130,23,255,219,128,20,255,198,129,118,0,108,101,11,0,178,5,146,1,62,7,100,255,181,236,94,254,28,26,164,0,76,22,112,255,120,102,79,0,202,192,229,1,200,176,215,0,41,64,244,255,206,184,78,0,167,45,63,1,160,35,0,255,59,12,142,255,204,9,144,255,219,94,229,1,122,27,112,0,189,105,109,255,64,208,74,255,251,127,55,1,2,226,198,0,44,76,209,0,151,152,77,255,210,23,46,1,201,171,69,255,44,211,231,0,190,37,224,255,245,196,62,255,169,181,222,255,34,211,17,0,119,241,197,255,229,35,152,1,21,69,40,255,178,226,161,0,148,179,193,0,219,194,254,1,40,206,51,255,231,92,250,1,67,153,170,0,21,148,241,0,170,69,82,255,121,18,231,255,92,114,3,0,184,62,230,0,225,201,87,255,146,96,162,255,181,242,220,0,173,187,221,1,226,62,170,255,56,126,217,1,117,13,227,255,179,44,239,0,157,141,155,255,144,221,83,0,235,209,208,0,42,17,165,1,251,81,133,0,124,245,201,254,97,211,24,255,83,214,166,0,154,36,9,255,248,47,127,0,90,219,140,255,161,217,38,254,212,147,63,255,66,84,148,1,207,3,1,0,230,134,89,1,127,78,122,255,224,155,1,255,82,136,74,0,178,156,208,255,186,25,49,255,222,3,210,1,229,150,190,255,85,162,52,255,41,84,141,255,73,123,84,254,93,17,150,0,119,19,28,1,32,22,215,255,28,23,204,255,142,241,52,255,228,52,125,0,29,76,207,0,215,167,250,254,175,164,230,0,55,207,105,1,109,187,245,255,161,44,220,1,41,101,128,255,167,16,94,0,93,214,107,255,118,72,0,254,80,61,234,255,121,175,125,0,139,169,251,0,97,39,147,254,250,196,49,255,165,179,110,254,223,70,187,255,22,142,125,1,154,179,138,255,118,176,42,1,10,174,153,0,156,92,102,0,168,13,161,255,143,16,32,0,250,197,180,255,203,163,44,1,87,32,36,0,161,153,20,255,123,252,15,0,25,227,80,0,60,88,142,0,17,22,201,1,154,205,77,255,39,63,47,0,8,122,141,0,128,23,182,254,204,39,19,255,4,112,29,255,23,36,140,255,210,234,116,254,53,50,63,255,121,171,104,255,160,219,94,0,87,82,14,254,231,42,5,0,165,139,127,254,86,78,38,0,130,60,66,254,203,30,45,255,46,196,122,1,249,53,162,255,136,143,103,254,215,210,114,0,231,7,160,254,169,152,42,255,111,45,246,0,142,131,135,255,131,71,204,255,36,226,11,0,0,28,242,255,225,138,213,255,247,46,216,254,245,3,183,0,108,252,74,1,206,26,48,255,205,54,246,255,211,198,36,255,121,35,50,0,52,216,202,255,38,139,129,254,242,73,148,0,67,231,141,255,42,47,204,0,78,116,25,1,4,225,191,255,6,147,228,0,58,88,177,0,122,165,229,255,252,83,201,255,224,167,96,1,177,184,158,255,242,105,179,1,248,198,240,0,133,66,203,1,254,36,47,0,45,24,115,255,119,62,254,0,196,225,186,254,123,141,172,0,26,85,41,255,226,111,183,0,213,231,151,0,4,59,7,255,238,138,148,0,66,147,33,255,31,246,141,255,209,141,116,255,104,112,31,0,88,161,172,0,83,215,230,254,47,111,151,0,45,38,52,1,132,45,204,0,138,128,109,254,233,117,134,255,243,190,173,254,241,236,240,0,82,127,236,254,40,223,161,255,110,182,225,255,123,174,239,0,135,242,145,1,51,209,154,0,150,3,115,254,217,164,252,255,55,156,69,1,84,94,255,255,232,73,45,1,20,19,212,255,96,197,59,254,96,251,33,0,38,199,73,1,64,172,247,255,117,116,56,255,228,17,18,0,62,138,103,1,246,229,164,255,244,118,201,254,86,32,159,255,109,34,137,1,85,211,186,0,10,193,193,254,122,194,177,0,122,238,102,255,162,218,171,0,108,217,161,1,158,170,34,0,176,47,155,1,181,228,11,255,8,156,0,0,16,75,93,0,206,98,255,1,58,154,35,0,12,243,184,254,67,117,66,255,230,229,123,0,201,42,110,0,134,228,178,254,186,108,118,255,58,19,154,255,82,169,62,255,114,143,115,1,239,196,50,255,173,48,193,255,147,2,84,255,150,134,147,254,95,232,73,0,109,227,52,254,191,137,10,0,40,204,30,254,76,52,97,255,164,235,126,0,254,124,188,0,74,182,21,1,121,29,35,255,241,30,7,254,85,218,214,255,7,84,150,254,81,27,117,255,160,159,152,254,66,24,221,255,227,10,60,1,141,135,102,0,208,189,150,1,117,179,92,0,132,22,136,255,120,199,28,0,21,129,79,254,182,9,65,0,218,163,169,0,246,147,198,255,107,38,144,1,78,175,205,255,214,5,250,254,47,88,29,255,164,47,204,255,43,55,6,255,131,134,207,254,116,100,214,0,96,140,75,1,106,220,144,0,195,32,28,1,172,81,5,255,199,179,52,255,37,84,203,0,170,112,174,0,11,4,91,0,69,244,27,1,117,131,92,0,33,152,175,255,140,153,107,255,251,135,43,254,87,138,4,255,198,234,147,254,121,152,84,255,205,101,155,1,157,9,25,0,72,106,17,254,108,153,0,255,189,229,186,0,193,8,176,255,174,149,209,0,238,130,29,0,233,214,126,1,61,226,102,0,57,163,4,1,198,111,51,255,45,79,78,1,115,210,10,255,218,9,25,255,158,139,198,255,211,82,187,254,80,133,83,0,157,129,230,1,243,133,134,255,40,136,16,0,77,107,79,255,183,85,92,1,177,204,202,0,163,71,147,255,152,69,190,0,172,51,188,1,250,210,172,255,211,242,113,1,89,89,26,255,64,66,111,254,116,152,42,0,161,39,27,255,54,80,254,0,106,209,115,1,103,124,97,0,221,230,98,255,31,231,6,0,178,192,120,254,15,217,203,255,124,158,79,0,112,145,247,0,92,250,48,1,163,181,193,255,37,47,142,254,144,189,165,255,46,146,240,0,6,75,128,0,41,157,200,254,87,121,213,0,1,113,236,0,5,45,250,0,144,12,82,0,31,108,231,0,225,239,119,255,167,7,189,255,187,228,132,255,110,189,34,0,94,44,204,1,162,52,197,0,78,188,241,254,57,20,141,0,244,146,47,1,206,100,51,0,125,107,148,254,27,195,77,0,152,253,90,1,7,143,144,255,51,37,31,0,34,119,38,255,7,197,118,0,153,188,211,0,151,20,116,254,245,65,52,255,180,253,110,1,47,177,209,0,161,99,17,255,118,222,202,0,125,179,252,1,123,54,126,255,145,57,191,0,55,186,121,0,10,243,138,0,205,211,229,255,125,156,241,254,148,156,185,255,227,19,188,255,124,41,32,255,31,34,206,254,17,57,83,0,204,22,37,255,42,96,98,0,119,102,184,1,3,190,28],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+20480);allocate([110,82,218,255,200,204,192,255,201,145,118,0,117,204,146,0,132,32,98,1,192,194,121,0,106,161,248,1,237,88,124,0,23,212,26,0,205,171,90,255,248,48,216,1,141,37,230,255,124,203,0,254,158,168,30,255,214,248,21,0,112,187,7,255,75,133,239,255,74,227,243,255,250,147,70,0,214,120,162,0,167,9,179,255,22,158,18,0,218,77,209,1,97,109,81,255,244,33,179,255,57,52,57,255,65,172,210,255,249,71,209,255,142,169,238,0,158,189,153,255,174,254,103,254,98,33,14,0,141,76,230,255,113,139,52,255,15,58,212,0,168,215,201,255,248,204,215,1,223,68,160,255,57,154,183,254,47,231,121,0,106,166,137,0,81,136,138,0,165,43,51,0,231,139,61,0,57,95,59,254,118,98,25,255,151,63,236,1,94,190,250,255,169,185,114,1,5,250,58,255,75,105,97,1,215,223,134,0,113,99,163,1,128,62,112,0,99,106,147,0,163,195,10,0,33,205,182,0,214,14,174,255,129,38,231,255,53,182,223,0,98,42,159,255,247,13,40,0,188,210,177,1,6,21,0,255,255,61,148,254,137,45,129,255,89,26,116,254,126,38,114,0,251,50,242,254,121,134,128,255,204,249,167,254,165,235,215,0,202,177,243,0,133,141,62,0,240,130,190,1,110,175,255,0,0,20,146,1,37,210,121,255,7,39,130,0,142,250,84,255,141,200,207,0,9,95,104,255,11,244,174,0,134,232,126,0,167,1,123,254,16,193,149,255,232,233,239,1,213,70,112,255,252,116,160,254,242,222,220,255,205,85,227,0,7,185,58,0,118,247,63,1,116,77,177,255,62,245,200,254,63,18,37,255,107,53,232,254,50,221,211,0,162,219,7,254,2,94,43,0,182,62,182,254,160,78,200,255,135,140,170,0,235,184,228,0,175,53,138,254,80,58,77,255,152,201,2,1,63,196,34,0,5,30,184,0,171,176,154,0,121,59,206,0,38,99,39,0,172,80,77,254,0,134,151,0,186,33,241,254,94,253,223,255,44,114,252,0,108,126,57,255,201,40,13,255,39,229,27,255,39,239,23,1,151,121,51,255,153,150,248,0,10,234,174,255,118,246,4,254,200,245,38,0,69,161,242,1,16,178,150,0,113,56,130,0,171,31,105,0,26,88,108,255,49,42,106,0,251,169,66,0,69,93,149,0,20,57,254,0,164,25,111,0,90,188,90,255,204,4,197,0,40,213,50,1,212,96,132,255,88,138,180,254,228,146,124,255,184,246,247,0,65,117,86,255,253,102,210,254,254,121,36,0,137,115,3,255,60,24,216,0,134,18,29,0,59,226,97,0,176,142,71,0,7,209,161,0,189,84,51,254,155,250,72,0,213,84,235,255,45,222,224,0,238,148,143,255,170,42,53,255,78,167,117,0,186,0,40,255,125,177,103,255,69,225,66,0,227,7,88,1,75,172,6,0,169,45,227,1,16,36,70,255,50,2,9,255,139,193,22,0,143,183,231,254,218,69,50,0,236,56,161,1,213,131,42,0,138,145,44,254,136,229,40,255,49,63,35,255,61,145,245,255,101,192,2,254,232,167,113,0,152,104,38,1,121,185,218,0,121,139,211,254,119,240,35,0,65,189,217,254,187,179,162,255,160,187,230,0,62,248,14,255,60,78,97,0,255,247,163,255,225,59,91,255,107,71,58,255,241,47,33,1,50,117,236,0,219,177,63,254,244,90,179,0,35,194,215,255,189,67,50,255,23,135,129,0,104,189,37,255,185,57,194,0,35,62,231,255,220,248,108,0,12,231,178,0,143,80,91,1,131,93,101,255,144,39,2,1,255,250,178,0,5,17,236,254,139,32,46,0,204,188,38,254,245,115,52,255,191,113,73,254,191,108,69,255,22,69,245,1,23,203,178,0,170,99,170,0,65,248,111,0,37,108,153,255,64,37,69,0,0,88,62,254,89,148,144,255,191,68,224,1,241,39,53,0,41,203,237,255,145,126,194,255,221,42,253,255,25,99,151,0,97,253,223,1,74,115,49,255,6,175,72,255,59,176,203,0,124,183,249,1,228,228,99,0,129,12,207,254,168,192,195,255,204,176,16,254,152,234,171,0,77,37,85,255,33,120,135,255,142,194,227,1,31,214,58,0,213,187,125,255,232,46,60,255,190,116,42,254,151,178,19,255,51,62,237,254,204,236,193,0,194,232,60,0,172,34,157,255,189,16,184,254,103,3,95,255,141,233,36,254,41,25,11,255,21,195,166,0,118,245,45,0,67,213,149,255,159,12,18,255,187,164,227,1,160,25,5,0,12,78,195,1,43,197,225,0,48,142,41,254,196,155,60,255,223,199,18,1,145,136,156,0,252,117,169,254,145,226,238,0,239,23,107,0,109,181,188,255,230,112,49,254,73,170,237,255,231,183,227,255,80,220,20,0,194,107,127,1,127,205,101,0,46,52,197,1,210,171,36,255,88,3,90,255,56,151,141,0,96,187,255,255,42,78,200,0,254,70,70,1,244,125,168,0,204,68,138,1,124,215,70,0,102,66,200,254,17,52,228,0,117,220,143,254,203,248,123,0,56,18,174,255,186,151,164,255,51,232,208,1,160,228,43,255,249,29,25,1,68,190,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,126,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,19,0,0,0,59,132,0,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,112,97,110,100,32,51,50,45,98,121,116,101,32,107,111,117,116,108,101,110,32,60,61,32,85,73,78,84,56,95,77,65,88,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,47,98,108,97,107,101,50,47,114,101,102,47,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,46,99,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,0,107,101,121,108,101,110,32,60,61,32,85,73,78,84,56,95,77,65,88,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,95,105,110,105,116,0,99,114,121,112,116,111,95,103,101,110,101,114,105,99,104,97,115,104,95,98,108,97,107,101,50,98,95,102,105,110,97,108,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,36,55,36,0,101,120,112,97,110,100,32,51,50,45,98,121,116,101,32,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,123,32,114,101,116,117,114,110,32,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,40,41,59,32,125,0,123,32,105,102,32,40,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,32,61,61,61,32,117,110,100,101,102,105,110,101,100,41,32,123,32,116,114,121,32,123,32,118,97,114,32,119,105,110,100,111,119,95,32,61,32,34,111,98,106,101,99,116,34,32,61,61,61,32,116,121,112,101,111,102,32,119,105,110,100,111,119,32,63,32,119,105,110,100,111,119,32,58,32,115,101,108,102,44,32,99,114,121,112,116,111,95,32,61,32,116,121,112,101,111,102,32,119,105,110,100,111,119,95,46,99,114,121,112,116,111,32,33,61,61,32,34,117,110,100,101,102,105,110,101,100,34,32,63,32,119,105,110,100,111,119,95,46,99,114,121,112,116,111,32,58,32,119,105,110,100,111,119,95,46,109,115,67,114,121,112,116,111,44,32,114,97,110,100,111,109,86,97,108,117,101,115,83,116,97,110,100,97,114,100,32,61,32,102,117,110,99,116,105,111,110,40,41,32,123,32,118,97,114,32,98,117,102,32,61,32,110,101,119,32,85,105,110,116,51,50,65,114,114,97,121,40,49,41,59,32,99,114,121,112,116,111,95,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,115,40,98,117,102,41,59,32,114,101,116,117,114,110,32,98,117,102,91,48,93,32,62,62,62,32,48,59,32,125,59,32,114,97,110,100,111,109,86,97,108,117,101,115,83,116,97,110,100,97,114,100,40,41,59,32,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,32,61,32,114,97,110,100,111,109,86,97,108,117,101,115,83,116,97,110,100,97,114,100,59,32,125,32,99,97,116,99,104,32,40,101,41,32,123,32,116,114,121,32,123,32,118,97,114,32,99,114,121,112,116,111,32,61,32,114,101,113,117,105,114,101,40,39,99,114,121,112,116,111,39,41,44,32,114,97,110,100,111,109,86,97,108,117,101,73,79,74,83,32,61,32,102,117,110,99,116,105,111,110,40,41,32,123,32,118,97,114,32,98,117,102,32,61,32,99,114,121,112,116,111,46,114,97,110,100,111,109,66,121,116,101,115,40,52,41,59,32,114,101,116,117,114,110,32,40,98,117,102,91,48,93,32,60,60,32,50,52,32,124,32,98,117,102,91,49,93,32,60,60,32,49,54,32,124,32,98,117,102,91,50,93,32,60,60,32,56,32,124,32,98,117,102,91,51,93,41,32,62,62,62,32,48,59,32,125,59,32,114,97,110,100,111,109,86,97,108,117,101,73,79,74,83,40,41,59,32,77,111,100,117,108,101,46,103,101,116,82,97,110,100,111,109,86,97,108,117,101,32,61,32,114,97,110,100,111,109,86,97,108,117,101,73,79,74,83,59,32,125,32,99,97,116,99,104,32,40,101,41,32,123,32,116,104,114,111,119,32,39,78,111,32,115,101,99,117,114,101,32,114,97,110,100,111,109,32,110,117,109,98,101,114,32,103,101,110,101,114,97,116,111,114,32,102,111,117,110,100,39,59,32,125,32,125,32,125,32,125,0,49,46,48,46,51,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,112,97,110,100,32,51,50,45,98,121,116,101,32,107,101,120,112,97,110,100,32,51,50,45,98,121,116,101,32,107],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+30720);allocate([46,47,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+34867);var tempDoublePtr=Runtime.alignMemory(allocate(12,"i8",ALLOC_STATIC),8);assert(tempDoublePtr%8==0);function copyTempFloat(ptr){HEAP8[tempDoublePtr]=HEAP8[ptr];HEAP8[tempDoublePtr+1]=HEAP8[ptr+1];HEAP8[tempDoublePtr+2]=HEAP8[ptr+2];HEAP8[tempDoublePtr+3]=HEAP8[ptr+3]}function copyTempDouble(ptr){HEAP8[tempDoublePtr]=HEAP8[ptr];HEAP8[tempDoublePtr+1]=HEAP8[ptr+1];HEAP8[tempDoublePtr+2]=HEAP8[ptr+2];HEAP8[tempDoublePtr+3]=HEAP8[ptr+3];HEAP8[tempDoublePtr+4]=HEAP8[ptr+4];HEAP8[tempDoublePtr+5]=HEAP8[ptr+5];HEAP8[tempDoublePtr+6]=HEAP8[ptr+6];HEAP8[tempDoublePtr+7]=HEAP8[ptr+7]}function ___setErrNo(value){if(Module["___errno_location"])HEAP32[Module["___errno_location"]()>>2]=value;return value}var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function _sysconf(name){switch(name){case 30:return PAGE_SIZE;case 85:return totalMemory/PAGE_SIZE;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 79:return 0;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:{if(typeof navigator==="object")return navigator["hardwareConcurrency"]||1;return 1}}___setErrNo(ERRNO_CODES.EINVAL);return-1}Module["_i64Subtract"]=_i64Subtract;Module["_i64Add"]=_i64Add;Module["_bitshift64Ashr"]=_bitshift64Ashr;Module["_memset"]=_memset;function _pthread_cleanup_push(routine,arg){__ATEXIT__.push((function(){Runtime.dynCall("vi",routine,[arg])}));_pthread_cleanup_push.level=__ATEXIT__.length}Module["_bitshift64Lshr"]=_bitshift64Lshr;Module["_bitshift64Shl"]=_bitshift64Shl;function _pthread_cleanup_pop(){assert(_pthread_cleanup_push.level==__ATEXIT__.length,"cannot pop if something else added meanwhile!");__ATEXIT__.pop();_pthread_cleanup_push.level=__ATEXIT__.length}function _abort(){Module["abort"]()}function ___lock(){}function ___unlock(){}var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};var PATH={splitPath:(function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)}),normalizeArray:(function(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up--;up){parts.unshift("..")}}return parts}),normalize:(function(path){var isAbsolute=path.charAt(0)==="/",trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path}),dirname:(function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir}),basename:(function(path){if(path==="/")return"/";var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)}),extname:(function(path){return PATH.splitPath(path)[3]}),join:(function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))}),join2:(function(l,r){return PATH.normalize(l+"/"+r)}),resolve:(function(){var resolvedPath="",resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if(typeof path!=="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=path.charAt(0)==="/"}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter((function(p){return!!p})),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."}),relative:(function(from,to){from=PATH.resolve(from).substr(1);to=PATH.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")})};var TTY={ttys:[],init:(function(){}),shutdown:(function(){}),register:(function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)}),stream_ops:{open:(function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}stream.tty=tty;stream.seekable=false}),close:(function(stream){stream.tty.ops.flush(stream.tty)}),flush:(function(stream){stream.tty.ops.flush(stream.tty)}),read:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}for(var i=0;i<length;i++){try{stream.tty.ops.put_char(stream.tty,buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})},default_tty_ops:{get_char:(function(tty){if(!tty.input.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=new Buffer(BUFSIZE);var bytesRead=0;var fd=process.stdin.fd;var usingDevice=false;try{fd=fs.openSync("/dev/stdin","r");usingDevice=true}catch(e){}bytesRead=fs.readSync(fd,buf,0,BUFSIZE,null);if(usingDevice){fs.closeSync(fd)}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}else{result=null}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else if(typeof readline=="function"){result=readline();if(result!==null){result+="\n"}}if(!result){return null}tty.input=intArrayFromString(result,true)}return tty.input.shift()}),put_char:(function(tty,val){if(val===null||val===10){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}})},default_tty1_ops:{put_char:(function(tty,val){if(val===null||val===10){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}})}};var MEMFS={ops_table:null,mount:(function(mount){return MEMFS.createNode(null,"/",16384|511,0)}),createNode:(function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(!MEMFS.ops_table){MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap,msync:MEMFS.stream_ops.msync}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}}}var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node}return node}),getFileDataAsRegularArray:(function(node){if(node.contents&&node.contents.subarray){var arr=[];for(var i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents}),getFileDataAsTypedArray:(function(node){if(!node.contents)return new Uint8Array;if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)}),expandFileStorage:(function(node,newCapacity){if(node.contents&&node.contents.subarray&&newCapacity>node.contents.length){node.contents=MEMFS.getFileDataAsRegularArray(node);node.usedBytes=node.contents.length}if(!node.contents||node.contents.subarray){var prevCapacity=node.contents?node.contents.buffer.byteLength:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)|0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0);return}if(!node.contents&&newCapacity>0)node.contents=[];while(node.contents.length<newCapacity)node.contents.push(0)}),resizeFileStorage:(function(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0;return}if(!node.contents||node.contents.subarray){var oldContents=node.contents;node.contents=new Uint8Array(new ArrayBuffer(newSize));if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize;return}if(!node.contents)node.contents=[];if(node.contents.length>newSize)node.contents.length=newSize;else while(node.contents.length<newSize)node.contents.push(0);node.usedBytes=newSize}),node_ops:{getattr:(function(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}}),lookup:(function(parent,name){throw FS.genericErrors[ERRNO_CODES.ENOENT]}),mknod:(function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)}),rename:(function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}}}delete old_node.parent.contents[old_node.name];old_node.name=new_name;new_dir.contents[new_name]=old_node;old_node.parent=new_dir}),unlink:(function(parent,name){delete parent.contents[name]}),rmdir:(function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete parent.contents[name]}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node}),readlink:(function(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return node.link})},stream_ops:{read:(function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);assert(size>=0);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size}),write:(function(stream,buffer,offset,length,position,canOwn){if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=new Uint8Array(buffer.subarray(offset,offset+length));node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray)node.contents.set(buffer.subarray(offset,offset+length),position);else{for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}}node.usedBytes=Math.max(node.usedBytes,position+length);return length}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position}),allocate:(function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&(contents.buffer===buffer||contents.buffer===buffer.buffer)){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<stream.node.usedBytes){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=_malloc(length);if(!ptr){throw new FS.ErrnoError(ERRNO_CODES.ENOMEM)}buffer.set(contents,ptr)}return{ptr:ptr,allocated:allocated}}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(mmapFlags&2){return 0}var bytesWritten=MEMFS.stream_ops.write(stream,buffer,0,length,offset,false);return 0})}};var IDBFS={dbs:{},indexedDB:(function(){if(typeof indexedDB!=="undefined")return indexedDB;var ret=null;if(typeof window==="object")ret=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB;assert(ret,"IDBFS used, but indexedDB not supported");return ret}),DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:(function(mount){return MEMFS.mount.apply(null,arguments)}),syncfs:(function(mount,populate,callback){IDBFS.getLocalSet(mount,(function(err,local){if(err)return callback(err);IDBFS.getRemoteSet(mount,(function(err,remote){if(err)return callback(err);var src=populate?remote:local;var dst=populate?local:remote;IDBFS.reconcile(src,dst,callback)}))}))}),getDB:(function(name,callback){var db=IDBFS.dbs[name];if(db){return callback(null,db)}var req;try{req=IDBFS.indexedDB().open(name,IDBFS.DB_VERSION)}catch(e){return callback(e)}req.onupgradeneeded=(function(e){var db=e.target.result;var transaction=e.target.transaction;var fileStore;if(db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)){fileStore=transaction.objectStore(IDBFS.DB_STORE_NAME)}else{fileStore=db.createObjectStore(IDBFS.DB_STORE_NAME)}if(!fileStore.indexNames.contains("timestamp")){fileStore.createIndex("timestamp","timestamp",{unique:false})}});req.onsuccess=(function(){db=req.result;IDBFS.dbs[name]=db;callback(null,db)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),getLocalSet:(function(mount,callback){var entries={};function isRealDir(p){return p!=="."&&p!==".."}function toAbsolute(root){return(function(p){return PATH.join2(root,p)})}var check=FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));while(check.length){var path=check.pop();var stat;try{stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){check.push.apply(check,FS.readdir(path).filter(isRealDir).map(toAbsolute(path)))}entries[path]={timestamp:stat.mtime}}return callback(null,{type:"local",entries:entries})}),getRemoteSet:(function(mount,callback){var entries={};IDBFS.getDB(mount.mountpoint,(function(err,db){if(err)return callback(err);var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readonly");transaction.onerror=(function(e){callback(this.error);e.preventDefault()});var store=transaction.objectStore(IDBFS.DB_STORE_NAME);var index=store.index("timestamp");index.openKeyCursor().onsuccess=(function(event){var cursor=event.target.result;if(!cursor){return callback(null,{type:"remote",db:db,entries:entries})}entries[cursor.primaryKey]={timestamp:cursor.key};cursor.continue()})}))}),loadLocalEntry:(function(path,callback){var stat,node;try{var lookup=FS.lookupPath(path);node=lookup.node;stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){return callback(null,{timestamp:stat.mtime,mode:stat.mode})}else if(FS.isFile(stat.mode)){node.contents=MEMFS.getFileDataAsTypedArray(node);return callback(null,{timestamp:stat.mtime,mode:stat.mode,contents:node.contents})}else{return callback(new Error("node type not supported"))}}),storeLocalEntry:(function(path,entry,callback){try{if(FS.isDir(entry.mode)){FS.mkdir(path,entry.mode)}else if(FS.isFile(entry.mode)){FS.writeFile(path,entry.contents,{encoding:"binary",canOwn:true})}else{return callback(new Error("node type not supported"))}FS.chmod(path,entry.mode);FS.utime(path,entry.timestamp,entry.timestamp)}catch(e){return callback(e)}callback(null)}),removeLocalEntry:(function(path,callback){try{var lookup=FS.lookupPath(path);var stat=FS.stat(path);if(FS.isDir(stat.mode)){FS.rmdir(path)}else if(FS.isFile(stat.mode)){FS.unlink(path)}}catch(e){return callback(e)}callback(null)}),loadRemoteEntry:(function(store,path,callback){var req=store.get(path);req.onsuccess=(function(event){callback(null,event.target.result)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),storeRemoteEntry:(function(store,path,entry,callback){var req=store.put(entry,path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),removeRemoteEntry:(function(store,path,callback){var req=store.delete(path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),reconcile:(function(src,dst,callback){var total=0;var create=[];Object.keys(src.entries).forEach((function(key){var e=src.entries[key];var e2=dst.entries[key];if(!e2||e.timestamp>e2.timestamp){create.push(key);total++}}));var remove=[];Object.keys(dst.entries).forEach((function(key){var e=dst.entries[key];var e2=src.entries[key];if(!e2){remove.push(key);total++}}));if(!total){return callback(null)}var errored=false;var completed=0;var db=src.type==="remote"?src.db:dst.db;var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readwrite");var store=transaction.objectStore(IDBFS.DB_STORE_NAME);function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=total){return callback(null)}}transaction.onerror=(function(e){done(this.error);e.preventDefault()});create.sort().forEach((function(path){if(dst.type==="local"){IDBFS.loadRemoteEntry(store,path,(function(err,entry){if(err)return done(err);IDBFS.storeLocalEntry(path,entry,done)}))}else{IDBFS.loadLocalEntry(path,(function(err,entry){if(err)return done(err);IDBFS.storeRemoteEntry(store,path,entry,done)}))}}));remove.sort().reverse().forEach((function(path){if(dst.type==="local"){IDBFS.removeLocalEntry(path,done)}else{IDBFS.removeRemoteEntry(store,path,done)}}))})};var NODEFS={isWindows:false,staticInit:(function(){NODEFS.isWindows=!!process.platform.match(/^win/)}),mount:(function(mount){assert(ENVIRONMENT_IS_NODE);return NODEFS.createNode(null,"/",NODEFS.getMode(mount.opts.root),0)}),createNode:(function(parent,name,mode,dev){if(!FS.isDir(mode)&&!FS.isFile(mode)&&!FS.isLink(mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=FS.createNode(parent,name,mode);node.node_ops=NODEFS.node_ops;node.stream_ops=NODEFS.stream_ops;return node}),getMode:(function(path){var stat;try{stat=fs.lstatSync(path);if(NODEFS.isWindows){stat.mode=stat.mode|(stat.mode&146)>>1}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return stat.mode}),realPath:(function(node){var parts=[];while(node.parent!==node){parts.push(node.name);node=node.parent}parts.push(node.mount.opts.root);parts.reverse();return PATH.join.apply(null,parts)}),flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:(function(flags){if(flags in NODEFS.flagsToPermissionStringMap){return NODEFS.flagsToPermissionStringMap[flags]}else{return flags}}),node_ops:{getattr:(function(node){var path=NODEFS.realPath(node);var stat;try{stat=fs.lstatSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(NODEFS.isWindows&&!stat.blksize){stat.blksize=4096}if(NODEFS.isWindows&&!stat.blocks){stat.blocks=(stat.size+stat.blksize-1)/stat.blksize|0}return{dev:stat.dev,ino:stat.ino,mode:stat.mode,nlink:stat.nlink,uid:stat.uid,gid:stat.gid,rdev:stat.rdev,size:stat.size,atime:stat.atime,mtime:stat.mtime,ctime:stat.ctime,blksize:stat.blksize,blocks:stat.blocks}}),setattr:(function(node,attr){var path=NODEFS.realPath(node);try{if(attr.mode!==undefined){fs.chmodSync(path,attr.mode);node.mode=attr.mode}if(attr.timestamp!==undefined){var date=new Date(attr.timestamp);fs.utimesSync(path,date,date)}if(attr.size!==undefined){fs.truncateSync(path,attr.size)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),lookup:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);var mode=NODEFS.getMode(path);return NODEFS.createNode(parent,name,mode)}),mknod:(function(parent,name,mode,dev){var node=NODEFS.createNode(parent,name,mode,dev);var path=NODEFS.realPath(node);try{if(FS.isDir(node.mode)){fs.mkdirSync(path,node.mode)}else{fs.writeFileSync(path,"",{mode:node.mode})}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return node}),rename:(function(oldNode,newDir,newName){var oldPath=NODEFS.realPath(oldNode);var newPath=PATH.join2(NODEFS.realPath(newDir),newName);try{fs.renameSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),unlink:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.unlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),rmdir:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.rmdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readdir:(function(node){var path=NODEFS.realPath(node);try{return fs.readdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),symlink:(function(parent,newName,oldPath){var newPath=PATH.join2(NODEFS.realPath(parent),newName);try{fs.symlinkSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readlink:(function(node){var path=NODEFS.realPath(node);try{path=fs.readlinkSync(path);path=NODEJS_PATH.relative(NODEJS_PATH.resolve(node.mount.opts.root),path);return path}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}})},stream_ops:{open:(function(stream){var path=NODEFS.realPath(stream.node);try{if(FS.isFile(stream.node.mode)){stream.nfd=fs.openSync(path,NODEFS.flagsToPermissionString(stream.flags))}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),close:(function(stream){try{if(FS.isFile(stream.node.mode)&&stream.nfd){fs.closeSync(stream.nfd)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),read:(function(stream,buffer,offset,length,position){if(length===0)return 0;var nbuffer=new Buffer(length);var res;try{res=fs.readSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(res>0){for(var i=0;i<res;i++){buffer[offset+i]=nbuffer[i]}}return res}),write:(function(stream,buffer,offset,length,position){var nbuffer=new Buffer(buffer.subarray(offset,offset+length));var res;try{res=fs.writeSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return res}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){try{var stat=fs.fstatSync(stream.nfd);position+=stat.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var WORKERFS={DIR_MODE:16895,FILE_MODE:33279,reader:null,mount:(function(mount){assert(ENVIRONMENT_IS_WORKER);if(!WORKERFS.reader)WORKERFS.reader=new FileReaderSync;var root=WORKERFS.createNode(null,"/",WORKERFS.DIR_MODE,0);Array.prototype.forEach.call(mount.opts["files"]||[],(function(file){WORKERFS.createNode(root,file.name,WORKERFS.FILE_MODE,0,file,file.lastModifiedDate)}));(mount.opts["blobs"]||[]).forEach((function(obj){WORKERFS.createNode(root,obj["name"],WORKERFS.FILE_MODE,0,obj["data"])}));return root}),createNode:(function(parent,name,mode,dev,contents,mtime){var node=FS.createNode(parent,name,mode);node.mode=mode;node.node_ops=WORKERFS.node_ops;node.stream_ops=WORKERFS.stream_ops;node.timestamp=(mtime||new Date).getTime();if(parent){node.size=contents.size;node.contents=contents;parent.contents[name]=node}else{node.size=4096;node.contents={}}return node}),node_ops:{getattr:(function(node){return{dev:1,ino:undefined,mode:node.mode,nlink:1,uid:0,gid:0,rdev:undefined,size:node.size,atime:new Date(node.timestamp),mtime:new Date(node.timestamp),ctime:new Date(node.timestamp),blksize:4096,blocks:Math.ceil(node.size/4096)}}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}}),lookup:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}),mknod:(function(parent,name,mode,dev){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rename:(function(oldNode,newDir,newName){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),unlink:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rmdir:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readdir:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),symlink:(function(parent,newName,oldPath){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readlink:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)})},stream_ops:{read:(function(stream,buffer,offset,length,position){if(position>=stream.node.size)return 0;var chunk=stream.node.contents.slice(position,position+length);var ab=WORKERFS.reader.readAsArrayBuffer(chunk);buffer.set(new Uint8Array(ab),offset);return chunk.size}),write:(function(stream,buffer,offset,length,position){throw new FS.ErrnoError(ERRNO_CODES.EIO)}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.size}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var _stdin=allocate(1,"i32*",ALLOC_STATIC);var _stdout=allocate(1,"i32*",ALLOC_STATIC);var _stderr=allocate(1,"i32*",ALLOC_STATIC);var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},handleFSError:(function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)}),lookupPath:(function(path,opts){path=PATH.resolve(FS.cwd(),path);opts=opts||{};if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};for(var key in defaults){if(opts[key]===undefined){opts[key]=defaults[key]}}if(opts.recurse_count>8){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}var parts=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),false);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});current=lookup.node;if(count++>40){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}}}return{path:current_path,node:current}}),getPath:(function(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?mount+"/"+path:mount+path}path=path?node.name+"/"+path:node.name;node=node.parent}}),hashName:(function(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length}),hashAddNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node}),hashRemoveNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}}),lookupNode:(function(parent,name){var err=FS.mayLookup(parent);if(err){throw new FS.ErrnoError(err,parent)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)}),createNode:(function(parent,name,mode,rdev){if(!FS.FSNode){FS.FSNode=(function(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev});FS.FSNode.prototype={};var readMode=292|73;var writeMode=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:(function(){return(this.mode&readMode)===readMode}),set:(function(val){val?this.mode|=readMode:this.mode&=~readMode})},write:{get:(function(){return(this.mode&writeMode)===writeMode}),set:(function(val){val?this.mode|=writeMode:this.mode&=~writeMode})},isFolder:{get:(function(){return FS.isDir(this.mode)})},isDevice:{get:(function(){return FS.isChrdev(this.mode)})}})}var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node}),destroyNode:(function(node){FS.hashRemoveNode(node)}),isRoot:(function(node){return node===node.parent}),isMountpoint:(function(node){return!!node.mounted}),isFile:(function(mode){return(mode&61440)===32768}),isDir:(function(mode){return(mode&61440)===16384}),isLink:(function(mode){return(mode&61440)===40960}),isChrdev:(function(mode){return(mode&61440)===8192}),isBlkdev:(function(mode){return(mode&61440)===24576}),isFIFO:(function(mode){return(mode&61440)===4096}),isSocket:(function(mode){return(mode&49152)===49152}),flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:(function(str){var flags=FS.flagModes[str];if(typeof flags==="undefined"){throw new Error("Unknown file open mode: "+str)}return flags}),flagsToPermissionString:(function(flag){var perms=["r","w","rw"][flag&3];if(flag&512){perms+="w"}return perms}),nodePermissions:(function(node,perms){if(FS.ignorePermissions){return 0}if(perms.indexOf("r")!==-1&&!(node.mode&292)){return ERRNO_CODES.EACCES}else if(perms.indexOf("w")!==-1&&!(node.mode&146)){return ERRNO_CODES.EACCES}else if(perms.indexOf("x")!==-1&&!(node.mode&73)){return ERRNO_CODES.EACCES}return 0}),mayLookup:(function(dir){var err=FS.nodePermissions(dir,"x");if(err)return err;if(!dir.node_ops.lookup)return ERRNO_CODES.EACCES;return 0}),mayCreate:(function(dir,name){try{var node=FS.lookupNode(dir,name);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(dir,"wx")}),mayDelete:(function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var err=FS.nodePermissions(dir,"wx");if(err){return err}if(isdir){if(!FS.isDir(node.mode)){return ERRNO_CODES.ENOTDIR}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return ERRNO_CODES.EBUSY}}else{if(FS.isDir(node.mode)){return ERRNO_CODES.EISDIR}}return 0}),mayOpen:(function(node,flags){if(!node){return ERRNO_CODES.ENOENT}if(FS.isLink(node.mode)){return ERRNO_CODES.ELOOP}else if(FS.isDir(node.mode)){if((flags&2097155)!==0||flags&512){return ERRNO_CODES.EISDIR}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))}),MAX_OPEN_FDS:4096,nextfd:(function(fd_start,fd_end){fd_start=fd_start||0;fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(ERRNO_CODES.EMFILE)}),getStream:(function(fd){return FS.streams[fd]}),createStream:(function(stream,fd_start,fd_end){if(!FS.FSStream){FS.FSStream=(function(){});FS.FSStream.prototype={};Object.defineProperties(FS.FSStream.prototype,{object:{get:(function(){return this.node}),set:(function(val){this.node=val})},isRead:{get:(function(){return(this.flags&2097155)!==1})},isWrite:{get:(function(){return(this.flags&2097155)!==0})},isAppend:{get:(function(){return this.flags&1024})}})}var newStream=new FS.FSStream;for(var p in stream){newStream[p]=stream[p]}stream=newStream;var fd=FS.nextfd(fd_start,fd_end);stream.fd=fd;FS.streams[fd]=stream;return stream}),closeStream:(function(fd){FS.streams[fd]=null}),chrdev_stream_ops:{open:(function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;if(stream.stream_ops.open){stream.stream_ops.open(stream)}}),llseek:(function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)})},major:(function(dev){return dev>>8}),minor:(function(dev){return dev&255}),makedev:(function(ma,mi){return ma<<8|mi}),registerDevice:(function(dev,ops){FS.devices[dev]={stream_ops:ops}}),getDevice:(function(dev){return FS.devices[dev]}),getMounts:(function(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push.apply(check,m.mounts)}return mounts}),syncfs:(function(populate,callback){if(typeof populate==="function"){callback=populate;populate=false}var mounts=FS.getMounts(FS.root.mount);var completed=0;function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=mounts.length){callback(null)}}mounts.forEach((function(mount){if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)}))}),mount:(function(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot}),unmount:(function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach((function(hash){var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.indexOf(current.mount)!==-1){FS.destroyNode(current)}current=next}}));node.mounted=null;var idx=node.mount.mounts.indexOf(mount);assert(idx!==-1);node.mount.mounts.splice(idx,1)}),lookup:(function(parent,name){return parent.node_ops.lookup(parent,name)}),mknod:(function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.mayCreate(parent,name);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.mknod(parent,name,mode,dev)}),create:(function(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)}),mkdir:(function(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)}),mkdev:(function(path,mode,dev){if(typeof dev==="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)}),symlink:(function(oldpath,newpath){if(!PATH.resolve(oldpath)){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var newname=PATH.basename(newpath);var err=FS.mayCreate(parent,newname);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.symlink(parent,newname,oldpath)}),rename:(function(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;try{lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!old_dir||!new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(ERRNO_CODES.EXDEV)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}relative=PATH.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var err=FS.mayDelete(old_dir,old_name,isdir);if(err){throw new FS.ErrnoError(err)}err=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(err){throw new FS.ErrnoError(err)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(new_dir!==old_dir){err=FS.nodePermissions(old_dir,"w");if(err){throw new FS.ErrnoError(err)}}try{if(FS.trackingDelegate["willMovePath"]){FS.trackingDelegate["willMovePath"](old_path,new_path)}}catch(e){console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{if(FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path,new_path)}catch(e){console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}}),rmdir:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,true);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}return node.node_ops.readdir(node)}),unlink:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,false);if(err){if(err===ERRNO_CODES.EISDIR)err=ERRNO_CODES.EPERM;throw new FS.ErrnoError(err)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readlink:(function(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!link.node_ops.readlink){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return PATH.resolve(FS.getPath(link.parent),link.node_ops.readlink(link))}),stat:(function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!node.node_ops.getattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return node.node_ops.getattr(node)}),lstat:(function(path){return FS.stat(path,true)}),chmod:(function(path,mode,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})}),lchmod:(function(path,mode){FS.chmod(path,mode,true)}),fchmod:(function(fd,mode){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chmod(stream.node,mode)}),chown:(function(path,uid,gid,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{timestamp:Date.now()})}),lchown:(function(path,uid,gid){FS.chown(path,uid,gid,true)}),fchown:(function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chown(stream.node,uid,gid)}),truncate:(function(path,len){if(len<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.nodePermissions(node,"w");if(err){throw new FS.ErrnoError(err)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})}),ftruncate:(function(fd,len){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}FS.truncate(stream.node,len)}),utime:(function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})}),open:(function(path,flags,mode,fd_start,fd_end){if(path===""){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}flags=typeof flags==="string"?FS.modeStringToFlags(flags):flags;mode=typeof mode==="undefined"?438:mode;if(flags&64){mode=mode&4095|32768}else{mode=0}var node;if(typeof path==="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(FS.isChrdev(node.mode)){flags&=~512}if(flags&65536&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}if(!created){var err=FS.mayOpen(node,flags);if(err){throw new FS.ErrnoError(err)}}if(flags&512){FS.truncate(node,0)}flags&=~(128|512);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false},fd_start,fd_end);if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(Module["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1;Module["printErr"]("read file: "+path)}}try{if(FS.trackingDelegate["onOpenFile"]){var trackingFlags=0;if((flags&2097155)!==1){trackingFlags|=FS.tracking.openFlags.READ}if((flags&2097155)!==0){trackingFlags|=FS.tracking.openFlags.WRITE}FS.trackingDelegate["onOpenFile"](path,trackingFlags)}}catch(e){console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream}),close:(function(stream){if(stream.getdents)stream.getdents=null;try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}}),llseek:(function(stream,offset,whence){if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position}),read:(function(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.read){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead}),write:(function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.write){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if(stream.flags&1024){FS.llseek(stream,0,2)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;try{if(stream.path&&FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return bytesWritten}),allocate:(function(stream,offset,length){if(offset<0||length<=0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}stream.stream_ops.allocate(stream,offset,length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EACCES)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}return stream.stream_ops.mmap(stream,buffer,offset,length,position,prot,flags)}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!stream||!stream.stream_ops.msync){return 0}return stream.stream_ops.msync(stream,buffer,offset,length,mmapFlags)}),munmap:(function(stream){return 0}),ioctl:(function(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(ERRNO_CODES.ENOTTY)}return stream.stream_ops.ioctl(stream,cmd,arg)}),readFile:(function(path,opts){opts=opts||{};opts.flags=opts.flags||"r";opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret}),writeFile:(function(path,data,opts){opts=opts||{};opts.flags=opts.flags||"w";opts.encoding=opts.encoding||"utf8";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var stream=FS.open(path,opts.flags,opts.mode);if(opts.encoding==="utf8"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,0,opts.canOwn)}else if(opts.encoding==="binary"){FS.write(stream,data,0,data.length,0,opts.canOwn)}FS.close(stream)}),cwd:(function(){return FS.currentPath}),chdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var err=FS.nodePermissions(lookup.node,"x");if(err){throw new FS.ErrnoError(err)}FS.currentPath=lookup.path}),createDefaultDirectories:(function(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")}),createDefaultDevices:(function(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:(function(){return 0}),write:(function(stream,buffer,offset,length,pos){return length})});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if(typeof crypto!=="undefined"){var randomBuffer=new Uint8Array(1);random_device=(function(){crypto.getRandomValues(randomBuffer);return randomBuffer[0]})}else if(ENVIRONMENT_IS_NODE){random_device=(function(){return require("crypto").randomBytes(1)[0]})}else{random_device=(function(){return Math.random()*256|0})}FS.createDevice("/dev","random",random_device);FS.createDevice("/dev","urandom",random_device);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")}),createSpecialDirectories:(function(){FS.mkdir("/proc");FS.mkdir("/proc/self");FS.mkdir("/proc/self/fd");FS.mount({mount:(function(){var node=FS.createNode("/proc/self","fd",16384|511,73);node.node_ops={lookup:(function(parent,name){var fd=+name;var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);var ret={parent:null,mount:{mountpoint:"fake"},node_ops:{readlink:(function(){return stream.path})}};ret.parent=ret;return ret})};return node})},{},"/proc/self/fd")}),createStandardStreams:(function(){if(Module["stdin"]){FS.createDevice("/dev","stdin",Module["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(Module["stdout"]){FS.createDevice("/dev","stdout",null,Module["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(Module["stderr"]){FS.createDevice("/dev","stderr",null,Module["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin","r");assert(stdin.fd===0,"invalid handle for stdin ("+stdin.fd+")");var stdout=FS.open("/dev/stdout","w");assert(stdout.fd===1,"invalid handle for stdout ("+stdout.fd+")");var stderr=FS.open("/dev/stderr","w");assert(stderr.fd===2,"invalid handle for stderr ("+stderr.fd+")")}),ensureErrnoError:(function(){if(FS.ErrnoError)return;FS.ErrnoError=function ErrnoError(errno,node){this.node=node;this.setErrno=(function(errno){this.errno=errno;for(var key in ERRNO_CODES){if(ERRNO_CODES[key]===errno){this.code=key;break}}});this.setErrno(errno);this.message=ERRNO_MESSAGES[errno]};FS.ErrnoError.prototype=new Error;FS.ErrnoError.prototype.constructor=FS.ErrnoError;[ERRNO_CODES.ENOENT].forEach((function(code){FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"}))}),staticInit:(function(){FS.ensureErrnoError();FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices();FS.createSpecialDirectories()}),init:(function(input,output,error){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");FS.init.initialized=true;FS.ensureErrnoError();Module["stdin"]=input||Module["stdin"];Module["stdout"]=output||Module["stdout"];Module["stderr"]=error||Module["stderr"];FS.createStandardStreams()}),quit:(function(){FS.init.initialized=false;var fflush=Module["_fflush"];if(fflush)fflush(0);for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}}),getMode:(function(canRead,canWrite){var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode}),joinPath:(function(parts,forceRelative){var path=PATH.join.apply(null,parts);if(forceRelative&&path[0]=="/")path=path.substr(1);return path}),absolutePath:(function(relative,base){return PATH.resolve(base,relative)}),standardizePath:(function(path){return PATH.normalize(path)}),findObject:(function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(ret.exists){return ret.object}else{___setErrNo(ret.error);return null}}),analyzePath:(function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret}),createFolder:(function(parent,name,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)}),createPath:(function(parent,path,canRead,canWrite){parent=typeof parent==="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current}),createFile:(function(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)}),createDataFile:(function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name):parent;var mode=FS.getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data==="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}return node}),createDevice:(function(parent,name,input,output){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open:(function(stream){stream.seekable=false}),close:(function(stream){if(output&&output.buffer&&output.buffer.length){output(10)}}),read:(function(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})});return FS.mkdev(path,mode,dev)}),createLink:(function(parent,name,target,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);return FS.symlink(target,path)}),forceLoadFile:(function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;var success=true;if(typeof XMLHttpRequest!=="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else if(Module["read"]){try{obj.contents=intArrayFromString(Module["read"](obj.url),true);obj.usedBytes=obj.contents.length}catch(e){success=false}}else{throw new Error("Cannot load without read() or XMLHttpRequest.")}if(!success)___setErrNo(ERRNO_CODES.EIO);return success}),createLazyFile:(function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=false;this.chunks=[]}LazyUint8Array.prototype.get=function LazyUint8Array_get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]};LazyUint8Array.prototype.setDataGetter=function LazyUint8Array_setDataGetter(getter){this.getter=getter};LazyUint8Array.prototype.cacheLength=function LazyUint8Array_cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=(function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);if(typeof Uint8Array!="undefined")xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}else{return intArrayFromString(xhr.responseText||"",true)}});var lazyArray=this;lazyArray.setDataGetter((function(chunkNum){var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]==="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]==="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]}));this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true};if(typeof XMLHttpRequest!=="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;Object.defineProperty(lazyArray,"length",{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._length})});Object.defineProperty(lazyArray,"chunkSize",{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize})});var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperty(node,"usedBytes",{get:(function(){return this.contents.length})});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach((function(key){var fn=node.stream_ops[key];stream_ops[key]=function forceLoadLazyFile(){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return fn.apply(null,arguments)}}));stream_ops.read=function stream_ops_read(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);assert(size>=0);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size};node.stream_ops=stream_ops;return node}),createPreloadedFile:(function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn,preFinish){Browser.init();var fullname=name?PATH.resolve(PATH.join2(parent,name)):parent;var dep=getUniqueRunDependency("cp "+fullname);function processData(byteArray){function finish(byteArray){if(preFinish)preFinish();if(!dontCreateFile){FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}if(onload)onload();removeRunDependency(dep)}var handled=false;Module["preloadPlugins"].forEach((function(plugin){if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,(function(){if(onerror)onerror();removeRunDependency(dep)}));handled=true}}));if(!handled)finish(byteArray)}addRunDependency(dep);if(typeof url=="string"){Browser.asyncLoad(url,(function(byteArray){processData(byteArray)}),onerror)}else{processData(url)}}),indexedDB:(function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB}),DB_NAME:(function(){return"EM_FS_"+window.location.pathname}),DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function openRequest_onupgradeneeded(){console.log("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)};openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;var transaction=db.transaction([FS.DB_STORE_NAME],"readwrite");var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function putRequest_onsuccess(){ok++;if(ok+fail==total)finish()};putRequest.onerror=function putRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror}),loadFilesFromDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror;openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){onerror(e);return}var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var getRequest=files.get(path);getRequest.onsuccess=function getRequest_onsuccess(){if(FS.analyzePath(path).exists){FS.unlink(path)}FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,true,true,true);ok++;if(ok+fail==total)finish()};getRequest.onerror=function getRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror})};var SYSCALLS={DEFAULT_POLLMASK:5,mappings:{},umask:511,calculateAt:(function(dirfd,path){if(path[0]!=="/"){var dir;if(dirfd===-100){dir=FS.cwd()}else{var dirstream=FS.getStream(dirfd);if(!dirstream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);dir=dirstream.path}path=PATH.join2(dir,path)}return path}),doStat:(function(func,path,buf){try{var stat=func(path)}catch(e){if(e&&e.node&&PATH.normalize(path)!==PATH.normalize(FS.getPath(e.node))){return-ERRNO_CODES.ENOTDIR}throw e}HEAP32[buf>>2]=stat.dev;HEAP32[buf+4>>2]=0;HEAP32[buf+8>>2]=stat.ino;HEAP32[buf+12>>2]=stat.mode;HEAP32[buf+16>>2]=stat.nlink;HEAP32[buf+20>>2]=stat.uid;HEAP32[buf+24>>2]=stat.gid;HEAP32[buf+28>>2]=stat.rdev;HEAP32[buf+32>>2]=0;HEAP32[buf+36>>2]=stat.size;HEAP32[buf+40>>2]=4096;HEAP32[buf+44>>2]=stat.blocks;HEAP32[buf+48>>2]=stat.atime.getTime()/1e3|0;HEAP32[buf+52>>2]=0;HEAP32[buf+56>>2]=stat.mtime.getTime()/1e3|0;HEAP32[buf+60>>2]=0;HEAP32[buf+64>>2]=stat.ctime.getTime()/1e3|0;HEAP32[buf+68>>2]=0;HEAP32[buf+72>>2]=stat.ino;return 0}),doMsync:(function(addr,stream,len,flags){var buffer=new Uint8Array(HEAPU8.buffer,addr,len);FS.msync(stream,buffer,0,len,flags)}),doMkdir:(function(path,mode){path=PATH.normalize(path);if(path[path.length-1]==="/")path=path.substr(0,path.length-1);FS.mkdir(path,mode,0);return 0}),doMknod:(function(path,mode,dev){switch(mode&61440){case 32768:case 8192:case 24576:case 4096:case 49152:break;default:return-ERRNO_CODES.EINVAL}FS.mknod(path,mode,dev);return 0}),doReadlink:(function(path,buf,bufsize){if(bufsize<=0)return-ERRNO_CODES.EINVAL;var ret=FS.readlink(path);ret=ret.slice(0,Math.max(0,bufsize));writeStringToMemory(ret,buf,true);return ret.length}),doAccess:(function(path,amode){if(amode&~7){return-ERRNO_CODES.EINVAL}var node;var lookup=FS.lookupPath(path,{follow:true});node=lookup.node;var perms="";if(amode&4)perms+="r";if(amode&2)perms+="w";if(amode&1)perms+="x";if(perms&&FS.nodePermissions(node,perms)){return-ERRNO_CODES.EACCES}return 0}),doDup:(function(path,flags,suggestFD){var suggest=FS.getStream(suggestFD);if(suggest)FS.close(suggest);return FS.open(path,flags,0,suggestFD,suggestFD).fd}),doReadv:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.read(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(curr<len)break}return ret}),doWritev:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.write(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr}return ret}),varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),getStreamFromFD:(function(){var stream=FS.getStream(SYSCALLS.get());if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return stream}),getSocketFromFD:(function(){var socket=SOCKFS.getSocket(SYSCALLS.get());if(!socket)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return socket}),getSocketAddress:(function(allowNull){var addrp=SYSCALLS.get(),addrlen=SYSCALLS.get();if(allowNull&&addrp===0)return null;var info=__read_sockaddr(addrp,addrlen);if(info.errno)throw new FS.ErrnoError(info.errno);info.addr=DNS.lookup_addr(info.addr)||info.addr;return info}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var _emscripten_asm_const=true;function ___assert_fail(condition,filename,line,func){ABORT=true;throw"Assertion failed: "+Pointer_stringify(condition)+", at: "+[filename?Pointer_stringify(filename):"unknown filename",line,func?Pointer_stringify(func):"unknown function"]+" at "+stackTrace()}function _sbrk(bytes){var self=_sbrk;if(!self.called){DYNAMICTOP=alignMemoryPage(DYNAMICTOP);self.called=true;assert(Runtime.dynamicAlloc);self.alloc=Runtime.dynamicAlloc;Runtime.dynamicAlloc=(function(){abort("cannot dynamically allocate, sbrk now has control")})}var ret=DYNAMICTOP;if(bytes!=0){var success=self.alloc(bytes);if(!success)return-1>>>0}return ret}function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}Module["_memcpy"]=_memcpy;Module["_memmove"]=_memmove;var _emscripten_asm_const_int=true;function _time(ptr){var ret=Date.now()/1e3|0;if(ptr){HEAP32[ptr>>2]=ret}return ret}function _pthread_self(){return 0}function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;assert(offset_high===0);FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doWritev(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),op=SYSCALLS.get();switch(op){case 21505:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21506:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21519:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;var argp=SYSCALLS.get();HEAP32[argp>>2]=0;return 0};case 21520:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return-ERRNO_CODES.EINVAL};case 21531:{var argp=SYSCALLS.get();return FS.ioctl(stream,op,argp)};default:abort("bad ioctl syscall "+op)}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}FS.staticInit();__ATINIT__.unshift((function(){if(!Module["noFSInit"]&&!FS.init.initialized)FS.init()}));__ATMAIN__.push((function(){FS.ignorePermissions=false}));__ATEXIT__.push((function(){FS.quit()}));Module["FS_createFolder"]=FS.createFolder;Module["FS_createPath"]=FS.createPath;Module["FS_createDataFile"]=FS.createDataFile;Module["FS_createPreloadedFile"]=FS.createPreloadedFile;Module["FS_createLazyFile"]=FS.createLazyFile;Module["FS_createLink"]=FS.createLink;Module["FS_createDevice"]=FS.createDevice;Module["FS_unlink"]=FS.unlink;__ATINIT__.unshift((function(){TTY.init()}));__ATEXIT__.push((function(){TTY.shutdown()}));if(ENVIRONMENT_IS_NODE){var fs=require("fs");var NODEJS_PATH=require("path");NODEFS.staticInit()}STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);staticSealed=true;STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=DYNAMICTOP=Runtime.alignMemory(STACK_MAX);assert(DYNAMIC_BASE<TOTAL_MEMORY,"TOTAL_MEMORY not big enough for stack");var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_DYNAMIC);function invoke_i(index){try{return Module["dynCall_i"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_i(index){return Runtime.functionPointers[index]()}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_ii(index,a1){return Runtime.functionPointers[index](a1)}function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_iiii(index,a1,a2,a3){return Runtime.functionPointers[index](a1,a2,a3)}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function jsCall_vi(index,a1){Runtime.functionPointers[index](a1)}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity};Module.asmLibraryArg={"abort":abort,"assert":assert,"invoke_i":invoke_i,"jsCall_i":jsCall_i,"invoke_ii":invoke_ii,"jsCall_ii":jsCall_ii,"invoke_iiii":invoke_iiii,"jsCall_iiii":jsCall_iiii,"invoke_vi":invoke_vi,"jsCall_vi":jsCall_vi,"_pthread_cleanup_pop":_pthread_cleanup_pop,"___lock":___lock,"_sysconf":_sysconf,"_pthread_self":_pthread_self,"___syscall6":___syscall6,"___setErrNo":___setErrNo,"_abort":_abort,"_sbrk":_sbrk,"_time":_time,"_pthread_cleanup_push":_pthread_cleanup_push,"_emscripten_memcpy_big":_emscripten_memcpy_big,"___syscall54":___syscall54,"___unlock":___unlock,"___syscall140":___syscall140,"___assert_fail":___assert_fail,"___syscall146":___syscall146,"_emscripten_asm_const_0":_emscripten_asm_const_0,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"cttz_i8":cttz_i8};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=0;var o=0;var p=0;var q=0;var r=global.NaN,s=global.Infinity;var t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0;var C=0;var D=0;var E=0;var F=0;var G=0;var H=0;var I=0;var J=0;var K=0;var L=0;var M=global.Math.floor;var N=global.Math.abs;var O=global.Math.sqrt;var P=global.Math.pow;var Q=global.Math.cos;var R=global.Math.sin;var S=global.Math.tan;var T=global.Math.acos;var U=global.Math.asin;var V=global.Math.atan;var W=global.Math.atan2;var X=global.Math.exp;var Y=global.Math.log;var Z=global.Math.ceil;var _=global.Math.imul;var $=global.Math.min;var aa=global.Math.clz32;var ba=env.abort;var ca=env.assert;var da=env.invoke_i;var ea=env.jsCall_i;var fa=env.invoke_ii;var ga=env.jsCall_ii;var ha=env.invoke_iiii;var ia=env.jsCall_iiii;var ja=env.invoke_vi;var ka=env.jsCall_vi;var la=env._pthread_cleanup_pop;var ma=env.___lock;var na=env._sysconf;var oa=env._pthread_self;var pa=env.___syscall6;var qa=env.___setErrNo;var ra=env._abort;var sa=env._sbrk;var ta=env._time;var ua=env._pthread_cleanup_push;var va=env._emscripten_memcpy_big;var wa=env.___syscall54;var xa=env.___unlock;var ya=env.___syscall140;var za=env.___assert_fail;var Aa=env.___syscall146;var Ba=env._emscripten_asm_const_0;var Ca=0.0;
// EMSCRIPTEN_START_FUNCS
function Oc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;R=i;P=i=i+63&-64;i=i+320|0;Q=P+280|0;k=P+240|0;j=P+200|0;s=P+160|0;l=P+120|0;m=P+80|0;r=P+40|0;O=b+40|0;T=d[e>>0]|0;M=Jd(d[e+1>>0]|0|0,0,8)|0;J=C;p=Jd(d[e+2>>0]|0|0,0,16)|0;J=J|C;q=Jd(d[e+3>>0]|0|0,0,24)|0;J=J|C;I=a[e+6>>0]|0;L=d[e+4>>0]|0;o=Jd(d[e+5>>0]|0|0,0,8)|0;K=C;I=Jd(I&255|0,0,16)|0;K=Jd(o|L|I|0,K|C|0,6)|0;I=C;L=a[e+9>>0]|0;o=d[e+7>>0]|0;f=Jd(d[e+8>>0]|0|0,0,8)|0;w=C;L=Jd(L&255|0,0,16)|0;w=Jd(f|o|L|0,w|C|0,5)|0;L=C;o=a[e+12>>0]|0;f=d[e+10>>0]|0;y=Jd(d[e+11>>0]|0|0,0,8)|0;n=C;o=Jd(o&255|0,0,16)|0;n=Jd(y|f|o|0,n|C|0,3)|0;o=C;f=a[e+15>>0]|0;y=d[e+13>>0]|0;F=Jd(d[e+14>>0]|0|0,0,8)|0;A=C;f=Jd(f&255|0,0,16)|0;A=Jd(F|y|f|0,A|C|0,2)|0;f=C;y=d[e+16>>0]|0;F=Jd(d[e+17>>0]|0|0,0,8)|0;u=C;h=Jd(d[e+18>>0]|0|0,0,16)|0;u=u|C;t=Jd(d[e+19>>0]|0|0,0,24)|0;t=F|y|h|t;u=u|C;h=a[e+22>>0]|0;y=d[e+20>>0]|0;F=Jd(d[e+21>>0]|0|0,0,8)|0;E=C;h=Jd(h&255|0,0,16)|0;E=Jd(F|y|h|0,E|C|0,7)|0;h=C;y=a[e+25>>0]|0;F=d[e+23>>0]|0;N=Jd(d[e+24>>0]|0|0,0,8)|0;x=C;y=Jd(y&255|0,0,16)|0;x=Jd(N|F|y|0,x|C|0,5)|0;y=C;F=a[e+28>>0]|0;N=d[e+26>>0]|0;g=Jd(d[e+27>>0]|0|0,0,8)|0;G=C;F=Jd(F&255|0,0,16)|0;G=Jd(g|N|F|0,G|C|0,4)|0;F=C;N=e+31|0;g=a[N>>0]|0;D=d[e+29>>0]|0;v=Jd(d[e+30>>0]|0|0,0,8)|0;B=C;g=Jd(g&255|0,0,16)|0;B=Jd(v|D|g|0,B|C|0,2)|0;B=B&33554428;g=Fd(B|0,0,16777216,0)|0;g=Id(g|0,C|0,25)|0;D=C;v=Ed(0,0,g|0,D|0)|0;J=Fd(v&19|0,0,M|T|p|q|0,J|0)|0;q=C;D=Jd(g|0,D|0,25)|0;g=C;p=Fd(K|0,I|0,16777216,0)|0;p=Id(p|0,C|0,25)|0;T=C;L=Fd(w|0,L|0,p|0,T|0)|0;w=C;T=Jd(p|0,T|0,25)|0;T=Ed(K|0,I|0,T|0,C|0)|0;I=C;K=Fd(n|0,o|0,16777216,0)|0;K=Id(K|0,C|0,25)|0;p=C;f=Fd(A|0,f|0,K|0,p|0)|0;A=C;p=Jd(K|0,p|0,25)|0;K=C;M=Fd(t|0,u|0,16777216,0)|0;M=Id(M|0,C|0,25)|0;v=C;h=Fd(E|0,h|0,M|0,v|0)|0;E=C;v=Jd(M|0,v|0,25)|0;M=C;e=Fd(x|0,y|0,16777216,0)|0;e=Id(e|0,C|0,25)|0;z=C;F=Fd(G|0,F|0,e|0,z|0)|0;G=C;z=Jd(e|0,z|0,25)|0;e=C;S=Fd(J|0,q|0,33554432,0)|0;S=Gd(S|0,C|0,26)|0;H=C;I=Fd(T|0,I|0,S|0,H|0)|0;H=Jd(S|0,H|0,26)|0;H=Ed(J|0,q|0,H|0,C|0)|0;q=Fd(L|0,w|0,33554432,0)|0;q=Gd(q|0,C|0,26)|0;J=C;o=Fd(q|0,J|0,n|0,o|0)|0;K=Ed(o|0,C|0,p|0,K|0)|0;J=Jd(q|0,J|0,26)|0;J=Ed(L|0,w|0,J|0,C|0)|0;w=Fd(f|0,A|0,33554432,0)|0;w=Gd(w|0,C|0,26)|0;L=C;u=Fd(w|0,L|0,t|0,u|0)|0;M=Ed(u|0,C|0,v|0,M|0)|0;L=Jd(w|0,L|0,26)|0;L=Ed(f|0,A|0,L|0,C|0)|0;A=Fd(h|0,E|0,33554432,0)|0;A=Gd(A|0,C|0,26)|0;f=C;y=Fd(A|0,f|0,x|0,y|0)|0;e=Ed(y|0,C|0,z|0,e|0)|0;f=Jd(A|0,f|0,26)|0;f=Ed(h|0,E|0,f|0,C|0)|0;E=Fd(F|0,G|0,33554432,0)|0;E=Gd(E|0,C|0,26)|0;h=C;B=Fd(B|0,0,E|0,h|0)|0;g=Ed(B|0,C|0,D|0,g|0)|0;h=Jd(E|0,h|0,26)|0;h=Ed(F|0,G|0,h|0,C|0)|0;c[O>>2]=H;c[b+44>>2]=I;c[b+48>>2]=J;c[b+52>>2]=K;c[b+56>>2]=L;c[b+60>>2]=M;c[b+64>>2]=f;c[b+68>>2]=e;c[b+72>>2]=h;c[b+76>>2]=g;g=b+80|0;c[g>>2]=1;h=b+84|0;e=h;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Lc(s,O);Kc(l,s,1064);p=s+4|0;q=s+8|0;o=s+12|0;n=s+16|0;e=s+20|0;v=s+24|0;x=s+28|0;z=s+32|0;B=s+36|0;g=c[g>>2]|0;t=c[h>>2]|0;w=c[b+88>>2]|0;A=c[b+92>>2]|0;E=c[b+96>>2]|0;G=c[b+100>>2]|0;I=c[b+104>>2]|0;K=c[b+108>>2]|0;M=c[b+112>>2]|0;T=c[b+116>>2]|0;f=(c[p>>2]|0)-t|0;S=(c[q>>2]|0)-w|0;L=(c[o>>2]|0)-A|0;J=(c[n>>2]|0)-E|0;H=(c[e>>2]|0)-G|0;F=(c[v>>2]|0)-I|0;D=(c[x>>2]|0)-K|0;y=(c[z>>2]|0)-M|0;u=(c[B>>2]|0)-T|0;c[s>>2]=(c[s>>2]|0)-g;c[p>>2]=f;c[q>>2]=S;c[o>>2]=L;c[n>>2]=J;c[e>>2]=H;c[v>>2]=F;c[x>>2]=D;c[z>>2]=y;c[B>>2]=u;u=l+4|0;y=l+8|0;D=l+12|0;F=l+16|0;H=l+20|0;J=l+24|0;L=l+28|0;S=l+32|0;f=l+36|0;t=t+(c[u>>2]|0)|0;w=w+(c[y>>2]|0)|0;A=A+(c[D>>2]|0)|0;E=E+(c[F>>2]|0)|0;G=G+(c[H>>2]|0)|0;I=I+(c[J>>2]|0)|0;K=K+(c[L>>2]|0)|0;M=M+(c[S>>2]|0)|0;T=T+(c[f>>2]|0)|0;c[l>>2]=g+(c[l>>2]|0);c[u>>2]=t;c[y>>2]=w;c[D>>2]=A;c[F>>2]=E;c[H>>2]=G;c[J>>2]=I;c[L>>2]=K;c[S>>2]=M;c[f>>2]=T;Lc(m,l);Kc(m,m,l);Lc(b,m);Kc(b,b,l);Kc(b,b,s);Lc(Q,b);Lc(k,Q);Lc(k,k);Kc(k,b,k);Kc(Q,Q,k);Lc(Q,Q);Kc(Q,k,Q);Lc(k,Q);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Kc(Q,k,Q);Lc(k,Q);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Kc(k,k,Q);Lc(j,k);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Lc(j,j);Kc(k,j,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Lc(k,k);Kc(Q,k,Q);Lc(k,Q);f=1;do{Lc(k,k);f=f+1|0}while((f|0)!=50);Kc(k,k,Q);Lc(j,k);f=1;do{Lc(j,j);f=f+1|0}while((f|0)!=100);Kc(k,j,k);Lc(k,k);f=1;do{Lc(k,k);f=f+1|0}while((f|0)!=50);Kc(Q,k,Q);Lc(Q,Q);Lc(Q,Q);Kc(b,Q,b);Kc(b,b,m);Kc(b,b,s);Lc(r,b);Kc(r,r,l);E=c[r>>2]|0;F=c[r+4>>2]|0;G=c[r+8>>2]|0;H=c[r+12>>2]|0;I=c[r+16>>2]|0;J=c[r+20>>2]|0;K=c[r+24>>2]|0;L=c[r+28>>2]|0;M=c[r+32>>2]|0;D=c[r+36>>2]|0;A=c[s>>2]|0;y=c[p>>2]|0;w=c[q>>2]|0;u=c[o>>2]|0;t=c[n>>2]|0;s=c[e>>2]|0;r=c[v>>2]|0;q=c[x>>2]|0;p=c[z>>2]|0;m=c[B>>2]|0;c[P>>2]=E-A;l=P+4|0;c[l>>2]=F-y;k=P+8|0;c[k>>2]=G-w;j=P+12|0;c[j>>2]=H-u;h=P+16|0;c[h>>2]=I-t;g=P+20|0;c[g>>2]=J-s;f=P+24|0;c[f>>2]=K-r;e=P+28|0;c[e>>2]=L-q;n=P+32|0;c[n>>2]=M-p;o=P+36|0;c[o>>2]=D-m;Mc(Q,P);do if(Zc(Q,33004)|0){c[P>>2]=A+E;c[l>>2]=y+F;c[k>>2]=w+G;c[j>>2]=u+H;c[h>>2]=t+I;c[g>>2]=s+J;c[f>>2]=r+K;c[e>>2]=q+L;c[n>>2]=p+M;c[o>>2]=m+D;Mc(Q,P);if(!(Zc(Q,33004)|0)){Kc(b,b,1104);break}else{T=-1;i=R;return T|0}}while(0);Mc(Q,b);if(((d[Q>>0]|0)&1|0)==((d[N>>0]|0)>>>7|0)){A=b+4|0;D=b+8|0;F=b+12|0;H=b+16|0;J=b+20|0;L=b+24|0;N=b+28|0;Q=b+32|0;T=b+36|0;z=0-(c[A>>2]|0)|0;B=0-(c[D>>2]|0)|0;E=0-(c[F>>2]|0)|0;G=0-(c[H>>2]|0)|0;I=0-(c[J>>2]|0)|0;K=0-(c[L>>2]|0)|0;M=0-(c[N>>2]|0)|0;P=0-(c[Q>>2]|0)|0;S=0-(c[T>>2]|0)|0;c[b>>2]=0-(c[b>>2]|0);c[A>>2]=z;c[D>>2]=B;c[F>>2]=E;c[H>>2]=G;c[J>>2]=I;c[L>>2]=K;c[N>>2]=M;c[Q>>2]=P;c[T>>2]=S}Kc(b+120|0,b,O);T=0;i=R;return T|0}function Pc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;V=b+40|0;j=b+44|0;m=b+48|0;p=b+52|0;s=b+56|0;v=b+60|0;y=b+64|0;B=b+68|0;E=b+72|0;C=b+76|0;S=b+4|0;P=b+8|0;e=b+12|0;l=b+16|0;n=b+20|0;u=b+24|0;w=b+28|0;D=b+32|0;O=b+36|0;ga=(c[S>>2]|0)+(c[j>>2]|0)|0;fa=(c[P>>2]|0)+(c[m>>2]|0)|0;ea=(c[e>>2]|0)+(c[p>>2]|0)|0;da=(c[l>>2]|0)+(c[s>>2]|0)|0;ca=(c[n>>2]|0)+(c[v>>2]|0)|0;ba=(c[u>>2]|0)+(c[y>>2]|0)|0;aa=(c[w>>2]|0)+(c[B>>2]|0)|0;$=(c[D>>2]|0)+(c[E>>2]|0)|0;Y=(c[O>>2]|0)+(c[C>>2]|0)|0;c[a>>2]=(c[b>>2]|0)+(c[V>>2]|0);ha=a+4|0;c[ha>>2]=ga;ga=a+8|0;c[ga>>2]=fa;fa=a+12|0;c[fa>>2]=ea;ea=a+16|0;c[ea>>2]=da;da=a+20|0;c[da>>2]=ca;ca=a+24|0;c[ca>>2]=ba;ba=a+28|0;c[ba>>2]=aa;aa=a+32|0;c[aa>>2]=$;$=a+36|0;c[$>>2]=Y;Y=a+40|0;S=(c[j>>2]|0)-(c[S>>2]|0)|0;P=(c[m>>2]|0)-(c[P>>2]|0)|0;e=(c[p>>2]|0)-(c[e>>2]|0)|0;l=(c[s>>2]|0)-(c[l>>2]|0)|0;n=(c[v>>2]|0)-(c[n>>2]|0)|0;u=(c[y>>2]|0)-(c[u>>2]|0)|0;w=(c[B>>2]|0)-(c[w>>2]|0)|0;D=(c[E>>2]|0)-(c[D>>2]|0)|0;O=(c[C>>2]|0)-(c[O>>2]|0)|0;c[Y>>2]=(c[V>>2]|0)-(c[b>>2]|0);V=a+44|0;c[V>>2]=S;S=a+48|0;c[S>>2]=P;P=a+52|0;c[P>>2]=e;e=a+56|0;c[e>>2]=l;l=a+60|0;c[l>>2]=n;n=a+64|0;c[n>>2]=u;u=a+68|0;c[u>>2]=w;w=a+72|0;c[w>>2]=D;D=a+76|0;c[D>>2]=O;O=a+80|0;Kc(O,a,d);Kc(Y,Y,d+40|0);C=a+120|0;Kc(C,d+80|0,b+120|0);E=c[b+80>>2]<<1;B=c[b+84>>2]<<1;y=c[b+88>>2]<<1;v=c[b+92>>2]<<1;s=c[b+96>>2]<<1;p=c[b+100>>2]<<1;m=c[b+104>>2]<<1;j=c[b+108>>2]<<1;g=c[b+112>>2]<<1;b=c[b+116>>2]<<1;Z=c[O>>2]|0;N=a+84|0;W=c[N>>2]|0;M=a+88|0;T=c[M>>2]|0;L=a+92|0;Q=c[L>>2]|0;K=a+96|0;f=c[K>>2]|0;J=a+100|0;h=c[J>>2]|0;I=a+104|0;o=c[I>>2]|0;H=a+108|0;q=c[H>>2]|0;G=a+112|0;x=c[G>>2]|0;F=a+116|0;z=c[F>>2]|0;_=c[Y>>2]|0;X=c[V>>2]|0;U=c[S>>2]|0;R=c[P>>2]|0;d=c[e>>2]|0;i=c[l>>2]|0;k=c[n>>2]|0;r=c[u>>2]|0;t=c[w>>2]|0;A=c[D>>2]|0;c[a>>2]=Z-_;c[ha>>2]=W-X;c[ga>>2]=T-U;c[fa>>2]=Q-R;c[ea>>2]=f-d;c[da>>2]=h-i;c[ca>>2]=o-k;c[ba>>2]=q-r;c[aa>>2]=x-t;c[$>>2]=z-A;c[Y>>2]=_+Z;c[V>>2]=X+W;c[S>>2]=U+T;c[P>>2]=R+Q;c[e>>2]=d+f;c[l>>2]=i+h;c[n>>2]=k+o;c[u>>2]=r+q;c[w>>2]=t+x;c[D>>2]=A+z;D=c[C>>2]|0;z=a+124|0;A=c[z>>2]|0;w=a+128|0;x=c[w>>2]|0;t=a+132|0;u=c[t>>2]|0;q=a+136|0;r=c[q>>2]|0;n=a+140|0;o=c[n>>2]|0;k=a+144|0;l=c[k>>2]|0;h=a+148|0;i=c[h>>2]|0;e=a+152|0;f=c[e>>2]|0;a=a+156|0;d=c[a>>2]|0;c[O>>2]=D+E;c[N>>2]=A+B;c[M>>2]=x+y;c[L>>2]=u+v;c[K>>2]=r+s;c[J>>2]=o+p;c[I>>2]=l+m;c[H>>2]=i+j;c[G>>2]=f+g;c[F>>2]=d+b;c[C>>2]=E-D;c[z>>2]=B-A;c[w>>2]=y-x;c[t>>2]=v-u;c[q>>2]=s-r;c[n>>2]=p-o;c[k>>2]=m-l;c[h>>2]=j-i;c[e>>2]=g-f;c[a>>2]=b-d;return}function Qc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0;d=i;S=i=i+63&-64;i=i+48|0;Lc(a,b);aa=a+80|0;ta=b+40|0;Lc(aa,ta);v=a+120|0;ib=c[b+80>>2]|0;Sa=c[b+84>>2]|0;p=c[b+88>>2]|0;x=c[b+92>>2]|0;f=c[b+96>>2]|0;kb=c[b+100>>2]|0;_=c[b+104>>2]|0;wa=c[b+108>>2]|0;l=c[b+112>>2]|0;ua=c[b+116>>2]|0;t=ib<<1;ra=Sa<<1;cb=p<<1;g=x<<1;Ma=f<<1;e=kb<<1;va=_<<1;n=wa<<1;bb=kb*38|0;Qa=_*19|0;Q=wa*38|0;H=l*19|0;nb=ua*38|0;jb=((ib|0)<0)<<31>>31;jb=Qd(ib|0,jb|0,ib|0,jb|0)|0;ib=C;qa=((t|0)<0)<<31>>31;Ta=((Sa|0)<0)<<31>>31;$a=Qd(t|0,qa|0,Sa|0,Ta|0)|0;_a=C;r=((p|0)<0)<<31>>31;Va=Qd(p|0,r|0,t|0,qa|0)|0;Ua=C;R=((x|0)<0)<<31>>31;La=Qd(x|0,R|0,t|0,qa|0)|0;Ka=C;ka=((f|0)<0)<<31>>31;za=Qd(f|0,ka|0,t|0,qa|0)|0;ya=C;lb=((kb|0)<0)<<31>>31;K=Qd(kb|0,lb|0,t|0,qa|0)|0;M=C;j=((_|0)<0)<<31>>31;k=Qd(_|0,j|0,t|0,qa|0)|0;F=C;xa=((wa|0)<0)<<31>>31;u=Qd(wa|0,xa|0,t|0,qa|0)|0;P=C;ma=((l|0)<0)<<31>>31;W=Qd(l|0,ma|0,t|0,qa|0)|0;fa=C;oa=((ua|0)<0)<<31>>31;qa=Qd(ua|0,oa|0,t|0,qa|0)|0;t=C;pa=((ra|0)<0)<<31>>31;Ta=Qd(ra|0,pa|0,Sa|0,Ta|0)|0;Sa=C;Ja=Qd(ra|0,pa|0,p|0,r|0)|0;Ia=C;ja=((g|0)<0)<<31>>31;Da=Qd(g|0,ja|0,ra|0,pa|0)|0;Ca=C;B=Qd(f|0,ka|0,ra|0,pa|0)|0;E=C;la=((e|0)<0)<<31>>31;h=Qd(e|0,la|0,ra|0,pa|0)|0;D=C;s=Qd(_|0,j|0,ra|0,pa|0)|0;N=C;$=((n|0)<0)<<31>>31;V=Qd(n|0,$|0,ra|0,pa|0)|0;ea=C;sa=Qd(l|0,ma|0,ra|0,pa|0)|0;na=C;mb=((nb|0)<0)<<31>>31;pa=Qd(nb|0,mb|0,ra|0,pa|0)|0;ra=C;Ba=Qd(p|0,r|0,p|0,r|0)|0;Aa=C;db=((cb|0)<0)<<31>>31;G=Qd(cb|0,db|0,x|0,R|0)|0;I=C;y=Qd(f|0,ka|0,cb|0,db|0)|0;A=C;o=Qd(kb|0,lb|0,cb|0,db|0)|0;J=C;w=Qd(_|0,j|0,cb|0,db|0)|0;ba=C;Z=Qd(wa|0,xa|0,cb|0,db|0)|0;ia=C;m=((H|0)<0)<<31>>31;db=Qd(H|0,m|0,cb|0,db|0)|0;cb=C;r=Qd(nb|0,mb|0,p|0,r|0)|0;p=C;R=Qd(g|0,ja|0,x|0,R|0)|0;x=C;q=Qd(g|0,ja|0,f|0,ka|0)|0;L=C;U=Qd(e|0,la|0,g|0,ja|0)|0;da=C;X=Qd(_|0,j|0,g|0,ja|0)|0;ga=C;O=((Q|0)<0)<<31>>31;fb=Qd(Q|0,O|0,g|0,ja|0)|0;eb=C;Xa=Qd(H|0,m|0,g|0,ja|0)|0;Wa=C;ja=Qd(nb|0,mb|0,g|0,ja|0)|0;g=C;T=Qd(f|0,ka|0,f|0,ka|0)|0;ca=C;Na=((Ma|0)<0)<<31>>31;Y=Qd(Ma|0,Na|0,kb|0,lb|0)|0;ha=C;Ra=((Qa|0)<0)<<31>>31;hb=Qd(Qa|0,Ra|0,Ma|0,Na|0)|0;gb=C;Za=Qd(Q|0,O|0,f|0,ka|0)|0;Ya=C;Na=Qd(H|0,m|0,Ma|0,Na|0)|0;Ma=C;ka=Qd(nb|0,mb|0,f|0,ka|0)|0;f=C;lb=Qd(bb|0,((bb|0)<0)<<31>>31|0,kb|0,lb|0)|0;kb=C;bb=Qd(Qa|0,Ra|0,e|0,la|0)|0;ab=C;Pa=Qd(Q|0,O|0,e|0,la|0)|0;Oa=C;Fa=Qd(H|0,m|0,e|0,la|0)|0;Ea=C;la=Qd(nb|0,mb|0,e|0,la|0)|0;e=C;Ra=Qd(Qa|0,Ra|0,_|0,j|0)|0;Qa=C;Ha=Qd(Q|0,O|0,_|0,j|0)|0;Ga=C;va=Qd(H|0,m|0,va|0,((va|0)<0)<<31>>31|0)|0;z=C;j=Qd(nb|0,mb|0,_|0,j|0)|0;_=C;xa=Qd(Q|0,O|0,wa|0,xa|0)|0;wa=C;O=Qd(H|0,m|0,n|0,$|0)|0;Q=C;$=Qd(nb|0,mb|0,n|0,$|0)|0;n=C;m=Qd(H|0,m|0,l|0,ma|0)|0;H=C;ma=Qd(nb|0,mb|0,l|0,ma|0)|0;l=C;oa=Qd(nb|0,mb|0,ua|0,oa|0)|0;ua=C;ib=Fd(lb|0,kb|0,jb|0,ib|0)|0;gb=Fd(ib|0,C|0,hb|0,gb|0)|0;eb=Fd(gb|0,C|0,fb|0,eb|0)|0;cb=Fd(eb|0,C|0,db|0,cb|0)|0;ra=Fd(cb|0,C|0,pa|0,ra|0)|0;pa=C;_a=Fd(bb|0,ab|0,$a|0,_a|0)|0;Ya=Fd(_a|0,C|0,Za|0,Ya|0)|0;Wa=Fd(Ya|0,C|0,Xa|0,Wa|0)|0;p=Fd(Wa|0,C|0,r|0,p|0)|0;r=C;Sa=Fd(Va|0,Ua|0,Ta|0,Sa|0)|0;Qa=Fd(Sa|0,C|0,Ra|0,Qa|0)|0;Oa=Fd(Qa|0,C|0,Pa|0,Oa|0)|0;Ma=Fd(Oa|0,C|0,Na|0,Ma|0)|0;g=Fd(Ma|0,C|0,ja|0,g|0)|0;ja=C;Ia=Fd(La|0,Ka|0,Ja|0,Ia|0)|0;Ga=Fd(Ia|0,C|0,Ha|0,Ga|0)|0;Ea=Fd(Ga|0,C|0,Fa|0,Ea|0)|0;f=Fd(Ea|0,C|0,ka|0,f|0)|0;ka=C;Aa=Fd(Da|0,Ca|0,Ba|0,Aa|0)|0;ya=Fd(Aa|0,C|0,za|0,ya|0)|0;wa=Fd(ya|0,C|0,xa|0,wa|0)|0;z=Fd(wa|0,C|0,va|0,z|0)|0;e=Fd(z|0,C|0,la|0,e|0)|0;la=C;I=Fd(B|0,E|0,G|0,I|0)|0;M=Fd(I|0,C|0,K|0,M|0)|0;Q=Fd(M|0,C|0,O|0,Q|0)|0;_=Fd(Q|0,C|0,j|0,_|0)|0;j=C;A=Fd(R|0,x|0,y|0,A|0)|0;D=Fd(A|0,C|0,h|0,D|0)|0;F=Fd(D|0,C|0,k|0,F|0)|0;H=Fd(F|0,C|0,m|0,H|0)|0;n=Fd(H|0,C|0,$|0,n|0)|0;$=C;L=Fd(o|0,J|0,q|0,L|0)|0;N=Fd(L|0,C|0,s|0,N|0)|0;P=Fd(N|0,C|0,u|0,P|0)|0;l=Fd(P|0,C|0,ma|0,l|0)|0;ma=C;ca=Fd(w|0,ba|0,T|0,ca|0)|0;da=Fd(ca|0,C|0,U|0,da|0)|0;ea=Fd(da|0,C|0,V|0,ea|0)|0;fa=Fd(ea|0,C|0,W|0,fa|0)|0;ua=Fd(fa|0,C|0,oa|0,ua|0)|0;oa=C;ha=Fd(X|0,ga|0,Y|0,ha|0)|0;ia=Fd(ha|0,C|0,Z|0,ia|0)|0;na=Fd(ia|0,C|0,sa|0,na|0)|0;t=Fd(na|0,C|0,qa|0,t|0)|0;qa=C;pa=Jd(ra|0,pa|0,1)|0;ra=C;r=Jd(p|0,r|0,1)|0;p=C;ja=Jd(g|0,ja|0,1)|0;g=C;ka=Jd(f|0,ka|0,1)|0;f=C;la=Jd(e|0,la|0,1)|0;e=C;j=Jd(_|0,j|0,1)|0;_=C;$=Jd(n|0,$|0,1)|0;n=C;ma=Jd(l|0,ma|0,1)|0;l=C;oa=Jd(ua|0,oa|0,1)|0;ua=C;qa=Jd(t|0,qa|0,1)|0;t=C;na=Fd(pa|0,ra|0,33554432,0)|0;na=Gd(na|0,C|0,26)|0;sa=C;p=Fd(na|0,sa|0,r|0,p|0)|0;r=C;sa=Jd(na|0,sa|0,26)|0;sa=Ed(pa|0,ra|0,sa|0,C|0)|0;ra=C;pa=Fd(la|0,e|0,33554432,0)|0;pa=Gd(pa|0,C|0,26)|0;na=C;_=Fd(pa|0,na|0,j|0,_|0)|0;j=C;na=Jd(pa|0,na|0,26)|0;na=Ed(la|0,e|0,na|0,C|0)|0;e=C;la=Fd(p|0,r|0,16777216,0)|0;la=Gd(la|0,C|0,25)|0;pa=C;g=Fd(la|0,pa|0,ja|0,g|0)|0;ja=C;pa=Jd(la|0,pa|0,25)|0;pa=Ed(p|0,r|0,pa|0,C|0)|0;r=C;p=Fd(_|0,j|0,16777216,0)|0;p=Gd(p|0,C|0,25)|0;la=C;n=Fd(p|0,la|0,$|0,n|0)|0;$=C;la=Jd(p|0,la|0,25)|0;la=Ed(_|0,j|0,la|0,C|0)|0;j=C;_=Fd(g|0,ja|0,33554432,0)|0;_=Gd(_|0,C|0,26)|0;p=C;f=Fd(_|0,p|0,ka|0,f|0)|0;ka=C;p=Jd(_|0,p|0,26)|0;p=Ed(g|0,ja|0,p|0,C|0)|0;ja=Fd(n|0,$|0,33554432,0)|0;ja=Gd(ja|0,C|0,26)|0;g=C;l=Fd(ja|0,g|0,ma|0,l|0)|0;ma=C;g=Jd(ja|0,g|0,26)|0;g=Ed(n|0,$|0,g|0,C|0)|0;$=Fd(f|0,ka|0,16777216,0)|0;$=Gd($|0,C|0,25)|0;n=C;e=Fd($|0,n|0,na|0,e|0)|0;na=C;n=Jd($|0,n|0,25)|0;n=Ed(f|0,ka|0,n|0,C|0)|0;ka=Fd(l|0,ma|0,16777216,0)|0;ka=Gd(ka|0,C|0,25)|0;f=C;ua=Fd(ka|0,f|0,oa|0,ua|0)|0;oa=C;f=Jd(ka|0,f|0,25)|0;f=Ed(l|0,ma|0,f|0,C|0)|0;ma=Fd(e|0,na|0,33554432,0)|0;ma=Gd(ma|0,C|0,26)|0;l=C;j=Fd(la|0,j|0,ma|0,l|0)|0;l=Jd(ma|0,l|0,26)|0;l=Ed(e|0,na|0,l|0,C|0)|0;na=Fd(ua|0,oa|0,33554432,0)|0;na=Gd(na|0,C|0,26)|0;e=C;t=Fd(na|0,e|0,qa|0,t|0)|0;qa=C;e=Jd(na|0,e|0,26)|0;e=Ed(ua|0,oa|0,e|0,C|0)|0;oa=Fd(t|0,qa|0,16777216,0)|0;oa=Gd(oa|0,C|0,25)|0;ua=C;na=Qd(oa|0,ua|0,19,0)|0;ra=Fd(na|0,C|0,sa|0,ra|0)|0;sa=C;ua=Jd(oa|0,ua|0,25)|0;ua=Ed(t|0,qa|0,ua|0,C|0)|0;qa=Fd(ra|0,sa|0,33554432,0)|0;qa=Gd(qa|0,C|0,26)|0;t=C;r=Fd(pa|0,r|0,qa|0,t|0)|0;t=Jd(qa|0,t|0,26)|0;t=Ed(ra|0,sa|0,t|0,C|0)|0;c[v>>2]=t;t=a+124|0;c[t>>2]=r;r=a+128|0;c[r>>2]=p;p=a+132|0;c[p>>2]=n;n=a+136|0;c[n>>2]=l;l=a+140|0;c[l>>2]=j;j=a+144|0;c[j>>2]=g;g=a+148|0;c[g>>2]=f;f=a+152|0;c[f>>2]=e;e=a+156|0;c[e>>2]=ua;ua=a+40|0;sa=(c[b+44>>2]|0)+(c[b+4>>2]|0)|0;ra=(c[b+48>>2]|0)+(c[b+8>>2]|0)|0;qa=(c[b+52>>2]|0)+(c[b+12>>2]|0)|0;pa=(c[b+56>>2]|0)+(c[b+16>>2]|0)|0;oa=(c[b+60>>2]|0)+(c[b+20>>2]|0)|0;na=(c[b+64>>2]|0)+(c[b+24>>2]|0)|0;ma=(c[b+68>>2]|0)+(c[b+28>>2]|0)|0;la=(c[b+72>>2]|0)+(c[b+32>>2]|0)|0;ka=(c[b+76>>2]|0)+(c[b+36>>2]|0)|0;c[ua>>2]=(c[ta>>2]|0)+(c[b>>2]|0);ta=a+44|0;c[ta>>2]=sa;sa=a+48|0;c[sa>>2]=ra;ra=a+52|0;c[ra>>2]=qa;qa=a+56|0;c[qa>>2]=pa;pa=a+60|0;c[pa>>2]=oa;oa=a+64|0;c[oa>>2]=na;na=a+68|0;c[na>>2]=ma;ma=a+72|0;c[ma>>2]=la;la=a+76|0;c[la>>2]=ka;Lc(S,ua);ka=c[aa>>2]|0;$=a+84|0;ja=c[$>>2]|0;_=a+88|0;ia=c[_>>2]|0;Z=a+92|0;ha=c[Z>>2]|0;Y=a+96|0;ga=c[Y>>2]|0;X=a+100|0;fa=c[X>>2]|0;W=a+104|0;ea=c[W>>2]|0;V=a+108|0;da=c[V>>2]|0;U=a+112|0;ca=c[U>>2]|0;T=a+116|0;ba=c[T>>2]|0;w=c[a>>2]|0;P=a+4|0;u=c[P>>2]|0;N=a+8|0;s=c[N>>2]|0;L=a+12|0;q=c[L>>2]|0;J=a+16|0;o=c[J>>2]|0;H=a+20|0;m=c[H>>2]|0;F=a+24|0;k=c[F>>2]|0;D=a+28|0;h=c[D>>2]|0;A=a+32|0;b=c[A>>2]|0;y=a+36|0;x=c[y>>2]|0;R=w+ka|0;Q=u+ja|0;O=s+ia|0;M=q+ha|0;K=o+ga|0;I=m+fa|0;G=k+ea|0;E=h+da|0;B=b+ca|0;z=x+ba|0;c[ua>>2]=R;c[ta>>2]=Q;c[sa>>2]=O;c[ra>>2]=M;c[qa>>2]=K;c[pa>>2]=I;c[oa>>2]=G;c[na>>2]=E;c[ma>>2]=B;c[la>>2]=z;w=ka-w|0;u=ja-u|0;s=ia-s|0;q=ha-q|0;o=ga-o|0;m=fa-m|0;k=ea-k|0;h=da-h|0;b=ca-b|0;x=ba-x|0;c[aa>>2]=w;c[$>>2]=u;c[_>>2]=s;c[Z>>2]=q;c[Y>>2]=o;c[X>>2]=m;c[W>>2]=k;c[V>>2]=h;c[U>>2]=b;c[T>>2]=x;Q=(c[S+4>>2]|0)-Q|0;O=(c[S+8>>2]|0)-O|0;M=(c[S+12>>2]|0)-M|0;K=(c[S+16>>2]|0)-K|0;I=(c[S+20>>2]|0)-I|0;G=(c[S+24>>2]|0)-G|0;E=(c[S+28>>2]|0)-E|0;B=(c[S+32>>2]|0)-B|0;z=(c[S+36>>2]|0)-z|0;c[a>>2]=(c[S>>2]|0)-R;c[P>>2]=Q;c[N>>2]=O;c[L>>2]=M;c[J>>2]=K;c[H>>2]=I;c[F>>2]=G;c[D>>2]=E;c[A>>2]=B;c[y>>2]=z;u=(c[t>>2]|0)-u|0;s=(c[r>>2]|0)-s|0;q=(c[p>>2]|0)-q|0;o=(c[n>>2]|0)-o|0;m=(c[l>>2]|0)-m|0;k=(c[j>>2]|0)-k|0;h=(c[g>>2]|0)-h|0;b=(c[f>>2]|0)-b|0;a=(c[e>>2]|0)-x|0;c[v>>2]=(c[v>>2]|0)-w;c[t>>2]=u;c[r>>2]=s;c[p>>2]=q;c[n>>2]=o;c[l>>2]=m;c[j>>2]=k;c[g>>2]=h;c[f>>2]=b;c[e>>2]=a;i=d;return}function Rc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;m=b+40|0;v=b+44|0;u=b+48|0;t=b+52|0;s=b+56|0;r=b+60|0;q=b+64|0;p=b+68|0;o=b+72|0;n=b+76|0;d=b+4|0;e=b+8|0;f=b+12|0;g=b+16|0;h=b+20|0;i=b+24|0;j=b+28|0;k=b+32|0;l=b+36|0;E=(c[d>>2]|0)+(c[v>>2]|0)|0;D=(c[e>>2]|0)+(c[u>>2]|0)|0;C=(c[f>>2]|0)+(c[t>>2]|0)|0;B=(c[g>>2]|0)+(c[s>>2]|0)|0;A=(c[h>>2]|0)+(c[r>>2]|0)|0;z=(c[i>>2]|0)+(c[q>>2]|0)|0;y=(c[j>>2]|0)+(c[p>>2]|0)|0;x=(c[k>>2]|0)+(c[o>>2]|0)|0;w=(c[l>>2]|0)+(c[n>>2]|0)|0;c[a>>2]=(c[b>>2]|0)+(c[m>>2]|0);c[a+4>>2]=E;c[a+8>>2]=D;c[a+12>>2]=C;c[a+16>>2]=B;c[a+20>>2]=A;c[a+24>>2]=z;c[a+28>>2]=y;c[a+32>>2]=x;c[a+36>>2]=w;d=(c[v>>2]|0)-(c[d>>2]|0)|0;e=(c[u>>2]|0)-(c[e>>2]|0)|0;f=(c[t>>2]|0)-(c[f>>2]|0)|0;g=(c[s>>2]|0)-(c[g>>2]|0)|0;h=(c[r>>2]|0)-(c[h>>2]|0)|0;i=(c[q>>2]|0)-(c[i>>2]|0)|0;j=(c[p>>2]|0)-(c[j>>2]|0)|0;k=(c[o>>2]|0)-(c[k>>2]|0)|0;l=(c[n>>2]|0)-(c[l>>2]|0)|0;c[a+40>>2]=(c[m>>2]|0)-(c[b>>2]|0);c[a+44>>2]=d;c[a+48>>2]=e;c[a+52>>2]=f;c[a+56>>2]=g;c[a+60>>2]=h;c[a+64>>2]=i;c[a+68>>2]=j;c[a+72>>2]=k;c[a+76>>2]=l;l=c[b+84>>2]|0;k=c[b+88>>2]|0;j=c[b+92>>2]|0;i=c[b+96>>2]|0;h=c[b+100>>2]|0;g=c[b+104>>2]|0;f=c[b+108>>2]|0;e=c[b+112>>2]|0;d=c[b+116>>2]|0;c[a+80>>2]=c[b+80>>2];c[a+84>>2]=l;c[a+88>>2]=k;c[a+92>>2]=j;c[a+96>>2]=i;c[a+100>>2]=h;c[a+104>>2]=g;c[a+108>>2]=f;c[a+112>>2]=e;c[a+116>>2]=d;Kc(a+120|0,b+120|0,1144);return}function Sc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;u=i;t=i=i+63&-64;i=i+592|0;p=t+400|0;r=t+520|0;s=t+240|0;q=t+120|0;f=0;do{n=a[e+f>>0]|0;o=f<<1;a[r+o>>0]=n&15;a[r+(o|1)>>0]=(n&255)>>>4;f=f+1|0}while((f|0)!=32);e=0;f=0;do{o=r+f|0;n=(d[o>>0]|0)+e|0;e=(n<<24)+134217728>>28;a[o>>0]=n-(e<<4);f=f+1|0}while((f|0)!=63);f=r+63|0;a[f>>0]=(d[f>>0]|0)+e;f=b;e=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(e|0));j=b+40|0;c[j>>2]=1;g=b+44|0;f=g;e=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(e|0));k=b+80|0;c[k>>2]=1;h=b+84|0;l=b+120|0;m=s+120|0;n=s+40|0;o=s+80|0;f=h;e=f+76|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(e|0));f=1;do{Tc(t,(f|0)/2|0,a[r+f>>0]|0);Pc(s,b,t);Kc(b,s,m);Kc(j,n,o);Kc(k,o,m);Kc(l,s,n);f=f+2|0}while((f|0)<64);B=c[b+4>>2]|0;z=c[b+8>>2]|0;y=c[b+12>>2]|0;x=c[b+16>>2]|0;w=c[b+20>>2]|0;v=c[b+24>>2]|0;e=c[b+28>>2]|0;f=c[b+32>>2]|0;A=c[b+36>>2]|0;c[p>>2]=c[b>>2];c[p+4>>2]=B;c[p+8>>2]=z;c[p+12>>2]=y;c[p+16>>2]=x;c[p+20>>2]=w;c[p+24>>2]=v;c[p+28>>2]=e;c[p+32>>2]=f;c[p+36>>2]=A;A=c[g>>2]|0;f=c[b+48>>2]|0;g=c[b+52>>2]|0;e=c[b+56>>2]|0;v=c[b+60>>2]|0;w=c[b+64>>2]|0;x=c[b+68>>2]|0;y=c[b+72>>2]|0;z=c[b+76>>2]|0;c[p+40>>2]=c[j>>2];c[p+44>>2]=A;c[p+48>>2]=f;c[p+52>>2]=g;c[p+56>>2]=e;c[p+60>>2]=v;c[p+64>>2]=w;c[p+68>>2]=x;c[p+72>>2]=y;c[p+76>>2]=z;z=c[h>>2]|0;y=c[b+88>>2]|0;x=c[b+92>>2]|0;w=c[b+96>>2]|0;v=c[b+100>>2]|0;e=c[b+104>>2]|0;g=c[b+108>>2]|0;h=c[b+112>>2]|0;f=c[b+116>>2]|0;c[p+80>>2]=c[k>>2];c[p+84>>2]=z;c[p+88>>2]=y;c[p+92>>2]=x;c[p+96>>2]=w;c[p+100>>2]=v;c[p+104>>2]=e;c[p+108>>2]=g;c[p+112>>2]=h;c[p+116>>2]=f;Qc(s,p);Kc(q,s,m);p=q+40|0;Kc(p,n,o);f=q+80|0;Kc(f,o,m);Qc(s,q);Kc(q,s,m);Kc(p,n,o);Kc(f,o,m);Qc(s,q);Kc(q,s,m);Kc(p,n,o);Kc(f,o,m);Qc(s,q);Kc(b,s,m);Kc(j,n,o);Kc(k,o,m);Kc(l,s,n);f=0;do{Tc(t,(f|0)/2|0,a[r+f>>0]|0);Pc(s,b,t);Kc(b,s,m);Kc(j,n,o);Kc(k,o,m);Kc(l,s,n);f=f+2|0}while((f|0)<64);i=u;return}function Tc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0;s=d<<24>>24;s=Id(s|0,((s|0)<0)<<31>>31|0,63)|0;h=d<<24>>24;s=0-s|0;d=a+4|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;c[d+28>>2]=0;e=a+40|0;c[e>>2]=1;f=a+44|0;g=a+80|0;h=h-((h&s)<<1)&255;i=(h^1)+-1|0;j=1184+(b*960|0)|0;k=a+8|0;l=a+12|0;m=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+32|0;r=a+36|0;t=f;u=t+76|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));H=i>>31;A=c[1184+(b*960|0)+4>>2]&H;I=c[1184+(b*960|0)+8>>2]&H;K=c[1184+(b*960|0)+12>>2]&H;M=c[1184+(b*960|0)+16>>2]&H;O=c[1184+(b*960|0)+20>>2]&H;Q=c[1184+(b*960|0)+24>>2]&H;S=c[1184+(b*960|0)+28>>2]&H;U=c[1184+(b*960|0)+32>>2]&H;W=c[1184+(b*960|0)+36>>2]&H;c[a>>2]=(c[j>>2]^1)&H^1;c[d>>2]=A;c[k>>2]=I;c[l>>2]=K;c[m>>2]=M;c[n>>2]=O;c[o>>2]=Q;c[p>>2]=S;c[q>>2]=U;c[r>>2]=W;W=a+48|0;U=a+52|0;S=a+56|0;Q=a+60|0;O=a+64|0;M=a+68|0;K=a+72|0;I=a+76|0;A=c[1184+(b*960|0)+44>>2]&H;z=c[1184+(b*960|0)+48>>2]&H;w=c[1184+(b*960|0)+52>>2]&H;B=c[1184+(b*960|0)+56>>2]&H;ia=c[1184+(b*960|0)+60>>2]&H;D=c[1184+(b*960|0)+64>>2]&H;ea=c[1184+(b*960|0)+68>>2]&H;F=c[1184+(b*960|0)+72>>2]&H;ga=c[1184+(b*960|0)+76>>2]&H;c[e>>2]=(c[1184+(b*960|0)+40>>2]^1)&H^1;c[f>>2]=A;c[W>>2]=z;c[U>>2]=w;c[S>>2]=B;c[Q>>2]=ia;c[O>>2]=D;c[M>>2]=ea;c[K>>2]=F;c[I>>2]=ga;ga=c[g>>2]|0;F=a+84|0;ea=c[F>>2]|0;D=a+88|0;ia=c[D>>2]|0;B=a+92|0;w=c[B>>2]|0;z=a+96|0;A=c[z>>2]|0;x=a+100|0;fa=c[x>>2]|0;v=a+104|0;ba=c[v>>2]|0;i=a+108|0;G=c[i>>2]|0;t=a+112|0;_=c[t>>2]|0;u=a+116|0;da=c[u>>2]|0;$=(c[1184+(b*960|0)+84>>2]^ea)&H;aa=(c[1184+(b*960|0)+88>>2]^ia)&H;y=(c[1184+(b*960|0)+92>>2]^w)&H;j=(c[1184+(b*960|0)+96>>2]^A)&H;ha=(c[1184+(b*960|0)+100>>2]^fa)&H;Z=(c[1184+(b*960|0)+104>>2]^ba)&H;ca=(c[1184+(b*960|0)+108>>2]^G)&H;C=(c[1184+(b*960|0)+112>>2]^_)&H;E=(c[1184+(b*960|0)+116>>2]^da)&H;c[g>>2]=(c[1184+(b*960|0)+80>>2]^ga)&H^ga;c[F>>2]=$^ea;c[D>>2]=aa^ia;c[B>>2]=y^w;c[z>>2]=j^A;c[x>>2]=ha^fa;c[v>>2]=Z^ba;c[i>>2]=ca^G;c[t>>2]=C^_;c[u>>2]=E^da;da=c[a>>2]|0;E=c[d>>2]|0;_=c[k>>2]|0;C=c[l>>2]|0;G=c[m>>2]|0;ca=c[n>>2]|0;ba=c[o>>2]|0;Z=c[p>>2]|0;fa=c[q>>2]|0;ha=c[r>>2]|0;A=(h^2)+-1>>31;j=(c[1184+(b*960|0)+124>>2]^E)&A;w=(c[1184+(b*960|0)+128>>2]^_)&A;y=(c[1184+(b*960|0)+132>>2]^C)&A;ia=(c[1184+(b*960|0)+136>>2]^G)&A;aa=(c[1184+(b*960|0)+140>>2]^ca)&A;ea=(c[1184+(b*960|0)+144>>2]^ba)&A;$=(c[1184+(b*960|0)+148>>2]^Z)&A;ga=(c[1184+(b*960|0)+152>>2]^fa)&A;H=(c[1184+(b*960|0)+156>>2]^ha)&A;c[a>>2]=(c[1184+(b*960|0)+120>>2]^da)&A^da;c[d>>2]=j^E;c[k>>2]=w^_;c[l>>2]=y^C;c[m>>2]=ia^G;c[n>>2]=aa^ca;c[o>>2]=ea^ba;c[p>>2]=$^Z;c[q>>2]=ga^fa;c[r>>2]=H^ha;ha=c[e>>2]|0;H=c[f>>2]|0;fa=c[W>>2]|0;ga=c[U>>2]|0;Z=c[S>>2]|0;$=c[Q>>2]|0;ba=c[O>>2]|0;ea=c[M>>2]|0;ca=c[K>>2]|0;aa=c[I>>2]|0;G=(c[1184+(b*960|0)+164>>2]^H)&A;ia=(c[1184+(b*960|0)+168>>2]^fa)&A;C=(c[1184+(b*960|0)+172>>2]^ga)&A;y=(c[1184+(b*960|0)+176>>2]^Z)&A;_=(c[1184+(b*960|0)+180>>2]^$)&A;w=(c[1184+(b*960|0)+184>>2]^ba)&A;E=(c[1184+(b*960|0)+188>>2]^ea)&A;j=(c[1184+(b*960|0)+192>>2]^ca)&A;da=(c[1184+(b*960|0)+196>>2]^aa)&A;c[e>>2]=(c[1184+(b*960|0)+160>>2]^ha)&A^ha;c[f>>2]=G^H;c[W>>2]=ia^fa;c[U>>2]=C^ga;c[S>>2]=y^Z;c[Q>>2]=_^$;c[O>>2]=w^ba;c[M>>2]=E^ea;c[K>>2]=j^ca;c[I>>2]=da^aa;aa=c[g>>2]|0;da=c[F>>2]|0;ca=c[D>>2]|0;j=c[B>>2]|0;ea=c[z>>2]|0;E=c[x>>2]|0;ba=c[v>>2]|0;w=c[i>>2]|0;$=c[t>>2]|0;_=c[u>>2]|0;Z=(c[1184+(b*960|0)+204>>2]^da)&A;y=(c[1184+(b*960|0)+208>>2]^ca)&A;ga=(c[1184+(b*960|0)+212>>2]^j)&A;C=(c[1184+(b*960|0)+216>>2]^ea)&A;fa=(c[1184+(b*960|0)+220>>2]^E)&A;ia=(c[1184+(b*960|0)+224>>2]^ba)&A;H=(c[1184+(b*960|0)+228>>2]^w)&A;G=(c[1184+(b*960|0)+232>>2]^$)&A;ha=(c[1184+(b*960|0)+236>>2]^_)&A;c[g>>2]=(c[1184+(b*960|0)+200>>2]^aa)&A^aa;c[F>>2]=Z^da;c[D>>2]=y^ca;c[B>>2]=ga^j;c[z>>2]=C^ea;c[x>>2]=fa^E;c[v>>2]=ia^ba;c[i>>2]=H^w;c[t>>2]=G^$;c[u>>2]=ha^_;_=c[a>>2]|0;ha=c[d>>2]|0;$=c[k>>2]|0;G=c[l>>2]|0;w=c[m>>2]|0;H=c[n>>2]|0;ba=c[o>>2]|0;ia=c[p>>2]|0;E=c[q>>2]|0;fa=c[r>>2]|0;ea=(h^3)+-1>>31;C=(c[1184+(b*960|0)+244>>2]^ha)&ea;j=(c[1184+(b*960|0)+248>>2]^$)&ea;ga=(c[1184+(b*960|0)+252>>2]^G)&ea;ca=(c[1184+(b*960|0)+256>>2]^w)&ea;y=(c[1184+(b*960|0)+260>>2]^H)&ea;da=(c[1184+(b*960|0)+264>>2]^ba)&ea;Z=(c[1184+(b*960|0)+268>>2]^ia)&ea;aa=(c[1184+(b*960|0)+272>>2]^E)&ea;A=(c[1184+(b*960|0)+276>>2]^fa)&ea;c[a>>2]=(c[1184+(b*960|0)+240>>2]^_)&ea^_;c[d>>2]=C^ha;c[k>>2]=j^$;c[l>>2]=ga^G;c[m>>2]=ca^w;c[n>>2]=y^H;c[o>>2]=da^ba;c[p>>2]=Z^ia;c[q>>2]=aa^E;c[r>>2]=A^fa;fa=c[e>>2]|0;A=c[f>>2]|0;E=c[W>>2]|0;aa=c[U>>2]|0;ia=c[S>>2]|0;Z=c[Q>>2]|0;ba=c[O>>2]|0;da=c[M>>2]|0;H=c[K>>2]|0;y=c[I>>2]|0;w=(c[1184+(b*960|0)+284>>2]^A)&ea;ca=(c[1184+(b*960|0)+288>>2]^E)&ea;G=(c[1184+(b*960|0)+292>>2]^aa)&ea;ga=(c[1184+(b*960|0)+296>>2]^ia)&ea;$=(c[1184+(b*960|0)+300>>2]^Z)&ea;j=(c[1184+(b*960|0)+304>>2]^ba)&ea;ha=(c[1184+(b*960|0)+308>>2]^da)&ea;C=(c[1184+(b*960|0)+312>>2]^H)&ea;_=(c[1184+(b*960|0)+316>>2]^y)&ea;c[e>>2]=(c[1184+(b*960|0)+280>>2]^fa)&ea^fa;c[f>>2]=w^A;c[W>>2]=ca^E;c[U>>2]=G^aa;c[S>>2]=ga^ia;c[Q>>2]=$^Z;c[O>>2]=j^ba;c[M>>2]=ha^da;c[K>>2]=C^H;c[I>>2]=_^y;y=c[g>>2]|0;_=c[F>>2]|0;H=c[D>>2]|0;C=c[B>>2]|0;da=c[z>>2]|0;ha=c[x>>2]|0;ba=c[v>>2]|0;j=c[i>>2]|0;Z=c[t>>2]|0;$=c[u>>2]|0;ia=(c[1184+(b*960|0)+324>>2]^_)&ea;ga=(c[1184+(b*960|0)+328>>2]^H)&ea;aa=(c[1184+(b*960|0)+332>>2]^C)&ea;G=(c[1184+(b*960|0)+336>>2]^da)&ea;E=(c[1184+(b*960|0)+340>>2]^ha)&ea;ca=(c[1184+(b*960|0)+344>>2]^ba)&ea;A=(c[1184+(b*960|0)+348>>2]^j)&ea;w=(c[1184+(b*960|0)+352>>2]^Z)&ea;fa=(c[1184+(b*960|0)+356>>2]^$)&ea;c[g>>2]=(c[1184+(b*960|0)+320>>2]^y)&ea^y;c[F>>2]=ia^_;c[D>>2]=ga^H;c[B>>2]=aa^C;c[z>>2]=G^da;c[x>>2]=E^ha;c[v>>2]=ca^ba;c[i>>2]=A^j;c[t>>2]=w^Z;c[u>>2]=fa^$;$=c[a>>2]|0;fa=c[d>>2]|0;Z=c[k>>2]|0;w=c[l>>2]|0;j=c[m>>2]|0;A=c[n>>2]|0;ba=c[o>>2]|0;ca=c[p>>2]|0;ha=c[q>>2]|0;E=c[r>>2]|0;da=(h^4)+-1>>31;G=(c[1184+(b*960|0)+364>>2]^fa)&da;C=(c[1184+(b*960|0)+368>>2]^Z)&da;aa=(c[1184+(b*960|0)+372>>2]^w)&da;H=(c[1184+(b*960|0)+376>>2]^j)&da;ga=(c[1184+(b*960|0)+380>>2]^A)&da;_=(c[1184+(b*960|0)+384>>2]^ba)&da;ia=(c[1184+(b*960|0)+388>>2]^ca)&da;y=(c[1184+(b*960|0)+392>>2]^ha)&da;ea=(c[1184+(b*960|0)+396>>2]^E)&da;c[a>>2]=(c[1184+(b*960|0)+360>>2]^$)&da^$;c[d>>2]=G^fa;c[k>>2]=C^Z;c[l>>2]=aa^w;c[m>>2]=H^j;c[n>>2]=ga^A;c[o>>2]=_^ba;c[p>>2]=ia^ca;c[q>>2]=y^ha;c[r>>2]=ea^E;E=c[e>>2]|0;ea=c[f>>2]|0;ha=c[W>>2]|0;y=c[U>>2]|0;ca=c[S>>2]|0;ia=c[Q>>2]|0;ba=c[O>>2]|0;_=c[M>>2]|0;A=c[K>>2]|0;ga=c[I>>2]|0;j=(c[1184+(b*960|0)+404>>2]^ea)&da;H=(c[1184+(b*960|0)+408>>2]^ha)&da;w=(c[1184+(b*960|0)+412>>2]^y)&da;aa=(c[1184+(b*960|0)+416>>2]^ca)&da;Z=(c[1184+(b*960|0)+420>>2]^ia)&da;C=(c[1184+(b*960|0)+424>>2]^ba)&da;fa=(c[1184+(b*960|0)+428>>2]^_)&da;G=(c[1184+(b*960|0)+432>>2]^A)&da;$=(c[1184+(b*960|0)+436>>2]^ga)&da;c[e>>2]=(c[1184+(b*960|0)+400>>2]^E)&da^E;c[f>>2]=j^ea;c[W>>2]=H^ha;c[U>>2]=w^y;c[S>>2]=aa^ca;c[Q>>2]=Z^ia;c[O>>2]=C^ba;c[M>>2]=fa^_;c[K>>2]=G^A;c[I>>2]=$^ga;ga=c[g>>2]|0;$=c[F>>2]|0;A=c[D>>2]|0;G=c[B>>2]|0;_=c[z>>2]|0;fa=c[x>>2]|0;ba=c[v>>2]|0;C=c[i>>2]|0;ia=c[t>>2]|0;Z=c[u>>2]|0;ca=(c[1184+(b*960|0)+444>>2]^$)&da;aa=(c[1184+(b*960|0)+448>>2]^A)&da;y=(c[1184+(b*960|0)+452>>2]^G)&da;w=(c[1184+(b*960|0)+456>>2]^_)&da;ha=(c[1184+(b*960|0)+460>>2]^fa)&da;H=(c[1184+(b*960|0)+464>>2]^ba)&da;ea=(c[1184+(b*960|0)+468>>2]^C)&da;j=(c[1184+(b*960|0)+472>>2]^ia)&da;E=(c[1184+(b*960|0)+476>>2]^Z)&da;c[g>>2]=(c[1184+(b*960|0)+440>>2]^ga)&da^ga;c[F>>2]=ca^$;c[D>>2]=aa^A;c[B>>2]=y^G;c[z>>2]=w^_;c[x>>2]=ha^fa;c[v>>2]=H^ba;c[i>>2]=ea^C;c[t>>2]=j^ia;c[u>>2]=E^Z;Z=c[a>>2]|0;E=c[d>>2]|0;ia=c[k>>2]|0;j=c[l>>2]|0;C=c[m>>2]|0;ea=c[n>>2]|0;ba=c[o>>2]|0;H=c[p>>2]|0;fa=c[q>>2]|0;ha=c[r>>2]|0;_=(h^5)+-1>>31;w=(c[1184+(b*960|0)+484>>2]^E)&_;G=(c[1184+(b*960|0)+488>>2]^ia)&_;y=(c[1184+(b*960|0)+492>>2]^j)&_;A=(c[1184+(b*960|0)+496>>2]^C)&_;aa=(c[1184+(b*960|0)+500>>2]^ea)&_;$=(c[1184+(b*960|0)+504>>2]^ba)&_;ca=(c[1184+(b*960|0)+508>>2]^H)&_;ga=(c[1184+(b*960|0)+512>>2]^fa)&_;da=(c[1184+(b*960|0)+516>>2]^ha)&_;c[a>>2]=(c[1184+(b*960|0)+480>>2]^Z)&_^Z;c[d>>2]=w^E;c[k>>2]=G^ia;c[l>>2]=y^j;c[m>>2]=A^C;c[n>>2]=aa^ea;c[o>>2]=$^ba;c[p>>2]=ca^H;c[q>>2]=ga^fa;c[r>>2]=da^ha;ha=c[e>>2]|0;da=c[f>>2]|0;fa=c[W>>2]|0;ga=c[U>>2]|0;H=c[S>>2]|0;ca=c[Q>>2]|0;ba=c[O>>2]|0;$=c[M>>2]|0;ea=c[K>>2]|0;aa=c[I>>2]|0;C=(c[1184+(b*960|0)+524>>2]^da)&_;A=(c[1184+(b*960|0)+528>>2]^fa)&_;j=(c[1184+(b*960|0)+532>>2]^ga)&_;y=(c[1184+(b*960|0)+536>>2]^H)&_;ia=(c[1184+(b*960|0)+540>>2]^ca)&_;G=(c[1184+(b*960|0)+544>>2]^ba)&_;E=(c[1184+(b*960|0)+548>>2]^$)&_;w=(c[1184+(b*960|0)+552>>2]^ea)&_;Z=(c[1184+(b*960|0)+556>>2]^aa)&_;c[e>>2]=(c[1184+(b*960|0)+520>>2]^ha)&_^ha;c[f>>2]=C^da;c[W>>2]=A^fa;c[U>>2]=j^ga;c[S>>2]=y^H;c[Q>>2]=ia^ca;c[O>>2]=G^ba;c[M>>2]=E^$;c[K>>2]=w^ea;c[I>>2]=Z^aa;aa=c[g>>2]|0;Z=c[F>>2]|0;ea=c[D>>2]|0;w=c[B>>2]|0;$=c[z>>2]|0;E=c[x>>2]|0;ba=c[v>>2]|0;G=c[i>>2]|0;ca=c[t>>2]|0;ia=c[u>>2]|0;H=(c[1184+(b*960|0)+564>>2]^Z)&_;y=(c[1184+(b*960|0)+568>>2]^ea)&_;ga=(c[1184+(b*960|0)+572>>2]^w)&_;j=(c[1184+(b*960|0)+576>>2]^$)&_;fa=(c[1184+(b*960|0)+580>>2]^E)&_;A=(c[1184+(b*960|0)+584>>2]^ba)&_;da=(c[1184+(b*960|0)+588>>2]^G)&_;C=(c[1184+(b*960|0)+592>>2]^ca)&_;ha=(c[1184+(b*960|0)+596>>2]^ia)&_;c[g>>2]=(c[1184+(b*960|0)+560>>2]^aa)&_^aa;c[F>>2]=H^Z;c[D>>2]=y^ea;c[B>>2]=ga^w;c[z>>2]=j^$;c[x>>2]=fa^E;c[v>>2]=A^ba;c[i>>2]=da^G;c[t>>2]=C^ca;c[u>>2]=ha^ia;ia=c[a>>2]|0;ha=c[d>>2]|0;ca=c[k>>2]|0;C=c[l>>2]|0;G=c[m>>2]|0;da=c[n>>2]|0;ba=c[o>>2]|0;A=c[p>>2]|0;E=c[q>>2]|0;fa=c[r>>2]|0;$=(h^6)+-1>>31;j=(c[1184+(b*960|0)+604>>2]^ha)&$;w=(c[1184+(b*960|0)+608>>2]^ca)&$;ga=(c[1184+(b*960|0)+612>>2]^C)&$;ea=(c[1184+(b*960|0)+616>>2]^G)&$;y=(c[1184+(b*960|0)+620>>2]^da)&$;Z=(c[1184+(b*960|0)+624>>2]^ba)&$;H=(c[1184+(b*960|0)+628>>2]^A)&$;aa=(c[1184+(b*960|0)+632>>2]^E)&$;_=(c[1184+(b*960|0)+636>>2]^fa)&$;c[a>>2]=(c[1184+(b*960|0)+600>>2]^ia)&$^ia;c[d>>2]=j^ha;c[k>>2]=w^ca;c[l>>2]=ga^C;c[m>>2]=ea^G;c[n>>2]=y^da;c[o>>2]=Z^ba;c[p>>2]=H^A;c[q>>2]=aa^E;c[r>>2]=_^fa;fa=c[e>>2]|0;_=c[f>>2]|0;E=c[W>>2]|0;aa=c[U>>2]|0;A=c[S>>2]|0;H=c[Q>>2]|0;ba=c[O>>2]|0;Z=c[M>>2]|0;da=c[K>>2]|0;y=c[I>>2]|0;G=(c[1184+(b*960|0)+644>>2]^_)&$;ea=(c[1184+(b*960|0)+648>>2]^E)&$;C=(c[1184+(b*960|0)+652>>2]^aa)&$;ga=(c[1184+(b*960|0)+656>>2]^A)&$;ca=(c[1184+(b*960|0)+660>>2]^H)&$;w=(c[1184+(b*960|0)+664>>2]^ba)&$;ha=(c[1184+(b*960|0)+668>>2]^Z)&$;j=(c[1184+(b*960|0)+672>>2]^da)&$;ia=(c[1184+(b*960|0)+676>>2]^y)&$;c[e>>2]=(c[1184+(b*960|0)+640>>2]^fa)&$^fa;c[f>>2]=G^_;c[W>>2]=ea^E;c[U>>2]=C^aa;c[S>>2]=ga^A;c[Q>>2]=ca^H;c[O>>2]=w^ba;c[M>>2]=ha^Z;c[K>>2]=j^da;c[I>>2]=ia^y;y=c[g>>2]|0;ia=c[F>>2]|0;da=c[D>>2]|0;j=c[B>>2]|0;Z=c[z>>2]|0;ha=c[x>>2]|0;ba=c[v>>2]|0;w=c[i>>2]|0;H=c[t>>2]|0;ca=c[u>>2]|0;A=(c[1184+(b*960|0)+684>>2]^ia)&$;ga=(c[1184+(b*960|0)+688>>2]^da)&$;aa=(c[1184+(b*960|0)+692>>2]^j)&$;C=(c[1184+(b*960|0)+696>>2]^Z)&$;E=(c[1184+(b*960|0)+700>>2]^ha)&$;ea=(c[1184+(b*960|0)+704>>2]^ba)&$;_=(c[1184+(b*960|0)+708>>2]^w)&$;G=(c[1184+(b*960|0)+712>>2]^H)&$;fa=(c[1184+(b*960|0)+716>>2]^ca)&$;c[g>>2]=(c[1184+(b*960|0)+680>>2]^y)&$^y;c[F>>2]=A^ia;c[D>>2]=ga^da;c[B>>2]=aa^j;c[z>>2]=C^Z;c[x>>2]=E^ha;c[v>>2]=ea^ba;c[i>>2]=_^w;c[t>>2]=G^H;c[u>>2]=fa^ca;ca=c[a>>2]|0;fa=c[d>>2]|0;H=c[k>>2]|0;G=c[l>>2]|0;w=c[m>>2]|0;_=c[n>>2]|0;ba=c[o>>2]|0;ea=c[p>>2]|0;ha=c[q>>2]|0;E=c[r>>2]|0;Z=(h^7)+-1>>31;C=(c[1184+(b*960|0)+724>>2]^fa)&Z;j=(c[1184+(b*960|0)+728>>2]^H)&Z;aa=(c[1184+(b*960|0)+732>>2]^G)&Z;da=(c[1184+(b*960|0)+736>>2]^w)&Z;ga=(c[1184+(b*960|0)+740>>2]^_)&Z;ia=(c[1184+(b*960|0)+744>>2]^ba)&Z;A=(c[1184+(b*960|0)+748>>2]^ea)&Z;y=(c[1184+(b*960|0)+752>>2]^ha)&Z;$=(c[1184+(b*960|0)+756>>2]^E)&Z;c[a>>2]=(c[1184+(b*960|0)+720>>2]^ca)&Z^ca;c[d>>2]=C^fa;c[k>>2]=j^H;c[l>>2]=aa^G;c[m>>2]=da^w;c[n>>2]=ga^_;c[o>>2]=ia^ba;c[p>>2]=A^ea;c[q>>2]=y^ha;c[r>>2]=$^E;E=c[e>>2]|0;$=c[f>>2]|0;ha=c[W>>2]|0;y=c[U>>2]|0;ea=c[S>>2]|0;A=c[Q>>2]|0;ba=c[O>>2]|0;ia=c[M>>2]|0;_=c[K>>2]|0;ga=c[I>>2]|0;w=(c[1184+(b*960|0)+764>>2]^$)&Z;da=(c[1184+(b*960|0)+768>>2]^ha)&Z;G=(c[1184+(b*960|0)+772>>2]^y)&Z;aa=(c[1184+(b*960|0)+776>>2]^ea)&Z;H=(c[1184+(b*960|0)+780>>2]^A)&Z;j=(c[1184+(b*960|0)+784>>2]^ba)&Z;fa=(c[1184+(b*960|0)+788>>2]^ia)&Z;C=(c[1184+(b*960|0)+792>>2]^_)&Z;ca=(c[1184+(b*960|0)+796>>2]^ga)&Z;c[e>>2]=(c[1184+(b*960|0)+760>>2]^E)&Z^E;c[f>>2]=w^$;c[W>>2]=da^ha;c[U>>2]=G^y;c[S>>2]=aa^ea;c[Q>>2]=H^A;c[O>>2]=j^ba;c[M>>2]=fa^ia;c[K>>2]=C^_;c[I>>2]=ca^ga;ga=c[g>>2]|0;ca=c[F>>2]|0;_=c[D>>2]|0;C=c[B>>2]|0;ia=c[z>>2]|0;fa=c[x>>2]|0;ba=c[v>>2]|0;j=c[i>>2]|0;A=c[t>>2]|0;H=c[u>>2]|0;ea=(c[1184+(b*960|0)+804>>2]^ca)&Z;aa=(c[1184+(b*960|0)+808>>2]^_)&Z;y=(c[1184+(b*960|0)+812>>2]^C)&Z;G=(c[1184+(b*960|0)+816>>2]^ia)&Z;ha=(c[1184+(b*960|0)+820>>2]^fa)&Z;da=(c[1184+(b*960|0)+824>>2]^ba)&Z;$=(c[1184+(b*960|0)+828>>2]^j)&Z;w=(c[1184+(b*960|0)+832>>2]^A)&Z;E=(c[1184+(b*960|0)+836>>2]^H)&Z;c[g>>2]=(c[1184+(b*960|0)+800>>2]^ga)&Z^ga;c[F>>2]=ea^ca;c[D>>2]=aa^_;c[B>>2]=y^C;c[z>>2]=G^ia;c[x>>2]=ha^fa;c[v>>2]=da^ba;c[i>>2]=$^j;c[t>>2]=w^A;c[u>>2]=E^H;H=c[a>>2]|0;E=c[d>>2]|0;A=c[k>>2]|0;w=c[l>>2]|0;j=c[m>>2]|0;$=c[n>>2]|0;ba=c[o>>2]|0;da=c[p>>2]|0;fa=c[q>>2]|0;ha=c[r>>2]|0;ia=(h^8)+-1>>31;G=(c[1184+(b*960|0)+844>>2]^E)&ia;C=(c[1184+(b*960|0)+848>>2]^A)&ia;y=(c[1184+(b*960|0)+852>>2]^w)&ia;h=(c[1184+(b*960|0)+856>>2]^j)&ia;_=(c[1184+(b*960|0)+860>>2]^$)&ia;aa=(c[1184+(b*960|0)+864>>2]^ba)&ia;ca=(c[1184+(b*960|0)+868>>2]^da)&ia;ea=(c[1184+(b*960|0)+872>>2]^fa)&ia;ga=(c[1184+(b*960|0)+876>>2]^ha)&ia;c[a>>2]=(c[1184+(b*960|0)+840>>2]^H)&ia^H;c[d>>2]=G^E;c[k>>2]=C^A;c[l>>2]=y^w;c[m>>2]=h^j;c[n>>2]=_^$;c[o>>2]=aa^ba;c[p>>2]=ca^da;c[q>>2]=ea^fa;c[r>>2]=ga^ha;ha=c[e>>2]|0;ga=c[f>>2]|0;fa=c[W>>2]|0;ea=c[U>>2]|0;da=c[S>>2]|0;ca=c[Q>>2]|0;ba=c[O>>2]|0;aa=c[M>>2]|0;$=c[K>>2]|0;_=c[I>>2]|0;j=(c[1184+(b*960|0)+884>>2]^ga)&ia;h=(c[1184+(b*960|0)+888>>2]^fa)&ia;w=(c[1184+(b*960|0)+892>>2]^ea)&ia;y=(c[1184+(b*960|0)+896>>2]^da)&ia;A=(c[1184+(b*960|0)+900>>2]^ca)&ia;C=(c[1184+(b*960|0)+904>>2]^ba)&ia;E=(c[1184+(b*960|0)+908>>2]^aa)&ia;G=(c[1184+(b*960|0)+912>>2]^$)&ia;H=(c[1184+(b*960|0)+916>>2]^_)&ia;ha=(c[1184+(b*960|0)+880>>2]^ha)&ia^ha;c[e>>2]=ha;ga=j^ga;c[f>>2]=ga;fa=h^fa;c[W>>2]=fa;ea=w^ea;c[U>>2]=ea;da=y^da;c[S>>2]=da;ca=A^ca;c[Q>>2]=ca;ba=C^ba;c[O>>2]=ba;aa=E^aa;c[M>>2]=aa;$=G^$;c[K>>2]=$;_=H^_;c[I>>2]=_;H=c[g>>2]|0;G=c[F>>2]|0;E=c[D>>2]|0;C=c[B>>2]|0;A=c[z>>2]|0;y=c[x>>2]|0;w=c[v>>2]|0;h=c[i>>2]|0;j=c[t>>2]|0;Z=c[u>>2]|0;J=(c[1184+(b*960|0)+924>>2]^G)&ia;L=(c[1184+(b*960|0)+928>>2]^E)&ia;N=(c[1184+(b*960|0)+932>>2]^C)&ia;P=(c[1184+(b*960|0)+936>>2]^A)&ia;R=(c[1184+(b*960|0)+940>>2]^y)&ia;T=(c[1184+(b*960|0)+944>>2]^w)&ia;V=(c[1184+(b*960|0)+948>>2]^h)&ia;X=(c[1184+(b*960|0)+952>>2]^j)&ia;Y=(c[1184+(b*960|0)+956>>2]^Z)&ia;H=(c[1184+(b*960|0)+920>>2]^H)&ia^H;c[g>>2]=H;G=J^G;c[F>>2]=G;E=L^E;c[D>>2]=E;C=N^C;c[B>>2]=C;A=P^A;c[z>>2]=A;y=R^y;c[x>>2]=y;w=T^w;c[v>>2]=w;h=V^h;c[i>>2]=h;j=X^j;c[t>>2]=j;b=Y^Z;c[u>>2]=b;Z=c[a>>2]|0;Y=c[d>>2]|0;X=c[k>>2]|0;V=c[l>>2]|0;T=c[m>>2]|0;R=c[n>>2]|0;P=c[o>>2]|0;N=c[p>>2]|0;L=c[q>>2]|0;J=c[r>>2]|0;c[a>>2]=(ha^Z)&s^Z;c[d>>2]=(ga^Y)&s^Y;c[k>>2]=(fa^X)&s^X;c[l>>2]=(ea^V)&s^V;c[m>>2]=(da^T)&s^T;c[n>>2]=(ca^R)&s^R;c[o>>2]=(ba^P)&s^P;c[p>>2]=(aa^N)&s^N;c[q>>2]=($^L)&s^L;c[r>>2]=(_^J)&s^J;d=c[e>>2]|0;a=c[f>>2]|0;r=c[W>>2]|0;q=c[U>>2]|0;p=c[S>>2]|0;o=c[Q>>2]|0;n=c[O>>2]|0;m=c[M>>2]|0;l=c[K>>2]|0;k=c[I>>2]|0;c[e>>2]=(Z^d)&s^d;c[f>>2]=(Y^a)&s^a;c[W>>2]=(X^r)&s^r;c[U>>2]=(V^q)&s^q;c[S>>2]=(T^p)&s^p;c[Q>>2]=(R^o)&s^o;c[O>>2]=(P^n)&s^n;c[M>>2]=(N^m)&s^m;c[K>>2]=(L^l)&s^l;c[I>>2]=(J^k)&s^k;f=c[g>>2]|0;k=c[F>>2]|0;l=c[D>>2]|0;m=c[B>>2]|0;n=c[z>>2]|0;o=c[x>>2]|0;p=c[v>>2]|0;q=c[i>>2]|0;r=c[t>>2]|0;a=c[u>>2]|0;c[g>>2]=(f^0-H)&s^f;c[F>>2]=(k^0-G)&s^k;c[D>>2]=(l^0-E)&s^l;c[B>>2]=(m^0-C)&s^m;c[z>>2]=(n^0-A)&s^n;c[x>>2]=(o^0-y)&s^o;c[v>>2]=(p^0-w)&s^p;c[i>>2]=(q^0-h)&s^q;c[t>>2]=(r^0-j)&s^r;c[u>>2]=(a^0-b)&s^a;return}function Uc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;e=i=i+63&-64;i=i+240|0;d=e+80|0;f=e+40|0;if(Oc(d,b)|0){f=-1;i=g;return f|0}y=e+4|0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[y+16>>2]=0;c[y+20>>2]=0;c[y+24>>2]=0;c[y+28>>2]=0;q=d+40|0;p=d+44|0;n=d+48|0;m=d+52|0;l=d+56|0;k=d+60|0;j=d+64|0;h=d+68|0;r=d+72|0;b=d+76|0;z=0-(c[p>>2]|0)|0;x=0-(c[n>>2]|0)|0;w=0-(c[m>>2]|0)|0;v=0-(c[l>>2]|0)|0;u=0-(c[k>>2]|0)|0;t=0-(c[j>>2]|0)|0;s=0-(c[h>>2]|0)|0;d=0-(c[r>>2]|0)|0;o=0-(c[b>>2]|0)|0;c[e>>2]=1-(c[q>>2]|0);c[y>>2]=z;c[e+8>>2]=x;c[e+12>>2]=w;c[e+16>>2]=v;c[e+20>>2]=u;c[e+24>>2]=t;c[e+28>>2]=s;c[e+32>>2]=d;c[e+36>>2]=o;Jc(e,e);o=f+4|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;c[o+16>>2]=0;c[o+20>>2]=0;c[o+24>>2]=0;c[o+28>>2]=0;p=c[p>>2]|0;n=c[n>>2]|0;m=c[m>>2]|0;l=c[l>>2]|0;k=c[k>>2]|0;j=c[j>>2]|0;h=c[h>>2]|0;d=c[r>>2]|0;b=c[b>>2]|0;c[f>>2]=(c[q>>2]|0)+1;c[o>>2]=p;c[f+8>>2]=n;c[f+12>>2]=m;c[f+16>>2]=l;c[f+20>>2]=k;c[f+24>>2]=j;c[f+28>>2]=h;c[f+32>>2]=d;c[f+36>>2]=b;Kc(f,f,e);Mc(a,f);f=0;i=g;return f|0}function Vc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;j=i;f=i=i+63&-64;i=i+272|0;g=f;f=f+208|0;h=g+64|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;h=g;k=8;l=h+64|0;do{c[h>>2]=c[k>>2];h=h+4|0;k=k+4|0}while((h|0)<(l|0));Gb(g,e,32,0);Hb(g,f);a[f>>0]=(d[f>>0]|0)&248;h=f+31|0;a[h>>0]=(d[h>>0]|0)&63|64;h=b;k=f;l=h+32|0;do{a[h>>0]=a[k>>0]|0;h=h+1|0;k=k+1|0}while((h|0)<(l|0));i=j;return 0}function Wc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0;Qa=i;k=i=i+63&-64;i=i+3024|0;Ma=k+2800|0;Na=k+2544|0;Oa=k+2288|0;j=k+2248|0;Ja=k+968|0;Ka=k+808|0;La=k+648|0;r=k+488|0;l=k;n=k+2920|0;Pa=k+2984|0;q=k+328|0;k=k+208|0;if((d[b+63>>0]|0)>31){b=-1;i=Qa;return b|0}if(Oc(q,h)|0){b=-1;i=Qa;return b|0}if(!((a[h+31>>0]|(a[h+30>>0]|(a[h+29>>0]|(a[h+28>>0]|(a[h+27>>0]|(a[h+26>>0]|(a[h+25>>0]|(a[h+24>>0]|(a[h+23>>0]|(a[h+22>>0]|(a[h+21>>0]|(a[h+20>>0]|(a[h+19>>0]|(a[h+18>>0]|(a[h+17>>0]|(a[h+16>>0]|(a[h+15>>0]|(a[h+14>>0]|(a[h+13>>0]|(a[h+12>>0]|(a[h+11>>0]|(a[h+10>>0]|(a[h+9>>0]|(a[h+8>>0]|(a[h+7>>0]|(a[h+6>>0]|(a[h+5>>0]|(a[h+4>>0]|(a[h+3>>0]|(a[h+2>>0]|(a[h+1>>0]|a[h>>0])))))))))))))))))))))))))))))))<<24>>24)){b=-1;i=Qa;return b|0}o=l+64|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;c[o+12>>2]=0;o=l;m=8;p=o+64|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(p|0));Gb(l,b,32,0);Gb(l,h,32,0);Gb(l,e,f,g);Hb(l,n);Xc(n);g=0;do{a[Na+g>>0]=(d[n+(g>>3)>>0]|0)>>>(g&7)&1;g=g+1|0}while((g|0)!=256);o=0;while(1){n=Na+o|0;a:do if(a[n>>0]|0){m=1;do{h=m+o|0;if((h|0)>=256)break a;e=Na+h|0;g=a[e>>0]|0;b:do if(g<<24>>24){l=a[n>>0]|0;g=g<<24>>24<<m;f=l+g|0;if((f|0)<16){a[n>>0]=f;a[e>>0]=0;break}g=l-g|0;if((g|0)<=-16)break a;a[n>>0]=g;while(1){g=Na+h|0;if(!(a[g>>0]|0))break;a[g>>0]=0;h=h+1|0;if((h|0)>=256)break b}a[g>>0]=1}while(0);m=m+1|0}while((m|0)<7)}while(0);o=o+1|0;if((o|0)==256){g=0;break}}do{a[Oa+g>>0]=(d[b+((g>>3)+32)>>0]|0)>>>(g&7)&1;g=g+1|0}while((g|0)!=256);o=0;do{n=Oa+o|0;c:do if(a[n>>0]|0){m=1;do{h=m+o|0;if((h|0)>=256)break c;l=Oa+h|0;g=a[l>>0]|0;d:do if(g<<24>>24){e=a[n>>0]|0;f=g<<24>>24<<m;g=e+f|0;if((g|0)<16){a[n>>0]=g;a[l>>0]=0;break}g=e-f|0;if((g|0)<=-16)break c;a[n>>0]=g;while(1){g=Oa+h|0;if(!(a[g>>0]|0))break;a[g>>0]=0;h=h+1|0;if((h|0)>=256)break d}a[g>>0]=1}while(0);m=m+1|0}while((m|0)<7)}while(0);o=o+1|0}while((o|0)!=256);Rc(Ja,q);Ia=c[q+4>>2]|0;p=c[q+8>>2]|0;o=c[q+12>>2]|0;Ga=c[q+16>>2]|0;Fa=c[q+20>>2]|0;Ea=c[q+24>>2]|0;Da=c[q+28>>2]|0;Ca=c[q+32>>2]|0;Ba=c[q+36>>2]|0;c[Ma>>2]=c[q>>2];c[Ma+4>>2]=Ia;c[Ma+8>>2]=p;c[Ma+12>>2]=o;c[Ma+16>>2]=Ga;c[Ma+20>>2]=Fa;c[Ma+24>>2]=Ea;c[Ma+28>>2]=Da;c[Ma+32>>2]=Ca;c[Ma+36>>2]=Ba;Ba=c[q+44>>2]|0;Ca=c[q+48>>2]|0;Da=c[q+52>>2]|0;Ea=c[q+56>>2]|0;Fa=c[q+60>>2]|0;Ga=c[q+64>>2]|0;o=c[q+68>>2]|0;p=c[q+72>>2]|0;Ia=c[q+76>>2]|0;c[Ma+40>>2]=c[q+40>>2];c[Ma+44>>2]=Ba;c[Ma+48>>2]=Ca;c[Ma+52>>2]=Da;c[Ma+56>>2]=Ea;c[Ma+60>>2]=Fa;c[Ma+64>>2]=Ga;c[Ma+68>>2]=o;c[Ma+72>>2]=p;c[Ma+76>>2]=Ia;Ia=c[q+84>>2]|0;p=c[q+88>>2]|0;o=c[q+92>>2]|0;Ga=c[q+96>>2]|0;Fa=c[q+100>>2]|0;Ea=c[q+104>>2]|0;Da=c[q+108>>2]|0;Ca=c[q+112>>2]|0;Ba=c[q+116>>2]|0;c[Ma+80>>2]=c[q+80>>2];c[Ma+84>>2]=Ia;c[Ma+88>>2]=p;c[Ma+92>>2]=o;c[Ma+96>>2]=Ga;c[Ma+100>>2]=Fa;c[Ma+104>>2]=Ea;c[Ma+108>>2]=Da;c[Ma+112>>2]=Ca;c[Ma+116>>2]=Ba;Qc(Ka,Ma);Ba=Ka+120|0;Kc(r,Ka,Ba);Ca=Ka+40|0;Da=Ka+80|0;Kc(r+40|0,Ca,Da);Kc(r+80|0,Da,Ba);Kc(r+120|0,Ka,Ca);Nc(Ka,r,Ja);Kc(La,Ka,Ba);Ea=La+40|0;Kc(Ea,Ca,Da);Fa=La+80|0;Kc(Fa,Da,Ba);Ga=La+120|0;Kc(Ga,Ka,Ca);o=Ja+160|0;Rc(o,La);Nc(Ka,r,o);Kc(La,Ka,Ba);Kc(Ea,Ca,Da);Kc(Fa,Da,Ba);Kc(Ga,Ka,Ca);o=Ja+320|0;Rc(o,La);Nc(Ka,r,o);Kc(La,Ka,Ba);Kc(Ea,Ca,Da);Kc(Fa,Da,Ba);Kc(Ga,Ka,Ca);o=Ja+480|0;Rc(o,La);Nc(Ka,r,o);Kc(La,Ka,Ba);Kc(Ea,Ca,Da);Kc(Fa,Da,Ba);Kc(Ga,Ka,Ca);o=Ja+640|0;Rc(o,La);Nc(Ka,r,o);Kc(La,Ka,Ba);Kc(Ea,Ca,Da);Kc(Fa,Da,Ba);Kc(Ga,Ka,Ca);o=Ja+800|0;Rc(o,La);Nc(Ka,r,o);Kc(La,Ka,Ba);Kc(Ea,Ca,Da);Kc(Fa,Da,Ba);Kc(Ga,Ka,Ca);o=Ja+960|0;Rc(o,La);Nc(Ka,r,o);Kc(La,Ka,Ba);Kc(Ea,Ca,Da);Kc(Fa,Da,Ba);Kc(Ga,Ka,Ca);Rc(Ja+1120|0,La);o=k;p=o+40|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));Ha=k+40|0;c[Ha>>2]=1;o=k+44|0;p=o+36|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));Ia=k+80|0;c[Ia>>2]=1;o=k+84|0;p=o+36|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));g=255;while(1){if(a[Na+g>>0]|0){f=g;break}if(a[Oa+g>>0]|0){f=g;break}f=g+-1|0;if((g|0)>0)g=f;else break}if((f|0)>-1){q=La+44|0;p=La+48|0;o=La+52|0;n=La+56|0;m=La+60|0;l=La+64|0;e=La+68|0;g=La+72|0;h=La+76|0;s=La+4|0;t=La+8|0;u=La+12|0;v=La+16|0;w=La+20|0;x=La+24|0;y=La+28|0;z=La+32|0;A=La+36|0;B=Ka+4|0;C=Ka+8|0;D=Ka+12|0;E=Ka+16|0;F=Ka+20|0;G=Ka+24|0;H=Ka+28|0;I=Ka+32|0;J=Ka+36|0;K=Ka+44|0;L=Ka+48|0;M=Ka+52|0;N=Ka+56|0;O=Ka+60|0;P=Ka+64|0;Q=Ka+68|0;R=Ka+72|0;S=Ka+76|0;T=La+84|0;U=La+88|0;V=La+92|0;W=La+96|0;X=La+100|0;Y=La+104|0;Z=La+108|0;_=La+112|0;$=La+116|0;aa=j+4|0;ba=j+8|0;ca=j+12|0;da=j+16|0;ea=j+20|0;fa=j+24|0;ga=j+28|0;ha=j+32|0;ia=j+36|0;ja=Ka+84|0;ka=Ka+88|0;la=Ka+92|0;ma=Ka+96|0;na=Ka+100|0;oa=Ka+104|0;pa=Ka+108|0;qa=Ka+112|0;ra=Ka+116|0;sa=Ka+124|0;ta=Ka+128|0;ua=Ka+132|0;va=Ka+136|0;wa=Ka+140|0;xa=Ka+144|0;ya=Ka+148|0;za=Ka+152|0;Aa=Ka+156|0;while(1){Qc(Ka,k);r=a[Na+f>>0]|0;if(r<<24>>24<=0){if(r<<24>>24<0){Kc(La,Ka,Ba);Kc(Ea,Ca,Da);Kc(Fa,Da,Ba);Kc(Ga,Ka,Ca);hb=(r<<24>>24|0)/-2|0;rb=c[Ea>>2]|0;Xa=c[q>>2]|0;Ta=c[p>>2]|0;ib=c[o>>2]|0;mb=c[n>>2]|0;qb=c[m>>2]|0;$a=c[l>>2]|0;bb=c[e>>2]|0;db=c[g>>2]|0;fb=c[h>>2]|0;Za=c[La>>2]|0;Va=c[s>>2]|0;Ra=c[t>>2]|0;kb=c[u>>2]|0;ob=c[v>>2]|0;_a=c[w>>2]|0;ab=c[x>>2]|0;cb=c[y>>2]|0;eb=c[z>>2]|0;gb=c[A>>2]|0;c[Ka>>2]=Za+rb;c[B>>2]=Va+Xa;c[C>>2]=Ra+Ta;c[D>>2]=kb+ib;c[E>>2]=ob+mb;c[F>>2]=_a+qb;c[G>>2]=ab+$a;c[H>>2]=cb+bb;c[I>>2]=eb+db;c[J>>2]=gb+fb;c[Ca>>2]=rb-Za;c[K>>2]=Xa-Va;c[L>>2]=Ta-Ra;c[M>>2]=ib-kb;c[N>>2]=mb-ob;c[O>>2]=qb-_a;c[P>>2]=$a-ab;c[Q>>2]=bb-cb;c[R>>2]=db-eb;c[S>>2]=fb-gb;Kc(Da,Ka,Ja+(hb*160|0)+40|0);Kc(Ca,Ca,Ja+(hb*160|0)|0);Kc(Ba,Ja+(hb*160|0)+120|0,Ga);Kc(Ka,Fa,Ja+(hb*160|0)+80|0);hb=c[Ka>>2]<<1;gb=c[B>>2]<<1;fb=c[C>>2]<<1;eb=c[D>>2]<<1;db=c[E>>2]<<1;cb=c[F>>2]<<1;bb=c[G>>2]<<1;ab=c[H>>2]<<1;$a=c[I>>2]<<1;_a=c[J>>2]<<1;c[j>>2]=hb;c[aa>>2]=gb;c[ba>>2]=fb;c[ca>>2]=eb;c[da>>2]=db;c[ea>>2]=cb;c[fa>>2]=bb;c[ga>>2]=ab;c[ha>>2]=$a;c[ia>>2]=_a;qb=c[Da>>2]|0;ob=c[ja>>2]|0;mb=c[ka>>2]|0;kb=c[la>>2]|0;ib=c[ma>>2]|0;Ra=c[na>>2]|0;Ta=c[oa>>2]|0;Va=c[pa>>2]|0;Xa=c[qa>>2]|0;Za=c[ra>>2]|0;rb=c[Ca>>2]|0;pb=c[K>>2]|0;nb=c[L>>2]|0;lb=c[M>>2]|0;jb=c[N>>2]|0;r=c[O>>2]|0;Sa=c[P>>2]|0;Ua=c[Q>>2]|0;Wa=c[R>>2]|0;Ya=c[S>>2]|0;c[Ka>>2]=qb-rb;c[B>>2]=ob-pb;c[C>>2]=mb-nb;c[D>>2]=kb-lb;c[E>>2]=ib-jb;c[F>>2]=Ra-r;c[G>>2]=Ta-Sa;c[H>>2]=Va-Ua;c[I>>2]=Xa-Wa;c[J>>2]=Za-Ya;c[Ca>>2]=rb+qb;c[K>>2]=pb+ob;c[L>>2]=nb+mb;c[M>>2]=lb+kb;c[N>>2]=jb+ib;c[O>>2]=r+Ra;c[P>>2]=Sa+Ta;c[Q>>2]=Ua+Va;c[R>>2]=Wa+Xa;c[S>>2]=Ya+Za;Za=c[Ba>>2]|0;Ya=c[sa>>2]|0;Xa=c[ta>>2]|0;Wa=c[ua>>2]|0;Va=c[va>>2]|0;Ua=c[wa>>2]|0;Ta=c[xa>>2]|0;Sa=c[ya>>2]|0;Ra=c[za>>2]|0;r=c[Aa>>2]|0;c[Da>>2]=hb-Za;c[ja>>2]=gb-Ya;c[ka>>2]=fb-Xa;c[la>>2]=eb-Wa;c[ma>>2]=db-Va;c[na>>2]=cb-Ua;c[oa>>2]=bb-Ta;c[pa>>2]=ab-Sa;c[qa>>2]=$a-Ra;c[ra>>2]=_a-r;Ya=Ya+(c[aa>>2]|0)|0;Xa=Xa+(c[ba>>2]|0)|0;Wa=Wa+(c[ca>>2]|0)|0;Va=Va+(c[da>>2]|0)|0;Ua=Ua+(c[ea>>2]|0)|0;Ta=Ta+(c[fa>>2]|0)|0;Sa=Sa+(c[ga>>2]|0)|0;Ra=Ra+(c[ha>>2]|0)|0;r=r+(c[ia>>2]|0)|0;c[Ba>>2]=Za+(c[j>>2]|0);c[sa>>2]=Ya;c[ta>>2]=Xa;c[ua>>2]=Wa;c[va>>2]=Va;c[wa>>2]=Ua;c[xa>>2]=Ta;c[ya>>2]=Sa;c[za>>2]=Ra;c[Aa>>2]=r}}else{Kc(La,Ka,Ba);Kc(Ea,Ca,Da);Kc(Fa,Da,Ba);Kc(Ga,Ka,Ca);Nc(Ka,La,Ja+(((r<<24>>24|0)/2|0)*160|0)|0)}r=a[Oa+f>>0]|0;if(r<<24>>24<=0){if(r<<24>>24<0){Kc(La,Ka,Ba);Kc(Ea,Ca,Da);Kc(Fa,Da,Ba);Kc(Ga,Ka,Ca);_a=(r<<24>>24|0)/-2|0;r=c[Ea>>2]|0;kb=c[q>>2]|0;ob=c[p>>2]|0;Za=c[o>>2]|0;Va=c[n>>2]|0;Ra=c[m>>2]|0;gb=c[l>>2]|0;eb=c[e>>2]|0;cb=c[g>>2]|0;ab=c[h>>2]|0;ib=c[La>>2]|0;mb=c[s>>2]|0;qb=c[t>>2]|0;Xa=c[u>>2]|0;Ta=c[v>>2]|0;hb=c[w>>2]|0;fb=c[x>>2]|0;db=c[y>>2]|0;bb=c[z>>2]|0;$a=c[A>>2]|0;c[Ka>>2]=ib+r;c[B>>2]=mb+kb;c[C>>2]=qb+ob;c[D>>2]=Xa+Za;c[E>>2]=Ta+Va;c[F>>2]=hb+Ra;c[G>>2]=fb+gb;c[H>>2]=db+eb;c[I>>2]=bb+cb;c[J>>2]=$a+ab;c[Ca>>2]=r-ib;c[K>>2]=kb-mb;c[L>>2]=ob-qb;c[M>>2]=Za-Xa;c[N>>2]=Va-Ta;c[O>>2]=Ra-hb;c[P>>2]=gb-fb;c[Q>>2]=eb-db;c[R>>2]=cb-bb;c[S>>2]=ab-$a;Kc(Da,Ka,104+(_a*120|0)+40|0);Kc(Ca,Ca,104+(_a*120|0)|0);Kc(Ba,104+(_a*120|0)+80|0,Ga);_a=c[Fa>>2]<<1;$a=c[T>>2]<<1;ab=c[U>>2]<<1;bb=c[V>>2]<<1;cb=c[W>>2]<<1;db=c[X>>2]<<1;eb=c[Y>>2]<<1;fb=c[Z>>2]<<1;gb=c[_>>2]<<1;hb=c[$>>2]<<1;c[j>>2]=_a;c[aa>>2]=$a;c[ba>>2]=ab;c[ca>>2]=bb;c[da>>2]=cb;c[ea>>2]=db;c[fa>>2]=eb;c[ga>>2]=fb;c[ha>>2]=gb;c[ia>>2]=hb;Ra=c[Da>>2]|0;Ta=c[ja>>2]|0;Va=c[ka>>2]|0;Xa=c[la>>2]|0;Za=c[ma>>2]|0;qb=c[na>>2]|0;ob=c[oa>>2]|0;mb=c[pa>>2]|0;kb=c[qa>>2]|0;ib=c[ra>>2]|0;r=c[Ca>>2]|0;Sa=c[K>>2]|0;Ua=c[L>>2]|0;Wa=c[M>>2]|0;Ya=c[N>>2]|0;rb=c[O>>2]|0;pb=c[P>>2]|0;nb=c[Q>>2]|0;lb=c[R>>2]|0;jb=c[S>>2]|0;c[Ka>>2]=Ra-r;c[B>>2]=Ta-Sa;c[C>>2]=Va-Ua;c[D>>2]=Xa-Wa;c[E>>2]=Za-Ya;c[F>>2]=qb-rb;c[G>>2]=ob-pb;c[H>>2]=mb-nb;c[I>>2]=kb-lb;c[J>>2]=ib-jb;c[Ca>>2]=r+Ra;c[K>>2]=Sa+Ta;c[L>>2]=Ua+Va;c[M>>2]=Wa+Xa;c[N>>2]=Ya+Za;c[O>>2]=rb+qb;c[P>>2]=pb+ob;c[Q>>2]=nb+mb;c[R>>2]=lb+kb;c[S>>2]=jb+ib;ib=c[Ba>>2]|0;jb=c[sa>>2]|0;kb=c[ta>>2]|0;lb=c[ua>>2]|0;mb=c[va>>2]|0;nb=c[wa>>2]|0;ob=c[xa>>2]|0;pb=c[ya>>2]|0;qb=c[za>>2]|0;rb=c[Aa>>2]|0;c[Da>>2]=_a-ib;c[ja>>2]=$a-jb;c[ka>>2]=ab-kb;c[la>>2]=bb-lb;c[ma>>2]=cb-mb;c[na>>2]=db-nb;c[oa>>2]=eb-ob;c[pa>>2]=fb-pb;c[qa>>2]=gb-qb;c[ra>>2]=hb-rb;jb=jb+(c[aa>>2]|0)|0;kb=kb+(c[ba>>2]|0)|0;lb=lb+(c[ca>>2]|0)|0;mb=mb+(c[da>>2]|0)|0;nb=nb+(c[ea>>2]|0)|0;ob=ob+(c[fa>>2]|0)|0;pb=pb+(c[ga>>2]|0)|0;qb=qb+(c[ha>>2]|0)|0;rb=rb+(c[ia>>2]|0)|0;c[Ba>>2]=ib+(c[j>>2]|0);c[sa>>2]=jb;c[ta>>2]=kb;c[ua>>2]=lb;c[va>>2]=mb;c[wa>>2]=nb;c[xa>>2]=ob;c[ya>>2]=pb;c[za>>2]=qb;c[Aa>>2]=rb}}else{Kc(La,Ka,Ba);Kc(Ea,Ca,Da);Kc(Fa,Da,Ba);Kc(Ga,Ka,Ca);Pc(Ka,La,104+(((r<<24>>24|0)/2|0)*120|0)|0)}Kc(k,Ka,Ba);Kc(Ha,Ca,Da);Kc(Ia,Da,Ba);if((f|0)>0)f=f+-1|0;else break}}Jc(j,Ia);Kc(Na,k,j);Kc(Oa,Ha,j);Mc(Pa,Oa);Mc(Ma,Na);h=Pa+31|0;a[h>>0]=d[h>>0]^d[Ma>>0]<<7;h=Zc(Pa,b)|0;g=(Pa|0)==(b|0);j=0;k=0;do{j=a[Pa+k>>0]^a[b+k>>0]|j;k=k+1|0}while((k|0)!=32);rb=(g?-1:h)|(((j&255)+511|0)>>>8&1)+-1;i=Qa;return rb|0}function Xc(b){b=b|0;var c=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0;ea=b+1|0;ba=b+2|0;ja=a[ba>>0]|0;j=d[b>>0]|0;ia=Jd(d[ea>>0]|0|0,0,8)|0;na=C;ja=ja&255;V=Jd(ja|0,0,16)|0;aa=b+3|0;n=Jd(d[aa>>0]|0|0,0,8)|0;e=C;$=b+4|0;U=Jd(d[$>>0]|0|0,0,16)|0;e=e|C;Y=b+5|0;N=d[Y>>0]|0;X=Jd(N|0,0,24)|0;e=Id(n|ja|U|X|0,e|C|0,5)|0;X=b+6|0;U=b+7|0;ja=a[U>>0]|0;n=Jd(d[X>>0]|0|0,0,8)|0;M=C;ja=ja&255;T=Jd(ja|0,0,16)|0;M=Id(n|N|T|0,M|C|0,2)|0;T=b+8|0;N=Jd(d[T>>0]|0|0,0,8)|0;n=C;S=b+9|0;fa=Jd(d[S>>0]|0|0,0,16)|0;n=n|C;P=b+10|0;L=d[P>>0]|0;O=Jd(L|0,0,24)|0;n=Id(N|ja|fa|O|0,n|C|0,7)|0;O=b+11|0;fa=Jd(d[O>>0]|0|0,0,8)|0;ja=C;N=b+12|0;G=Jd(d[N>>0]|0|0,0,16)|0;ja=ja|C;K=b+13|0;u=d[K>>0]|0;J=Jd(u|0,0,24)|0;ja=Id(fa|L|G|J|0,ja|C|0,4)|0;J=b+14|0;G=b+15|0;L=a[G>>0]|0;fa=Jd(d[J>>0]|0|0,0,8)|0;ga=C;L=L&255;F=Jd(L|0,0,16)|0;ga=Id(fa|u|F|0,ga|C|0,1)|0;F=b+16|0;u=Jd(d[F>>0]|0|0,0,8)|0;fa=C;E=b+17|0;w=Jd(d[E>>0]|0|0,0,16)|0;fa=fa|C;A=b+18|0;v=d[A>>0]|0;z=Jd(v|0,0,24)|0;fa=Id(u|L|w|z|0,fa|C|0,6)|0;z=b+19|0;w=b+20|0;L=a[w>>0]|0;u=Jd(d[z>>0]|0|0,0,8)|0;W=C;L=Jd(L&255|0,0,16)|0;W=Id(u|v|L|0,W|C|0,3)|0;L=C;v=b+21|0;u=b+22|0;r=b+23|0;x=a[r>>0]|0;la=d[v>>0]|0;xa=Jd(d[u>>0]|0|0,0,8)|0;ra=C;x=x&255;H=Jd(x|0,0,16)|0;q=b+24|0;Z=Jd(d[q>>0]|0|0,0,8)|0;D=C;p=b+25|0;i=Jd(d[p>>0]|0|0,0,16)|0;D=D|C;m=b+26|0;oa=d[m>>0]|0;l=Jd(oa|0,0,24)|0;D=Id(Z|x|i|l|0,D|C|0,5)|0;l=b+27|0;i=b+28|0;x=a[i>>0]|0;Z=Jd(d[l>>0]|0|0,0,8)|0;B=C;x=x&255;h=Jd(x|0,0,16)|0;B=Id(Z|oa|h|0,B|C|0,2)|0;h=b+29|0;oa=Jd(d[h>>0]|0|0,0,8)|0;Z=C;g=b+30|0;s=Jd(d[g>>0]|0|0,0,16)|0;Z=Z|C;c=b+31|0;t=d[c>>0]|0;_=Jd(t|0,0,24)|0;Z=Id(oa|x|s|_|0,Z|C|0,7)|0;_=Jd(d[b+32>>0]|0|0,0,8)|0;s=C;x=Jd(d[b+33>>0]|0|0,0,16)|0;s=s|C;oa=d[b+34>>0]|0;da=Jd(oa|0,0,24)|0;s=Id(_|t|x|da|0,s|C|0,4)|0;da=a[b+36>>0]|0;x=Jd(d[b+35>>0]|0|0,0,8)|0;t=C;da=da&255;_=Jd(da|0,0,16)|0;t=Id(x|oa|_|0,t|C|0,1)|0;_=Jd(d[b+37>>0]|0|0,0,8)|0;oa=C;x=Jd(d[b+38>>0]|0|0,0,16)|0;oa=oa|C;R=d[b+39>>0]|0;va=Jd(R|0,0,24)|0;oa=Id(_|da|x|va|0,oa|C|0,6)|0;va=a[b+41>>0]|0;x=Jd(d[b+40>>0]|0|0,0,8)|0;da=C;va=Jd(va&255|0,0,16)|0;da=Id(x|R|va|0,da|C|0,3)|0;va=C;R=a[b+44>>0]|0;x=d[b+42>>0]|0;_=Jd(d[b+43>>0]|0|0,0,8)|0;ma=C;R=R&255;ta=Jd(R|0,0,16)|0;ha=Jd(d[b+45>>0]|0|0,0,8)|0;pa=C;ca=Jd(d[b+46>>0]|0|0,0,16)|0;pa=pa|C;I=d[b+47>>0]|0;sa=Jd(I|0,0,24)|0;pa=Id(ha|R|ca|sa|0,pa|C|0,5)|0;sa=a[b+49>>0]|0;ca=Jd(d[b+48>>0]|0|0,0,8)|0;R=C;sa=sa&255;ha=Jd(sa|0,0,16)|0;R=Id(ca|I|ha|0,R|C|0,2)|0;R=R&2097151;ha=Jd(d[b+50>>0]|0|0,0,8)|0;I=C;ca=Jd(d[b+51>>0]|0|0,0,16)|0;I=I|C;qa=d[b+52>>0]|0;ka=Jd(qa|0,0,24)|0;I=Id(ha|sa|ca|ka|0,I|C|0,7)|0;I=I&2097151;ka=Jd(d[b+53>>0]|0|0,0,8)|0;ca=C;sa=Jd(d[b+54>>0]|0|0,0,16)|0;ca=ca|C;ha=d[b+55>>0]|0;k=Jd(ha|0,0,24)|0;ca=Id(ka|qa|sa|k|0,ca|C|0,4)|0;ca=ca&2097151;k=a[b+57>>0]|0;sa=Jd(d[b+56>>0]|0|0,0,8)|0;qa=C;k=k&255;ka=Jd(k|0,0,16)|0;qa=Id(sa|ha|ka|0,qa|C|0,1)|0;qa=qa&2097151;ka=Jd(d[b+58>>0]|0|0,0,8)|0;ha=C;sa=Jd(d[b+59>>0]|0|0,0,16)|0;ha=ha|C;ua=d[b+60>>0]|0;y=Jd(ua|0,0,24)|0;ha=Id(ka|k|sa|y|0,ha|C|0,6)|0;ha=ha&2097151;y=Jd(d[b+61>>0]|0|0,0,8)|0;sa=C;k=Jd(d[b+62>>0]|0|0,0,16)|0;sa=sa|C;ka=Jd(d[b+63>>0]|0|0,0,24)|0;sa=Id(y|ua|k|ka|0,sa|C|0,3)|0;ka=C;k=Qd(sa|0,ka|0,666643,0)|0;k=Fd(Z&2097151|0,0,k|0,C|0)|0;Z=C;ua=Qd(sa|0,ka|0,470296,0)|0;ua=Fd(s&2097151|0,0,ua|0,C|0)|0;s=C;y=Qd(sa|0,ka|0,654183,0)|0;y=Fd(t&2097151|0,0,y|0,C|0)|0;t=C;wa=Qd(sa|0,ka|0,-997805,-1)|0;wa=Fd(oa&2097151|0,0,wa|0,C|0)|0;oa=C;o=Qd(sa|0,ka|0,136657,0)|0;o=Fd(da|0,va|0,o|0,C|0)|0;va=C;ka=Qd(sa|0,ka|0,-683901,-1)|0;ka=Fd(_|x|ta&2031616|0,ma|0,ka|0,C|0)|0;ma=C;ta=Qd(ha|0,0,666643,0)|0;ta=Fd(B&2097151|0,0,ta|0,C|0)|0;B=C;x=Qd(ha|0,0,470296,0)|0;Z=Fd(x|0,C|0,k|0,Z|0)|0;k=C;x=Qd(ha|0,0,654183,0)|0;s=Fd(x|0,C|0,ua|0,s|0)|0;ua=C;x=Qd(ha|0,0,-997805,-1)|0;t=Fd(x|0,C|0,y|0,t|0)|0;y=C;x=Qd(ha|0,0,136657,0)|0;oa=Fd(x|0,C|0,wa|0,oa|0)|0;wa=C;ha=Qd(ha|0,0,-683901,-1)|0;ha=Fd(o|0,va|0,ha|0,C|0)|0;va=C;o=Qd(qa|0,0,666643,0)|0;o=Fd(D&2097151|0,0,o|0,C|0)|0;D=C;x=Qd(qa|0,0,470296,0)|0;B=Fd(x|0,C|0,ta|0,B|0)|0;ta=C;x=Qd(qa|0,0,654183,0)|0;k=Fd(x|0,C|0,Z|0,k|0)|0;Z=C;x=Qd(qa|0,0,-997805,-1)|0;ua=Fd(x|0,C|0,s|0,ua|0)|0;s=C;x=Qd(qa|0,0,136657,0)|0;y=Fd(x|0,C|0,t|0,y|0)|0;t=C;qa=Qd(qa|0,0,-683901,-1)|0;qa=Fd(oa|0,wa|0,qa|0,C|0)|0;wa=C;oa=Qd(ca|0,0,666643,0)|0;x=C;_=Qd(ca|0,0,470296,0)|0;D=Fd(_|0,C|0,o|0,D|0)|0;o=C;_=Qd(ca|0,0,654183,0)|0;ta=Fd(_|0,C|0,B|0,ta|0)|0;B=C;_=Qd(ca|0,0,-997805,-1)|0;Z=Fd(_|0,C|0,k|0,Z|0)|0;k=C;_=Qd(ca|0,0,136657,0)|0;s=Fd(_|0,C|0,ua|0,s|0)|0;ua=C;ca=Qd(ca|0,0,-683901,-1)|0;ca=Fd(y|0,t|0,ca|0,C|0)|0;t=C;y=Qd(I|0,0,666643,0)|0;_=C;sa=Qd(I|0,0,470296,0)|0;da=C;Q=Qd(I|0,0,654183,0)|0;o=Fd(Q|0,C|0,D|0,o|0)|0;D=C;Q=Qd(I|0,0,-997805,-1)|0;Q=Fd(ta|0,B|0,Q|0,C|0)|0;B=C;ta=Qd(I|0,0,136657,0)|0;k=Fd(ta|0,C|0,Z|0,k|0)|0;Z=C;I=Qd(I|0,0,-683901,-1)|0;I=Fd(s|0,ua|0,I|0,C|0)|0;ua=C;s=Qd(R|0,0,666643,0)|0;fa=Fd(s|0,C|0,fa&2097151|0,0)|0;s=C;ta=Qd(R|0,0,470296,0)|0;f=C;ya=Qd(R|0,0,654183,0)|0;ra=Fd(ya|0,C|0,xa|la|H&2031616|0,ra|0)|0;da=Fd(ra|0,C|0,sa|0,da|0)|0;x=Fd(da|0,C|0,oa|0,x|0)|0;oa=C;da=Qd(R|0,0,-997805,-1)|0;da=Fd(o|0,D|0,da|0,C|0)|0;D=C;o=Qd(R|0,0,136657,0)|0;o=Fd(Q|0,B|0,o|0,C|0)|0;B=C;R=Qd(R|0,0,-683901,-1)|0;R=Fd(k|0,Z|0,R|0,C|0)|0;Z=C;k=Fd(fa|0,s|0,1048576,0)|0;k=Id(k|0,C|0,21)|0;Q=C;L=Fd(ta|0,f|0,W|0,L|0)|0;L=Fd(L|0,C|0,k|0,Q|0)|0;_=Fd(L|0,C|0,y|0,_|0)|0;y=C;Q=Jd(k|0,Q|0,21)|0;Q=Ed(fa|0,s|0,Q|0,C|0)|0;s=C;fa=Fd(x|0,oa|0,1048576,0)|0;fa=Id(fa|0,C|0,21)|0;k=C;D=Fd(da|0,D|0,fa|0,k|0)|0;da=C;k=Jd(fa|0,k|0,21)|0;k=Ed(x|0,oa|0,k|0,C|0)|0;oa=C;x=Fd(o|0,B|0,1048576,0)|0;x=Gd(x|0,C|0,21)|0;fa=C;Z=Fd(R|0,Z|0,x|0,fa|0)|0;R=C;fa=Jd(x|0,fa|0,21)|0;fa=Ed(o|0,B|0,fa|0,C|0)|0;B=C;o=Fd(I|0,ua|0,1048576,0)|0;o=Gd(o|0,C|0,21)|0;x=C;t=Fd(o|0,x|0,ca|0,t|0)|0;ca=C;x=Jd(o|0,x|0,21)|0;x=Ed(I|0,ua|0,x|0,C|0)|0;ua=C;I=Fd(qa|0,wa|0,1048576,0)|0;I=Gd(I|0,C|0,21)|0;o=C;va=Fd(I|0,o|0,ha|0,va|0)|0;ha=C;o=Jd(I|0,o|0,21)|0;o=Ed(qa|0,wa|0,o|0,C|0)|0;wa=C;qa=Fd(ka|0,ma|0,1048576,0)|0;qa=Gd(qa|0,C|0,21)|0;I=C;pa=Fd(qa|0,I|0,pa&2097151|0,0)|0;L=C;I=Jd(qa|0,I|0,21)|0;I=Ed(ka|0,ma|0,I|0,C|0)|0;ma=C;ka=Fd(_|0,y|0,1048576,0)|0;ka=Id(ka|0,C|0,21)|0;qa=C;oa=Fd(ka|0,qa|0,k|0,oa|0)|0;k=C;qa=Jd(ka|0,qa|0,21)|0;qa=Ed(_|0,y|0,qa|0,C|0)|0;y=C;_=Fd(D|0,da|0,1048576,0)|0;_=Gd(_|0,C|0,21)|0;ka=C;B=Fd(_|0,ka|0,fa|0,B|0)|0;fa=C;ka=Jd(_|0,ka|0,21)|0;ka=Ed(D|0,da|0,ka|0,C|0)|0;da=C;D=Fd(Z|0,R|0,1048576,0)|0;D=Gd(D|0,C|0,21)|0;_=C;ua=Fd(x|0,ua|0,D|0,_|0)|0;x=C;_=Jd(D|0,_|0,21)|0;_=Ed(Z|0,R|0,_|0,C|0)|0;R=C;Z=Fd(t|0,ca|0,1048576,0)|0;Z=Gd(Z|0,C|0,21)|0;D=C;wa=Fd(Z|0,D|0,o|0,wa|0)|0;o=C;D=Jd(Z|0,D|0,21)|0;D=Ed(t|0,ca|0,D|0,C|0)|0;ca=C;t=Fd(va|0,ha|0,1048576,0)|0;t=Gd(t|0,C|0,21)|0;Z=C;ma=Fd(t|0,Z|0,I|0,ma|0)|0;I=C;Z=Jd(t|0,Z|0,21)|0;Z=Ed(va|0,ha|0,Z|0,C|0)|0;ha=C;va=Qd(pa|0,L|0,666643,0)|0;va=Fd(ga&2097151|0,0,va|0,C|0)|0;ga=C;t=Qd(pa|0,L|0,470296,0)|0;t=Fd(Q|0,s|0,t|0,C|0)|0;s=C;Q=Qd(pa|0,L|0,654183,0)|0;Q=Fd(qa|0,y|0,Q|0,C|0)|0;y=C;qa=Qd(pa|0,L|0,-997805,-1)|0;qa=Fd(oa|0,k|0,qa|0,C|0)|0;k=C;oa=Qd(pa|0,L|0,136657,0)|0;oa=Fd(ka|0,da|0,oa|0,C|0)|0;da=C;L=Qd(pa|0,L|0,-683901,-1)|0;L=Fd(B|0,fa|0,L|0,C|0)|0;fa=C;B=Qd(ma|0,I|0,666643,0)|0;B=Fd(ja&2097151|0,0,B|0,C|0)|0;ja=C;pa=Qd(ma|0,I|0,470296,0)|0;pa=Fd(va|0,ga|0,pa|0,C|0)|0;ga=C;va=Qd(ma|0,I|0,654183,0)|0;va=Fd(t|0,s|0,va|0,C|0)|0;s=C;t=Qd(ma|0,I|0,-997805,-1)|0;t=Fd(Q|0,y|0,t|0,C|0)|0;y=C;Q=Qd(ma|0,I|0,136657,0)|0;Q=Fd(qa|0,k|0,Q|0,C|0)|0;k=C;I=Qd(ma|0,I|0,-683901,-1)|0;I=Fd(oa|0,da|0,I|0,C|0)|0;da=C;oa=Qd(Z|0,ha|0,666643,0)|0;oa=Fd(n&2097151|0,0,oa|0,C|0)|0;n=C;ma=Qd(Z|0,ha|0,470296,0)|0;ma=Fd(B|0,ja|0,ma|0,C|0)|0;ja=C;B=Qd(Z|0,ha|0,654183,0)|0;B=Fd(pa|0,ga|0,B|0,C|0)|0;ga=C;pa=Qd(Z|0,ha|0,-997805,-1)|0;pa=Fd(va|0,s|0,pa|0,C|0)|0;s=C;va=Qd(Z|0,ha|0,136657,0)|0;va=Fd(t|0,y|0,va|0,C|0)|0;y=C;ha=Qd(Z|0,ha|0,-683901,-1)|0;ha=Fd(Q|0,k|0,ha|0,C|0)|0;k=C;Q=Qd(wa|0,o|0,666643,0)|0;Z=C;t=Qd(wa|0,o|0,470296,0)|0;t=Fd(oa|0,n|0,t|0,C|0)|0;n=C;oa=Qd(wa|0,o|0,654183,0)|0;oa=Fd(ma|0,ja|0,oa|0,C|0)|0;ja=C;ma=Qd(wa|0,o|0,-997805,-1)|0;ma=Fd(B|0,ga|0,ma|0,C|0)|0;ga=C;B=Qd(wa|0,o|0,136657,0)|0;B=Fd(pa|0,s|0,B|0,C|0)|0;s=C;o=Qd(wa|0,o|0,-683901,-1)|0;o=Fd(va|0,y|0,o|0,C|0)|0;y=C;va=Qd(D|0,ca|0,666643,0)|0;wa=C;pa=Qd(D|0,ca|0,470296,0)|0;qa=C;ka=Qd(D|0,ca|0,654183,0)|0;ka=Fd(t|0,n|0,ka|0,C|0)|0;n=C;t=Qd(D|0,ca|0,-997805,-1)|0;t=Fd(oa|0,ja|0,t|0,C|0)|0;ja=C;oa=Qd(D|0,ca|0,136657,0)|0;oa=Fd(ma|0,ga|0,oa|0,C|0)|0;ga=C;ca=Qd(D|0,ca|0,-683901,-1)|0;ca=Fd(B|0,s|0,ca|0,C|0)|0;s=C;B=Qd(ua|0,x|0,666643,0)|0;na=Fd(B|0,C|0,ia|j|V&2031616|0,na|0)|0;V=C;j=Qd(ua|0,x|0,470296,0)|0;ia=C;B=Qd(ua|0,x|0,654183,0)|0;M=Fd(B|0,C|0,M&2097151|0,0)|0;Z=Fd(M|0,C|0,Q|0,Z|0)|0;qa=Fd(Z|0,C|0,pa|0,qa|0)|0;pa=C;Z=Qd(ua|0,x|0,-997805,-1)|0;Z=Fd(ka|0,n|0,Z|0,C|0)|0;n=C;ka=Qd(ua|0,x|0,136657,0)|0;ka=Fd(t|0,ja|0,ka|0,C|0)|0;ja=C;x=Qd(ua|0,x|0,-683901,-1)|0;x=Fd(oa|0,ga|0,x|0,C|0)|0;ga=C;oa=Fd(na|0,V|0,1048576,0)|0;oa=Gd(oa|0,C|0,21)|0;ua=C;e=Fd(j|0,ia|0,e&2097151|0,0)|0;wa=Fd(e|0,C|0,va|0,wa|0)|0;wa=Fd(wa|0,C|0,oa|0,ua|0)|0;va=C;ua=Jd(oa|0,ua|0,21)|0;ua=Ed(na|0,V|0,ua|0,C|0)|0;V=C;na=Fd(qa|0,pa|0,1048576,0)|0;na=Gd(na|0,C|0,21)|0;oa=C;n=Fd(na|0,oa|0,Z|0,n|0)|0;Z=C;oa=Jd(na|0,oa|0,21)|0;na=C;e=Fd(ka|0,ja|0,1048576,0)|0;e=Gd(e|0,C|0,21)|0;ia=C;ga=Fd(e|0,ia|0,x|0,ga|0)|0;x=C;ia=Jd(e|0,ia|0,21)|0;e=C;j=Fd(ca|0,s|0,1048576,0)|0;j=Gd(j|0,C|0,21)|0;t=C;y=Fd(j|0,t|0,o|0,y|0)|0;o=C;t=Jd(j|0,t|0,21)|0;t=Ed(ca|0,s|0,t|0,C|0)|0;s=C;ca=Fd(ha|0,k|0,1048576,0)|0;ca=Gd(ca|0,C|0,21)|0;j=C;da=Fd(ca|0,j|0,I|0,da|0)|0;I=C;j=Jd(ca|0,j|0,21)|0;j=Ed(ha|0,k|0,j|0,C|0)|0;k=C;ha=Fd(L|0,fa|0,1048576,0)|0;ha=Gd(ha|0,C|0,21)|0;ca=C;R=Fd(_|0,R|0,ha|0,ca|0)|0;_=C;ca=Jd(ha|0,ca|0,21)|0;ca=Ed(L|0,fa|0,ca|0,C|0)|0;fa=C;L=Fd(wa|0,va|0,1048576,0)|0;L=Gd(L|0,C|0,21)|0;ha=C;Q=Jd(L|0,ha|0,21)|0;M=C;B=Fd(n|0,Z|0,1048576,0)|0;B=Gd(B|0,C|0,21)|0;D=C;ma=Jd(B|0,D|0,21)|0;ma=Ed(n|0,Z|0,ma|0,C|0)|0;Z=C;n=Fd(ga|0,x|0,1048576,0)|0;n=Gd(n|0,C|0,21)|0;W=C;s=Fd(t|0,s|0,n|0,W|0)|0;t=C;W=Jd(n|0,W|0,21)|0;W=Ed(ga|0,x|0,W|0,C|0)|0;x=C;ga=Fd(y|0,o|0,1048576,0)|0;ga=Gd(ga|0,C|0,21)|0;n=C;k=Fd(j|0,k|0,ga|0,n|0)|0;j=C;n=Jd(ga|0,n|0,21)|0;n=Ed(y|0,o|0,n|0,C|0)|0;o=C;y=Fd(da|0,I|0,1048576,0)|0;y=Gd(y|0,C|0,21)|0;ga=C;fa=Fd(ca|0,fa|0,y|0,ga|0)|0;ca=C;ga=Jd(y|0,ga|0,21)|0;ga=Ed(da|0,I|0,ga|0,C|0)|0;I=C;da=Fd(R|0,_|0,1048576,0)|0;da=Gd(da|0,C|0,21)|0;y=C;f=Jd(da|0,y|0,21)|0;f=Ed(R|0,_|0,f|0,C|0)|0;_=C;R=Qd(da|0,y|0,666643,0)|0;R=Fd(ua|0,V|0,R|0,C|0)|0;V=C;ua=Qd(da|0,y|0,470296,0)|0;ta=C;sa=Qd(da|0,y|0,654183,0)|0;ra=C;H=Qd(da|0,y|0,-997805,-1)|0;H=Fd(ma|0,Z|0,H|0,C|0)|0;Z=C;ma=Qd(da|0,y|0,136657,0)|0;la=C;y=Qd(da|0,y|0,-683901,-1)|0;y=Fd(W|0,x|0,y|0,C|0)|0;x=C;W=Gd(R|0,V|0,21)|0;da=C;ta=Fd(wa|0,va|0,ua|0,ta|0)|0;ta=Fd(ta|0,C|0,W|0,da|0)|0;M=Ed(ta|0,C|0,Q|0,M|0)|0;Q=C;da=Jd(W|0,da|0,21)|0;da=Ed(R|0,V|0,da|0,C|0)|0;V=C;R=Gd(M|0,Q|0,21)|0;W=C;pa=Fd(sa|0,ra|0,qa|0,pa|0)|0;na=Ed(pa|0,C|0,oa|0,na|0)|0;ha=Fd(na|0,C|0,L|0,ha|0)|0;ha=Fd(ha|0,C|0,R|0,W|0)|0;L=C;W=Jd(R|0,W|0,21)|0;W=Ed(M|0,Q|0,W|0,C|0)|0;Q=C;M=Gd(ha|0,L|0,21)|0;R=C;Z=Fd(M|0,R|0,H|0,Z|0)|0;H=C;R=Jd(M|0,R|0,21)|0;R=Ed(ha|0,L|0,R|0,C|0)|0;L=C;ha=Gd(Z|0,H|0,21)|0;M=C;ja=Fd(ma|0,la|0,ka|0,ja|0)|0;e=Ed(ja|0,C|0,ia|0,e|0)|0;D=Fd(e|0,C|0,B|0,D|0)|0;D=Fd(D|0,C|0,ha|0,M|0)|0;B=C;M=Jd(ha|0,M|0,21)|0;M=Ed(Z|0,H|0,M|0,C|0)|0;H=C;Z=Gd(D|0,B|0,21)|0;ha=C;x=Fd(Z|0,ha|0,y|0,x|0)|0;y=C;ha=Jd(Z|0,ha|0,21)|0;ha=Ed(D|0,B|0,ha|0,C|0)|0;B=C;D=Gd(x|0,y|0,21)|0;Z=C;t=Fd(s|0,t|0,D|0,Z|0)|0;s=C;Z=Jd(D|0,Z|0,21)|0;Z=Ed(x|0,y|0,Z|0,C|0)|0;y=C;x=Gd(t|0,s|0,21)|0;D=C;o=Fd(x|0,D|0,n|0,o|0)|0;n=C;D=Jd(x|0,D|0,21)|0;D=Ed(t|0,s|0,D|0,C|0)|0;s=C;t=Gd(o|0,n|0,21)|0;x=C;j=Fd(k|0,j|0,t|0,x|0)|0;k=C;x=Jd(t|0,x|0,21)|0;x=Ed(o|0,n|0,x|0,C|0)|0;n=C;o=Gd(j|0,k|0,21)|0;t=C;I=Fd(o|0,t|0,ga|0,I|0)|0;ga=C;t=Jd(o|0,t|0,21)|0;t=Ed(j|0,k|0,t|0,C|0)|0;k=C;j=Gd(I|0,ga|0,21)|0;o=C;ca=Fd(fa|0,ca|0,j|0,o|0)|0;fa=C;o=Jd(j|0,o|0,21)|0;o=Ed(I|0,ga|0,o|0,C|0)|0;ga=C;I=Gd(ca|0,fa|0,21)|0;j=C;_=Fd(I|0,j|0,f|0,_|0)|0;f=C;j=Jd(I|0,j|0,21)|0;j=Ed(ca|0,fa|0,j|0,C|0)|0;fa=C;ca=Gd(_|0,f|0,21)|0;I=C;e=Jd(ca|0,I|0,21)|0;e=Ed(_|0,f|0,e|0,C|0)|0;f=C;_=Qd(ca|0,I|0,666643,0)|0;V=Fd(_|0,C|0,da|0,V|0)|0;da=C;_=Qd(ca|0,I|0,470296,0)|0;_=Fd(W|0,Q|0,_|0,C|0)|0;Q=C;W=Qd(ca|0,I|0,654183,0)|0;W=Fd(R|0,L|0,W|0,C|0)|0;L=C;R=Qd(ca|0,I|0,-997805,-1)|0;R=Fd(M|0,H|0,R|0,C|0)|0;H=C;M=Qd(ca|0,I|0,136657,0)|0;M=Fd(ha|0,B|0,M|0,C|0)|0;B=C;I=Qd(ca|0,I|0,-683901,-1)|0;I=Fd(Z|0,y|0,I|0,C|0)|0;y=C;Z=Gd(V|0,da|0,21)|0;ca=C;Q=Fd(_|0,Q|0,Z|0,ca|0)|0;_=C;ca=Jd(Z|0,ca|0,21)|0;ca=Ed(V|0,da|0,ca|0,C|0)|0;da=C;V=Gd(Q|0,_|0,21)|0;Z=C;L=Fd(W|0,L|0,V|0,Z|0)|0;W=C;Z=Jd(V|0,Z|0,21)|0;Z=Ed(Q|0,_|0,Z|0,C|0)|0;_=C;Q=Gd(L|0,W|0,21)|0;V=C;H=Fd(Q|0,V|0,R|0,H|0)|0;R=C;V=Jd(Q|0,V|0,21)|0;V=Ed(L|0,W|0,V|0,C|0)|0;W=C;L=Gd(H|0,R|0,21)|0;Q=C;B=Fd(M|0,B|0,L|0,Q|0)|0;M=C;Q=Jd(L|0,Q|0,21)|0;Q=Ed(H|0,R|0,Q|0,C|0)|0;R=C;H=Gd(B|0,M|0,21)|0;L=C;y=Fd(H|0,L|0,I|0,y|0)|0;I=C;L=Jd(H|0,L|0,21)|0;L=Ed(B|0,M|0,L|0,C|0)|0;M=C;B=Gd(y|0,I|0,21)|0;H=C;s=Fd(B|0,H|0,D|0,s|0)|0;D=C;H=Jd(B|0,H|0,21)|0;H=Ed(y|0,I|0,H|0,C|0)|0;I=C;y=Gd(s|0,D|0,21)|0;B=C;n=Fd(y|0,B|0,x|0,n|0)|0;x=C;B=Jd(y|0,B|0,21)|0;B=Ed(s|0,D|0,B|0,C|0)|0;D=C;s=Gd(n|0,x|0,21)|0;y=C;k=Fd(s|0,y|0,t|0,k|0)|0;t=C;y=Jd(s|0,y|0,21)|0;y=Ed(n|0,x|0,y|0,C|0)|0;x=C;n=Gd(k|0,t|0,21)|0;s=C;ga=Fd(n|0,s|0,o|0,ga|0)|0;o=C;s=Jd(n|0,s|0,21)|0;s=Ed(k|0,t|0,s|0,C|0)|0;t=C;k=Gd(ga|0,o|0,21)|0;n=C;fa=Fd(k|0,n|0,j|0,fa|0)|0;j=C;n=Jd(k|0,n|0,21)|0;n=Ed(ga|0,o|0,n|0,C|0)|0;o=C;ga=Gd(fa|0,j|0,21)|0;k=C;f=Fd(ga|0,k|0,e|0,f|0)|0;e=C;k=Jd(ga|0,k|0,21)|0;k=Ed(fa|0,j|0,k|0,C|0)|0;j=C;a[b>>0]=ca;b=Id(ca|0,da|0,8)|0;a[ea>>0]=b;b=Id(ca|0,da|0,16)|0;da=C;ca=Jd(Z|0,_|0,5)|0;a[ba>>0]=ca|b;b=Id(Z|0,_|0,3)|0;a[aa>>0]=b;b=Id(Z|0,_|0,11)|0;a[$>>0]=b;b=Id(Z|0,_|0,19)|0;_=C;Z=Jd(V|0,W|0,2)|0;a[Y>>0]=Z|b;b=Id(V|0,W|0,6)|0;a[X>>0]=b;b=Id(V|0,W|0,14)|0;W=C;V=Jd(Q|0,R|0,7)|0;a[U>>0]=V|b;b=Id(Q|0,R|0,1)|0;a[T>>0]=b;b=Id(Q|0,R|0,9)|0;a[S>>0]=b;b=Id(Q|0,R|0,17)|0;R=C;Q=Jd(L|0,M|0,4)|0;a[P>>0]=Q|b;b=Id(L|0,M|0,4)|0;a[O>>0]=b;b=Id(L|0,M|0,12)|0;a[N>>0]=b;b=Id(L|0,M|0,20)|0;M=C;L=Jd(H|0,I|0,1)|0;a[K>>0]=L|b;b=Id(H|0,I|0,7)|0;a[J>>0]=b;b=Id(H|0,I|0,15)|0;I=C;H=Jd(B|0,D|0,6)|0;a[G>>0]=H|b;b=Id(B|0,D|0,2)|0;a[F>>0]=b;b=Id(B|0,D|0,10)|0;a[E>>0]=b;b=Id(B|0,D|0,18)|0;D=C;B=Jd(y|0,x|0,3)|0;a[A>>0]=B|b;b=Id(y|0,x|0,5)|0;a[z>>0]=b;b=Id(y|0,x|0,13)|0;a[w>>0]=b;a[v>>0]=s;b=Id(s|0,t|0,8)|0;a[u>>0]=b;b=Id(s|0,t|0,16)|0;t=C;s=Jd(n|0,o|0,5)|0;a[r>>0]=s|b;b=Id(n|0,o|0,3)|0;a[q>>0]=b;b=Id(n|0,o|0,11)|0;a[p>>0]=b;b=Id(n|0,o|0,19)|0;o=C;n=Jd(k|0,j|0,2)|0;a[m>>0]=n|b;b=Id(k|0,j|0,6)|0;a[l>>0]=b;j=Id(k|0,j|0,14)|0;k=C;b=Jd(f|0,e|0,7)|0;a[i>>0]=j|b;b=Id(f|0,e|0,1)|0;a[h>>0]=b;b=Id(f|0,e|0,9)|0;a[g>>0]=b;b=Id(f|0,e|0,17)|0;a[c>>0]=b;return}function Yc(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0;x=i;n=i=i+63&-64;i=i+896|0;t=n+208|0;s=n+656|0;u=n+616|0;v=n+576|0;q=n;o=n+824|0;r=n+760|0;p=n+696|0;n=n+416|0;w=t+64|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;w=t;y=8;z=w+64|0;do{c[w>>2]=c[y>>2];w=w+4|0;y=y+4|0}while((w|0)<(z|0));Gb(t,j,32,0);Hb(t,o);a[o>>0]=(d[o>>0]|0)&248;m=o+31|0;a[m>>0]=(d[m>>0]|0)&63|64;k=q+64|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;w=q;y=8;z=w+64|0;do{c[w>>2]=c[y>>2];w=w+4|0;y=y+4|0}while((w|0)<(z|0));Gb(q,o+32|0,32,0);Gb(q,f,g,h);Hb(q,r);l=b+32|0;Ld(l|0,j+32|0,32)|0;Xc(r);Sc(n,r);Jc(s,n+80|0);Kc(u,n,s);Kc(v,n+40|0,s);Mc(b,v);Mc(t,u);w=b+31|0;a[w>>0]=(d[w>>0]|0)^(d[t>>0]|0)<<7;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;w=q;y=8;z=w+64|0;do{c[w>>2]=c[y>>2];w=w+4|0;y=y+4|0}while((w|0)<(z|0));Gb(q,b,64,0);Gb(q,f,g,h);Hb(q,p);Xc(p);T=a[p+2>>0]|0;F=d[p>>0]|0;ka=Jd(d[p+1>>0]|0|0,0,8)|0;gb=C;T=T&255;fb=Jd(T|0,0,16)|0;fb=ka|F|fb&2031616;F=Jd(d[p+3>>0]|0|0,0,8)|0;ka=C;oa=Jd(d[p+4>>0]|0|0,0,16)|0;ka=ka|C;ma=d[p+5>>0]|0;db=Jd(ma|0,0,24)|0;ka=Id(F|T|oa|db|0,ka|C|0,5)|0;ka=ka&2097151;db=a[p+7>>0]|0;oa=Jd(d[p+6>>0]|0|0,0,8)|0;T=C;db=db&255;F=Jd(db|0,0,16)|0;T=Id(oa|ma|F|0,T|C|0,2)|0;T=T&2097151;F=Jd(d[p+8>>0]|0|0,0,8)|0;ma=C;oa=Jd(d[p+9>>0]|0|0,0,16)|0;ma=ma|C;fa=d[p+10>>0]|0;k=Jd(fa|0,0,24)|0;ma=Id(F|db|oa|k|0,ma|C|0,7)|0;ma=ma&2097151;k=Jd(d[p+11>>0]|0|0,0,8)|0;oa=C;db=Jd(d[p+12>>0]|0|0,0,16)|0;oa=oa|C;F=d[p+13>>0]|0;I=Jd(F|0,0,24)|0;oa=Id(k|fa|db|I|0,oa|C|0,4)|0;oa=oa&2097151;I=a[p+15>>0]|0;db=Jd(d[p+14>>0]|0|0,0,8)|0;fa=C;I=I&255;k=Jd(I|0,0,16)|0;fa=Id(db|F|k|0,fa|C|0,1)|0;fa=fa&2097151;k=Jd(d[p+16>>0]|0|0,0,8)|0;F=C;db=Jd(d[p+17>>0]|0|0,0,16)|0;F=F|C;Bc=d[p+18>>0]|0;f=Jd(Bc|0,0,24)|0;F=Id(k|I|db|f|0,F|C|0,6)|0;F=F&2097151;f=a[p+20>>0]|0;db=Jd(d[p+19>>0]|0|0,0,8)|0;I=C;f=Jd(f&255|0,0,16)|0;I=Id(db|Bc|f|0,I|C|0,3)|0;f=C;Bc=a[p+23>>0]|0;db=d[p+21>>0]|0;k=Jd(d[p+22>>0]|0|0,0,8)|0;n=C;Bc=Bc&255;ua=Jd(Bc|0,0,16)|0;ua=k|db|ua&2031616;db=Jd(d[p+24>>0]|0|0,0,8)|0;k=C;cb=Jd(d[p+25>>0]|0|0,0,16)|0;k=k|C;na=d[p+26>>0]|0;ya=Jd(na|0,0,24)|0;k=Id(db|Bc|cb|ya|0,k|C|0,5)|0;k=k&2097151;ya=a[p+28>>0]|0;cb=Jd(d[p+27>>0]|0|0,0,8)|0;Bc=C;ya=ya&255;db=Jd(ya|0,0,16)|0;Bc=Id(cb|na|db|0,Bc|C|0,2)|0;Bc=Bc&2097151;db=Jd(d[p+29>>0]|0|0,0,8)|0;na=C;cb=Jd(d[p+30>>0]|0|0,0,16)|0;na=na|C;E=Jd(d[p+31>>0]|0|0,0,24)|0;na=Id(db|ya|cb|E|0,na|C|0,7)|0;E=C;cb=a[o+2>>0]|0;ya=d[o>>0]|0;db=Jd(d[o+1>>0]|0|0,0,8)|0;Ab=C;cb=cb&255;zb=Jd(cb|0,0,16)|0;zb=db|ya|zb&2031616;ya=Jd(d[o+3>>0]|0|0,0,8)|0;db=C;Ma=Jd(d[o+4>>0]|0|0,0,16)|0;db=db|C;Na=d[o+5>>0]|0;yc=Jd(Na|0,0,24)|0;db=Id(ya|cb|Ma|yc|0,db|C|0,5)|0;db=db&2097151;yc=a[o+7>>0]|0;Ma=Jd(d[o+6>>0]|0|0,0,8)|0;cb=C;yc=yc&255;ya=Jd(yc|0,0,16)|0;cb=Id(Ma|Na|ya|0,cb|C|0,2)|0;cb=cb&2097151;ya=Jd(d[o+8>>0]|0|0,0,8)|0;Na=C;Ma=Jd(d[o+9>>0]|0|0,0,16)|0;Na=Na|C;za=d[o+10>>0]|0;ta=Jd(za|0,0,24)|0;Na=Id(ya|yc|Ma|ta|0,Na|C|0,7)|0;Na=Na&2097151;ta=Jd(d[o+11>>0]|0|0,0,8)|0;Ma=C;yc=Jd(d[o+12>>0]|0|0,0,16)|0;Ma=Ma|C;ya=d[o+13>>0]|0;Ec=Jd(ya|0,0,24)|0;Ma=Id(ta|za|yc|Ec|0,Ma|C|0,4)|0;Ma=Ma&2097151;Ec=a[o+15>>0]|0;yc=Jd(d[o+14>>0]|0|0,0,8)|0;za=C;Ec=Ec&255;ta=Jd(Ec|0,0,16)|0;za=Id(yc|ya|ta|0,za|C|0,1)|0;za=za&2097151;ta=Jd(d[o+16>>0]|0|0,0,8)|0;ya=C;yc=Jd(d[o+17>>0]|0|0,0,16)|0;ya=ya|C;M=d[o+18>>0]|0;sa=Jd(M|0,0,24)|0;ya=Id(ta|Ec|yc|sa|0,ya|C|0,6)|0;ya=ya&2097151;sa=a[o+20>>0]|0;yc=Jd(d[o+19>>0]|0|0,0,8)|0;Ec=C;sa=Jd(sa&255|0,0,16)|0;Ec=Id(yc|M|sa|0,Ec|C|0,3)|0;sa=C;M=a[o+23>>0]|0;yc=d[o+21>>0]|0;ta=Jd(d[o+22>>0]|0|0,0,8)|0;h=C;M=M&255;j=Jd(M|0,0,16)|0;j=ta|yc|j&2031616;yc=Jd(d[o+24>>0]|0|0,0,8)|0;ta=C;q=Jd(d[o+25>>0]|0|0,0,16)|0;ta=ta|C;D=d[o+26>>0]|0;zc=Jd(D|0,0,24)|0;ta=Id(yc|M|q|zc|0,ta|C|0,5)|0;ta=ta&2097151;zc=a[o+28>>0]|0;q=Jd(d[o+27>>0]|0|0,0,8)|0;M=C;zc=zc&255;yc=Jd(zc|0,0,16)|0;M=Id(q|D|yc|0,M|C|0,2)|0;M=M&2097151;yc=Jd(d[o+29>>0]|0|0,0,8)|0;D=C;q=Jd(d[o+30>>0]|0|0,0,16)|0;D=D|C;p=Jd(d[m>>0]|0|0,0,24)|0;D=Id(yc|zc|q|p|0,D|C|0,7)|0;p=C;q=a[r+2>>0]|0;zc=d[r>>0]|0;yc=Jd(d[r+1>>0]|0|0,0,8)|0;V=C;q=q&255;Ac=Jd(q|0,0,16)|0;da=Jd(d[r+3>>0]|0|0,0,8)|0;ja=C;N=Jd(d[r+4>>0]|0|0,0,16)|0;ja=ja|C;pa=d[r+5>>0]|0;ca=Jd(pa|0,0,24)|0;ja=Id(da|q|N|ca|0,ja|C|0,5)|0;ca=a[r+7>>0]|0;N=Jd(d[r+6>>0]|0|0,0,8)|0;q=C;ca=ca&255;da=Jd(ca|0,0,16)|0;q=Id(N|pa|da|0,q|C|0,2)|0;da=Jd(d[r+8>>0]|0|0,0,8)|0;pa=C;N=Jd(d[r+9>>0]|0|0,0,16)|0;pa=pa|C;ia=d[r+10>>0]|0;y=Jd(ia|0,0,24)|0;pa=Id(da|ca|N|y|0,pa|C|0,7)|0;y=Jd(d[r+11>>0]|0|0,0,8)|0;N=C;ca=Jd(d[r+12>>0]|0|0,0,16)|0;N=N|C;da=d[r+13>>0]|0;_=Jd(da|0,0,24)|0;N=Id(y|ia|ca|_|0,N|C|0,4)|0;_=a[r+15>>0]|0;ca=Jd(d[r+14>>0]|0|0,0,8)|0;ia=C;_=_&255;y=Jd(_|0,0,16)|0;ia=Id(ca|da|y|0,ia|C|0,1)|0;y=Jd(d[r+16>>0]|0|0,0,8)|0;da=C;ca=Jd(d[r+17>>0]|0|0,0,16)|0;da=da|C;aa=d[r+18>>0]|0;Z=Jd(aa|0,0,24)|0;da=Id(y|_|ca|Z|0,da|C|0,6)|0;Z=a[r+20>>0]|0;ca=Jd(d[r+19>>0]|0|0,0,8)|0;_=C;Z=Jd(Z&255|0,0,16)|0;_=Id(ca|aa|Z|0,_|C|0,3)|0;Z=C;aa=a[r+23>>0]|0;ca=d[r+21>>0]|0;y=Jd(d[r+22>>0]|0|0,0,8)|0;ga=C;aa=aa&255;W=Jd(aa|0,0,16)|0;X=Jd(d[r+24>>0]|0|0,0,8)|0;ba=C;m=Jd(d[r+25>>0]|0|0,0,16)|0;ba=ba|C;u=d[r+26>>0]|0;v=Jd(u|0,0,24)|0;ba=Id(X|aa|m|v|0,ba|C|0,5)|0;v=a[r+28>>0]|0;m=Jd(d[r+27>>0]|0|0,0,8)|0;aa=C;v=v&255;X=Jd(v|0,0,16)|0;aa=Id(m|u|X|0,aa|C|0,2)|0;X=Jd(d[r+29>>0]|0|0,0,8)|0;u=C;m=Jd(d[r+30>>0]|0|0,0,16)|0;u=u|C;z=Jd(d[r+31>>0]|0|0,0,24)|0;u=Id(X|v|m|z|0,u|C|0,7)|0;z=C;m=Qd(zb|0,Ab|0,fb|0,gb|0)|0;m=Fd(yc|zc|Ac&2031616|0,V|0,m|0,C|0)|0;V=C;Ac=Qd(db|0,0,fb|0,gb|0)|0;zc=C;yc=Qd(zb|0,Ab|0,ka|0,0)|0;v=C;X=Qd(cb|0,0,fb|0,gb|0)|0;K=C;R=Qd(db|0,0,ka|0,0)|0;tc=C;t=Qd(zb|0,Ab|0,T|0,0)|0;t=Fd(R|0,tc|0,t|0,C|0)|0;K=Fd(t|0,C|0,X|0,K|0)|0;q=Fd(K|0,C|0,q&2097151|0,0)|0;K=C;X=Qd(Na|0,0,fb|0,gb|0)|0;t=C;tc=Qd(cb|0,0,ka|0,0)|0;R=C;xc=Qd(db|0,0,T|0,0)|0;wc=C;vc=Qd(zb|0,Ab|0,ma|0,0)|0;uc=C;ic=Qd(Ma|0,0,fb|0,gb|0)|0;L=C;kc=Qd(Na|0,0,ka|0,0)|0;Q=C;mc=Qd(cb|0,0,T|0,0)|0;jc=C;nc=Qd(db|0,0,ma|0,0)|0;oc=C;lc=Qd(zb|0,Ab|0,oa|0,0)|0;lc=Fd(nc|0,oc|0,lc|0,C|0)|0;jc=Fd(lc|0,C|0,mc|0,jc|0)|0;Q=Fd(jc|0,C|0,kc|0,Q|0)|0;L=Fd(Q|0,C|0,ic|0,L|0)|0;N=Fd(L|0,C|0,N&2097151|0,0)|0;L=C;ic=Qd(za|0,0,fb|0,gb|0)|0;Q=C;kc=Qd(Ma|0,0,ka|0,0)|0;jc=C;mc=Qd(Na|0,0,T|0,0)|0;lc=C;oc=Qd(cb|0,0,ma|0,0)|0;nc=C;sc=Qd(db|0,0,oa|0,0)|0;rc=C;qc=Qd(zb|0,Ab|0,fa|0,0)|0;pc=C;g=Qd(ya|0,0,fb|0,gb|0)|0;ea=C;Xb=Qd(za|0,0,ka|0,0)|0;s=C;Zb=Qd(Ma|0,0,T|0,0)|0;Wb=C;$b=Qd(Na|0,0,ma|0,0)|0;Yb=C;bc=Qd(cb|0,0,oa|0,0)|0;_b=C;cc=Qd(db|0,0,fa|0,0)|0;dc=C;ac=Qd(zb|0,Ab|0,F|0,0)|0;ac=Fd(cc|0,dc|0,ac|0,C|0)|0;_b=Fd(ac|0,C|0,bc|0,_b|0)|0;Yb=Fd(_b|0,C|0,$b|0,Yb|0)|0;Wb=Fd(Yb|0,C|0,Zb|0,Wb|0)|0;s=Fd(Wb|0,C|0,Xb|0,s|0)|0;ea=Fd(s|0,C|0,g|0,ea|0)|0;da=Fd(ea|0,C|0,da&2097151|0,0)|0;ea=C;g=Qd(Ec|0,sa|0,fb|0,gb|0)|0;s=C;Xb=Qd(ya|0,0,ka|0,0)|0;Wb=C;Zb=Qd(za|0,0,T|0,0)|0;Yb=C;$b=Qd(Ma|0,0,ma|0,0)|0;_b=C;bc=Qd(Na|0,0,oa|0,0)|0;ac=C;dc=Qd(cb|0,0,fa|0,0)|0;cc=C;hc=Qd(db|0,0,F|0,0)|0;gc=C;fc=Qd(zb|0,Ab|0,I|0,f|0)|0;ec=C;ra=Qd(j|0,h|0,fb|0,gb|0)|0;Db=C;Eb=Qd(Ec|0,sa|0,ka|0,0)|0;Fb=C;Ib=Qd(ya|0,0,T|0,0)|0;Jb=C;Kb=Qd(za|0,0,ma|0,0)|0;Lb=C;Mb=Qd(Ma|0,0,oa|0,0)|0;Nb=C;Ob=Qd(Na|0,0,fa|0,0)|0;Pb=C;Qb=Qd(cb|0,0,F|0,0)|0;Rb=C;Tb=Qd(db|0,0,I|0,f|0)|0;Ub=C;Vb=Qd(zb|0,Ab|0,ua|0,n|0)|0;Vb=Fd(Tb|0,Ub|0,Vb|0,C|0)|0;Rb=Fd(Vb|0,C|0,Qb|0,Rb|0)|0;Pb=Fd(Rb|0,C|0,Ob|0,Pb|0)|0;Nb=Fd(Pb|0,C|0,Mb|0,Nb|0)|0;Lb=Fd(Nb|0,C|0,Kb|0,Lb|0)|0;Jb=Fd(Lb|0,C|0,Ib|0,Jb|0)|0;Fb=Fd(Jb|0,C|0,Eb|0,Fb|0)|0;Db=Fd(Fb|0,C|0,ra|0,Db|0)|0;ga=Fd(Db|0,C|0,y|ca|W&2031616|0,ga|0)|0;W=C;ca=Qd(ta|0,0,fb|0,gb|0)|0;y=C;Db=Qd(j|0,h|0,ka|0,0)|0;ra=C;Fb=Qd(Ec|0,sa|0,T|0,0)|0;Eb=C;Jb=Qd(ya|0,0,ma|0,0)|0;Ib=C;Lb=Qd(za|0,0,oa|0,0)|0;Kb=C;Nb=Qd(Ma|0,0,fa|0,0)|0;Mb=C;Pb=Qd(Na|0,0,F|0,0)|0;Ob=C;Rb=Qd(cb|0,0,I|0,f|0)|0;Qb=C;Vb=Qd(db|0,0,ua|0,n|0)|0;Ub=C;Tb=Qd(zb|0,Ab|0,k|0,0)|0;Sb=C;ib=Qd(M|0,0,fb|0,gb|0)|0;S=C;kb=Qd(ta|0,0,ka|0,0)|0;hb=C;mb=Qd(j|0,h|0,T|0,0)|0;jb=C;ob=Qd(Ec|0,sa|0,ma|0,0)|0;lb=C;qb=Qd(ya|0,0,oa|0,0)|0;nb=C;sb=Qd(za|0,0,fa|0,0)|0;pb=C;ub=Qd(Ma|0,0,F|0,0)|0;rb=C;wb=Qd(Na|0,0,I|0,f|0)|0;tb=C;yb=Qd(cb|0,0,ua|0,n|0)|0;vb=C;Bb=Qd(db|0,0,k|0,0)|0;Cb=C;xb=Qd(zb|0,Ab|0,Bc|0,0)|0;xb=Fd(Bb|0,Cb|0,xb|0,C|0)|0;vb=Fd(xb|0,C|0,yb|0,vb|0)|0;tb=Fd(vb|0,C|0,wb|0,tb|0)|0;rb=Fd(tb|0,C|0,ub|0,rb|0)|0;pb=Fd(rb|0,C|0,sb|0,pb|0)|0;nb=Fd(pb|0,C|0,qb|0,nb|0)|0;lb=Fd(nb|0,C|0,ob|0,lb|0)|0;jb=Fd(lb|0,C|0,mb|0,jb|0)|0;hb=Fd(jb|0,C|0,kb|0,hb|0)|0;S=Fd(hb|0,C|0,ib|0,S|0)|0;aa=Fd(S|0,C|0,aa&2097151|0,0)|0;S=C;gb=Qd(D|0,p|0,fb|0,gb|0)|0;fb=C;ib=Qd(M|0,0,ka|0,0)|0;hb=C;kb=Qd(ta|0,0,T|0,0)|0;jb=C;mb=Qd(j|0,h|0,ma|0,0)|0;lb=C;ob=Qd(Ec|0,sa|0,oa|0,0)|0;nb=C;qb=Qd(ya|0,0,fa|0,0)|0;pb=C;sb=Qd(za|0,0,F|0,0)|0;rb=C;ub=Qd(Ma|0,0,I|0,f|0)|0;tb=C;wb=Qd(Na|0,0,ua|0,n|0)|0;vb=C;yb=Qd(cb|0,0,k|0,0)|0;xb=C;Cb=Qd(db|0,0,Bc|0,0)|0;Bb=C;Ab=Qd(zb|0,Ab|0,na|0,E|0)|0;zb=C;ka=Qd(D|0,p|0,ka|0,0)|0;Y=C;Qa=Qd(M|0,0,T|0,0)|0;O=C;Sa=Qd(ta|0,0,ma|0,0)|0;Pa=C;Ua=Qd(j|0,h|0,oa|0,0)|0;Ra=C;Wa=Qd(Ec|0,sa|0,fa|0,0)|0;Ta=C;Ya=Qd(ya|0,0,F|0,0)|0;Va=C;_a=Qd(za|0,0,I|0,f|0)|0;Xa=C;ab=Qd(Ma|0,0,ua|0,n|0)|0;Za=C;eb=Qd(Na|0,0,k|0,0)|0;$a=C;B=Qd(cb|0,0,Bc|0,0)|0;bb=C;db=Qd(db|0,0,na|0,E|0)|0;db=Fd(B|0,bb|0,db|0,C|0)|0;$a=Fd(db|0,C|0,eb|0,$a|0)|0;Za=Fd($a|0,C|0,ab|0,Za|0)|0;Xa=Fd(Za|0,C|0,_a|0,Xa|0)|0;Va=Fd(Xa|0,C|0,Ya|0,Va|0)|0;Ta=Fd(Va|0,C|0,Wa|0,Ta|0)|0;Ra=Fd(Ta|0,C|0,Ua|0,Ra|0)|0;Pa=Fd(Ra|0,C|0,Sa|0,Pa|0)|0;O=Fd(Pa|0,C|0,Qa|0,O|0)|0;Y=Fd(O|0,C|0,ka|0,Y|0)|0;ka=C;T=Qd(D|0,p|0,T|0,0)|0;O=C;Qa=Qd(M|0,0,ma|0,0)|0;Pa=C;Sa=Qd(ta|0,0,oa|0,0)|0;Ra=C;Ua=Qd(j|0,h|0,fa|0,0)|0;Ta=C;Wa=Qd(Ec|0,sa|0,F|0,0)|0;Va=C;Ya=Qd(ya|0,0,I|0,f|0)|0;Xa=C;_a=Qd(za|0,0,ua|0,n|0)|0;Za=C;ab=Qd(Ma|0,0,k|0,0)|0;$a=C;eb=Qd(Na|0,0,Bc|0,0)|0;db=C;cb=Qd(cb|0,0,na|0,E|0)|0;bb=C;ma=Qd(D|0,p|0,ma|0,0)|0;B=C;Ca=Qd(M|0,0,oa|0,0)|0;qa=C;Ea=Qd(ta|0,0,fa|0,0)|0;Ba=C;Ga=Qd(j|0,h|0,F|0,0)|0;Da=C;Ia=Qd(Ec|0,sa|0,I|0,f|0)|0;Fa=C;Ka=Qd(ya|0,0,ua|0,n|0)|0;Ha=C;Oa=Qd(za|0,0,k|0,0)|0;Ja=C;J=Qd(Ma|0,0,Bc|0,0)|0;La=C;Na=Qd(Na|0,0,na|0,E|0)|0;Na=Fd(J|0,La|0,Na|0,C|0)|0;Ja=Fd(Na|0,C|0,Oa|0,Ja|0)|0;Ha=Fd(Ja|0,C|0,Ka|0,Ha|0)|0;Fa=Fd(Ha|0,C|0,Ia|0,Fa|0)|0;Da=Fd(Fa|0,C|0,Ga|0,Da|0)|0;Ba=Fd(Da|0,C|0,Ea|0,Ba|0)|0;qa=Fd(Ba|0,C|0,Ca|0,qa|0)|0;B=Fd(qa|0,C|0,ma|0,B|0)|0;ma=C;oa=Qd(D|0,p|0,oa|0,0)|0;qa=C;Ca=Qd(M|0,0,fa|0,0)|0;Ba=C;Ea=Qd(ta|0,0,F|0,0)|0;Da=C;Ga=Qd(j|0,h|0,I|0,f|0)|0;Fa=C;Ia=Qd(Ec|0,sa|0,ua|0,n|0)|0;Ha=C;Ka=Qd(ya|0,0,k|0,0)|0;Ja=C;Oa=Qd(za|0,0,Bc|0,0)|0;Na=C;Ma=Qd(Ma|0,0,na|0,E|0)|0;La=C;fa=Qd(D|0,p|0,fa|0,0)|0;J=C;G=Qd(M|0,0,F|0,0)|0;la=C;P=Qd(ta|0,0,I|0,f|0)|0;$=C;wa=Qd(j|0,h|0,ua|0,n|0)|0;A=C;Aa=Qd(Ec|0,sa|0,k|0,0)|0;va=C;H=Qd(ya|0,0,Bc|0,0)|0;xa=C;za=Qd(za|0,0,na|0,E|0)|0;za=Fd(H|0,xa|0,za|0,C|0)|0;va=Fd(za|0,C|0,Aa|0,va|0)|0;A=Fd(va|0,C|0,wa|0,A|0)|0;$=Fd(A|0,C|0,P|0,$|0)|0;la=Fd($|0,C|0,G|0,la|0)|0;J=Fd(la|0,C|0,fa|0,J|0)|0;fa=C;F=Qd(D|0,p|0,F|0,0)|0;la=C;G=Qd(M|0,0,I|0,f|0)|0;$=C;P=Qd(ta|0,0,ua|0,n|0)|0;A=C;wa=Qd(j|0,h|0,k|0,0)|0;va=C;Aa=Qd(Ec|0,sa|0,Bc|0,0)|0;za=C;ya=Qd(ya|0,0,na|0,E|0)|0;xa=C;f=Qd(D|0,p|0,I|0,f|0)|0;I=C;H=Qd(M|0,0,ua|0,n|0)|0;U=C;w=Qd(ta|0,0,k|0,0)|0;ha=C;Cc=Qd(j|0,h|0,Bc|0,0)|0;Dc=C;sa=Qd(Ec|0,sa|0,na|0,E|0)|0;sa=Fd(Cc|0,Dc|0,sa|0,C|0)|0;ha=Fd(sa|0,C|0,w|0,ha|0)|0;U=Fd(ha|0,C|0,H|0,U|0)|0;I=Fd(U|0,C|0,f|0,I|0)|0;f=C;n=Qd(D|0,p|0,ua|0,n|0)|0;ua=C;U=Qd(M|0,0,k|0,0)|0;H=C;ha=Qd(ta|0,0,Bc|0,0)|0;w=C;h=Qd(j|0,h|0,na|0,E|0)|0;j=C;k=Qd(D|0,p|0,k|0,0)|0;sa=C;Dc=Qd(M|0,0,Bc|0,0)|0;Cc=C;ta=Qd(ta|0,0,na|0,E|0)|0;ta=Fd(Dc|0,Cc|0,ta|0,C|0)|0;sa=Fd(ta|0,C|0,k|0,sa|0)|0;k=C;Bc=Qd(D|0,p|0,Bc|0,0)|0;ta=C;M=Qd(M|0,0,na|0,E|0)|0;M=Fd(Bc|0,ta|0,M|0,C|0)|0;ta=C;E=Qd(D|0,p|0,na|0,E|0)|0;na=C;p=Fd(m|0,V|0,1048576,0)|0;p=Id(p|0,C|0,21)|0;D=C;v=Fd(Ac|0,zc|0,yc|0,v|0)|0;v=Fd(v|0,C|0,p|0,D|0)|0;ja=Fd(v|0,C|0,ja&2097151|0,0)|0;v=C;D=Jd(p|0,D|0,21)|0;D=Ed(m|0,V|0,D|0,C|0)|0;V=C;m=Fd(q|0,K|0,1048576,0)|0;m=Id(m|0,C|0,21)|0;p=C;uc=Fd(xc|0,wc|0,vc|0,uc|0)|0;R=Fd(uc|0,C|0,tc|0,R|0)|0;t=Fd(R|0,C|0,X|0,t|0)|0;pa=Fd(t|0,C|0,pa&2097151|0,0)|0;pa=Fd(pa|0,C|0,m|0,p|0)|0;t=C;p=Jd(m|0,p|0,21)|0;m=C;X=Fd(N|0,L|0,1048576,0)|0;X=Gd(X|0,C|0,21)|0;R=C;pc=Fd(sc|0,rc|0,qc|0,pc|0)|0;nc=Fd(pc|0,C|0,oc|0,nc|0)|0;lc=Fd(nc|0,C|0,mc|0,lc|0)|0;jc=Fd(lc|0,C|0,kc|0,jc|0)|0;Q=Fd(jc|0,C|0,ic|0,Q|0)|0;ia=Fd(Q|0,C|0,ia&2097151|0,0)|0;ia=Fd(ia|0,C|0,X|0,R|0)|0;Q=C;R=Jd(X|0,R|0,21)|0;R=Ed(N|0,L|0,R|0,C|0)|0;L=C;N=Fd(da|0,ea|0,1048576,0)|0;N=Gd(N|0,C|0,21)|0;X=C;ec=Fd(hc|0,gc|0,fc|0,ec|0)|0;cc=Fd(ec|0,C|0,dc|0,cc|0)|0;ac=Fd(cc|0,C|0,bc|0,ac|0)|0;_b=Fd(ac|0,C|0,$b|0,_b|0)|0;Yb=Fd(_b|0,C|0,Zb|0,Yb|0)|0;Wb=Fd(Yb|0,C|0,Xb|0,Wb|0)|0;s=Fd(Wb|0,C|0,g|0,s|0)|0;Z=Fd(s|0,C|0,_|0,Z|0)|0;Z=Fd(Z|0,C|0,N|0,X|0)|0;_=C;X=Jd(N|0,X|0,21)|0;N=C;s=Fd(ga|0,W|0,1048576,0)|0;s=Gd(s|0,C|0,21)|0;g=C;Sb=Fd(Vb|0,Ub|0,Tb|0,Sb|0)|0;Qb=Fd(Sb|0,C|0,Rb|0,Qb|0)|0;Ob=Fd(Qb|0,C|0,Pb|0,Ob|0)|0;Mb=Fd(Ob|0,C|0,Nb|0,Mb|0)|0;Kb=Fd(Mb|0,C|0,Lb|0,Kb|0)|0;Ib=Fd(Kb|0,C|0,Jb|0,Ib|0)|0;Eb=Fd(Ib|0,C|0,Fb|0,Eb|0)|0;ra=Fd(Eb|0,C|0,Db|0,ra|0)|0;y=Fd(ra|0,C|0,ca|0,y|0)|0;ba=Fd(y|0,C|0,ba&2097151|0,0)|0;ba=Fd(ba|0,C|0,s|0,g|0)|0;y=C;g=Jd(s|0,g|0,21)|0;s=C;ca=Fd(aa|0,S|0,1048576,0)|0;ca=Gd(ca|0,C|0,21)|0;ra=C;zb=Fd(Cb|0,Bb|0,Ab|0,zb|0)|0;xb=Fd(zb|0,C|0,yb|0,xb|0)|0;vb=Fd(xb|0,C|0,wb|0,vb|0)|0;tb=Fd(vb|0,C|0,ub|0,tb|0)|0;rb=Fd(tb|0,C|0,sb|0,rb|0)|0;pb=Fd(rb|0,C|0,qb|0,pb|0)|0;nb=Fd(pb|0,C|0,ob|0,nb|0)|0;lb=Fd(nb|0,C|0,mb|0,lb|0)|0;jb=Fd(lb|0,C|0,kb|0,jb|0)|0;hb=Fd(jb|0,C|0,ib|0,hb|0)|0;fb=Fd(hb|0,C|0,gb|0,fb|0)|0;z=Fd(fb|0,C|0,u|0,z|0)|0;z=Fd(z|0,C|0,ca|0,ra|0)|0;u=C;ra=Jd(ca|0,ra|0,21)|0;ra=Ed(aa|0,S|0,ra|0,C|0)|0;S=C;aa=Fd(Y|0,ka|0,1048576,0)|0;aa=Gd(aa|0,C|0,21)|0;ca=C;bb=Fd(eb|0,db|0,cb|0,bb|0)|0;$a=Fd(bb|0,C|0,ab|0,$a|0)|0;Za=Fd($a|0,C|0,_a|0,Za|0)|0;Xa=Fd(Za|0,C|0,Ya|0,Xa|0)|0;Va=Fd(Xa|0,C|0,Wa|0,Va|0)|0;Ta=Fd(Va|0,C|0,Ua|0,Ta|0)|0;Ra=Fd(Ta|0,C|0,Sa|0,Ra|0)|0;Pa=Fd(Ra|0,C|0,Qa|0,Pa|0)|0;O=Fd(Pa|0,C|0,T|0,O|0)|0;O=Fd(O|0,C|0,aa|0,ca|0)|0;T=C;ca=Jd(aa|0,ca|0,21)|0;ca=Ed(Y|0,ka|0,ca|0,C|0)|0;ka=C;Y=Fd(B|0,ma|0,1048576,0)|0;Y=Gd(Y|0,C|0,21)|0;aa=C;La=Fd(Oa|0,Na|0,Ma|0,La|0)|0;Ja=Fd(La|0,C|0,Ka|0,Ja|0)|0;Ha=Fd(Ja|0,C|0,Ia|0,Ha|0)|0;Fa=Fd(Ha|0,C|0,Ga|0,Fa|0)|0;Da=Fd(Fa|0,C|0,Ea|0,Da|0)|0;Ba=Fd(Da|0,C|0,Ca|0,Ba|0)|0;qa=Fd(Ba|0,C|0,oa|0,qa|0)|0;qa=Fd(qa|0,C|0,Y|0,aa|0)|0;oa=C;aa=Jd(Y|0,aa|0,21)|0;aa=Ed(B|0,ma|0,aa|0,C|0)|0;ma=C;B=Fd(J|0,fa|0,1048576,0)|0;B=Gd(B|0,C|0,21)|0;Y=C;xa=Fd(Aa|0,za|0,ya|0,xa|0)|0;va=Fd(xa|0,C|0,wa|0,va|0)|0;A=Fd(va|0,C|0,P|0,A|0)|0;$=Fd(A|0,C|0,G|0,$|0)|0;la=Fd($|0,C|0,F|0,la|0)|0;la=Fd(la|0,C|0,B|0,Y|0)|0;F=C;Y=Jd(B|0,Y|0,21)|0;Y=Ed(J|0,fa|0,Y|0,C|0)|0;fa=C;J=Fd(I|0,f|0,1048576,0)|0;J=Gd(J|0,C|0,21)|0;B=C;j=Fd(ha|0,w|0,h|0,j|0)|0;H=Fd(j|0,C|0,U|0,H|0)|0;ua=Fd(H|0,C|0,n|0,ua|0)|0;ua=Fd(ua|0,C|0,J|0,B|0)|0;n=C;B=Jd(J|0,B|0,21)|0;B=Ed(I|0,f|0,B|0,C|0)|0;f=C;I=Fd(sa|0,k|0,1048576,0)|0;I=Gd(I|0,C|0,21)|0;J=C;ta=Fd(M|0,ta|0,I|0,J|0)|0;M=C;J=Jd(I|0,J|0,21)|0;J=Ed(sa|0,k|0,J|0,C|0)|0;k=C;sa=Fd(E|0,na|0,1048576,0)|0;sa=Gd(sa|0,C|0,21)|0;I=C;H=Jd(sa|0,I|0,21)|0;H=Ed(E|0,na|0,H|0,C|0)|0;na=C;E=Fd(ja|0,v|0,1048576,0)|0;E=Id(E|0,C|0,21)|0;U=C;j=Jd(E|0,U|0,21)|0;j=Ed(ja|0,v|0,j|0,C|0)|0;v=C;ja=Fd(pa|0,t|0,1048576,0)|0;ja=Gd(ja|0,C|0,21)|0;h=C;L=Fd(ja|0,h|0,R|0,L|0)|0;R=C;h=Jd(ja|0,h|0,21)|0;h=Ed(pa|0,t|0,h|0,C|0)|0;t=C;pa=Fd(ia|0,Q|0,1048576,0)|0;pa=Gd(pa|0,C|0,21)|0;ja=C;w=Jd(pa|0,ja|0,21)|0;w=Ed(ia|0,Q|0,w|0,C|0)|0;Q=C;ia=Fd(Z|0,_|0,1048576,0)|0;ia=Gd(ia|0,C|0,21)|0;ha=C;$=Jd(ia|0,ha|0,21)|0;G=C;A=Fd(ba|0,y|0,1048576,0)|0;A=Gd(A|0,C|0,21)|0;P=C;S=Fd(A|0,P|0,ra|0,S|0)|0;ra=C;P=Jd(A|0,P|0,21)|0;P=Ed(ba|0,y|0,P|0,C|0)|0;y=C;ba=Fd(z|0,u|0,1048576,0)|0;ba=Gd(ba|0,C|0,21)|0;A=C;ka=Fd(ca|0,ka|0,ba|0,A|0)|0;ca=C;A=Jd(ba|0,A|0,21)|0;A=Ed(z|0,u|0,A|0,C|0)|0;u=C;z=Fd(O|0,T|0,1048576,0)|0;z=Gd(z|0,C|0,21)|0;ba=C;ma=Fd(aa|0,ma|0,z|0,ba|0)|0;aa=C;ba=Jd(z|0,ba|0,21)|0;ba=Ed(O|0,T|0,ba|0,C|0)|0;T=C;O=Fd(qa|0,oa|0,1048576,0)|0;O=Gd(O|0,C|0,21)|0;z=C;fa=Fd(Y|0,fa|0,O|0,z|0)|0;Y=C;z=Jd(O|0,z|0,21)|0;z=Ed(qa|0,oa|0,z|0,C|0)|0;oa=C;qa=Fd(la|0,F|0,1048576,0)|0;qa=Gd(qa|0,C|0,21)|0;O=C;f=Fd(qa|0,O|0,B|0,f|0)|0;B=C;O=Jd(qa|0,O|0,21)|0;O=Ed(la|0,F|0,O|0,C|0)|0;F=C;la=Fd(ua|0,n|0,1048576,0)|0;la=Gd(la|0,C|0,21)|0;qa=C;k=Fd(la|0,qa|0,J|0,k|0)|0;J=C;qa=Jd(la|0,qa|0,21)|0;qa=Ed(ua|0,n|0,qa|0,C|0)|0;n=C;ua=Fd(ta|0,M|0,1048576,0)|0;ua=Gd(ua|0,C|0,21)|0;la=C;na=Fd(ua|0,la|0,H|0,na|0)|0;H=C;la=Jd(ua|0,la|0,21)|0;la=Ed(ta|0,M|0,la|0,C|0)|0;M=C;ta=Qd(sa|0,I|0,666643,0)|0;u=Fd(ta|0,C|0,A|0,u|0)|0;A=C;ta=Qd(sa|0,I|0,470296,0)|0;ca=Fd(ta|0,C|0,ka|0,ca|0)|0;ka=C;ta=Qd(sa|0,I|0,654183,0)|0;T=Fd(ta|0,C|0,ba|0,T|0)|0;ba=C;ta=Qd(sa|0,I|0,-997805,-1)|0;aa=Fd(ta|0,C|0,ma|0,aa|0)|0;ma=C;ta=Qd(sa|0,I|0,136657,0)|0;oa=Fd(ta|0,C|0,z|0,oa|0)|0;z=C;I=Qd(sa|0,I|0,-683901,-1)|0;I=Fd(fa|0,Y|0,I|0,C|0)|0;Y=C;fa=Qd(na|0,H|0,666643,0)|0;ra=Fd(fa|0,C|0,S|0,ra|0)|0;S=C;fa=Qd(na|0,H|0,470296,0)|0;A=Fd(fa|0,C|0,u|0,A|0)|0;u=C;fa=Qd(na|0,H|0,654183,0)|0;ka=Fd(fa|0,C|0,ca|0,ka|0)|0;ca=C;fa=Qd(na|0,H|0,-997805,-1)|0;ba=Fd(fa|0,C|0,T|0,ba|0)|0;T=C;fa=Qd(na|0,H|0,136657,0)|0;ma=Fd(fa|0,C|0,aa|0,ma|0)|0;aa=C;H=Qd(na|0,H|0,-683901,-1)|0;H=Fd(oa|0,z|0,H|0,C|0)|0;z=C;oa=Qd(la|0,M|0,666643,0)|0;y=Fd(oa|0,C|0,P|0,y|0)|0;P=C;oa=Qd(la|0,M|0,470296,0)|0;S=Fd(oa|0,C|0,ra|0,S|0)|0;ra=C;oa=Qd(la|0,M|0,654183,0)|0;u=Fd(oa|0,C|0,A|0,u|0)|0;A=C;oa=Qd(la|0,M|0,-997805,-1)|0;ca=Fd(oa|0,C|0,ka|0,ca|0)|0;ka=C;oa=Qd(la|0,M|0,136657,0)|0;T=Fd(oa|0,C|0,ba|0,T|0)|0;ba=C;M=Qd(la|0,M|0,-683901,-1)|0;M=Fd(ma|0,aa|0,M|0,C|0)|0;aa=C;ma=Qd(k|0,J|0,666643,0)|0;la=C;oa=Qd(k|0,J|0,470296,0)|0;P=Fd(oa|0,C|0,y|0,P|0)|0;y=C;oa=Qd(k|0,J|0,654183,0)|0;ra=Fd(oa|0,C|0,S|0,ra|0)|0;S=C;oa=Qd(k|0,J|0,-997805,-1)|0;A=Fd(oa|0,C|0,u|0,A|0)|0;u=C;oa=Qd(k|0,J|0,136657,0)|0;ka=Fd(oa|0,C|0,ca|0,ka|0)|0;ca=C;J=Qd(k|0,J|0,-683901,-1)|0;J=Fd(T|0,ba|0,J|0,C|0)|0;ba=C;T=Qd(qa|0,n|0,666643,0)|0;k=C;oa=Qd(qa|0,n|0,470296,0)|0;na=C;fa=Qd(qa|0,n|0,654183,0)|0;y=Fd(fa|0,C|0,P|0,y|0)|0;P=C;fa=Qd(qa|0,n|0,-997805,-1)|0;fa=Fd(ra|0,S|0,fa|0,C|0)|0;S=C;ra=Qd(qa|0,n|0,136657,0)|0;u=Fd(ra|0,C|0,A|0,u|0)|0;A=C;n=Qd(qa|0,n|0,-683901,-1)|0;n=Fd(ka|0,ca|0,n|0,C|0)|0;ca=C;ka=Qd(f|0,B|0,666643,0)|0;ka=Fd(pa|0,ja|0,ka|0,C|0)|0;ea=Fd(ka|0,C|0,da|0,ea|0)|0;N=Ed(ea|0,C|0,X|0,N|0)|0;X=C;ea=Qd(f|0,B|0,470296,0)|0;da=C;ka=Qd(f|0,B|0,654183,0)|0;ja=C;la=Fd(oa|0,na|0,ma|0,la|0)|0;ja=Fd(la|0,C|0,ka|0,ja|0)|0;ha=Fd(ja|0,C|0,ia|0,ha|0)|0;W=Fd(ha|0,C|0,ga|0,W|0)|0;s=Ed(W|0,C|0,g|0,s|0)|0;g=C;W=Qd(f|0,B|0,-997805,-1)|0;W=Fd(y|0,P|0,W|0,C|0)|0;P=C;y=Qd(f|0,B|0,136657,0)|0;y=Fd(fa|0,S|0,y|0,C|0)|0;S=C;B=Qd(f|0,B|0,-683901,-1)|0;B=Fd(u|0,A|0,B|0,C|0)|0;A=C;u=Fd(N|0,X|0,1048576,0)|0;u=Gd(u|0,C|0,21)|0;f=C;k=Fd(ea|0,da|0,T|0,k|0)|0;_=Fd(k|0,C|0,Z|0,_|0)|0;G=Ed(_|0,C|0,$|0,G|0)|0;G=Fd(G|0,C|0,u|0,f|0)|0;$=C;f=Jd(u|0,f|0,21)|0;f=Ed(N|0,X|0,f|0,C|0)|0;X=C;N=Fd(s|0,g|0,1048576,0)|0;N=Gd(N|0,C|0,21)|0;u=C;P=Fd(W|0,P|0,N|0,u|0)|0;W=C;u=Jd(N|0,u|0,21)|0;u=Ed(s|0,g|0,u|0,C|0)|0;g=C;s=Fd(y|0,S|0,1048576,0)|0;s=Gd(s|0,C|0,21)|0;N=C;A=Fd(B|0,A|0,s|0,N|0)|0;B=C;N=Jd(s|0,N|0,21)|0;N=Ed(y|0,S|0,N|0,C|0)|0;S=C;y=Fd(n|0,ca|0,1048576,0)|0;y=Gd(y|0,C|0,21)|0;s=C;ba=Fd(y|0,s|0,J|0,ba|0)|0;J=C;s=Jd(y|0,s|0,21)|0;s=Ed(n|0,ca|0,s|0,C|0)|0;ca=C;n=Fd(M|0,aa|0,1048576,0)|0;n=Gd(n|0,C|0,21)|0;y=C;z=Fd(n|0,y|0,H|0,z|0)|0;H=C;y=Jd(n|0,y|0,21)|0;y=Ed(M|0,aa|0,y|0,C|0)|0;aa=C;M=Fd(I|0,Y|0,1048576,0)|0;M=Gd(M|0,C|0,21)|0;n=C;F=Fd(M|0,n|0,O|0,F|0)|0;O=C;n=Jd(M|0,n|0,21)|0;n=Ed(I|0,Y|0,n|0,C|0)|0;Y=C;I=Fd(G|0,$|0,1048576,0)|0;I=Gd(I|0,C|0,21)|0;M=C;g=Fd(I|0,M|0,u|0,g|0)|0;u=C;M=Jd(I|0,M|0,21)|0;M=Ed(G|0,$|0,M|0,C|0)|0;$=C;G=Fd(P|0,W|0,1048576,0)|0;G=Gd(G|0,C|0,21)|0;I=C;S=Fd(G|0,I|0,N|0,S|0)|0;N=C;I=Jd(G|0,I|0,21)|0;I=Ed(P|0,W|0,I|0,C|0)|0;W=C;P=Fd(A|0,B|0,1048576,0)|0;P=Gd(P|0,C|0,21)|0;G=C;ca=Fd(P|0,G|0,s|0,ca|0)|0;s=C;G=Jd(P|0,G|0,21)|0;G=Ed(A|0,B|0,G|0,C|0)|0;B=C;A=Fd(ba|0,J|0,1048576,0)|0;A=Gd(A|0,C|0,21)|0;P=C;aa=Fd(A|0,P|0,y|0,aa|0)|0;y=C;P=Jd(A|0,P|0,21)|0;P=Ed(ba|0,J|0,P|0,C|0)|0;J=C;ba=Fd(z|0,H|0,1048576,0)|0;ba=Gd(ba|0,C|0,21)|0;A=C;Y=Fd(ba|0,A|0,n|0,Y|0)|0;n=C;A=Jd(ba|0,A|0,21)|0;A=Ed(z|0,H|0,A|0,C|0)|0;H=C;z=Qd(F|0,O|0,666643,0)|0;Q=Fd(z|0,C|0,w|0,Q|0)|0;w=C;z=Qd(F|0,O|0,470296,0)|0;X=Fd(z|0,C|0,f|0,X|0)|0;f=C;z=Qd(F|0,O|0,654183,0)|0;$=Fd(z|0,C|0,M|0,$|0)|0;M=C;z=Qd(F|0,O|0,-997805,-1)|0;u=Fd(z|0,C|0,g|0,u|0)|0;g=C;z=Qd(F|0,O|0,136657,0)|0;W=Fd(z|0,C|0,I|0,W|0)|0;I=C;O=Qd(F|0,O|0,-683901,-1)|0;O=Fd(S|0,N|0,O|0,C|0)|0;N=C;S=Qd(Y|0,n|0,666643,0)|0;R=Fd(S|0,C|0,L|0,R|0)|0;L=C;S=Qd(Y|0,n|0,470296,0)|0;w=Fd(S|0,C|0,Q|0,w|0)|0;Q=C;S=Qd(Y|0,n|0,654183,0)|0;f=Fd(S|0,C|0,X|0,f|0)|0;X=C;S=Qd(Y|0,n|0,-997805,-1)|0;M=Fd(S|0,C|0,$|0,M|0)|0;$=C;S=Qd(Y|0,n|0,136657,0)|0;g=Fd(S|0,C|0,u|0,g|0)|0;u=C;n=Qd(Y|0,n|0,-683901,-1)|0;n=Fd(W|0,I|0,n|0,C|0)|0;I=C;W=Qd(A|0,H|0,666643,0)|0;W=Fd(h|0,t|0,W|0,C|0)|0;t=C;h=Qd(A|0,H|0,470296,0)|0;L=Fd(h|0,C|0,R|0,L|0)|0;R=C;h=Qd(A|0,H|0,654183,0)|0;Q=Fd(h|0,C|0,w|0,Q|0)|0;w=C;h=Qd(A|0,H|0,-997805,-1)|0;X=Fd(h|0,C|0,f|0,X|0)|0;f=C;h=Qd(A|0,H|0,136657,0)|0;$=Fd(h|0,C|0,M|0,$|0)|0;M=C;H=Qd(A|0,H|0,-683901,-1)|0;H=Fd(g|0,u|0,H|0,C|0)|0;u=C;g=Qd(aa|0,y|0,666643,0)|0;A=C;h=Qd(aa|0,y|0,470296,0)|0;h=Fd(W|0,t|0,h|0,C|0)|0;t=C;W=Qd(aa|0,y|0,654183,0)|0;W=Fd(L|0,R|0,W|0,C|0)|0;R=C;L=Qd(aa|0,y|0,-997805,-1)|0;L=Fd(Q|0,w|0,L|0,C|0)|0;w=C;Q=Qd(aa|0,y|0,136657,0)|0;Q=Fd(X|0,f|0,Q|0,C|0)|0;f=C;y=Qd(aa|0,y|0,-683901,-1)|0;y=Fd($|0,M|0,y|0,C|0)|0;M=C;$=Qd(P|0,J|0,666643,0)|0;aa=C;X=Qd(P|0,J|0,470296,0)|0;Y=C;S=Qd(P|0,J|0,654183,0)|0;S=Fd(h|0,t|0,S|0,C|0)|0;t=C;h=Qd(P|0,J|0,-997805,-1)|0;h=Fd(W|0,R|0,h|0,C|0)|0;R=C;W=Qd(P|0,J|0,136657,0)|0;W=Fd(L|0,w|0,W|0,C|0)|0;w=C;J=Qd(P|0,J|0,-683901,-1)|0;J=Fd(Q|0,f|0,J|0,C|0)|0;f=C;Q=Qd(ca|0,s|0,666643,0)|0;V=Fd(Q|0,C|0,D|0,V|0)|0;D=C;Q=Qd(ca|0,s|0,470296,0)|0;P=C;L=Qd(ca|0,s|0,654183,0)|0;F=C;U=Fd(q|0,K|0,E|0,U|0)|0;m=Ed(U|0,C|0,p|0,m|0)|0;A=Fd(m|0,C|0,g|0,A|0)|0;F=Fd(A|0,C|0,L|0,F|0)|0;Y=Fd(F|0,C|0,X|0,Y|0)|0;X=C;F=Qd(ca|0,s|0,-997805,-1)|0;F=Fd(S|0,t|0,F|0,C|0)|0;t=C;S=Qd(ca|0,s|0,136657,0)|0;S=Fd(h|0,R|0,S|0,C|0)|0;R=C;s=Qd(ca|0,s|0,-683901,-1)|0;s=Fd(W|0,w|0,s|0,C|0)|0;w=C;W=Fd(V|0,D|0,1048576,0)|0;W=Gd(W|0,C|0,21)|0;ca=C;P=Fd(j|0,v|0,Q|0,P|0)|0;aa=Fd(P|0,C|0,$|0,aa|0)|0;aa=Fd(aa|0,C|0,W|0,ca|0)|0;$=C;ca=Jd(W|0,ca|0,21)|0;ca=Ed(V|0,D|0,ca|0,C|0)|0;D=C;V=Fd(Y|0,X|0,1048576,0)|0;V=Gd(V|0,C|0,21)|0;W=C;t=Fd(V|0,W|0,F|0,t|0)|0;F=C;W=Jd(V|0,W|0,21)|0;V=C;P=Fd(S|0,R|0,1048576,0)|0;P=Gd(P|0,C|0,21)|0;Q=C;w=Fd(P|0,Q|0,s|0,w|0)|0;s=C;Q=Jd(P|0,Q|0,21)|0;P=C;v=Fd(J|0,f|0,1048576,0)|0;v=Gd(v|0,C|0,21)|0;j=C;M=Fd(v|0,j|0,y|0,M|0)|0;y=C;j=Jd(v|0,j|0,21)|0;j=Ed(J|0,f|0,j|0,C|0)|0;f=C;J=Fd(H|0,u|0,1048576,0)|0;J=Gd(J|0,C|0,21)|0;v=C;I=Fd(n|0,I|0,J|0,v|0)|0;n=C;v=Jd(J|0,v|0,21)|0;v=Ed(H|0,u|0,v|0,C|0)|0;u=C;H=Fd(O|0,N|0,1048576,0)|0;H=Gd(H|0,C|0,21)|0;J=C;B=Fd(G|0,B|0,H|0,J|0)|0;G=C;J=Jd(H|0,J|0,21)|0;H=C;h=Fd(aa|0,$|0,1048576,0)|0;h=Gd(h|0,C|0,21)|0;L=C;A=Jd(h|0,L|0,21)|0;g=C;m=Fd(t|0,F|0,1048576,0)|0;m=Gd(m|0,C|0,21)|0;p=C;U=Jd(m|0,p|0,21)|0;U=Ed(t|0,F|0,U|0,C|0)|0;F=C;t=Fd(w|0,s|0,1048576,0)|0;t=Gd(t|0,C|0,21)|0;E=C;f=Fd(j|0,f|0,t|0,E|0)|0;j=C;E=Jd(t|0,E|0,21)|0;E=Ed(w|0,s|0,E|0,C|0)|0;s=C;w=Fd(M|0,y|0,1048576,0)|0;w=Gd(w|0,C|0,21)|0;t=C;u=Fd(v|0,u|0,w|0,t|0)|0;v=C;t=Jd(w|0,t|0,21)|0;t=Ed(M|0,y|0,t|0,C|0)|0;y=C;M=Fd(I|0,n|0,1048576,0)|0;M=Gd(M|0,C|0,21)|0;w=C;K=Jd(M|0,w|0,21)|0;K=Ed(I|0,n|0,K|0,C|0)|0;n=C;I=Fd(B|0,G|0,1048576,0)|0;I=Gd(I|0,C|0,21)|0;q=C;z=Jd(I|0,q|0,21)|0;z=Ed(B|0,G|0,z|0,C|0)|0;G=C;B=Qd(I|0,q|0,666643,0)|0;B=Fd(ca|0,D|0,B|0,C|0)|0;D=C;ca=Qd(I|0,q|0,470296,0)|0;ba=C;_=Qd(I|0,q|0,654183,0)|0;Z=C;k=Qd(I|0,q|0,-997805,-1)|0;k=Fd(U|0,F|0,k|0,C|0)|0;F=C;U=Qd(I|0,q|0,136657,0)|0;T=C;q=Qd(I|0,q|0,-683901,-1)|0;q=Fd(E|0,s|0,q|0,C|0)|0;s=C;E=Gd(B|0,D|0,21)|0;I=C;$=Fd(ca|0,ba|0,aa|0,$|0)|0;g=Ed($|0,C|0,A|0,g|0)|0;g=Fd(g|0,C|0,E|0,I|0)|0;A=C;I=Jd(E|0,I|0,21)|0;I=Ed(B|0,D|0,I|0,C|0)|0;D=C;B=Gd(g|0,A|0,21)|0;E=C;X=Fd(_|0,Z|0,Y|0,X|0)|0;V=Ed(X|0,C|0,W|0,V|0)|0;L=Fd(V|0,C|0,h|0,L|0)|0;L=Fd(L|0,C|0,B|0,E|0)|0;h=C;E=Jd(B|0,E|0,21)|0;E=Ed(g|0,A|0,E|0,C|0)|0;A=C;g=Gd(L|0,h|0,21)|0;B=C;F=Fd(g|0,B|0,k|0,F|0)|0;k=C;B=Jd(g|0,B|0,21)|0;B=Ed(L|0,h|0,B|0,C|0)|0;h=C;L=Gd(F|0,k|0,21)|0;g=C;R=Fd(U|0,T|0,S|0,R|0)|0;P=Ed(R|0,C|0,Q|0,P|0)|0;p=Fd(P|0,C|0,m|0,p|0)|0;p=Fd(p|0,C|0,L|0,g|0)|0;m=C;g=Jd(L|0,g|0,21)|0;g=Ed(F|0,k|0,g|0,C|0)|0;k=C;F=Gd(p|0,m|0,21)|0;L=C;s=Fd(F|0,L|0,q|0,s|0)|0;q=C;L=Jd(F|0,L|0,21)|0;L=Ed(p|0,m|0,L|0,C|0)|0;m=C;p=Gd(s|0,q|0,21)|0;F=C;j=Fd(f|0,j|0,p|0,F|0)|0;f=C;F=Jd(p|0,F|0,21)|0;F=Ed(s|0,q|0,F|0,C|0)|0;q=C;s=Gd(j|0,f|0,21)|0;p=C;y=Fd(s|0,p|0,t|0,y|0)|0;t=C;p=Jd(s|0,p|0,21)|0;p=Ed(j|0,f|0,p|0,C|0)|0;f=C;j=Gd(y|0,t|0,21)|0;s=C;v=Fd(u|0,v|0,j|0,s|0)|0;u=C;s=Jd(j|0,s|0,21)|0;s=Ed(y|0,t|0,s|0,C|0)|0;t=C;y=Gd(v|0,u|0,21)|0;j=C;n=Fd(y|0,j|0,K|0,n|0)|0;K=C;j=Jd(y|0,j|0,21)|0;j=Ed(v|0,u|0,j|0,C|0)|0;u=C;v=Gd(n|0,K|0,21)|0;y=C;w=Fd(O|0,N|0,M|0,w|0)|0;H=Ed(w|0,C|0,J|0,H|0)|0;H=Fd(H|0,C|0,v|0,y|0)|0;J=C;y=Jd(v|0,y|0,21)|0;y=Ed(n|0,K|0,y|0,C|0)|0;K=C;n=Gd(H|0,J|0,21)|0;v=C;G=Fd(n|0,v|0,z|0,G|0)|0;z=C;v=Jd(n|0,v|0,21)|0;v=Ed(H|0,J|0,v|0,C|0)|0;J=C;H=Gd(G|0,z|0,21)|0;n=C;w=Jd(H|0,n|0,21)|0;w=Ed(G|0,z|0,w|0,C|0)|0;z=C;G=Qd(H|0,n|0,666643,0)|0;D=Fd(G|0,C|0,I|0,D|0)|0;I=C;G=Qd(H|0,n|0,470296,0)|0;G=Fd(E|0,A|0,G|0,C|0)|0;A=C;E=Qd(H|0,n|0,654183,0)|0;E=Fd(B|0,h|0,E|0,C|0)|0;h=C;B=Qd(H|0,n|0,-997805,-1)|0;B=Fd(g|0,k|0,B|0,C|0)|0;k=C;g=Qd(H|0,n|0,136657,0)|0;g=Fd(L|0,m|0,g|0,C|0)|0;m=C;n=Qd(H|0,n|0,-683901,-1)|0;n=Fd(F|0,q|0,n|0,C|0)|0;q=C;F=Gd(D|0,I|0,21)|0;H=C;A=Fd(G|0,A|0,F|0,H|0)|0;G=C;H=Jd(F|0,H|0,21)|0;H=Ed(D|0,I|0,H|0,C|0)|0;I=C;D=Gd(A|0,G|0,21)|0;F=C;h=Fd(E|0,h|0,D|0,F|0)|0;E=C;F=Jd(D|0,F|0,21)|0;F=Ed(A|0,G|0,F|0,C|0)|0;G=C;A=Gd(h|0,E|0,21)|0;D=C;k=Fd(A|0,D|0,B|0,k|0)|0;B=C;D=Jd(A|0,D|0,21)|0;D=Ed(h|0,E|0,D|0,C|0)|0;E=C;h=Gd(k|0,B|0,21)|0;A=C;m=Fd(g|0,m|0,h|0,A|0)|0;g=C;A=Jd(h|0,A|0,21)|0;A=Ed(k|0,B|0,A|0,C|0)|0;B=C;k=Gd(m|0,g|0,21)|0;h=C;q=Fd(k|0,h|0,n|0,q|0)|0;n=C;h=Jd(k|0,h|0,21)|0;h=Ed(m|0,g|0,h|0,C|0)|0;g=C;m=Gd(q|0,n|0,21)|0;k=C;f=Fd(m|0,k|0,p|0,f|0)|0;p=C;k=Jd(m|0,k|0,21)|0;k=Ed(q|0,n|0,k|0,C|0)|0;n=C;q=Gd(f|0,p|0,21)|0;m=C;t=Fd(q|0,m|0,s|0,t|0)|0;s=C;m=Jd(q|0,m|0,21)|0;m=Ed(f|0,p|0,m|0,C|0)|0;p=C;f=Gd(t|0,s|0,21)|0;q=C;u=Fd(f|0,q|0,j|0,u|0)|0;j=C;q=Jd(f|0,q|0,21)|0;q=Ed(t|0,s|0,q|0,C|0)|0;s=C;t=Gd(u|0,j|0,21)|0;f=C;K=Fd(t|0,f|0,y|0,K|0)|0;y=C;f=Jd(t|0,f|0,21)|0;f=Ed(u|0,j|0,f|0,C|0)|0;j=C;u=Gd(K|0,y|0,21)|0;t=C;J=Fd(u|0,t|0,v|0,J|0)|0;v=C;t=Jd(u|0,t|0,21)|0;t=Ed(K|0,y|0,t|0,C|0)|0;y=C;K=Gd(J|0,v|0,21)|0;u=C;z=Fd(K|0,u|0,w|0,z|0)|0;w=C;u=Jd(K|0,u|0,21)|0;u=Ed(J|0,v|0,u|0,C|0)|0;v=C;a[l>>0]=H;l=Id(H|0,I|0,8)|0;a[b+33>>0]=l;l=Id(H|0,I|0,16)|0;I=C;H=Jd(F|0,G|0,5)|0;a[b+34>>0]=H|l;l=Id(F|0,G|0,3)|0;a[b+35>>0]=l;l=Id(F|0,G|0,11)|0;a[b+36>>0]=l;l=Id(F|0,G|0,19)|0;G=C;F=Jd(D|0,E|0,2)|0;a[b+37>>0]=F|l;l=Id(D|0,E|0,6)|0;a[b+38>>0]=l;l=Id(D|0,E|0,14)|0;E=C;D=Jd(A|0,B|0,7)|0;a[b+39>>0]=D|l;l=Id(A|0,B|0,1)|0;a[b+40>>0]=l;l=Id(A|0,B|0,9)|0;a[b+41>>0]=l;l=Id(A|0,B|0,17)|0;B=C;A=Jd(h|0,g|0,4)|0;a[b+42>>0]=A|l;l=Id(h|0,g|0,4)|0;a[b+43>>0]=l;l=Id(h|0,g|0,12)|0;a[b+44>>0]=l;l=Id(h|0,g|0,20)|0;g=C;h=Jd(k|0,n|0,1)|0;a[b+45>>0]=h|l;l=Id(k|0,n|0,7)|0;a[b+46>>0]=l;n=Id(k|0,n|0,15)|0;k=C;l=Jd(m|0,p|0,6)|0;a[b+47>>0]=l|n;n=Id(m|0,p|0,2)|0;a[b+48>>0]=n;n=Id(m|0,p|0,10)|0;a[b+49>>0]=n;p=Id(m|0,p|0,18)|0;m=C;n=Jd(q|0,s|0,3)|0;a[b+50>>0]=n|p;p=Id(q|0,s|0,5)|0;a[b+51>>0]=p;s=Id(q|0,s|0,13)|0;a[b+52>>0]=s;a[b+53>>0]=f;s=Id(f|0,j|0,8)|0;a[b+54>>0]=s;j=Id(f|0,j|0,16)|0;f=C;s=Jd(t|0,y|0,5)|0;a[b+55>>0]=s|j;j=Id(t|0,y|0,3)|0;a[b+56>>0]=j;j=Id(t|0,y|0,11)|0;a[b+57>>0]=j;y=Id(t|0,y|0,19)|0;t=C;j=Jd(u|0,v|0,2)|0;a[b+58>>0]=j|y;y=Id(u|0,v|0,6)|0;a[b+59>>0]=y;v=Id(u|0,v|0,14)|0;u=C;y=Jd(z|0,w|0,7)|0;a[b+60>>0]=v|y;y=Id(z|0,w|0,1)|0;a[b+61>>0]=y;y=Id(z|0,w|0,9)|0;a[b+62>>0]=y;w=Id(z|0,w|0,17)|0;a[b+63>>0]=w;w=o;z=w+64|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(z|0));w=r;z=w+64|0;do{a[w>>0]=0;w=w+1|0}while((w|0)<(z|0));if(!e){i=x;return}Ec=e;c[Ec>>2]=64;c[Ec+4>>2]=0;i=x;return}function Zc(b,c){b=b|0;c=c|0;return ((((a[c+1>>0]^a[b+1>>0]|a[c>>0]^a[b>>0]|a[c+2>>0]^a[b+2>>0]|a[c+3>>0]^a[b+3>>0]|a[c+4>>0]^a[b+4>>0]|a[c+5>>0]^a[b+5>>0]|a[c+6>>0]^a[b+6>>0]|a[c+7>>0]^a[b+7>>0]|a[c+8>>0]^a[b+8>>0]|a[c+9>>0]^a[b+9>>0]|a[c+10>>0]^a[b+10>>0]|a[c+11>>0]^a[b+11>>0]|a[c+12>>0]^a[b+12>>0]|a[c+13>>0]^a[b+13>>0]|a[c+14>>0]^a[b+14>>0]|a[c+15>>0]^a[b+15>>0]|a[c+16>>0]^a[b+16>>0]|a[c+17>>0]^a[b+17>>0]|a[c+18>>0]^a[b+18>>0]|a[c+19>>0]^a[b+19>>0]|a[c+20>>0]^a[b+20>>0]|a[c+21>>0]^a[b+21>>0]|a[c+22>>0]^a[b+22>>0]|a[c+23>>0]^a[b+23>>0]|a[c+24>>0]^a[b+24>>0]|a[c+25>>0]^a[b+25>>0]|a[c+26>>0]^a[b+26>>0]|a[c+27>>0]^a[b+27>>0]|a[c+28>>0]^a[b+28>>0]|a[c+29>>0]^a[b+29>>0]|a[c+30>>0]^a[b+30>>0]|a[c+31>>0]^a[b+31>>0])&255)+511|0)>>>8&1)+-1|0}function _c(a){a=a|0;c[7976]=a;return 0}function $c(){return Ba(0)|0}function ad(){Ba(1);return}function bd(a){a=a|0;var b=0,d=0;b=c[7976]|0;if((b|0)!=0?(d=c[b+12>>2]|0,(d|0)!=0):0){a=Ea[d&31](a)|0;return a|0}if(a>>>0<2){a=0;return a|0}d=((0-a|0)>>>0)%(a>>>0)|0;do b=Ba(0)|0;while(b>>>0<d>>>0);a=(b>>>0)%(a>>>0)|0;return a|0}function cd(b,c){b=b|0;c=c|0;var d=0;if(!c)return;else d=0;do{a[b+d>>0]=Ba(0)|0;d=d+1|0}while((d|0)!=(c|0));return}function dd(){var a=0;a=c[7976]|0;if(!a){a=0;return a|0}a=c[a+20>>2]|0;if(!a){a=0;return a|0}a=Da[a&31]()|0;return a|0}function ed(){var a=0,b=0;if(c[7977]|0){b=1;return b|0}Ba(1);a=na(30)|0;if((a|0)>0)c[7978]=a;else a=c[7978]|0;if(a>>>0<16)ra();else b=0;do{Ba(0)|0;b=b+1|0}while((b|0)!=16);c[7977]=1;b=0;return b|0}function fd(a,b){a=a|0;b=b|0;Hd(a|0,0,b|0)|0;return}function gd(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;if(!d)e=0;else{e=0;f=0;do{e=a[c+f>>0]^a[b+f>>0]|e;f=f+1|0}while((f|0)!=(d|0))}return (((e&255)+511|0)>>>8&1)+-1|0}function hd(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=f<<1;if(!(f>>>0<2147483647&g>>>0<c>>>0))ra();if(!f){f=0;f=b+f|0;a[f>>0]=0;return b|0}else c=0;do{j=d[e+c>>0]|0;i=j&15;j=j>>>4;h=c<<1;a[b+h>>0]=j+87+((j+65526|0)>>>8&217);a[b+(h|1)>>0]=((i<<8)+22272+(i+65526&55552)|0)>>>8;c=c+1|0}while((c|0)!=(f|0));j=b+g|0;a[j>>0]=0;return b|0}function id(b,e,f,g,h,i,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;a:do if(!g){n=0;l=0;m=0;k=0}else{u=(h|0)!=0;n=0;t=0;l=0;v=0;while(1){s=v<<24>>24==0;b:do if(!(u&s)){p=d[f+l>>0]|0;m=p^48;k=(m+65526|0)>>>8;p=(p&223)+201|0;o=p&255;o=(o+65526^o+65520)>>>8;if(!((o|k)&255)){m=0;k=v;break a}}else while(1){q=a[f+l>>0]|0;r=q&255;m=r^48;k=(m+65526|0)>>>8;p=(r&223)+201|0;o=p&255;o=(o+65526^o+65520)>>>8;if((o|k)&255)break b;r=yd(h,r)|0;if((r|0)==0?1:(a[r>>0]|0)!=q<<24>>24){m=0;k=0;break a}l=l+1|0;if(l>>>0>=g>>>0){m=0;k=0;break a}}while(0);m=o&p|k&m;if(n>>>0>=e>>>0)break;if(s)m=m<<4&255;else{a[b+n>>0]=m|t&255;n=n+1|0;m=t}k=(v&255^255)&255;l=l+1|0;if(l>>>0<g>>>0){t=m;v=k}else{m=0;break a}}if(!(c[7979]|0))k=32460;else k=c[(oa()|0)+60>>2]|0;c[k>>2]=34;m=-1;k=v}while(0);if(j)c[j>>2]=f+(((k<<24>>24!=0)<<31>>31)+l);if(!i)return m|0;c[i>>2]=n;return m|0}function jd(){return 33773}function kd(){return 7}function ld(){return 5}function md(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0;l=c[b>>2]|0;s=c[b+4>>2]|0;j=c[b+8>>2]|0;Rb=c[b+12>>2]|0;e=c[b+16>>2]|0;za=c[b+20>>2]|0;ya=c[b+24>>2]|0;zb=c[b+28>>2]|0;h=c[b+32>>2]|0;ga=c[b+36>>2]|0;H=c[d>>2]|0;J=c[d+4>>2]|0;F=c[d+8>>2]|0;D=c[d+12>>2]|0;A=c[d+16>>2]|0;y=c[d+20>>2]|0;w=c[d+24>>2]|0;u=c[d+28>>2]|0;k=c[d+32>>2]|0;t=c[d+36>>2]|0;Oc=J*19|0;bc=F*19|0;rb=D*19|0;Ha=A*19|0;jc=y*19|0;Db=w*19|0;Ta=u*19|0;Sc=k*19|0;Qc=t*19|0;p=s<<1;f=Rb<<1;M=za<<1;i=zb<<1;d=ga<<1;o=((l|0)<0)<<31>>31;I=((H|0)<0)<<31>>31;Mc=Qd(H|0,I|0,l|0,o|0)|0;Lc=C;K=((J|0)<0)<<31>>31;wc=Qd(J|0,K|0,l|0,o|0)|0;vc=C;G=((F|0)<0)<<31>>31;ub=Qd(F|0,G|0,l|0,o|0)|0;tb=C;E=((D|0)<0)<<31>>31;Ka=Qd(D|0,E|0,l|0,o|0)|0;Ja=C;B=((A|0)<0)<<31>>31;mc=Qd(A|0,B|0,l|0,o|0)|0;lc=C;z=((y|0)<0)<<31>>31;Gb=Qd(y|0,z|0,l|0,o|0)|0;Fb=C;x=((w|0)<0)<<31>>31;Wa=Qd(w|0,x|0,l|0,o|0)|0;Va=C;v=((u|0)<0)<<31>>31;ja=Qd(u|0,v|0,l|0,o|0)|0;ia=C;Pc=((k|0)<0)<<31>>31;P=Qd(k|0,Pc|0,l|0,o|0)|0;O=C;o=Qd(t|0,((t|0)<0)<<31>>31|0,l|0,o|0)|0;l=C;t=((s|0)<0)<<31>>31;dc=Qd(H|0,I|0,s|0,t|0)|0;ec=C;n=((p|0)<0)<<31>>31;yb=Qd(J|0,K|0,p|0,n|0)|0;xb=C;Ma=Qd(F|0,G|0,s|0,t|0)|0;La=C;oc=Qd(D|0,E|0,p|0,n|0)|0;nc=C;Ib=Qd(A|0,B|0,s|0,t|0)|0;Hb=C;Ya=Qd(y|0,z|0,p|0,n|0)|0;Xa=C;la=Qd(w|0,x|0,s|0,t|0)|0;ka=C;R=Qd(u|0,v|0,p|0,n|0)|0;Q=C;t=Qd(k|0,Pc|0,s|0,t|0)|0;s=C;Pc=((Qc|0)<0)<<31>>31;n=Qd(Qc|0,Pc|0,p|0,n|0)|0;p=C;k=((j|0)<0)<<31>>31;wb=Qd(H|0,I|0,j|0,k|0)|0;vb=C;Qa=Qd(J|0,K|0,j|0,k|0)|0;Pa=C;qc=Qd(F|0,G|0,j|0,k|0)|0;pc=C;Kb=Qd(D|0,E|0,j|0,k|0)|0;Jb=C;_a=Qd(A|0,B|0,j|0,k|0)|0;Za=C;na=Qd(y|0,z|0,j|0,k|0)|0;ma=C;T=Qd(w|0,x|0,j|0,k|0)|0;S=C;v=Qd(u|0,v|0,j|0,k|0)|0;u=C;Rc=((Sc|0)<0)<<31>>31;yc=Qd(Sc|0,Rc|0,j|0,k|0)|0;xc=C;k=Qd(Qc|0,Pc|0,j|0,k|0)|0;j=C;Sb=((Rb|0)<0)<<31>>31;Oa=Qd(H|0,I|0,Rb|0,Sb|0)|0;Na=C;fa=((f|0)<0)<<31>>31;uc=Qd(J|0,K|0,f|0,fa|0)|0;tc=C;Mb=Qd(F|0,G|0,Rb|0,Sb|0)|0;Lb=C;ab=Qd(D|0,E|0,f|0,fa|0)|0;$a=C;pa=Qd(A|0,B|0,Rb|0,Sb|0)|0;oa=C;V=Qd(y|0,z|0,f|0,fa|0)|0;U=C;x=Qd(w|0,x|0,Rb|0,Sb|0)|0;w=C;Ua=((Ta|0)<0)<<31>>31;Ac=Qd(Ta|0,Ua|0,f|0,fa|0)|0;zc=C;Sb=Qd(Sc|0,Rc|0,Rb|0,Sb|0)|0;Rb=C;fa=Qd(Qc|0,Pc|0,f|0,fa|0)|0;f=C;N=((e|0)<0)<<31>>31;sc=Qd(H|0,I|0,e|0,N|0)|0;rc=C;Qb=Qd(J|0,K|0,e|0,N|0)|0;Pb=C;cb=Qd(F|0,G|0,e|0,N|0)|0;bb=C;ra=Qd(D|0,E|0,e|0,N|0)|0;qa=C;X=Qd(A|0,B|0,e|0,N|0)|0;W=C;z=Qd(y|0,z|0,e|0,N|0)|0;y=C;Eb=((Db|0)<0)<<31>>31;Cc=Qd(Db|0,Eb|0,e|0,N|0)|0;Bc=C;Ub=Qd(Ta|0,Ua|0,e|0,N|0)|0;Tb=C;ib=Qd(Sc|0,Rc|0,e|0,N|0)|0;hb=C;N=Qd(Qc|0,Pc|0,e|0,N|0)|0;e=C;Aa=((za|0)<0)<<31>>31;Ob=Qd(H|0,I|0,za|0,Aa|0)|0;Nb=C;b=((M|0)<0)<<31>>31;gb=Qd(J|0,K|0,M|0,b|0)|0;fb=C;ta=Qd(F|0,G|0,za|0,Aa|0)|0;sa=C;Z=Qd(D|0,E|0,M|0,b|0)|0;Y=C;B=Qd(A|0,B|0,za|0,Aa|0)|0;A=C;kc=((jc|0)<0)<<31>>31;Ec=Qd(jc|0,kc|0,M|0,b|0)|0;Dc=C;Wb=Qd(Db|0,Eb|0,za|0,Aa|0)|0;Vb=C;kb=Qd(Ta|0,Ua|0,M|0,b|0)|0;jb=C;Aa=Qd(Sc|0,Rc|0,za|0,Aa|0)|0;za=C;b=Qd(Qc|0,Pc|0,M|0,b|0)|0;M=C;g=((ya|0)<0)<<31>>31;eb=Qd(H|0,I|0,ya|0,g|0)|0;db=C;xa=Qd(J|0,K|0,ya|0,g|0)|0;wa=C;$=Qd(F|0,G|0,ya|0,g|0)|0;_=C;E=Qd(D|0,E|0,ya|0,g|0)|0;D=C;Ia=((Ha|0)<0)<<31>>31;Gc=Qd(Ha|0,Ia|0,ya|0,g|0)|0;Fc=C;Yb=Qd(jc|0,kc|0,ya|0,g|0)|0;Xb=C;mb=Qd(Db|0,Eb|0,ya|0,g|0)|0;lb=C;Ca=Qd(Ta|0,Ua|0,ya|0,g|0)|0;Ba=C;m=Qd(Sc|0,Rc|0,ya|0,g|0)|0;r=C;g=Qd(Qc|0,Pc|0,ya|0,g|0)|0;ya=C;Ab=((zb|0)<0)<<31>>31;va=Qd(H|0,I|0,zb|0,Ab|0)|0;ua=C;ea=((i|0)<0)<<31>>31;da=Qd(J|0,K|0,i|0,ea|0)|0;ca=C;G=Qd(F|0,G|0,zb|0,Ab|0)|0;F=C;sb=((rb|0)<0)<<31>>31;Ic=Qd(rb|0,sb|0,i|0,ea|0)|0;Hc=C;_b=Qd(Ha|0,Ia|0,zb|0,Ab|0)|0;Zb=C;ob=Qd(jc|0,kc|0,i|0,ea|0)|0;nb=C;Ea=Qd(Db|0,Eb|0,zb|0,Ab|0)|0;Da=C;gc=Qd(Ta|0,Ua|0,i|0,ea|0)|0;fc=C;Ab=Qd(Sc|0,Rc|0,zb|0,Ab|0)|0;zb=C;ea=Qd(Qc|0,Pc|0,i|0,ea|0)|0;i=C;L=((h|0)<0)<<31>>31;ba=Qd(H|0,I|0,h|0,L|0)|0;aa=C;K=Qd(J|0,K|0,h|0,L|0)|0;J=C;cc=((bc|0)<0)<<31>>31;Kc=Qd(bc|0,cc|0,h|0,L|0)|0;Jc=C;ac=Qd(rb|0,sb|0,h|0,L|0)|0;$b=C;qb=Qd(Ha|0,Ia|0,h|0,L|0)|0;pb=C;Ga=Qd(jc|0,kc|0,h|0,L|0)|0;Fa=C;ic=Qd(Db|0,Eb|0,h|0,L|0)|0;hc=C;Cb=Qd(Ta|0,Ua|0,h|0,L|0)|0;Bb=C;Sa=Qd(Sc|0,Rc|0,h|0,L|0)|0;Ra=C;L=Qd(Qc|0,Pc|0,h|0,L|0)|0;h=C;ha=((ga|0)<0)<<31>>31;I=Qd(H|0,I|0,ga|0,ha|0)|0;H=C;q=((d|0)<0)<<31>>31;Oc=Qd(Oc|0,((Oc|0)<0)<<31>>31|0,d|0,q|0)|0;Nc=C;cc=Qd(bc|0,cc|0,ga|0,ha|0)|0;bc=C;sb=Qd(rb|0,sb|0,d|0,q|0)|0;rb=C;Ia=Qd(Ha|0,Ia|0,ga|0,ha|0)|0;Ha=C;kc=Qd(jc|0,kc|0,d|0,q|0)|0;jc=C;Eb=Qd(Db|0,Eb|0,ga|0,ha|0)|0;Db=C;Ua=Qd(Ta|0,Ua|0,d|0,q|0)|0;Ta=C;ha=Qd(Sc|0,Rc|0,ga|0,ha|0)|0;ga=C;q=Qd(Qc|0,Pc|0,d|0,q|0)|0;d=C;Lc=Fd(Oc|0,Nc|0,Mc|0,Lc|0)|0;Jc=Fd(Lc|0,C|0,Kc|0,Jc|0)|0;Hc=Fd(Jc|0,C|0,Ic|0,Hc|0)|0;Fc=Fd(Hc|0,C|0,Gc|0,Fc|0)|0;Dc=Fd(Fc|0,C|0,Ec|0,Dc|0)|0;Bc=Fd(Dc|0,C|0,Cc|0,Bc|0)|0;zc=Fd(Bc|0,C|0,Ac|0,zc|0)|0;xc=Fd(zc|0,C|0,yc|0,xc|0)|0;p=Fd(xc|0,C|0,n|0,p|0)|0;n=C;ec=Fd(wc|0,vc|0,dc|0,ec|0)|0;dc=C;rc=Fd(uc|0,tc|0,sc|0,rc|0)|0;pc=Fd(rc|0,C|0,qc|0,pc|0)|0;nc=Fd(pc|0,C|0,oc|0,nc|0)|0;lc=Fd(nc|0,C|0,mc|0,lc|0)|0;jc=Fd(lc|0,C|0,kc|0,jc|0)|0;hc=Fd(jc|0,C|0,ic|0,hc|0)|0;fc=Fd(hc|0,C|0,gc|0,fc|0)|0;r=Fd(fc|0,C|0,m|0,r|0)|0;M=Fd(r|0,C|0,b|0,M|0)|0;b=C;r=Fd(p|0,n|0,33554432,0)|0;r=Gd(r|0,C|0,26)|0;m=C;bc=Fd(ec|0,dc|0,cc|0,bc|0)|0;$b=Fd(bc|0,C|0,ac|0,$b|0)|0;Zb=Fd($b|0,C|0,_b|0,Zb|0)|0;Xb=Fd(Zb|0,C|0,Yb|0,Xb|0)|0;Vb=Fd(Xb|0,C|0,Wb|0,Vb|0)|0;Tb=Fd(Vb|0,C|0,Ub|0,Tb|0)|0;Rb=Fd(Tb|0,C|0,Sb|0,Rb|0)|0;j=Fd(Rb|0,C|0,k|0,j|0)|0;j=Fd(j|0,C|0,r|0,m|0)|0;k=C;m=Jd(r|0,m|0,26)|0;m=Ed(p|0,n|0,m|0,C|0)|0;n=C;p=Fd(M|0,b|0,33554432,0)|0;p=Gd(p|0,C|0,26)|0;r=C;Nb=Fd(Qb|0,Pb|0,Ob|0,Nb|0)|0;Lb=Fd(Nb|0,C|0,Mb|0,Lb|0)|0;Jb=Fd(Lb|0,C|0,Kb|0,Jb|0)|0;Hb=Fd(Jb|0,C|0,Ib|0,Hb|0)|0;Fb=Fd(Hb|0,C|0,Gb|0,Fb|0)|0;Db=Fd(Fb|0,C|0,Eb|0,Db|0)|0;Bb=Fd(Db|0,C|0,Cb|0,Bb|0)|0;zb=Fd(Bb|0,C|0,Ab|0,zb|0)|0;ya=Fd(zb|0,C|0,g|0,ya|0)|0;ya=Fd(ya|0,C|0,p|0,r|0)|0;g=C;r=Jd(p|0,r|0,26)|0;r=Ed(M|0,b|0,r|0,C|0)|0;b=C;M=Fd(j|0,k|0,16777216,0)|0;M=Gd(M|0,C|0,25)|0;p=C;vb=Fd(yb|0,xb|0,wb|0,vb|0)|0;tb=Fd(vb|0,C|0,ub|0,tb|0)|0;rb=Fd(tb|0,C|0,sb|0,rb|0)|0;pb=Fd(rb|0,C|0,qb|0,pb|0)|0;nb=Fd(pb|0,C|0,ob|0,nb|0)|0;lb=Fd(nb|0,C|0,mb|0,lb|0)|0;jb=Fd(lb|0,C|0,kb|0,jb|0)|0;hb=Fd(jb|0,C|0,ib|0,hb|0)|0;f=Fd(hb|0,C|0,fa|0,f|0)|0;f=Fd(f|0,C|0,M|0,p|0)|0;fa=C;p=Jd(M|0,p|0,25)|0;p=Ed(j|0,k|0,p|0,C|0)|0;k=C;j=Fd(ya|0,g|0,16777216,0)|0;j=Gd(j|0,C|0,25)|0;M=C;db=Fd(gb|0,fb|0,eb|0,db|0)|0;bb=Fd(db|0,C|0,cb|0,bb|0)|0;$a=Fd(bb|0,C|0,ab|0,$a|0)|0;Za=Fd($a|0,C|0,_a|0,Za|0)|0;Xa=Fd(Za|0,C|0,Ya|0,Xa|0)|0;Va=Fd(Xa|0,C|0,Wa|0,Va|0)|0;Ta=Fd(Va|0,C|0,Ua|0,Ta|0)|0;Ra=Fd(Ta|0,C|0,Sa|0,Ra|0)|0;i=Fd(Ra|0,C|0,ea|0,i|0)|0;i=Fd(i|0,C|0,j|0,M|0)|0;ea=C;M=Jd(j|0,M|0,25)|0;M=Ed(ya|0,g|0,M|0,C|0)|0;g=C;ya=Fd(f|0,fa|0,33554432,0)|0;ya=Gd(ya|0,C|0,26)|0;j=C;Na=Fd(Qa|0,Pa|0,Oa|0,Na|0)|0;La=Fd(Na|0,C|0,Ma|0,La|0)|0;Ja=Fd(La|0,C|0,Ka|0,Ja|0)|0;Ha=Fd(Ja|0,C|0,Ia|0,Ha|0)|0;Fa=Fd(Ha|0,C|0,Ga|0,Fa|0)|0;Da=Fd(Fa|0,C|0,Ea|0,Da|0)|0;Ba=Fd(Da|0,C|0,Ca|0,Ba|0)|0;za=Fd(Ba|0,C|0,Aa|0,za|0)|0;e=Fd(za|0,C|0,N|0,e|0)|0;e=Fd(e|0,C|0,ya|0,j|0)|0;N=C;j=Jd(ya|0,j|0,26)|0;j=Ed(f|0,fa|0,j|0,C|0)|0;fa=Fd(i|0,ea|0,33554432,0)|0;fa=Gd(fa|0,C|0,26)|0;f=C;ua=Fd(xa|0,wa|0,va|0,ua|0)|0;sa=Fd(ua|0,C|0,ta|0,sa|0)|0;qa=Fd(sa|0,C|0,ra|0,qa|0)|0;oa=Fd(qa|0,C|0,pa|0,oa|0)|0;ma=Fd(oa|0,C|0,na|0,ma|0)|0;ka=Fd(ma|0,C|0,la|0,ka|0)|0;ia=Fd(ka|0,C|0,ja|0,ia|0)|0;ga=Fd(ia|0,C|0,ha|0,ga|0)|0;h=Fd(ga|0,C|0,L|0,h|0)|0;h=Fd(h|0,C|0,fa|0,f|0)|0;L=C;f=Jd(fa|0,f|0,26)|0;f=Ed(i|0,ea|0,f|0,C|0)|0;ea=Fd(e|0,N|0,16777216,0)|0;ea=Gd(ea|0,C|0,25)|0;i=C;b=Fd(ea|0,i|0,r|0,b|0)|0;r=C;i=Jd(ea|0,i|0,25)|0;i=Ed(e|0,N|0,i|0,C|0)|0;N=Fd(h|0,L|0,16777216,0)|0;N=Gd(N|0,C|0,25)|0;e=C;aa=Fd(da|0,ca|0,ba|0,aa|0)|0;_=Fd(aa|0,C|0,$|0,_|0)|0;Y=Fd(_|0,C|0,Z|0,Y|0)|0;W=Fd(Y|0,C|0,X|0,W|0)|0;U=Fd(W|0,C|0,V|0,U|0)|0;S=Fd(U|0,C|0,T|0,S|0)|0;Q=Fd(S|0,C|0,R|0,Q|0)|0;O=Fd(Q|0,C|0,P|0,O|0)|0;d=Fd(O|0,C|0,q|0,d|0)|0;d=Fd(d|0,C|0,N|0,e|0)|0;q=C;e=Jd(N|0,e|0,25)|0;e=Ed(h|0,L|0,e|0,C|0)|0;L=Fd(b|0,r|0,33554432,0)|0;L=Gd(L|0,C|0,26)|0;h=C;g=Fd(M|0,g|0,L|0,h|0)|0;h=Jd(L|0,h|0,26)|0;h=Ed(b|0,r|0,h|0,C|0)|0;r=Fd(d|0,q|0,33554432,0)|0;r=Gd(r|0,C|0,26)|0;b=C;H=Fd(K|0,J|0,I|0,H|0)|0;F=Fd(H|0,C|0,G|0,F|0)|0;D=Fd(F|0,C|0,E|0,D|0)|0;A=Fd(D|0,C|0,B|0,A|0)|0;y=Fd(A|0,C|0,z|0,y|0)|0;w=Fd(y|0,C|0,x|0,w|0)|0;u=Fd(w|0,C|0,v|0,u|0)|0;s=Fd(u|0,C|0,t|0,s|0)|0;l=Fd(s|0,C|0,o|0,l|0)|0;l=Fd(l|0,C|0,r|0,b|0)|0;o=C;b=Jd(r|0,b|0,26)|0;b=Ed(d|0,q|0,b|0,C|0)|0;q=Fd(l|0,o|0,16777216,0)|0;q=Gd(q|0,C|0,25)|0;d=C;r=Qd(q|0,d|0,19,0)|0;n=Fd(r|0,C|0,m|0,n|0)|0;m=C;d=Jd(q|0,d|0,25)|0;d=Ed(l|0,o|0,d|0,C|0)|0;o=Fd(n|0,m|0,33554432,0)|0;o=Gd(o|0,C|0,26)|0;l=C;k=Fd(p|0,k|0,o|0,l|0)|0;l=Jd(o|0,l|0,26)|0;l=Ed(n|0,m|0,l|0,C|0)|0;c[a>>2]=l;c[a+4>>2]=k;c[a+8>>2]=j;c[a+12>>2]=i;c[a+16>>2]=h;c[a+20>>2]=g;c[a+24>>2]=f;c[a+28>>2]=e;c[a+32>>2]=b;c[a+36>>2]=d;return}function nd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;bb=c[b>>2]|0;ua=c[b+4>>2]|0;j=c[b+8>>2]|0;la=c[b+12>>2]|0;e=c[b+16>>2]|0;db=c[b+20>>2]|0;Y=c[b+24>>2]|0;La=c[b+28>>2]|0;h=c[b+32>>2]|0;b=c[b+36>>2]|0;l=bb<<1;p=ua<<1;Xa=j<<1;f=la<<1;na=e<<1;B=db<<1;m=Y<<1;i=La<<1;Ka=db*38|0;ra=Y*19|0;va=La*38|0;da=h*19|0;gb=b*38|0;cb=((bb|0)<0)<<31>>31;cb=Qd(bb|0,cb|0,bb|0,cb|0)|0;bb=C;o=((l|0)<0)<<31>>31;ta=((ua|0)<0)<<31>>31;Ia=Qd(l|0,o|0,ua|0,ta|0)|0;Ha=C;k=((j|0)<0)<<31>>31;Wa=Qd(j|0,k|0,l|0,o|0)|0;Va=C;ma=((la|0)<0)<<31>>31;Ua=Qd(la|0,ma|0,l|0,o|0)|0;Ta=C;D=((e|0)<0)<<31>>31;Oa=Qd(e|0,D|0,l|0,o|0)|0;Na=C;eb=((db|0)<0)<<31>>31;ya=Qd(db|0,eb|0,l|0,o|0)|0;xa=C;g=((Y|0)<0)<<31>>31;ga=Qd(Y|0,g|0,l|0,o|0)|0;fa=C;Ma=((La|0)<0)<<31>>31;R=Qd(La|0,Ma|0,l|0,o|0)|0;Q=C;A=((h|0)<0)<<31>>31;F=Qd(h|0,A|0,l|0,o|0)|0;E=C;q=((b|0)<0)<<31>>31;o=Qd(b|0,q|0,l|0,o|0)|0;l=C;n=((p|0)<0)<<31>>31;ta=Qd(p|0,n|0,ua|0,ta|0)|0;ua=C;ba=Qd(p|0,n|0,j|0,k|0)|0;ca=C;P=((f|0)<0)<<31>>31;Sa=Qd(f|0,P|0,p|0,n|0)|0;Ra=C;Ca=Qd(e|0,D|0,p|0,n|0)|0;Ba=C;d=((B|0)<0)<<31>>31;ia=Qd(B|0,d|0,p|0,n|0)|0;ha=C;T=Qd(Y|0,g|0,p|0,n|0)|0;S=C;O=((i|0)<0)<<31>>31;H=Qd(i|0,O|0,p|0,n|0)|0;G=C;t=Qd(h|0,A|0,p|0,n|0)|0;s=C;fb=((gb|0)<0)<<31>>31;n=Qd(gb|0,fb|0,p|0,n|0)|0;p=C;Qa=Qd(j|0,k|0,j|0,k|0)|0;Pa=C;Ya=((Xa|0)<0)<<31>>31;Aa=Qd(Xa|0,Ya|0,la|0,ma|0)|0;za=C;ka=Qd(e|0,D|0,Xa|0,Ya|0)|0;ja=C;X=Qd(db|0,eb|0,Xa|0,Ya|0)|0;W=C;N=Qd(Y|0,g|0,Xa|0,Ya|0)|0;M=C;v=Qd(La|0,Ma|0,Xa|0,Ya|0)|0;u=C;ea=((da|0)<0)<<31>>31;Ya=Qd(da|0,ea|0,Xa|0,Ya|0)|0;Xa=C;k=Qd(gb|0,fb|0,j|0,k|0)|0;j=C;ma=Qd(f|0,P|0,la|0,ma|0)|0;la=C;V=Qd(f|0,P|0,e|0,D|0)|0;U=C;J=Qd(B|0,d|0,f|0,P|0)|0;I=C;z=Qd(Y|0,g|0,f|0,P|0)|0;y=C;wa=((va|0)<0)<<31>>31;_a=Qd(va|0,wa|0,f|0,P|0)|0;Za=C;Ea=Qd(da|0,ea|0,f|0,P|0)|0;Da=C;P=Qd(gb|0,fb|0,f|0,P|0)|0;f=C;L=Qd(e|0,D|0,e|0,D|0)|0;K=C;oa=((na|0)<0)<<31>>31;x=Qd(na|0,oa|0,db|0,eb|0)|0;w=C;sa=((ra|0)<0)<<31>>31;ab=Qd(ra|0,sa|0,na|0,oa|0)|0;$a=C;Ga=Qd(va|0,wa|0,e|0,D|0)|0;Fa=C;oa=Qd(da|0,ea|0,na|0,oa|0)|0;na=C;D=Qd(gb|0,fb|0,e|0,D|0)|0;e=C;eb=Qd(Ka|0,((Ka|0)<0)<<31>>31|0,db|0,eb|0)|0;db=C;Ka=Qd(ra|0,sa|0,B|0,d|0)|0;Ja=C;qa=Qd(va|0,wa|0,B|0,d|0)|0;pa=C;_=Qd(da|0,ea|0,B|0,d|0)|0;Z=C;d=Qd(gb|0,fb|0,B|0,d|0)|0;B=C;sa=Qd(ra|0,sa|0,Y|0,g|0)|0;ra=C;aa=Qd(va|0,wa|0,Y|0,g|0)|0;$=C;m=Qd(da|0,ea|0,m|0,((m|0)<0)<<31>>31|0)|0;r=C;g=Qd(gb|0,fb|0,Y|0,g|0)|0;Y=C;Ma=Qd(va|0,wa|0,La|0,Ma|0)|0;La=C;wa=Qd(da|0,ea|0,i|0,O|0)|0;va=C;O=Qd(gb|0,fb|0,i|0,O|0)|0;i=C;ea=Qd(da|0,ea|0,h|0,A|0)|0;da=C;A=Qd(gb|0,fb|0,h|0,A|0)|0;h=C;q=Qd(gb|0,fb|0,b|0,q|0)|0;b=C;bb=Fd(eb|0,db|0,cb|0,bb|0)|0;$a=Fd(bb|0,C|0,ab|0,$a|0)|0;Za=Fd($a|0,C|0,_a|0,Za|0)|0;Xa=Fd(Za|0,C|0,Ya|0,Xa|0)|0;p=Fd(Xa|0,C|0,n|0,p|0)|0;n=C;ua=Fd(Wa|0,Va|0,ta|0,ua|0)|0;ta=C;ca=Fd(Ua|0,Ta|0,ba|0,ca|0)|0;ba=C;Pa=Fd(Sa|0,Ra|0,Qa|0,Pa|0)|0;Na=Fd(Pa|0,C|0,Oa|0,Na|0)|0;La=Fd(Na|0,C|0,Ma|0,La|0)|0;r=Fd(La|0,C|0,m|0,r|0)|0;B=Fd(r|0,C|0,d|0,B|0)|0;d=C;r=Fd(p|0,n|0,33554432,0)|0;r=Gd(r|0,C|0,26)|0;m=C;Ha=Fd(Ka|0,Ja|0,Ia|0,Ha|0)|0;Fa=Fd(Ha|0,C|0,Ga|0,Fa|0)|0;Da=Fd(Fa|0,C|0,Ea|0,Da|0)|0;j=Fd(Da|0,C|0,k|0,j|0)|0;j=Fd(j|0,C|0,r|0,m|0)|0;k=C;m=Jd(r|0,m|0,26)|0;m=Ed(p|0,n|0,m|0,C|0)|0;n=C;p=Fd(B|0,d|0,33554432,0)|0;p=Gd(p|0,C|0,26)|0;r=C;za=Fd(Ca|0,Ba|0,Aa|0,za|0)|0;xa=Fd(za|0,C|0,ya|0,xa|0)|0;va=Fd(xa|0,C|0,wa|0,va|0)|0;Y=Fd(va|0,C|0,g|0,Y|0)|0;Y=Fd(Y|0,C|0,p|0,r|0)|0;g=C;r=Jd(p|0,r|0,26)|0;r=Ed(B|0,d|0,r|0,C|0)|0;d=C;B=Fd(j|0,k|0,16777216,0)|0;B=Gd(B|0,C|0,25)|0;p=C;ra=Fd(ua|0,ta|0,sa|0,ra|0)|0;pa=Fd(ra|0,C|0,qa|0,pa|0)|0;na=Fd(pa|0,C|0,oa|0,na|0)|0;f=Fd(na|0,C|0,P|0,f|0)|0;f=Fd(f|0,C|0,B|0,p|0)|0;P=C;p=Jd(B|0,p|0,25)|0;p=Ed(j|0,k|0,p|0,C|0)|0;k=C;j=Fd(Y|0,g|0,16777216,0)|0;j=Gd(j|0,C|0,25)|0;B=C;ja=Fd(ma|0,la|0,ka|0,ja|0)|0;ha=Fd(ja|0,C|0,ia|0,ha|0)|0;fa=Fd(ha|0,C|0,ga|0,fa|0)|0;da=Fd(fa|0,C|0,ea|0,da|0)|0;i=Fd(da|0,C|0,O|0,i|0)|0;i=Fd(i|0,C|0,j|0,B|0)|0;O=C;B=Jd(j|0,B|0,25)|0;B=Ed(Y|0,g|0,B|0,C|0)|0;g=C;Y=Fd(f|0,P|0,33554432,0)|0;Y=Gd(Y|0,C|0,26)|0;j=C;$=Fd(ca|0,ba|0,aa|0,$|0)|0;Z=Fd($|0,C|0,_|0,Z|0)|0;e=Fd(Z|0,C|0,D|0,e|0)|0;e=Fd(e|0,C|0,Y|0,j|0)|0;D=C;j=Jd(Y|0,j|0,26)|0;j=Ed(f|0,P|0,j|0,C|0)|0;P=Fd(i|0,O|0,33554432,0)|0;P=Gd(P|0,C|0,26)|0;f=C;U=Fd(X|0,W|0,V|0,U|0)|0;S=Fd(U|0,C|0,T|0,S|0)|0;Q=Fd(S|0,C|0,R|0,Q|0)|0;h=Fd(Q|0,C|0,A|0,h|0)|0;h=Fd(h|0,C|0,P|0,f|0)|0;A=C;f=Jd(P|0,f|0,26)|0;f=Ed(i|0,O|0,f|0,C|0)|0;O=Fd(e|0,D|0,16777216,0)|0;O=Gd(O|0,C|0,25)|0;i=C;d=Fd(O|0,i|0,r|0,d|0)|0;r=C;i=Jd(O|0,i|0,25)|0;i=Ed(e|0,D|0,i|0,C|0)|0;D=Fd(h|0,A|0,16777216,0)|0;D=Gd(D|0,C|0,25)|0;e=C;K=Fd(N|0,M|0,L|0,K|0)|0;I=Fd(K|0,C|0,J|0,I|0)|0;G=Fd(I|0,C|0,H|0,G|0)|0;E=Fd(G|0,C|0,F|0,E|0)|0;b=Fd(E|0,C|0,q|0,b|0)|0;b=Fd(b|0,C|0,D|0,e|0)|0;q=C;e=Jd(D|0,e|0,25)|0;e=Ed(h|0,A|0,e|0,C|0)|0;A=Fd(d|0,r|0,33554432,0)|0;A=Gd(A|0,C|0,26)|0;h=C;g=Fd(B|0,g|0,A|0,h|0)|0;h=Jd(A|0,h|0,26)|0;h=Ed(d|0,r|0,h|0,C|0)|0;r=Fd(b|0,q|0,33554432,0)|0;r=Gd(r|0,C|0,26)|0;d=C;w=Fd(z|0,y|0,x|0,w|0)|0;u=Fd(w|0,C|0,v|0,u|0)|0;s=Fd(u|0,C|0,t|0,s|0)|0;l=Fd(s|0,C|0,o|0,l|0)|0;l=Fd(l|0,C|0,r|0,d|0)|0;o=C;d=Jd(r|0,d|0,26)|0;d=Ed(b|0,q|0,d|0,C|0)|0;q=Fd(l|0,o|0,16777216,0)|0;q=Gd(q|0,C|0,25)|0;b=C;r=Qd(q|0,b|0,19,0)|0;n=Fd(r|0,C|0,m|0,n|0)|0;m=C;b=Jd(q|0,b|0,25)|0;b=Ed(l|0,o|0,b|0,C|0)|0;o=Fd(n|0,m|0,33554432,0)|0;o=Gd(o|0,C|0,26)|0;l=C;k=Fd(p|0,k|0,o|0,l|0)|0;l=Jd(o|0,l|0,26)|0;l=Ed(n|0,m|0,l|0,C|0)|0;c[a>>2]=l;c[a+4>>2]=k;c[a+8>>2]=j;c[a+12>>2]=i;c[a+16>>2]=h;c[a+20>>2]=g;c[a+24>>2]=f;c[a+28>>2]=e;c[a+32>>2]=d;c[a+36>>2]=b;return}function od(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0;Ya=i;Oa=i=i+63&-64;i=i+480|0;Ta=Oa+400|0;Ua=Oa+360|0;Va=Oa+320|0;Sa=Oa+280|0;Ma=Oa+440|0;Pa=Oa+240|0;Wa=Oa+200|0;Xa=Oa+160|0;Qa=Oa+120|0;Ra=Oa+80|0;Na=Oa+40|0;h=Ma;g=h+32|0;do{a[h>>0]=a[e>>0]|0;h=h+1|0;e=e+1|0}while((h|0)<(g|0));a[Ma>>0]=(d[Ma>>0]|0)&248;va=Ma+31|0;a[va>>0]=(d[va>>0]|0)&63|64;va=d[f>>0]|0;m=Jd(d[f+1>>0]|0|0,0,8)|0;j=C;za=Jd(d[f+2>>0]|0|0,0,16)|0;j=j|C;Aa=Jd(d[f+3>>0]|0|0,0,24)|0;j=j|C;e=a[f+6>>0]|0;l=d[f+4>>0]|0;ya=Jd(d[f+5>>0]|0|0,0,8)|0;k=C;e=Jd(e&255|0,0,16)|0;k=Jd(ya|l|e|0,k|C|0,6)|0;e=C;l=a[f+9>>0]|0;ya=d[f+7>>0]|0;n=Jd(d[f+8>>0]|0|0,0,8)|0;Ea=C;l=Jd(l&255|0,0,16)|0;Ea=Jd(n|ya|l|0,Ea|C|0,5)|0;l=C;ya=a[f+12>>0]|0;n=d[f+10>>0]|0;Ga=Jd(d[f+11>>0]|0|0,0,8)|0;xa=C;ya=Jd(ya&255|0,0,16)|0;xa=Jd(Ga|n|ya|0,xa|C|0,3)|0;ya=C;n=a[f+15>>0]|0;Ga=d[f+13>>0]|0;h=Jd(d[f+14>>0]|0|0,0,8)|0;Ia=C;n=Jd(n&255|0,0,16)|0;Ia=Jd(h|Ga|n|0,Ia|C|0,2)|0;n=C;Ga=d[f+16>>0]|0;h=Jd(d[f+17>>0]|0|0,0,8)|0;Ca=C;p=Jd(d[f+18>>0]|0|0,0,16)|0;Ca=Ca|C;Ba=Jd(d[f+19>>0]|0|0,0,24)|0;Ba=h|Ga|p|Ba;Ca=Ca|C;p=a[f+22>>0]|0;Ga=d[f+20>>0]|0;h=Jd(d[f+21>>0]|0|0,0,8)|0;g=C;p=Jd(p&255|0,0,16)|0;g=Jd(h|Ga|p|0,g|C|0,7)|0;p=C;Ga=a[f+25>>0]|0;h=d[f+23>>0]|0;q=Jd(d[f+24>>0]|0|0,0,8)|0;Fa=C;Ga=Jd(Ga&255|0,0,16)|0;Fa=Jd(q|h|Ga|0,Fa|C|0,5)|0;Ga=C;h=a[f+28>>0]|0;q=d[f+26>>0]|0;Ka=Jd(d[f+27>>0]|0|0,0,8)|0;La=C;h=Jd(h&255|0,0,16)|0;La=Jd(Ka|q|h|0,La|C|0,4)|0;h=C;q=a[f+31>>0]|0;Ka=d[f+29>>0]|0;Da=Jd(d[f+30>>0]|0|0,0,8)|0;Ja=C;q=Jd(q&255|0,0,16)|0;Ja=Jd(Da|Ka|q|0,Ja|C|0,2)|0;Ja=Ja&33554428;q=Fd(Ja|0,0,16777216,0)|0;q=Id(q|0,C|0,25)|0;Ka=C;Da=Ed(0,0,q|0,Ka|0)|0;j=Fd(Da&19|0,0,m|va|za|Aa|0,j|0)|0;Aa=C;Ka=Jd(q|0,Ka|0,25)|0;q=C;za=Fd(k|0,e|0,16777216,0)|0;za=Id(za|0,C|0,25)|0;va=C;l=Fd(Ea|0,l|0,za|0,va|0)|0;Ea=C;va=Jd(za|0,va|0,25)|0;va=Ed(k|0,e|0,va|0,C|0)|0;e=C;k=Fd(xa|0,ya|0,16777216,0)|0;k=Id(k|0,C|0,25)|0;za=C;n=Fd(Ia|0,n|0,k|0,za|0)|0;Ia=C;za=Jd(k|0,za|0,25)|0;k=C;m=Fd(Ba|0,Ca|0,16777216,0)|0;m=Id(m|0,C|0,25)|0;Da=C;p=Fd(g|0,p|0,m|0,Da|0)|0;g=C;Da=Jd(m|0,Da|0,25)|0;m=C;o=Fd(Fa|0,Ga|0,16777216,0)|0;o=Id(o|0,C|0,25)|0;Ha=C;h=Fd(La|0,h|0,o|0,Ha|0)|0;La=C;Ha=Jd(o|0,Ha|0,25)|0;o=C;wa=Fd(j|0,Aa|0,33554432,0)|0;wa=Gd(wa|0,C|0,26)|0;f=C;e=Fd(va|0,e|0,wa|0,f|0)|0;f=Jd(wa|0,f|0,26)|0;f=Ed(j|0,Aa|0,f|0,C|0)|0;Aa=Fd(l|0,Ea|0,33554432,0)|0;Aa=Gd(Aa|0,C|0,26)|0;j=C;ya=Fd(Aa|0,j|0,xa|0,ya|0)|0;k=Ed(ya|0,C|0,za|0,k|0)|0;j=Jd(Aa|0,j|0,26)|0;j=Ed(l|0,Ea|0,j|0,C|0)|0;Ea=Fd(n|0,Ia|0,33554432,0)|0;Ea=Gd(Ea|0,C|0,26)|0;l=C;Ca=Fd(Ea|0,l|0,Ba|0,Ca|0)|0;m=Ed(Ca|0,C|0,Da|0,m|0)|0;l=Jd(Ea|0,l|0,26)|0;l=Ed(n|0,Ia|0,l|0,C|0)|0;Ia=Fd(p|0,g|0,33554432,0)|0;Ia=Gd(Ia|0,C|0,26)|0;n=C;Ga=Fd(Ia|0,n|0,Fa|0,Ga|0)|0;o=Ed(Ga|0,C|0,Ha|0,o|0)|0;n=Jd(Ia|0,n|0,26)|0;n=Ed(p|0,g|0,n|0,C|0)|0;g=Fd(h|0,La|0,33554432,0)|0;g=Gd(g|0,C|0,26)|0;p=C;Ja=Fd(Ja|0,0,g|0,p|0)|0;q=Ed(Ja|0,C|0,Ka|0,q|0)|0;p=Jd(g|0,p|0,26)|0;p=Ed(h|0,La|0,p|0,C|0)|0;c[Pa>>2]=f;c[Pa+4>>2]=e;c[Pa+8>>2]=j;c[Pa+12>>2]=k;c[Pa+16>>2]=l;c[Pa+20>>2]=m;c[Pa+24>>2]=n;c[Pa+28>>2]=o;c[Pa+32>>2]=p;c[Pa+36>>2]=q;c[Wa>>2]=1;La=Wa+4|0;h=La;g=h+36|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(g|0));h=Xa;g=h+40|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(g|0));c[Qa>>2]=f;ta=Qa+4|0;c[ta>>2]=e;ua=Qa+8|0;c[ua>>2]=j;va=Qa+12|0;c[va>>2]=k;wa=Qa+16|0;c[wa>>2]=l;xa=Qa+20|0;c[xa>>2]=m;ya=Qa+24|0;c[ya>>2]=n;za=Qa+28|0;c[za>>2]=o;Aa=Qa+32|0;c[Aa>>2]=p;Ba=Qa+36|0;c[Ba>>2]=q;c[Ra>>2]=1;Ca=Ra+4|0;h=Ca;g=h+36|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(g|0));Da=Wa+8|0;Ea=Wa+12|0;Fa=Wa+16|0;Ga=Wa+20|0;Ha=Wa+24|0;Ia=Wa+28|0;Ja=Wa+32|0;Ka=Wa+36|0;M=Xa+4|0;N=Xa+8|0;O=Xa+12|0;P=Xa+16|0;Q=Xa+20|0;R=Xa+24|0;S=Xa+28|0;T=Xa+32|0;U=Xa+36|0;V=Ra+8|0;W=Ra+12|0;X=Ra+16|0;Y=Ra+20|0;Z=Ra+24|0;_=Ra+28|0;$=Ra+32|0;aa=Ra+36|0;ba=Na+4|0;ca=Na+8|0;da=Na+12|0;ea=Na+16|0;fa=Na+20|0;ga=Na+24|0;ha=Na+28|0;ia=Na+32|0;ja=Na+36|0;ka=Oa+4|0;la=Oa+8|0;ma=Oa+12|0;na=Oa+16|0;oa=Oa+20|0;pa=Oa+24|0;qa=Oa+28|0;ra=Oa+32|0;sa=Oa+36|0;L=1;K=0;J=0;I=0;H=0;G=0;F=0;E=0;D=0;g=0;r=0;s=0;t=0;u=0;v=0;w=0;x=0;y=0;z=0;A=254;B=0;while(1){h=(d[Ma+((A|0)/8|0)>>0]|0)>>>(A&7)&1;nb=0-(h^B)|0;bb=(f^L)&nb;ab=(e^K)&nb;$a=(j^J)&nb;_a=(k^I)&nb;Za=(l^H)&nb;kb=(m^G)&nb;mb=(n^F)&nb;B=(o^E)&nb;jb=(p^D)&nb;lb=(q^g)&nb;c[Wa>>2]=bb^L;c[La>>2]=ab^K;c[Da>>2]=$a^J;c[Ea>>2]=_a^I;c[Fa>>2]=Za^H;c[Ga>>2]=kb^G;c[Ha>>2]=mb^F;c[Ia>>2]=B^E;c[Ja>>2]=jb^D;c[Ka>>2]=lb^g;bb=bb^f;c[Qa>>2]=bb;ab=ab^e;c[ta>>2]=ab;$a=$a^j;c[ua>>2]=$a;_a=_a^k;c[va>>2]=_a;Za=Za^l;c[wa>>2]=Za;I=kb^m;c[xa>>2]=I;E=mb^n;c[ya>>2]=E;l=B^o;c[za>>2]=l;j=jb^p;c[Aa>>2]=j;f=lb^q;c[Ba>>2]=f;K=c[U>>2]|0;lb=c[Ra>>2]|0;jb=c[Ca>>2]|0;B=c[V>>2]|0;p=c[W>>2]|0;q=c[X>>2]|0;D=c[Y>>2]|0;F=c[Z>>2]|0;H=c[_>>2]|0;J=c[$>>2]|0;L=c[aa>>2]|0;mb=(lb^r)&nb;kb=(jb^s)&nb;ib=(B^t)&nb;hb=(p^u)&nb;gb=(q^v)&nb;fb=(D^w)&nb;eb=(F^x)&nb;db=(H^y)&nb;cb=(J^z)&nb;o=(L^K)&nb;e=mb^r;c[Xa>>2]=e;g=kb^s;c[M>>2]=g;k=ib^t;c[N>>2]=k;m=hb^u;c[O>>2]=m;n=gb^v;c[P>>2]=n;r=fb^w;c[Q>>2]=r;v=eb^x;c[R>>2]=v;x=db^y;c[S>>2]=x;G=cb^z;c[T>>2]=G;K=o^K;c[U>>2]=K;s=mb^lb;c[Ra>>2]=s;u=kb^jb;c[Ca>>2]=u;B=ib^B;c[V>>2]=B;p=hb^p;c[W>>2]=p;q=gb^q;c[X>>2]=q;D=fb^D;c[Y>>2]=D;F=eb^F;c[Z>>2]=F;H=db^H;c[_>>2]=H;J=cb^J;c[$>>2]=J;L=o^L;c[aa>>2]=L;c[Na>>2]=bb-s;c[ba>>2]=ab-u;c[ca>>2]=$a-B;c[da>>2]=_a-p;c[ea>>2]=Za-q;c[fa>>2]=I-D;c[ga>>2]=E-F;c[ha>>2]=l-H;c[ia>>2]=j-J;c[ja>>2]=f-L;f=c[Wa>>2]|0;j=c[La>>2]|0;l=c[Da>>2]|0;w=c[Ea>>2]|0;o=c[Fa>>2]|0;t=c[Ga>>2]|0;z=c[Ha>>2]|0;E=c[Ia>>2]|0;I=c[Ja>>2]|0;y=c[Ka>>2]|0;c[Oa>>2]=f-e;c[ka>>2]=j-g;c[la>>2]=l-k;c[ma>>2]=w-m;c[na>>2]=o-n;c[oa>>2]=t-r;c[pa>>2]=z-v;c[qa>>2]=E-x;c[ra>>2]=I-G;c[sa>>2]=y-K;c[Wa>>2]=e+f;c[La>>2]=g+j;c[Da>>2]=k+l;c[Ea>>2]=m+w;c[Fa>>2]=n+o;c[Ga>>2]=r+t;c[Ha>>2]=v+z;c[Ia>>2]=x+E;c[Ja>>2]=G+I;c[Ka>>2]=K+y;u=u+(c[ta>>2]|0)|0;B=B+(c[ua>>2]|0)|0;p=p+(c[va>>2]|0)|0;q=q+(c[wa>>2]|0)|0;D=D+(c[xa>>2]|0)|0;F=F+(c[ya>>2]|0)|0;H=H+(c[za>>2]|0)|0;J=J+(c[Aa>>2]|0)|0;L=L+(c[Ba>>2]|0)|0;c[Xa>>2]=s+(c[Qa>>2]|0);c[M>>2]=u;c[N>>2]=B;c[O>>2]=p;c[P>>2]=q;c[Q>>2]=D;c[R>>2]=F;c[S>>2]=H;c[T>>2]=J;c[U>>2]=L;md(Ra,Na,Wa);md(Xa,Xa,Oa);nd(Na,Oa);nd(Oa,Wa);L=c[Ra>>2]|0;J=c[Ca>>2]|0;H=c[V>>2]|0;F=c[W>>2]|0;D=c[X>>2]|0;q=c[Y>>2]|0;p=c[Z>>2]|0;B=c[_>>2]|0;u=c[$>>2]|0;s=c[aa>>2]|0;y=c[Xa>>2]|0;K=c[M>>2]|0;I=c[N>>2]|0;G=c[O>>2]|0;E=c[P>>2]|0;z=c[Q>>2]|0;x=c[R>>2]|0;v=c[S>>2]|0;t=c[T>>2]|0;r=c[U>>2]|0;c[Qa>>2]=y+L;c[ta>>2]=K+J;c[ua>>2]=I+H;c[va>>2]=G+F;c[wa>>2]=E+D;c[xa>>2]=z+q;c[ya>>2]=x+p;c[za>>2]=v+B;c[Aa>>2]=t+u;c[Ba>>2]=r+s;c[Xa>>2]=L-y;c[M>>2]=J-K;c[N>>2]=H-I;c[O>>2]=F-G;c[P>>2]=D-E;c[Q>>2]=q-z;c[R>>2]=p-x;c[S>>2]=B-v;c[T>>2]=u-t;c[U>>2]=s-r;md(Wa,Oa,Na);r=(c[Oa>>2]|0)-(c[Na>>2]|0)|0;s=(c[ka>>2]|0)-(c[ba>>2]|0)|0;t=(c[la>>2]|0)-(c[ca>>2]|0)|0;u=(c[ma>>2]|0)-(c[da>>2]|0)|0;v=(c[na>>2]|0)-(c[ea>>2]|0)|0;B=(c[oa>>2]|0)-(c[fa>>2]|0)|0;x=(c[pa>>2]|0)-(c[ga>>2]|0)|0;p=(c[qa>>2]|0)-(c[ha>>2]|0)|0;z=(c[ra>>2]|0)-(c[ia>>2]|0)|0;q=(c[sa>>2]|0)-(c[ja>>2]|0)|0;c[Oa>>2]=r;c[ka>>2]=s;c[la>>2]=t;c[ma>>2]=u;c[na>>2]=v;c[oa>>2]=B;c[pa>>2]=x;c[qa>>2]=p;c[ra>>2]=z;c[sa>>2]=q;nd(Xa,Xa);r=Qd(r|0,((r|0)<0)<<31>>31|0,121666,0)|0;E=C;s=Qd(s|0,((s|0)<0)<<31>>31|0,121666,0)|0;D=C;t=Qd(t|0,((t|0)<0)<<31>>31|0,121666,0)|0;G=C;u=Qd(u|0,((u|0)<0)<<31>>31|0,121666,0)|0;F=C;v=Qd(v|0,((v|0)<0)<<31>>31|0,121666,0)|0;I=C;B=Qd(B|0,((B|0)<0)<<31>>31|0,121666,0)|0;H=C;x=Qd(x|0,((x|0)<0)<<31>>31|0,121666,0)|0;K=C;p=Qd(p|0,((p|0)<0)<<31>>31|0,121666,0)|0;J=C;z=Qd(z|0,((z|0)<0)<<31>>31|0,121666,0)|0;y=C;q=Qd(q|0,((q|0)<0)<<31>>31|0,121666,0)|0;L=C;o=Fd(q|0,L|0,16777216,0)|0;o=Gd(o|0,C|0,25)|0;w=C;n=Qd(o|0,w|0,19,0)|0;E=Fd(n|0,C|0,r|0,E|0)|0;r=C;w=Jd(o|0,w|0,25)|0;w=Ed(q|0,L|0,w|0,C|0)|0;L=C;q=Fd(s|0,D|0,16777216,0)|0;q=Gd(q|0,C|0,25)|0;o=C;G=Fd(q|0,o|0,t|0,G|0)|0;t=C;o=Jd(q|0,o|0,25)|0;o=Ed(s|0,D|0,o|0,C|0)|0;D=C;s=Fd(u|0,F|0,16777216,0)|0;s=Gd(s|0,C|0,25)|0;q=C;I=Fd(s|0,q|0,v|0,I|0)|0;v=C;q=Jd(s|0,q|0,25)|0;q=Ed(u|0,F|0,q|0,C|0)|0;F=C;u=Fd(B|0,H|0,16777216,0)|0;u=Gd(u|0,C|0,25)|0;s=C;K=Fd(u|0,s|0,x|0,K|0)|0;x=C;s=Jd(u|0,s|0,25)|0;s=Ed(B|0,H|0,s|0,C|0)|0;H=C;B=Fd(p|0,J|0,16777216,0)|0;B=Gd(B|0,C|0,25)|0;u=C;y=Fd(B|0,u|0,z|0,y|0)|0;z=C;u=Jd(B|0,u|0,25)|0;u=Ed(p|0,J|0,u|0,C|0)|0;J=C;p=Fd(E|0,r|0,33554432,0)|0;p=Gd(p|0,C|0,26)|0;B=C;D=Fd(o|0,D|0,p|0,B|0)|0;B=Jd(p|0,B|0,26)|0;B=Ed(E|0,r|0,B|0,C|0)|0;r=Fd(G|0,t|0,33554432,0)|0;r=Gd(r|0,C|0,26)|0;E=C;F=Fd(q|0,F|0,r|0,E|0)|0;E=Jd(r|0,E|0,26)|0;E=Ed(G|0,t|0,E|0,C|0)|0;t=Fd(I|0,v|0,33554432,0)|0;t=Gd(t|0,C|0,26)|0;G=C;H=Fd(s|0,H|0,t|0,G|0)|0;G=Jd(t|0,G|0,26)|0;G=Ed(I|0,v|0,G|0,C|0)|0;v=Fd(K|0,x|0,33554432,0)|0;v=Gd(v|0,C|0,26)|0;I=C;J=Fd(u|0,J|0,v|0,I|0)|0;I=Jd(v|0,I|0,26)|0;I=Ed(K|0,x|0,I|0,C|0)|0;x=Fd(y|0,z|0,33554432,0)|0;x=Gd(x|0,C|0,26)|0;K=C;L=Fd(w|0,L|0,x|0,K|0)|0;K=Jd(x|0,K|0,26)|0;K=Ed(y|0,z|0,K|0,C|0)|0;c[Ra>>2]=B;c[Ca>>2]=D;c[V>>2]=E;c[W>>2]=F;c[X>>2]=G;c[Y>>2]=H;c[Z>>2]=I;c[_>>2]=J;c[$>>2]=K;c[aa>>2]=L;nd(Qa,Qa);D=D+(c[ba>>2]|0)|0;E=E+(c[ca>>2]|0)|0;F=F+(c[da>>2]|0)|0;G=G+(c[ea>>2]|0)|0;H=H+(c[fa>>2]|0)|0;I=I+(c[ga>>2]|0)|0;J=J+(c[ha>>2]|0)|0;K=K+(c[ia>>2]|0)|0;L=L+(c[ja>>2]|0)|0;c[Na>>2]=B+(c[Na>>2]|0);c[ba>>2]=D;c[ca>>2]=E;c[da>>2]=F;c[ea>>2]=G;c[fa>>2]=H;c[ga>>2]=I;c[ha>>2]=J;c[ia>>2]=K;c[ja>>2]=L;md(Ra,Pa,Xa);md(Xa,Oa,Na);if((A|0)<=0)break;f=c[Qa>>2]|0;L=c[Wa>>2]|0;e=c[ta>>2]|0;K=c[La>>2]|0;j=c[ua>>2]|0;J=c[Da>>2]|0;k=c[va>>2]|0;I=c[Ea>>2]|0;l=c[wa>>2]|0;H=c[Fa>>2]|0;m=c[xa>>2]|0;G=c[Ga>>2]|0;n=c[ya>>2]|0;F=c[Ha>>2]|0;o=c[za>>2]|0;E=c[Ia>>2]|0;p=c[Aa>>2]|0;D=c[Ja>>2]|0;q=c[Ba>>2]|0;g=c[Ka>>2]|0;r=c[Xa>>2]|0;s=c[M>>2]|0;t=c[N>>2]|0;u=c[O>>2]|0;v=c[P>>2]|0;w=c[Q>>2]|0;x=c[R>>2]|0;y=c[S>>2]|0;z=c[T>>2]|0;A=A+-1|0;B=h}ka=c[Wa>>2]|0;la=c[La>>2]|0;ma=c[Da>>2]|0;na=c[Ea>>2]|0;oa=c[Fa>>2]|0;pa=c[Ga>>2]|0;qa=c[Ha>>2]|0;ra=c[Ia>>2]|0;sa=c[Ja>>2]|0;lb=c[Ka>>2]|0;hb=c[Qa>>2]|0;db=c[ta>>2]|0;$a=c[ua>>2]|0;Pa=c[va>>2]|0;mb=c[wa>>2]|0;ib=c[xa>>2]|0;eb=c[ya>>2]|0;ab=c[za>>2]|0;Oa=c[Aa>>2]|0;Ma=c[Ba>>2]|0;nb=0-h|0;jb=(hb^ka)&nb;fb=(db^la)&nb;bb=($a^ma)&nb;Za=(Pa^na)&nb;e=(mb^oa)&nb;kb=(ib^pa)&nb;gb=(eb^qa)&nb;cb=(ab^ra)&nb;_a=(Oa^sa)&nb;Na=(Ma^lb)&nb;c[Wa>>2]=jb^ka;c[La>>2]=fb^la;c[Da>>2]=bb^ma;c[Ea>>2]=Za^na;c[Fa>>2]=e^oa;c[Ga>>2]=kb^pa;c[Ha>>2]=gb^qa;c[Ia>>2]=cb^ra;c[Ja>>2]=_a^sa;c[Ka>>2]=Na^lb;c[Qa>>2]=jb^hb;c[ta>>2]=fb^db;c[ua>>2]=bb^$a;c[va>>2]=Za^Pa;c[wa>>2]=e^mb;c[xa>>2]=kb^ib;c[ya>>2]=gb^eb;c[za>>2]=cb^ab;c[Aa>>2]=_a^Oa;c[Ba>>2]=Na^Ma;va=c[Xa>>2]|0;wa=c[M>>2]|0;xa=c[N>>2]|0;ya=c[O>>2]|0;za=c[P>>2]|0;Aa=c[Q>>2]|0;Ba=c[R>>2]|0;Ma=c[S>>2]|0;Na=c[T>>2]|0;Oa=c[U>>2]|0;Qa=c[Ra>>2]|0;_a=c[Ca>>2]|0;ab=c[V>>2]|0;cb=c[W>>2]|0;eb=c[X>>2]|0;gb=c[Y>>2]|0;ib=c[Z>>2]|0;kb=c[_>>2]|0;mb=c[$>>2]|0;e=c[aa>>2]|0;Pa=(Qa^va)&nb;Za=(_a^wa)&nb;$a=(ab^xa)&nb;bb=(cb^ya)&nb;db=(eb^za)&nb;fb=(gb^Aa)&nb;hb=(ib^Ba)&nb;jb=(kb^Ma)&nb;lb=(mb^Na)&nb;nb=(e^Oa)&nb;c[Xa>>2]=Pa^va;c[M>>2]=Za^wa;c[N>>2]=$a^xa;c[O>>2]=bb^ya;c[P>>2]=db^za;c[Q>>2]=fb^Aa;c[R>>2]=hb^Ba;c[S>>2]=jb^Ma;c[T>>2]=lb^Na;c[U>>2]=nb^Oa;c[Ra>>2]=Pa^Qa;c[Ca>>2]=Za^_a;c[V>>2]=$a^ab;c[W>>2]=bb^cb;c[X>>2]=db^eb;c[Y>>2]=fb^gb;c[Z>>2]=hb^ib;c[_>>2]=jb^kb;c[$>>2]=lb^mb;c[aa>>2]=nb^e;nd(Ta,Xa);nd(Ua,Ta);nd(Ua,Ua);md(Ua,Xa,Ua);md(Ta,Ta,Ua);nd(Va,Ta);md(Ua,Ua,Va);nd(Va,Ua);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);md(Ua,Va,Ua);nd(Va,Ua);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);md(Va,Va,Ua);nd(Sa,Va);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);nd(Sa,Sa);md(Va,Sa,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);nd(Va,Va);md(Ua,Va,Ua);nd(Va,Ua);e=1;do{nd(Va,Va);e=e+1|0}while((e|0)!=50);md(Va,Va,Ua);nd(Sa,Va);e=1;do{nd(Sa,Sa);e=e+1|0}while((e|0)!=100);md(Va,Sa,Va);nd(Va,Va);e=1;do{nd(Va,Va);e=e+1|0}while((e|0)!=50);md(Ua,Va,Ua);nd(Ua,Ua);nd(Ua,Ua);nd(Ua,Ua);nd(Ua,Ua);nd(Ua,Ua);md(Xa,Ua,Ta);md(Wa,Wa,Xa);eb=c[Wa>>2]|0;fb=c[La>>2]|0;gb=c[Da>>2]|0;hb=c[Ea>>2]|0;ib=c[Fa>>2]|0;jb=c[Ga>>2]|0;kb=c[Ha>>2]|0;lb=c[Ia>>2]|0;nb=c[Ja>>2]|0;mb=c[Ka>>2]|0;eb=(((((((((((((mb*19|0)+16777216>>25)+eb>>26)+fb>>25)+gb>>26)+hb>>25)+ib>>26)+jb>>25)+kb>>26)+lb>>25)+nb>>26)+mb>>25)*19|0)+eb|0;db=eb>>26;fb=db+fb|0;db=eb-(db<<26)|0;eb=fb>>25;gb=eb+gb|0;eb=fb-(eb<<25)|0;fb=gb>>26;hb=fb+hb|0;fb=gb-(fb<<26)|0;gb=hb>>25;ib=gb+ib|0;gb=hb-(gb<<25)|0;hb=ib>>26;jb=hb+jb|0;hb=ib-(hb<<26)|0;ib=jb>>25;kb=ib+kb|0;ib=jb-(ib<<25)|0;jb=kb>>26;lb=jb+lb|0;jb=kb-(jb<<26)|0;kb=lb>>25;nb=kb+nb|0;kb=lb-(kb<<25)|0;lb=nb>>26;mb=lb+mb|0;lb=nb-(lb<<26)|0;nb=mb&33554431;a[b>>0]=db;a[b+1>>0]=db>>>8;a[b+2>>0]=db>>>16;a[b+3>>0]=eb<<2|db>>>24;a[b+4>>0]=eb>>>6;a[b+5>>0]=eb>>>14;a[b+6>>0]=fb<<3|eb>>>22;a[b+7>>0]=fb>>>5;a[b+8>>0]=fb>>>13;a[b+9>>0]=gb<<5|fb>>>21;a[b+10>>0]=gb>>>3;a[b+11>>0]=gb>>>11;a[b+12>>0]=hb<<6|gb>>>19;a[b+13>>0]=hb>>>2;a[b+14>>0]=hb>>>10;a[b+15>>0]=hb>>>18;a[b+16>>0]=ib;a[b+17>>0]=ib>>>8;a[b+18>>0]=ib>>>16;a[b+19>>0]=jb<<1|ib>>>24;a[b+20>>0]=jb>>>7;a[b+21>>0]=jb>>>15;a[b+22>>0]=kb<<3|jb>>>23;a[b+23>>0]=kb>>>5;a[b+24>>0]=kb>>>13;a[b+25>>0]=lb<<4|kb>>>21;a[b+26>>0]=lb>>>4;a[b+27>>0]=lb>>>12;a[b+28>>0]=lb>>>20|nb<<6;a[b+29>>0]=mb>>>2;a[b+30>>0]=mb>>>10;a[b+31>>0]=nb>>>18;i=Ya;return}function pd(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0;D=i;B=i=i+63&-64;i=i+112|0;y=B;A=B+48|0;B=B+16|0;if((f|0)==0&(g|0)==0){i=D;return}o=B;n=o+32|0;do{a[o>>0]=a[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(n|0));u=h;r=u;u=u+4|0;u=d[u>>0]|d[u+1>>0]<<8|d[u+2>>0]<<16|d[u+3>>0]<<24;q=y;c[q>>2]=d[r>>0]|d[r+1>>0]<<8|d[r+2>>0]<<16|d[r+3>>0]<<24;c[q+4>>2]=u;q=y+8|0;a[q>>0]=j;u=Id(j|0,k|0,8)|0;r=y+9|0;a[r>>0]=u;u=Id(j|0,k|0,16)|0;s=y+10|0;a[s>>0]=u;u=Id(j|0,k|0,24)|0;t=y+11|0;a[t>>0]=u;u=y+12|0;a[u>>0]=k;x=Id(j|0,k|0,40)|0;v=y+13|0;a[v>>0]=x;x=Id(j|0,k|0,48)|0;w=y+14|0;a[w>>0]=x;x=Id(j|0,k|0,56)|0;l=y+15|0;a[l>>0]=x;if(g>>>0>0|(g|0)==0&f>>>0>63){p=Fd(f|0,g|0,-64,-1)|0;x=p+64&-64;j=b;n=e;k=f;o=g;while(1){ob(A,y,B,33827);h=0;do{a[j+h>>0]=a[A+h>>0]^a[n+h>>0];h=h+1|0}while((h|0)!=64);f=c[q>>2]|0;g=(f&255)+1|0;a[q>>0]=g;g=(f>>>8&255)+(g>>>8)|0;a[r>>0]=g;g=(f>>>16&255)+(g>>>8)|0;a[s>>0]=g;g=(f>>>24)+(g>>>8)|0;a[t>>0]=g;f=c[u>>2]|0;g=(f&255)+(g>>>8)|0;a[u>>0]=g;g=(f>>>8&255)+(g>>>8)|0;a[v>>0]=g;g=(f>>>16&255)+(g>>>8)|0;a[w>>0]=g;a[l>>0]=(f>>>24)+(g>>>8);k=Fd(k|0,o|0,-64,-1)|0;o=C;if(!(o>>>0>0|(o|0)==0&k>>>0>63))break;else{j=j+64|0;n=n+64|0}}l=p&63;if(!((l|0)==0&0==0)?(m=l,ob(A,y,B,33827),(m|0)!=0):0){b=b+x|0;e=e+x|0;z=10}}else{ob(A,y,B,33827);m=f;z=10}if((z|0)==10){l=0;do{a[b+l>>0]=a[A+l>>0]^a[e+l>>0];l=l+1|0}while((l|0)!=(m|0))}o=A;n=o+64|0;do{a[o>>0]=0;o=o+1|0}while((o|0)<(n|0));o=B;n=o+32|0;do{a[o>>0]=0;o=o+1|0}while((o|0)<(n|0));i=D;return}
function Ib(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;h=i;g=i=i+63&-64;i=i+640|0;e=0;do{j=e<<3;o=d[b+(j|7)>>0]|0;p=Jd(d[b+(j|6)>>0]|0|0,0,8)|0;f=C;n=Jd(d[b+(j|5)>>0]|0|0,0,16)|0;f=f|C;m=Jd(d[b+(j|4)>>0]|0|0,0,24)|0;f=f|C|(d[b+(j|3)>>0]|0);l=Jd(d[b+(j|2)>>0]|0|0,0,40)|0;f=f|C;k=Jd(d[b+(j|1)>>0]|0|0,0,48)|0;k=Fd(p|o|n|m|l|0,f|0,k|0,C|0)|0;f=C;j=Jd(d[b+j>>0]|0|0,0,56)|0;j=Fd(k|0,f|0,j|0,C|0)|0;f=g+(e<<3)|0;c[f>>2]=j;c[f+4>>2]=C;e=e+1|0}while((e|0)!=16);b=g;e=c[b>>2]|0;b=c[b+4>>2]|0;f=16;do{s=g+(f+-2<<3)|0;w=c[s>>2]|0;s=c[s+4>>2]|0;r=Id(w|0,s|0,19)|0;j=C;q=Jd(w|0,s|0,45)|0;j=j|C;u=Id(w|0,s|0,61)|0;v=C;t=Jd(w|0,s|0,3)|0;v=v|C;s=Id(w|0,s|0,6)|0;j=v^C^j;v=g+(f+-7<<3)|0;w=c[v>>2]|0;v=c[v+4>>2]|0;n=g+(f+-15<<3)|0;y=e;e=c[n>>2]|0;x=b;b=c[n+4>>2]|0;n=Id(e|0,b|0,1)|0;o=C;p=Jd(e|0,b|0,63)|0;o=o|C;k=Id(e|0,b|0,8)|0;z=C;l=Jd(e|0,b|0,56)|0;z=z|C;m=Id(e|0,b|0,7)|0;o=z^C^o;v=Fd(y|0,x|0,w|0,v|0)|0;j=Fd(v|0,C|0,(u|t)^s^(r|q)|0,j|0)|0;o=Fd(j|0,C|0,(k|l)^m^(n|p)|0,o|0)|0;p=g+(f<<3)|0;c[p>>2]=o;c[p+4>>2]=C;f=f+1|0}while((f|0)!=80);K=a;I=c[K>>2]|0;K=c[K+4>>2]|0;e=a+8|0;A=e;B=c[A>>2]|0;A=c[A+4>>2]|0;k=a+16|0;f=k;b=c[f>>2]|0;f=c[f+4>>2]|0;n=a+24|0;l=n;j=c[l>>2]|0;l=c[l+4>>2]|0;q=a+32|0;m=q;p=c[m>>2]|0;m=c[m+4>>2]|0;t=a+40|0;o=t;s=c[o>>2]|0;o=c[o+4>>2]|0;w=a+48|0;r=w;v=c[r>>2]|0;r=c[r+4>>2]|0;z=a+56|0;u=z;y=c[u>>2]|0;u=c[u+4>>2]|0;H=Id(p|0,m|0,14)|0;D=C;x=Jd(p|0,m|0,50)|0;D=D|C;M=Id(p|0,m|0,18)|0;E=C;L=Jd(p|0,m|0,46)|0;E=D^(E|C);D=Id(p|0,m|0,41)|0;G=C;J=Jd(p|0,m|0,23)|0;G=E^(G|C);E=g;F=c[E>>2]|0;E=c[E+4>>2]|0;u=Fd(y|0,u|0,-685199838,1116352408)|0;E=Fd(u|0,C|0,F|0,E|0)|0;G=Fd(E|0,C|0,(H|x)^(M|L)^(D|J)|0,G|0)|0;G=Fd(G|0,C|0,(v^s)&p^v|0,(r^o)&m^r|0)|0;J=C;D=Id(I|0,K|0,28)|0;L=C;M=Jd(I|0,K|0,36)|0;L=L|C;x=Id(I|0,K|0,34)|0;H=C;E=Jd(I|0,K|0,30)|0;H=L^(H|C);L=Id(I|0,K|0,39)|0;F=C;u=Jd(I|0,K|0,25)|0;F=Fd((b|B)&I|b&B|0,(f|A)&K|f&A|0,(D|M)^(x|E)^(L|u)|0,H^(F|C)|0)|0;H=C;l=Fd(j|0,l|0,G|0,J|0)|0;j=C;J=Fd(F|0,H|0,G|0,J|0)|0;G=C;H=Id(l|0,j|0,14)|0;F=C;u=Jd(l|0,j|0,50)|0;F=F|C;L=Id(l|0,j|0,18)|0;E=C;x=Jd(l|0,j|0,46)|0;E=F^(E|C);F=Id(l|0,j|0,41)|0;M=C;D=Jd(l|0,j|0,23)|0;M=E^(M|C);E=g+8|0;y=c[E>>2]|0;E=c[E+4>>2]|0;r=Fd(v|0,r|0,602891725,1899447441)|0;E=Fd(r|0,C|0,y|0,E|0)|0;M=Fd(E|0,C|0,(H|u)^(L|x)^(F|D)|0,M|0)|0;M=Fd(M|0,C|0,(s^p)&l^s|0,(o^m)&j^o|0)|0;D=C;F=Id(J|0,G|0,28)|0;x=C;L=Jd(J|0,G|0,36)|0;x=x|C;u=Id(J|0,G|0,34)|0;H=C;E=Jd(J|0,G|0,30)|0;H=x^(H|C);x=Id(J|0,G|0,39)|0;y=C;r=Jd(J|0,G|0,25)|0;y=Fd((B|I)&J|B&I|0,(A|K)&G|A&K|0,(F|L)^(u|E)^(x|r)|0,H^(y|C)|0)|0;H=C;f=Fd(b|0,f|0,M|0,D|0)|0;b=C;D=Fd(y|0,H|0,M|0,D|0)|0;M=C;H=Id(f|0,b|0,14)|0;y=C;r=Jd(f|0,b|0,50)|0;y=y|C;x=Id(f|0,b|0,18)|0;E=C;u=Jd(f|0,b|0,46)|0;E=y^(E|C);y=Id(f|0,b|0,41)|0;L=C;F=Jd(f|0,b|0,23)|0;L=E^(L|C);E=g+16|0;v=c[E>>2]|0;E=c[E+4>>2]|0;o=Fd(s|0,o|0,-330482897,-1245643825)|0;E=Fd(o|0,C|0,v|0,E|0)|0;L=Fd(E|0,C|0,(H|r)^(x|u)^(y|F)|0,L|0)|0;L=Fd(L|0,C|0,(p^l)&f^p|0,(m^j)&b^m|0)|0;F=C;y=Id(D|0,M|0,28)|0;u=C;x=Jd(D|0,M|0,36)|0;u=u|C;r=Id(D|0,M|0,34)|0;H=C;E=Jd(D|0,M|0,30)|0;H=u^(H|C);u=Id(D|0,M|0,39)|0;v=C;o=Jd(D|0,M|0,25)|0;v=Fd((I|J)&D|I&J|0,(K|G)&M|K&G|0,(y|x)^(r|E)^(u|o)|0,H^(v|C)|0)|0;H=C;A=Fd(B|0,A|0,L|0,F|0)|0;B=C;F=Fd(v|0,H|0,L|0,F|0)|0;L=C;H=Id(A|0,B|0,14)|0;v=C;o=Jd(A|0,B|0,50)|0;v=v|C;u=Id(A|0,B|0,18)|0;E=C;r=Jd(A|0,B|0,46)|0;E=v^(E|C);v=Id(A|0,B|0,41)|0;x=C;y=Jd(A|0,B|0,23)|0;x=E^(x|C);E=g+24|0;s=c[E>>2]|0;E=c[E+4>>2]|0;m=Fd(p|0,m|0,-2121671748,-373957723)|0;E=Fd(m|0,C|0,s|0,E|0)|0;x=Fd(E|0,C|0,(H|o)^(u|r)^(v|y)|0,x|0)|0;x=Fd(x|0,C|0,(l^f)&A^l|0,(j^b)&B^j|0)|0;y=C;v=Id(F|0,L|0,28)|0;r=C;u=Jd(F|0,L|0,36)|0;r=r|C;o=Id(F|0,L|0,34)|0;H=C;E=Jd(F|0,L|0,30)|0;H=r^(H|C);r=Id(F|0,L|0,39)|0;s=C;m=Jd(F|0,L|0,25)|0;s=Fd((J|D)&F|J&D|0,(G|M)&L|G&M|0,(v|u)^(o|E)^(r|m)|0,H^(s|C)|0)|0;H=C;K=Fd(I|0,K|0,x|0,y|0)|0;I=C;y=Fd(s|0,H|0,x|0,y|0)|0;x=C;H=Id(K|0,I|0,14)|0;s=C;m=Jd(K|0,I|0,50)|0;s=s|C;r=Id(K|0,I|0,18)|0;E=C;o=Jd(K|0,I|0,46)|0;E=s^(E|C);s=Id(K|0,I|0,41)|0;u=C;v=Jd(K|0,I|0,23)|0;u=E^(u|C);E=g+32|0;p=c[E>>2]|0;E=c[E+4>>2]|0;j=Fd(l|0,j|0,-213338824,961987163)|0;E=Fd(j|0,C|0,p|0,E|0)|0;u=Fd(E|0,C|0,(H|m)^(r|o)^(s|v)|0,u|0)|0;u=Fd(u|0,C|0,(f^A)&K^f|0,(b^B)&I^b|0)|0;v=C;s=Id(y|0,x|0,28)|0;o=C;r=Jd(y|0,x|0,36)|0;o=o|C;m=Id(y|0,x|0,34)|0;H=C;E=Jd(y|0,x|0,30)|0;H=o^(H|C);o=Id(y|0,x|0,39)|0;p=C;j=Jd(y|0,x|0,25)|0;p=Fd((D|F)&y|D&F|0,(M|L)&x|M&L|0,(s|r)^(m|E)^(o|j)|0,H^(p|C)|0)|0;H=C;G=Fd(J|0,G|0,u|0,v|0)|0;J=C;v=Fd(p|0,H|0,u|0,v|0)|0;u=C;H=Id(G|0,J|0,14)|0;p=C;j=Jd(G|0,J|0,50)|0;p=p|C;o=Id(G|0,J|0,18)|0;E=C;m=Jd(G|0,J|0,46)|0;E=p^(E|C);p=Id(G|0,J|0,41)|0;r=C;s=Jd(G|0,J|0,23)|0;r=E^(r|C);E=g+40|0;l=c[E>>2]|0;E=c[E+4>>2]|0;b=Fd(f|0,b|0,-1241133031,1508970993)|0;E=Fd(b|0,C|0,l|0,E|0)|0;r=Fd(E|0,C|0,(H|j)^(o|m)^(p|s)|0,r|0)|0;r=Fd(r|0,C|0,(A^K)&G^A|0,(B^I)&J^B|0)|0;s=C;p=Id(v|0,u|0,28)|0;m=C;o=Jd(v|0,u|0,36)|0;m=m|C;j=Id(v|0,u|0,34)|0;H=C;E=Jd(v|0,u|0,30)|0;H=m^(H|C);m=Id(v|0,u|0,39)|0;l=C;b=Jd(v|0,u|0,25)|0;l=Fd((F|y)&v|F&y|0,(L|x)&u|L&x|0,(p|o)^(j|E)^(m|b)|0,H^(l|C)|0)|0;H=C;M=Fd(D|0,M|0,r|0,s|0)|0;D=C;s=Fd(l|0,H|0,r|0,s|0)|0;r=C;H=Id(M|0,D|0,14)|0;l=C;b=Jd(M|0,D|0,50)|0;l=l|C;m=Id(M|0,D|0,18)|0;E=C;j=Jd(M|0,D|0,46)|0;E=l^(E|C);l=Id(M|0,D|0,41)|0;o=C;p=Jd(M|0,D|0,23)|0;o=E^(o|C);E=g+48|0;f=c[E>>2]|0;E=c[E+4>>2]|0;B=Fd(A|0,B|0,-1357295717,-1841331548)|0;E=Fd(B|0,C|0,f|0,E|0)|0;o=Fd(E|0,C|0,(H|b)^(m|j)^(l|p)|0,o|0)|0;o=Fd(o|0,C|0,(K^G)&M^K|0,(I^J)&D^I|0)|0;p=C;l=Id(s|0,r|0,28)|0;j=C;m=Jd(s|0,r|0,36)|0;j=j|C;b=Id(s|0,r|0,34)|0;H=C;E=Jd(s|0,r|0,30)|0;H=j^(H|C);j=Id(s|0,r|0,39)|0;f=C;B=Jd(s|0,r|0,25)|0;f=Fd((y|v)&s|y&v|0,(x|u)&r|x&u|0,(l|m)^(b|E)^(j|B)|0,H^(f|C)|0)|0;H=C;L=Fd(F|0,L|0,o|0,p|0)|0;F=C;p=Fd(f|0,H|0,o|0,p|0)|0;o=C;H=Id(L|0,F|0,14)|0;f=C;B=Jd(L|0,F|0,50)|0;f=f|C;j=Id(L|0,F|0,18)|0;E=C;b=Jd(L|0,F|0,46)|0;E=f^(E|C);f=Id(L|0,F|0,41)|0;m=C;l=Jd(L|0,F|0,23)|0;m=E^(m|C);E=g+56|0;A=c[E>>2]|0;E=c[E+4>>2]|0;I=Fd(K|0,I|0,-630357736,-1424204075)|0;E=Fd(I|0,C|0,A|0,E|0)|0;m=Fd(E|0,C|0,(H|B)^(j|b)^(f|l)|0,m|0)|0;m=Fd(m|0,C|0,(G^M)&L^G|0,(J^D)&F^J|0)|0;l=C;f=Id(p|0,o|0,28)|0;b=C;j=Jd(p|0,o|0,36)|0;b=b|C;B=Id(p|0,o|0,34)|0;H=C;E=Jd(p|0,o|0,30)|0;H=b^(H|C);b=Id(p|0,o|0,39)|0;A=C;I=Jd(p|0,o|0,25)|0;A=Fd((v|s)&p|v&s|0,(u|r)&o|u&r|0,(f|j)^(B|E)^(b|I)|0,H^(A|C)|0)|0;H=C;x=Fd(y|0,x|0,m|0,l|0)|0;y=C;l=Fd(A|0,H|0,m|0,l|0)|0;m=C;H=Id(x|0,y|0,14)|0;A=C;I=Jd(x|0,y|0,50)|0;A=A|C;b=Id(x|0,y|0,18)|0;E=C;B=Jd(x|0,y|0,46)|0;E=A^(E|C);A=Id(x|0,y|0,41)|0;j=C;f=Jd(x|0,y|0,23)|0;j=E^(j|C);E=g+64|0;K=c[E>>2]|0;E=c[E+4>>2]|0;J=Fd(G|0,J|0,-1560083902,-670586216)|0;E=Fd(J|0,C|0,K|0,E|0)|0;j=Fd(E|0,C|0,(H|I)^(b|B)^(A|f)|0,j|0)|0;j=Fd(j|0,C|0,(M^L)&x^M|0,(D^F)&y^D|0)|0;f=C;A=Id(l|0,m|0,28)|0;B=C;b=Jd(l|0,m|0,36)|0;B=B|C;I=Id(l|0,m|0,34)|0;H=C;E=Jd(l|0,m|0,30)|0;H=B^(H|C);B=Id(l|0,m|0,39)|0;K=C;J=Jd(l|0,m|0,25)|0;K=Fd((s|p)&l|s&p|0,(r|o)&m|r&o|0,(A|b)^(I|E)^(B|J)|0,H^(K|C)|0)|0;H=C;u=Fd(v|0,u|0,j|0,f|0)|0;v=C;f=Fd(K|0,H|0,j|0,f|0)|0;j=C;H=Id(u|0,v|0,14)|0;K=C;J=Jd(u|0,v|0,50)|0;K=K|C;B=Id(u|0,v|0,18)|0;E=C;I=Jd(u|0,v|0,46)|0;E=K^(E|C);K=Id(u|0,v|0,41)|0;b=C;A=Jd(u|0,v|0,23)|0;b=E^(b|C);E=g+72|0;G=c[E>>2]|0;E=c[E+4>>2]|0;D=Fd(M|0,D|0,1164996542,310598401)|0;E=Fd(D|0,C|0,G|0,E|0)|0;b=Fd(E|0,C|0,(H|J)^(B|I)^(K|A)|0,b|0)|0;b=Fd(b|0,C|0,(L^x)&u^L|0,(F^y)&v^F|0)|0;A=C;K=Id(f|0,j|0,28)|0;I=C;B=Jd(f|0,j|0,36)|0;I=I|C;J=Id(f|0,j|0,34)|0;H=C;E=Jd(f|0,j|0,30)|0;H=I^(H|C);I=Id(f|0,j|0,39)|0;G=C;D=Jd(f|0,j|0,25)|0;G=Fd((p|l)&f|p&l|0,(o|m)&j|o&m|0,(K|B)^(J|E)^(I|D)|0,H^(G|C)|0)|0;H=C;r=Fd(s|0,r|0,b|0,A|0)|0;s=C;A=Fd(G|0,H|0,b|0,A|0)|0;b=C;H=Id(r|0,s|0,14)|0;G=C;D=Jd(r|0,s|0,50)|0;G=G|C;I=Id(r|0,s|0,18)|0;E=C;J=Jd(r|0,s|0,46)|0;E=G^(E|C);G=Id(r|0,s|0,41)|0;B=C;K=Jd(r|0,s|0,23)|0;B=E^(B|C);E=g+80|0;M=c[E>>2]|0;E=c[E+4>>2]|0;F=Fd(L|0,F|0,1323610764,607225278)|0;E=Fd(F|0,C|0,M|0,E|0)|0;B=Fd(E|0,C|0,(H|D)^(I|J)^(G|K)|0,B|0)|0;B=Fd(B|0,C|0,(x^u)&r^x|0,(y^v)&s^y|0)|0;K=C;G=Id(A|0,b|0,28)|0;J=C;I=Jd(A|0,b|0,36)|0;J=J|C;D=Id(A|0,b|0,34)|0;H=C;E=Jd(A|0,b|0,30)|0;H=J^(H|C);J=Id(A|0,b|0,39)|0;M=C;F=Jd(A|0,b|0,25)|0;M=Fd((l|f)&A|l&f|0,(m|j)&b|m&j|0,(G|I)^(D|E)^(J|F)|0,H^(M|C)|0)|0;H=C;o=Fd(p|0,o|0,B|0,K|0)|0;p=C;K=Fd(M|0,H|0,B|0,K|0)|0;B=C;H=Id(o|0,p|0,14)|0;M=C;F=Jd(o|0,p|0,50)|0;M=M|C;J=Id(o|0,p|0,18)|0;E=C;D=Jd(o|0,p|0,46)|0;E=M^(E|C);M=Id(o|0,p|0,41)|0;I=C;G=Jd(o|0,p|0,23)|0;I=E^(I|C);E=g+88|0;L=c[E>>2]|0;E=c[E+4>>2]|0;y=Fd(x|0,y|0,-704662302,1426881987)|0;E=Fd(y|0,C|0,L|0,E|0)|0;I=Fd(E|0,C|0,(H|F)^(J|D)^(M|G)|0,I|0)|0;I=Fd(I|0,C|0,(u^r)&o^u|0,(v^s)&p^v|0)|0;G=C;M=Id(K|0,B|0,28)|0;D=C;J=Jd(K|0,B|0,36)|0;D=D|C;F=Id(K|0,B|0,34)|0;H=C;E=Jd(K|0,B|0,30)|0;H=D^(H|C);D=Id(K|0,B|0,39)|0;L=C;y=Jd(K|0,B|0,25)|0;L=Fd((f|A)&K|f&A|0,(j|b)&B|j&b|0,(M|J)^(F|E)^(D|y)|0,H^(L|C)|0)|0;H=C;m=Fd(l|0,m|0,I|0,G|0)|0;l=C;G=Fd(L|0,H|0,I|0,G|0)|0;I=C;H=Id(m|0,l|0,14)|0;L=C;y=Jd(m|0,l|0,50)|0;L=L|C;D=Id(m|0,l|0,18)|0;E=C;F=Jd(m|0,l|0,46)|0;E=L^(E|C);L=Id(m|0,l|0,41)|0;J=C;M=Jd(m|0,l|0,23)|0;J=E^(J|C);E=g+96|0;x=c[E>>2]|0;E=c[E+4>>2]|0;v=Fd(u|0,v|0,-226784913,1925078388)|0;E=Fd(v|0,C|0,x|0,E|0)|0;J=Fd(E|0,C|0,(H|y)^(D|F)^(L|M)|0,J|0)|0;J=Fd(J|0,C|0,(r^o)&m^r|0,(s^p)&l^s|0)|0;M=C;L=Id(G|0,I|0,28)|0;F=C;D=Jd(G|0,I|0,36)|0;F=F|C;y=Id(G|0,I|0,34)|0;H=C;E=Jd(G|0,I|0,30)|0;H=F^(H|C);F=Id(G|0,I|0,39)|0;x=C;v=Jd(G|0,I|0,25)|0;x=Fd((A|K)&G|A&K|0,(b|B)&I|b&B|0,(L|D)^(y|E)^(F|v)|0,H^(x|C)|0)|0;H=C;j=Fd(f|0,j|0,J|0,M|0)|0;f=C;M=Fd(x|0,H|0,J|0,M|0)|0;J=C;H=Id(j|0,f|0,14)|0;x=C;v=Jd(j|0,f|0,50)|0;x=x|C;F=Id(j|0,f|0,18)|0;E=C;y=Jd(j|0,f|0,46)|0;E=x^(E|C);x=Id(j|0,f|0,41)|0;D=C;L=Jd(j|0,f|0,23)|0;D=E^(D|C);E=g+104|0;u=c[E>>2]|0;E=c[E+4>>2]|0;s=Fd(r|0,s|0,991336113,-2132889090)|0;E=Fd(s|0,C|0,u|0,E|0)|0;D=Fd(E|0,C|0,(H|v)^(F|y)^(x|L)|0,D|0)|0;D=Fd(D|0,C|0,(o^m)&j^o|0,(p^l)&f^p|0)|0;L=C;x=Id(M|0,J|0,28)|0;y=C;F=Jd(M|0,J|0,36)|0;y=y|C;v=Id(M|0,J|0,34)|0;H=C;E=Jd(M|0,J|0,30)|0;H=y^(H|C);y=Id(M|0,J|0,39)|0;u=C;s=Jd(M|0,J|0,25)|0;u=Fd((K|G)&M|K&G|0,(B|I)&J|B&I|0,(x|F)^(v|E)^(y|s)|0,H^(u|C)|0)|0;H=C;b=Fd(A|0,b|0,D|0,L|0)|0;A=C;L=Fd(u|0,H|0,D|0,L|0)|0;D=C;H=Id(b|0,A|0,14)|0;u=C;s=Jd(b|0,A|0,50)|0;u=u|C;y=Id(b|0,A|0,18)|0;E=C;v=Jd(b|0,A|0,46)|0;E=u^(E|C);u=Id(b|0,A|0,41)|0;F=C;x=Jd(b|0,A|0,23)|0;F=E^(F|C);E=g+112|0;r=c[E>>2]|0;E=c[E+4>>2]|0;p=Fd(o|0,p|0,633803317,-1680079193)|0;E=Fd(p|0,C|0,r|0,E|0)|0;F=Fd(E|0,C|0,(H|s)^(y|v)^(u|x)|0,F|0)|0;F=Fd(F|0,C|0,(m^j)&b^m|0,(l^f)&A^l|0)|0;x=C;u=Id(L|0,D|0,28)|0;v=C;y=Jd(L|0,D|0,36)|0;v=v|C;s=Id(L|0,D|0,34)|0;H=C;E=Jd(L|0,D|0,30)|0;H=v^(H|C);v=Id(L|0,D|0,39)|0;r=C;p=Jd(L|0,D|0,25)|0;r=Fd((G|M)&L|G&M|0,(I|J)&D|I&J|0,(u|y)^(s|E)^(v|p)|0,H^(r|C)|0)|0;H=C;B=Fd(K|0,B|0,F|0,x|0)|0;K=C;x=Fd(r|0,H|0,F|0,x|0)|0;F=C;H=Id(B|0,K|0,14)|0;r=C;p=Jd(B|0,K|0,50)|0;r=r|C;v=Id(B|0,K|0,18)|0;E=C;s=Jd(B|0,K|0,46)|0;E=r^(E|C);r=Id(B|0,K|0,41)|0;y=C;u=Jd(B|0,K|0,23)|0;y=E^(y|C);E=g+120|0;o=c[E>>2]|0;E=c[E+4>>2]|0;l=Fd(m|0,l|0,-815192428,-1046744716)|0;E=Fd(l|0,C|0,o|0,E|0)|0;y=Fd(E|0,C|0,(H|p)^(v|s)^(r|u)|0,y|0)|0;y=Fd(y|0,C|0,(j^b)&B^j|0,(f^A)&K^f|0)|0;u=C;r=Id(x|0,F|0,28)|0;s=C;v=Jd(x|0,F|0,36)|0;s=s|C;p=Id(x|0,F|0,34)|0;H=C;E=Jd(x|0,F|0,30)|0;H=s^(H|C);s=Id(x|0,F|0,39)|0;o=C;l=Jd(x|0,F|0,25)|0;o=Fd((M|L)&x|M&L|0,(J|D)&F|J&D|0,(r|v)^(p|E)^(s|l)|0,H^(o|C)|0)|0;H=C;I=Fd(G|0,I|0,y|0,u|0)|0;G=C;u=Fd(o|0,H|0,y|0,u|0)|0;y=C;H=Id(I|0,G|0,14)|0;o=C;l=Jd(I|0,G|0,50)|0;o=o|C;s=Id(I|0,G|0,18)|0;E=C;p=Jd(I|0,G|0,46)|0;E=o^(E|C);o=Id(I|0,G|0,41)|0;v=C;r=Jd(I|0,G|0,23)|0;v=E^(v|C);E=g+128|0;m=c[E>>2]|0;E=c[E+4>>2]|0;f=Fd(j|0,f|0,-1628353838,-459576895)|0;E=Fd(f|0,C|0,m|0,E|0)|0;v=Fd(E|0,C|0,(H|l)^(s|p)^(o|r)|0,v|0)|0;v=Fd(v|0,C|0,(b^B)&I^b|0,(A^K)&G^A|0)|0;r=C;o=Id(u|0,y|0,28)|0;p=C;s=Jd(u|0,y|0,36)|0;p=p|C;l=Id(u|0,y|0,34)|0;H=C;E=Jd(u|0,y|0,30)|0;H=p^(H|C);p=Id(u|0,y|0,39)|0;m=C;f=Jd(u|0,y|0,25)|0;m=Fd((L|x)&u|L&x|0,(D|F)&y|D&F|0,(o|s)^(l|E)^(p|f)|0,H^(m|C)|0)|0;H=C;J=Fd(M|0,J|0,v|0,r|0)|0;M=C;r=Fd(m|0,H|0,v|0,r|0)|0;v=C;H=Id(J|0,M|0,14)|0;m=C;f=Jd(J|0,M|0,50)|0;m=m|C;p=Id(J|0,M|0,18)|0;E=C;l=Jd(J|0,M|0,46)|0;E=m^(E|C);m=Id(J|0,M|0,41)|0;s=C;o=Jd(J|0,M|0,23)|0;s=E^(s|C);E=g+136|0;j=c[E>>2]|0;E=c[E+4>>2]|0;A=Fd(b|0,A|0,944711139,-272742522)|0;E=Fd(A|0,C|0,j|0,E|0)|0;s=Fd(E|0,C|0,(H|f)^(p|l)^(m|o)|0,s|0)|0;s=Fd(s|0,C|0,(B^I)&J^B|0,(K^G)&M^K|0)|0;o=C;m=Id(r|0,v|0,28)|0;l=C;p=Jd(r|0,v|0,36)|0;l=l|C;f=Id(r|0,v|0,34)|0;H=C;E=Jd(r|0,v|0,30)|0;H=l^(H|C);l=Id(r|0,v|0,39)|0;j=C;A=Jd(r|0,v|0,25)|0;j=Fd((x|u)&r|x&u|0,(F|y)&v|F&y|0,(m|p)^(f|E)^(l|A)|0,H^(j|C)|0)|0;H=C;D=Fd(L|0,D|0,s|0,o|0)|0;L=C;o=Fd(j|0,H|0,s|0,o|0)|0;s=C;H=Id(D|0,L|0,14)|0;j=C;A=Jd(D|0,L|0,50)|0;j=j|C;l=Id(D|0,L|0,18)|0;E=C;f=Jd(D|0,L|0,46)|0;E=j^(E|C);j=Id(D|0,L|0,41)|0;p=C;m=Jd(D|0,L|0,23)|0;p=E^(p|C);E=g+144|0;b=c[E>>2]|0;E=c[E+4>>2]|0;K=Fd(B|0,K|0,-1953704523,264347078)|0;E=Fd(K|0,C|0,b|0,E|0)|0;p=Fd(E|0,C|0,(H|A)^(l|f)^(j|m)|0,p|0)|0;p=Fd(p|0,C|0,(I^J)&D^I|0,(G^M)&L^G|0)|0;m=C;j=Id(o|0,s|0,28)|0;f=C;l=Jd(o|0,s|0,36)|0;f=f|C;A=Id(o|0,s|0,34)|0;H=C;E=Jd(o|0,s|0,30)|0;H=f^(H|C);f=Id(o|0,s|0,39)|0;b=C;K=Jd(o|0,s|0,25)|0;b=Fd((u|r)&o|u&r|0,(y|v)&s|y&v|0,(j|l)^(A|E)^(f|K)|0,H^(b|C)|0)|0;H=C;F=Fd(x|0,F|0,p|0,m|0)|0;x=C;m=Fd(b|0,H|0,p|0,m|0)|0;p=C;H=Id(F|0,x|0,14)|0;b=C;K=Jd(F|0,x|0,50)|0;b=b|C;f=Id(F|0,x|0,18)|0;E=C;A=Jd(F|0,x|0,46)|0;E=b^(E|C);b=Id(F|0,x|0,41)|0;l=C;j=Jd(F|0,x|0,23)|0;l=E^(l|C);E=g+152|0;B=c[E>>2]|0;E=c[E+4>>2]|0;G=Fd(I|0,G|0,2007800933,604807628)|0;E=Fd(G|0,C|0,B|0,E|0)|0;l=Fd(E|0,C|0,(H|K)^(f|A)^(b|j)|0,l|0)|0;l=Fd(l|0,C|0,(J^D)&F^J|0,(M^L)&x^M|0)|0;j=C;b=Id(m|0,p|0,28)|0;A=C;f=Jd(m|0,p|0,36)|0;A=A|C;K=Id(m|0,p|0,34)|0;H=C;E=Jd(m|0,p|0,30)|0;H=A^(H|C);A=Id(m|0,p|0,39)|0;B=C;G=Jd(m|0,p|0,25)|0;B=Fd((r|o)&m|r&o|0,(v|s)&p|v&s|0,(b|f)^(K|E)^(A|G)|0,H^(B|C)|0)|0;H=C;y=Fd(u|0,y|0,l|0,j|0)|0;u=C;j=Fd(B|0,H|0,l|0,j|0)|0;l=C;H=Id(y|0,u|0,14)|0;B=C;G=Jd(y|0,u|0,50)|0;B=B|C;A=Id(y|0,u|0,18)|0;E=C;K=Jd(y|0,u|0,46)|0;E=B^(E|C);B=Id(y|0,u|0,41)|0;f=C;b=Jd(y|0,u|0,23)|0;f=E^(f|C);E=g+160|0;I=c[E>>2]|0;E=c[E+4>>2]|0;M=Fd(J|0,M|0,1495990901,770255983)|0;E=Fd(M|0,C|0,I|0,E|0)|0;f=Fd(E|0,C|0,(H|G)^(A|K)^(B|b)|0,f|0)|0;f=Fd(f|0,C|0,(D^F)&y^D|0,(L^x)&u^L|0)|0;b=C;B=Id(j|0,l|0,28)|0;K=C;A=Jd(j|0,l|0,36)|0;K=K|C;G=Id(j|0,l|0,34)|0;H=C;E=Jd(j|0,l|0,30)|0;H=K^(H|C);K=Id(j|0,l|0,39)|0;I=C;M=Jd(j|0,l|0,25)|0;I=Fd((o|m)&j|o&m|0,(s|p)&l|s&p|0,(B|A)^(G|E)^(K|M)|0,H^(I|C)|0)|0;H=C;v=Fd(r|0,v|0,f|0,b|0)|0;r=C;b=Fd(I|0,H|0,f|0,b|0)|0;f=C;H=Id(v|0,r|0,14)|0;I=C;M=Jd(v|0,r|0,50)|0;I=I|C;K=Id(v|0,r|0,18)|0;E=C;G=Jd(v|0,r|0,46)|0;E=I^(E|C);I=Id(v|0,r|0,41)|0;A=C;B=Jd(v|0,r|0,23)|0;A=E^(A|C);E=g+168|0;J=c[E>>2]|0;E=c[E+4>>2]|0;L=Fd(D|0,L|0,1856431235,1249150122)|0;E=Fd(L|0,C|0,J|0,E|0)|0;A=Fd(E|0,C|0,(H|M)^(K|G)^(I|B)|0,A|0)|0;A=Fd(A|0,C|0,(F^y)&v^F|0,(x^u)&r^x|0)|0;B=C;I=Id(b|0,f|0,28)|0;G=C;K=Jd(b|0,f|0,36)|0;G=G|C;M=Id(b|0,f|0,34)|0;H=C;E=Jd(b|0,f|0,30)|0;H=G^(H|C);G=Id(b|0,f|0,39)|0;J=C;L=Jd(b|0,f|0,25)|0;J=Fd((m|j)&b|m&j|0,(p|l)&f|p&l|0,(I|K)^(M|E)^(G|L)|0,H^(J|C)|0)|0;H=C;s=Fd(o|0,s|0,A|0,B|0)|0;o=C;B=Fd(J|0,H|0,A|0,B|0)|0;A=C;H=Id(s|0,o|0,14)|0;J=C;L=Jd(s|0,o|0,50)|0;J=J|C;G=Id(s|0,o|0,18)|0;E=C;M=Jd(s|0,o|0,46)|0;E=J^(E|C);J=Id(s|0,o|0,41)|0;K=C;I=Jd(s|0,o|0,23)|0;K=E^(K|C);E=g+176|0;D=c[E>>2]|0;E=c[E+4>>2]|0;x=Fd(F|0,x|0,-1119749164,1555081692)|0;E=Fd(x|0,C|0,D|0,E|0)|0;K=Fd(E|0,C|0,(H|L)^(G|M)^(J|I)|0,K|0)|0;K=Fd(K|0,C|0,(y^v)&s^y|0,(u^r)&o^u|0)|0;I=C;J=Id(B|0,A|0,28)|0;M=C;G=Jd(B|0,A|0,36)|0;M=M|C;L=Id(B|0,A|0,34)|0;H=C;E=Jd(B|0,A|0,30)|0;H=M^(H|C);M=Id(B|0,A|0,39)|0;D=C;x=Jd(B|0,A|0,25)|0;D=Fd((j|b)&B|j&b|0,(l|f)&A|l&f|0,(J|G)^(L|E)^(M|x)|0,H^(D|C)|0)|0;H=C;p=Fd(m|0,p|0,K|0,I|0)|0;m=C;I=Fd(D|0,H|0,K|0,I|0)|0;K=C;H=Id(p|0,m|0,14)|0;D=C;x=Jd(p|0,m|0,50)|0;D=D|C;M=Id(p|0,m|0,18)|0;E=C;L=Jd(p|0,m|0,46)|0;E=D^(E|C);D=Id(p|0,m|0,41)|0;G=C;J=Jd(p|0,m|0,23)|0;G=E^(G|C);E=g+184|0;F=c[E>>2]|0;E=c[E+4>>2]|0;u=Fd(y|0,u|0,-2096016459,1996064986)|0;E=Fd(u|0,C|0,F|0,E|0)|0;G=Fd(E|0,C|0,(H|x)^(M|L)^(D|J)|0,G|0)|0;G=Fd(G|0,C|0,(v^s)&p^v|0,(r^o)&m^r|0)|0;J=C;D=Id(I|0,K|0,28)|0;L=C;M=Jd(I|0,K|0,36)|0;L=L|C;x=Id(I|0,K|0,34)|0;H=C;E=Jd(I|0,K|0,30)|0;H=L^(H|C);L=Id(I|0,K|0,39)|0;F=C;u=Jd(I|0,K|0,25)|0;F=Fd((b|B)&I|b&B|0,(f|A)&K|f&A|0,(D|M)^(x|E)^(L|u)|0,H^(F|C)|0)|0;H=C;l=Fd(j|0,l|0,G|0,J|0)|0;j=C;J=Fd(F|0,H|0,G|0,J|0)|0;G=C;H=Id(l|0,j|0,14)|0;F=C;u=Jd(l|0,j|0,50)|0;F=F|C;L=Id(l|0,j|0,18)|0;E=C;x=Jd(l|0,j|0,46)|0;E=F^(E|C);F=Id(l|0,j|0,41)|0;M=C;D=Jd(l|0,j|0,23)|0;M=E^(M|C);E=g+192|0;y=c[E>>2]|0;E=c[E+4>>2]|0;r=Fd(v|0,r|0,-295247957,-1740746414)|0;E=Fd(r|0,C|0,y|0,E|0)|0;M=Fd(E|0,C|0,(H|u)^(L|x)^(F|D)|0,M|0)|0;M=Fd(M|0,C|0,(s^p)&l^s|0,(o^m)&j^o|0)|0;D=C;F=Id(J|0,G|0,28)|0;x=C;L=Jd(J|0,G|0,36)|0;x=x|C;u=Id(J|0,G|0,34)|0;H=C;E=Jd(J|0,G|0,30)|0;H=x^(H|C);x=Id(J|0,G|0,39)|0;y=C;r=Jd(J|0,G|0,25)|0;y=Fd((B|I)&J|B&I|0,(A|K)&G|A&K|0,(F|L)^(u|E)^(x|r)|0,H^(y|C)|0)|0;H=C;f=Fd(b|0,f|0,M|0,D|0)|0;b=C;D=Fd(y|0,H|0,M|0,D|0)|0;M=C;H=Id(f|0,b|0,14)|0;y=C;r=Jd(f|0,b|0,50)|0;y=y|C;x=Id(f|0,b|0,18)|0;E=C;u=Jd(f|0,b|0,46)|0;E=y^(E|C);y=Id(f|0,b|0,41)|0;L=C;F=Jd(f|0,b|0,23)|0;L=E^(L|C);E=g+200|0;v=c[E>>2]|0;E=c[E+4>>2]|0;o=Fd(s|0,o|0,766784016,-1473132947)|0;E=Fd(o|0,C|0,v|0,E|0)|0;L=Fd(E|0,C|0,(H|r)^(x|u)^(y|F)|0,L|0)|0;L=Fd(L|0,C|0,(p^l)&f^p|0,(m^j)&b^m|0)|0;F=C;y=Id(D|0,M|0,28)|0;u=C;x=Jd(D|0,M|0,36)|0;u=u|C;r=Id(D|0,M|0,34)|0;H=C;E=Jd(D|0,M|0,30)|0;H=u^(H|C);u=Id(D|0,M|0,39)|0;v=C;o=Jd(D|0,M|0,25)|0;v=Fd((I|J)&D|I&J|0,(K|G)&M|K&G|0,(y|x)^(r|E)^(u|o)|0,H^(v|C)|0)|0;H=C;A=Fd(B|0,A|0,L|0,F|0)|0;B=C;F=Fd(v|0,H|0,L|0,F|0)|0;L=C;H=Id(A|0,B|0,14)|0;v=C;o=Jd(A|0,B|0,50)|0;v=v|C;u=Id(A|0,B|0,18)|0;E=C;r=Jd(A|0,B|0,46)|0;E=v^(E|C);v=Id(A|0,B|0,41)|0;x=C;y=Jd(A|0,B|0,23)|0;x=E^(x|C);E=g+208|0;s=c[E>>2]|0;E=c[E+4>>2]|0;m=Fd(p|0,m|0,-1728372417,-1341970488)|0;E=Fd(m|0,C|0,s|0,E|0)|0;x=Fd(E|0,C|0,(H|o)^(u|r)^(v|y)|0,x|0)|0;x=Fd(x|0,C|0,(l^f)&A^l|0,(j^b)&B^j|0)|0;y=C;v=Id(F|0,L|0,28)|0;r=C;u=Jd(F|0,L|0,36)|0;r=r|C;o=Id(F|0,L|0,34)|0;H=C;E=Jd(F|0,L|0,30)|0;H=r^(H|C);r=Id(F|0,L|0,39)|0;s=C;m=Jd(F|0,L|0,25)|0;s=Fd((J|D)&F|J&D|0,(G|M)&L|G&M|0,(v|u)^(o|E)^(r|m)|0,H^(s|C)|0)|0;H=C;K=Fd(I|0,K|0,x|0,y|0)|0;I=C;y=Fd(s|0,H|0,x|0,y|0)|0;x=C;H=Id(K|0,I|0,14)|0;s=C;m=Jd(K|0,I|0,50)|0;s=s|C;r=Id(K|0,I|0,18)|0;E=C;o=Jd(K|0,I|0,46)|0;E=s^(E|C);s=Id(K|0,I|0,41)|0;u=C;v=Jd(K|0,I|0,23)|0;u=E^(u|C);E=g+216|0;p=c[E>>2]|0;E=c[E+4>>2]|0;j=Fd(l|0,j|0,-1091629340,-1084653625)|0;E=Fd(j|0,C|0,p|0,E|0)|0;u=Fd(E|0,C|0,(H|m)^(r|o)^(s|v)|0,u|0)|0;u=Fd(u|0,C|0,(f^A)&K^f|0,(b^B)&I^b|0)|0;v=C;s=Id(y|0,x|0,28)|0;o=C;r=Jd(y|0,x|0,36)|0;o=o|C;m=Id(y|0,x|0,34)|0;H=C;E=Jd(y|0,x|0,30)|0;H=o^(H|C);o=Id(y|0,x|0,39)|0;p=C;j=Jd(y|0,x|0,25)|0;p=Fd((D|F)&y|D&F|0,(M|L)&x|M&L|0,(s|r)^(m|E)^(o|j)|0,H^(p|C)|0)|0;H=C;G=Fd(J|0,G|0,u|0,v|0)|0;J=C;v=Fd(p|0,H|0,u|0,v|0)|0;u=C;H=Id(G|0,J|0,14)|0;p=C;j=Jd(G|0,J|0,50)|0;p=p|C;o=Id(G|0,J|0,18)|0;E=C;m=Jd(G|0,J|0,46)|0;E=p^(E|C);p=Id(G|0,J|0,41)|0;r=C;s=Jd(G|0,J|0,23)|0;r=E^(r|C);E=g+224|0;l=c[E>>2]|0;E=c[E+4>>2]|0;b=Fd(f|0,b|0,1034457026,-958395405)|0;E=Fd(b|0,C|0,l|0,E|0)|0;r=Fd(E|0,C|0,(H|j)^(o|m)^(p|s)|0,r|0)|0;r=Fd(r|0,C|0,(A^K)&G^A|0,(B^I)&J^B|0)|0;s=C;p=Id(v|0,u|0,28)|0;m=C;o=Jd(v|0,u|0,36)|0;m=m|C;j=Id(v|0,u|0,34)|0;H=C;E=Jd(v|0,u|0,30)|0;H=m^(H|C);m=Id(v|0,u|0,39)|0;l=C;b=Jd(v|0,u|0,25)|0;l=Fd((F|y)&v|F&y|0,(L|x)&u|L&x|0,(p|o)^(j|E)^(m|b)|0,H^(l|C)|0)|0;H=C;M=Fd(D|0,M|0,r|0,s|0)|0;D=C;s=Fd(l|0,H|0,r|0,s|0)|0;r=C;H=Id(M|0,D|0,14)|0;l=C;b=Jd(M|0,D|0,50)|0;l=l|C;m=Id(M|0,D|0,18)|0;E=C;j=Jd(M|0,D|0,46)|0;E=l^(E|C);l=Id(M|0,D|0,41)|0;o=C;p=Jd(M|0,D|0,23)|0;o=E^(o|C);E=g+232|0;f=c[E>>2]|0;E=c[E+4>>2]|0;B=Fd(A|0,B|0,-1828018395,-710438585)|0;E=Fd(B|0,C|0,f|0,E|0)|0;o=Fd(E|0,C|0,(H|b)^(m|j)^(l|p)|0,o|0)|0;o=Fd(o|0,C|0,(K^G)&M^K|0,(I^J)&D^I|0)|0;p=C;l=Id(s|0,r|0,28)|0;j=C;m=Jd(s|0,r|0,36)|0;j=j|C;b=Id(s|0,r|0,34)|0;H=C;E=Jd(s|0,r|0,30)|0;H=j^(H|C);j=Id(s|0,r|0,39)|0;f=C;B=Jd(s|0,r|0,25)|0;f=Fd((y|v)&s|y&v|0,(x|u)&r|x&u|0,(l|m)^(b|E)^(j|B)|0,H^(f|C)|0)|0;H=C;L=Fd(F|0,L|0,o|0,p|0)|0;F=C;p=Fd(f|0,H|0,o|0,p|0)|0;o=C;H=Id(L|0,F|0,14)|0;f=C;B=Jd(L|0,F|0,50)|0;f=f|C;j=Id(L|0,F|0,18)|0;E=C;b=Jd(L|0,F|0,46)|0;E=f^(E|C);f=Id(L|0,F|0,41)|0;m=C;l=Jd(L|0,F|0,23)|0;m=E^(m|C);E=g+240|0;A=c[E>>2]|0;E=c[E+4>>2]|0;I=Fd(K|0,I|0,-536640913,113926993)|0;E=Fd(I|0,C|0,A|0,E|0)|0;m=Fd(E|0,C|0,(H|B)^(j|b)^(f|l)|0,m|0)|0;m=Fd(m|0,C|0,(G^M)&L^G|0,(J^D)&F^J|0)|0;l=C;f=Id(p|0,o|0,28)|0;b=C;j=Jd(p|0,o|0,36)|0;b=b|C;B=Id(p|0,o|0,34)|0;H=C;E=Jd(p|0,o|0,30)|0;H=b^(H|C);b=Id(p|0,o|0,39)|0;A=C;I=Jd(p|0,o|0,25)|0;A=Fd((v|s)&p|v&s|0,(u|r)&o|u&r|0,(f|j)^(B|E)^(b|I)|0,H^(A|C)|0)|0;H=C;x=Fd(y|0,x|0,m|0,l|0)|0;y=C;l=Fd(A|0,H|0,m|0,l|0)|0;m=C;H=Id(x|0,y|0,14)|0;A=C;I=Jd(x|0,y|0,50)|0;A=A|C;b=Id(x|0,y|0,18)|0;E=C;B=Jd(x|0,y|0,46)|0;E=A^(E|C);A=Id(x|0,y|0,41)|0;j=C;f=Jd(x|0,y|0,23)|0;j=E^(j|C);E=g+248|0;K=c[E>>2]|0;E=c[E+4>>2]|0;J=Fd(G|0,J|0,168717936,338241895)|0;E=Fd(J|0,C|0,K|0,E|0)|0;j=Fd(E|0,C|0,(H|I)^(b|B)^(A|f)|0,j|0)|0;j=Fd(j|0,C|0,(M^L)&x^M|0,(D^F)&y^D|0)|0;f=C;A=Id(l|0,m|0,28)|0;B=C;b=Jd(l|0,m|0,36)|0;B=B|C;I=Id(l|0,m|0,34)|0;H=C;E=Jd(l|0,m|0,30)|0;H=B^(H|C);B=Id(l|0,m|0,39)|0;K=C;J=Jd(l|0,m|0,25)|0;K=Fd((s|p)&l|s&p|0,(r|o)&m|r&o|0,(A|b)^(I|E)^(B|J)|0,H^(K|C)|0)|0;H=C;u=Fd(v|0,u|0,j|0,f|0)|0;v=C;f=Fd(K|0,H|0,j|0,f|0)|0;j=C;H=Id(u|0,v|0,14)|0;K=C;J=Jd(u|0,v|0,50)|0;K=K|C;B=Id(u|0,v|0,18)|0;E=C;I=Jd(u|0,v|0,46)|0;E=K^(E|C);K=Id(u|0,v|0,41)|0;b=C;A=Jd(u|0,v|0,23)|0;b=E^(b|C);E=g+256|0;G=c[E>>2]|0;E=c[E+4>>2]|0;D=Fd(M|0,D|0,1188179964,666307205)|0;E=Fd(D|0,C|0,G|0,E|0)|0;b=Fd(E|0,C|0,(H|J)^(B|I)^(K|A)|0,b|0)|0;b=Fd(b|0,C|0,(L^x)&u^L|0,(F^y)&v^F|0)|0;A=C;K=Id(f|0,j|0,28)|0;I=C;B=Jd(f|0,j|0,36)|0;I=I|C;J=Id(f|0,j|0,34)|0;H=C;E=Jd(f|0,j|0,30)|0;H=I^(H|C);I=Id(f|0,j|0,39)|0;G=C;D=Jd(f|0,j|0,25)|0;G=Fd((p|l)&f|p&l|0,(o|m)&j|o&m|0,(K|B)^(J|E)^(I|D)|0,H^(G|C)|0)|0;H=C;r=Fd(s|0,r|0,b|0,A|0)|0;s=C;A=Fd(G|0,H|0,b|0,A|0)|0;b=C;H=Id(r|0,s|0,14)|0;G=C;D=Jd(r|0,s|0,50)|0;G=G|C;I=Id(r|0,s|0,18)|0;E=C;J=Jd(r|0,s|0,46)|0;E=G^(E|C);G=Id(r|0,s|0,41)|0;B=C;K=Jd(r|0,s|0,23)|0;B=E^(B|C);E=g+264|0;M=c[E>>2]|0;E=c[E+4>>2]|0;F=Fd(L|0,F|0,1546045734,773529912)|0;E=Fd(F|0,C|0,M|0,E|0)|0;B=Fd(E|0,C|0,(H|D)^(I|J)^(G|K)|0,B|0)|0;B=Fd(B|0,C|0,(x^u)&r^x|0,(y^v)&s^y|0)|0;K=C;G=Id(A|0,b|0,28)|0;J=C;I=Jd(A|0,b|0,36)|0;J=J|C;D=Id(A|0,b|0,34)|0;H=C;E=Jd(A|0,b|0,30)|0;H=J^(H|C);J=Id(A|0,b|0,39)|0;M=C;F=Jd(A|0,b|0,25)|0;M=Fd((l|f)&A|l&f|0,(m|j)&b|m&j|0,(G|I)^(D|E)^(J|F)|0,H^(M|C)|0)|0;H=C;o=Fd(p|0,o|0,B|0,K|0)|0;p=C;K=Fd(M|0,H|0,B|0,K|0)|0;B=C;H=Id(o|0,p|0,14)|0;M=C;F=Jd(o|0,p|0,50)|0;M=M|C;J=Id(o|0,p|0,18)|0;E=C;D=Jd(o|0,p|0,46)|0;E=M^(E|C);M=Id(o|0,p|0,41)|0;I=C;G=Jd(o|0,p|0,23)|0;I=E^(I|C);E=g+272|0;L=c[E>>2]|0;E=c[E+4>>2]|0;y=Fd(x|0,y|0,1522805485,1294757372)|0;E=Fd(y|0,C|0,L|0,E|0)|0;I=Fd(E|0,C|0,(H|F)^(J|D)^(M|G)|0,I|0)|0;I=Fd(I|0,C|0,(u^r)&o^u|0,(v^s)&p^v|0)|0;G=C;M=Id(K|0,B|0,28)|0;D=C;J=Jd(K|0,B|0,36)|0;D=D|C;F=Id(K|0,B|0,34)|0;H=C;E=Jd(K|0,B|0,30)|0;H=D^(H|C);D=Id(K|0,B|0,39)|0;L=C;y=Jd(K|0,B|0,25)|0;L=Fd((f|A)&K|f&A|0,(j|b)&B|j&b|0,(M|J)^(F|E)^(D|y)|0,H^(L|C)|0)|0;H=C;m=Fd(l|0,m|0,I|0,G|0)|0;l=C;G=Fd(L|0,H|0,I|0,G|0)|0;I=C;H=Id(m|0,l|0,14)|0;L=C;y=Jd(m|0,l|0,50)|0;L=L|C;D=Id(m|0,l|0,18)|0;E=C;F=Jd(m|0,l|0,46)|0;E=L^(E|C);L=Id(m|0,l|0,41)|0;J=C;M=Jd(m|0,l|0,23)|0;J=E^(J|C);E=g+280|0;x=c[E>>2]|0;E=c[E+4>>2]|0;v=Fd(u|0,v|0,-1651133473,1396182291)|0;E=Fd(v|0,C|0,x|0,E|0)|0;J=Fd(E|0,C|0,(H|y)^(D|F)^(L|M)|0,J|0)|0;J=Fd(J|0,C|0,(r^o)&m^r|0,(s^p)&l^s|0)|0;M=C;L=Id(G|0,I|0,28)|0;F=C;D=Jd(G|0,I|0,36)|0;F=F|C;y=Id(G|0,I|0,34)|0;H=C;E=Jd(G|0,I|0,30)|0;H=F^(H|C);F=Id(G|0,I|0,39)|0;x=C;v=Jd(G|0,I|0,25)|0;x=Fd((A|K)&G|A&K|0,(b|B)&I|b&B|0,(L|D)^(y|E)^(F|v)|0,H^(x|C)|0)|0;H=C;j=Fd(f|0,j|0,J|0,M|0)|0;f=C;M=Fd(x|0,H|0,J|0,M|0)|0;J=C;H=Id(j|0,f|0,14)|0;x=C;v=Jd(j|0,f|0,50)|0;x=x|C;F=Id(j|0,f|0,18)|0;E=C;y=Jd(j|0,f|0,46)|0;E=x^(E|C);x=Id(j|0,f|0,41)|0;D=C;L=Jd(j|0,f|0,23)|0;D=E^(D|C);E=g+288|0;u=c[E>>2]|0;E=c[E+4>>2]|0;s=Fd(r|0,s|0,-1951439906,1695183700)|0;E=Fd(s|0,C|0,u|0,E|0)|0;D=Fd(E|0,C|0,(H|v)^(F|y)^(x|L)|0,D|0)|0;D=Fd(D|0,C|0,(o^m)&j^o|0,(p^l)&f^p|0)|0;L=C;x=Id(M|0,J|0,28)|0;y=C;F=Jd(M|0,J|0,36)|0;y=y|C;v=Id(M|0,J|0,34)|0;H=C;E=Jd(M|0,J|0,30)|0;H=y^(H|C);y=Id(M|0,J|0,39)|0;u=C;s=Jd(M|0,J|0,25)|0;u=Fd((K|G)&M|K&G|0,(B|I)&J|B&I|0,(x|F)^(v|E)^(y|s)|0,H^(u|C)|0)|0;H=C;b=Fd(A|0,b|0,D|0,L|0)|0;A=C;L=Fd(u|0,H|0,D|0,L|0)|0;D=C;H=Id(b|0,A|0,14)|0;u=C;s=Jd(b|0,A|0,50)|0;u=u|C;y=Id(b|0,A|0,18)|0;E=C;v=Jd(b|0,A|0,46)|0;E=u^(E|C);u=Id(b|0,A|0,41)|0;F=C;x=Jd(b|0,A|0,23)|0;F=E^(F|C);E=g+296|0;r=c[E>>2]|0;E=c[E+4>>2]|0;p=Fd(o|0,p|0,1014477480,1986661051)|0;E=Fd(p|0,C|0,r|0,E|0)|0;F=Fd(E|0,C|0,(H|s)^(y|v)^(u|x)|0,F|0)|0;F=Fd(F|0,C|0,(m^j)&b^m|0,(l^f)&A^l|0)|0;x=C;u=Id(L|0,D|0,28)|0;v=C;y=Jd(L|0,D|0,36)|0;v=v|C;s=Id(L|0,D|0,34)|0;H=C;E=Jd(L|0,D|0,30)|0;H=v^(H|C);v=Id(L|0,D|0,39)|0;r=C;p=Jd(L|0,D|0,25)|0;r=Fd((G|M)&L|G&M|0,(I|J)&D|I&J|0,(u|y)^(s|E)^(v|p)|0,H^(r|C)|0)|0;H=C;B=Fd(K|0,B|0,F|0,x|0)|0;K=C;x=Fd(r|0,H|0,F|0,x|0)|0;F=C;H=Id(B|0,K|0,14)|0;r=C;p=Jd(B|0,K|0,50)|0;r=r|C;v=Id(B|0,K|0,18)|0;E=C;s=Jd(B|0,K|0,46)|0;E=r^(E|C);r=Id(B|0,K|0,41)|0;y=C;u=Jd(B|0,K|0,23)|0;y=E^(y|C);E=g+304|0;o=c[E>>2]|0;E=c[E+4>>2]|0;l=Fd(m|0,l|0,1206759142,-2117940946)|0;E=Fd(l|0,C|0,o|0,E|0)|0;y=Fd(E|0,C|0,(H|p)^(v|s)^(r|u)|0,y|0)|0;y=Fd(y|0,C|0,(j^b)&B^j|0,(f^A)&K^f|0)|0;u=C;r=Id(x|0,F|0,28)|0;s=C;v=Jd(x|0,F|0,36)|0;s=s|C;p=Id(x|0,F|0,34)|0;H=C;E=Jd(x|0,F|0,30)|0;H=s^(H|C);s=Id(x|0,F|0,39)|0;o=C;l=Jd(x|0,F|0,25)|0;o=Fd((M|L)&x|M&L|0,(J|D)&F|J&D|0,(r|v)^(p|E)^(s|l)|0,H^(o|C)|0)|0;H=C;I=Fd(G|0,I|0,y|0,u|0)|0;G=C;u=Fd(o|0,H|0,y|0,u|0)|0;y=C;H=Id(I|0,G|0,14)|0;o=C;l=Jd(I|0,G|0,50)|0;o=o|C;s=Id(I|0,G|0,18)|0;E=C;p=Jd(I|0,G|0,46)|0;E=o^(E|C);o=Id(I|0,G|0,41)|0;v=C;r=Jd(I|0,G|0,23)|0;v=E^(v|C);E=g+312|0;m=c[E>>2]|0;E=c[E+4>>2]|0;f=Fd(j|0,f|0,344077627,-1838011259)|0;E=Fd(f|0,C|0,m|0,E|0)|0;v=Fd(E|0,C|0,(H|l)^(s|p)^(o|r)|0,v|0)|0;v=Fd(v|0,C|0,(b^B)&I^b|0,(A^K)&G^A|0)|0;r=C;o=Id(u|0,y|0,28)|0;p=C;s=Jd(u|0,y|0,36)|0;p=p|C;l=Id(u|0,y|0,34)|0;H=C;E=Jd(u|0,y|0,30)|0;H=p^(H|C);p=Id(u|0,y|0,39)|0;m=C;f=Jd(u|0,y|0,25)|0;m=Fd((L|x)&u|L&x|0,(D|F)&y|D&F|0,(o|s)^(l|E)^(p|f)|0,H^(m|C)|0)|0;H=C;J=Fd(M|0,J|0,v|0,r|0)|0;M=C;r=Fd(m|0,H|0,v|0,r|0)|0;v=C;H=Id(J|0,M|0,14)|0;m=C;f=Jd(J|0,M|0,50)|0;m=m|C;p=Id(J|0,M|0,18)|0;E=C;l=Jd(J|0,M|0,46)|0;E=m^(E|C);m=Id(J|0,M|0,41)|0;s=C;o=Jd(J|0,M|0,23)|0;s=E^(s|C);E=g+320|0;j=c[E>>2]|0;E=c[E+4>>2]|0;A=Fd(b|0,A|0,1290863460,-1564481375)|0;E=Fd(A|0,C|0,j|0,E|0)|0;s=Fd(E|0,C|0,(H|f)^(p|l)^(m|o)|0,s|0)|0;s=Fd(s|0,C|0,(B^I)&J^B|0,(K^G)&M^K|0)|0;o=C;m=Id(r|0,v|0,28)|0;l=C;p=Jd(r|0,v|0,36)|0;l=l|C;f=Id(r|0,v|0,34)|0;H=C;E=Jd(r|0,v|0,30)|0;H=l^(H|C);l=Id(r|0,v|0,39)|0;j=C;A=Jd(r|0,v|0,25)|0;j=Fd((x|u)&r|x&u|0,(F|y)&v|F&y|0,(m|p)^(f|E)^(l|A)|0,H^(j|C)|0)|0;H=C;D=Fd(L|0,D|0,s|0,o|0)|0;L=C;o=Fd(j|0,H|0,s|0,o|0)|0;s=C;H=Id(D|0,L|0,14)|0;j=C;A=Jd(D|0,L|0,50)|0;j=j|C;l=Id(D|0,L|0,18)|0;E=C;f=Jd(D|0,L|0,46)|0;E=j^(E|C);j=Id(D|0,L|0,41)|0;p=C;m=Jd(D|0,L|0,23)|0;p=E^(p|C);E=g+328|0;b=c[E>>2]|0;E=c[E+4>>2]|0;K=Fd(B|0,K|0,-1136513023,-1474664885)|0;E=Fd(K|0,C|0,b|0,E|0)|0;p=Fd(E|0,C|0,(H|A)^(l|f)^(j|m)|0,p|0)|0;p=Fd(p|0,C|0,(I^J)&D^I|0,(G^M)&L^G|0)|0;m=C;j=Id(o|0,s|0,28)|0;f=C;l=Jd(o|0,s|0,36)|0;f=f|C;A=Id(o|0,s|0,34)|0;H=C;E=Jd(o|0,s|0,30)|0;H=f^(H|C);f=Id(o|0,s|0,39)|0;b=C;K=Jd(o|0,s|0,25)|0;b=Fd((u|r)&o|u&r|0,(y|v)&s|y&v|0,(j|l)^(A|E)^(f|K)|0,H^(b|C)|0)|0;H=C;F=Fd(x|0,F|0,p|0,m|0)|0;x=C;m=Fd(b|0,H|0,p|0,m|0)|0;p=C;H=Id(F|0,x|0,14)|0;b=C;K=Jd(F|0,x|0,50)|0;b=b|C;f=Id(F|0,x|0,18)|0;E=C;A=Jd(F|0,x|0,46)|0;E=b^(E|C);b=Id(F|0,x|0,41)|0;l=C;j=Jd(F|0,x|0,23)|0;l=E^(l|C);E=g+336|0;B=c[E>>2]|0;E=c[E+4>>2]|0;G=Fd(I|0,G|0,-789014639,-1035236496)|0;E=Fd(G|0,C|0,B|0,E|0)|0;l=Fd(E|0,C|0,(H|K)^(f|A)^(b|j)|0,l|0)|0;l=Fd(l|0,C|0,(J^D)&F^J|0,(M^L)&x^M|0)|0;j=C;b=Id(m|0,p|0,28)|0;A=C;f=Jd(m|0,p|0,36)|0;A=A|C;K=Id(m|0,p|0,34)|0;H=C;E=Jd(m|0,p|0,30)|0;H=A^(H|C);A=Id(m|0,p|0,39)|0;B=C;G=Jd(m|0,p|0,25)|0;B=Fd((r|o)&m|r&o|0,(v|s)&p|v&s|0,(b|f)^(K|E)^(A|G)|0,H^(B|C)|0)|0;H=C;y=Fd(u|0,y|0,l|0,j|0)|0;u=C;j=Fd(B|0,H|0,l|0,j|0)|0;l=C;H=Id(y|0,u|0,14)|0;B=C;G=Jd(y|0,u|0,50)|0;B=B|C;A=Id(y|0,u|0,18)|0;E=C;K=Jd(y|0,u|0,46)|0;E=B^(E|C);B=Id(y|0,u|0,41)|0;f=C;b=Jd(y|0,u|0,23)|0;f=E^(f|C);E=g+344|0;I=c[E>>2]|0;E=c[E+4>>2]|0;M=Fd(J|0,M|0,106217008,-949202525)|0;E=Fd(M|0,C|0,I|0,E|0)|0;f=Fd(E|0,C|0,(H|G)^(A|K)^(B|b)|0,f|0)|0;f=Fd(f|0,C|0,(D^F)&y^D|0,(L^x)&u^L|0)|0;b=C;B=Id(j|0,l|0,28)|0;K=C;A=Jd(j|0,l|0,36)|0;K=K|C;G=Id(j|0,l|0,34)|0;H=C;E=Jd(j|0,l|0,30)|0;H=K^(H|C);K=Id(j|0,l|0,39)|0;I=C;M=Jd(j|0,l|0,25)|0;I=Fd((o|m)&j|o&m|0,(s|p)&l|s&p|0,(B|A)^(G|E)^(K|M)|0,H^(I|C)|0)|0;H=C;v=Fd(r|0,v|0,f|0,b|0)|0;r=C;b=Fd(I|0,H|0,f|0,b|0)|0;f=C;H=Id(v|0,r|0,14)|0;I=C;M=Jd(v|0,r|0,50)|0;I=I|C;K=Id(v|0,r|0,18)|0;E=C;G=Jd(v|0,r|0,46)|0;E=I^(E|C);I=Id(v|0,r|0,41)|0;A=C;B=Jd(v|0,r|0,23)|0;A=E^(A|C);E=g+352|0;J=c[E>>2]|0;E=c[E+4>>2]|0;L=Fd(D|0,L|0,-688958952,-778901479)|0;E=Fd(L|0,C|0,J|0,E|0)|0;A=Fd(E|0,C|0,(H|M)^(K|G)^(I|B)|0,A|0)|0;A=Fd(A|0,C|0,(F^y)&v^F|0,(x^u)&r^x|0)|0;B=C;I=Id(b|0,f|0,28)|0;G=C;K=Jd(b|0,f|0,36)|0;G=G|C;M=Id(b|0,f|0,34)|0;H=C;E=Jd(b|0,f|0,30)|0;H=G^(H|C);G=Id(b|0,f|0,39)|0;J=C;L=Jd(b|0,f|0,25)|0;J=Fd((m|j)&b|m&j|0,(p|l)&f|p&l|0,(I|K)^(M|E)^(G|L)|0,H^(J|C)|0)|0;H=C;s=Fd(o|0,s|0,A|0,B|0)|0;o=C;B=Fd(J|0,H|0,A|0,B|0)|0;A=C;H=Id(s|0,o|0,14)|0;J=C;L=Jd(s|0,o|0,50)|0;J=J|C;G=Id(s|0,o|0,18)|0;E=C;M=Jd(s|0,o|0,46)|0;E=J^(E|C);J=Id(s|0,o|0,41)|0;K=C;I=Jd(s|0,o|0,23)|0;K=E^(K|C);E=g+360|0;D=c[E>>2]|0;E=c[E+4>>2]|0;x=Fd(F|0,x|0,1432725776,-694614492)|0;E=Fd(x|0,C|0,D|0,E|0)|0;K=Fd(E|0,C|0,(H|L)^(G|M)^(J|I)|0,K|0)|0;K=Fd(K|0,C|0,(y^v)&s^y|0,(u^r)&o^u|0)|0;I=C;J=Id(B|0,A|0,28)|0;M=C;G=Jd(B|0,A|0,36)|0;M=M|C;L=Id(B|0,A|0,34)|0;H=C;E=Jd(B|0,A|0,30)|0;H=M^(H|C);M=Id(B|0,A|0,39)|0;D=C;x=Jd(B|0,A|0,25)|0;D=Fd((j|b)&B|j&b|0,(l|f)&A|l&f|0,(J|G)^(L|E)^(M|x)|0,H^(D|C)|0)|0;H=C;p=Fd(m|0,p|0,K|0,I|0)|0;m=C;I=Fd(D|0,H|0,K|0,I|0)|0;K=C;H=Id(p|0,m|0,14)|0;D=C;x=Jd(p|0,m|0,50)|0;D=D|C;M=Id(p|0,m|0,18)|0;E=C;L=Jd(p|0,m|0,46)|0;E=D^(E|C);D=Id(p|0,m|0,41)|0;G=C;J=Jd(p|0,m|0,23)|0;G=E^(G|C);E=g+368|0;F=c[E>>2]|0;E=c[E+4>>2]|0;u=Fd(y|0,u|0,1467031594,-200395387)|0;E=Fd(u|0,C|0,F|0,E|0)|0;G=Fd(E|0,C|0,(H|x)^(M|L)^(D|J)|0,G|0)|0;G=Fd(G|0,C|0,(v^s)&p^v|0,(r^o)&m^r|0)|0;J=C;D=Id(I|0,K|0,28)|0;L=C;M=Jd(I|0,K|0,36)|0;L=L|C;x=Id(I|0,K|0,34)|0;H=C;E=Jd(I|0,K|0,30)|0;H=L^(H|C);L=Id(I|0,K|0,39)|0;F=C;u=Jd(I|0,K|0,25)|0;F=Fd((b|B)&I|b&B|0,(f|A)&K|f&A|0,(D|M)^(x|E)^(L|u)|0,H^(F|C)|0)|0;H=C;l=Fd(j|0,l|0,G|0,J|0)|0;j=C;J=Fd(F|0,H|0,G|0,J|0)|0;G=C;H=Id(l|0,j|0,14)|0;F=C;u=Jd(l|0,j|0,50)|0;F=F|C;L=Id(l|0,j|0,18)|0;E=C;x=Jd(l|0,j|0,46)|0;E=F^(E|C);F=Id(l|0,j|0,41)|0;M=C;D=Jd(l|0,j|0,23)|0;M=E^(M|C);E=g+376|0;y=c[E>>2]|0;E=c[E+4>>2]|0;r=Fd(v|0,r|0,851169720,275423344)|0;E=Fd(r|0,C|0,y|0,E|0)|0;M=Fd(E|0,C|0,(H|u)^(L|x)^(F|D)|0,M|0)|0;M=Fd(M|0,C|0,(s^p)&l^s|0,(o^m)&j^o|0)|0;D=C;F=Id(J|0,G|0,28)|0;x=C;L=Jd(J|0,G|0,36)|0;x=x|C;u=Id(J|0,G|0,34)|0;H=C;E=Jd(J|0,G|0,30)|0;H=x^(H|C);x=Id(J|0,G|0,39)|0;y=C;r=Jd(J|0,G|0,25)|0;y=Fd((B|I)&J|B&I|0,(A|K)&G|A&K|0,(F|L)^(u|E)^(x|r)|0,H^(y|C)|0)|0;H=C;f=Fd(b|0,f|0,M|0,D|0)|0;b=C;D=Fd(y|0,H|0,M|0,D|0)|0;M=C;H=Id(f|0,b|0,14)|0;y=C;r=Jd(f|0,b|0,50)|0;y=y|C;x=Id(f|0,b|0,18)|0;E=C;u=Jd(f|0,b|0,46)|0;E=y^(E|C);y=Id(f|0,b|0,41)|0;L=C;F=Jd(f|0,b|0,23)|0;L=E^(L|C);E=g+384|0;v=c[E>>2]|0;E=c[E+4>>2]|0;o=Fd(s|0,o|0,-1194143544,430227734)|0;E=Fd(o|0,C|0,v|0,E|0)|0;L=Fd(E|0,C|0,(H|r)^(x|u)^(y|F)|0,L|0)|0;L=Fd(L|0,C|0,(p^l)&f^p|0,(m^j)&b^m|0)|0;F=C;y=Id(D|0,M|0,28)|0;u=C;x=Jd(D|0,M|0,36)|0;u=u|C;r=Id(D|0,M|0,34)|0;H=C;E=Jd(D|0,M|0,30)|0;H=u^(H|C);u=Id(D|0,M|0,39)|0;v=C;o=Jd(D|0,M|0,25)|0;v=Fd((I|J)&D|I&J|0,(K|G)&M|K&G|0,(y|x)^(r|E)^(u|o)|0,H^(v|C)|0)|0;H=C;A=Fd(B|0,A|0,L|0,F|0)|0;B=C;F=Fd(v|0,H|0,L|0,F|0)|0;L=C;H=Id(A|0,B|0,14)|0;v=C;o=Jd(A|0,B|0,50)|0;v=v|C;u=Id(A|0,B|0,18)|0;E=C;r=Jd(A|0,B|0,46)|0;E=v^(E|C);v=Id(A|0,B|0,41)|0;x=C;y=Jd(A|0,B|0,23)|0;x=E^(x|C);E=g+392|0;s=c[E>>2]|0;E=c[E+4>>2]|0;m=Fd(p|0,m|0,1363258195,506948616)|0;E=Fd(m|0,C|0,s|0,E|0)|0;x=Fd(E|0,C|0,(H|o)^(u|r)^(v|y)|0,x|0)|0;x=Fd(x|0,C|0,(l^f)&A^l|0,(j^b)&B^j|0)|0;y=C;v=Id(F|0,L|0,28)|0;r=C;u=Jd(F|0,L|0,36)|0;r=r|C;o=Id(F|0,L|0,34)|0;H=C;E=Jd(F|0,L|0,30)|0;H=r^(H|C);r=Id(F|0,L|0,39)|0;s=C;m=Jd(F|0,L|0,25)|0;s=Fd((J|D)&F|J&D|0,(G|M)&L|G&M|0,(v|u)^(o|E)^(r|m)|0,H^(s|C)|0)|0;H=C;K=Fd(I|0,K|0,x|0,y|0)|0;I=C;y=Fd(s|0,H|0,x|0,y|0)|0;x=C;H=Id(K|0,I|0,14)|0;s=C;m=Jd(K|0,I|0,50)|0;s=s|C;r=Id(K|0,I|0,18)|0;E=C;o=Jd(K|0,I|0,46)|0;E=s^(E|C);s=Id(K|0,I|0,41)|0;u=C;v=Jd(K|0,I|0,23)|0;u=E^(u|C);E=g+400|0;p=c[E>>2]|0;E=c[E+4>>2]|0;j=Fd(l|0,j|0,-544281703,659060556)|0;E=Fd(j|0,C|0,p|0,E|0)|0;u=Fd(E|0,C|0,(H|m)^(r|o)^(s|v)|0,u|0)|0;u=Fd(u|0,C|0,(f^A)&K^f|0,(b^B)&I^b|0)|0;v=C;s=Id(y|0,x|0,28)|0;o=C;r=Jd(y|0,x|0,36)|0;o=o|C;m=Id(y|0,x|0,34)|0;H=C;E=Jd(y|0,x|0,30)|0;H=o^(H|C);o=Id(y|0,x|0,39)|0;p=C;j=Jd(y|0,x|0,25)|0;p=Fd((D|F)&y|D&F|0,(M|L)&x|M&L|0,(s|r)^(m|E)^(o|j)|0,H^(p|C)|0)|0;H=C;G=Fd(J|0,G|0,u|0,v|0)|0;J=C;v=Fd(p|0,H|0,u|0,v|0)|0;u=C;H=Id(G|0,J|0,14)|0;p=C;j=Jd(G|0,J|0,50)|0;p=p|C;o=Id(G|0,J|0,18)|0;E=C;m=Jd(G|0,J|0,46)|0;E=p^(E|C);p=Id(G|0,J|0,41)|0;r=C;s=Jd(G|0,J|0,23)|0;r=E^(r|C);E=g+408|0;l=c[E>>2]|0;E=c[E+4>>2]|0;b=Fd(f|0,b|0,-509917016,883997877)|0;E=Fd(b|0,C|0,l|0,E|0)|0;r=Fd(E|0,C|0,(H|j)^(o|m)^(p|s)|0,r|0)|0;r=Fd(r|0,C|0,(A^K)&G^A|0,(B^I)&J^B|0)|0;s=C;p=Id(v|0,u|0,28)|0;m=C;o=Jd(v|0,u|0,36)|0;m=m|C;j=Id(v|0,u|0,34)|0;H=C;E=Jd(v|0,u|0,30)|0;H=m^(H|C);m=Id(v|0,u|0,39)|0;l=C;b=Jd(v|0,u|0,25)|0;l=Fd((F|y)&v|F&y|0,(L|x)&u|L&x|0,(p|o)^(j|E)^(m|b)|0,H^(l|C)|0)|0;H=C;M=Fd(D|0,M|0,r|0,s|0)|0;D=C;s=Fd(l|0,H|0,r|0,s|0)|0;r=C;H=Id(M|0,D|0,14)|0;l=C;b=Jd(M|0,D|0,50)|0;l=l|C;m=Id(M|0,D|0,18)|0;E=C;j=Jd(M|0,D|0,46)|0;E=l^(E|C);l=Id(M|0,D|0,41)|0;o=C;p=Jd(M|0,D|0,23)|0;o=E^(o|C);E=g+416|0;f=c[E>>2]|0;E=c[E+4>>2]|0;B=Fd(A|0,B|0,-976659869,958139571)|0;E=Fd(B|0,C|0,f|0,E|0)|0;o=Fd(E|0,C|0,(H|b)^(m|j)^(l|p)|0,o|0)|0;o=Fd(o|0,C|0,(K^G)&M^K|0,(I^J)&D^I|0)|0;p=C;l=Id(s|0,r|0,28)|0;j=C;m=Jd(s|0,r|0,36)|0;j=j|C;b=Id(s|0,r|0,34)|0;H=C;E=Jd(s|0,r|0,30)|0;H=j^(H|C);j=Id(s|0,r|0,39)|0;f=C;B=Jd(s|0,r|0,25)|0;f=Fd((y|v)&s|y&v|0,(x|u)&r|x&u|0,(l|m)^(b|E)^(j|B)|0,H^(f|C)|0)|0;H=C;L=Fd(F|0,L|0,o|0,p|0)|0;F=C;p=Fd(f|0,H|0,o|0,p|0)|0;o=C;H=Id(L|0,F|0,14)|0;f=C;B=Jd(L|0,F|0,50)|0;f=f|C;j=Id(L|0,F|0,18)|0;E=C;b=Jd(L|0,F|0,46)|0;E=f^(E|C);f=Id(L|0,F|0,41)|0;m=C;l=Jd(L|0,F|0,23)|0;m=E^(m|C);E=g+424|0;A=c[E>>2]|0;E=c[E+4>>2]|0;I=Fd(K|0,I|0,-482243893,1322822218)|0;E=Fd(I|0,C|0,A|0,E|0)|0;m=Fd(E|0,C|0,(H|B)^(j|b)^(f|l)|0,m|0)|0;m=Fd(m|0,C|0,(G^M)&L^G|0,(J^D)&F^J|0)|0;l=C;f=Id(p|0,o|0,28)|0;b=C;j=Jd(p|0,o|0,36)|0;b=b|C;B=Id(p|0,o|0,34)|0;H=C;E=Jd(p|0,o|0,30)|0;H=b^(H|C);b=Id(p|0,o|0,39)|0;A=C;I=Jd(p|0,o|0,25)|0;A=Fd((v|s)&p|v&s|0,(u|r)&o|u&r|0,(f|j)^(B|E)^(b|I)|0,H^(A|C)|0)|0;H=C;x=Fd(y|0,x|0,m|0,l|0)|0;y=C;l=Fd(A|0,H|0,m|0,l|0)|0;m=C;H=Id(x|0,y|0,14)|0;A=C;I=Jd(x|0,y|0,50)|0;A=A|C;b=Id(x|0,y|0,18)|0;E=C;B=Jd(x|0,y|0,46)|0;E=A^(E|C);A=Id(x|0,y|0,41)|0;j=C;f=Jd(x|0,y|0,23)|0;j=E^(j|C);E=g+432|0;K=c[E>>2]|0;E=c[E+4>>2]|0;J=Fd(G|0,J|0,2003034995,1537002063)|0;E=Fd(J|0,C|0,K|0,E|0)|0;j=Fd(E|0,C|0,(H|I)^(b|B)^(A|f)|0,j|0)|0;j=Fd(j|0,C|0,(M^L)&x^M|0,(D^F)&y^D|0)|0;f=C;A=Id(l|0,m|0,28)|0;B=C;b=Jd(l|0,m|0,36)|0;B=B|C;I=Id(l|0,m|0,34)|0;H=C;E=Jd(l|0,m|0,30)|0;H=B^(H|C);B=Id(l|0,m|0,39)|0;K=C;J=Jd(l|0,m|0,25)|0;K=Fd((s|p)&l|s&p|0,(r|o)&m|r&o|0,(A|b)^(I|E)^(B|J)|0,H^(K|C)|0)|0;H=C;u=Fd(v|0,u|0,j|0,f|0)|0;v=C;f=Fd(K|0,H|0,j|0,f|0)|0;j=C;H=Id(u|0,v|0,14)|0;K=C;J=Jd(u|0,v|0,50)|0;K=K|C;B=Id(u|0,v|0,18)|0;E=C;I=Jd(u|0,v|0,46)|0;E=K^(E|C);K=Id(u|0,v|0,41)|0;b=C;A=Jd(u|0,v|0,23)|0;b=E^(b|C);E=g+440|0;G=c[E>>2]|0;E=c[E+4>>2]|0;D=Fd(M|0,D|0,-692930397,1747873779)|0;E=Fd(D|0,C|0,G|0,E|0)|0;b=Fd(E|0,C|0,(H|J)^(B|I)^(K|A)|0,b|0)|0;b=Fd(b|0,C|0,(L^x)&u^L|0,(F^y)&v^F|0)|0;A=C;K=Id(f|0,j|0,28)|0;I=C;B=Jd(f|0,j|0,36)|0;I=I|C;J=Id(f|0,j|0,34)|0;H=C;E=Jd(f|0,j|0,30)|0;H=I^(H|C);I=Id(f|0,j|0,39)|0;G=C;D=Jd(f|0,j|0,25)|0;G=Fd((p|l)&f|p&l|0,(o|m)&j|o&m|0,(K|B)^(J|E)^(I|D)|0,H^(G|C)|0)|0;H=C;r=Fd(s|0,r|0,b|0,A|0)|0;s=C;A=Fd(G|0,H|0,b|0,A|0)|0;b=C;H=Id(r|0,s|0,14)|0;G=C;D=Jd(r|0,s|0,50)|0;G=G|C;I=Id(r|0,s|0,18)|0;E=C;J=Jd(r|0,s|0,46)|0;E=G^(E|C);G=Id(r|0,s|0,41)|0;B=C;K=Jd(r|0,s|0,23)|0;B=E^(B|C);E=g+448|0;M=c[E>>2]|0;E=c[E+4>>2]|0;F=Fd(L|0,F|0,1575990012,1955562222)|0;E=Fd(F|0,C|0,M|0,E|0)|0;B=Fd(E|0,C|0,(H|D)^(I|J)^(G|K)|0,B|0)|0;B=Fd(B|0,C|0,(x^u)&r^x|0,(y^v)&s^y|0)|0;K=C;G=Id(A|0,b|0,28)|0;J=C;I=Jd(A|0,b|0,36)|0;J=J|C;D=Id(A|0,b|0,34)|0;H=C;E=Jd(A|0,b|0,30)|0;H=J^(H|C);J=Id(A|0,b|0,39)|0;M=C;F=Jd(A|0,b|0,25)|0;M=Fd((l|f)&A|l&f|0,(m|j)&b|m&j|0,(G|I)^(D|E)^(J|F)|0,H^(M|C)|0)|0;H=C;o=Fd(p|0,o|0,B|0,K|0)|0;p=C;K=Fd(M|0,H|0,B|0,K|0)|0;B=C;H=Id(o|0,p|0,14)|0;M=C;F=Jd(o|0,p|0,50)|0;M=M|C;J=Id(o|0,p|0,18)|0;E=C;D=Jd(o|0,p|0,46)|0;E=M^(E|C);M=Id(o|0,p|0,41)|0;I=C;G=Jd(o|0,p|0,23)|0;I=E^(I|C);E=g+456|0;L=c[E>>2]|0;E=c[E+4>>2]|0;y=Fd(x|0,y|0,1125592928,2024104815)|0;E=Fd(y|0,C|0,L|0,E|0)|0;I=Fd(E|0,C|0,(H|F)^(J|D)^(M|G)|0,I|0)|0;I=Fd(I|0,C|0,(u^r)&o^u|0,(v^s)&p^v|0)|0;G=C;M=Id(K|0,B|0,28)|0;D=C;J=Jd(K|0,B|0,36)|0;D=D|C;F=Id(K|0,B|0,34)|0;H=C;E=Jd(K|0,B|0,30)|0;H=D^(H|C);D=Id(K|0,B|0,39)|0;L=C;y=Jd(K|0,B|0,25)|0;L=Fd((f|A)&K|f&A|0,(j|b)&B|j&b|0,(M|J)^(F|E)^(D|y)|0,H^(L|C)|0)|0;H=C;m=Fd(l|0,m|0,I|0,G|0)|0;l=C;G=Fd(L|0,H|0,I|0,G|0)|0;I=C;H=Id(m|0,l|0,14)|0;L=C;y=Jd(m|0,l|0,50)|0;L=L|C;D=Id(m|0,l|0,18)|0;E=C;F=Jd(m|0,l|0,46)|0;E=L^(E|C);L=Id(m|0,l|0,41)|0;J=C;M=Jd(m|0,l|0,23)|0;J=E^(J|C);E=g+464|0;x=c[E>>2]|0;E=c[E+4>>2]|0;v=Fd(u|0,v|0,-1578062990,-2067236844)|0;E=Fd(v|0,C|0,x|0,E|0)|0;J=Fd(E|0,C|0,(H|y)^(D|F)^(L|M)|0,J|0)|0;J=Fd(J|0,C|0,(r^o)&m^r|0,(s^p)&l^s|0)|0;M=C;L=Id(G|0,I|0,28)|0;F=C;D=Jd(G|0,I|0,36)|0;F=F|C;y=Id(G|0,I|0,34)|0;H=C;E=Jd(G|0,I|0,30)|0;H=F^(H|C);F=Id(G|0,I|0,39)|0;x=C;v=Jd(G|0,I|0,25)|0;x=Fd((A|K)&G|A&K|0,(b|B)&I|b&B|0,(L|D)^(y|E)^(F|v)|0,H^(x|C)|0)|0;H=C;j=Fd(f|0,j|0,J|0,M|0)|0;f=C;M=Fd(x|0,H|0,J|0,M|0)|0;J=C;H=Id(j|0,f|0,14)|0;x=C;v=Jd(j|0,f|0,50)|0;x=x|C;F=Id(j|0,f|0,18)|0;E=C;y=Jd(j|0,f|0,46)|0;E=x^(E|C);x=Id(j|0,f|0,41)|0;D=C;L=Jd(j|0,f|0,23)|0;D=E^(D|C);E=g+472|0;u=c[E>>2]|0;E=c[E+4>>2]|0;s=Fd(r|0,s|0,442776044,-1933114872)|0;E=Fd(s|0,C|0,u|0,E|0)|0;D=Fd(E|0,C|0,(H|v)^(F|y)^(x|L)|0,D|0)|0;D=Fd(D|0,C|0,(o^m)&j^o|0,(p^l)&f^p|0)|0;L=C;x=Id(M|0,J|0,28)|0;y=C;F=Jd(M|0,J|0,36)|0;y=y|C;v=Id(M|0,J|0,34)|0;H=C;E=Jd(M|0,J|0,30)|0;H=y^(H|C);y=Id(M|0,J|0,39)|0;u=C;s=Jd(M|0,J|0,25)|0;u=Fd((K|G)&M|K&G|0,(B|I)&J|B&I|0,(x|F)^(v|E)^(y|s)|0,H^(u|C)|0)|0;H=C;b=Fd(A|0,b|0,D|0,L|0)|0;A=C;L=Fd(u|0,H|0,D|0,L|0)|0;D=C;H=Id(b|0,A|0,14)|0;u=C;s=Jd(b|0,A|0,50)|0;u=u|C;y=Id(b|0,A|0,18)|0;E=C;v=Jd(b|0,A|0,46)|0;E=u^(E|C);u=Id(b|0,A|0,41)|0;F=C;x=Jd(b|0,A|0,23)|0;F=E^(F|C);E=g+480|0;r=c[E>>2]|0;E=c[E+4>>2]|0;p=Fd(o|0,p|0,593698344,-1866530822)|0;E=Fd(p|0,C|0,r|0,E|0)|0;F=Fd(E|0,C|0,(H|s)^(y|v)^(u|x)|0,F|0)|0;F=Fd(F|0,C|0,(m^j)&b^m|0,(l^f)&A^l|0)|0;x=C;u=Id(L|0,D|0,28)|0;v=C;y=Jd(L|0,D|0,36)|0;v=v|C;s=Id(L|0,D|0,34)|0;H=C;E=Jd(L|0,D|0,30)|0;H=v^(H|C);v=Id(L|0,D|0,39)|0;r=C;p=Jd(L|0,D|0,25)|0;r=Fd((G|M)&L|G&M|0,(I|J)&D|I&J|0,(u|y)^(s|E)^(v|p)|0,H^(r|C)|0)|0;H=C;B=Fd(K|0,B|0,F|0,x|0)|0;K=C;x=Fd(r|0,H|0,F|0,x|0)|0;F=C;H=Id(B|0,K|0,14)|0;r=C;p=Jd(B|0,K|0,50)|0;r=r|C;v=Id(B|0,K|0,18)|0;E=C;s=Jd(B|0,K|0,46)|0;E=r^(E|C);r=Id(B|0,K|0,41)|0;y=C;u=Jd(B|0,K|0,23)|0;y=E^(y|C);E=g+488|0;o=c[E>>2]|0;E=c[E+4>>2]|0;l=Fd(m|0,l|0,-561857047,-1538233109)|0;E=Fd(l|0,C|0,o|0,E|0)|0;y=Fd(E|0,C|0,(H|p)^(v|s)^(r|u)|0,y|0)|0;y=Fd(y|0,C|0,(j^b)&B^j|0,(f^A)&K^f|0)|0;u=C;r=Id(x|0,F|0,28)|0;s=C;v=Jd(x|0,F|0,36)|0;s=s|C;p=Id(x|0,F|0,34)|0;H=C;E=Jd(x|0,F|0,30)|0;H=s^(H|C);s=Id(x|0,F|0,39)|0;o=C;l=Jd(x|0,F|0,25)|0;o=Fd((M|L)&x|M&L|0,(J|D)&F|J&D|0,(r|v)^(p|E)^(s|l)|0,H^(o|C)|0)|0;H=C;I=Fd(G|0,I|0,y|0,u|0)|0;G=C;u=Fd(o|0,H|0,y|0,u|0)|0;y=C;H=Id(I|0,G|0,14)|0;o=C;l=Jd(I|0,G|0,50)|0;o=o|C;s=Id(I|0,G|0,18)|0;E=C;p=Jd(I|0,G|0,46)|0;E=o^(E|C);o=Id(I|0,G|0,41)|0;v=C;r=Jd(I|0,G|0,23)|0;v=E^(v|C);E=g+496|0;m=c[E>>2]|0;E=c[E+4>>2]|0;f=Fd(j|0,f|0,-1295615723,-1090935817)|0;E=Fd(f|0,C|0,m|0,E|0)|0;v=Fd(E|0,C|0,(H|l)^(s|p)^(o|r)|0,v|0)|0;v=Fd(v|0,C|0,(b^B)&I^b|0,(A^K)&G^A|0)|0;r=C;o=Id(u|0,y|0,28)|0;p=C;s=Jd(u|0,y|0,36)|0;p=p|C;l=Id(u|0,y|0,34)|0;H=C;E=Jd(u|0,y|0,30)|0;H=p^(H|C);p=Id(u|0,y|0,39)|0;m=C;f=Jd(u|0,y|0,25)|0;m=Fd((L|x)&u|L&x|0,(D|F)&y|D&F|0,(o|s)^(l|E)^(p|f)|0,H^(m|C)|0)|0;H=C;J=Fd(M|0,J|0,v|0,r|0)|0;M=C;r=Fd(m|0,H|0,v|0,r|0)|0;v=C;H=Id(J|0,M|0,14)|0;m=C;f=Jd(J|0,M|0,50)|0;m=m|C;p=Id(J|0,M|0,18)|0;E=C;l=Jd(J|0,M|0,46)|0;E=m^(E|C);m=Id(J|0,M|0,41)|0;s=C;o=Jd(J|0,M|0,23)|0;s=E^(s|C);E=g+504|0;j=c[E>>2]|0;E=c[E+4>>2]|0;A=Fd(b|0,A|0,-479046869,-965641998)|0;E=Fd(A|0,C|0,j|0,E|0)|0;s=Fd(E|0,C|0,(H|f)^(p|l)^(m|o)|0,s|0)|0;s=Fd(s|0,C|0,(B^I)&J^B|0,(K^G)&M^K|0)|0;o=C;m=Id(r|0,v|0,28)|0;l=C;p=Jd(r|0,v|0,36)|0;l=l|C;f=Id(r|0,v|0,34)|0;H=C;E=Jd(r|0,v|0,30)|0;H=l^(H|C);l=Id(r|0,v|0,39)|0;j=C;A=Jd(r|0,v|0,25)|0;j=Fd((x|u)&r|x&u|0,(F|y)&v|F&y|0,(m|p)^(f|E)^(l|A)|0,H^(j|C)|0)|0;H=C;D=Fd(L|0,D|0,s|0,o|0)|0;L=C;o=Fd(j|0,H|0,s|0,o|0)|0;s=C;H=Id(D|0,L|0,14)|0;j=C;A=Jd(D|0,L|0,50)|0;j=j|C;l=Id(D|0,L|0,18)|0;E=C;f=Jd(D|0,L|0,46)|0;E=j^(E|C);j=Id(D|0,L|0,41)|0;p=C;m=Jd(D|0,L|0,23)|0;p=E^(p|C);E=g+512|0;b=c[E>>2]|0;E=c[E+4>>2]|0;K=Fd(B|0,K|0,-366583396,-903397682)|0;E=Fd(K|0,C|0,b|0,E|0)|0;p=Fd(E|0,C|0,(H|A)^(l|f)^(j|m)|0,p|0)|0;p=Fd(p|0,C|0,(I^J)&D^I|0,(G^M)&L^G|0)|0;m=C;j=Id(o|0,s|0,28)|0;f=C;l=Jd(o|0,s|0,36)|0;f=f|C;A=Id(o|0,s|0,34)|0;H=C;E=Jd(o|0,s|0,30)|0;H=f^(H|C);f=Id(o|0,s|0,39)|0;b=C;K=Jd(o|0,s|0,25)|0;b=Fd((u|r)&o|u&r|0,(y|v)&s|y&v|0,(j|l)^(A|E)^(f|K)|0,H^(b|C)|0)|0;H=C;F=Fd(x|0,F|0,p|0,m|0)|0;x=C;m=Fd(b|0,H|0,p|0,m|0)|0;p=C;H=Id(F|0,x|0,14)|0;b=C;K=Jd(F|0,x|0,50)|0;b=b|C;f=Id(F|0,x|0,18)|0;E=C;A=Jd(F|0,x|0,46)|0;E=b^(E|C);b=Id(F|0,x|0,41)|0;l=C;j=Jd(F|0,x|0,23)|0;l=E^(l|C);E=g+520|0;B=c[E>>2]|0;E=c[E+4>>2]|0;G=Fd(I|0,G|0,566280711,-779700025)|0;E=Fd(G|0,C|0,B|0,E|0)|0;l=Fd(E|0,C|0,(H|K)^(f|A)^(b|j)|0,l|0)|0;l=Fd(l|0,C|0,(J^D)&F^J|0,(M^L)&x^M|0)|0;j=C;b=Id(m|0,p|0,28)|0;A=C;f=Jd(m|0,p|0,36)|0;A=A|C;K=Id(m|0,p|0,34)|0;H=C;E=Jd(m|0,p|0,30)|0;H=A^(H|C);A=Id(m|0,p|0,39)|0;B=C;G=Jd(m|0,p|0,25)|0;B=Fd((r|o)&m|r&o|0,(v|s)&p|v&s|0,(b|f)^(K|E)^(A|G)|0,H^(B|C)|0)|0;H=C;y=Fd(u|0,y|0,l|0,j|0)|0;u=C;j=Fd(B|0,H|0,l|0,j|0)|0;l=C;H=Id(y|0,u|0,14)|0;B=C;G=Jd(y|0,u|0,50)|0;B=B|C;A=Id(y|0,u|0,18)|0;E=C;K=Jd(y|0,u|0,46)|0;E=B^(E|C);B=Id(y|0,u|0,41)|0;f=C;b=Jd(y|0,u|0,23)|0;f=E^(f|C);E=g+528|0;I=c[E>>2]|0;E=c[E+4>>2]|0;M=Fd(J|0,M|0,-840897762,-354779690)|0;E=Fd(M|0,C|0,I|0,E|0)|0;f=Fd(E|0,C|0,(H|G)^(A|K)^(B|b)|0,f|0)|0;f=Fd(f|0,C|0,(D^F)&y^D|0,(L^x)&u^L|0)|0;b=C;B=Id(j|0,l|0,28)|0;K=C;A=Jd(j|0,l|0,36)|0;K=K|C;G=Id(j|0,l|0,34)|0;H=C;E=Jd(j|0,l|0,30)|0;H=K^(H|C);K=Id(j|0,l|0,39)|0;I=C;M=Jd(j|0,l|0,25)|0;I=Fd((o|m)&j|o&m|0,(s|p)&l|s&p|0,(B|A)^(G|E)^(K|M)|0,H^(I|C)|0)|0;H=C;v=Fd(r|0,v|0,f|0,b|0)|0;r=C;b=Fd(I|0,H|0,f|0,b|0)|0;f=C;H=Id(v|0,r|0,14)|0;I=C;M=Jd(v|0,r|0,50)|0;I=I|C;K=Id(v|0,r|0,18)|0;E=C;G=Jd(v|0,r|0,46)|0;E=I^(E|C);I=Id(v|0,r|0,41)|0;A=C;B=Jd(v|0,r|0,23)|0;A=E^(A|C);E=g+536|0;J=c[E>>2]|0;E=c[E+4>>2]|0;L=Fd(D|0,L|0,-294727304,-176337025)|0;E=Fd(L|0,C|0,J|0,E|0)|0;A=Fd(E|0,C|0,(H|M)^(K|G)^(I|B)|0,A|0)|0;A=Fd(A|0,C|0,(F^y)&v^F|0,(x^u)&r^x|0)|0;B=C;I=Id(b|0,f|0,28)|0;G=C;K=Jd(b|0,f|0,36)|0;G=G|C;M=Id(b|0,f|0,34)|0;H=C;E=Jd(b|0,f|0,30)|0;H=G^(H|C);G=Id(b|0,f|0,39)|0;J=C;L=Jd(b|0,f|0,25)|0;J=Fd((m|j)&b|m&j|0,(p|l)&f|p&l|0,(I|K)^(M|E)^(G|L)|0,H^(J|C)|0)|0;H=C;s=Fd(o|0,s|0,A|0,B|0)|0;o=C;B=Fd(J|0,H|0,A|0,B|0)|0;A=C;H=Id(s|0,o|0,14)|0;J=C;L=Jd(s|0,o|0,50)|0;J=J|C;G=Id(s|0,o|0,18)|0;E=C;M=Jd(s|0,o|0,46)|0;E=J^(E|C);J=Id(s|0,o|0,41)|0;K=C;I=Jd(s|0,o|0,23)|0;K=E^(K|C);E=g+544|0;D=c[E>>2]|0;E=c[E+4>>2]|0;x=Fd(F|0,x|0,1914138554,116418474)|0;E=Fd(x|0,C|0,D|0,E|0)|0;K=Fd(E|0,C|0,(H|L)^(G|M)^(J|I)|0,K|0)|0;K=Fd(K|0,C|0,(y^v)&s^y|0,(u^r)&o^u|0)|0;I=C;J=Id(B|0,A|0,28)|0;M=C;G=Jd(B|0,A|0,36)|0;M=M|C;L=Id(B|0,A|0,34)|0;H=C;E=Jd(B|0,A|0,30)|0;H=M^(H|C);M=Id(B|0,A|0,39)|0;D=C;x=Jd(B|0,A|0,25)|0;D=Fd((j|b)&B|j&b|0,(l|f)&A|l&f|0,(J|G)^(L|E)^(M|x)|0,H^(D|C)|0)|0;H=C;p=Fd(m|0,p|0,K|0,I|0)|0;m=C;I=Fd(D|0,H|0,K|0,I|0)|0;K=C;H=Id(p|0,m|0,14)|0;D=C;x=Jd(p|0,m|0,50)|0;D=D|C;M=Id(p|0,m|0,18)|0;E=C;L=Jd(p|0,m|0,46)|0;E=D^(E|C);D=Id(p|0,m|0,41)|0;G=C;J=Jd(p|0,m|0,23)|0;G=E^(G|C);E=g+552|0;F=c[E>>2]|0;E=c[E+4>>2]|0;u=Fd(y|0,u|0,-1563912026,174292421)|0;E=Fd(u|0,C|0,F|0,E|0)|0;G=Fd(E|0,C|0,(H|x)^(M|L)^(D|J)|0,G|0)|0;G=Fd(G|0,C|0,(v^s)&p^v|0,(r^o)&m^r|0)|0;J=C;D=Id(I|0,K|0,28)|0;L=C;M=Jd(I|0,K|0,36)|0;L=L|C;x=Id(I|0,K|0,34)|0;H=C;E=Jd(I|0,K|0,30)|0;H=L^(H|C);L=Id(I|0,K|0,39)|0;F=C;u=Jd(I|0,K|0,25)|0;F=Fd((b|B)&I|b&B|0,(f|A)&K|f&A|0,(D|M)^(x|E)^(L|u)|0,H^(F|C)|0)|0;H=C;l=Fd(j|0,l|0,G|0,J|0)|0;j=C;J=Fd(F|0,H|0,G|0,J|0)|0;G=C;H=Id(l|0,j|0,14)|0;F=C;u=Jd(l|0,j|0,50)|0;F=F|C;L=Id(l|0,j|0,18)|0;E=C;x=Jd(l|0,j|0,46)|0;E=F^(E|C);F=Id(l|0,j|0,41)|0;M=C;D=Jd(l|0,j|0,23)|0;M=E^(M|C);E=g+560|0;y=c[E>>2]|0;E=c[E+4>>2]|0;r=Fd(v|0,r|0,-1090974290,289380356)|0;E=Fd(r|0,C|0,y|0,E|0)|0;M=Fd(E|0,C|0,(H|u)^(L|x)^(F|D)|0,M|0)|0;M=Fd(M|0,C|0,(s^p)&l^s|0,(o^m)&j^o|0)|0;D=C;F=Id(J|0,G|0,28)|0;x=C;L=Jd(J|0,G|0,36)|0;x=x|C;u=Id(J|0,G|0,34)|0;H=C;E=Jd(J|0,G|0,30)|0;H=x^(H|C);x=Id(J|0,G|0,39)|0;y=C;r=Jd(J|0,G|0,25)|0;y=Fd((B|I)&J|B&I|0,(A|K)&G|A&K|0,(F|L)^(u|E)^(x|r)|0,H^(y|C)|0)|0;H=C;f=Fd(b|0,f|0,M|0,D|0)|0;b=C;D=Fd(y|0,H|0,M|0,D|0)|0;M=C;H=Id(f|0,b|0,14)|0;y=C;r=Jd(f|0,b|0,50)|0;y=y|C;x=Id(f|0,b|0,18)|0;E=C;u=Jd(f|0,b|0,46)|0;E=y^(E|C);y=Id(f|0,b|0,41)|0;L=C;F=Jd(f|0,b|0,23)|0;L=E^(L|C);E=g+568|0;v=c[E>>2]|0;E=c[E+4>>2]|0;o=Fd(s|0,o|0,320620315,460393269)|0;E=Fd(o|0,C|0,v|0,E|0)|0;L=Fd(E|0,C|0,(H|r)^(x|u)^(y|F)|0,L|0)|0;L=Fd(L|0,C|0,(p^l)&f^p|0,(m^j)&b^m|0)|0;F=C;y=Id(D|0,M|0,28)|0;u=C;x=Jd(D|0,M|0,36)|0;u=u|C;r=Id(D|0,M|0,34)|0;H=C;E=Jd(D|0,M|0,30)|0;H=u^(H|C);u=Id(D|0,M|0,39)|0;v=C;o=Jd(D|0,M|0,25)|0;v=Fd((I|J)&D|I&J|0,(K|G)&M|K&G|0,(y|x)^(r|E)^(u|o)|0,H^(v|C)|0)|0;H=C;A=Fd(B|0,A|0,L|0,F|0)|0;B=C;F=Fd(v|0,H|0,L|0,F|0)|0;L=C;H=Id(A|0,B|0,14)|0;v=C;o=Jd(A|0,B|0,50)|0;v=v|C;u=Id(A|0,B|0,18)|0;E=C;r=Jd(A|0,B|0,46)|0;E=v^(E|C);v=Id(A|0,B|0,41)|0;x=C;y=Jd(A|0,B|0,23)|0;x=E^(x|C);E=g+576|0;s=c[E>>2]|0;E=c[E+4>>2]|0;m=Fd(p|0,m|0,587496836,685471733)|0;E=Fd(m|0,C|0,s|0,E|0)|0;x=Fd(E|0,C|0,(H|o)^(u|r)^(v|y)|0,x|0)|0;x=Fd(x|0,C|0,(l^f)&A^l|0,(j^b)&B^j|0)|0;y=C;v=Id(F|0,L|0,28)|0;r=C;u=Jd(F|0,L|0,36)|0;r=r|C;o=Id(F|0,L|0,34)|0;H=C;E=Jd(F|0,L|0,30)|0;H=r^(H|C);r=Id(F|0,L|0,39)|0;s=C;m=Jd(F|0,L|0,25)|0;s=Fd((J|D)&F|J&D|0,(G|M)&L|G&M|0,(v|u)^(o|E)^(r|m)|0,H^(s|C)|0)|0;H=C;K=Fd(I|0,K|0,x|0,y|0)|0;I=C;y=Fd(s|0,H|0,x|0,y|0)|0;x=C;H=Id(K|0,I|0,14)|0;s=C;m=Jd(K|0,I|0,50)|0;s=s|C;r=Id(K|0,I|0,18)|0;E=C;o=Jd(K|0,I|0,46)|0;E=s^(E|C);s=Id(K|0,I|0,41)|0;u=C;v=Jd(K|0,I|0,23)|0;u=E^(u|C);E=g+584|0;p=c[E>>2]|0;E=c[E+4>>2]|0;j=Fd(l|0,j|0,1086792851,852142971)|0;E=Fd(j|0,C|0,p|0,E|0)|0;u=Fd(E|0,C|0,(H|m)^(r|o)^(s|v)|0,u|0)|0;u=Fd(u|0,C|0,(f^A)&K^f|0,(b^B)&I^b|0)|0;v=C;s=Id(y|0,x|0,28)|0;o=C;r=Jd(y|0,x|0,36)|0;o=o|C;m=Id(y|0,x|0,34)|0;H=C;E=Jd(y|0,x|0,30)|0;H=o^(H|C);o=Id(y|0,x|0,39)|0;p=C;j=Jd(y|0,x|0,25)|0;p=Fd((D|F)&y|D&F|0,(M|L)&x|M&L|0,(s|r)^(m|E)^(o|j)|0,H^(p|C)|0)|0;H=C;G=Fd(J|0,G|0,u|0,v|0)|0;J=C;v=Fd(p|0,H|0,u|0,v|0)|0;u=C;H=Id(G|0,J|0,14)|0;p=C;j=Jd(G|0,J|0,50)|0;p=p|C;o=Id(G|0,J|0,18)|0;E=C;m=Jd(G|0,J|0,46)|0;E=p^(E|C);p=Id(G|0,J|0,41)|0;r=C;s=Jd(G|0,J|0,23)|0;r=E^(r|C);E=g+592|0;l=c[E>>2]|0;E=c[E+4>>2]|0;b=Fd(f|0,b|0,365543100,1017036298)|0;E=Fd(b|0,C|0,l|0,E|0)|0;r=Fd(E|0,C|0,(H|j)^(o|m)^(p|s)|0,r|0)|0;r=Fd(r|0,C|0,(A^K)&G^A|0,(B^I)&J^B|0)|0;s=C;p=Id(v|0,u|0,28)|0;m=C;o=Jd(v|0,u|0,36)|0;m=m|C;j=Id(v|0,u|0,34)|0;H=C;E=Jd(v|0,u|0,30)|0;H=m^(H|C);m=Id(v|0,u|0,39)|0;l=C;b=Jd(v|0,u|0,25)|0;l=Fd((F|y)&v|F&y|0,(L|x)&u|L&x|0,(p|o)^(j|E)^(m|b)|0,H^(l|C)|0)|0;H=C;M=Fd(D|0,M|0,r|0,s|0)|0;D=C;s=Fd(l|0,H|0,r|0,s|0)|0;r=C;H=Id(M|0,D|0,14)|0;l=C;b=Jd(M|0,D|0,50)|0;l=l|C;m=Id(M|0,D|0,18)|0;E=C;j=Jd(M|0,D|0,46)|0;E=l^(E|C);l=Id(M|0,D|0,41)|0;o=C;p=Jd(M|0,D|0,23)|0;o=E^(o|C);E=g+600|0;f=c[E>>2]|0;E=c[E+4>>2]|0;B=Fd(A|0,B|0,-1676669620,1126000580)|0;E=Fd(B|0,C|0,f|0,E|0)|0;o=Fd(E|0,C|0,(H|b)^(m|j)^(l|p)|0,o|0)|0;o=Fd(o|0,C|0,(K^G)&M^K|0,(I^J)&D^I|0)|0;p=C;l=Id(s|0,r|0,28)|0;j=C;m=Jd(s|0,r|0,36)|0;j=j|C;b=Id(s|0,r|0,34)|0;H=C;E=Jd(s|0,r|0,30)|0;H=j^(H|C);j=Id(s|0,r|0,39)|0;f=C;B=Jd(s|0,r|0,25)|0;f=Fd((y|v)&s|y&v|0,(x|u)&r|x&u|0,(l|m)^(b|E)^(j|B)|0,H^(f|C)|0)|0;H=C;L=Fd(F|0,L|0,o|0,p|0)|0;F=C;p=Fd(f|0,H|0,o|0,p|0)|0;o=C;H=Id(L|0,F|0,14)|0;f=C;B=Jd(L|0,F|0,50)|0;f=f|C;j=Id(L|0,F|0,18)|0;E=C;b=Jd(L|0,F|0,46)|0;E=f^(E|C);f=Id(L|0,F|0,41)|0;m=C;l=Jd(L|0,F|0,23)|0;m=E^(m|C);E=g+608|0;A=c[E>>2]|0;E=c[E+4>>2]|0;I=Fd(K|0,I|0,-885112138,1288033470)|0;E=Fd(I|0,C|0,A|0,E|0)|0;m=Fd(E|0,C|0,(H|B)^(j|b)^(f|l)|0,m|0)|0;m=Fd(m|0,C|0,(G^M)&L^G|0,(J^D)&F^J|0)|0;l=C;f=Id(p|0,o|0,28)|0;b=C;j=Jd(p|0,o|0,36)|0;b=b|C;B=Id(p|0,o|0,34)|0;H=C;E=Jd(p|0,o|0,30)|0;H=b^(H|C);b=Id(p|0,o|0,39)|0;A=C;I=Jd(p|0,o|0,25)|0;A=Fd((v|s)&p|v&s|0,(u|r)&o|u&r|0,(f|j)^(B|E)^(b|I)|0,H^(A|C)|0)|0;H=C;x=Fd(y|0,x|0,m|0,l|0)|0;y=C;l=Fd(A|0,H|0,m|0,l|0)|0;m=C;H=Id(x|0,y|0,14)|0;A=C;I=Jd(x|0,y|0,50)|0;A=A|C;b=Id(x|0,y|0,18)|0;E=C;B=Jd(x|0,y|0,46)|0;E=A^(E|C);A=Id(x|0,y|0,41)|0;j=C;f=Jd(x|0,y|0,23)|0;j=E^(j|C);E=g+616|0;K=c[E>>2]|0;E=c[E+4>>2]|0;J=Fd(G|0,J|0,-60457430,1501505948)|0;E=Fd(J|0,C|0,K|0,E|0)|0;j=Fd(E|0,C|0,(H|I)^(b|B)^(A|f)|0,j|0)|0;j=Fd(j|0,C|0,(M^L)&x^M|0,(D^F)&y^D|0)|0;f=C;A=Id(l|0,m|0,28)|0;B=C;b=Jd(l|0,m|0,36)|0;B=B|C;I=Id(l|0,m|0,34)|0;H=C;E=Jd(l|0,m|0,30)|0;H=B^(H|C);B=Id(l|0,m|0,39)|0;K=C;J=Jd(l|0,m|0,25)|0;K=Fd((s|p)&l|s&p|0,(r|o)&m|r&o|0,(A|b)^(I|E)^(B|J)|0,H^(K|C)|0)|0;H=C;u=Fd(v|0,u|0,j|0,f|0)|0;v=C;f=Fd(K|0,H|0,j|0,f|0)|0;j=C;H=Id(u|0,v|0,14)|0;K=C;J=Jd(u|0,v|0,50)|0;K=K|C;B=Id(u|0,v|0,18)|0;E=C;I=Jd(u|0,v|0,46)|0;E=K^(E|C);K=Id(u|0,v|0,41)|0;b=C;A=Jd(u|0,v|0,23)|0;b=E^(b|C);E=g+624|0;G=c[E>>2]|0;E=c[E+4>>2]|0;D=Fd(M|0,D|0,987167468,1607167915)|0;E=Fd(D|0,C|0,G|0,E|0)|0;b=Fd(E|0,C|0,(H|J)^(B|I)^(K|A)|0,b|0)|0;b=Fd(b|0,C|0,(L^x)&u^L|0,(F^y)&v^F|0)|0;A=C;K=Id(f|0,j|0,28)|0;I=C;B=Jd(f|0,j|0,36)|0;I=I|C;J=Id(f|0,j|0,34)|0;H=C;E=Jd(f|0,j|0,30)|0;H=I^(H|C);I=Id(f|0,j|0,39)|0;G=C;D=Jd(f|0,j|0,25)|0;G=Fd((p|l)&f|p&l|0,(o|m)&j|o&m|0,(K|B)^(J|E)^(I|D)|0,H^(G|C)|0)|0;H=C;r=Fd(s|0,r|0,b|0,A|0)|0;s=C;A=Fd(G|0,H|0,b|0,A|0)|0;b=C;H=Id(r|0,s|0,14)|0;G=C;D=Jd(r|0,s|0,50)|0;G=G|C;I=Id(r|0,s|0,18)|0;E=C;J=Jd(r|0,s|0,46)|0;E=G^(E|C);G=Id(r|0,s|0,41)|0;B=C;K=Jd(r|0,s|0,23)|0;B=E^(B|C);g=g+632|0;E=c[g>>2]|0;g=c[g+4>>2]|0;F=Fd(L|0,F|0,1246189591,1816402316)|0;g=Fd(F|0,C|0,E|0,g|0)|0;g=Fd(g|0,C|0,(H|D)^(I|J)^(G|K)|0,B|0)|0;g=Fd(g|0,C|0,(x^u)&r^x|0,(y^v)&s^y|0)|0;B=C;K=Id(A|0,b|0,28)|0;G=C;J=Jd(A|0,b|0,36)|0;G=G|C;I=Id(A|0,b|0,34)|0;D=C;H=Jd(A|0,b|0,30)|0;D=G^(D|C);G=Id(A|0,b|0,39)|0;E=C;F=Jd(A|0,b|0,25)|0;E=Fd((l|f)&A|l&f|0,(m|j)&b|m&j|0,(K|J)^(I|H)^(G|F)|0,D^(E|C)|0)|0;D=C;o=Fd(p|0,o|0,g|0,B|0)|0;p=C;B=Fd(E|0,D|0,g|0,B|0)|0;g=a;B=Fd(c[g>>2]|0,c[g+4>>2]|0,B|0,C|0)|0;g=a;c[g>>2]=B;c[g+4>>2]=C;g=e;g=Fd(c[g>>2]|0,c[g+4>>2]|0,A|0,b|0)|0;a=e;c[a>>2]=g;c[a+4>>2]=C;a=k;j=Fd(c[a>>2]|0,c[a+4>>2]|0,f|0,j|0)|0;c[k>>2]=j;c[k+4>>2]=C;k=n;m=Fd(c[k>>2]|0,c[k+4>>2]|0,l|0,m|0)|0;c[n>>2]=m;c[n+4>>2]=C;n=q;p=Fd(c[n>>2]|0,c[n+4>>2]|0,o|0,p|0)|0;c[q>>2]=p;c[q+4>>2]=C;q=t;s=Fd(c[q>>2]|0,c[q+4>>2]|0,r|0,s|0)|0;c[t>>2]=s;c[t+4>>2]=C;t=w;v=Fd(c[t>>2]|0,c[t+4>>2]|0,u|0,v|0)|0;c[w>>2]=v;c[w+4>>2]=C;w=z;y=Fd(c[w>>2]|0,c[w+4>>2]|0,x|0,y|0)|0;c[z>>2]=y;c[z+4>>2]=C;i=h;return}function Jb(){return 144}function Kb(){return 16}function Lb(){return 32}function Mb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=i=i+63&-64;i=i+144|0;Sb(g,e);Tb(g,b,c,d);Ub(g,a);i=f;return 0}function Nb(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Rb(a,b,c,d,e)|0}function Ob(a,b){a=a|0;b=b|0;Sb(a,b);return 0}function Pb(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Tb(a,b,c,d);return 0}function Qb(a,b){a=a|0;b=b|0;Ub(a,b);return 0}function Rb(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;h=i;g=i=i+63&-64;i=i+160|0;j=g;g=g+144|0;Sb(j,f);Tb(j,c,d,e);Ub(j,g);i=h;return ((((a[g+1>>0]^a[b+1>>0]|a[g>>0]^a[b>>0]|a[g+2>>0]^a[b+2>>0]|a[g+3>>0]^a[b+3>>0]|a[g+4>>0]^a[b+4>>0]|a[g+5>>0]^a[b+5>>0]|a[g+6>>0]^a[b+6>>0]|a[g+7>>0]^a[b+7>>0]|a[g+8>>0]^a[b+8>>0]|a[g+9>>0]^a[b+9>>0]|a[g+10>>0]^a[b+10>>0]|a[g+11>>0]^a[b+11>>0]|a[g+12>>0]^a[b+12>>0]|a[g+13>>0]^a[b+13>>0]|a[g+14>>0]^a[b+14>>0]|a[g+15>>0]^a[b+15>>0])&255)+511|0)>>>8&1)+-1|0}function Sb(b,e){b=b|0;e=e|0;var f=0,g=0;f=e+3|0;c[b>>2]=(d[e+1>>0]|0)<<8|(d[e>>0]|0)|(d[e+2>>0]|0)<<16|(d[f>>0]|0)<<24&50331648;g=e+6|0;c[b+4>>2]=((d[e+4>>0]|0)<<8|(d[f>>0]|0)|(d[e+5>>0]|0)<<16|(d[g>>0]|0)<<24)>>>2&67108611;f=e+9|0;c[b+8>>2]=((d[e+7>>0]|0)<<8|(d[g>>0]|0)|(d[e+8>>0]|0)<<16|(d[f>>0]|0)<<24)>>>4&67092735;c[b+12>>2]=((d[e+10>>0]|0)<<8|(d[f>>0]|0)|(d[e+11>>0]|0)<<16|(d[e+12>>0]|0)<<24)>>>6&66076671;c[b+16>>2]=(d[e+14>>0]|0)<<8|(d[e+13>>0]|0)|(d[e+15>>0]|0)<<16&983040;f=b+20|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[b+40>>2]=(d[e+17>>0]|0)<<8|(d[e+16>>0]|0)|(d[e+18>>0]|0)<<16|(d[e+19>>0]|0)<<24;c[b+44>>2]=(d[e+21>>0]|0)<<8|(d[e+20>>0]|0)|(d[e+22>>0]|0)<<16|(d[e+23>>0]|0)<<24;c[b+48>>2]=(d[e+25>>0]|0)<<8|(d[e+24>>0]|0)|(d[e+26>>0]|0)<<16|(d[e+27>>0]|0)<<24;c[b+52>>2]=(d[e+29>>0]|0)<<8|(d[e+28>>0]|0)|(d[e+30>>0]|0)<<16|(d[e+31>>0]|0)<<24;e=b+56|0;c[e>>2]=0;c[e+4>>2]=0;a[b+80>>0]=0;return}function Tb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;m=b+56|0;h=m;g=c[h>>2]|0;h=c[h+4>>2]|0;do if(!((g|0)==0&(h|0)==0)){k=Ed(16,0,g|0,h|0)|0;l=C;j=l>>>0>f>>>0|(l|0)==(f|0)&k>>>0>e>>>0;k=j?e:k;l=j?f:l;if(!((k|0)==0&(l|0)==0)){j=0;i=0;do{n=a[d+j>>0]|0;h=Fd(g|0,h|0,j|0,i|0)|0;a[h+56+(b+8)>>0]=n;j=Fd(j|0,i|0,1,0)|0;i=C;h=m;g=c[h>>2]|0;h=c[h+4>>2]|0}while(i>>>0<l>>>0|(i|0)==(l|0)&j>>>0<k>>>0)}n=Fd(g|0,h|0,k|0,l|0)|0;j=C;i=m;c[i>>2]=n;c[i+4>>2]=j;if(j>>>0<0|(j|0)==0&n>>>0<16)return;else{e=Ed(e|0,f|0,k|0,l|0)|0;f=C;Vb(b,b+64|0,16,0);n=m;c[n>>2]=0;c[n+4>>2]=0;d=d+k|0;break}}while(0);if(f>>>0>0|(f|0)==0&e>>>0>15){n=e&-16;Vb(b,d,n,f);e=Ed(e|0,f|0,n|0,f|0)|0;d=d+n|0;f=C}if((e|0)==0&(f|0)==0)return;else{g=0;h=0}do{l=a[d+g>>0]|0;n=m;n=Fd(c[n>>2]|0,c[n+4>>2]|0,g|0,h|0)|0;a[n+56+(b+8)>>0]=l;g=Fd(g|0,h|0,1,0)|0;h=C}while(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0);b=m;b=Fd(c[b>>2]|0,c[b+4>>2]|0,e|0,f|0)|0;n=m;c[n>>2]=b;c[n+4>>2]=C;return}function Ub(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=b+56|0;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!((f|0)==0&(g|0)==0)){a[f+56+(b+8)>>0]=1;e=Fd(f|0,g|0,1,0)|0;h=C;if(h>>>0<0|(h|0)==0&e>>>0<16){h=Ed(14,0,f|0,g|0)|0;Hd(b+(e+64)|0,0,h+1|0)|0}a[b+80>>0]=1;Vb(b,b+64|0,16,0)}h=c[b+24>>2]|0;p=(c[b+28>>2]|0)+(h>>>26)|0;e=p&67108863;n=(p>>>26)+(c[b+32>>2]|0)|0;m=n&67108863;i=(n>>>26)+(c[b+36>>2]|0)|0;g=((i>>>26)*5|0)+(c[b+20>>2]|0)|0;f=g&67108863;h=(g>>>26)+(h&67108863)|0;r=((f+5|0)>>>26)+h|0;q=r>>>26;o=(q+e|0)>>>26;k=(i|-67108864)+((o+m|0)>>>26)|0;l=(k>>>31)+-1|0;j=k>>31;h=r&67108863&l|j&h;e=q+p&67108863&l|j&e;m=o+n&67108863&l|j&m;f=Fd(g+5&67108863&l|j&f|h<<26|0,0,c[b+40>>2]|0,0)|0;g=C;h=Fd(h>>>6|e<<20|0,0,c[b+44>>2]|0,0)|0;g=Fd(h|0,C|0,g|0,0)|0;h=C;e=Fd(e>>>12|m<<14|0,0,c[b+48>>2]|0,0)|0;h=Fd(e|0,C|0,h|0,0)|0;e=C;i=Fd(m>>>18|(l&k|j&i)<<8|0,0,c[b+52>>2]|0,0)|0;e=Fd(i|0,C|0,e|0,0)|0;a[d>>0]=f;a[d+1>>0]=f>>>8;a[d+2>>0]=f>>>16;a[d+3>>0]=f>>>24;a[d+4>>0]=g;a[d+5>>0]=g>>>8;a[d+6>>0]=g>>>16;a[d+7>>0]=g>>>24;a[d+8>>0]=h;a[d+9>>0]=h>>>8;a[d+10>>0]=h>>>16;a[d+11>>0]=h>>>24;a[d+12>>0]=e;a[d+13>>0]=e>>>8;a[d+14>>0]=e>>>16;a[d+15>>0]=e>>>24;e=b+88|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(e|0));return}function Vb(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;s=(a[b+80>>0]|0)!=0?0:16777216;t=c[b+4>>2]|0;u=c[b+8>>2]|0;m=c[b+12>>2]|0;n=c[b+16>>2]|0;v=b+20|0;l=c[v>>2]|0;w=b+24|0;k=c[w>>2]|0;x=b+28|0;j=c[x>>2]|0;y=b+32|0;i=c[y>>2]|0;z=b+36|0;h=c[z>>2]|0;if(!(g>>>0>0|(g|0)==0&f>>>0>15)){q=l;r=k;s=j;t=i;u=h;c[v>>2]=q;c[w>>2]=r;c[x>>2]=s;c[y>>2]=t;c[z>>2]=u;return}o=n*5|0;p=m*5|0;q=u*5|0;r=t*5|0;b=c[b>>2]|0;while(1){J=d[e+3>>0]|0;B=(d[e+1>>0]<<8|d[e>>0]|d[e+2>>0]<<16|J<<24&50331648)+l|0;H=d[e+6>>0]|0;J=((d[e+4>>0]<<8|J|d[e+5>>0]<<16|H<<24)>>>2&67108863)+k|0;G=d[e+9>>0]|0;H=((d[e+7>>0]<<8|H|d[e+8>>0]<<16|G<<24)>>>4&67108863)+j|0;G=((d[e+10>>0]<<8|G|d[e+11>>0]<<16|d[e+12>>0]<<24)>>>6)+i|0;l=(d[e+13>>0]|s|d[e+14>>0]<<8|d[e+15>>0]<<16)+h|0;k=Qd(B|0,0,b|0,0)|0;j=C;A=Qd(J|0,0,o|0,0)|0;j=Fd(A|0,C|0,k|0,j|0)|0;k=C;A=Qd(H|0,0,p|0,0)|0;A=Fd(j|0,k|0,A|0,C|0)|0;k=C;j=Qd(G|0,0,q|0,0)|0;j=Fd(A|0,k|0,j|0,C|0)|0;k=C;A=Qd(l|0,0,r|0,0)|0;A=Fd(j|0,k|0,A|0,C|0)|0;k=C;j=Qd(B|0,0,t|0,0)|0;i=C;F=Qd(J|0,0,b|0,0)|0;i=Fd(F|0,C|0,j|0,i|0)|0;j=C;F=Qd(H|0,0,o|0,0)|0;F=Fd(i|0,j|0,F|0,C|0)|0;j=C;i=Qd(G|0,0,p|0,0)|0;i=Fd(F|0,j|0,i|0,C|0)|0;j=C;F=Qd(l|0,0,q|0,0)|0;F=Fd(i|0,j|0,F|0,C|0)|0;j=C;i=Qd(B|0,0,u|0,0)|0;h=C;E=Qd(J|0,0,t|0,0)|0;h=Fd(E|0,C|0,i|0,h|0)|0;i=C;E=Qd(H|0,0,b|0,0)|0;E=Fd(h|0,i|0,E|0,C|0)|0;i=C;h=Qd(G|0,0,o|0,0)|0;h=Fd(E|0,i|0,h|0,C|0)|0;i=C;E=Qd(l|0,0,p|0,0)|0;E=Fd(h|0,i|0,E|0,C|0)|0;i=C;h=Qd(B|0,0,m|0,0)|0;I=C;D=Qd(J|0,0,u|0,0)|0;I=Fd(D|0,C|0,h|0,I|0)|0;h=C;D=Qd(H|0,0,t|0,0)|0;D=Fd(I|0,h|0,D|0,C|0)|0;h=C;I=Qd(G|0,0,b|0,0)|0;I=Fd(D|0,h|0,I|0,C|0)|0;h=C;D=Qd(l|0,0,o|0,0)|0;D=Fd(I|0,h|0,D|0,C|0)|0;h=C;B=Qd(B|0,0,n|0,0)|0;I=C;J=Qd(J|0,0,m|0,0)|0;I=Fd(J|0,C|0,B|0,I|0)|0;B=C;H=Qd(H|0,0,u|0,0)|0;H=Fd(I|0,B|0,H|0,C|0)|0;B=C;G=Qd(G|0,0,t|0,0)|0;G=Fd(H|0,B|0,G|0,C|0)|0;B=C;l=Qd(l|0,0,b|0,0)|0;l=Fd(G|0,B|0,l|0,C|0)|0;B=C;k=Id(A|0,k|0,26)|0;k=Fd(F|0,j|0,k|0,0)|0;j=Id(k|0,C|0,26)|0;j=Fd(E|0,i|0,j|0,0)|0;i=Id(j|0,C|0,26)|0;j=j&67108863;i=Fd(D|0,h|0,i|0,0)|0;h=Id(i|0,C|0,26)|0;i=i&67108863;h=Fd(l|0,B|0,h|0,0)|0;B=Id(h|0,C|0,26)|0;h=h&67108863;B=B*5|0;l=B+A&67108863;k=((B+(A&67108863)|0)>>>26)+(k&67108863)|0;f=Fd(f|0,g|0,-16,-1)|0;g=C;if(!(g>>>0>0|(g|0)==0&f>>>0>15))break;else e=e+16|0}c[v>>2]=l;c[w>>2]=k;c[x>>2]=j;c[y>>2]=i;c[z>>2]=h;return}function Wb(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=i;v=i=i+63&-64;i=i+48|0;j=v+8|0;w=v+4|0;if((a[g>>0]|0)!=36){h=0;i=y;return h|0}if((a[g+1>>0]|0)!=55){h=0;i=y;return h|0}if((a[g+2>>0]|0)!=36){h=0;i=y;return h|0}s=a[g+3>>0]|0;n=s&255;a:do if(3){o=65;m=34875;do{if((a[m>>0]|0)==s<<24>>24)break a;m=m+1|0;o=o+-1|0;p=(o|0)!=0}while(p&(m&3|0)!=0);if(!p){h=0;i=y;return h|0}}else{o=65;m=34875}while(0);b:do if((a[m>>0]|0)!=s<<24>>24){q=_(n,16843009)|0;c:do if(o>>>0>3)while(1){u=c[m>>2]^q;if((u&-2139062144^-2139062144)&u+-16843009)break c;m=m+4|0;o=o+-4|0;if(o>>>0<=3){x=12;break}}else x=12;while(0);if((x|0)==12)if(!o){h=0;i=y;return h|0}while(1){if((a[m>>0]|0)==s<<24>>24)break b;o=o+-1|0;if(!o){j=0;break}else m=m+1|0}i=y;return j|0}while(0);if((m|0)==0|(o|0)==0){h=0;i=y;return h|0}t=Jd(1,0,m-34875|0)|0;u=C;n=Yb(w,g+4|0)|0;if(!n){h=0;i=y;return h|0}k=Yb(v,n)|0;if(!k){h=0;i=y;return h|0}m=k;l=m-g|0;n=(m&3|0)==0;d:do if(n){p=k;x=22}else{p=k;s=m;while(1){if(!(a[p>>0]|0)){p=s;break d}p=p+1|0;s=p;if(!(s&3)){x=22;break}}}while(0);if((x|0)==22){while(1){o=c[p>>2]|0;if(!((o&-2139062144^-2139062144)&o+-16843009))p=p+4|0;else break}if((o&255)<<24>>24)do p=p+1|0;while((a[p>>0]|0)!=0)}r=p-m+1|0;while(1){q=r+-1|0;if(!r){x=32;break}s=k+q|0;if((a[s>>0]|0)==36){x=30;break}else r=q}if((x|0)==30)if(!s)x=32;else o=r+-1|0;if((x|0)==32){e:do if(n){p=k;x=35}else{o=k;p=m;while(1){if(!(a[o>>0]|0))break e;o=o+1|0;p=o;if(!(p&3)){p=o;x=35;break}}}while(0);if((x|0)==35){while(1){o=c[p>>2]|0;if(!((o&-2139062144^-2139062144)&o+-16843009))p=p+4|0;else break}if((o&255)<<24>>24)do p=p+1|0;while((a[p>>0]|0)!=0)}o=p-m|0}p=o+l|0;s=p+45|0;if(s>>>0>102|s>>>0<o>>>0){h=0;i=y;return h|0}if(ic(b,e,f,k,o,t,u,c[w>>2]|0,c[v>>2]|0,j,32)|0){h=0;i=y;return h|0}Kd(h|0,g|0,p|0)|0;a[h+p>>0]=36;s=h+(p+1)|0;q=101-p|0;r=0;f:while(1){m=r+1|0;m=r-(m>>>0<32?32:m)|0;m=m>>>0>4294967293?m:-3;l=0;k=r;r=r-m|0;n=0;while(1){g=k;k=k+1|0;n=d[j+g>>0]<<l|n;if((k|0)==(r|0))break;else l=l+8|0}p=_(m,-8)|0;if(!p)l=s;else{m=q;k=s;o=0;while(1){if(!m){x=51;break f}l=k+1|0;a[k>>0]=a[34875+(n&63)>>0]|0;o=o+6|0;if(o>>>0>=p>>>0)break;else{n=n>>>6;m=m+-1|0;k=l}}}if(!l){x=51;break}q=s+q-l|0;if(r>>>0>=32)break;else s=l}if((x|0)==51){k=j+32|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(k|0));h=0;i=y;return h|0}k=j+32|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(k|0));if(l>>>0>=(h+102|0)>>>0){h=0;i=y;return h|0}a[l>>0]=0;i=y;return h|0}function Xb(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0;m=i;n=i=i+63&-64;i=i+16|0;c[n+4>>2]=0;c[n>>2]=0;c[n+8>>2]=0;g=ic(n,a,b,d,e,f,g,h,j,k,l)|0;f=c[n>>2]|0;if(!f){i=m;return g|0}rd(f);i=m;return g|0}function Yb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;k=a[d>>0]|0;i=k&255;a:do if(3){f=65;e=34875;do{if((a[e>>0]|0)==k<<24>>24)break a;e=e+1|0;f=f+-1|0;g=(f|0)!=0}while(g&(e&3|0)!=0);if(!g){d=0;n=0;c[b>>2]=n;return d|0}}else{f=65;e=34875}while(0);b:do if((a[e>>0]|0)!=k<<24>>24){j=_(i,16843009)|0;c:do if(f>>>0>3)while(1){m=c[e>>2]^j;if((m&-2139062144^-2139062144)&m+-16843009)break c;e=e+4|0;f=f+-4|0;if(f>>>0<=3){n=9;break}}else n=9;while(0);if((n|0)==9)if(!f){d=0;n=0;c[b>>2]=n;return d|0}while(1){if((a[e>>0]|0)==k<<24>>24)break b;f=f+-1|0;if(!f){e=0;f=0;break}else e=e+1|0}c[b>>2]=f;return e|0}while(0);if((e|0)==0|(f|0)==0){d=0;n=0;c[b>>2]=n;return d|0}k=a[d+1>>0]|0;j=k&255;d:do if(3){f=65;g=34875;do{if((a[g>>0]|0)==k<<24>>24)break d;g=g+1|0;f=f+-1|0;h=(f|0)!=0}while(h&(g&3|0)!=0);if(!h){d=0;n=0;c[b>>2]=n;return d|0}}else{f=65;g=34875}while(0);e:do if((a[g>>0]|0)!=k<<24>>24){j=_(j,16843009)|0;f:do if(f>>>0>3)while(1){m=c[g>>2]^j;if((m&-2139062144^-2139062144)&m+-16843009)break f;g=g+4|0;f=f+-4|0;if(f>>>0<=3){n=22;break}}else n=22;while(0);if((n|0)==22)if(!f){d=0;n=0;c[b>>2]=n;return d|0}while(1){if((a[g>>0]|0)==k<<24>>24)break e;f=f+-1|0;if(!f){e=0;f=0;break}else g=g+1|0}c[b>>2]=f;return e|0}while(0);if((g|0)==0|(f|0)==0){d=0;n=0;c[b>>2]=n;return d|0}l=a[d+2>>0]|0;j=l&255;g:do if(3){f=65;h=34875;do{if((a[h>>0]|0)==l<<24>>24)break g;h=h+1|0;f=f+-1|0;i=(f|0)!=0}while(i&(h&3|0)!=0);if(!i){d=0;n=0;c[b>>2]=n;return d|0}}else{f=65;h=34875}while(0);h:do if((a[h>>0]|0)!=l<<24>>24){k=_(j,16843009)|0;i:do if(f>>>0>3)while(1){m=c[h>>2]^k;if((m&-2139062144^-2139062144)&m+-16843009)break i;h=h+4|0;f=f+-4|0;if(f>>>0<=3){n=36;break}}else n=36;while(0);if((n|0)==36)if(!f){d=0;n=0;c[b>>2]=n;return d|0}while(1){if((a[h>>0]|0)==l<<24>>24)break h;f=f+-1|0;if(!f){e=0;f=0;break}else h=h+1|0}c[b>>2]=f;return e|0}while(0);if((h|0)==0|(f|0)==0){d=0;n=0;c[b>>2]=n;return d|0}l=a[d+3>>0]|0;k=l&255;j:do if(3){i=65;f=34875;do{if((a[f>>0]|0)==l<<24>>24)break j;f=f+1|0;i=i+-1|0;j=(i|0)!=0}while(j&(f&3|0)!=0);if(!j){d=0;n=0;c[b>>2]=n;return d|0}}else{i=65;f=34875}while(0);k:do if((a[f>>0]|0)==l<<24>>24)m=f;else{k=_(k,16843009)|0;l:do if(i>>>0>3)while(1){m=c[f>>2]^k;if((m&-2139062144^-2139062144)&m+-16843009)break l;f=f+4|0;i=i+-4|0;if(i>>>0<=3){n=49;break}}else n=49;while(0);if((n|0)==49)if(!i){d=0;n=0;c[b>>2]=n;return d|0}while(1){if((a[f>>0]|0)==l<<24>>24){m=f;break k}i=i+-1|0;if(!i){e=0;f=0;break}else f=f+1|0}c[b>>2]=f;return e|0}while(0);if((m|0)==0|(i|0)==0){d=0;n=0;c[b>>2]=n;return d|0}l=a[d+4>>0]|0;k=l&255;m:do if(3){i=65;f=34875;do{if((a[f>>0]|0)==l<<24>>24)break m;f=f+1|0;i=i+-1|0;j=(i|0)!=0}while(j&(f&3|0)!=0);if(!j){d=0;n=0;c[b>>2]=n;return d|0}}else{i=65;f=34875}while(0);n:do if((a[f>>0]|0)!=l<<24>>24){k=_(k,16843009)|0;o:do if(i>>>0>3)while(1){j=c[f>>2]^k;if((j&-2139062144^-2139062144)&j+-16843009)break o;f=f+4|0;i=i+-4|0;if(i>>>0<=3){n=62;break}}else n=62;while(0);if((n|0)==62)if(!i){d=0;n=0;c[b>>2]=n;return d|0}while(1){if((a[f>>0]|0)==l<<24>>24)break n;i=i+-1|0;if(!i){e=0;f=0;break}else f=f+1|0}c[b>>2]=f;return e|0}while(0);if((f|0)==0|(i|0)==0){d=0;n=0;c[b>>2]=n;return d|0}d=d+5|0;n=f-34875<<24|(m-34875<<18|(h-34875<<12|(g-34875<<6|e-34875)));c[b>>2]=n;return d|0}function Zb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=i;q=i=i+63&-64;i=i+560|0;o=q+488|0;t=q+456|0;p=q+208|0;r=q;s=q+448|0;q=q+416|0;m=p+32|0;l=m;c[l>>2]=0;c[l+4>>2]=0;c[p>>2]=c[18];c[p+4>>2]=c[19];c[p+8>>2]=c[20];c[p+12>>2]=c[21];c[p+16>>2]=c[22];c[p+20>>2]=c[23];c[p+24>>2]=c[24];c[p+28>>2]=c[25];if(d>>>0<=64){k=o;j=k+64|0;do{a[k>>0]=54;k=k+1|0}while((k|0)<(j|0));l=(d|0)==0;if(!l){m=b;a[o>>0]=a[m>>0]^54;if((d|0)==1){b=m;m=l}else{b=m;n=5}}else m=l}else{Db(p,b,d,0);Eb(p,t);k=m;c[k>>2]=0;c[k+4>>2]=0;c[p>>2]=c[18];c[p+4>>2]=c[19];c[p+8>>2]=c[20];c[p+12>>2]=c[21];c[p+16>>2]=c[22];c[p+20>>2]=c[23];c[p+24>>2]=c[24];c[p+28>>2]=c[25];k=o;j=k+64|0;do{a[k>>0]=54;k=k+1|0}while((k|0)<(j|0));a[o>>0]=a[t>>0]^54;b=t;d=32;l=0;n=5}if((n|0)==5){m=1;do{n=o+m|0;a[n>>0]=a[n>>0]^a[b+m>>0];m=m+1|0}while((m|0)!=(d|0));m=l}Db(p,o,64,0);l=p+104|0;k=p+136|0;c[k>>2]=0;c[k+4>>2]=0;c[l>>2]=c[18];c[l+4>>2]=c[19];c[l+8>>2]=c[20];c[l+12>>2]=c[21];c[l+16>>2]=c[22];c[l+20>>2]=c[23];c[l+24>>2]=c[24];c[l+28>>2]=c[25];k=o;j=k+64|0;do{a[k>>0]=92;k=k+1|0}while((k|0)<(j|0));if(!m?(a[o>>0]=a[b>>0]^92,(d|0)!=1):0){m=1;do{n=o+m|0;a[n>>0]=a[n>>0]^a[b+m>>0];m=m+1|0}while((m|0)!=(d|0))}Db(l,o,64,0);Db(p,e,f,0);if(!h){i=u;return}j=s+3|0;k=s+2|0;l=s+1|0;d=r+104|0;b=0;m=0;do{m=m+1|0;a[j>>0]=m;a[k>>0]=m>>>8;a[l>>0]=m>>>16;a[s>>0]=m>>>24;Kd(r|0,p|0,208)|0;Db(r,s,4,0);Eb(r,t);Db(d,t,32,0);Eb(d,q);f=h-b|0;Kd(g+b|0,q|0,(f>>>0>32?32:f)|0)|0;b=m<<5}while(b>>>0<h>>>0);i=u;return}function _b(){return 32}function $b(){return 102}function ac(){return 32984}function bc(){return 524288}function cc(){return 16777216}function dc(){return 33554432}function ec(){return 1073741824}function fc(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;o=i;n=i=i+63&-64;i=i+16|0;Hd(a|0,0,b|0)|0;m=g|d;if(m>>>0>0|(m|0)==0&(f|b)>>>0>4294967295){if(!(c[7979]|0))k=32460;else k=c[(oa()|0)+60>>2]|0;c[k>>2]=27;n=-1;i=o;return n|0}d=k>>>0<0|(k|0)==0&j>>>0<32768;m=d?32768:j;k=d?0:k;a:do if(k>>>0<0|(k|0)==0&m>>>0<l>>>5>>>0){k=Id(m|0,k|0,6)|0;g=C;d=1;while(1){m=Jd(1,0,d|0)|0;l=C;j=d+1|0;if(l>>>0>g>>>0|(l|0)==(g|0)&m>>>0>k>>>0){j=d;k=1;break a}if(j>>>0<63)d=j;else{k=1;break}}}else{g=l>>>11;j=1;while(1){l=Jd(1,0,j|0)|0;p=C;d=j+1|0;if(p>>>0>0|(p|0)==0&l>>>0>g>>>0)break;if(d>>>0<63)j=d;else{j=d;break}}k=Id(m|0,k|0,2)|0;k=Id(k|0,C|0,j|0)|0;p=C;k=p>>>0>0|(p|0)==0&k>>>0>1073741823?134217727:k>>>3}while(0);j=Jd(1,0,j|0)|0;c[n+4>>2]=0;c[n>>2]=0;c[n+8>>2]=0;j=ic(n,e,f,h,32,j,C,8,k,a,b)|0;k=c[n>>2]|0;if(k)rd(k);p=j;i=o;return p|0}function gc(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=i;v=i=i+63&-64;i=i+112|0;t=v+16|0;u=v+48|0;n=b;m=n+102|0;do{a[n>>0]=0;n=n+1|0}while((n|0)<(m|0));if(g>>>0>0|(g|0)==0&f>>>0>4294967295){if(!(c[7979]|0))l=32460;else l=c[(oa()|0)+60>>2]|0;c[l>>2]=27;v=-1;i=w;return v|0}m=j>>>0<0|(j|0)==0&h>>>0<32768;l=m?32768:h;m=m?0:j;a:do if(m>>>0<0|(m|0)==0&l>>>0<k>>>5>>>0){m=Id(l|0,m|0,6)|0;j=C;h=1;while(1){k=Jd(1,0,h|0)|0;g=C;n=h+1|0;if(g>>>0>j>>>0|(g|0)==(j|0)&k>>>0>m>>>0){n=h;m=1;break a}if(n>>>0<63)h=n;else{m=1;break}}}else{h=k>>>11;n=1;while(1){k=Jd(1,0,n|0)|0;j=C;g=n+1|0;if(j>>>0>0|(j|0)==0&k>>>0>h>>>0)break;if(g>>>0<63)n=g;else{n=g;break}}m=Id(l|0,m|0,2)|0;m=Id(m|0,C|0,n|0)|0;k=C;m=k>>>0>0|(k|0)==0&m>>>0>1073741823?134217727:m>>>3}while(0);j=0;do{a[t+j>>0]=Ba(0)|0;j=j+1|0}while((j|0)!=32);b:do if((((((((n>>>0<=63?(k=Jd(m|0,0,3)|0,g=C,!(g>>>0>0|(g|0)==0&k>>>0>1073741823)):0)?(a[u>>0]=36,a[u+1>>0]=55,a[u+2>>0]=36,a[u+3>>0]=a[34875+n>>0]|0,a[u+4>>0]=54,k=u+5|0,p=u+9|0,a[k>>0]=46,a[k+1>>0]=46,a[k+2>>0]=46,a[k+3>>0]=46,(p|0)!=0):0)?(o=p,r=u+58|0,(r|0)!=(o|0)):0)?(q=r-o|0,a[p>>0]=a[34875+(m&63)>>0]|0,(q|0)!=1):0)?(a[u+10>>0]=a[34875+(m>>>6&63)>>0]|0,(q|0)!=2):0)?(a[u+11>>0]=a[34875+(m>>>12&63)>>0]|0,(q|0)!=3):0)?(a[u+12>>0]=a[34875+(m>>>18&63)>>0]|0,(q|0)!=4):0)?(s=u+14|0,a[u+13>>0]=a[34875+(m>>>24&63)>>0]|0,(s|0)!=0):0){p=s;k=r-s|0;o=0;while(1){j=o+1|0;j=o-(j>>>0<32?32:j)|0;j=j>>>0>4294967293?j:-3;n=0;m=o;o=o-j|0;l=0;while(1){s=m;m=m+1|0;l=(d[t+s>>0]|0)<<n|l;if((m|0)==(o|0))break;else n=n+8|0}g=_(j,-8)|0;if(!g)n=p;else{m=k;j=p;h=0;while(1){if(!m)break b;n=j+1|0;a[j>>0]=a[34875+(l&63)>>0]|0;h=h+6|0;if(h>>>0>=g>>>0)break;else{l=l>>>6;m=m+-1|0;j=n}}}if(!n)break b;k=p+k-n|0;if(o>>>0>=32)break;else p=n}if(n>>>0<(u+58|0)>>>0){a[n>>0]=0;m=v+4|0;c[m>>2]=0;c[v>>2]=0;n=v+8|0;c[n>>2]=0;l=(Wb(v,e,f,u,b)|0)==0;j=c[v>>2]|0;if(j)rd(j);c[m>>2]=0;c[v>>2]=0;c[n>>2]=0;if(!l){v=0;i=w;return v|0}if(!(c[7979]|0))l=32460;else l=c[(oa()|0)+60>>2]|0;c[l>>2]=22;v=-1;i=w;return v|0}}while(0);if(!(c[7979]|0))l=32460;else l=c[(oa()|0)+60>>2]|0;c[l>>2]=22;v=-1;i=w;return v|0}function hc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;m=i;l=i=i+63&-64;i=i+128|0;g=l+12|0;a:do if(b&3){h=102;f=b;do{if(!(a[f>>0]|0)){k=5;break a}f=f+1|0;h=h+-1|0;j=(h|0)!=0}while(j&(f&3|0)!=0);if(j)k=5;else h=0}else{h=102;f=b;k=5}while(0);b:do if((k|0)==5)if(a[f>>0]|0){c:do if(h>>>0>3)while(1){j=c[f>>2]|0;if((j&-2139062144^-2139062144)&j+-16843009)break;f=f+4|0;h=h+-4|0;if(h>>>0<=3){k=10;break c}}else k=10;while(0);if((k|0)==10)if(!h){h=0;break}while(1){if(!(a[f>>0]|0))break b;f=f+1|0;h=h+-1|0;if(!h){h=0;break}}}while(0);if((((h|0)!=0?f:0)|0)!=(b+101|0)){b=-1;i=m;return b|0}j=l+4|0;c[j>>2]=0;c[l>>2]=0;k=l+8|0;c[k>>2]=0;h=(Wb(l,d,e,b,g)|0)==0;f=c[l>>2]|0;if(f)rd(f);c[j>>2]=0;c[l>>2]=0;c[k>>2]=0;if(h){b=-1;i=m;return b|0}else{h=0;f=0}do{h=a[b+f>>0]^a[g+f>>0]|h;f=f+1|0}while((f|0)!=102);h=(((h&255)+511|0)>>>8&1)+-1|0;f=g+102|0;do{a[g>>0]=0;g=g+1|0}while((g|0)<(f|0));b=h;i=m;return b|0}function ic(b,e,f,g,h,i,j,k,l,m,n){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=Qd(l|0,0,k|0,0)|0;I=C;if(I>>>0>0|(I|0)==0&J>>>0>1073741823){if(!(c[7979]|0))o=32460;else o=c[(oa()|0)+60>>2]|0;c[o>>2]=27;f=-1;return f|0}if(j>>>0>0|(j|0)==0&i>>>0>4294967295){if(!(c[7979]|0))o=32460;else o=c[(oa()|0)+60>>2]|0;c[o>>2]=27;f=-1;return f|0}H=Fd(i|0,j|0,-1,-1)|0;I=C;if(j>>>0<0|(j|0)==0&i>>>0<2|((H&i|0)!=0|(I&j|0)!=0)){if(!(c[7979]|0))o=32460;else o=c[(oa()|0)+60>>2]|0;c[o>>2]=22;f=-1;return f|0}if((k|0)==0|(l|0)==0){if(!(c[7979]|0))o=32460;else o=c[(oa()|0)+60>>2]|0;c[o>>2]=22;f=-1;return f|0}if(!(k>>>0>16777215?1:(33554431/(l>>>0)|0)>>>0<k>>>0)?!(0<j>>>0|(0==(j|0)?(33554431/(k>>>0)|0)>>>0<i>>>0:0)):0){E=k<<7;J=_(E,l)|0;G=Qd(E|0,0,i|0,j|0)|0;y=G+J|0;if(y>>>0<G>>>0){if(!(c[7979]|0))o=32460;else o=c[(oa()|0)+60>>2]|0;c[o>>2]=12;f=-1;return f|0}G=k<<8|64;w=y+G|0;if(w>>>0<G>>>0){if(!(c[7979]|0))o=32460;else o=c[(oa()|0)+60>>2]|0;c[o>>2]=12;f=-1;return f|0}x=b+8|0;do if((c[x>>2]|0)>>>0<w>>>0){o=c[b>>2]|0;if(o)rd(o);v=b+4|0;c[v>>2]=0;c[b>>2]=0;c[x>>2]=0;do if(w>>>0<=4294967168){if(w>>>0>=4294967168){if(!(c[7979]|0))o=32460;else o=c[(oa()|0)+60>>2]|0;c[o>>2]=12;q=12;o=0;break}t=w>>>0<11?16:w|8;q=qd(t+76|0)|0;if(q){r=q+-8|0;do if(q&63){o=q+63&-64;G=o+-8|0;s=r;o=(G-s|0)>>>0>15?G:o+56|0;s=o-s|0;q=q+-4|0;G=c[q>>2]|0;p=(G&-8)-s|0;if(!(G&3)){c[o>>2]=(c[r>>2]|0)+s;c[o+4>>2]=p;break}else{G=o+4|0;c[G>>2]=p|c[G>>2]&1|2;F=o+(p+4)|0;c[F>>2]=c[F>>2]|1;c[q>>2]=s|c[q>>2]&1|2;c[G>>2]=c[G>>2]|1;Ad(r,s);break}}else o=r;while(0);q=o+4|0;p=c[q>>2]|0;if((p&3|0)!=0?(u=p&-8,u>>>0>(t+16|0)>>>0):0){G=u-t|0;c[q>>2]=t|p&1|2;c[o+(t|4)>>2]=G|3;F=o+(u|4)|0;c[F>>2]=c[F>>2]|1;Ad(o+t|0,G)}q=0;o=o+8|0}else{q=12;o=0}}else{q=12;o=0}while(0);if(!(c[7979]|0))p=32460;else p=c[(oa()|0)+60>>2]|0;c[p>>2]=q;if(!q){c[b>>2]=o;c[v>>2]=o;c[x>>2]=(o|0)!=0?w:0;if(!o)o=-1;else break;return o|0}else{c[b>>2]=0;c[v>>2]=0;c[x>>2]=0;f=-1;return f|0}}else o=c[b+4>>2]|0;while(0);G=o+J|0;F=o+y|0;Zb(e,f,g,h,o,J);v=k<<5;q=F+(v<<2)|0;p=F+(k<<6<<2)|0;z=(v|0)==0;A=(i|0)==0&(j|0)==0;B=v&1073741792;D=(B|0)==0;g=E+-64|0;h=F+g|0;g=q+g|0;y=g+4|0;b=h+4|0;w=0;do{x=_(w<<7,k)|0;if(!z){s=0;do{E=s<<2;c[F+(s<<2)>>2]=(d[o+((E|1)+x)>>0]|0)<<8|(d[o+(E+x)>>0]|0)|(d[o+((E|2)+x)>>0]|0)<<16|(d[o+((E|3)+x)>>0]|0)<<24;s=s+1|0}while((s|0)!=(v|0))}a:do if(!A){if(D){s=0;r=0;do{jc(F,q,p,k);jc(q,F,p,k);s=Fd(s|0,r|0,2,0)|0;r=C}while(r>>>0<j>>>0|(r|0)==(j|0)&s>>>0<i>>>0)}else{s=0;r=0;do{u=Qd(s|0,r|0,v|0,0)|0;t=0;do{c[G+(t+u<<2)>>2]=c[F+(t<<2)>>2];t=t+1|0}while((t|0)!=(B|0));jc(F,q,p,k);u=Qd(s|1|0,r|0,v|0,0)|0;t=0;do{c[G+(t+u<<2)>>2]=c[F+(t+v<<2)>>2];t=t+1|0}while((t|0)!=(B|0));jc(q,F,p,k);s=Fd(s|0,r|0,2,0)|0;r=C}while(r>>>0<j>>>0|(r|0)==(j|0)&s>>>0<i>>>0)}if(D){s=0;r=0;while(1){jc(F,q,p,k);jc(q,F,p,k);s=Fd(s|0,r|0,2,0)|0;r=C;if(!(r>>>0<j>>>0|(r|0)==(j|0)&s>>>0<i>>>0))break a}}else{s=0;r=0}do{u=Qd(c[h>>2]&H|0,c[b>>2]&I|0,v|0,0)|0;t=0;do{E=F+(t<<2)|0;c[E>>2]=c[E>>2]^c[G+(t+u<<2)>>2];t=t+1|0}while((t|0)!=(B|0));jc(F,q,p,k);u=Qd(c[g>>2]&H|0,c[y>>2]&I|0,v|0,0)|0;t=0;do{E=F+(t+v<<2)|0;c[E>>2]=c[E>>2]^c[G+(t+u<<2)>>2];t=t+1|0}while((t|0)!=(B|0));jc(q,F,p,k);s=Fd(s|0,r|0,2,0)|0;r=C}while(r>>>0<j>>>0|(r|0)==(j|0)&s>>>0<i>>>0)}while(0);if(!z){s=0;do{E=s<<2;u=c[F+(s<<2)>>2]|0;a[o+(E+x)>>0]=u;a[o+((E|1)+x)>>0]=u>>>8;a[o+((E|2)+x)>>0]=u>>>16;a[o+((E|3)+x)>>0]=u>>>24;s=s+1|0}while((s|0)!=(v|0))}w=w+1|0}while((w|0)!=(l|0));Zb(e,f,o,J,m,n);f=0;return f|0}if(!(c[7979]|0))o=32460;else o=c[(oa()|0)+60>>2]|0;c[o>>2]=12;f=-1;return f|0}function jc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;w=e<<1;m=e<<5;o=c[a+(m+-16<<2)>>2]|0;c[d>>2]=o;q=c[a+(m+-15<<2)>>2]|0;L=d+4|0;c[L>>2]=q;t=c[a+(m+-14<<2)>>2]|0;x=d+8|0;c[x>>2]=t;u=c[a+(m+-13<<2)>>2]|0;y=d+12|0;c[y>>2]=u;s=c[a+(m+-12<<2)>>2]|0;z=d+16|0;c[z>>2]=s;r=c[a+(m+-11<<2)>>2]|0;A=d+20|0;c[A>>2]=r;p=c[a+(m+-10<<2)>>2]|0;B=d+24|0;c[B>>2]=p;n=c[a+(m+-9<<2)>>2]|0;C=d+28|0;c[C>>2]=n;l=c[a+(m+-8<<2)>>2]|0;D=d+32|0;c[D>>2]=l;j=c[a+(m+-7<<2)>>2]|0;E=d+36|0;c[E>>2]=j;h=c[a+(m+-6<<2)>>2]|0;F=d+40|0;c[F>>2]=h;f=c[a+(m+-5<<2)>>2]|0;G=d+44|0;c[G>>2]=f;g=c[a+(m+-4<<2)>>2]|0;H=d+48|0;c[H>>2]=g;i=c[a+(m+-3<<2)>>2]|0;I=d+52|0;c[I>>2]=i;k=c[a+(m+-2<<2)>>2]|0;J=d+56|0;c[J>>2]=k;m=c[a+(m+-1<<2)>>2]|0;K=d+60|0;c[K>>2]=m;if(!w)return;v=e<<4;e=0;while(1){M=e<<4;c[d>>2]=o^c[a+(M<<2)>>2];c[L>>2]=q^c[a+((M|1)<<2)>>2];c[x>>2]=t^c[a+((M|2)<<2)>>2];c[y>>2]=u^c[a+((M|3)<<2)>>2];c[z>>2]=s^c[a+((M|4)<<2)>>2];c[A>>2]=r^c[a+((M|5)<<2)>>2];c[B>>2]=p^c[a+((M|6)<<2)>>2];c[C>>2]=n^c[a+((M|7)<<2)>>2];c[D>>2]=l^c[a+((M|8)<<2)>>2];c[E>>2]=j^c[a+((M|9)<<2)>>2];c[F>>2]=h^c[a+((M|10)<<2)>>2];c[G>>2]=f^c[a+((M|11)<<2)>>2];c[H>>2]=g^c[a+((M|12)<<2)>>2];c[I>>2]=i^c[a+((M|13)<<2)>>2];c[J>>2]=k^c[a+((M|14)<<2)>>2];c[K>>2]=m^c[a+((M|15)<<2)>>2];kc(d);u=e<<3;c[b+(u<<2)>>2]=c[d>>2];c[b+((u|1)<<2)>>2]=c[L>>2];c[b+((u|2)<<2)>>2]=c[x>>2];c[b+((u|3)<<2)>>2]=c[y>>2];c[b+((u|4)<<2)>>2]=c[z>>2];c[b+((u|5)<<2)>>2]=c[A>>2];c[b+((u|6)<<2)>>2]=c[B>>2];c[b+((u|7)<<2)>>2]=c[C>>2];c[b+((u|8)<<2)>>2]=c[D>>2];c[b+((u|9)<<2)>>2]=c[E>>2];c[b+((u|10)<<2)>>2]=c[F>>2];c[b+((u|11)<<2)>>2]=c[G>>2];c[b+((u|12)<<2)>>2]=c[H>>2];c[b+((u|13)<<2)>>2]=c[I>>2];c[b+((u|14)<<2)>>2]=c[J>>2];c[b+((u|15)<<2)>>2]=c[K>>2];c[d>>2]=c[d>>2]^c[a+((M|16)<<2)>>2];c[L>>2]=c[L>>2]^c[a+((M|17)<<2)>>2];c[x>>2]=c[x>>2]^c[a+((M|18)<<2)>>2];c[y>>2]=c[y>>2]^c[a+((M|19)<<2)>>2];c[z>>2]=c[z>>2]^c[a+((M|20)<<2)>>2];c[A>>2]=c[A>>2]^c[a+((M|21)<<2)>>2];c[B>>2]=c[B>>2]^c[a+((M|22)<<2)>>2];c[C>>2]=c[C>>2]^c[a+((M|23)<<2)>>2];c[D>>2]=c[D>>2]^c[a+((M|24)<<2)>>2];c[E>>2]=c[E>>2]^c[a+((M|25)<<2)>>2];c[F>>2]=c[F>>2]^c[a+((M|26)<<2)>>2];c[G>>2]=c[G>>2]^c[a+((M|27)<<2)>>2];c[H>>2]=c[H>>2]^c[a+((M|28)<<2)>>2];c[I>>2]=c[I>>2]^c[a+((M|29)<<2)>>2];c[J>>2]=c[J>>2]^c[a+((M|30)<<2)>>2];c[K>>2]=c[K>>2]^c[a+((M|31)<<2)>>2];kc(d);u=u+v|0;c[b+(u<<2)>>2]=c[d>>2];c[b+((u|1)<<2)>>2]=c[L>>2];c[b+((u|2)<<2)>>2]=c[x>>2];c[b+((u|3)<<2)>>2]=c[y>>2];c[b+((u|4)<<2)>>2]=c[z>>2];c[b+((u|5)<<2)>>2]=c[A>>2];c[b+((u|6)<<2)>>2]=c[B>>2];c[b+((u|7)<<2)>>2]=c[C>>2];c[b+((u|8)<<2)>>2]=c[D>>2];c[b+((u|9)<<2)>>2]=c[E>>2];c[b+((u|10)<<2)>>2]=c[F>>2];c[b+((u|11)<<2)>>2]=c[G>>2];c[b+((u|12)<<2)>>2]=c[H>>2];c[b+((u|13)<<2)>>2]=c[I>>2];c[b+((u|14)<<2)>>2]=c[J>>2];c[b+((u|15)<<2)>>2]=c[K>>2];e=e+2|0;if(e>>>0>=w>>>0)break;f=c[G>>2]|0;g=c[H>>2]|0;i=c[I>>2]|0;k=c[J>>2]|0;m=c[K>>2]|0;o=c[d>>2]|0;q=c[L>>2]|0;t=c[x>>2]|0;u=c[y>>2]|0;s=c[z>>2]|0;r=c[A>>2]|0;p=c[B>>2]|0;n=c[C>>2]|0;l=c[D>>2]|0;j=c[E>>2]|0;h=c[F>>2]|0}return}function kc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;b=a+4|0;z=a+8|0;A=a+12|0;B=a+16|0;F=a+20|0;f=a+24|0;k=a+28|0;n=a+32|0;s=a+36|0;t=a+40|0;u=a+44|0;v=a+48|0;w=a+52|0;x=a+56|0;y=a+60|0;d=c[b>>2]|0;e=c[F>>2]|0;g=c[s>>2]|0;h=c[w>>2]|0;i=c[f>>2]|0;j=c[t>>2]|0;l=c[x>>2]|0;m=c[z>>2]|0;o=c[u>>2]|0;p=c[y>>2]|0;q=c[A>>2]|0;r=c[k>>2]|0;C=c[v>>2]|0;D=c[a>>2]|0;E=c[B>>2]|0;G=c[n>>2]|0;H=0;do{R=C+D|0;R=(R<<7|R>>>25)^E;O=R+D|0;O=(O<<9|O>>>23)^G;L=O+R|0;L=(L<<13|L>>>19)^C;U=L+O|0;U=(U<<18|U>>>14)^D;N=d+e|0;N=(N<<7|N>>>25)^g;K=N+e|0;K=(K<<9|K>>>23)^h;X=K+N|0;X=(X<<13|X>>>19)^d;Q=X+K|0;Q=(Q<<18|Q>>>14)^e;J=i+j|0;J=(J<<7|J>>>25)^l;W=J+j|0;W=(W<<9|W>>>23)^m;T=W+J|0;T=(T<<13|T>>>19)^i;M=T+W|0;M=(M<<18|M>>>14)^j;V=o+p|0;V=(V<<7|V>>>25)^q;S=V+p|0;S=(S<<9|S>>>23)^r;P=S+V|0;P=(P<<13|P>>>19)^o;I=P+S|0;I=(I<<18|I>>>14)^p;Y=V+U|0;d=(Y<<7|Y>>>25)^X;X=d+U|0;m=(X<<9|X>>>23)^W;W=m+d|0;q=(W<<13|W>>>19)^V;V=q+m|0;D=(V<<18|V>>>14)^U;U=R+Q|0;i=(U<<7|U>>>25)^T;T=i+Q|0;r=(T<<9|T>>>23)^S;S=r+i|0;E=(S<<13|S>>>19)^R;R=E+r|0;e=(R<<18|R>>>14)^Q;Q=N+M|0;o=(Q<<7|Q>>>25)^P;P=o+M|0;G=(P<<9|P>>>23)^O;O=G+o|0;g=(O<<13|O>>>19)^N;N=g+G|0;j=(N<<18|N>>>14)^M;M=J+I|0;C=(M<<7|M>>>25)^L;L=C+I|0;h=(L<<9|L>>>23)^K;K=h+C|0;l=(K<<13|K>>>19)^J;J=l+h|0;p=(J<<18|J>>>14)^I;H=H+2|0}while(H>>>0<8);c[a>>2]=(c[a>>2]|0)+D;c[b>>2]=(c[b>>2]|0)+d;c[z>>2]=(c[z>>2]|0)+m;c[A>>2]=(c[A>>2]|0)+q;c[B>>2]=(c[B>>2]|0)+E;c[F>>2]=(c[F>>2]|0)+e;c[f>>2]=(c[f>>2]|0)+i;c[k>>2]=(c[k>>2]|0)+r;c[n>>2]=(c[n>>2]|0)+G;c[s>>2]=(c[s>>2]|0)+g;c[t>>2]=(c[t>>2]|0)+j;c[u>>2]=(c[u>>2]|0)+o;c[v>>2]=(c[v>>2]|0)+C;c[w>>2]=(c[w>>2]|0)+h;c[x>>2]=(c[x>>2]|0)+l;c[y>>2]=(c[y>>2]|0)+p;return}function lc(){return 32}function mc(){return 32}function nc(a,b){a=a|0;b=b|0;od(a,b,33779);return 0}function oc(a,b,c){a=a|0;b=b|0;c=c|0;od(a,b,c);return 0}function pc(){return 32}function qc(){return 24}function rc(){return 16}function sc(b,c,d,e,f,g,h){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;r=i;q=i=i+63&-64;i=i+240|0;p=q;o=q+176|0;q=q+144|0;nb(q,g,h,32988);h=b;j=d;if(b>>>0>=d>>>0?0<f>>>0|0==(f|0)&(h-j|0)>>>0<e>>>0:0)k=5;else if(d>>>0>=b>>>0?0<f>>>0|0==(f|0)&(j-h|0)>>>0<e>>>0:0)k=5;if((k|0)==5){Ld(b|0,d|0,e|0)|0;d=b}j=o;h=j+32|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(h|0));l=f>>>0>0|(f|0)==0&e>>>0>32;m=l?32:e;n=l?0:f;j=o+32|0;if(!((m|0)==0&(n|0)==0)){h=~f;k=Fd(e|0,f|0,-1,0)|0;Kd(j|0,d|0,(h>>>0>4294967295|(h|0)==-1&(e^-32)>>>0>4294967263?k+1|0:32)|0)|0}h=Fd(m|0,n|0,32,0)|0;k=g+16|0;pd(o,o,h,C,k,0,0,q);Sb(p,o);Kd(b|0,j|0,m|0)|0;j=o;h=j+64|0;do{a[j>>0]=0;j=j+1|0}while((j|0)<(h|0));if(!l){Tb(p,b,e,f);Ub(p,c);i=r;return 0}o=Ed(e|0,f|0,m|0,n|0)|0;pd(b+m|0,d+m|0,o,C,k,1,0,q);Tb(p,b,e,f);Ub(p,c);i=r;return 0}function tc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(d>>>0>0|(d|0)==0&c>>>0>4294967279){e=-1;return e|0}sc(a+16|0,a,b,c,d,e,f)|0;e=0;return e|0}function uc(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;t=i;s=i=i+63&-64;i=i+208|0;l=s;o=s+144|0;n=s+112|0;r=s+48|0;s=s+16|0;nb(s,j,k,32988);q=j+16|0;k=n;j=s;m=k+32|0;do{a[k>>0]=a[j>>0]|0;k=k+1|0;j=j+1|0}while((k|0)<(m|0));j=q;m=j;j=j+4|0;j=d[j>>0]|d[j+1>>0]<<8|d[j+2>>0]<<16|d[j+3>>0]<<24;k=l;c[k>>2]=d[m>>0]|d[m+1>>0]<<8|d[m+2>>0]<<16|d[m+3>>0]<<24;c[k+4>>2]=j;k=l+8|0;c[k>>2]=0;c[k+4>>2]=0;ob(o,l,n,33811);k=0;do{a[r+k>>0]=a[o+k>>0]|0;k=k+1|0}while((k|0)!=32);if(Rb(f,e,g,h,r)|0){k=s;m=k+32|0;do{a[k>>0]=0;k=k+1|0}while((k|0)<(m|0));s=-1;i=t;return s|0}l=e;m=b;if(e>>>0>=b>>>0?0<h>>>0|0==(h|0)&(l-m|0)>>>0<g>>>0:0)p=9;else if(b>>>0>=e>>>0?0<h>>>0|0==(h|0)&(m-l|0)>>>0<g>>>0:0)p=9;if((p|0)==9){Ld(b|0,e|0,g|0)|0;e=b}m=h>>>0>0|(h|0)==0&g>>>0>32;l=m?32:g;j=m?0:h;k=r+32|0;Kd(k|0,e|0,l|0)|0;p=Fd(l|0,j|0,32,0)|0;pd(r,r,p,C,q,0,0,s);if(!((l|0)==0&(j|0)==0)){p=~h;r=Fd(g|0,h|0,-1,0)|0;Kd(b|0,k|0,(p>>>0>4294967295|(p|0)==-1&(g^-32)>>>0>4294967263?r+1|0:32)|0)|0}if(m){r=Ed(g|0,h|0,l|0,j|0)|0;pd(b+l|0,e+l|0,r,C,q,1,0,s)}k=s;m=k+32|0;do{a[k>>0]=0;k=k+1|0}while((k|0)<(m|0));s=0;i=t;return s|0}function vc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(d>>>0<0|(d|0)==0&c>>>0<16){e=-1;return e|0}d=Fd(c|0,d|0,-16,-1)|0;e=uc(a,b+16|0,b,d,C,e,f)|0;return e|0}function wc(){return 8}function xc(){return 16}function yc(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=d[g>>0]|0;o=Jd(d[g+1>>0]|0|0,0,8)|0;n=C;j=Jd(d[g+2>>0]|0|0,0,16)|0;n=n|C;k=Jd(d[g+3>>0]|0|0,0,24)|0;n=n|C|(d[g+4>>0]|0);r=Jd(d[g+5>>0]|0|0,0,40)|0;n=n|C;i=Jd(d[g+6>>0]|0|0,0,48)|0;n=n|C;l=Jd(d[g+7>>0]|0|0,0,56)|0;l=o|h|j|k|r|i|l;n=n|C;i=d[g+8>>0]|0;r=Jd(d[g+9>>0]|0|0,0,8)|0;k=C;j=Jd(d[g+10>>0]|0|0,0,16)|0;k=k|C;h=Jd(d[g+11>>0]|0|0,0,24)|0;k=k|C|(d[g+12>>0]|0);o=Jd(d[g+13>>0]|0|0,0,40)|0;k=k|C;p=Jd(d[g+14>>0]|0|0,0,48)|0;k=k|C;m=Jd(d[g+15>>0]|0|0,0,56)|0;m=r|i|j|h|o|p|m;k=k|C;p=e&7;o=c+(e-p)|0;e=Jd(e|0,f|0,56)|0;f=C;h=m^2037671283;j=k^1952801890;i=l^1852142177;g=n^1819895653;m=m^1852075885;k=k^1685025377;l=l^1886610805;n=n^1936682341;if((o|0)!=(c|0)){do{x=d[c>>0]|0;y=Jd(d[c+1>>0]|0|0,0,8)|0;r=C;w=Jd(d[c+2>>0]|0|0,0,16)|0;r=r|C;t=Jd(d[c+3>>0]|0|0,0,24)|0;r=r|C|(d[c+4>>0]|0);u=Jd(d[c+5>>0]|0|0,0,40)|0;r=r|C;v=Jd(d[c+6>>0]|0|0,0,48)|0;r=r|C;s=Jd(d[c+7>>0]|0|0,0,56)|0;s=y|x|w|t|u|v|s;r=r|C;v=s^h;u=r^j;n=Fd(l|0,n|0,m|0,k|0)|0;l=C;t=Jd(m|0,k|0,13)|0;h=C;m=Id(m|0,k|0,51)|0;m=(t|m)^n;h=(h|C)^l;g=Fd(v|0,u|0,i|0,g|0)|0;i=C;t=Jd(v|0,u|0,16)|0;j=C;u=Id(v|0,u|0,48)|0;u=(t|u)^g;j=(j|C)^i;n=Fd(u|0,j|0,l|0,n|0)|0;l=C;t=Jd(u|0,j|0,21)|0;k=C;j=Id(u|0,j|0,43)|0;j=(t|j)^n;k=(k|C)^l;i=Fd(g|0,i|0,m|0,h|0)|0;g=C;t=Jd(m|0,h|0,17)|0;u=C;h=Id(m|0,h|0,47)|0;h=i^(t|h);u=g^(u|C);l=Fd(n|0,l|0,h|0,u|0)|0;n=C;t=Jd(h|0,u|0,13)|0;m=C;u=Id(h|0,u|0,51)|0;u=(t|u)^l;m=(m|C)^n;i=Fd(j|0,k|0,g|0,i|0)|0;g=C;t=Jd(j|0,k|0,16)|0;h=C;k=Id(j|0,k|0,48)|0;k=(t|k)^i;h=(h|C)^g;l=Fd(k|0,h|0,n|0,l|0)|0;n=C;t=Jd(k|0,h|0,21)|0;j=C;h=Id(k|0,h|0,43)|0;h=(t|h)^l;j=(j|C)^n;g=Fd(i|0,g|0,u|0,m|0)|0;i=C;t=Jd(u|0,m|0,17)|0;k=C;m=Id(u|0,m|0,47)|0;m=(t|m)^g;k=(k|C)^i;l=l^s;n=n^r;c=c+8|0}while((c|0)!=(o|0));c=o}switch(p|0){case 7:{e=Jd(d[c+6>>0]|0|0,0,48)|0|e;f=C|f;q=5;break}case 6:{q=5;break}case 5:{q=6;break}case 4:{q=7;break}case 3:{q=8;break}case 2:{q=9;break}case 1:{q=10;break}default:{}}if((q|0)==5){y=Jd(d[c+5>>0]|0|0,0,40)|0;f=C|f;e=y|e;q=6}if((q|0)==6){f=d[c+4>>0]|0|f;q=7}if((q|0)==7){y=Jd(d[c+3>>0]|0|0,0,24)|0;e=y|e;f=C|f;q=8}if((q|0)==8){y=Jd(d[c+2>>0]|0|0,0,16)|0;e=y|e;f=C|f;q=9}if((q|0)==9){y=Jd(d[c+1>>0]|0|0,0,8)|0;e=y|e;f=C|f;q=10}if((q|0)==10)e=d[c>>0]|0|e;y=e^h;r=f^j;s=Fd(l|0,n|0,m|0,k|0)|0;q=C;w=Jd(m|0,k|0,13)|0;t=C;x=Id(m|0,k|0,51)|0;x=(w|x)^s;t=(t|C)^q;w=Fd(y|0,r|0,i|0,g|0)|0;v=C;u=Jd(y|0,r|0,16)|0;p=C;r=Id(y|0,r|0,48)|0;r=(u|r)^w;p=(p|C)^v;s=Fd(r|0,p|0,q|0,s|0)|0;q=C;u=Jd(r|0,p|0,21)|0;y=C;p=Id(r|0,p|0,43)|0;p=(u|p)^s;y=(y|C)^q;v=Fd(w|0,v|0,x|0,t|0)|0;w=C;u=Jd(x|0,t|0,17)|0;r=C;t=Id(x|0,t|0,47)|0;t=v^(u|t);r=w^(r|C);q=Fd(s|0,q|0,t|0,r|0)|0;s=C;u=Jd(t|0,r|0,13)|0;x=C;r=Id(t|0,r|0,51)|0;r=(u|r)^q;x=(x|C)^s;v=Fd(p|0,y|0,w|0,v|0)|0;w=C;u=Jd(p|0,y|0,16)|0;t=C;y=Id(p|0,y|0,48)|0;y=(u|y)^v;t=(t|C)^w;q=Fd(y|0,t|0,s|0,q|0)|0;s=C;u=Jd(y|0,t|0,21)|0;p=C;t=Id(y|0,t|0,43)|0;t=(u|t)^q;p=(p|C)^s;w=Fd(v|0,w|0,r|0,x|0)|0;v=C;u=Jd(r|0,x|0,17)|0;y=C;x=Id(r|0,x|0,47)|0;x=(u|x)^w;y=(y|C)^v;s=Fd(q^e|0,s^f|0,x|0,y|0)|0;q=C;u=Jd(x|0,y|0,13)|0;r=C;y=Id(x|0,y|0,51)|0;y=s^(u|y);r=q^(r|C);w=Fd(t|0,p|0,v^255|0,w|0)|0;v=C;u=Jd(t|0,p|0,16)|0;x=C;p=Id(t|0,p|0,48)|0;p=(u|p)^w;x=(x|C)^v;s=Fd(p|0,x|0,q|0,s|0)|0;q=C;u=Jd(p|0,x|0,21)|0;t=C;x=Id(p|0,x|0,43)|0;x=(u|x)^s;t=(t|C)^q;v=Fd(w|0,v|0,y|0,r|0)|0;w=C;u=Jd(y|0,r|0,17)|0;p=C;r=Id(y|0,r|0,47)|0;r=(u|r)^v;p=(p|C)^w;q=Fd(s|0,q|0,r|0,p|0)|0;s=C;u=Jd(r|0,p|0,13)|0;y=C;p=Id(r|0,p|0,51)|0;p=(u|p)^q;y=(y|C)^s;v=Fd(x|0,t|0,w|0,v|0)|0;w=C;u=Jd(x|0,t|0,16)|0;r=C;t=Id(x|0,t|0,48)|0;t=(u|t)^v;r=(r|C)^w;q=Fd(t|0,r|0,s|0,q|0)|0;s=C;u=Jd(t|0,r|0,21)|0;x=C;r=Id(t|0,r|0,43)|0;r=(u|r)^q;x=(x|C)^s;w=Fd(v|0,w|0,p|0,y|0)|0;v=C;u=Jd(p|0,y|0,17)|0;t=C;y=Id(p|0,y|0,47)|0;y=(u|y)^w;t=(t|C)^v;s=Fd(q|0,s|0,y|0,t|0)|0;q=C;u=Jd(y|0,t|0,13)|0;p=C;t=Id(y|0,t|0,51)|0;t=(u|t)^s;p=(p|C)^q;w=Fd(r|0,x|0,v|0,w|0)|0;v=C;u=Jd(r|0,x|0,16)|0;y=C;x=Id(r|0,x|0,48)|0;x=(u|x)^w;y=(y|C)^v;s=Fd(x|0,y|0,q|0,s|0)|0;q=C;u=Jd(x|0,y|0,21)|0;r=C;y=Id(x|0,y|0,43)|0;y=(u|y)^s;r=(r|C)^q;v=Fd(w|0,v|0,t|0,p|0)|0;w=C;u=Jd(t|0,p|0,17)|0;x=C;p=Id(t|0,p|0,47)|0;p=(u|p)^v;x=(x|C)^w;q=Fd(s|0,q|0,p|0,x|0)|0;s=C;u=Jd(p|0,x|0,13)|0;t=C;x=Id(p|0,x|0,51)|0;q=(u|x)^q;s=(t|C)^s;v=Fd(y|0,r|0,w|0,v|0)|0;w=C;t=Jd(y|0,r|0,16)|0;x=C;r=Id(y|0,r|0,48)|0;r=(t|r)^v;x=(x|C)^w;t=Jd(r|0,x|0,21)|0;y=C;x=Id(r|0,x|0,43)|0;y=y|C;w=Fd(v|0,w|0,q|0,s|0)|0;v=C;r=Jd(q|0,s|0,17)|0;u=C;s=Id(q|0,s|0,47)|0;x=(r|s)^w^v^(t|x);y=(u|C)^v^w^y;a[b>>0]=x;a[b+1>>0]=x>>>8;a[b+2>>0]=x>>>16;a[b+3>>0]=x>>>24;a[b+4>>0]=y;w=Id(x|0,y|0,40)|0;a[b+5>>0]=w;w=Id(x|0,y|0,48)|0;a[b+6>>0]=w;y=Id(x|0,y|0,56)|0;a[b+7>>0]=y;return 0}function zc(){return 64}function Ac(){return 32}function Bc(){return 32}function Cc(){return 64}function Dc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;n=i;g=i=i+63&-64;i=i+496|0;j=g;h=g+448|0;k=g+408|0;l=g+368|0;g=g+208|0;m=j+64|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;m=j;o=8;p=m+64|0;do{c[m>>2]=c[o>>2];m=m+4|0;o=o+4|0}while((m|0)<(p|0));Gb(j,f,32,0);Hb(j,e);a[e>>0]=(d[e>>0]|0)&248;p=e+31|0;a[p>>0]=(d[p>>0]|0)&63|64;Sc(g,e);Jc(h,g+80|0);Kc(k,g,h);Kc(l,g+40|0,h);Mc(b,l);Mc(j,k);p=b+31|0;a[p>>0]=(d[p>>0]|0)^(d[j>>0]|0)<<7;Ld(e|0,f|0,32)|0;Ld(e+32|0,b|0,32)|0;i=n;return 0}function Ec(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;m=i=i+63&-64;i=i+528|0;l=m;k=m+448|0;n=m+408|0;o=m+368|0;j=m+208|0;m=m+488|0;f=0;do{a[m+f>>0]=Ba(0)|0;f=f+1|0}while((f|0)!=32);f=l+64|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;f=l;g=8;h=f+64|0;do{c[f>>2]=c[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));Gb(l,m,32,0);Hb(l,e);a[e>>0]=(d[e>>0]|0)&248;f=e+31|0;a[f>>0]=(d[f>>0]|0)&63|64;Sc(j,e);Jc(k,j+80|0);Kc(n,j,k);Kc(o,j+40|0,k);Mc(b,o);Mc(l,n);f=b+31|0;a[f>>0]=(d[f>>0]|0)^(d[l>>0]|0)<<7;f=e;g=m;h=f+32|0;do{a[f>>0]=a[g>>0]|0;f=f+1|0;g=g+1|0}while((f|0)<(h|0));Ld(e+32|0,b|0,32)|0;i=p;return 0}function Fc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;h=i;j=i=i+63&-64;i=i+16|0;k=a+64|0;Ld(k|0,d|0,e|0)|0;Yc(a,j,k,e,f,g);g=j;d=(b|0)!=0;if((c[g>>2]|0)==64&(c[g+4>>2]|0)==0){if(!d){k=0;i=h;return k|0}j=Fd(e|0,f|0,64,0)|0;k=b;c[k>>2]=j;c[k+4>>2]=C;k=0;i=h;return k|0}else{if(d){k=b;c[k>>2]=0;c[k+4>>2]=0}k=Fd(e|0,f|0,64,0)|0;Hd(a|0,0,k|0)|0;k=-1;i=h;return k|0}return 0}function Gc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;f=Fd(e|0,f|0,-64,-1)|0;e=C;do if(!(e>>>0>0|(e|0)==0&f>>>0>4294967231)){h=d+64|0;if(Wc(d,h,f,e,g)|0){Hd(a|0,0,f|0)|0;break}if(b){d=b;c[d>>2]=f;c[d+4>>2]=e}Ld(a|0,h|0,f|0)|0;d=0;return d|0}while(0);if(!b){d=-1;return d|0}d=b;c[d>>2]=0;c[d+4>>2]=0;d=-1;return d|0}function Hc(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Yc(a,b,c,d,e,f);return 0}function Ic(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Wc(a,b,c,d,e)|0}function Jc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;g=i;c=i=i+63&-64;i=i+160|0;d=c+120|0;e=c+80|0;f=c+40|0;Lc(d,b);Lc(e,d);Lc(e,e);Kc(e,b,e);Kc(d,d,e);Lc(f,d);Kc(e,e,f);Lc(f,e);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Kc(e,f,e);Lc(f,e);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Kc(f,f,e);Lc(c,f);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Lc(c,c);Kc(f,c,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Lc(f,f);Kc(e,f,e);Lc(f,e);b=1;do{Lc(f,f);b=b+1|0}while((b|0)!=50);Kc(f,f,e);Lc(c,f);b=1;do{Lc(c,c);b=b+1|0}while((b|0)!=100);Kc(f,c,f);Lc(f,f);b=1;do{Lc(f,f);b=b+1|0}while((b|0)!=50);Kc(e,f,e);Lc(e,e);Lc(e,e);Lc(e,e);Lc(e,e);Lc(e,e);Kc(a,e,d);i=g;return}function Kc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0;l=c[b>>2]|0;s=c[b+4>>2]|0;j=c[b+8>>2]|0;Rb=c[b+12>>2]|0;e=c[b+16>>2]|0;za=c[b+20>>2]|0;ya=c[b+24>>2]|0;zb=c[b+28>>2]|0;h=c[b+32>>2]|0;ga=c[b+36>>2]|0;H=c[d>>2]|0;J=c[d+4>>2]|0;F=c[d+8>>2]|0;D=c[d+12>>2]|0;A=c[d+16>>2]|0;y=c[d+20>>2]|0;w=c[d+24>>2]|0;u=c[d+28>>2]|0;k=c[d+32>>2]|0;t=c[d+36>>2]|0;Oc=J*19|0;bc=F*19|0;rb=D*19|0;Ha=A*19|0;jc=y*19|0;Db=w*19|0;Ta=u*19|0;Sc=k*19|0;Qc=t*19|0;p=s<<1;f=Rb<<1;M=za<<1;i=zb<<1;d=ga<<1;o=((l|0)<0)<<31>>31;I=((H|0)<0)<<31>>31;Mc=Qd(H|0,I|0,l|0,o|0)|0;Lc=C;K=((J|0)<0)<<31>>31;wc=Qd(J|0,K|0,l|0,o|0)|0;vc=C;G=((F|0)<0)<<31>>31;ub=Qd(F|0,G|0,l|0,o|0)|0;tb=C;E=((D|0)<0)<<31>>31;Ka=Qd(D|0,E|0,l|0,o|0)|0;Ja=C;B=((A|0)<0)<<31>>31;mc=Qd(A|0,B|0,l|0,o|0)|0;lc=C;z=((y|0)<0)<<31>>31;Gb=Qd(y|0,z|0,l|0,o|0)|0;Fb=C;x=((w|0)<0)<<31>>31;Wa=Qd(w|0,x|0,l|0,o|0)|0;Va=C;v=((u|0)<0)<<31>>31;ja=Qd(u|0,v|0,l|0,o|0)|0;ia=C;Pc=((k|0)<0)<<31>>31;P=Qd(k|0,Pc|0,l|0,o|0)|0;O=C;o=Qd(t|0,((t|0)<0)<<31>>31|0,l|0,o|0)|0;l=C;t=((s|0)<0)<<31>>31;dc=Qd(H|0,I|0,s|0,t|0)|0;ec=C;n=((p|0)<0)<<31>>31;yb=Qd(J|0,K|0,p|0,n|0)|0;xb=C;Ma=Qd(F|0,G|0,s|0,t|0)|0;La=C;oc=Qd(D|0,E|0,p|0,n|0)|0;nc=C;Ib=Qd(A|0,B|0,s|0,t|0)|0;Hb=C;Ya=Qd(y|0,z|0,p|0,n|0)|0;Xa=C;la=Qd(w|0,x|0,s|0,t|0)|0;ka=C;R=Qd(u|0,v|0,p|0,n|0)|0;Q=C;t=Qd(k|0,Pc|0,s|0,t|0)|0;s=C;Pc=((Qc|0)<0)<<31>>31;n=Qd(Qc|0,Pc|0,p|0,n|0)|0;p=C;k=((j|0)<0)<<31>>31;wb=Qd(H|0,I|0,j|0,k|0)|0;vb=C;Qa=Qd(J|0,K|0,j|0,k|0)|0;Pa=C;qc=Qd(F|0,G|0,j|0,k|0)|0;pc=C;Kb=Qd(D|0,E|0,j|0,k|0)|0;Jb=C;_a=Qd(A|0,B|0,j|0,k|0)|0;Za=C;na=Qd(y|0,z|0,j|0,k|0)|0;ma=C;T=Qd(w|0,x|0,j|0,k|0)|0;S=C;v=Qd(u|0,v|0,j|0,k|0)|0;u=C;Rc=((Sc|0)<0)<<31>>31;yc=Qd(Sc|0,Rc|0,j|0,k|0)|0;xc=C;k=Qd(Qc|0,Pc|0,j|0,k|0)|0;j=C;Sb=((Rb|0)<0)<<31>>31;Oa=Qd(H|0,I|0,Rb|0,Sb|0)|0;Na=C;fa=((f|0)<0)<<31>>31;uc=Qd(J|0,K|0,f|0,fa|0)|0;tc=C;Mb=Qd(F|0,G|0,Rb|0,Sb|0)|0;Lb=C;ab=Qd(D|0,E|0,f|0,fa|0)|0;$a=C;pa=Qd(A|0,B|0,Rb|0,Sb|0)|0;oa=C;V=Qd(y|0,z|0,f|0,fa|0)|0;U=C;x=Qd(w|0,x|0,Rb|0,Sb|0)|0;w=C;Ua=((Ta|0)<0)<<31>>31;Ac=Qd(Ta|0,Ua|0,f|0,fa|0)|0;zc=C;Sb=Qd(Sc|0,Rc|0,Rb|0,Sb|0)|0;Rb=C;fa=Qd(Qc|0,Pc|0,f|0,fa|0)|0;f=C;N=((e|0)<0)<<31>>31;sc=Qd(H|0,I|0,e|0,N|0)|0;rc=C;Qb=Qd(J|0,K|0,e|0,N|0)|0;Pb=C;cb=Qd(F|0,G|0,e|0,N|0)|0;bb=C;ra=Qd(D|0,E|0,e|0,N|0)|0;qa=C;X=Qd(A|0,B|0,e|0,N|0)|0;W=C;z=Qd(y|0,z|0,e|0,N|0)|0;y=C;Eb=((Db|0)<0)<<31>>31;Cc=Qd(Db|0,Eb|0,e|0,N|0)|0;Bc=C;Ub=Qd(Ta|0,Ua|0,e|0,N|0)|0;Tb=C;ib=Qd(Sc|0,Rc|0,e|0,N|0)|0;hb=C;N=Qd(Qc|0,Pc|0,e|0,N|0)|0;e=C;Aa=((za|0)<0)<<31>>31;Ob=Qd(H|0,I|0,za|0,Aa|0)|0;Nb=C;b=((M|0)<0)<<31>>31;gb=Qd(J|0,K|0,M|0,b|0)|0;fb=C;ta=Qd(F|0,G|0,za|0,Aa|0)|0;sa=C;Z=Qd(D|0,E|0,M|0,b|0)|0;Y=C;B=Qd(A|0,B|0,za|0,Aa|0)|0;A=C;kc=((jc|0)<0)<<31>>31;Ec=Qd(jc|0,kc|0,M|0,b|0)|0;Dc=C;Wb=Qd(Db|0,Eb|0,za|0,Aa|0)|0;Vb=C;kb=Qd(Ta|0,Ua|0,M|0,b|0)|0;jb=C;Aa=Qd(Sc|0,Rc|0,za|0,Aa|0)|0;za=C;b=Qd(Qc|0,Pc|0,M|0,b|0)|0;M=C;g=((ya|0)<0)<<31>>31;eb=Qd(H|0,I|0,ya|0,g|0)|0;db=C;xa=Qd(J|0,K|0,ya|0,g|0)|0;wa=C;$=Qd(F|0,G|0,ya|0,g|0)|0;_=C;E=Qd(D|0,E|0,ya|0,g|0)|0;D=C;Ia=((Ha|0)<0)<<31>>31;Gc=Qd(Ha|0,Ia|0,ya|0,g|0)|0;Fc=C;Yb=Qd(jc|0,kc|0,ya|0,g|0)|0;Xb=C;mb=Qd(Db|0,Eb|0,ya|0,g|0)|0;lb=C;Ca=Qd(Ta|0,Ua|0,ya|0,g|0)|0;Ba=C;m=Qd(Sc|0,Rc|0,ya|0,g|0)|0;r=C;g=Qd(Qc|0,Pc|0,ya|0,g|0)|0;ya=C;Ab=((zb|0)<0)<<31>>31;va=Qd(H|0,I|0,zb|0,Ab|0)|0;ua=C;ea=((i|0)<0)<<31>>31;da=Qd(J|0,K|0,i|0,ea|0)|0;ca=C;G=Qd(F|0,G|0,zb|0,Ab|0)|0;F=C;sb=((rb|0)<0)<<31>>31;Ic=Qd(rb|0,sb|0,i|0,ea|0)|0;Hc=C;_b=Qd(Ha|0,Ia|0,zb|0,Ab|0)|0;Zb=C;ob=Qd(jc|0,kc|0,i|0,ea|0)|0;nb=C;Ea=Qd(Db|0,Eb|0,zb|0,Ab|0)|0;Da=C;gc=Qd(Ta|0,Ua|0,i|0,ea|0)|0;fc=C;Ab=Qd(Sc|0,Rc|0,zb|0,Ab|0)|0;zb=C;ea=Qd(Qc|0,Pc|0,i|0,ea|0)|0;i=C;L=((h|0)<0)<<31>>31;ba=Qd(H|0,I|0,h|0,L|0)|0;aa=C;K=Qd(J|0,K|0,h|0,L|0)|0;J=C;cc=((bc|0)<0)<<31>>31;Kc=Qd(bc|0,cc|0,h|0,L|0)|0;Jc=C;ac=Qd(rb|0,sb|0,h|0,L|0)|0;$b=C;qb=Qd(Ha|0,Ia|0,h|0,L|0)|0;pb=C;Ga=Qd(jc|0,kc|0,h|0,L|0)|0;Fa=C;ic=Qd(Db|0,Eb|0,h|0,L|0)|0;hc=C;Cb=Qd(Ta|0,Ua|0,h|0,L|0)|0;Bb=C;Sa=Qd(Sc|0,Rc|0,h|0,L|0)|0;Ra=C;L=Qd(Qc|0,Pc|0,h|0,L|0)|0;h=C;ha=((ga|0)<0)<<31>>31;I=Qd(H|0,I|0,ga|0,ha|0)|0;H=C;q=((d|0)<0)<<31>>31;Oc=Qd(Oc|0,((Oc|0)<0)<<31>>31|0,d|0,q|0)|0;Nc=C;cc=Qd(bc|0,cc|0,ga|0,ha|0)|0;bc=C;sb=Qd(rb|0,sb|0,d|0,q|0)|0;rb=C;Ia=Qd(Ha|0,Ia|0,ga|0,ha|0)|0;Ha=C;kc=Qd(jc|0,kc|0,d|0,q|0)|0;jc=C;Eb=Qd(Db|0,Eb|0,ga|0,ha|0)|0;Db=C;Ua=Qd(Ta|0,Ua|0,d|0,q|0)|0;Ta=C;ha=Qd(Sc|0,Rc|0,ga|0,ha|0)|0;ga=C;q=Qd(Qc|0,Pc|0,d|0,q|0)|0;d=C;Lc=Fd(Oc|0,Nc|0,Mc|0,Lc|0)|0;Jc=Fd(Lc|0,C|0,Kc|0,Jc|0)|0;Hc=Fd(Jc|0,C|0,Ic|0,Hc|0)|0;Fc=Fd(Hc|0,C|0,Gc|0,Fc|0)|0;Dc=Fd(Fc|0,C|0,Ec|0,Dc|0)|0;Bc=Fd(Dc|0,C|0,Cc|0,Bc|0)|0;zc=Fd(Bc|0,C|0,Ac|0,zc|0)|0;xc=Fd(zc|0,C|0,yc|0,xc|0)|0;p=Fd(xc|0,C|0,n|0,p|0)|0;n=C;ec=Fd(wc|0,vc|0,dc|0,ec|0)|0;dc=C;rc=Fd(uc|0,tc|0,sc|0,rc|0)|0;pc=Fd(rc|0,C|0,qc|0,pc|0)|0;nc=Fd(pc|0,C|0,oc|0,nc|0)|0;lc=Fd(nc|0,C|0,mc|0,lc|0)|0;jc=Fd(lc|0,C|0,kc|0,jc|0)|0;hc=Fd(jc|0,C|0,ic|0,hc|0)|0;fc=Fd(hc|0,C|0,gc|0,fc|0)|0;r=Fd(fc|0,C|0,m|0,r|0)|0;M=Fd(r|0,C|0,b|0,M|0)|0;b=C;r=Fd(p|0,n|0,33554432,0)|0;r=Gd(r|0,C|0,26)|0;m=C;bc=Fd(ec|0,dc|0,cc|0,bc|0)|0;$b=Fd(bc|0,C|0,ac|0,$b|0)|0;Zb=Fd($b|0,C|0,_b|0,Zb|0)|0;Xb=Fd(Zb|0,C|0,Yb|0,Xb|0)|0;Vb=Fd(Xb|0,C|0,Wb|0,Vb|0)|0;Tb=Fd(Vb|0,C|0,Ub|0,Tb|0)|0;Rb=Fd(Tb|0,C|0,Sb|0,Rb|0)|0;j=Fd(Rb|0,C|0,k|0,j|0)|0;j=Fd(j|0,C|0,r|0,m|0)|0;k=C;m=Jd(r|0,m|0,26)|0;m=Ed(p|0,n|0,m|0,C|0)|0;n=C;p=Fd(M|0,b|0,33554432,0)|0;p=Gd(p|0,C|0,26)|0;r=C;Nb=Fd(Qb|0,Pb|0,Ob|0,Nb|0)|0;Lb=Fd(Nb|0,C|0,Mb|0,Lb|0)|0;Jb=Fd(Lb|0,C|0,Kb|0,Jb|0)|0;Hb=Fd(Jb|0,C|0,Ib|0,Hb|0)|0;Fb=Fd(Hb|0,C|0,Gb|0,Fb|0)|0;Db=Fd(Fb|0,C|0,Eb|0,Db|0)|0;Bb=Fd(Db|0,C|0,Cb|0,Bb|0)|0;zb=Fd(Bb|0,C|0,Ab|0,zb|0)|0;ya=Fd(zb|0,C|0,g|0,ya|0)|0;ya=Fd(ya|0,C|0,p|0,r|0)|0;g=C;r=Jd(p|0,r|0,26)|0;r=Ed(M|0,b|0,r|0,C|0)|0;b=C;M=Fd(j|0,k|0,16777216,0)|0;M=Gd(M|0,C|0,25)|0;p=C;vb=Fd(yb|0,xb|0,wb|0,vb|0)|0;tb=Fd(vb|0,C|0,ub|0,tb|0)|0;rb=Fd(tb|0,C|0,sb|0,rb|0)|0;pb=Fd(rb|0,C|0,qb|0,pb|0)|0;nb=Fd(pb|0,C|0,ob|0,nb|0)|0;lb=Fd(nb|0,C|0,mb|0,lb|0)|0;jb=Fd(lb|0,C|0,kb|0,jb|0)|0;hb=Fd(jb|0,C|0,ib|0,hb|0)|0;f=Fd(hb|0,C|0,fa|0,f|0)|0;f=Fd(f|0,C|0,M|0,p|0)|0;fa=C;p=Jd(M|0,p|0,25)|0;p=Ed(j|0,k|0,p|0,C|0)|0;k=C;j=Fd(ya|0,g|0,16777216,0)|0;j=Gd(j|0,C|0,25)|0;M=C;db=Fd(gb|0,fb|0,eb|0,db|0)|0;bb=Fd(db|0,C|0,cb|0,bb|0)|0;$a=Fd(bb|0,C|0,ab|0,$a|0)|0;Za=Fd($a|0,C|0,_a|0,Za|0)|0;Xa=Fd(Za|0,C|0,Ya|0,Xa|0)|0;Va=Fd(Xa|0,C|0,Wa|0,Va|0)|0;Ta=Fd(Va|0,C|0,Ua|0,Ta|0)|0;Ra=Fd(Ta|0,C|0,Sa|0,Ra|0)|0;i=Fd(Ra|0,C|0,ea|0,i|0)|0;i=Fd(i|0,C|0,j|0,M|0)|0;ea=C;M=Jd(j|0,M|0,25)|0;M=Ed(ya|0,g|0,M|0,C|0)|0;g=C;ya=Fd(f|0,fa|0,33554432,0)|0;ya=Gd(ya|0,C|0,26)|0;j=C;Na=Fd(Qa|0,Pa|0,Oa|0,Na|0)|0;La=Fd(Na|0,C|0,Ma|0,La|0)|0;Ja=Fd(La|0,C|0,Ka|0,Ja|0)|0;Ha=Fd(Ja|0,C|0,Ia|0,Ha|0)|0;Fa=Fd(Ha|0,C|0,Ga|0,Fa|0)|0;Da=Fd(Fa|0,C|0,Ea|0,Da|0)|0;Ba=Fd(Da|0,C|0,Ca|0,Ba|0)|0;za=Fd(Ba|0,C|0,Aa|0,za|0)|0;e=Fd(za|0,C|0,N|0,e|0)|0;e=Fd(e|0,C|0,ya|0,j|0)|0;N=C;j=Jd(ya|0,j|0,26)|0;j=Ed(f|0,fa|0,j|0,C|0)|0;fa=Fd(i|0,ea|0,33554432,0)|0;fa=Gd(fa|0,C|0,26)|0;f=C;ua=Fd(xa|0,wa|0,va|0,ua|0)|0;sa=Fd(ua|0,C|0,ta|0,sa|0)|0;qa=Fd(sa|0,C|0,ra|0,qa|0)|0;oa=Fd(qa|0,C|0,pa|0,oa|0)|0;ma=Fd(oa|0,C|0,na|0,ma|0)|0;ka=Fd(ma|0,C|0,la|0,ka|0)|0;ia=Fd(ka|0,C|0,ja|0,ia|0)|0;ga=Fd(ia|0,C|0,ha|0,ga|0)|0;h=Fd(ga|0,C|0,L|0,h|0)|0;h=Fd(h|0,C|0,fa|0,f|0)|0;L=C;f=Jd(fa|0,f|0,26)|0;f=Ed(i|0,ea|0,f|0,C|0)|0;ea=Fd(e|0,N|0,16777216,0)|0;ea=Gd(ea|0,C|0,25)|0;i=C;b=Fd(ea|0,i|0,r|0,b|0)|0;r=C;i=Jd(ea|0,i|0,25)|0;i=Ed(e|0,N|0,i|0,C|0)|0;N=Fd(h|0,L|0,16777216,0)|0;N=Gd(N|0,C|0,25)|0;e=C;aa=Fd(da|0,ca|0,ba|0,aa|0)|0;_=Fd(aa|0,C|0,$|0,_|0)|0;Y=Fd(_|0,C|0,Z|0,Y|0)|0;W=Fd(Y|0,C|0,X|0,W|0)|0;U=Fd(W|0,C|0,V|0,U|0)|0;S=Fd(U|0,C|0,T|0,S|0)|0;Q=Fd(S|0,C|0,R|0,Q|0)|0;O=Fd(Q|0,C|0,P|0,O|0)|0;d=Fd(O|0,C|0,q|0,d|0)|0;d=Fd(d|0,C|0,N|0,e|0)|0;q=C;e=Jd(N|0,e|0,25)|0;e=Ed(h|0,L|0,e|0,C|0)|0;L=Fd(b|0,r|0,33554432,0)|0;L=Gd(L|0,C|0,26)|0;h=C;g=Fd(M|0,g|0,L|0,h|0)|0;h=Jd(L|0,h|0,26)|0;h=Ed(b|0,r|0,h|0,C|0)|0;r=Fd(d|0,q|0,33554432,0)|0;r=Gd(r|0,C|0,26)|0;b=C;H=Fd(K|0,J|0,I|0,H|0)|0;F=Fd(H|0,C|0,G|0,F|0)|0;D=Fd(F|0,C|0,E|0,D|0)|0;A=Fd(D|0,C|0,B|0,A|0)|0;y=Fd(A|0,C|0,z|0,y|0)|0;w=Fd(y|0,C|0,x|0,w|0)|0;u=Fd(w|0,C|0,v|0,u|0)|0;s=Fd(u|0,C|0,t|0,s|0)|0;l=Fd(s|0,C|0,o|0,l|0)|0;l=Fd(l|0,C|0,r|0,b|0)|0;o=C;b=Jd(r|0,b|0,26)|0;b=Ed(d|0,q|0,b|0,C|0)|0;q=Fd(l|0,o|0,16777216,0)|0;q=Gd(q|0,C|0,25)|0;d=C;r=Qd(q|0,d|0,19,0)|0;n=Fd(r|0,C|0,m|0,n|0)|0;m=C;d=Jd(q|0,d|0,25)|0;d=Ed(l|0,o|0,d|0,C|0)|0;o=Fd(n|0,m|0,33554432,0)|0;o=Gd(o|0,C|0,26)|0;l=C;k=Fd(p|0,k|0,o|0,l|0)|0;l=Jd(o|0,l|0,26)|0;l=Ed(n|0,m|0,l|0,C|0)|0;c[a>>2]=l;c[a+4>>2]=k;c[a+8>>2]=j;c[a+12>>2]=i;c[a+16>>2]=h;c[a+20>>2]=g;c[a+24>>2]=f;c[a+28>>2]=e;c[a+32>>2]=b;c[a+36>>2]=d;return}function Lc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0;bb=c[b>>2]|0;ua=c[b+4>>2]|0;j=c[b+8>>2]|0;la=c[b+12>>2]|0;e=c[b+16>>2]|0;db=c[b+20>>2]|0;Y=c[b+24>>2]|0;La=c[b+28>>2]|0;h=c[b+32>>2]|0;b=c[b+36>>2]|0;l=bb<<1;p=ua<<1;Xa=j<<1;f=la<<1;na=e<<1;B=db<<1;m=Y<<1;i=La<<1;Ka=db*38|0;ra=Y*19|0;va=La*38|0;da=h*19|0;gb=b*38|0;cb=((bb|0)<0)<<31>>31;cb=Qd(bb|0,cb|0,bb|0,cb|0)|0;bb=C;o=((l|0)<0)<<31>>31;ta=((ua|0)<0)<<31>>31;Ia=Qd(l|0,o|0,ua|0,ta|0)|0;Ha=C;k=((j|0)<0)<<31>>31;Wa=Qd(j|0,k|0,l|0,o|0)|0;Va=C;ma=((la|0)<0)<<31>>31;Ua=Qd(la|0,ma|0,l|0,o|0)|0;Ta=C;D=((e|0)<0)<<31>>31;Oa=Qd(e|0,D|0,l|0,o|0)|0;Na=C;eb=((db|0)<0)<<31>>31;ya=Qd(db|0,eb|0,l|0,o|0)|0;xa=C;g=((Y|0)<0)<<31>>31;ga=Qd(Y|0,g|0,l|0,o|0)|0;fa=C;Ma=((La|0)<0)<<31>>31;R=Qd(La|0,Ma|0,l|0,o|0)|0;Q=C;A=((h|0)<0)<<31>>31;F=Qd(h|0,A|0,l|0,o|0)|0;E=C;q=((b|0)<0)<<31>>31;o=Qd(b|0,q|0,l|0,o|0)|0;l=C;n=((p|0)<0)<<31>>31;ta=Qd(p|0,n|0,ua|0,ta|0)|0;ua=C;ba=Qd(p|0,n|0,j|0,k|0)|0;ca=C;P=((f|0)<0)<<31>>31;Sa=Qd(f|0,P|0,p|0,n|0)|0;Ra=C;Ca=Qd(e|0,D|0,p|0,n|0)|0;Ba=C;d=((B|0)<0)<<31>>31;ia=Qd(B|0,d|0,p|0,n|0)|0;ha=C;T=Qd(Y|0,g|0,p|0,n|0)|0;S=C;O=((i|0)<0)<<31>>31;H=Qd(i|0,O|0,p|0,n|0)|0;G=C;t=Qd(h|0,A|0,p|0,n|0)|0;s=C;fb=((gb|0)<0)<<31>>31;n=Qd(gb|0,fb|0,p|0,n|0)|0;p=C;Qa=Qd(j|0,k|0,j|0,k|0)|0;Pa=C;Ya=((Xa|0)<0)<<31>>31;Aa=Qd(Xa|0,Ya|0,la|0,ma|0)|0;za=C;ka=Qd(e|0,D|0,Xa|0,Ya|0)|0;ja=C;X=Qd(db|0,eb|0,Xa|0,Ya|0)|0;W=C;N=Qd(Y|0,g|0,Xa|0,Ya|0)|0;M=C;v=Qd(La|0,Ma|0,Xa|0,Ya|0)|0;u=C;ea=((da|0)<0)<<31>>31;Ya=Qd(da|0,ea|0,Xa|0,Ya|0)|0;Xa=C;k=Qd(gb|0,fb|0,j|0,k|0)|0;j=C;ma=Qd(f|0,P|0,la|0,ma|0)|0;la=C;V=Qd(f|0,P|0,e|0,D|0)|0;U=C;J=Qd(B|0,d|0,f|0,P|0)|0;I=C;z=Qd(Y|0,g|0,f|0,P|0)|0;y=C;wa=((va|0)<0)<<31>>31;_a=Qd(va|0,wa|0,f|0,P|0)|0;Za=C;Ea=Qd(da|0,ea|0,f|0,P|0)|0;Da=C;P=Qd(gb|0,fb|0,f|0,P|0)|0;f=C;L=Qd(e|0,D|0,e|0,D|0)|0;K=C;oa=((na|0)<0)<<31>>31;x=Qd(na|0,oa|0,db|0,eb|0)|0;w=C;sa=((ra|0)<0)<<31>>31;ab=Qd(ra|0,sa|0,na|0,oa|0)|0;$a=C;Ga=Qd(va|0,wa|0,e|0,D|0)|0;Fa=C;oa=Qd(da|0,ea|0,na|0,oa|0)|0;na=C;D=Qd(gb|0,fb|0,e|0,D|0)|0;e=C;eb=Qd(Ka|0,((Ka|0)<0)<<31>>31|0,db|0,eb|0)|0;db=C;Ka=Qd(ra|0,sa|0,B|0,d|0)|0;Ja=C;qa=Qd(va|0,wa|0,B|0,d|0)|0;pa=C;_=Qd(da|0,ea|0,B|0,d|0)|0;Z=C;d=Qd(gb|0,fb|0,B|0,d|0)|0;B=C;sa=Qd(ra|0,sa|0,Y|0,g|0)|0;ra=C;aa=Qd(va|0,wa|0,Y|0,g|0)|0;$=C;m=Qd(da|0,ea|0,m|0,((m|0)<0)<<31>>31|0)|0;r=C;g=Qd(gb|0,fb|0,Y|0,g|0)|0;Y=C;Ma=Qd(va|0,wa|0,La|0,Ma|0)|0;La=C;wa=Qd(da|0,ea|0,i|0,O|0)|0;va=C;O=Qd(gb|0,fb|0,i|0,O|0)|0;i=C;ea=Qd(da|0,ea|0,h|0,A|0)|0;da=C;A=Qd(gb|0,fb|0,h|0,A|0)|0;h=C;q=Qd(gb|0,fb|0,b|0,q|0)|0;b=C;bb=Fd(eb|0,db|0,cb|0,bb|0)|0;$a=Fd(bb|0,C|0,ab|0,$a|0)|0;Za=Fd($a|0,C|0,_a|0,Za|0)|0;Xa=Fd(Za|0,C|0,Ya|0,Xa|0)|0;p=Fd(Xa|0,C|0,n|0,p|0)|0;n=C;ua=Fd(Wa|0,Va|0,ta|0,ua|0)|0;ta=C;ca=Fd(Ua|0,Ta|0,ba|0,ca|0)|0;ba=C;Pa=Fd(Sa|0,Ra|0,Qa|0,Pa|0)|0;Na=Fd(Pa|0,C|0,Oa|0,Na|0)|0;La=Fd(Na|0,C|0,Ma|0,La|0)|0;r=Fd(La|0,C|0,m|0,r|0)|0;B=Fd(r|0,C|0,d|0,B|0)|0;d=C;r=Fd(p|0,n|0,33554432,0)|0;r=Gd(r|0,C|0,26)|0;m=C;Ha=Fd(Ka|0,Ja|0,Ia|0,Ha|0)|0;Fa=Fd(Ha|0,C|0,Ga|0,Fa|0)|0;Da=Fd(Fa|0,C|0,Ea|0,Da|0)|0;j=Fd(Da|0,C|0,k|0,j|0)|0;j=Fd(j|0,C|0,r|0,m|0)|0;k=C;m=Jd(r|0,m|0,26)|0;m=Ed(p|0,n|0,m|0,C|0)|0;n=C;p=Fd(B|0,d|0,33554432,0)|0;p=Gd(p|0,C|0,26)|0;r=C;za=Fd(Ca|0,Ba|0,Aa|0,za|0)|0;xa=Fd(za|0,C|0,ya|0,xa|0)|0;va=Fd(xa|0,C|0,wa|0,va|0)|0;Y=Fd(va|0,C|0,g|0,Y|0)|0;Y=Fd(Y|0,C|0,p|0,r|0)|0;g=C;r=Jd(p|0,r|0,26)|0;r=Ed(B|0,d|0,r|0,C|0)|0;d=C;B=Fd(j|0,k|0,16777216,0)|0;B=Gd(B|0,C|0,25)|0;p=C;ra=Fd(ua|0,ta|0,sa|0,ra|0)|0;pa=Fd(ra|0,C|0,qa|0,pa|0)|0;na=Fd(pa|0,C|0,oa|0,na|0)|0;f=Fd(na|0,C|0,P|0,f|0)|0;f=Fd(f|0,C|0,B|0,p|0)|0;P=C;p=Jd(B|0,p|0,25)|0;p=Ed(j|0,k|0,p|0,C|0)|0;k=C;j=Fd(Y|0,g|0,16777216,0)|0;j=Gd(j|0,C|0,25)|0;B=C;ja=Fd(ma|0,la|0,ka|0,ja|0)|0;ha=Fd(ja|0,C|0,ia|0,ha|0)|0;fa=Fd(ha|0,C|0,ga|0,fa|0)|0;da=Fd(fa|0,C|0,ea|0,da|0)|0;i=Fd(da|0,C|0,O|0,i|0)|0;i=Fd(i|0,C|0,j|0,B|0)|0;O=C;B=Jd(j|0,B|0,25)|0;B=Ed(Y|0,g|0,B|0,C|0)|0;g=C;Y=Fd(f|0,P|0,33554432,0)|0;Y=Gd(Y|0,C|0,26)|0;j=C;$=Fd(ca|0,ba|0,aa|0,$|0)|0;Z=Fd($|0,C|0,_|0,Z|0)|0;e=Fd(Z|0,C|0,D|0,e|0)|0;e=Fd(e|0,C|0,Y|0,j|0)|0;D=C;j=Jd(Y|0,j|0,26)|0;j=Ed(f|0,P|0,j|0,C|0)|0;P=Fd(i|0,O|0,33554432,0)|0;P=Gd(P|0,C|0,26)|0;f=C;U=Fd(X|0,W|0,V|0,U|0)|0;S=Fd(U|0,C|0,T|0,S|0)|0;Q=Fd(S|0,C|0,R|0,Q|0)|0;h=Fd(Q|0,C|0,A|0,h|0)|0;h=Fd(h|0,C|0,P|0,f|0)|0;A=C;f=Jd(P|0,f|0,26)|0;f=Ed(i|0,O|0,f|0,C|0)|0;O=Fd(e|0,D|0,16777216,0)|0;O=Gd(O|0,C|0,25)|0;i=C;d=Fd(O|0,i|0,r|0,d|0)|0;r=C;i=Jd(O|0,i|0,25)|0;i=Ed(e|0,D|0,i|0,C|0)|0;D=Fd(h|0,A|0,16777216,0)|0;D=Gd(D|0,C|0,25)|0;e=C;K=Fd(N|0,M|0,L|0,K|0)|0;I=Fd(K|0,C|0,J|0,I|0)|0;G=Fd(I|0,C|0,H|0,G|0)|0;E=Fd(G|0,C|0,F|0,E|0)|0;b=Fd(E|0,C|0,q|0,b|0)|0;b=Fd(b|0,C|0,D|0,e|0)|0;q=C;e=Jd(D|0,e|0,25)|0;e=Ed(h|0,A|0,e|0,C|0)|0;A=Fd(d|0,r|0,33554432,0)|0;A=Gd(A|0,C|0,26)|0;h=C;g=Fd(B|0,g|0,A|0,h|0)|0;h=Jd(A|0,h|0,26)|0;h=Ed(d|0,r|0,h|0,C|0)|0;r=Fd(b|0,q|0,33554432,0)|0;r=Gd(r|0,C|0,26)|0;d=C;w=Fd(z|0,y|0,x|0,w|0)|0;u=Fd(w|0,C|0,v|0,u|0)|0;s=Fd(u|0,C|0,t|0,s|0)|0;l=Fd(s|0,C|0,o|0,l|0)|0;l=Fd(l|0,C|0,r|0,d|0)|0;o=C;d=Jd(r|0,d|0,26)|0;d=Ed(b|0,q|0,d|0,C|0)|0;q=Fd(l|0,o|0,16777216,0)|0;q=Gd(q|0,C|0,25)|0;b=C;r=Qd(q|0,b|0,19,0)|0;n=Fd(r|0,C|0,m|0,n|0)|0;m=C;b=Jd(q|0,b|0,25)|0;b=Ed(l|0,o|0,b|0,C|0)|0;o=Fd(n|0,m|0,33554432,0)|0;o=Gd(o|0,C|0,26)|0;l=C;k=Fd(p|0,k|0,o|0,l|0)|0;l=Jd(o|0,l|0,26)|0;l=Ed(n|0,m|0,l|0,C|0)|0;c[a>>2]=l;c[a+4>>2]=k;c[a+8>>2]=j;c[a+12>>2]=i;c[a+16>>2]=h;c[a+20>>2]=g;c[a+24>>2]=f;c[a+28>>2]=e;c[a+32>>2]=d;c[a+36>>2]=b;return}function Mc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;m=c[d>>2]|0;l=c[d+4>>2]|0;k=c[d+8>>2]|0;j=c[d+12>>2]|0;i=c[d+16>>2]|0;h=c[d+20>>2]|0;g=c[d+24>>2]|0;f=c[d+28>>2]|0;o=c[d+32>>2]|0;e=c[d+36>>2]|0;m=(((((((((((((e*19|0)+16777216>>25)+m>>26)+l>>25)+k>>26)+j>>25)+i>>26)+h>>25)+g>>26)+f>>25)+o>>26)+e>>25)*19|0)+m|0;n=m>>26;l=n+l|0;n=m-(n<<26)|0;m=l>>25;k=m+k|0;m=l-(m<<25)|0;l=k>>26;j=l+j|0;l=k-(l<<26)|0;k=j>>25;i=k+i|0;k=j-(k<<25)|0;j=i>>26;h=j+h|0;j=i-(j<<26)|0;i=h>>25;g=i+g|0;i=h-(i<<25)|0;h=g>>26;f=h+f|0;h=g-(h<<26)|0;g=f>>25;d=g+o|0;g=f-(g<<25)|0;f=d>>26;e=f+e|0;f=d-(f<<26)|0;d=e&33554431;a[b>>0]=n;a[b+1>>0]=n>>>8;a[b+2>>0]=n>>>16;a[b+3>>0]=m<<2|n>>>24;a[b+4>>0]=m>>>6;a[b+5>>0]=m>>>14;a[b+6>>0]=l<<3|m>>>22;a[b+7>>0]=l>>>5;a[b+8>>0]=l>>>13;a[b+9>>0]=k<<5|l>>>21;a[b+10>>0]=k>>>3;a[b+11>>0]=k>>>11;a[b+12>>0]=j<<6|k>>>19;a[b+13>>0]=j>>>2;a[b+14>>0]=j>>>10;a[b+15>>0]=j>>>18;a[b+16>>0]=i;a[b+17>>0]=i>>>8;a[b+18>>0]=i>>>16;a[b+19>>0]=h<<1|i>>>24;a[b+20>>0]=h>>>7;a[b+21>>0]=h>>>15;a[b+22>>0]=g<<3|h>>>23;a[b+23>>0]=g>>>5;a[b+24>>0]=g>>>13;a[b+25>>0]=f<<4|g>>>21;a[b+26>>0]=f>>>4;a[b+27>>0]=f>>>12;a[b+28>>0]=f>>>20|d<<6;a[b+29>>0]=e>>>2;a[b+30>>0]=e>>>10;a[b+31>>0]=d>>>18;return}function Nc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;V=b+40|0;j=b+44|0;m=b+48|0;p=b+52|0;s=b+56|0;v=b+60|0;y=b+64|0;B=b+68|0;E=b+72|0;C=b+76|0;S=b+4|0;P=b+8|0;e=b+12|0;l=b+16|0;n=b+20|0;u=b+24|0;w=b+28|0;D=b+32|0;O=b+36|0;ga=(c[S>>2]|0)+(c[j>>2]|0)|0;fa=(c[P>>2]|0)+(c[m>>2]|0)|0;ea=(c[e>>2]|0)+(c[p>>2]|0)|0;da=(c[l>>2]|0)+(c[s>>2]|0)|0;ca=(c[n>>2]|0)+(c[v>>2]|0)|0;ba=(c[u>>2]|0)+(c[y>>2]|0)|0;aa=(c[w>>2]|0)+(c[B>>2]|0)|0;$=(c[D>>2]|0)+(c[E>>2]|0)|0;Y=(c[O>>2]|0)+(c[C>>2]|0)|0;c[a>>2]=(c[b>>2]|0)+(c[V>>2]|0);ha=a+4|0;c[ha>>2]=ga;ga=a+8|0;c[ga>>2]=fa;fa=a+12|0;c[fa>>2]=ea;ea=a+16|0;c[ea>>2]=da;da=a+20|0;c[da>>2]=ca;ca=a+24|0;c[ca>>2]=ba;ba=a+28|0;c[ba>>2]=aa;aa=a+32|0;c[aa>>2]=$;$=a+36|0;c[$>>2]=Y;Y=a+40|0;S=(c[j>>2]|0)-(c[S>>2]|0)|0;P=(c[m>>2]|0)-(c[P>>2]|0)|0;e=(c[p>>2]|0)-(c[e>>2]|0)|0;l=(c[s>>2]|0)-(c[l>>2]|0)|0;n=(c[v>>2]|0)-(c[n>>2]|0)|0;u=(c[y>>2]|0)-(c[u>>2]|0)|0;w=(c[B>>2]|0)-(c[w>>2]|0)|0;D=(c[E>>2]|0)-(c[D>>2]|0)|0;O=(c[C>>2]|0)-(c[O>>2]|0)|0;c[Y>>2]=(c[V>>2]|0)-(c[b>>2]|0);V=a+44|0;c[V>>2]=S;S=a+48|0;c[S>>2]=P;P=a+52|0;c[P>>2]=e;e=a+56|0;c[e>>2]=l;l=a+60|0;c[l>>2]=n;n=a+64|0;c[n>>2]=u;u=a+68|0;c[u>>2]=w;w=a+72|0;c[w>>2]=D;D=a+76|0;c[D>>2]=O;O=a+80|0;Kc(O,a,d);Kc(Y,Y,d+40|0);C=a+120|0;Kc(C,d+120|0,b+120|0);Kc(a,b+80|0,d+80|0);E=c[a>>2]<<1;B=c[ha>>2]<<1;y=c[ga>>2]<<1;v=c[fa>>2]<<1;s=c[ea>>2]<<1;p=c[da>>2]<<1;m=c[ca>>2]<<1;j=c[ba>>2]<<1;g=c[aa>>2]<<1;b=c[$>>2]<<1;Z=c[O>>2]|0;N=a+84|0;W=c[N>>2]|0;M=a+88|0;T=c[M>>2]|0;L=a+92|0;Q=c[L>>2]|0;K=a+96|0;f=c[K>>2]|0;J=a+100|0;h=c[J>>2]|0;I=a+104|0;o=c[I>>2]|0;H=a+108|0;q=c[H>>2]|0;G=a+112|0;x=c[G>>2]|0;F=a+116|0;z=c[F>>2]|0;_=c[Y>>2]|0;X=c[V>>2]|0;U=c[S>>2]|0;R=c[P>>2]|0;d=c[e>>2]|0;i=c[l>>2]|0;k=c[n>>2]|0;r=c[u>>2]|0;t=c[w>>2]|0;A=c[D>>2]|0;c[a>>2]=Z-_;c[ha>>2]=W-X;c[ga>>2]=T-U;c[fa>>2]=Q-R;c[ea>>2]=f-d;c[da>>2]=h-i;c[ca>>2]=o-k;c[ba>>2]=q-r;c[aa>>2]=x-t;c[$>>2]=z-A;c[Y>>2]=_+Z;c[V>>2]=X+W;c[S>>2]=U+T;c[P>>2]=R+Q;c[e>>2]=d+f;c[l>>2]=i+h;c[n>>2]=k+o;c[u>>2]=r+q;c[w>>2]=t+x;c[D>>2]=A+z;D=c[C>>2]|0;z=a+124|0;A=c[z>>2]|0;w=a+128|0;x=c[w>>2]|0;t=a+132|0;u=c[t>>2]|0;q=a+136|0;r=c[q>>2]|0;n=a+140|0;o=c[n>>2]|0;k=a+144|0;l=c[k>>2]|0;h=a+148|0;i=c[h>>2]|0;e=a+152|0;f=c[e>>2]|0;a=a+156|0;d=c[a>>2]|0;c[O>>2]=D+E;c[N>>2]=A+B;c[M>>2]=x+y;c[L>>2]=u+v;c[K>>2]=r+s;c[J>>2]=o+p;c[I>>2]=l+m;c[H>>2]=i+j;c[G>>2]=f+g;c[F>>2]=d+b;c[C>>2]=E-D;c[z>>2]=B-A;c[w>>2]=y-x;c[t>>2]=v-u;c[q>>2]=s-r;c[n>>2]=p-o;c[k>>2]=m-l;c[h>>2]=j-i;c[e>>2]=g-f;c[a>>2]=b-d;return}
function Ha(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+15&-16;return b|0}function Ia(){return i|0}function Ja(a){a=a|0;i=a}function Ka(a,b){a=a|0;b=b|0;i=a;j=b}function La(a,b){a=a|0;b=b|0;if(!n){n=a;o=b}}function Ma(b){b=b|0;a[k>>0]=a[b>>0];a[k+1>>0]=a[b+1>>0];a[k+2>>0]=a[b+2>>0];a[k+3>>0]=a[b+3>>0]}function Na(b){b=b|0;a[k>>0]=a[b>>0];a[k+1>>0]=a[b+1>>0];a[k+2>>0]=a[b+2>>0];a[k+3>>0]=a[b+3>>0];a[k+4>>0]=a[b+4>>0];a[k+5>>0]=a[b+5>>0];a[k+6>>0]=a[b+6>>0];a[k+7>>0]=a[b+7>>0]}function Oa(a){a=a|0;C=a}function Pa(){return C|0}function Qa(){return 32}function Ra(){return 32}function Sa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ua(a,b,c,d,e);return 0}function Ta(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;h=i;i=i+32|0;g=h;Ua(g,c,d,e,f);e=Zc(b,g)|0;d=(g|0)==(b|0);f=0;c=0;do{f=a[b+c>>0]^a[g+c>>0]|f;c=c+1|0}while((c|0)!=32);i=h;return (d?-1:e)|(((f&255)+511|0)>>>8&1)+-1|0}function Ua(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=i;i=i+608|0;n=p+480|0;m=p+416|0;o=p;h=o+64|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;h=o;j=8;k=h+64|0;do{c[h>>2]=c[j>>2];h=h+4|0;j=j+4|0}while((h|0)<(k|0));h=n;k=h+128|0;do{a[h>>0]=54;h=h+1|0}while((h|0)<(k|0));a[n>>0]=a[g>>0]^54;h=1;do{l=n+h|0;a[l>>0]=a[l>>0]^a[g+h>>0];h=h+1|0}while((h|0)!=32);Gb(o,n,128,0);l=o+208|0;h=o+272|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;h=l;j=8;k=h+64|0;do{c[h>>2]=c[j>>2];h=h+4|0;j=j+4|0}while((h|0)<(k|0));h=n;k=h+128|0;do{a[h>>0]=92;h=h+1|0}while((h|0)<(k|0));a[n>>0]=a[g>>0]^92;h=1;do{k=n+h|0;a[k>>0]=a[k>>0]^a[g+h>>0];h=h+1|0}while((h|0)!=32);Gb(l,n,128,0);Gb(o,d,e,f);Hb(o,m);Gb(l,m,64,0);Hb(l,n);h=b;j=n;k=h+32|0;do{a[h>>0]=a[j>>0]|0;h=h+1|0;j=j+1|0}while((h|0)<(k|0));i=p;return}function Va(){return 32}function Wa(){return 32}function Xa(){return 32}function Ya(){return 32}function Za(){return 24}function _a(){return 16}function $a(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;j=i;i=i+272|0;g=j;f=j+208|0;h=g+64|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;h=g;k=8;l=h+64|0;do{c[h>>2]=c[k>>2];h=h+4|0;k=k+4|0}while((h|0)<(l|0));Gb(g,e,32,0);Hb(g,f);h=d;k=f;l=h+32|0;do{a[h>>0]=a[k>>0]|0;h=h+1|0;k=k+1|0}while((h|0)<(l|0));od(b,d,33779);i=j;return 0}function ab(b,c){b=b|0;c=c|0;var d=0;d=0;do{a[c+d>>0]=Ba(0)|0;d=d+1|0}while((d|0)!=32);od(b,c,33779);return 0}function bb(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+32|0;e=d;od(e,c,b);nb(a,32576,e,32592);i=d;return 0}function cb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sc(a,b,c,d,e,f,g)|0;return 0}function db(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+64|0;l=j+32|0;k=j;od(l,h,g);nb(k,32576,l,32592);sc(a,b,c,d,e,f,k)|0;i=j;return 0}function eb(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(d>>>0>0|(d|0)==0&c>>>0>4294967279){e=-1;return e|0}sc(a+16|0,a,b,c,d,e,f)|0;e=0;return e|0}function fb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;k=i;i=i+64|0;j=k+32|0;h=k;if(d>>>0>0|(d|0)==0&c>>>0>4294967279){g=-1;i=k;return g|0}od(j,g,f);nb(h,32576,j,32592);sc(a+16|0,a,b,c,d,e,h)|0;g=0;i=k;return g|0}function gb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return uc(a,b,c,d,e,f,g)|0}function hb(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+64|0;l=j+32|0;k=j;od(l,h,g);nb(k,32576,l,32592);h=uc(a,b,c,d,e,f,k)|0;i=j;return h|0}function ib(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;if(d>>>0<0|(d|0)==0&c>>>0<16){e=-1;return e|0}d=Fd(c|0,d|0,-16,-1)|0;e=uc(a,b+16|0,b,d,C,e,f)|0;return e|0}function jb(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;k=i;i=i+64|0;j=k+32|0;h=k;if(d>>>0<0|(d|0)==0&c>>>0<16){g=-1;i=k;return g|0}c=Fd(c|0,d|0,-16,-1)|0;d=C;od(j,g,f);nb(h,32576,j,32592);g=uc(a,b+16|0,b,c,d,e,h)|0;i=k;return g|0}function kb(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=i;v=i=i+63&-64;i=i+480|0;y=v;w=v+448|0;x=v+424|0;j=v+392|0;v=v+360|0;h=0;do{a[v+h>>0]=Ba(0)|0;h=h+1|0}while((h|0)!=32);od(j,v,33779);h=b;o=j;p=h+32|0;do{a[h>>0]=a[o>>0]|0;h=h+1|0;o=o+1|0}while((h|0)<(p|0));Hd(y|0,0,357)|0;q=y;c[q>>2]=-222443248;c[q+4>>2]=1779033703;q=y+8|0;c[q>>2]=-2067093701;c[q+4>>2]=-1150833019;q=y+16|0;c[q>>2]=-23791573;c[q+4>>2]=1013904242;q=y+24|0;c[q>>2]=1595750129;c[q+4>>2]=-1521486534;q=y+32|0;c[q>>2]=-1377402159;c[q+4>>2]=1359893119;q=y+40|0;c[q>>2]=725511199;c[q+4>>2]=-1694144372;q=y+48|0;c[q>>2]=-79577749;c[q+4>>2]=528734635;q=y+56|0;c[q>>2]=327033209;c[q+4>>2]=1541459225;q=y+352|0;r=y+96|0;s=y+64|0;t=y+72|0;u=y+224|0;h=0;m=0;l=32;while(1){n=256-h|0;h=y+96+h|0;if(!(m>>>0>0|(m|0)==0&l>>>0>n>>>0)){z=5;break}Kd(h|0,j|0,n|0)|0;c[q>>2]=(c[q>>2]|0)+n;p=s;h=c[p>>2]|0;p=c[p+4>>2]|0;k=Fd(h|0,p|0,128,0)|0;o=s;c[o>>2]=k;c[o+4>>2]=C;o=t;o=Fd((p>>>0>4294967295|(p|0)==-1&h>>>0>4294967167)&1|0,0,c[o>>2]|0,c[o+4>>2]|0)|0;h=t;c[h>>2]=o;c[h+4>>2]=C;Ab(y,r);h=r;o=u;p=h+128|0;do{c[h>>2]=c[o>>2];h=h+4|0;o=o+4|0}while((h|0)<(p|0));h=(c[q>>2]|0)+-128|0;c[q>>2]=h;k=Ed(l|0,m|0,n|0,0)|0;if((l|0)==(n|0)&(m|0)==0){n=g;j=h;l=0;m=32;break}else{j=j+n|0;m=C;l=k}}if((z|0)==5){Kd(h|0,j|0,l|0)|0;j=Fd(c[q>>2]|0,0,l|0,m|0)|0;c[q>>2]=j;n=g;l=0;m=32}while(1){k=256-j|0;h=y+96+j|0;if(!(l>>>0>0|(l|0)==0&m>>>0>k>>>0)){z=8;break}Kd(h|0,n|0,k|0)|0;c[q>>2]=(c[q>>2]|0)+k;p=s;h=c[p>>2]|0;p=c[p+4>>2]|0;j=Fd(h|0,p|0,128,0)|0;o=s;c[o>>2]=j;c[o+4>>2]=C;o=t;o=Fd((p>>>0>4294967295|(p|0)==-1&h>>>0>4294967167)&1|0,0,c[o>>2]|0,c[o+4>>2]|0)|0;h=t;c[h>>2]=o;c[h+4>>2]=C;Ab(y,r);h=r;o=u;p=h+128|0;do{c[h>>2]=c[o>>2];h=h+4|0;o=o+4|0}while((h|0)<(p|0));j=(c[q>>2]|0)+-128|0;c[q>>2]=j;h=Ed(m|0,l|0,k|0,0)|0;if((m|0)==(k|0)&(l|0)==0)break;else{n=n+k|0;l=C;m=h}}if((z|0)==8){Kd(h|0,n|0,m|0)|0;z=Fd(c[q>>2]|0,0,m|0,l|0)|0;c[q>>2]=z}zb(y,x,24)|0;if(f>>>0>0|(f|0)==0&e>>>0>4294967279){z=-1;i=A;return z|0}od(y,v,g);nb(w,32576,y,32592);sc(b+48|0,b+32|0,d,e,f,x,w)|0;z=0;i=A;return z|0}function lb(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=i;v=i=i+63&-64;i=i+416|0;w=v;u=v+384|0;v=v+360|0;if(e>>>0<0|(e|0)==0&d>>>0<48){x=-1;i=y;return x|0}Hd(w|0,0,357)|0;p=w;c[p>>2]=-222443248;c[p+4>>2]=1779033703;p=w+8|0;c[p>>2]=-2067093701;c[p+4>>2]=-1150833019;p=w+16|0;c[p>>2]=-23791573;c[p+4>>2]=1013904242;p=w+24|0;c[p>>2]=1595750129;c[p+4>>2]=-1521486534;p=w+32|0;c[p>>2]=-1377402159;c[p+4>>2]=1359893119;p=w+40|0;c[p>>2]=725511199;c[p+4>>2]=-1694144372;p=w+48|0;c[p>>2]=-79577749;c[p+4>>2]=528734635;p=w+56|0;c[p>>2]=327033209;c[p+4>>2]=1541459225;p=w+352|0;q=w+96|0;r=w+64|0;s=w+72|0;t=w+224|0;m=b;h=0;k=0;n=32;while(1){l=256-h|0;j=w+96+h|0;if(!(k>>>0>0|(k|0)==0&n>>>0>l>>>0)){x=4;break}Kd(j|0,m|0,l|0)|0;c[p>>2]=(c[p>>2]|0)+l;o=r;j=c[o>>2]|0;o=c[o+4>>2]|0;z=Fd(j|0,o|0,128,0)|0;h=r;c[h>>2]=z;c[h+4>>2]=C;h=s;h=Fd((o>>>0>4294967295|(o|0)==-1&j>>>0>4294967167)&1|0,0,c[h>>2]|0,c[h+4>>2]|0)|0;j=s;c[j>>2]=h;c[j+4>>2]=C;Ab(w,q);j=q;h=t;o=j+128|0;do{c[j>>2]=c[h>>2];j=j+4|0;h=h+4|0}while((j|0)<(o|0));h=(c[p>>2]|0)+-128|0;c[p>>2]=h;j=Ed(n|0,k|0,l|0,0)|0;if((n|0)==(l|0)&(k|0)==0){l=0;m=32;break}else{m=m+l|0;k=C;n=j}}if((x|0)==4){Kd(j|0,m|0,n|0)|0;h=Fd(c[p>>2]|0,0,n|0,k|0)|0;c[p>>2]=h;l=0;m=32}while(1){k=256-h|0;h=w+96+h|0;if(!(l>>>0>0|(l|0)==0&m>>>0>k>>>0)){x=7;break}Kd(h|0,f|0,k|0)|0;c[p>>2]=(c[p>>2]|0)+k;o=r;j=c[o>>2]|0;o=c[o+4>>2]|0;z=Fd(j|0,o|0,128,0)|0;h=r;c[h>>2]=z;c[h+4>>2]=C;h=s;h=Fd((o>>>0>4294967295|(o|0)==-1&j>>>0>4294967167)&1|0,0,c[h>>2]|0,c[h+4>>2]|0)|0;j=s;c[j>>2]=h;c[j+4>>2]=C;Ab(w,q);j=q;h=t;o=j+128|0;do{c[j>>2]=c[h>>2];j=j+4|0;h=h+4|0}while((j|0)<(o|0));h=(c[p>>2]|0)+-128|0;c[p>>2]=h;j=Ed(m|0,l|0,k|0,0)|0;if((m|0)==(k|0)&(l|0)==0)break;else{f=f+k|0;l=C;m=j}}if((x|0)==7){Kd(h|0,f|0,m|0)|0;z=Fd(c[p>>2]|0,0,m|0,l|0)|0;c[p>>2]=z}zb(w,v,24)|0;if((d&-16|0)==32&(e|0)==0){z=-1;i=y;return z|0}x=Fd(d|0,e|0,-48,-1)|0;z=C;od(w,g,b);nb(u,32576,w,32592);z=uc(a,b+48|0,b+32|0,x,z,v,u)|0;i=y;return z|0}function mb(){return 48}function nb(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;k=20;l=(d[f+1>>0]|0)<<8|(d[f>>0]|0)|(d[f+2>>0]|0)<<16|(d[f+3>>0]|0)<<24;m=(d[e+1>>0]|0)<<8|(d[e>>0]|0)|(d[e+2>>0]|0)<<16|(d[e+3>>0]|0)<<24;n=(d[f+9>>0]|0)<<8|(d[f+8>>0]|0)|(d[f+10>>0]|0)<<16|(d[f+11>>0]|0)<<24;o=(d[e+17>>0]|0)<<8|(d[e+16>>0]|0)|(d[e+18>>0]|0)<<16|(d[e+19>>0]|0)<<24;p=(d[e+21>>0]|0)<<8|(d[e+20>>0]|0)|(d[e+22>>0]|0)<<16|(d[e+23>>0]|0)<<24;q=(d[e+25>>0]|0)<<8|(d[e+24>>0]|0)|(d[e+26>>0]|0)<<16|(d[e+27>>0]|0)<<24;r=(d[e+29>>0]|0)<<8|(d[e+28>>0]|0)|(d[e+30>>0]|0)<<16|(d[e+31>>0]|0)<<24;s=(d[f+13>>0]|0)<<8|(d[f+12>>0]|0)|(d[f+14>>0]|0)<<16|(d[f+15>>0]|0)<<24;t=(d[e+5>>0]|0)<<8|(d[e+4>>0]|0)|(d[e+6>>0]|0)<<16|(d[e+7>>0]|0)<<24;u=(d[e+9>>0]|0)<<8|(d[e+8>>0]|0)|(d[e+10>>0]|0)<<16|(d[e+11>>0]|0)<<24;j=(d[e+13>>0]|0)<<8|(d[e+12>>0]|0)|(d[e+14>>0]|0)<<16|(d[e+15>>0]|0)<<24;e=(d[f+5>>0]|0)<<8|(d[f+4>>0]|0)|(d[f+6>>0]|0)<<16|(d[f+7>>0]|0)<<24;g=(d[c+1>>0]|0)<<8|(d[c>>0]|0)|(d[c+2>>0]|0)<<16|(d[c+3>>0]|0)<<24;h=(d[c+5>>0]|0)<<8|(d[c+4>>0]|0)|(d[c+6>>0]|0)<<16|(d[c+7>>0]|0)<<24;i=(d[c+9>>0]|0)<<8|(d[c+8>>0]|0)|(d[c+10>>0]|0)<<16|(d[c+11>>0]|0)<<24;f=(d[c+13>>0]|0)<<8|(d[c+12>>0]|0)|(d[c+14>>0]|0)<<16|(d[c+15>>0]|0)<<24;while(1){D=p+l|0;D=(D>>>25|D<<7)^j;A=D+l|0;A=(A>>>23|A<<9)^i;x=A+D|0;x=(x>>>19|x<<13)^p;G=x+A|0;G=(G>>>14|G<<18)^l;z=e+m|0;z=f^(z>>>25|z<<7);w=z+e|0;w=q^(w>>>23|w<<9);J=w+z|0;J=(J>>>19|J<<13)^m;C=J+w|0;C=(C>>>14|C<<18)^e;v=n+g|0;v=r^(v>>>25|v<<7);I=v+n|0;I=(I>>>23|I<<9)^t;F=I+v|0;F=(F>>>19|F<<13)^g;y=F+I|0;y=(y>>>14|y<<18)^n;H=s+o|0;H=(H>>>25|H<<7)^u;E=H+s|0;E=(E>>>23|E<<9)^h;B=E+H|0;B=(B>>>19|B<<13)^o;c=B+E|0;c=(c>>>14|c<<18)^s;K=G+H|0;m=(K>>>25|K<<7)^J;J=m+G|0;t=(J>>>23|J<<9)^I;I=t+m|0;u=(I>>>19|I<<13)^H;H=u+t|0;l=(H>>>14|H<<18)^G;G=C+D|0;g=(G>>>25|G<<7)^F;F=g+C|0;h=(F>>>23|F<<9)^E;E=h+g|0;j=(E>>>19|E<<13)^D;D=j+h|0;e=(D>>>14|D<<18)^C;C=y+z|0;o=(C>>>25|C<<7)^B;B=o+y|0;i=(B>>>23|B<<9)^A;A=i+o|0;f=(A>>>19|A<<13)^z;z=f+i|0;n=(z>>>14|z<<18)^y;y=c+v|0;p=(y>>>25|y<<7)^x;x=p+c|0;q=(x>>>23|x<<9)^w;w=q+p|0;r=(w>>>19|w<<13)^v;v=r+q|0;s=(v>>>14|v<<18)^c;if((k|0)<=2)break;else k=k+-2|0}a[b>>0]=l;a[b+1>>0]=l>>>8;a[b+2>>0]=l>>>16;a[b+3>>0]=l>>>24;a[b+4>>0]=e;a[b+5>>0]=e>>>8;a[b+6>>0]=e>>>16;a[b+7>>0]=e>>>24;a[b+8>>0]=n;a[b+9>>0]=n>>>8;a[b+10>>0]=n>>>16;a[b+11>>0]=n>>>24;a[b+12>>0]=s;a[b+13>>0]=s>>>8;a[b+14>>0]=s>>>16;a[b+15>>0]=s>>>24;a[b+16>>0]=g;a[b+17>>0]=g>>>8;a[b+18>>0]=g>>>16;a[b+19>>0]=g>>>24;a[b+20>>0]=h;a[b+21>>0]=h>>>8;a[b+22>>0]=h>>>16;a[b+23>>0]=h>>>24;a[b+24>>0]=i;a[b+25>>0]=i>>>8;a[b+26>>0]=i>>>16;a[b+27>>0]=i>>>24;a[b+28>>0]=f;a[b+29>>0]=f>>>8;a[b+30>>0]=f>>>16;a[b+31>>0]=f>>>24;return}function ob(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;F=(d[f+1>>0]|0)<<8|(d[f>>0]|0)|(d[f+2>>0]|0)<<16|(d[f+3>>0]|0)<<24;G=(d[e+1>>0]|0)<<8|(d[e>>0]|0)|(d[e+2>>0]|0)<<16|(d[e+3>>0]|0)<<24;H=(d[e+5>>0]|0)<<8|(d[e+4>>0]|0)|(d[e+6>>0]|0)<<16|(d[e+7>>0]|0)<<24;I=(d[e+9>>0]|0)<<8|(d[e+8>>0]|0)|(d[e+10>>0]|0)<<16|(d[e+11>>0]|0)<<24;J=(d[e+13>>0]|0)<<8|(d[e+12>>0]|0)|(d[e+14>>0]|0)<<16|(d[e+15>>0]|0)<<24;B=(d[f+5>>0]|0)<<8|(d[f+4>>0]|0)|(d[f+6>>0]|0)<<16|(d[f+7>>0]|0)<<24;C=(d[c+1>>0]|0)<<8|(d[c>>0]|0)|(d[c+2>>0]|0)<<16|(d[c+3>>0]|0)<<24;D=(d[c+5>>0]|0)<<8|(d[c+4>>0]|0)|(d[c+6>>0]|0)<<16|(d[c+7>>0]|0)<<24;E=(d[c+9>>0]|0)<<8|(d[c+8>>0]|0)|(d[c+10>>0]|0)<<16|(d[c+11>>0]|0)<<24;w=(d[c+13>>0]|0)<<8|(d[c+12>>0]|0)|(d[c+14>>0]|0)<<16|(d[c+15>>0]|0)<<24;x=(d[f+9>>0]|0)<<8|(d[f+8>>0]|0)|(d[f+10>>0]|0)<<16|(d[f+11>>0]|0)<<24;y=(d[e+17>>0]|0)<<8|(d[e+16>>0]|0)|(d[e+18>>0]|0)<<16|(d[e+19>>0]|0)<<24;z=(d[e+21>>0]|0)<<8|(d[e+20>>0]|0)|(d[e+22>>0]|0)<<16|(d[e+23>>0]|0)<<24;A=(d[e+25>>0]|0)<<8|(d[e+24>>0]|0)|(d[e+26>>0]|0)<<16|(d[e+27>>0]|0)<<24;v=(d[e+29>>0]|0)<<8|(d[e+28>>0]|0)|(d[e+30>>0]|0)<<16|(d[e+31>>0]|0)<<24;f=(d[f+13>>0]|0)<<8|(d[f+12>>0]|0)|(d[f+14>>0]|0)<<16|(d[f+15>>0]|0)<<24;e=20;c=F;g=G;h=x;i=y;j=z;k=A;l=v;m=f;n=H;o=I;p=J;q=B;r=C;s=D;t=E;u=w;while(1){T=c+j|0;T=(T>>>25|T<<7)^p;Q=T+c|0;Q=(Q>>>23|Q<<9)^t;N=Q+T|0;N=(N>>>19|N<<13)^j;W=N+Q|0;W=(W>>>14|W<<18)^c;P=g+q|0;P=(P>>>25|P<<7)^u;M=P+q|0;M=(M>>>23|M<<9)^k;Z=M+P|0;Z=(Z>>>19|Z<<13)^g;S=Z+M|0;S=(S>>>14|S<<18)^q;L=r+h|0;L=(L>>>25|L<<7)^l;Y=L+h|0;Y=(Y>>>23|Y<<9)^n;V=Y+L|0;V=(V>>>19|V<<13)^r;O=V+Y|0;O=(O>>>14|O<<18)^h;X=i+m|0;X=o^(X>>>25|X<<7);U=X+m|0;U=(U>>>23|U<<9)^s;R=U+X|0;R=(R>>>19|R<<13)^i;K=R+U|0;K=(K>>>14|K<<18)^m;_=W+X|0;g=(_>>>25|_<<7)^Z;Z=g+W|0;n=(Z>>>23|Z<<9)^Y;Y=n+g|0;o=(Y>>>19|Y<<13)^X;X=o+n|0;c=(X>>>14|X<<18)^W;W=S+T|0;r=(W>>>25|W<<7)^V;V=r+S|0;s=(V>>>23|V<<9)^U;U=s+r|0;p=(U>>>19|U<<13)^T;T=p+s|0;q=(T>>>14|T<<18)^S;S=O+P|0;i=(S>>>25|S<<7)^R;R=i+O|0;t=(R>>>23|R<<9)^Q;Q=t+i|0;u=(Q>>>19|Q<<13)^P;P=u+t|0;h=(P>>>14|P<<18)^O;O=K+L|0;j=(O>>>25|O<<7)^N;N=j+K|0;k=(N>>>23|N<<9)^M;M=k+j|0;l=(M>>>19|M<<13)^L;L=l+k|0;m=(L>>>14|L<<18)^K;if((e|0)<=2)break;else e=e+-2|0}L=c+F|0;M=g+G|0;N=n+H|0;O=o+I|0;P=p+J|0;Q=q+B|0;R=r+C|0;S=s+D|0;T=t+E|0;U=u+w|0;V=h+x|0;W=i+y|0;X=j+z|0;Y=k+A|0;Z=l+v|0;_=m+f|0;a[b>>0]=L;a[b+1>>0]=L>>>8;a[b+2>>0]=L>>>16;a[b+3>>0]=L>>>24;a[b+4>>0]=M;a[b+5>>0]=M>>>8;a[b+6>>0]=M>>>16;a[b+7>>0]=M>>>24;a[b+8>>0]=N;a[b+9>>0]=N>>>8;a[b+10>>0]=N>>>16;a[b+11>>0]=N>>>24;a[b+12>>0]=O;a[b+13>>0]=O>>>8;a[b+14>>0]=O>>>16;a[b+15>>0]=O>>>24;a[b+16>>0]=P;a[b+17>>0]=P>>>8;a[b+18>>0]=P>>>16;a[b+19>>0]=P>>>24;a[b+20>>0]=Q;a[b+21>>0]=Q>>>8;a[b+22>>0]=Q>>>16;a[b+23>>0]=Q>>>24;a[b+24>>0]=R;a[b+25>>0]=R>>>8;a[b+26>>0]=R>>>16;a[b+27>>0]=R>>>24;a[b+28>>0]=S;a[b+29>>0]=S>>>8;a[b+30>>0]=S>>>16;a[b+31>>0]=S>>>24;a[b+32>>0]=T;a[b+33>>0]=T>>>8;a[b+34>>0]=T>>>16;a[b+35>>0]=T>>>24;a[b+36>>0]=U;a[b+37>>0]=U>>>8;a[b+38>>0]=U>>>16;a[b+39>>0]=U>>>24;a[b+40>>0]=V;a[b+41>>0]=V>>>8;a[b+42>>0]=V>>>16;a[b+43>>0]=V>>>24;a[b+44>>0]=W;a[b+45>>0]=W>>>8;a[b+46>>0]=W>>>16;a[b+47>>0]=W>>>24;a[b+48>>0]=X;a[b+49>>0]=X>>>8;a[b+50>>0]=X>>>16;a[b+51>>0]=X>>>24;a[b+52>>0]=Y;a[b+53>>0]=Y>>>8;a[b+54>>0]=Y>>>16;a[b+55>>0]=Y>>>24;a[b+56>>0]=Z;a[b+57>>0]=Z>>>8;a[b+58>>0]=Z>>>16;a[b+59>>0]=Z>>>24;a[b+60>>0]=_;a[b+61>>0]=_>>>8;a[b+62>>0]=_>>>16;a[b+63>>0]=_>>>24;return}function pb(){return 16}function qb(){return 64}function rb(){return 32}function sb(){return 16}function tb(){return 64}function ub(){return 32}function vb(){return 357}function wb(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=i;w=i=i+63&-64;i=i+496|0;x=w+360|0;if((e+-1|0)>>>0>63|k>>>0>64){b=-1;i=y;return b|0}if(e>>>0>=256)za(32608,32628,18,32680);if(k>>>0>=256)za(32707,32628,19,32680);v=e&255;m=k&255;do if((b|0)==0|(f|0)==0)l=-1;else{n=v+-1<<24>>24;if((j|0)==0|m<<24>>24==0){if((n&255)>63){l=-1;break}Hd(w|0,0,357)|0;l=w;c[l>>2]=e&255^-222443256;c[l+4>>2]=1779033703;l=w+8|0;c[l>>2]=-2067093701;c[l+4>>2]=-1150833019;l=w+16|0;c[l>>2]=-23791573;c[l+4>>2]=1013904242;l=w+24|0;c[l>>2]=1595750129;c[l+4>>2]=-1521486534;l=w+32|0;c[l>>2]=-1377402159;c[l+4>>2]=1359893119;l=w+40|0;c[l>>2]=725511199;c[l+4>>2]=-1694144372;l=w+48|0;c[l>>2]=-79577749;c[l+4>>2]=528734635;l=w+56|0;c[l>>2]=327033209;c[l+4>>2]=1541459225;l=0}else{if(((n|m+-1<<24>>24)&255)>63){l=-1;break}n=k&255;Hd(w|0,0,357)|0;p=Jd(n|0,0,8)|0;o=w;c[o>>2]=(p|e&255)^-222443256;c[o+4>>2]=C^1779033703;o=w+8|0;c[o>>2]=-2067093701;c[o+4>>2]=-1150833019;o=w+16|0;c[o>>2]=-23791573;c[o+4>>2]=1013904242;o=w+24|0;c[o>>2]=1595750129;c[o+4>>2]=-1521486534;o=w+32|0;c[o>>2]=-1377402159;c[o+4>>2]=1359893119;o=w+40|0;c[o>>2]=725511199;c[o+4>>2]=-1694144372;o=w+48|0;c[o>>2]=-79577749;c[o+4>>2]=528734635;o=w+56|0;c[o>>2]=327033209;c[o+4>>2]=1541459225;o=x;p=o+128|0;do{a[o>>0]=0;o=o+1|0}while((o|0)<(p|0));Kd(x|0,j|0,n|0)|0;n=w+352|0;o=w+96|0;l=x;p=o+128|0;do{a[o>>0]=a[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(p|0));c[n>>2]=128;l=128}a:do if(!((g|0)==0&(h|0)==0)){q=w+352|0;r=w+96|0;s=w+64|0;t=w+72|0;u=w+224|0;k=h;m=g;while(1){n=256-l|0;j=w+96+l|0;if(!(k>>>0>0|(k|0)==0&m>>>0>n>>>0))break;Kd(j|0,f|0,n|0)|0;c[q>>2]=(c[q>>2]|0)+n;p=s;o=c[p>>2]|0;p=c[p+4>>2]|0;g=Fd(o|0,p|0,128,0)|0;l=s;c[l>>2]=g;c[l+4>>2]=C;l=t;l=Fd((p>>>0>4294967295|(p|0)==-1&o>>>0>4294967167)&1|0,0,c[l>>2]|0,c[l+4>>2]|0)|0;o=t;c[o>>2]=l;c[o+4>>2]=C;Ab(w,r);o=r;l=u;p=o+128|0;do{c[o>>2]=c[l>>2];o=o+4|0;l=l+4|0}while((o|0)<(p|0));l=(c[q>>2]|0)+-128|0;c[q>>2]=l;j=Ed(m|0,k|0,n|0,0)|0;if((m|0)==(n|0)&(k|0)==0)break a;else{f=f+n|0;k=C;m=j}}Kd(j|0,f|0,m|0)|0;l=Fd(c[q>>2]|0,0,m|0,k|0)|0;c[q>>2]=l}while(0);j=e&255;if((v&255)<=64){k=w+352|0;n=w+64|0;if(l>>>0>128){e=n;v=c[e>>2]|0;e=c[e+4>>2]|0;l=Fd(v|0,e|0,128,0)|0;m=n;c[m>>2]=l;c[m+4>>2]=C;m=w+72|0;l=m;l=Fd((e>>>0>4294967295|(e|0)==-1&v>>>0>4294967167)&1|0,0,c[l>>2]|0,c[l+4>>2]|0)|0;v=m;c[v>>2]=l;c[v+4>>2]=C;v=w+96|0;Ab(w,v);l=(c[k>>2]|0)+-128|0;c[k>>2]=l;Ld(v|0,w+224|0,l|0)|0;l=c[k>>2]|0}else m=w+72|0;v=n;v=Fd(c[v>>2]|0,c[v+4>>2]|0,l|0,0)|0;g=C;u=n;c[u>>2]=v;c[u+4>>2]=g;u=m;e=u;u=u+4|0;u=Fd((g>>>0<0|(g|0)==0&v>>>0<l>>>0)&1|0,0,d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24|0,d[u>>0]|d[u+1>>0]<<8|d[u+2>>0]<<16|d[u+3>>0]<<24|0)|0;e=C;v=m;g=v;a[g>>0]=u;a[g+1>>0]=u>>8;a[g+2>>0]=u>>16;a[g+3>>0]=u>>24;v=v+4|0;a[v>>0]=e;a[v+1>>0]=e>>8;a[v+2>>0]=e>>16;a[v+3>>0]=e>>24;if(a[w+356>>0]|0){v=w+88|0;c[v>>2]=-1;c[v+4>>2]=-1}o=w+80|0;c[o>>2]=-1;c[o+4>>2]=-1;Hd(w+96+l|0,0,256-l|0)|0;Ab(w,w+96|0);o=x;l=w;p=o+64|0;do{a[o>>0]=a[l>>0]|0;o=o+1|0;l=l+1|0}while((o|0)<(p|0));Kd(b|0,x|0,j|0)|0}l=0}while(0);b=l;i=y;return b|0}function xb(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;j=i;f=i=i+63&-64;i=i+128|0;if(d>>>0>64|(e+-1|0)>>>0>63){b=-1;i=j;return b|0}if(e>>>0>=256)za(32608,32628,53,32727);if(d>>>0>=256)za(32707,32628,54,32727);g=((e&255)+-1&255)>63;if((c|0)==0|(d|0)==0){if(g){b=-1;i=j;return b|0}Hd(b|0,0,357)|0;e=e&255^-222443256;c=b;h=c;a[h>>0]=e;a[h+1>>0]=e>>8;a[h+2>>0]=e>>16;a[h+3>>0]=e>>24;c=c+4|0;a[c>>0]=103;a[c+1>>0]=230;a[c+2>>0]=9;a[c+3>>0]=106;c=b+8|0;h=c;a[h>>0]=-2067093701;a[h+1>>0]=-2067093701>>8;a[h+2>>0]=-2067093701>>16;a[h+3>>0]=-2067093701>>24;c=c+4|0;a[c>>0]=-1150833019;a[c+1>>0]=-1150833019>>8;a[c+2>>0]=-1150833019>>16;a[c+3>>0]=-1150833019>>24;c=b+16|0;h=c;a[h>>0]=-23791573;a[h+1>>0]=-23791573>>8;a[h+2>>0]=-23791573>>16;a[h+3>>0]=-23791573>>24;c=c+4|0;a[c>>0]=114;a[c+1>>0]=243;a[c+2>>0]=110;a[c+3>>0]=60;c=b+24|0;h=c;a[h>>0]=241;a[h+1>>0]=54;a[h+2>>0]=29;a[h+3>>0]=95;c=c+4|0;a[c>>0]=-1521486534;a[c+1>>0]=-1521486534>>8;a[c+2>>0]=-1521486534>>16;a[c+3>>0]=-1521486534>>24;c=b+32|0;h=c;a[h>>0]=-1377402159;a[h+1>>0]=-1377402159>>8;a[h+2>>0]=-1377402159>>16;a[h+3>>0]=-1377402159>>24;c=c+4|0;a[c>>0]=127;a[c+1>>0]=82;a[c+2>>0]=14;a[c+3>>0]=81;c=b+40|0;h=c;a[h>>0]=31;a[h+1>>0]=108;a[h+2>>0]=62;a[h+3>>0]=43;c=c+4|0;a[c>>0]=-1694144372;a[c+1>>0]=-1694144372>>8;a[c+2>>0]=-1694144372>>16;a[c+3>>0]=-1694144372>>24;c=b+48|0;h=c;a[h>>0]=-79577749;a[h+1>>0]=-79577749>>8;a[h+2>>0]=-79577749>>16;a[h+3>>0]=-79577749>>24;c=c+4|0;a[c>>0]=171;a[c+1>>0]=217;a[c+2>>0]=131;a[c+3>>0]=31;b=b+56|0;c=b;a[c>>0]=121;a[c+1>>0]=33;a[c+2>>0]=126;a[c+3>>0]=19;b=b+4|0;a[b>>0]=25;a[b+1>>0]=205;a[b+2>>0]=224;a[b+3>>0]=91;b=0;i=j;return b|0}if(g){b=-1;i=j;return b|0}if(((d&255)+-1&255)>63){b=-1;i=j;return b|0}d=d&255;Hd(b|0,0,357)|0;k=Jd(d|0,0,8)|0;k=(k|e&255)^-222443256;h=C^1779033703;e=b;g=e;a[g>>0]=k;a[g+1>>0]=k>>8;a[g+2>>0]=k>>16;a[g+3>>0]=k>>24;e=e+4|0;a[e>>0]=h;a[e+1>>0]=h>>8;a[e+2>>0]=h>>16;a[e+3>>0]=h>>24;e=b+8|0;h=e;a[h>>0]=-2067093701;a[h+1>>0]=-2067093701>>8;a[h+2>>0]=-2067093701>>16;a[h+3>>0]=-2067093701>>24;e=e+4|0;a[e>>0]=-1150833019;a[e+1>>0]=-1150833019>>8;a[e+2>>0]=-1150833019>>16;a[e+3>>0]=-1150833019>>24;e=b+16|0;h=e;a[h>>0]=-23791573;a[h+1>>0]=-23791573>>8;a[h+2>>0]=-23791573>>16;a[h+3>>0]=-23791573>>24;e=e+4|0;a[e>>0]=114;a[e+1>>0]=243;a[e+2>>0]=110;a[e+3>>0]=60;e=b+24|0;h=e;a[h>>0]=241;a[h+1>>0]=54;a[h+2>>0]=29;a[h+3>>0]=95;e=e+4|0;a[e>>0]=-1521486534;a[e+1>>0]=-1521486534>>8;a[e+2>>0]=-1521486534>>16;a[e+3>>0]=-1521486534>>24;e=b+32|0;h=e;a[h>>0]=-1377402159;a[h+1>>0]=-1377402159>>8;a[h+2>>0]=-1377402159>>16;a[h+3>>0]=-1377402159>>24;e=e+4|0;a[e>>0]=127;a[e+1>>0]=82;a[e+2>>0]=14;a[e+3>>0]=81;e=b+40|0;h=e;a[h>>0]=31;a[h+1>>0]=108;a[h+2>>0]=62;a[h+3>>0]=43;e=e+4|0;a[e>>0]=-1694144372;a[e+1>>0]=-1694144372>>8;a[e+2>>0]=-1694144372>>16;a[e+3>>0]=-1694144372>>24;e=b+48|0;h=e;a[h>>0]=-79577749;a[h+1>>0]=-79577749>>8;a[h+2>>0]=-79577749>>16;a[h+3>>0]=-79577749>>24;e=e+4|0;a[e>>0]=171;a[e+1>>0]=217;a[e+2>>0]=131;a[e+3>>0]=31;e=b+56|0;h=e;a[h>>0]=121;a[h+1>>0]=33;a[h+2>>0]=126;a[h+3>>0]=19;e=e+4|0;a[e>>0]=25;a[e+1>>0]=205;a[e+2>>0]=224;a[e+3>>0]=91;e=f;h=e+128|0;do{a[e>>0]=0;e=e+1|0}while((e|0)<(h|0));Kd(f|0,c|0,d|0)|0;g=b+352|0;e=b+96|0;h=e+128|0;do{a[e>>0]=a[f>>0]|0;e=e+1|0;f=f+1|0}while((e|0)<(h|0));a[g>>0]=128;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;k=0;i=j;return k|0}function yb(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;if((e|0)==0&(f|0)==0)return 0;k=b+352|0;l=b+96|0;m=b+64|0;n=b+72|0;o=b+224|0;h=d[k>>0]|d[k+1>>0]<<8|d[k+2>>0]<<16|d[k+3>>0]<<24;j=e;while(1){i=256-h|0;e=b+96+h|0;if(!(f>>>0>0|(f|0)==0&j>>>0>i>>>0))break;Kd(e|0,c|0,i|0)|0;h=(d[k>>0]|d[k+1>>0]<<8|d[k+2>>0]<<16|d[k+3>>0]<<24)+i|0;a[k>>0]=h;a[k+1>>0]=h>>8;a[k+2>>0]=h>>16;a[k+3>>0]=h>>24;h=m;e=h;e=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;h=h+4|0;h=d[h>>0]|d[h+1>>0]<<8|d[h+2>>0]<<16|d[h+3>>0]<<24;s=Fd(e|0,h|0,128,0)|0;g=C;q=m;r=q;a[r>>0]=s;a[r+1>>0]=s>>8;a[r+2>>0]=s>>16;a[r+3>>0]=s>>24;q=q+4|0;a[q>>0]=g;a[q+1>>0]=g>>8;a[q+2>>0]=g>>16;a[q+3>>0]=g>>24;q=n;g=q;q=q+4|0;q=Fd((h>>>0>4294967295|(h|0)==-1&e>>>0>4294967167)&1|0,0,d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24|0,d[q>>0]|d[q+1>>0]<<8|d[q+2>>0]<<16|d[q+3>>0]<<24|0)|0;g=C;e=n;h=e;a[h>>0]=q;a[h+1>>0]=q>>8;a[h+2>>0]=q>>16;a[h+3>>0]=q>>24;e=e+4|0;a[e>>0]=g;a[e+1>>0]=g>>8;a[e+2>>0]=g>>16;a[e+3>>0]=g>>24;Ab(b,l);e=l;g=o;h=e+128|0;do{a[e>>0]=a[g>>0]|0;e=e+1|0;g=g+1|0}while((e|0)<(h|0));h=(d[k>>0]|d[k+1>>0]<<8|d[k+2>>0]<<16|d[k+3>>0]<<24)+-128|0;a[k>>0]=h;a[k+1>>0]=h>>8;a[k+2>>0]=h>>16;a[k+3>>0]=h>>24;e=Ed(j|0,f|0,i|0,0)|0;if((j|0)==(i|0)&(f|0)==0){p=6;break}else{c=c+i|0;f=C;j=e}}if((p|0)==6)return 0;Kd(e|0,c|0,j|0)|0;s=Fd(d[k>>0]|d[k+1>>0]<<8|d[k+2>>0]<<16|d[k+3>>0]<<24|0,0,j|0,f|0)|0;a[k>>0]=s;a[k+1>>0]=s>>8;a[k+2>>0]=s>>16;a[k+3>>0]=s>>24;return 0}function zb(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;l=i;k=i=i+63&-64;i=i+64|0;if(e>>>0>=256)za(32608,32628,106,32759);j=e&255;if((e&255)>64){c=-1;i=l;return c|0}g=b+352|0;f=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;h=b+64|0;if(f>>>0>128){n=h;m=n;m=d[m>>0]|d[m+1>>0]<<8|d[m+2>>0]<<16|d[m+3>>0]<<24;n=n+4|0;n=d[n>>0]|d[n+1>>0]<<8|d[n+2>>0]<<16|d[n+3>>0]<<24;p=Fd(m|0,n|0,128,0)|0;o=C;e=h;f=e;a[f>>0]=p;a[f+1>>0]=p>>8;a[f+2>>0]=p>>16;a[f+3>>0]=p>>24;e=e+4|0;a[e>>0]=o;a[e+1>>0]=o>>8;a[e+2>>0]=o>>16;a[e+3>>0]=o>>24;e=b+72|0;o=e;f=o;o=o+4|0;o=Fd((n>>>0>4294967295|(n|0)==-1&m>>>0>4294967167)&1|0,0,d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24|0,d[o>>0]|d[o+1>>0]<<8|d[o+2>>0]<<16|d[o+3>>0]<<24|0)|0;f=C;m=e;n=m;a[n>>0]=o;a[n+1>>0]=o>>8;a[n+2>>0]=o>>16;a[n+3>>0]=o>>24;m=m+4|0;a[m>>0]=f;a[m+1>>0]=f>>8;a[m+2>>0]=f>>16;a[m+3>>0]=f>>24;m=b+96|0;Ab(b,m);f=(d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24)+-128|0;a[g>>0]=f;a[g+1>>0]=f>>8;a[g+2>>0]=f>>16;a[g+3>>0]=f>>24;Ld(m|0,b+224|0,f|0)|0;f=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24}else e=b+72|0;p=h;n=p;p=p+4|0;p=Fd(d[n>>0]|d[n+1>>0]<<8|d[n+2>>0]<<16|d[n+3>>0]<<24|0,d[p>>0]|d[p+1>>0]<<8|d[p+2>>0]<<16|d[p+3>>0]<<24|0,f|0,0)|0;n=C;m=h;o=m;a[o>>0]=p;a[o+1>>0]=p>>8;a[o+2>>0]=p>>16;a[o+3>>0]=p>>24;m=m+4|0;a[m>>0]=n;a[m+1>>0]=n>>8;a[m+2>>0]=n>>16;a[m+3>>0]=n>>24;m=e;o=m;m=m+4|0;m=Fd((n>>>0<0|(n|0)==0&p>>>0<f>>>0)&1|0,0,d[o>>0]|d[o+1>>0]<<8|d[o+2>>0]<<16|d[o+3>>0]<<24|0,d[m>>0]|d[m+1>>0]<<8|d[m+2>>0]<<16|d[m+3>>0]<<24|0)|0;o=C;p=e;n=p;a[n>>0]=m;a[n+1>>0]=m>>8;a[n+2>>0]=m>>16;a[n+3>>0]=m>>24;p=p+4|0;a[p>>0]=o;a[p+1>>0]=o>>8;a[p+2>>0]=o>>16;a[p+3>>0]=o>>24;if(a[b+356>>0]|0){p=b+88|0;o=p;a[o>>0]=-1;a[o+1>>0]=-1>>8;a[o+2>>0]=-1>>16;a[o+3>>0]=-1>>24;p=p+4|0;a[p>>0]=-1;a[p+1>>0]=-1>>8;a[p+2>>0]=-1>>16;a[p+3>>0]=-1>>24}g=b+80|0;e=g;a[e>>0]=-1;a[e+1>>0]=-1>>8;a[e+2>>0]=-1>>16;a[e+3>>0]=-1>>24;g=g+4|0;a[g>>0]=-1;a[g+1>>0]=-1>>8;a[g+2>>0]=-1>>16;a[g+3>>0]=-1>>24;Hd(b+96+f|0,0,256-f|0)|0;Ab(b,b+96|0);g=k;e=b;f=g+64|0;do{a[g>>0]=a[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(f|0));Kd(c|0,k|0,j|0)|0;p=0;i=l;return p|0}function Ab(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0;P=c;R=P;R=d[R>>0]|d[R+1>>0]<<8|d[R+2>>0]<<16|d[R+3>>0]<<24;P=P+4|0;P=d[P>>0]|d[P+1>>0]<<8|d[P+2>>0]<<16|d[P+3>>0]<<24;U=c+8|0;W=U;W=d[W>>0]|d[W+1>>0]<<8|d[W+2>>0]<<16|d[W+3>>0]<<24;U=U+4|0;U=d[U>>0]|d[U+1>>0]<<8|d[U+2>>0]<<16|d[U+3>>0]<<24;x=c+16|0;t=x;t=d[t>>0]|d[t+1>>0]<<8|d[t+2>>0]<<16|d[t+3>>0]<<24;x=x+4|0;x=d[x>>0]|d[x+1>>0]<<8|d[x+2>>0]<<16|d[x+3>>0]<<24;l=c+24|0;h=l;h=d[h>>0]|d[h+1>>0]<<8|d[h+2>>0]<<16|d[h+3>>0]<<24;l=l+4|0;l=d[l>>0]|d[l+1>>0]<<8|d[l+2>>0]<<16|d[l+3>>0]<<24;$=c+32|0;p=$;p=d[p>>0]|d[p+1>>0]<<8|d[p+2>>0]<<16|d[p+3>>0]<<24;$=$+4|0;$=d[$>>0]|d[$+1>>0]<<8|d[$+2>>0]<<16|d[$+3>>0]<<24;F=c+40|0;H=F;H=d[H>>0]|d[H+1>>0]<<8|d[H+2>>0]<<16|d[H+3>>0]<<24;F=F+4|0;F=d[F>>0]|d[F+1>>0]<<8|d[F+2>>0]<<16|d[F+3>>0]<<24;u=c+48|0;s=u;s=d[s>>0]|d[s+1>>0]<<8|d[s+2>>0]<<16|d[s+3>>0]<<24;u=u+4|0;u=d[u>>0]|d[u+1>>0]<<8|d[u+2>>0]<<16|d[u+3>>0]<<24;r=c+56|0;n=r;n=d[n>>0]|d[n+1>>0]<<8|d[n+2>>0]<<16|d[n+3>>0]<<24;r=r+4|0;r=d[r>>0]|d[r+1>>0]<<8|d[r+2>>0]<<16|d[r+3>>0]<<24;i=c+64|0;g=i;g=d[g>>0]|d[g+1>>0]<<8|d[g+2>>0]<<16|d[g+3>>0]<<24;i=i+4|0;i=d[i>>0]|d[i+1>>0]<<8|d[i+2>>0]<<16|d[i+3>>0]<<24;Y=c+72|0;j=Y;j=d[j>>0]|d[j+1>>0]<<8|d[j+2>>0]<<16|d[j+3>>0]<<24;Y=Y+4|0;Y=d[Y>>0]|d[Y+1>>0]<<8|d[Y+2>>0]<<16|d[Y+3>>0]<<24;o=c+80|0;m=o;m=d[m>>0]|d[m+1>>0]<<8|d[m+2>>0]<<16|d[m+3>>0]<<24;o=o+4|0;o=d[o>>0]|d[o+1>>0]<<8|d[o+2>>0]<<16|d[o+3>>0]<<24;K=c+88|0;M=K;M=d[M>>0]|d[M+1>>0]<<8|d[M+2>>0]<<16|d[M+3>>0]<<24;K=K+4|0;K=d[K>>0]|d[K+1>>0]<<8|d[K+2>>0]<<16|d[K+3>>0]<<24;f=c+96|0;e=f;e=d[e>>0]|d[e+1>>0]<<8|d[e+2>>0]<<16|d[e+3>>0]<<24;f=f+4|0;f=d[f>>0]|d[f+1>>0]<<8|d[f+2>>0]<<16|d[f+3>>0]<<24;S=c+104|0;B=S;B=d[B>>0]|d[B+1>>0]<<8|d[B+2>>0]<<16|d[B+3>>0]<<24;S=S+4|0;S=d[S>>0]|d[S+1>>0]<<8|d[S+2>>0]<<16|d[S+3>>0]<<24;sa=c+112|0;ra=sa;ra=d[ra>>0]|d[ra+1>>0]<<8|d[ra+2>>0]<<16|d[ra+3>>0]<<24;sa=sa+4|0;sa=d[sa>>0]|d[sa+1>>0]<<8|d[sa+2>>0]<<16|d[sa+3>>0]<<24;A=c+120|0;y=A;y=d[y>>0]|d[y+1>>0]<<8|d[y+2>>0]<<16|d[y+3>>0]<<24;A=A+4|0;A=d[A>>0]|d[A+1>>0]<<8|d[A+2>>0]<<16|d[A+3>>0]<<24;ca=b;v=ca;ca=ca+4|0;N=b+8|0;oa=N;na=oa;na=d[na>>0]|d[na+1>>0]<<8|d[na+2>>0]<<16|d[na+3>>0]<<24;oa=oa+4|0;oa=d[oa>>0]|d[oa+1>>0]<<8|d[oa+2>>0]<<16|d[oa+3>>0]<<24;I=b+16|0;ka=I;ja=ka;ja=d[ja>>0]|d[ja+1>>0]<<8|d[ja+2>>0]<<16|d[ja+3>>0]<<24;ka=ka+4|0;ka=d[ka>>0]|d[ka+1>>0]<<8|d[ka+2>>0]<<16|d[ka+3>>0]<<24;D=b+24|0;ga=D;fa=ga;fa=d[fa>>0]|d[fa+1>>0]<<8|d[fa+2>>0]<<16|d[fa+3>>0]<<24;ga=ga+4|0;ga=d[ga>>0]|d[ga+1>>0]<<8|d[ga+2>>0]<<16|d[ga+3>>0]<<24;w=b+32|0;ma=w;la=ma;la=d[la>>0]|d[la+1>>0]<<8|d[la+2>>0]<<16|d[la+3>>0]<<24;ma=ma+4|0;ma=d[ma>>0]|d[ma+1>>0]<<8|d[ma+2>>0]<<16|d[ma+3>>0]<<24;q=b+40|0;ia=q;ha=ia;ha=d[ha>>0]|d[ha+1>>0]<<8|d[ha+2>>0]<<16|d[ha+3>>0]<<24;ia=ia+4|0;ia=d[ia>>0]|d[ia+1>>0]<<8|d[ia+2>>0]<<16|d[ia+3>>0]<<24;k=b+48|0;ua=k;ta=ua;ta=d[ta>>0]|d[ta+1>>0]<<8|d[ta+2>>0]<<16|d[ta+3>>0]<<24;ua=ua+4|0;ua=d[ua>>0]|d[ua+1>>0]<<8|d[ua+2>>0]<<16|d[ua+3>>0]<<24;c=b+56|0;qa=c;pa=qa;pa=d[pa>>0]|d[pa+1>>0]<<8|d[pa+2>>0]<<16|d[pa+3>>0]<<24;qa=qa+4|0;qa=d[qa>>0]|d[qa+1>>0]<<8|d[qa+2>>0]<<16|d[qa+3>>0]<<24;ba=b+64|0;aa=ba;ba=ba+4|0;aa=(d[aa>>0]|d[aa+1>>0]<<8|d[aa+2>>0]<<16|d[aa+3>>0]<<24)^-1377402159;ba=(d[ba>>0]|d[ba+1>>0]<<8|d[ba+2>>0]<<16|d[ba+3>>0]<<24)^1359893119;_=b+72|0;Z=_;_=_+4|0;Z=(d[Z>>0]|d[Z+1>>0]<<8|d[Z+2>>0]<<16|d[Z+3>>0]<<24)^725511199;_=(d[_>>0]|d[_+1>>0]<<8|d[_+2>>0]<<16|d[_+3>>0]<<24)^-1694144372;X=b+80|0;V=X;X=X+4|0;V=(d[V>>0]|d[V+1>>0]<<8|d[V+2>>0]<<16|d[V+3>>0]<<24)^-79577749;X=(d[X>>0]|d[X+1>>0]<<8|d[X+2>>0]<<16|d[X+3>>0]<<24)^528734635;ea=b+88|0;da=ea;ea=ea+4|0;da=(d[da>>0]|d[da+1>>0]<<8|d[da+2>>0]<<16|d[da+3>>0]<<24)^327033209;ea=(d[ea>>0]|d[ea+1>>0]<<8|d[ea+2>>0]<<16|d[ea+3>>0]<<24)^1541459225;ca=Fd(la|0,ma|0,d[v>>0]|d[v+1>>0]<<8|d[v+2>>0]<<16|d[v+3>>0]<<24|0,d[ca>>0]|d[ca+1>>0]<<8|d[ca+2>>0]<<16|d[ca+3>>0]<<24|0)|0;ca=Fd(ca|0,C|0,R|0,P|0)|0;v=C;aa=aa^ca;ba=ba^v;Q=Fd(ba|0,aa|0,-205731576,1779033703)|0;T=C;la=Q^la;ma=T^ma;O=Id(la|0,ma|0,24)|0;L=C;ma=Jd(la|0,ma|0,40)|0;O=ma|O;L=C|L;v=Fd(W|0,U|0,ca|0,v|0)|0;v=Fd(v|0,C|0,O|0,L|0)|0;ca=C;ba=v^ba;aa=ca^aa;ma=Id(ba|0,aa|0,16)|0;la=C;aa=Jd(ba|0,aa|0,48)|0;ma=aa|ma;la=C|la;T=Fd(ma|0,la|0,Q|0,T|0)|0;Q=C;O=T^O;L=Q^L;aa=Id(O|0,L|0,63)|0;ba=C;L=Jd(O|0,L|0,1)|0;aa=L|aa;ba=C|ba;oa=Fd(ha|0,ia|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,t|0,x|0)|0;na=C;Z=Z^oa;_=_^na;L=Fd(_|0,Z|0,-2067093701,-1150833019)|0;O=C;ha=L^ha;ia=O^ia;J=Id(ha|0,ia|0,24)|0;G=C;ia=Jd(ha|0,ia|0,40)|0;J=ia|J;G=C|G;na=Fd(h|0,l|0,oa|0,na|0)|0;na=Fd(na|0,C|0,J|0,G|0)|0;oa=C;_=na^_;Z=oa^Z;ia=Id(_|0,Z|0,16)|0;ha=C;Z=Jd(_|0,Z|0,48)|0;ia=Z|ia;ha=C|ha;O=Fd(ia|0,ha|0,L|0,O|0)|0;L=C;J=O^J;G=L^G;Z=Id(J|0,G|0,63)|0;_=C;G=Jd(J|0,G|0,1)|0;Z=G|Z;_=C|_;ka=Fd(ta|0,ua|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,p|0,$|0)|0;ja=C;V=V^ka;X=X^ja;G=Fd(X|0,V|0,-23791573,1013904242)|0;J=C;ta=G^ta;ua=J^ua;E=Id(ta|0,ua|0,24)|0;z=C;ua=Jd(ta|0,ua|0,40)|0;E=ua|E;z=C|z;ja=Fd(H|0,F|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,E|0,z|0)|0;ka=C;X=ja^X;V=ka^V;ua=Id(X|0,V|0,16)|0;ta=C;V=Jd(X|0,V|0,48)|0;ua=V|ua;ta=C|ta;J=Fd(ua|0,ta|0,G|0,J|0)|0;G=C;E=J^E;z=G^z;V=Id(E|0,z|0,63)|0;X=C;z=Jd(E|0,z|0,1)|0;V=z|V;X=C|X;ga=Fd(pa|0,qa|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,s|0,u|0)|0;fa=C;da=da^ga;ea=ea^fa;z=Fd(ea|0,da|0,1595750129,-1521486534)|0;E=C;pa=z^pa;qa=E^qa;wa=Id(pa|0,qa|0,24)|0;va=C;qa=Jd(pa|0,qa|0,40)|0;wa=qa|wa;va=C|va;fa=Fd(n|0,r|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ea=fa^ea;da=ga^da;qa=Id(ea|0,da|0,16)|0;pa=C;da=Jd(ea|0,da|0,48)|0;qa=da|qa;pa=C|pa;E=Fd(qa|0,pa|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;da=Id(wa|0,va|0,63)|0;ea=C;va=Jd(wa|0,va|0,1)|0;da=va|da;ea=C|ea;ca=Fd(Z|0,_|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,g|0,i|0)|0;v=C;qa=qa^ca;pa=pa^v;G=Fd(pa|0,qa|0,J|0,G|0)|0;J=C;Z=G^Z;_=J^_;va=Id(Z|0,_|0,24)|0;wa=C;_=Jd(Z|0,_|0,40)|0;va=_|va;wa=C|wa;v=Fd(j|0,Y|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;pa=v^pa;qa=ca^qa;_=Id(pa|0,qa|0,16)|0;Z=C;qa=Jd(pa|0,qa|0,48)|0;_=qa|_;Z=C|Z;J=Fd(_|0,Z|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;qa=Id(va|0,wa|0,63)|0;pa=C;wa=Jd(va|0,wa|0,1)|0;qa=wa|qa;pa=C|pa;oa=Fd(V|0,X|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,m|0,o|0)|0;na=C;ma=ma^oa;la=la^na;z=Fd(la|0,ma|0,E|0,z|0)|0;E=C;V=z^V;X=E^X;wa=Id(V|0,X|0,24)|0;va=C;X=Jd(V|0,X|0,40)|0;wa=X|wa;va=C|va;na=Fd(M|0,K|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;la=na^la;ma=oa^ma;X=Id(la|0,ma|0,16)|0;V=C;ma=Jd(la|0,ma|0,48)|0;X=ma|X;V=C|V;E=Fd(X|0,V|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ma=Id(wa|0,va|0,63)|0;la=C;va=Jd(wa|0,va|0,1)|0;ma=va|ma;la=C|la;ka=Fd(da|0,ea|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,e|0,f|0)|0;ja=C;ia=ia^ka;ha=ha^ja;Q=Fd(ha|0,ia|0,T|0,Q|0)|0;T=C;da=Q^da;ea=T^ea;va=Id(da|0,ea|0,24)|0;wa=C;ea=Jd(da|0,ea|0,40)|0;va=ea|va;wa=C|wa;ja=Fd(B|0,S|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;ha=ja^ha;ia=ka^ia;ea=Id(ha|0,ia|0,16)|0;da=C;ia=Jd(ha|0,ia|0,48)|0;ea=ia|ea;da=C|da;T=Fd(ea|0,da|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;ia=Id(va|0,wa|0,63)|0;ha=C;wa=Jd(va|0,wa|0,1)|0;ia=wa|ia;ha=C|ha;ga=Fd(aa|0,ba|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,ra|0,sa|0)|0;fa=C;ua=ua^ga;ta=ta^fa;L=Fd(ta|0,ua|0,O|0,L|0)|0;O=C;aa=L^aa;ba=O^ba;wa=Id(aa|0,ba|0,24)|0;va=C;ba=Jd(aa|0,ba|0,40)|0;wa=ba|wa;va=C|va;fa=Fd(y|0,A|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ta=fa^ta;ua=ga^ua;ba=Id(ta|0,ua|0,16)|0;aa=C;ua=Jd(ta|0,ua|0,48)|0;ba=ua|ba;aa=C|aa;O=Fd(ba|0,aa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ua=Id(wa|0,va|0,63)|0;ta=C;va=Jd(wa|0,va|0,1)|0;ua=va|ua;ta=C|ta;ca=Fd(ra|0,sa|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,ua|0,ta|0)|0;v=C;X=ca^X;V=v^V;Q=Fd(V|0,X|0,T|0,Q|0)|0;T=C;ua=Q^ua;ta=T^ta;va=Id(ua|0,ta|0,24)|0;wa=C;ta=Jd(ua|0,ta|0,40)|0;va=ta|va;wa=C|wa;v=Fd(m|0,o|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;V=v^V;X=ca^X;ta=Id(V|0,X|0,16)|0;ua=C;X=Jd(V|0,X|0,48)|0;ta=X|ta;ua=C|ua;T=Fd(ta|0,ua|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;X=Id(va|0,wa|0,63)|0;V=C;wa=Jd(va|0,wa|0,1)|0;X=wa|X;V=C|V;oa=Fd(qa|0,pa|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,p|0,$|0)|0;na=C;ea=ea^oa;da=da^na;L=Fd(da|0,ea|0,O|0,L|0)|0;O=C;qa=L^qa;pa=O^pa;wa=Id(qa|0,pa|0,24)|0;va=C;pa=Jd(qa|0,pa|0,40)|0;wa=pa|wa;va=C|va;na=Fd(g|0,i|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;da=na^da;ea=oa^ea;pa=Id(da|0,ea|0,16)|0;qa=C;ea=Jd(da|0,ea|0,48)|0;pa=ea|pa;qa=C|qa;O=Fd(pa|0,qa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ea=Id(wa|0,va|0,63)|0;da=C;va=Jd(wa|0,va|0,1)|0;ea=va|ea;da=C|da;ka=Fd(ma|0,la|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,j|0,Y|0)|0;ja=C;ba=ba^ka;aa=aa^ja;G=Fd(aa|0,ba|0,J|0,G|0)|0;J=C;ma=G^ma;la=J^la;va=Id(ma|0,la|0,24)|0;wa=C;la=Jd(ma|0,la|0,40)|0;va=la|va;wa=C|wa;ja=Fd(y|0,A|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;aa=ja^aa;ba=ka^ba;la=Id(aa|0,ba|0,16)|0;ma=C;ba=Jd(aa|0,ba|0,48)|0;la=ba|la;ma=C|ma;J=Fd(la|0,ma|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;ba=Id(va|0,wa|0,63)|0;aa=C;wa=Jd(va|0,wa|0,1)|0;ba=wa|ba;aa=C|aa;ga=Fd(ia|0,ha|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,B|0,S|0)|0;fa=C;_=_^ga;Z=Z^fa;z=Fd(Z|0,_|0,E|0,z|0)|0;E=C;ia=z^ia;ha=E^ha;wa=Id(ia|0,ha|0,24)|0;va=C;ha=Jd(ia|0,ha|0,40)|0;wa=ha|wa;va=C|va;fa=Fd(s|0,u|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;Z=fa^Z;_=ga^_;ha=Id(Z|0,_|0,16)|0;ia=C;_=Jd(Z|0,_|0,48)|0;ha=_|ha;ia=C|ia;E=Fd(ha|0,ia|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;_=Id(wa|0,va|0,63)|0;Z=C;va=Jd(wa|0,va|0,1)|0;_=va|_;Z=C|Z;ca=Fd(ea|0,da|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,W|0,U|0)|0;v=C;ha=ha^ca;ia=ia^v;G=Fd(ia|0,ha|0,J|0,G|0)|0;J=C;ea=G^ea;da=J^da;va=Id(ea|0,da|0,24)|0;wa=C;da=Jd(ea|0,da|0,40)|0;va=da|va;wa=C|wa;v=Fd(e|0,f|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;ia=v^ia;ha=ca^ha;da=Id(ia|0,ha|0,16)|0;ea=C;ha=Jd(ia|0,ha|0,48)|0;da=ha|da;ea=C|ea;J=Fd(da|0,ea|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;ha=Id(va|0,wa|0,63)|0;ia=C;wa=Jd(va|0,wa|0,1)|0;ha=wa|ha;ia=C|ia;oa=Fd(ba|0,aa|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,R|0,P|0)|0;na=C;ta=ta^oa;ua=ua^na;z=Fd(ua|0,ta|0,E|0,z|0)|0;E=C;ba=z^ba;aa=E^aa;wa=Id(ba|0,aa|0,24)|0;va=C;aa=Jd(ba|0,aa|0,40)|0;wa=aa|wa;va=C|va;na=Fd(t|0,x|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;ua=na^ua;ta=oa^ta;aa=Id(ua|0,ta|0,16)|0;ba=C;ta=Jd(ua|0,ta|0,48)|0;aa=ta|aa;ba=C|ba;E=Fd(aa|0,ba|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ta=Id(wa|0,va|0,63)|0;ua=C;va=Jd(wa|0,va|0,1)|0;ta=va|ta;ua=C|ua;ka=Fd(_|0,Z|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,M|0,K|0)|0;ja=C;pa=pa^ka;qa=qa^ja;Q=Fd(qa|0,pa|0,T|0,Q|0)|0;T=C;_=Q^_;Z=T^Z;va=Id(_|0,Z|0,24)|0;wa=C;Z=Jd(_|0,Z|0,40)|0;va=Z|va;wa=C|wa;ja=Fd(n|0,r|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;qa=ja^qa;pa=ka^pa;Z=Id(qa|0,pa|0,16)|0;_=C;pa=Jd(qa|0,pa|0,48)|0;Z=pa|Z;_=C|_;T=Fd(Z|0,_|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;pa=Id(va|0,wa|0,63)|0;qa=C;wa=Jd(va|0,wa|0,1)|0;pa=wa|pa;qa=C|qa;ga=Fd(X|0,V|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,H|0,F|0)|0;fa=C;la=la^ga;ma=ma^fa;L=Fd(ma|0,la|0,O|0,L|0)|0;O=C;X=L^X;V=O^V;wa=Id(X|0,V|0,24)|0;va=C;V=Jd(X|0,V|0,40)|0;wa=V|wa;va=C|va;fa=Fd(h|0,l|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ma=fa^ma;la=ga^la;V=Id(ma|0,la|0,16)|0;X=C;la=Jd(ma|0,la|0,48)|0;V=la|V;X=C|X;O=Fd(V|0,X|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;la=Id(wa|0,va|0,63)|0;ma=C;va=Jd(wa|0,va|0,1)|0;la=va|la;ma=C|ma;ca=Fd(M|0,K|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,la|0,ma|0)|0;v=C;aa=ca^aa;ba=v^ba;Q=Fd(ba|0,aa|0,T|0,Q|0)|0;T=C;la=Q^la;ma=T^ma;va=Id(la|0,ma|0,24)|0;wa=C;ma=Jd(la|0,ma|0,40)|0;va=ma|va;wa=C|wa;v=Fd(g|0,i|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;ba=v^ba;aa=ca^aa;ma=Id(ba|0,aa|0,16)|0;la=C;aa=Jd(ba|0,aa|0,48)|0;ma=aa|ma;la=C|la;T=Fd(ma|0,la|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;aa=Id(va|0,wa|0,63)|0;ba=C;wa=Jd(va|0,wa|0,1)|0;aa=wa|aa;ba=C|ba;oa=Fd(ha|0,ia|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,e|0,f|0)|0;na=C;Z=Z^oa;_=_^na;L=Fd(_|0,Z|0,O|0,L|0)|0;O=C;ha=L^ha;ia=O^ia;wa=Id(ha|0,ia|0,24)|0;va=C;ia=Jd(ha|0,ia|0,40)|0;wa=ia|wa;va=C|va;na=Fd(R|0,P|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;_=na^_;Z=oa^Z;ia=Id(_|0,Z|0,16)|0;ha=C;Z=Jd(_|0,Z|0,48)|0;ia=Z|ia;ha=C|ha;O=Fd(ia|0,ha|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;Z=Id(wa|0,va|0,63)|0;_=C;va=Jd(wa|0,va|0,1)|0;Z=va|Z;_=C|_;ka=Fd(ta|0,ua|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,H|0,F|0)|0;ja=C;V=V^ka;X=X^ja;G=Fd(X|0,V|0,J|0,G|0)|0;J=C;ta=G^ta;ua=J^ua;va=Id(ta|0,ua|0,24)|0;wa=C;ua=Jd(ta|0,ua|0,40)|0;va=ua|va;wa=C|wa;ja=Fd(t|0,x|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;X=ja^X;V=ka^V;ua=Id(X|0,V|0,16)|0;ta=C;V=Jd(X|0,V|0,48)|0;ua=V|ua;ta=C|ta;J=Fd(ua|0,ta|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;V=Id(va|0,wa|0,63)|0;X=C;wa=Jd(va|0,wa|0,1)|0;V=wa|V;X=C|X;ga=Fd(pa|0,qa|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,y|0,A|0)|0;fa=C;da=da^ga;ea=ea^fa;z=Fd(ea|0,da|0,E|0,z|0)|0;E=C;pa=z^pa;qa=E^qa;wa=Id(pa|0,qa|0,24)|0;va=C;qa=Jd(pa|0,qa|0,40)|0;wa=qa|wa;va=C|va;fa=Fd(B|0,S|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ea=fa^ea;da=ga^da;qa=Id(ea|0,da|0,16)|0;pa=C;da=Jd(ea|0,da|0,48)|0;qa=da|qa;pa=C|pa;E=Fd(qa|0,pa|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;da=Id(wa|0,va|0,63)|0;ea=C;va=Jd(wa|0,va|0,1)|0;da=va|da;ea=C|ea;ca=Fd(Z|0,_|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,m|0,o|0)|0;v=C;qa=qa^ca;pa=pa^v;G=Fd(pa|0,qa|0,J|0,G|0)|0;J=C;Z=G^Z;_=J^_;va=Id(Z|0,_|0,24)|0;wa=C;_=Jd(Z|0,_|0,40)|0;va=_|va;wa=C|wa;v=Fd(ra|0,sa|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;pa=v^pa;qa=ca^qa;_=Id(pa|0,qa|0,16)|0;Z=C;qa=Jd(pa|0,qa|0,48)|0;_=qa|_;Z=C|Z;J=Fd(_|0,Z|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;qa=Id(va|0,wa|0,63)|0;pa=C;wa=Jd(va|0,wa|0,1)|0;qa=wa|qa;pa=C|pa;oa=Fd(V|0,X|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,h|0,l|0)|0;na=C;ma=ma^oa;la=la^na;z=Fd(la|0,ma|0,E|0,z|0)|0;E=C;V=z^V;X=E^X;wa=Id(V|0,X|0,24)|0;va=C;X=Jd(V|0,X|0,40)|0;wa=X|wa;va=C|va;na=Fd(s|0,u|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;la=na^la;ma=oa^ma;X=Id(la|0,ma|0,16)|0;V=C;ma=Jd(la|0,ma|0,48)|0;X=ma|X;V=C|V;E=Fd(X|0,V|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ma=Id(wa|0,va|0,63)|0;la=C;va=Jd(wa|0,va|0,1)|0;ma=va|ma;la=C|la;ka=Fd(da|0,ea|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,n|0,r|0)|0;ja=C;ia=ia^ka;ha=ha^ja;Q=Fd(ha|0,ia|0,T|0,Q|0)|0;T=C;da=Q^da;ea=T^ea;va=Id(da|0,ea|0,24)|0;wa=C;ea=Jd(da|0,ea|0,40)|0;va=ea|va;wa=C|wa;ja=Fd(W|0,U|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;ha=ja^ha;ia=ka^ia;ea=Id(ha|0,ia|0,16)|0;da=C;ia=Jd(ha|0,ia|0,48)|0;ea=ia|ea;da=C|da;T=Fd(ea|0,da|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;ia=Id(va|0,wa|0,63)|0;ha=C;wa=Jd(va|0,wa|0,1)|0;ia=wa|ia;ha=C|ha;ga=Fd(aa|0,ba|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,j|0,Y|0)|0;fa=C;ua=ua^ga;ta=ta^fa;L=Fd(ta|0,ua|0,O|0,L|0)|0;O=C;aa=L^aa;ba=O^ba;wa=Id(aa|0,ba|0,24)|0;va=C;ba=Jd(aa|0,ba|0,40)|0;wa=ba|wa;va=C|va;fa=Fd(p|0,$|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ta=fa^ta;ua=ga^ua;ba=Id(ta|0,ua|0,16)|0;aa=C;ua=Jd(ta|0,ua|0,48)|0;ba=ua|ba;aa=C|aa;O=Fd(ba|0,aa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ua=Id(wa|0,va|0,63)|0;ta=C;va=Jd(wa|0,va|0,1)|0;ua=va|ua;ta=C|ta;ca=Fd(n|0,r|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,ua|0,ta|0)|0;v=C;X=ca^X;V=v^V;Q=Fd(V|0,X|0,T|0,Q|0)|0;T=C;ua=Q^ua;ta=T^ta;va=Id(ua|0,ta|0,24)|0;wa=C;ta=Jd(ua|0,ta|0,40)|0;va=ta|va;wa=C|wa;v=Fd(j|0,Y|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;V=v^V;X=ca^X;ta=Id(V|0,X|0,16)|0;ua=C;X=Jd(V|0,X|0,48)|0;ta=X|ta;ua=C|ua;T=Fd(ta|0,ua|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;X=Id(va|0,wa|0,63)|0;V=C;wa=Jd(va|0,wa|0,1)|0;X=wa|X;V=C|V;oa=Fd(qa|0,pa|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,h|0,l|0)|0;na=C;ea=ea^oa;da=da^na;L=Fd(da|0,ea|0,O|0,L|0)|0;O=C;qa=L^qa;pa=O^pa;wa=Id(qa|0,pa|0,24)|0;va=C;pa=Jd(qa|0,pa|0,40)|0;wa=pa|wa;va=C|va;na=Fd(W|0,U|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;da=na^da;ea=oa^ea;pa=Id(da|0,ea|0,16)|0;qa=C;ea=Jd(da|0,ea|0,48)|0;pa=ea|pa;qa=C|qa;O=Fd(pa|0,qa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ea=Id(wa|0,va|0,63)|0;da=C;va=Jd(wa|0,va|0,1)|0;ea=va|ea;da=C|da;ka=Fd(ma|0,la|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,B|0,S|0)|0;ja=C;ba=ba^ka;aa=aa^ja;G=Fd(aa|0,ba|0,J|0,G|0)|0;J=C;ma=G^ma;la=J^la;va=Id(ma|0,la|0,24)|0;wa=C;la=Jd(ma|0,la|0,40)|0;va=la|va;wa=C|wa;ja=Fd(e|0,f|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;aa=ja^aa;ba=ka^ba;la=Id(aa|0,ba|0,16)|0;ma=C;ba=Jd(aa|0,ba|0,48)|0;la=ba|la;ma=C|ma;J=Fd(la|0,ma|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;ba=Id(va|0,wa|0,63)|0;aa=C;wa=Jd(va|0,wa|0,1)|0;ba=wa|ba;aa=C|aa;ga=Fd(ia|0,ha|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,M|0,K|0)|0;fa=C;_=_^ga;Z=Z^fa;z=Fd(Z|0,_|0,E|0,z|0)|0;E=C;ia=z^ia;ha=E^ha;wa=Id(ia|0,ha|0,24)|0;va=C;ha=Jd(ia|0,ha|0,40)|0;wa=ha|wa;va=C|va;fa=Fd(ra|0,sa|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;Z=fa^Z;_=ga^_;ha=Id(Z|0,_|0,16)|0;ia=C;_=Jd(Z|0,_|0,48)|0;ha=_|ha;ia=C|ia;E=Fd(ha|0,ia|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;_=Id(wa|0,va|0,63)|0;Z=C;va=Jd(wa|0,va|0,1)|0;_=va|_;Z=C|Z;ca=Fd(ea|0,da|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,t|0,x|0)|0;v=C;ha=ha^ca;ia=ia^v;G=Fd(ia|0,ha|0,J|0,G|0)|0;J=C;ea=G^ea;da=J^da;va=Id(ea|0,da|0,24)|0;wa=C;da=Jd(ea|0,da|0,40)|0;va=da|va;wa=C|wa;v=Fd(s|0,u|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;ia=v^ia;ha=ca^ha;da=Id(ia|0,ha|0,16)|0;ea=C;ha=Jd(ia|0,ha|0,48)|0;da=ha|da;ea=C|ea;J=Fd(da|0,ea|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;ha=Id(va|0,wa|0,63)|0;ia=C;wa=Jd(va|0,wa|0,1)|0;ha=wa|ha;ia=C|ia;oa=Fd(ba|0,aa|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,H|0,F|0)|0;na=C;ta=ta^oa;ua=ua^na;z=Fd(ua|0,ta|0,E|0,z|0)|0;E=C;ba=z^ba;aa=E^aa;wa=Id(ba|0,aa|0,24)|0;va=C;aa=Jd(ba|0,aa|0,40)|0;wa=aa|wa;va=C|va;na=Fd(m|0,o|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;ua=na^ua;ta=oa^ta;aa=Id(ua|0,ta|0,16)|0;ba=C;ta=Jd(ua|0,ta|0,48)|0;aa=ta|aa;ba=C|ba;E=Fd(aa|0,ba|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ta=Id(wa|0,va|0,63)|0;ua=C;va=Jd(wa|0,va|0,1)|0;ta=va|ta;ua=C|ua;ka=Fd(_|0,Z|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,p|0,$|0)|0;ja=C;pa=pa^ka;qa=qa^ja;Q=Fd(qa|0,pa|0,T|0,Q|0)|0;T=C;_=Q^_;Z=T^Z;va=Id(_|0,Z|0,24)|0;wa=C;Z=Jd(_|0,Z|0,40)|0;va=Z|va;wa=C|wa;ja=Fd(R|0,P|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;qa=ja^qa;pa=ka^pa;Z=Id(qa|0,pa|0,16)|0;_=C;pa=Jd(qa|0,pa|0,48)|0;Z=pa|Z;_=C|_;T=Fd(Z|0,_|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;pa=Id(va|0,wa|0,63)|0;qa=C;wa=Jd(va|0,wa|0,1)|0;pa=wa|pa;qa=C|qa;ga=Fd(X|0,V|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,y|0,A|0)|0;fa=C;la=la^ga;ma=ma^fa;L=Fd(ma|0,la|0,O|0,L|0)|0;O=C;X=L^X;V=O^V;wa=Id(X|0,V|0,24)|0;va=C;V=Jd(X|0,V|0,40)|0;wa=V|wa;va=C|va;fa=Fd(g|0,i|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ma=fa^ma;la=ga^la;V=Id(ma|0,la|0,16)|0;X=C;la=Jd(ma|0,la|0,48)|0;V=la|V;X=C|X;O=Fd(V|0,X|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;la=Id(wa|0,va|0,63)|0;ma=C;va=Jd(wa|0,va|0,1)|0;la=va|la;ma=C|ma;ca=Fd(j|0,Y|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,la|0,ma|0)|0;v=C;aa=ca^aa;ba=v^ba;Q=Fd(ba|0,aa|0,T|0,Q|0)|0;T=C;la=Q^la;ma=T^ma;va=Id(la|0,ma|0,24)|0;wa=C;ma=Jd(la|0,ma|0,40)|0;va=ma|va;wa=C|wa;v=Fd(R|0,P|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;ba=v^ba;aa=ca^aa;ma=Id(ba|0,aa|0,16)|0;la=C;aa=Jd(ba|0,aa|0,48)|0;ma=aa|ma;la=C|la;T=Fd(ma|0,la|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;aa=Id(va|0,wa|0,63)|0;ba=C;wa=Jd(va|0,wa|0,1)|0;aa=wa|aa;ba=C|ba;oa=Fd(ha|0,ia|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,H|0,F|0)|0;na=C;Z=Z^oa;_=_^na;L=Fd(_|0,Z|0,O|0,L|0)|0;O=C;ha=L^ha;ia=O^ia;wa=Id(ha|0,ia|0,24)|0;va=C;ia=Jd(ha|0,ia|0,40)|0;wa=ia|wa;va=C|va;na=Fd(n|0,r|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;_=na^_;Z=oa^Z;ia=Id(_|0,Z|0,16)|0;ha=C;Z=Jd(_|0,Z|0,48)|0;ia=Z|ia;ha=C|ha;O=Fd(ia|0,ha|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;Z=Id(wa|0,va|0,63)|0;_=C;va=Jd(wa|0,va|0,1)|0;Z=va|Z;_=C|_;ka=Fd(ta|0,ua|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,t|0,x|0)|0;ja=C;V=V^ka;X=X^ja;G=Fd(X|0,V|0,J|0,G|0)|0;J=C;ta=G^ta;ua=J^ua;va=Id(ta|0,ua|0,24)|0;wa=C;ua=Jd(ta|0,ua|0,40)|0;va=ua|va;wa=C|wa;ja=Fd(p|0,$|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;X=ja^X;V=ka^V;ua=Id(X|0,V|0,16)|0;ta=C;V=Jd(X|0,V|0,48)|0;ua=V|ua;ta=C|ta;J=Fd(ua|0,ta|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;V=Id(va|0,wa|0,63)|0;X=C;wa=Jd(va|0,wa|0,1)|0;V=wa|V;X=C|X;ga=Fd(pa|0,qa|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,m|0,o|0)|0;fa=C;da=da^ga;ea=ea^fa;z=Fd(ea|0,da|0,E|0,z|0)|0;E=C;pa=z^pa;qa=E^qa;wa=Id(pa|0,qa|0,24)|0;va=C;qa=Jd(pa|0,qa|0,40)|0;wa=qa|wa;va=C|va;fa=Fd(y|0,A|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ea=fa^ea;da=ga^da;qa=Id(ea|0,da|0,16)|0;pa=C;da=Jd(ea|0,da|0,48)|0;qa=da|qa;pa=C|pa;E=Fd(qa|0,pa|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;da=Id(wa|0,va|0,63)|0;ea=C;va=Jd(wa|0,va|0,1)|0;da=va|da;ea=C|ea;ca=Fd(Z|0,_|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,ra|0,sa|0)|0;v=C;qa=qa^ca;pa=pa^v;G=Fd(pa|0,qa|0,J|0,G|0)|0;J=C;Z=G^Z;_=J^_;va=Id(Z|0,_|0,24)|0;wa=C;_=Jd(Z|0,_|0,40)|0;va=_|va;wa=C|wa;v=Fd(W|0,U|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;pa=v^pa;qa=ca^qa;_=Id(pa|0,qa|0,16)|0;Z=C;qa=Jd(pa|0,qa|0,48)|0;_=qa|_;Z=C|Z;J=Fd(_|0,Z|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;qa=Id(va|0,wa|0,63)|0;pa=C;wa=Jd(va|0,wa|0,1)|0;qa=wa|qa;pa=C|pa;oa=Fd(V|0,X|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,M|0,K|0)|0;na=C;ma=ma^oa;la=la^na;z=Fd(la|0,ma|0,E|0,z|0)|0;E=C;V=z^V;X=E^X;wa=Id(V|0,X|0,24)|0;va=C;X=Jd(V|0,X|0,40)|0;wa=X|wa;va=C|va;na=Fd(e|0,f|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;la=na^la;ma=oa^ma;X=Id(la|0,ma|0,16)|0;V=C;ma=Jd(la|0,ma|0,48)|0;X=ma|X;V=C|V;E=Fd(X|0,V|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ma=Id(wa|0,va|0,63)|0;la=C;va=Jd(wa|0,va|0,1)|0;ma=va|ma;la=C|la;ka=Fd(da|0,ea|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,s|0,u|0)|0;ja=C;ia=ia^ka;ha=ha^ja;Q=Fd(ha|0,ia|0,T|0,Q|0)|0;T=C;da=Q^da;ea=T^ea;va=Id(da|0,ea|0,24)|0;wa=C;ea=Jd(da|0,ea|0,40)|0;va=ea|va;wa=C|wa;ja=Fd(g|0,i|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;ha=ja^ha;ia=ka^ia;ea=Id(ha|0,ia|0,16)|0;da=C;ia=Jd(ha|0,ia|0,48)|0;ea=ia|ea;da=C|da;T=Fd(ea|0,da|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;ia=Id(va|0,wa|0,63)|0;ha=C;wa=Jd(va|0,wa|0,1)|0;ia=wa|ia;ha=C|ha;ga=Fd(aa|0,ba|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,h|0,l|0)|0;fa=C;ua=ua^ga;ta=ta^fa;L=Fd(ta|0,ua|0,O|0,L|0)|0;O=C;aa=L^aa;ba=O^ba;wa=Id(aa|0,ba|0,24)|0;va=C;ba=Jd(aa|0,ba|0,40)|0;wa=ba|wa;va=C|va;fa=Fd(B|0,S|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ta=fa^ta;ua=ga^ua;ba=Id(ta|0,ua|0,16)|0;aa=C;ua=Jd(ta|0,ua|0,48)|0;ba=ua|ba;aa=C|aa;O=Fd(ba|0,aa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ua=Id(wa|0,va|0,63)|0;ta=C;va=Jd(wa|0,va|0,1)|0;ua=va|ua;ta=C|ta;ca=Fd(t|0,x|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,ua|0,ta|0)|0;v=C;X=ca^X;V=v^V;Q=Fd(V|0,X|0,T|0,Q|0)|0;T=C;ua=Q^ua;ta=T^ta;va=Id(ua|0,ta|0,24)|0;wa=C;ta=Jd(ua|0,ta|0,40)|0;va=ta|va;wa=C|wa;v=Fd(e|0,f|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;V=v^V;X=ca^X;ta=Id(V|0,X|0,16)|0;ua=C;X=Jd(V|0,X|0,48)|0;ta=X|ta;ua=C|ua;T=Fd(ta|0,ua|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;X=Id(va|0,wa|0,63)|0;V=C;wa=Jd(va|0,wa|0,1)|0;X=wa|X;V=C|V;oa=Fd(qa|0,pa|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,s|0,u|0)|0;na=C;ea=ea^oa;da=da^na;L=Fd(da|0,ea|0,O|0,L|0)|0;O=C;qa=L^qa;pa=O^pa;wa=Id(qa|0,pa|0,24)|0;va=C;pa=Jd(qa|0,pa|0,40)|0;wa=pa|wa;va=C|va;na=Fd(m|0,o|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;da=na^da;ea=oa^ea;pa=Id(da|0,ea|0,16)|0;qa=C;ea=Jd(da|0,ea|0,48)|0;pa=ea|pa;qa=C|qa;O=Fd(pa|0,qa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ea=Id(wa|0,va|0,63)|0;da=C;va=Jd(wa|0,va|0,1)|0;ea=va|ea;da=C|da;ka=Fd(ma|0,la|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,R|0,P|0)|0;ja=C;ba=ba^ka;aa=aa^ja;G=Fd(aa|0,ba|0,J|0,G|0)|0;J=C;ma=G^ma;la=J^la;va=Id(ma|0,la|0,24)|0;wa=C;la=Jd(ma|0,la|0,40)|0;va=la|va;wa=C|wa;ja=Fd(M|0,K|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;aa=ja^aa;ba=ka^ba;la=Id(aa|0,ba|0,16)|0;ma=C;ba=Jd(aa|0,ba|0,48)|0;la=ba|la;ma=C|ma;J=Fd(la|0,ma|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;ba=Id(va|0,wa|0,63)|0;aa=C;wa=Jd(va|0,wa|0,1)|0;ba=wa|ba;aa=C|aa;ga=Fd(ia|0,ha|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,g|0,i|0)|0;fa=C;_=_^ga;Z=Z^fa;z=Fd(Z|0,_|0,E|0,z|0)|0;E=C;ia=z^ia;ha=E^ha;wa=Id(ia|0,ha|0,24)|0;va=C;ha=Jd(ia|0,ha|0,40)|0;wa=ha|wa;va=C|va;fa=Fd(h|0,l|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;Z=fa^Z;_=ga^_;ha=Id(Z|0,_|0,16)|0;ia=C;_=Jd(Z|0,_|0,48)|0;ha=_|ha;ia=C|ia;E=Fd(ha|0,ia|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;_=Id(wa|0,va|0,63)|0;Z=C;va=Jd(wa|0,va|0,1)|0;_=va|_;Z=C|Z;ca=Fd(ea|0,da|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,p|0,$|0)|0;v=C;ha=ha^ca;ia=ia^v;G=Fd(ia|0,ha|0,J|0,G|0)|0;J=C;ea=G^ea;da=J^da;va=Id(ea|0,da|0,24)|0;wa=C;da=Jd(ea|0,da|0,40)|0;va=da|va;wa=C|wa;v=Fd(B|0,S|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;ia=v^ia;ha=ca^ha;da=Id(ia|0,ha|0,16)|0;ea=C;ha=Jd(ia|0,ha|0,48)|0;da=ha|da;ea=C|ea;J=Fd(da|0,ea|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;ha=Id(va|0,wa|0,63)|0;ia=C;wa=Jd(va|0,wa|0,1)|0;ha=wa|ha;ia=C|ia;oa=Fd(ba|0,aa|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,n|0,r|0)|0;na=C;ta=ta^oa;ua=ua^na;z=Fd(ua|0,ta|0,E|0,z|0)|0;E=C;ba=z^ba;aa=E^aa;wa=Id(ba|0,aa|0,24)|0;va=C;aa=Jd(ba|0,aa|0,40)|0;wa=aa|wa;va=C|va;na=Fd(H|0,F|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;ua=na^ua;ta=oa^ta;aa=Id(ua|0,ta|0,16)|0;ba=C;ta=Jd(ua|0,ta|0,48)|0;aa=ta|aa;ba=C|ba;E=Fd(aa|0,ba|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ta=Id(wa|0,va|0,63)|0;ua=C;va=Jd(wa|0,va|0,1)|0;ta=va|ta;ua=C|ua;ka=Fd(_|0,Z|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,y|0,A|0)|0;ja=C;pa=pa^ka;qa=qa^ja;Q=Fd(qa|0,pa|0,T|0,Q|0)|0;T=C;_=Q^_;Z=T^Z;va=Id(_|0,Z|0,24)|0;wa=C;Z=Jd(_|0,Z|0,40)|0;va=Z|va;wa=C|wa;ja=Fd(ra|0,sa|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;qa=ja^qa;pa=ka^pa;Z=Id(qa|0,pa|0,16)|0;_=C;pa=Jd(qa|0,pa|0,48)|0;Z=pa|Z;_=C|_;T=Fd(Z|0,_|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;pa=Id(va|0,wa|0,63)|0;qa=C;wa=Jd(va|0,wa|0,1)|0;pa=wa|pa;qa=C|qa;ga=Fd(X|0,V|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,W|0,U|0)|0;fa=C;la=la^ga;ma=ma^fa;L=Fd(ma|0,la|0,O|0,L|0)|0;O=C;X=L^X;V=O^V;wa=Id(X|0,V|0,24)|0;va=C;V=Jd(X|0,V|0,40)|0;wa=V|wa;va=C|va;fa=Fd(j|0,Y|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ma=fa^ma;la=ga^la;V=Id(ma|0,la|0,16)|0;X=C;la=Jd(ma|0,la|0,48)|0;V=la|V;X=C|X;O=Fd(V|0,X|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;la=Id(wa|0,va|0,63)|0;ma=C;va=Jd(wa|0,va|0,1)|0;la=va|la;ma=C|ma;ca=Fd(e|0,f|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,la|0,ma|0)|0;v=C;aa=ca^aa;ba=v^ba;Q=Fd(ba|0,aa|0,T|0,Q|0)|0;T=C;la=Q^la;ma=T^ma;va=Id(la|0,ma|0,24)|0;wa=C;ma=Jd(la|0,ma|0,40)|0;va=ma|va;wa=C|wa;v=Fd(H|0,F|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;ba=v^ba;aa=ca^aa;ma=Id(ba|0,aa|0,16)|0;la=C;aa=Jd(ba|0,aa|0,48)|0;ma=aa|ma;la=C|la;T=Fd(ma|0,la|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;aa=Id(va|0,wa|0,63)|0;ba=C;wa=Jd(va|0,wa|0,1)|0;aa=wa|aa;ba=C|ba;oa=Fd(ha|0,ia|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,W|0,U|0)|0;na=C;Z=Z^oa;_=_^na;L=Fd(_|0,Z|0,O|0,L|0)|0;O=C;ha=L^ha;ia=O^ia;wa=Id(ha|0,ia|0,24)|0;va=C;ia=Jd(ha|0,ia|0,40)|0;wa=ia|wa;va=C|va;na=Fd(y|0,A|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;_=na^_;Z=oa^Z;ia=Id(_|0,Z|0,16)|0;ha=C;Z=Jd(_|0,Z|0,48)|0;ia=Z|ia;ha=C|ha;O=Fd(ia|0,ha|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;Z=Id(wa|0,va|0,63)|0;_=C;va=Jd(wa|0,va|0,1)|0;Z=va|Z;_=C|_;ka=Fd(ta|0,ua|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,ra|0,sa|0)|0;ja=C;V=V^ka;X=X^ja;G=Fd(X|0,V|0,J|0,G|0)|0;J=C;ta=G^ta;ua=J^ua;va=Id(ta|0,ua|0,24)|0;wa=C;ua=Jd(ta|0,ua|0,40)|0;va=ua|va;wa=C|wa;ja=Fd(B|0,S|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;X=ja^X;V=ka^V;ua=Id(X|0,V|0,16)|0;ta=C;V=Jd(X|0,V|0,48)|0;ua=V|ua;ta=C|ta;J=Fd(ua|0,ta|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;V=Id(va|0,wa|0,63)|0;X=C;wa=Jd(va|0,wa|0,1)|0;V=wa|V;X=C|X;ga=Fd(pa|0,qa|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,p|0,$|0)|0;fa=C;da=da^ga;ea=ea^fa;z=Fd(ea|0,da|0,E|0,z|0)|0;E=C;pa=z^pa;qa=E^qa;wa=Id(pa|0,qa|0,24)|0;va=C;qa=Jd(pa|0,qa|0,40)|0;wa=qa|wa;va=C|va;fa=Fd(m|0,o|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ea=fa^ea;da=ga^da;qa=Id(ea|0,da|0,16)|0;pa=C;da=Jd(ea|0,da|0,48)|0;qa=da|qa;pa=C|pa;E=Fd(qa|0,pa|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;da=Id(wa|0,va|0,63)|0;ea=C;va=Jd(wa|0,va|0,1)|0;da=va|da;ea=C|ea;ca=Fd(Z|0,_|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,R|0,P|0)|0;v=C;qa=qa^ca;pa=pa^v;G=Fd(pa|0,qa|0,J|0,G|0)|0;J=C;Z=G^Z;_=J^_;va=Id(Z|0,_|0,24)|0;wa=C;_=Jd(Z|0,_|0,40)|0;va=_|va;wa=C|wa;v=Fd(n|0,r|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;pa=v^pa;qa=ca^qa;_=Id(pa|0,qa|0,16)|0;Z=C;qa=Jd(pa|0,qa|0,48)|0;_=qa|_;Z=C|Z;J=Fd(_|0,Z|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;qa=Id(va|0,wa|0,63)|0;pa=C;wa=Jd(va|0,wa|0,1)|0;qa=wa|qa;pa=C|pa;oa=Fd(V|0,X|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,s|0,u|0)|0;na=C;ma=ma^oa;la=la^na;z=Fd(la|0,ma|0,E|0,z|0)|0;E=C;V=z^V;X=E^X;wa=Id(V|0,X|0,24)|0;va=C;X=Jd(V|0,X|0,40)|0;wa=X|wa;va=C|va;na=Fd(h|0,l|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;la=na^la;ma=oa^ma;X=Id(la|0,ma|0,16)|0;V=C;ma=Jd(la|0,ma|0,48)|0;X=ma|X;V=C|V;E=Fd(X|0,V|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ma=Id(wa|0,va|0,63)|0;la=C;va=Jd(wa|0,va|0,1)|0;ma=va|ma;la=C|la;ka=Fd(da|0,ea|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,j|0,Y|0)|0;ja=C;ia=ia^ka;ha=ha^ja;Q=Fd(ha|0,ia|0,T|0,Q|0)|0;T=C;da=Q^da;ea=T^ea;va=Id(da|0,ea|0,24)|0;wa=C;ea=Jd(da|0,ea|0,40)|0;va=ea|va;wa=C|wa;ja=Fd(t|0,x|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;ha=ja^ha;ia=ka^ia;ea=Id(ha|0,ia|0,16)|0;da=C;ia=Jd(ha|0,ia|0,48)|0;ea=ia|ea;da=C|da;T=Fd(ea|0,da|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;ia=Id(va|0,wa|0,63)|0;ha=C;wa=Jd(va|0,wa|0,1)|0;ia=wa|ia;ha=C|ha;ga=Fd(aa|0,ba|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,g|0,i|0)|0;fa=C;ua=ua^ga;ta=ta^fa;L=Fd(ta|0,ua|0,O|0,L|0)|0;O=C;aa=L^aa;ba=O^ba;wa=Id(aa|0,ba|0,24)|0;va=C;ba=Jd(aa|0,ba|0,40)|0;wa=ba|wa;va=C|va;fa=Fd(M|0,K|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ta=fa^ta;ua=ga^ua;ba=Id(ta|0,ua|0,16)|0;aa=C;ua=Jd(ta|0,ua|0,48)|0;ba=ua|ba;aa=C|aa;O=Fd(ba|0,aa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ua=Id(wa|0,va|0,63)|0;ta=C;va=Jd(wa|0,va|0,1)|0;ua=va|ua;ta=C|ta;ca=Fd(B|0,S|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,ua|0,ta|0)|0;v=C;X=ca^X;V=v^V;Q=Fd(V|0,X|0,T|0,Q|0)|0;T=C;ua=Q^ua;ta=T^ta;va=Id(ua|0,ta|0,24)|0;wa=C;ta=Jd(ua|0,ta|0,40)|0;va=ta|va;wa=C|wa;v=Fd(M|0,K|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;V=v^V;X=ca^X;ta=Id(V|0,X|0,16)|0;ua=C;X=Jd(V|0,X|0,48)|0;ta=X|ta;ua=C|ua;T=Fd(ta|0,ua|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;X=Id(va|0,wa|0,63)|0;V=C;wa=Jd(va|0,wa|0,1)|0;X=wa|X;V=C|V;oa=Fd(qa|0,pa|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,n|0,r|0)|0;na=C;ea=ea^oa;da=da^na;L=Fd(da|0,ea|0,O|0,L|0)|0;O=C;qa=L^qa;pa=O^pa;wa=Id(qa|0,pa|0,24)|0;va=C;pa=Jd(qa|0,pa|0,40)|0;wa=pa|wa;va=C|va;na=Fd(ra|0,sa|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;da=na^da;ea=oa^ea;pa=Id(da|0,ea|0,16)|0;qa=C;ea=Jd(da|0,ea|0,48)|0;pa=ea|pa;qa=C|qa;O=Fd(pa|0,qa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ea=Id(wa|0,va|0,63)|0;da=C;va=Jd(wa|0,va|0,1)|0;ea=va|ea;da=C|da;ka=Fd(ma|0,la|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,e|0,f|0)|0;ja=C;ba=ba^ka;aa=aa^ja;G=Fd(aa|0,ba|0,J|0,G|0)|0;J=C;ma=G^ma;la=J^la;va=Id(ma|0,la|0,24)|0;wa=C;la=Jd(ma|0,la|0,40)|0;va=la|va;wa=C|wa;ja=Fd(W|0,U|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;aa=ja^aa;ba=ka^ba;la=Id(aa|0,ba|0,16)|0;ma=C;ba=Jd(aa|0,ba|0,48)|0;la=ba|la;ma=C|ma;J=Fd(la|0,ma|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;ba=Id(va|0,wa|0,63)|0;aa=C;wa=Jd(va|0,wa|0,1)|0;ba=wa|ba;aa=C|aa;ga=Fd(ia|0,ha|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,h|0,l|0)|0;fa=C;_=_^ga;Z=Z^fa;z=Fd(Z|0,_|0,E|0,z|0)|0;E=C;ia=z^ia;ha=E^ha;wa=Id(ia|0,ha|0,24)|0;va=C;ha=Jd(ia|0,ha|0,40)|0;wa=ha|wa;va=C|va;fa=Fd(j|0,Y|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;Z=fa^Z;_=ga^_;ha=Id(Z|0,_|0,16)|0;ia=C;_=Jd(Z|0,_|0,48)|0;ha=_|ha;ia=C|ia;E=Fd(ha|0,ia|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;_=Id(wa|0,va|0,63)|0;Z=C;va=Jd(wa|0,va|0,1)|0;_=va|_;Z=C|Z;ca=Fd(ea|0,da|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,H|0,F|0)|0;v=C;ha=ha^ca;ia=ia^v;G=Fd(ia|0,ha|0,J|0,G|0)|0;J=C;ea=G^ea;da=J^da;va=Id(ea|0,da|0,24)|0;wa=C;da=Jd(ea|0,da|0,40)|0;va=da|va;wa=C|wa;v=Fd(R|0,P|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;ia=v^ia;ha=ca^ha;da=Id(ia|0,ha|0,16)|0;ea=C;ha=Jd(ia|0,ha|0,48)|0;da=ha|da;ea=C|ea;J=Fd(da|0,ea|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;ha=Id(va|0,wa|0,63)|0;ia=C;wa=Jd(va|0,wa|0,1)|0;ha=wa|ha;ia=C|ia;oa=Fd(ba|0,aa|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,y|0,A|0)|0;na=C;ta=ta^oa;ua=ua^na;z=Fd(ua|0,ta|0,E|0,z|0)|0;E=C;ba=z^ba;aa=E^aa;wa=Id(ba|0,aa|0,24)|0;va=C;aa=Jd(ba|0,aa|0,40)|0;wa=aa|wa;va=C|va;na=Fd(p|0,$|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;ua=na^ua;ta=oa^ta;aa=Id(ua|0,ta|0,16)|0;ba=C;ta=Jd(ua|0,ta|0,48)|0;aa=ta|aa;ba=C|ba;E=Fd(aa|0,ba|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ta=Id(wa|0,va|0,63)|0;ua=C;va=Jd(wa|0,va|0,1)|0;ta=va|ta;ua=C|ua;ka=Fd(_|0,Z|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,g|0,i|0)|0;ja=C;pa=pa^ka;qa=qa^ja;Q=Fd(qa|0,pa|0,T|0,Q|0)|0;T=C;_=Q^_;Z=T^Z;va=Id(_|0,Z|0,24)|0;wa=C;Z=Jd(_|0,Z|0,40)|0;va=Z|va;wa=C|wa;ja=Fd(s|0,u|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;qa=ja^qa;pa=ka^pa;Z=Id(qa|0,pa|0,16)|0;_=C;pa=Jd(qa|0,pa|0,48)|0;Z=pa|Z;_=C|_;T=Fd(Z|0,_|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;pa=Id(va|0,wa|0,63)|0;qa=C;wa=Jd(va|0,wa|0,1)|0;pa=wa|pa;qa=C|qa;ga=Fd(X|0,V|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,t|0,x|0)|0;fa=C;la=la^ga;ma=ma^fa;L=Fd(ma|0,la|0,O|0,L|0)|0;O=C;X=L^X;V=O^V;wa=Id(X|0,V|0,24)|0;va=C;V=Jd(X|0,V|0,40)|0;wa=V|wa;va=C|va;fa=Fd(m|0,o|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ma=fa^ma;la=ga^la;V=Id(ma|0,la|0,16)|0;X=C;la=Jd(ma|0,la|0,48)|0;V=la|V;X=C|X;O=Fd(V|0,X|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;la=Id(wa|0,va|0,63)|0;ma=C;va=Jd(wa|0,va|0,1)|0;la=va|la;ma=C|ma;ca=Fd(s|0,u|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,la|0,ma|0)|0;v=C;aa=ca^aa;ba=v^ba;Q=Fd(ba|0,aa|0,T|0,Q|0)|0;T=C;la=Q^la;ma=T^ma;va=Id(la|0,ma|0,24)|0;wa=C;ma=Jd(la|0,ma|0,40)|0;va=ma|va;wa=C|wa;v=Fd(y|0,A|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;ba=v^ba;aa=ca^aa;ma=Id(ba|0,aa|0,16)|0;la=C;aa=Jd(ba|0,aa|0,48)|0;ma=aa|ma;la=C|la;T=Fd(ma|0,la|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;aa=Id(va|0,wa|0,63)|0;ba=C;wa=Jd(va|0,wa|0,1)|0;aa=wa|aa;ba=C|ba;oa=Fd(ha|0,ia|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,ra|0,sa|0)|0;na=C;Z=Z^oa;_=_^na;L=Fd(_|0,Z|0,O|0,L|0)|0;O=C;ha=L^ha;ia=O^ia;wa=Id(ha|0,ia|0,24)|0;va=C;ia=Jd(ha|0,ia|0,40)|0;wa=ia|wa;va=C|va;na=Fd(j|0,Y|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;_=na^_;Z=oa^Z;ia=Id(_|0,Z|0,16)|0;ha=C;Z=Jd(_|0,Z|0,48)|0;ia=Z|ia;ha=C|ha;O=Fd(ia|0,ha|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;Z=Id(wa|0,va|0,63)|0;_=C;va=Jd(wa|0,va|0,1)|0;Z=va|Z;_=C|_;ka=Fd(ta|0,ua|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,M|0,K|0)|0;ja=C;V=V^ka;X=X^ja;G=Fd(X|0,V|0,J|0,G|0)|0;J=C;ta=G^ta;ua=J^ua;va=Id(ta|0,ua|0,24)|0;wa=C;ua=Jd(ta|0,ua|0,40)|0;va=ua|va;wa=C|wa;ja=Fd(h|0,l|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;X=ja^X;V=ka^V;ua=Id(X|0,V|0,16)|0;ta=C;V=Jd(X|0,V|0,48)|0;ua=V|ua;ta=C|ta;J=Fd(ua|0,ta|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;V=Id(va|0,wa|0,63)|0;X=C;wa=Jd(va|0,wa|0,1)|0;V=wa|V;X=C|X;ga=Fd(pa|0,qa|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,R|0,P|0)|0;fa=C;da=da^ga;ea=ea^fa;z=Fd(ea|0,da|0,E|0,z|0)|0;E=C;pa=z^pa;qa=E^qa;wa=Id(pa|0,qa|0,24)|0;va=C;qa=Jd(pa|0,qa|0,40)|0;wa=qa|wa;va=C|va;fa=Fd(g|0,i|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ea=fa^ea;da=ga^da;qa=Id(ea|0,da|0,16)|0;pa=C;da=Jd(ea|0,da|0,48)|0;qa=da|qa;pa=C|pa;E=Fd(qa|0,pa|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;da=Id(wa|0,va|0,63)|0;ea=C;va=Jd(wa|0,va|0,1)|0;da=va|da;ea=C|ea;ca=Fd(Z|0,_|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,e|0,f|0)|0;v=C;qa=qa^ca;pa=pa^v;G=Fd(pa|0,qa|0,J|0,G|0)|0;J=C;Z=G^Z;_=J^_;va=Id(Z|0,_|0,24)|0;wa=C;_=Jd(Z|0,_|0,40)|0;va=_|va;wa=C|wa;v=Fd(t|0,x|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;pa=v^pa;qa=ca^qa;_=Id(pa|0,qa|0,16)|0;Z=C;qa=Jd(pa|0,qa|0,48)|0;_=qa|_;Z=C|Z;J=Fd(_|0,Z|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;qa=Id(va|0,wa|0,63)|0;pa=C;wa=Jd(va|0,wa|0,1)|0;qa=wa|qa;pa=C|pa;oa=Fd(V|0,X|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,B|0,S|0)|0;na=C;ma=ma^oa;la=la^na;z=Fd(la|0,ma|0,E|0,z|0)|0;E=C;V=z^V;X=E^X;wa=Id(V|0,X|0,24)|0;va=C;X=Jd(V|0,X|0,40)|0;wa=X|wa;va=C|va;na=Fd(n|0,r|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;la=na^la;ma=oa^ma;X=Id(la|0,ma|0,16)|0;V=C;ma=Jd(la|0,ma|0,48)|0;X=ma|X;V=C|V;E=Fd(X|0,V|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ma=Id(wa|0,va|0,63)|0;la=C;va=Jd(wa|0,va|0,1)|0;ma=va|ma;la=C|la;ka=Fd(da|0,ea|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,W|0,U|0)|0;ja=C;ia=ia^ka;ha=ha^ja;Q=Fd(ha|0,ia|0,T|0,Q|0)|0;T=C;da=Q^da;ea=T^ea;va=Id(da|0,ea|0,24)|0;wa=C;ea=Jd(da|0,ea|0,40)|0;va=ea|va;wa=C|wa;ja=Fd(p|0,$|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;ha=ja^ha;ia=ka^ia;ea=Id(ha|0,ia|0,16)|0;da=C;ia=Jd(ha|0,ia|0,48)|0;ea=ia|ea;da=C|da;T=Fd(ea|0,da|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;ia=Id(va|0,wa|0,63)|0;ha=C;wa=Jd(va|0,wa|0,1)|0;ia=wa|ia;ha=C|ha;ga=Fd(aa|0,ba|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,m|0,o|0)|0;fa=C;ua=ua^ga;ta=ta^fa;L=Fd(ta|0,ua|0,O|0,L|0)|0;O=C;aa=L^aa;ba=O^ba;wa=Id(aa|0,ba|0,24)|0;va=C;ba=Jd(aa|0,ba|0,40)|0;wa=ba|wa;va=C|va;fa=Fd(H|0,F|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ta=fa^ta;ua=ga^ua;ba=Id(ta|0,ua|0,16)|0;aa=C;ua=Jd(ta|0,ua|0,48)|0;ba=ua|ba;aa=C|aa;O=Fd(ba|0,aa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ua=Id(wa|0,va|0,63)|0;ta=C;va=Jd(wa|0,va|0,1)|0;ua=va|ua;ta=C|ta;ca=Fd(m|0,o|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,ua|0,ta|0)|0;v=C;X=ca^X;V=v^V;Q=Fd(V|0,X|0,T|0,Q|0)|0;T=C;ua=Q^ua;ta=T^ta;va=Id(ua|0,ta|0,24)|0;wa=C;ta=Jd(ua|0,ta|0,40)|0;va=ta|va;wa=C|wa;v=Fd(t|0,x|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;V=v^V;X=ca^X;ta=Id(V|0,X|0,16)|0;ua=C;X=Jd(V|0,X|0,48)|0;ta=X|ta;ua=C|ua;T=Fd(ta|0,ua|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;X=Id(va|0,wa|0,63)|0;V=C;wa=Jd(va|0,wa|0,1)|0;X=wa|X;V=C|V;oa=Fd(qa|0,pa|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,g|0,i|0)|0;na=C;ea=ea^oa;da=da^na;L=Fd(da|0,ea|0,O|0,L|0)|0;O=C;qa=L^qa;pa=O^pa;wa=Id(qa|0,pa|0,24)|0;va=C;pa=Jd(qa|0,pa|0,40)|0;wa=pa|wa;va=C|va;na=Fd(p|0,$|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;da=na^da;ea=oa^ea;pa=Id(da|0,ea|0,16)|0;qa=C;ea=Jd(da|0,ea|0,48)|0;pa=ea|pa;qa=C|qa;O=Fd(pa|0,qa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ea=Id(wa|0,va|0,63)|0;da=C;va=Jd(wa|0,va|0,1)|0;ea=va|ea;da=C|da;ka=Fd(ma|0,la|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,n|0,r|0)|0;ja=C;ba=ba^ka;aa=aa^ja;G=Fd(aa|0,ba|0,J|0,G|0)|0;J=C;ma=G^ma;la=J^la;va=Id(ma|0,la|0,24)|0;wa=C;la=Jd(ma|0,la|0,40)|0;va=la|va;wa=C|wa;ja=Fd(s|0,u|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;aa=ja^aa;ba=ka^ba;la=Id(aa|0,ba|0,16)|0;ma=C;ba=Jd(aa|0,ba|0,48)|0;la=ba|la;ma=C|ma;J=Fd(la|0,ma|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;ba=Id(va|0,wa|0,63)|0;aa=C;wa=Jd(va|0,wa|0,1)|0;ba=wa|ba;aa=C|aa;ga=Fd(ia|0,ha|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,W|0,U|0)|0;fa=C;_=_^ga;Z=Z^fa;z=Fd(Z|0,_|0,E|0,z|0)|0;E=C;ia=z^ia;ha=E^ha;wa=Id(ia|0,ha|0,24)|0;va=C;ha=Jd(ia|0,ha|0,40)|0;wa=ha|wa;va=C|va;fa=Fd(H|0,F|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;Z=fa^Z;_=ga^_;ha=Id(Z|0,_|0,16)|0;ia=C;_=Jd(Z|0,_|0,48)|0;ha=_|ha;ia=C|ia;E=Fd(ha|0,ia|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;_=Id(wa|0,va|0,63)|0;Z=C;va=Jd(wa|0,va|0,1)|0;_=va|_;Z=C|Z;ca=Fd(ea|0,da|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,y|0,A|0)|0;v=C;ha=ha^ca;ia=ia^v;G=Fd(ia|0,ha|0,J|0,G|0)|0;J=C;ea=G^ea;da=J^da;va=Id(ea|0,da|0,24)|0;wa=C;da=Jd(ea|0,da|0,40)|0;va=da|va;wa=C|wa;v=Fd(M|0,K|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;ia=v^ia;ha=ca^ha;da=Id(ia|0,ha|0,16)|0;ea=C;ha=Jd(ia|0,ha|0,48)|0;da=ha|da;ea=C|ea;J=Fd(da|0,ea|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;ha=Id(va|0,wa|0,63)|0;ia=C;wa=Jd(va|0,wa|0,1)|0;ha=wa|ha;ia=C|ia;oa=Fd(ba|0,aa|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,j|0,Y|0)|0;na=C;ta=ta^oa;ua=ua^na;z=Fd(ua|0,ta|0,E|0,z|0)|0;E=C;ba=z^ba;aa=E^aa;wa=Id(ba|0,aa|0,24)|0;va=C;aa=Jd(ba|0,aa|0,40)|0;wa=aa|wa;va=C|va;na=Fd(ra|0,sa|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;ua=na^ua;ta=oa^ta;aa=Id(ua|0,ta|0,16)|0;ba=C;ta=Jd(ua|0,ta|0,48)|0;aa=ta|aa;ba=C|ba;E=Fd(aa|0,ba|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ta=Id(wa|0,va|0,63)|0;ua=C;va=Jd(wa|0,va|0,1)|0;ta=va|ta;ua=C|ua;ka=Fd(_|0,Z|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,h|0,l|0)|0;ja=C;pa=pa^ka;qa=qa^ja;Q=Fd(qa|0,pa|0,T|0,Q|0)|0;T=C;_=Q^_;Z=T^Z;va=Id(_|0,Z|0,24)|0;wa=C;Z=Jd(_|0,Z|0,40)|0;va=Z|va;wa=C|wa;ja=Fd(e|0,f|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;qa=ja^qa;pa=ka^pa;Z=Id(qa|0,pa|0,16)|0;_=C;pa=Jd(qa|0,pa|0,48)|0;Z=pa|Z;_=C|_;T=Fd(Z|0,_|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;pa=Id(va|0,wa|0,63)|0;qa=C;wa=Jd(va|0,wa|0,1)|0;pa=wa|pa;qa=C|qa;ga=Fd(X|0,V|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,B|0,S|0)|0;fa=C;la=la^ga;ma=ma^fa;L=Fd(ma|0,la|0,O|0,L|0)|0;O=C;X=L^X;V=O^V;wa=Id(X|0,V|0,24)|0;va=C;V=Jd(X|0,V|0,40)|0;wa=V|wa;va=C|va;fa=Fd(R|0,P|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ma=fa^ma;la=ga^la;V=Id(ma|0,la|0,16)|0;X=C;la=Jd(ma|0,la|0,48)|0;V=la|V;X=C|X;O=Fd(V|0,X|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;la=Id(wa|0,va|0,63)|0;ma=C;va=Jd(wa|0,va|0,1)|0;la=va|la;ma=C|ma;ca=Fd(R|0,P|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,la|0,ma|0)|0;v=C;aa=ca^aa;ba=v^ba;Q=Fd(ba|0,aa|0,T|0,Q|0)|0;T=C;la=Q^la;ma=T^ma;va=Id(la|0,ma|0,24)|0;wa=C;ma=Jd(la|0,ma|0,40)|0;va=ma|va;wa=C|wa;v=Fd(W|0,U|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;ba=v^ba;aa=ca^aa;ma=Id(ba|0,aa|0,16)|0;la=C;aa=Jd(ba|0,aa|0,48)|0;ma=aa|ma;la=C|la;T=Fd(ma|0,la|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;aa=Id(va|0,wa|0,63)|0;ba=C;wa=Jd(va|0,wa|0,1)|0;aa=wa|aa;ba=C|ba;oa=Fd(ha|0,ia|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,t|0,x|0)|0;na=C;Z=Z^oa;_=_^na;L=Fd(_|0,Z|0,O|0,L|0)|0;O=C;ha=L^ha;ia=O^ia;wa=Id(ha|0,ia|0,24)|0;va=C;ia=Jd(ha|0,ia|0,40)|0;wa=ia|wa;va=C|va;na=Fd(h|0,l|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;_=na^_;Z=oa^Z;ia=Id(_|0,Z|0,16)|0;ha=C;Z=Jd(_|0,Z|0,48)|0;ia=Z|ia;ha=C|ha;O=Fd(ia|0,ha|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;Z=Id(wa|0,va|0,63)|0;_=C;va=Jd(wa|0,va|0,1)|0;Z=va|Z;_=C|_;ka=Fd(ta|0,ua|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,p|0,$|0)|0;ja=C;V=V^ka;X=X^ja;G=Fd(X|0,V|0,J|0,G|0)|0;J=C;ta=G^ta;ua=J^ua;va=Id(ta|0,ua|0,24)|0;wa=C;ua=Jd(ta|0,ua|0,40)|0;va=ua|va;wa=C|wa;ja=Fd(H|0,F|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;X=ja^X;V=ka^V;ua=Id(X|0,V|0,16)|0;ta=C;V=Jd(X|0,V|0,48)|0;ua=V|ua;ta=C|ta;J=Fd(ua|0,ta|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;V=Id(va|0,wa|0,63)|0;X=C;wa=Jd(va|0,wa|0,1)|0;V=wa|V;X=C|X;ga=Fd(pa|0,qa|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,s|0,u|0)|0;fa=C;da=da^ga;ea=ea^fa;z=Fd(ea|0,da|0,E|0,z|0)|0;E=C;pa=z^pa;qa=E^qa;wa=Id(pa|0,qa|0,24)|0;va=C;qa=Jd(pa|0,qa|0,40)|0;wa=qa|wa;va=C|va;fa=Fd(n|0,r|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ea=fa^ea;da=ga^da;qa=Id(ea|0,da|0,16)|0;pa=C;da=Jd(ea|0,da|0,48)|0;qa=da|qa;pa=C|pa;E=Fd(qa|0,pa|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;da=Id(wa|0,va|0,63)|0;ea=C;va=Jd(wa|0,va|0,1)|0;da=va|da;ea=C|ea;ca=Fd(Z|0,_|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,g|0,i|0)|0;v=C;qa=qa^ca;pa=pa^v;G=Fd(pa|0,qa|0,J|0,G|0)|0;J=C;Z=G^Z;_=J^_;va=Id(Z|0,_|0,24)|0;wa=C;_=Jd(Z|0,_|0,40)|0;va=_|va;wa=C|wa;v=Fd(j|0,Y|0,ca|0,v|0)|0;v=Fd(v|0,C|0,va|0,wa|0)|0;ca=C;pa=v^pa;qa=ca^qa;_=Id(pa|0,qa|0,16)|0;Z=C;qa=Jd(pa|0,qa|0,48)|0;_=qa|_;Z=C|Z;J=Fd(_|0,Z|0,G|0,J|0)|0;G=C;va=J^va;wa=G^wa;qa=Id(va|0,wa|0,63)|0;pa=C;wa=Jd(va|0,wa|0,1)|0;qa=wa|qa;pa=C|pa;oa=Fd(V|0,X|0,na|0,oa|0)|0;oa=Fd(oa|0,C|0,m|0,o|0)|0;na=C;ma=ma^oa;la=la^na;z=Fd(la|0,ma|0,E|0,z|0)|0;E=C;V=z^V;X=E^X;wa=Id(V|0,X|0,24)|0;va=C;X=Jd(V|0,X|0,40)|0;wa=X|wa;va=C|va;na=Fd(M|0,K|0,oa|0,na|0)|0;na=Fd(na|0,C|0,wa|0,va|0)|0;oa=C;la=na^la;ma=oa^ma;X=Id(la|0,ma|0,16)|0;V=C;ma=Jd(la|0,ma|0,48)|0;X=ma|X;V=C|V;E=Fd(X|0,V|0,z|0,E|0)|0;z=C;wa=E^wa;va=z^va;ma=Id(wa|0,va|0,63)|0;la=C;va=Jd(wa|0,va|0,1)|0;ma=va|ma;la=C|la;ka=Fd(da|0,ea|0,ja|0,ka|0)|0;ka=Fd(ka|0,C|0,e|0,f|0)|0;ja=C;ia=ia^ka;ha=ha^ja;Q=Fd(ha|0,ia|0,T|0,Q|0)|0;T=C;da=Q^da;ea=T^ea;va=Id(da|0,ea|0,24)|0;wa=C;ea=Jd(da|0,ea|0,40)|0;va=ea|va;wa=C|wa;ja=Fd(B|0,S|0,ka|0,ja|0)|0;ja=Fd(ja|0,C|0,va|0,wa|0)|0;ka=C;ha=ja^ha;ia=ka^ia;ea=Id(ha|0,ia|0,16)|0;da=C;ia=Jd(ha|0,ia|0,48)|0;ea=ia|ea;da=C|da;T=Fd(ea|0,da|0,Q|0,T|0)|0;Q=C;va=T^va;wa=Q^wa;ia=Id(va|0,wa|0,63)|0;ha=C;wa=Jd(va|0,wa|0,1)|0;ia=wa|ia;ha=C|ha;ga=Fd(aa|0,ba|0,fa|0,ga|0)|0;ga=Fd(ga|0,C|0,ra|0,sa|0)|0;fa=C;ua=ua^ga;ta=ta^fa;L=Fd(ta|0,ua|0,O|0,L|0)|0;O=C;aa=L^aa;ba=O^ba;wa=Id(aa|0,ba|0,24)|0;va=C;ba=Jd(aa|0,ba|0,40)|0;wa=ba|wa;va=C|va;fa=Fd(y|0,A|0,ga|0,fa|0)|0;fa=Fd(fa|0,C|0,wa|0,va|0)|0;ga=C;ta=fa^ta;ua=ga^ua;ba=Id(ta|0,ua|0,16)|0;aa=C;ua=Jd(ta|0,ua|0,48)|0;ba=ua|ba;aa=C|aa;O=Fd(ba|0,aa|0,L|0,O|0)|0;L=C;wa=O^wa;va=L^va;ua=Id(wa|0,va|0,63)|0;ta=C;va=Jd(wa|0,va|0,1)|0;ua=va|ua;ta=C|ta;ca=Fd(ra|0,sa|0,v|0,ca|0)|0;ca=Fd(ca|0,C|0,ua|0,ta|0)|0;v=C;X=ca^X;V=v^V;Q=Fd(V|0,X|0,T|0,Q|0)|0;T=C;ua=Q^ua;ta=T^ta;sa=Id(ua|0,ta|0,24)|0;ra=C;ta=Jd(ua|0,ta|0,40)|0;sa=ta|sa;ra=C|ra;v=Fd(m|0,o|0,ca|0,v|0)|0;v=Fd(v|0,C|0,sa|0,ra|0)|0;ca=C;V=v^V;X=ca^X;o=Id(V|0,X|0,16)|0;m=C;X=Jd(V|0,X|0,48)|0;o=X|o;m=C|m;T=Fd(o|0,m|0,Q|0,T|0)|0;Q=C;sa=T^sa;ra=Q^ra;X=Id(sa|0,ra|0,63)|0;V=C;ra=Jd(sa|0,ra|0,1)|0;X=ra|X;V=C|V;oa=Fd(qa|0,pa|0,na|0,oa|0)|0;$=Fd(oa|0,C|0,p|0,$|0)|0;p=C;ea=ea^$;da=da^p;L=Fd(da|0,ea|0,O|0,L|0)|0;O=C;qa=L^qa;pa=O^pa;oa=Id(qa|0,pa|0,24)|0;na=C;pa=Jd(qa|0,pa|0,40)|0;oa=pa|oa;na=C|na;p=Fd(g|0,i|0,$|0,p|0)|0;p=Fd(p|0,C|0,oa|0,na|0)|0;$=C;da=p^da;ea=$^ea;i=Id(da|0,ea|0,16)|0;g=C;ea=Jd(da|0,ea|0,48)|0;i=ea|i;g=C|g;O=Fd(i|0,g|0,L|0,O|0)|0;L=C;oa=O^oa;na=L^na;ea=Id(oa|0,na|0,63)|0;da=C;na=Jd(oa|0,na|0,1)|0;ea=na|ea;da=C|da;ka=Fd(ma|0,la|0,ja|0,ka|0)|0;Y=Fd(ka|0,C|0,j|0,Y|0)|0;j=C;ba=ba^Y;aa=aa^j;G=Fd(aa|0,ba|0,J|0,G|0)|0;J=C;ma=G^ma;la=J^la;ka=Id(ma|0,la|0,24)|0;ja=C;la=Jd(ma|0,la|0,40)|0;ka=la|ka;ja=C|ja;j=Fd(y|0,A|0,Y|0,j|0)|0;j=Fd(j|0,C|0,ka|0,ja|0)|0;Y=C;aa=j^aa;ba=Y^ba;A=Id(aa|0,ba|0,16)|0;y=C;ba=Jd(aa|0,ba|0,48)|0;A=ba|A;y=C|y;J=Fd(A|0,y|0,G|0,J|0)|0;G=C;ka=J^ka;ja=G^ja;ba=Id(ka|0,ja|0,63)|0;aa=C;ja=Jd(ka|0,ja|0,1)|0;ba=ja|ba;aa=C|aa;ga=Fd(ia|0,ha|0,fa|0,ga|0)|0;S=Fd(ga|0,C|0,B|0,S|0)|0;B=C;_=_^S;Z=Z^B;z=Fd(Z|0,_|0,E|0,z|0)|0;E=C;ia=z^ia;ha=E^ha;ga=Id(ia|0,ha|0,24)|0;fa=C;ha=Jd(ia|0,ha|0,40)|0;ga=ha|ga;fa=C|fa;B=Fd(s|0,u|0,S|0,B|0)|0;B=Fd(B|0,C|0,ga|0,fa|0)|0;S=C;Z=B^Z;_=S^_;u=Id(Z|0,_|0,16)|0;s=C;_=Jd(Z|0,_|0,48)|0;u=_|u;s=C|s;E=Fd(u|0,s|0,z|0,E|0)|0;z=C;ga=E^ga;fa=z^fa;_=Id(ga|0,fa|0,63)|0;Z=C;fa=Jd(ga|0,fa|0,1)|0;_=fa|_;Z=C|Z;ca=Fd(ea|0,da|0,v|0,ca|0)|0;U=Fd(ca|0,C|0,W|0,U|0)|0;W=C;u=u^U;s=s^W;G=Fd(s|0,u|0,J|0,G|0)|0;J=C;ea=G^ea;da=J^da;ca=Id(ea|0,da|0,24)|0;v=C;da=Jd(ea|0,da|0,40)|0;ca=da|ca;v=C|v;W=Fd(e|0,f|0,U|0,W|0)|0;W=Fd(W|0,C|0,ca|0,v|0)|0;U=C;s=W^s;u=U^u;f=Id(s|0,u|0,16)|0;e=C;u=Jd(s|0,u|0,48)|0;f=u|f;e=C|e;J=Fd(f|0,e|0,G|0,J|0)|0;G=C;ca=J^ca;v=G^v;u=Id(ca|0,v|0,63)|0;s=C;v=Jd(ca|0,v|0,1)|0;s=C|s;$=Fd(ba|0,aa|0,p|0,$|0)|0;P=Fd($|0,C|0,R|0,P|0)|0;R=C;o=o^P;m=m^R;z=Fd(m|0,o|0,E|0,z|0)|0;E=C;ba=z^ba;aa=E^aa;$=Id(ba|0,aa|0,24)|0;p=C;aa=Jd(ba|0,aa|0,40)|0;$=aa|$;p=C|p;R=Fd(t|0,x|0,P|0,R|0)|0;R=Fd(R|0,C|0,$|0,p|0)|0;P=C;m=R^m;o=P^o;x=Id(m|0,o|0,16)|0;t=C;o=Jd(m|0,o|0,48)|0;x=o|x;t=C|t;E=Fd(x|0,t|0,z|0,E|0)|0;z=C;$=E^$;p=z^p;o=Id($|0,p|0,63)|0;m=C;p=Jd($|0,p|0,1)|0;m=C|m;Y=Fd(_|0,Z|0,j|0,Y|0)|0;K=Fd(Y|0,C|0,M|0,K|0)|0;M=C;i=i^K;g=g^M;Q=Fd(g|0,i|0,T|0,Q|0)|0;T=C;_=Q^_;Z=T^Z;Y=Id(_|0,Z|0,24)|0;j=C;Z=Jd(_|0,Z|0,40)|0;Y=Z|Y;j=C|j;M=Fd(n|0,r|0,K|0,M|0)|0;M=Fd(M|0,C|0,Y|0,j|0)|0;K=C;g=M^g;i=K^i;r=Id(g|0,i|0,16)|0;n=C;i=Jd(g|0,i|0,48)|0;r=i|r;n=C|n;T=Fd(r|0,n|0,Q|0,T|0)|0;Q=C;Y=T^Y;j=Q^j;i=Id(Y|0,j|0,63)|0;g=C;j=Jd(Y|0,j|0,1)|0;g=C|g;S=Fd(X|0,V|0,B|0,S|0)|0;F=Fd(S|0,C|0,H|0,F|0)|0;H=C;A=A^F;y=y^H;L=Fd(y|0,A|0,O|0,L|0)|0;O=C;X=L^X;V=O^V;S=Id(X|0,V|0,24)|0;B=C;V=Jd(X|0,V|0,40)|0;S=V|S;B=C|B;H=Fd(h|0,l|0,F|0,H|0)|0;H=Fd(H|0,C|0,S|0,B|0)|0;F=C;y=H^y;A=F^A;l=Id(y|0,A|0,16)|0;h=C;A=Jd(y|0,A|0,48)|0;l=A|l;h=C|h;O=Fd(l|0,h|0,L|0,O|0)|0;L=C;S=O^S;B=L^B;A=Id(S|0,B|0,63)|0;y=C;B=Jd(S|0,B|0,1)|0;S=b;V=S;S=S+4|0;T=W^(d[V>>0]|d[V+1>>0]<<8|d[V+2>>0]<<16|d[V+3>>0]<<24)^T;Q=U^(d[S>>0]|d[S+1>>0]<<8|d[S+2>>0]<<16|d[S+3>>0]<<24)^Q;S=b;a[S>>0]=T;a[S+1>>0]=T>>8;a[S+2>>0]=T>>16;a[S+3>>0]=T>>24;b=b+4|0;a[b>>0]=Q;a[b+1>>0]=Q>>8;a[b+2>>0]=Q>>16;a[b+3>>0]=Q>>24;b=N;Q=b;b=b+4|0;O=R^(d[Q>>0]|d[Q+1>>0]<<8|d[Q+2>>0]<<16|d[Q+3>>0]<<24)^O;L=P^(d[b>>0]|d[b+1>>0]<<8|d[b+2>>0]<<16|d[b+3>>0]<<24)^L;b=N;N=b;a[N>>0]=O;a[N+1>>0]=O>>8;a[N+2>>0]=O>>16;a[N+3>>0]=O>>24;b=b+4|0;a[b>>0]=L;a[b+1>>0]=L>>8;a[b+2>>0]=L>>16;a[b+3>>0]=L>>24;b=I;L=b;b=b+4|0;J=M^(d[L>>0]|d[L+1>>0]<<8|d[L+2>>0]<<16|d[L+3>>0]<<24)^J;G=K^(d[b>>0]|d[b+1>>0]<<8|d[b+2>>0]<<16|d[b+3>>0]<<24)^G;b=I;I=b;a[I>>0]=J;a[I+1>>0]=J>>8;a[I+2>>0]=J>>16;a[I+3>>0]=J>>24;b=b+4|0;a[b>>0]=G;a[b+1>>0]=G>>8;a[b+2>>0]=G>>16;a[b+3>>0]=G>>24;b=D;G=b;b=b+4|0;E=H^(d[G>>0]|d[G+1>>0]<<8|d[G+2>>0]<<16|d[G+3>>0]<<24)^E;z=F^(d[b>>0]|d[b+1>>0]<<8|d[b+2>>0]<<16|d[b+3>>0]<<24)^z;b=D;D=b;a[D>>0]=E;a[D+1>>0]=E>>8;a[D+2>>0]=E>>16;a[D+3>>0]=E>>24;b=b+4|0;a[b>>0]=z;a[b+1>>0]=z>>8;a[b+2>>0]=z>>16;a[b+3>>0]=z>>24;b=w;z=b;b=b+4|0;x=(B|A)^(d[z>>0]|d[z+1>>0]<<8|d[z+2>>0]<<16|d[z+3>>0]<<24)^x;t=(C|y)^(d[b>>0]|d[b+1>>0]<<8|d[b+2>>0]<<16|d[b+3>>0]<<24)^t;b=w;w=b;a[w>>0]=x;a[w+1>>0]=x>>8;a[w+2>>0]=x>>16;a[w+3>>0]=x>>24;b=b+4|0;a[b>>0]=t;a[b+1>>0]=t>>8;a[b+2>>0]=t>>16;a[b+3>>0]=t>>24;b=q;t=b;b=b+4|0;r=(v|u)^(d[t>>0]|d[t+1>>0]<<8|d[t+2>>0]<<16|d[t+3>>0]<<24)^r;n=s^(d[b>>0]|d[b+1>>0]<<8|d[b+2>>0]<<16|d[b+3>>0]<<24)^n;b=q;q=b;a[q>>0]=r;a[q+1>>0]=r>>8;a[q+2>>0]=r>>16;a[q+3>>0]=r>>24;b=b+4|0;a[b>>0]=n;a[b+1>>0]=n>>8;a[b+2>>0]=n>>16;a[b+3>>0]=n>>24;b=k;n=b;b=b+4|0;l=(p|o)^(d[n>>0]|d[n+1>>0]<<8|d[n+2>>0]<<16|d[n+3>>0]<<24)^l;h=m^(d[b>>0]|d[b+1>>0]<<8|d[b+2>>0]<<16|d[b+3>>0]<<24)^h;b=k;k=b;a[k>>0]=l;a[k+1>>0]=l>>8;a[k+2>>0]=l>>16;a[k+3>>0]=l>>24;b=b+4|0;a[b>>0]=h;a[b+1>>0]=h>>8;a[b+2>>0]=h>>16;a[b+3>>0]=h>>24;b=c;h=b;b=b+4|0;f=(j|i)^(d[h>>0]|d[h+1>>0]<<8|d[h+2>>0]<<16|d[h+3>>0]<<24)^f;b=g^(d[b>>0]|d[b+1>>0]<<8|d[b+2>>0]<<16|d[b+3>>0]<<24)^e;e=c;a[e>>0]=f;a[e+1>>0]=f>>8;a[e+2>>0]=f>>16;a[e+3>>0]=f>>24;c=c+4|0;a[c>>0]=b;a[c+1>>0]=b>>8;a[c+2>>0]=b>>16;a[c+3>>0]=b>>24;return}function Bb(){return 64}function Cb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;h=i;f=i=i+63&-64;i=i+208|0;g=f+64|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;g=f;j=8;k=g+64|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(k|0));Gb(f,b,d,e);Hb(f,a);i=h;return 0}function Db(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;if((d|0)==0&(e|0)==0)return;i=a+32|0;k=i;h=c[k>>2]|0;k=c[k+4>>2]|0;j=Id(h|0,k|0,3)|0;j=j&63;g=Jd(d|0,e|0,3)|0;g=Fd(h|0,k|0,g|0,C|0)|0;c[i>>2]=g;c[i+4>>2]=C;i=64-j|0;g=a+40+j|0;if(0>e>>>0|0==(e|0)&i>>>0>d>>>0){Kd(g|0,b|0,d|0)|0;return}Kd(g|0,b|0,i|0)|0;k=a+40|0;Fb(a,k);f=b+i|0;g=Ed(d|0,e|0,i|0,0)|0;h=C;if(h>>>0>0|(h|0)==0&g>>>0>63){e=Fd(d|0,e|0,-64,0)|0;i=Ed(e|0,C|0,i|0,0)|0;e=i+128&-64;while(1){Fb(a,f);g=Fd(g|0,h|0,-64,-1)|0;h=C;if(!(h>>>0>0|(h|0)==0&g>>>0>63))break;else f=f+64|0}g=i&63;f=b+(e-j)|0}Kd(k|0,f|0,g|0)|0;return}function Eb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;o=i;n=i=i+63&-64;i=i+16|0;m=b+32|0;e=m;f=c[e>>2]|0;e=c[e+4>>2]|0;a[n+7>>0]=f;l=Id(f|0,e|0,8)|0;a[n+6>>0]=l;l=Id(f|0,e|0,16)|0;a[n+5>>0]=l;l=Id(f|0,e|0,24)|0;a[n+4>>0]=l;a[n+3>>0]=e;l=Id(f|0,e|0,40)|0;a[n+2>>0]=l;l=Id(f|0,e|0,48)|0;a[n+1>>0]=l;l=Id(f|0,e|0,56)|0;a[n>>0]=l;l=Id(f|0,e|0,3)|0;l=l&63;k=l>>>0<56?56:120;j=k-l|0;do if((k|0)!=(l|0)){h=Jd(j|0,0,3)|0;f=Fd(h|0,C|0,f|0,e|0)|0;e=C;h=m;c[h>>2]=f;c[h+4>>2]=e;h=64-l|0;g=b+40+l|0;if(j>>>0<h>>>0){Kd(g|0,32792,j|0)|0;break}Kd(g|0,32792,h|0)|0;k=b+40|0;Fb(b,k);e=32792+h|0;g=Ed(j|0,0,h|0,0)|0;f=C;if(f>>>0>0|(f|0)==0&g>>>0>63){h=j+(-64-h)|0;while(1){Fb(b,e);g=Fd(g|0,f|0,-64,-1)|0;f=C;if(!(f>>>0>0|(f|0)==0&g>>>0>63))break;else e=e+64|0}g=h&63;e=32792+((h+128&-64)-l)|0}Kd(k|0,e|0,g|0)|0;e=m;f=c[e>>2]|0;e=c[e+4>>2]|0}while(0);k=Id(f|0,e|0,3)|0;k=k&63;e=Fd(f|0,e|0,64,0)|0;h=m;c[h>>2]=e;c[h+4>>2]=C;h=64-k|0;e=b+40+k|0;if(h>>>0>8){m=n;k=c[m>>2]|0;m=c[m+4>>2]|0;n=e;l=n;a[l>>0]=k;a[l+1>>0]=k>>8;a[l+2>>0]=k>>16;a[l+3>>0]=k>>24;n=n+4|0;a[n>>0]=m;a[n+1>>0]=m>>8;a[n+2>>0]=m>>16;a[n+3>>0]=m>>24}else{Kd(e|0,n|0,h|0)|0;j=b+40|0;Fb(b,j);e=n+h|0;f=Ed(8,0,h|0,0)|0;g=C;if(g>>>0>0|(g|0)==0&f>>>0>63){h=-56-h|0;while(1){Fb(b,e);f=Fd(f|0,g|0,-64,-1)|0;g=C;if(!(g>>>0>0|(g|0)==0&f>>>0>63))break;else e=e+64|0}f=h&63;e=n+((h+128&-64)-k)|0}Kd(j|0,e|0,f|0)|0}e=0;do{n=e<<2;m=c[b+(e<<2)>>2]|0;a[d+(n|3)>>0]=m;a[d+(n|2)>>0]=m>>>8;a[d+(n|1)>>0]=m>>>16;a[d+n>>0]=m>>>24;e=e+1|0}while((e|0)!=8);e=b+104|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(e|0));i=o;return}function Fb(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;f=i=i+63&-64;i=i+256|0;e=0;do{h=e<<2;c[f+(e<<2)>>2]=(d[b+(h|2)>>0]|0)<<8|(d[b+(h|3)>>0]|0)|(d[b+(h|1)>>0]|0)<<16|(d[b+h>>0]|0)<<24;e=e+1|0}while((e|0)!=16);b=c[f>>2]|0;e=16;do{h=c[f+(e+-2<<2)>>2]|0;j=b;b=c[f+(e+-15<<2)>>2]|0;c[f+(e<<2)>>2]=j+(c[f+(e+-7<<2)>>2]|0)+((h>>>19|h<<13)^h>>>10^(h>>>17|h<<15))+((b>>>18|b<<14)^b>>>3^(b>>>7|b<<25));e=e+1|0}while((e|0)!=64);u=c[a>>2]|0;s=a+4|0;t=c[s>>2]|0;q=a+8|0;r=c[q>>2]|0;o=a+12|0;m=a+16|0;n=c[m>>2]|0;k=a+20|0;l=c[k>>2]|0;e=a+24|0;b=c[e>>2]|0;j=a+28|0;h=(c[j>>2]|0)+1116352408+(c[f>>2]|0)+((n>>>6|n<<26)^(n>>>11|n<<21)^(n>>>25|n<<7))+((b^l)&n^b)|0;p=(c[o>>2]|0)+h|0;h=((r|t)&u|r&t)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+h|0;b=b+1899447441+(c[f+4>>2]|0)+((p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7))+((l^n)&p^l)|0;r=r+b|0;b=((t|u)&h|t&u)+((h>>>2|h<<30)^(h>>>13|h<<19)^(h>>>22|h<<10))+b|0;l=l+-1245643825+(c[f+8>>2]|0)+((r>>>6|r<<26)^(r>>>11|r<<21)^(r>>>25|r<<7))+((n^p)&r^n)|0;t=t+l|0;l=((u|h)&b|u&h)+((b>>>2|b<<30)^(b>>>13|b<<19)^(b>>>22|b<<10))+l|0;n=n+-373957723+(c[f+12>>2]|0)+((t>>>6|t<<26)^(t>>>11|t<<21)^(t>>>25|t<<7))+((p^r)&t^p)|0;u=u+n|0;n=((h|b)&l|h&b)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+n|0;p=p+961987163+(c[f+16>>2]|0)+((u>>>6|u<<26)^(u>>>11|u<<21)^(u>>>25|u<<7))+((r^t)&u^r)|0;h=h+p|0;p=((b|l)&n|b&l)+((n>>>2|n<<30)^(n>>>13|n<<19)^(n>>>22|n<<10))+p|0;r=r+1508970993+(c[f+20>>2]|0)+((h>>>6|h<<26)^(h>>>11|h<<21)^(h>>>25|h<<7))+((t^u)&h^t)|0;b=b+r|0;r=((l|n)&p|l&n)+((p>>>2|p<<30)^(p>>>13|p<<19)^(p>>>22|p<<10))+r|0;t=t+-1841331548+(c[f+24>>2]|0)+((b>>>6|b<<26)^(b>>>11|b<<21)^(b>>>25|b<<7))+((u^h)&b^u)|0;l=l+t|0;t=((n|p)&r|n&p)+((r>>>2|r<<30)^(r>>>13|r<<19)^(r>>>22|r<<10))+t|0;u=u+-1424204075+(c[f+28>>2]|0)+((l>>>6|l<<26)^(l>>>11|l<<21)^(l>>>25|l<<7))+((h^b)&l^h)|0;n=n+u|0;u=((p|r)&t|p&r)+((t>>>2|t<<30)^(t>>>13|t<<19)^(t>>>22|t<<10))+u|0;h=h+-670586216+(c[f+32>>2]|0)+((n>>>6|n<<26)^(n>>>11|n<<21)^(n>>>25|n<<7))+((b^l)&n^b)|0;p=p+h|0;h=((r|t)&u|r&t)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+h|0;b=b+310598401+(c[f+36>>2]|0)+((p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7))+((l^n)&p^l)|0;r=r+b|0;b=((t|u)&h|t&u)+((h>>>2|h<<30)^(h>>>13|h<<19)^(h>>>22|h<<10))+b|0;l=l+607225278+(c[f+40>>2]|0)+((r>>>6|r<<26)^(r>>>11|r<<21)^(r>>>25|r<<7))+((n^p)&r^n)|0;t=t+l|0;l=((u|h)&b|u&h)+((b>>>2|b<<30)^(b>>>13|b<<19)^(b>>>22|b<<10))+l|0;n=n+1426881987+(c[f+44>>2]|0)+((t>>>6|t<<26)^(t>>>11|t<<21)^(t>>>25|t<<7))+((p^r)&t^p)|0;u=u+n|0;n=((h|b)&l|h&b)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+n|0;p=p+1925078388+(c[f+48>>2]|0)+((u>>>6|u<<26)^(u>>>11|u<<21)^(u>>>25|u<<7))+((r^t)&u^r)|0;h=h+p|0;p=((b|l)&n|b&l)+((n>>>2|n<<30)^(n>>>13|n<<19)^(n>>>22|n<<10))+p|0;r=r+-2132889090+(c[f+52>>2]|0)+((h>>>6|h<<26)^(h>>>11|h<<21)^(h>>>25|h<<7))+((t^u)&h^t)|0;b=b+r|0;r=((l|n)&p|l&n)+((p>>>2|p<<30)^(p>>>13|p<<19)^(p>>>22|p<<10))+r|0;t=t+-1680079193+(c[f+56>>2]|0)+((b>>>6|b<<26)^(b>>>11|b<<21)^(b>>>25|b<<7))+((u^h)&b^u)|0;l=l+t|0;t=((n|p)&r|n&p)+((r>>>2|r<<30)^(r>>>13|r<<19)^(r>>>22|r<<10))+t|0;u=u+-1046744716+(c[f+60>>2]|0)+((l>>>6|l<<26)^(l>>>11|l<<21)^(l>>>25|l<<7))+((h^b)&l^h)|0;n=n+u|0;u=((p|r)&t|p&r)+((t>>>2|t<<30)^(t>>>13|t<<19)^(t>>>22|t<<10))+u|0;h=h+-459576895+(c[f+64>>2]|0)+((n>>>6|n<<26)^(n>>>11|n<<21)^(n>>>25|n<<7))+((b^l)&n^b)|0;p=p+h|0;h=((r|t)&u|r&t)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+h|0;b=b+-272742522+(c[f+68>>2]|0)+((p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7))+((l^n)&p^l)|0;r=r+b|0;b=((t|u)&h|t&u)+((h>>>2|h<<30)^(h>>>13|h<<19)^(h>>>22|h<<10))+b|0;l=l+264347078+(c[f+72>>2]|0)+((r>>>6|r<<26)^(r>>>11|r<<21)^(r>>>25|r<<7))+((n^p)&r^n)|0;t=t+l|0;l=((u|h)&b|u&h)+((b>>>2|b<<30)^(b>>>13|b<<19)^(b>>>22|b<<10))+l|0;n=n+604807628+(c[f+76>>2]|0)+((t>>>6|t<<26)^(t>>>11|t<<21)^(t>>>25|t<<7))+((p^r)&t^p)|0;u=u+n|0;n=((h|b)&l|h&b)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+n|0;p=p+770255983+(c[f+80>>2]|0)+((u>>>6|u<<26)^(u>>>11|u<<21)^(u>>>25|u<<7))+((r^t)&u^r)|0;h=h+p|0;p=((b|l)&n|b&l)+((n>>>2|n<<30)^(n>>>13|n<<19)^(n>>>22|n<<10))+p|0;r=r+1249150122+(c[f+84>>2]|0)+((h>>>6|h<<26)^(h>>>11|h<<21)^(h>>>25|h<<7))+((t^u)&h^t)|0;b=b+r|0;r=((l|n)&p|l&n)+((p>>>2|p<<30)^(p>>>13|p<<19)^(p>>>22|p<<10))+r|0;t=t+1555081692+(c[f+88>>2]|0)+((b>>>6|b<<26)^(b>>>11|b<<21)^(b>>>25|b<<7))+((u^h)&b^u)|0;l=l+t|0;t=((n|p)&r|n&p)+((r>>>2|r<<30)^(r>>>13|r<<19)^(r>>>22|r<<10))+t|0;u=u+1996064986+(c[f+92>>2]|0)+((l>>>6|l<<26)^(l>>>11|l<<21)^(l>>>25|l<<7))+((h^b)&l^h)|0;n=n+u|0;u=((p|r)&t|p&r)+((t>>>2|t<<30)^(t>>>13|t<<19)^(t>>>22|t<<10))+u|0;h=h+-1740746414+(c[f+96>>2]|0)+((n>>>6|n<<26)^(n>>>11|n<<21)^(n>>>25|n<<7))+((b^l)&n^b)|0;p=p+h|0;h=((r|t)&u|r&t)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+h|0;b=b+-1473132947+(c[f+100>>2]|0)+((p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7))+((l^n)&p^l)|0;r=r+b|0;b=((t|u)&h|t&u)+((h>>>2|h<<30)^(h>>>13|h<<19)^(h>>>22|h<<10))+b|0;l=l+-1341970488+(c[f+104>>2]|0)+((r>>>6|r<<26)^(r>>>11|r<<21)^(r>>>25|r<<7))+((n^p)&r^n)|0;t=t+l|0;l=((u|h)&b|u&h)+((b>>>2|b<<30)^(b>>>13|b<<19)^(b>>>22|b<<10))+l|0;n=n+-1084653625+(c[f+108>>2]|0)+((t>>>6|t<<26)^(t>>>11|t<<21)^(t>>>25|t<<7))+((p^r)&t^p)|0;u=u+n|0;n=((h|b)&l|h&b)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+n|0;p=p+-958395405+(c[f+112>>2]|0)+((u>>>6|u<<26)^(u>>>11|u<<21)^(u>>>25|u<<7))+((r^t)&u^r)|0;h=h+p|0;p=((b|l)&n|b&l)+((n>>>2|n<<30)^(n>>>13|n<<19)^(n>>>22|n<<10))+p|0;r=r+-710438585+(c[f+116>>2]|0)+((h>>>6|h<<26)^(h>>>11|h<<21)^(h>>>25|h<<7))+((t^u)&h^t)|0;b=b+r|0;r=((l|n)&p|l&n)+((p>>>2|p<<30)^(p>>>13|p<<19)^(p>>>22|p<<10))+r|0;t=t+113926993+(c[f+120>>2]|0)+((b>>>6|b<<26)^(b>>>11|b<<21)^(b>>>25|b<<7))+((u^h)&b^u)|0;l=l+t|0;t=((n|p)&r|n&p)+((r>>>2|r<<30)^(r>>>13|r<<19)^(r>>>22|r<<10))+t|0;u=u+338241895+(c[f+124>>2]|0)+((l>>>6|l<<26)^(l>>>11|l<<21)^(l>>>25|l<<7))+((h^b)&l^h)|0;n=n+u|0;u=((p|r)&t|p&r)+((t>>>2|t<<30)^(t>>>13|t<<19)^(t>>>22|t<<10))+u|0;h=h+666307205+(c[f+128>>2]|0)+((n>>>6|n<<26)^(n>>>11|n<<21)^(n>>>25|n<<7))+((b^l)&n^b)|0;p=p+h|0;h=((r|t)&u|r&t)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+h|0;b=b+773529912+(c[f+132>>2]|0)+((p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7))+((l^n)&p^l)|0;r=r+b|0;b=((t|u)&h|t&u)+((h>>>2|h<<30)^(h>>>13|h<<19)^(h>>>22|h<<10))+b|0;l=l+1294757372+(c[f+136>>2]|0)+((r>>>6|r<<26)^(r>>>11|r<<21)^(r>>>25|r<<7))+((n^p)&r^n)|0;t=t+l|0;l=((u|h)&b|u&h)+((b>>>2|b<<30)^(b>>>13|b<<19)^(b>>>22|b<<10))+l|0;n=n+1396182291+(c[f+140>>2]|0)+((t>>>6|t<<26)^(t>>>11|t<<21)^(t>>>25|t<<7))+((p^r)&t^p)|0;u=u+n|0;n=((h|b)&l|h&b)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+n|0;p=p+1695183700+(c[f+144>>2]|0)+((u>>>6|u<<26)^(u>>>11|u<<21)^(u>>>25|u<<7))+((r^t)&u^r)|0;h=h+p|0;p=((b|l)&n|b&l)+((n>>>2|n<<30)^(n>>>13|n<<19)^(n>>>22|n<<10))+p|0;r=r+1986661051+(c[f+148>>2]|0)+((h>>>6|h<<26)^(h>>>11|h<<21)^(h>>>25|h<<7))+((t^u)&h^t)|0;b=b+r|0;r=((l|n)&p|l&n)+((p>>>2|p<<30)^(p>>>13|p<<19)^(p>>>22|p<<10))+r|0;t=t+-2117940946+(c[f+152>>2]|0)+((b>>>6|b<<26)^(b>>>11|b<<21)^(b>>>25|b<<7))+((u^h)&b^u)|0;l=l+t|0;t=((n|p)&r|n&p)+((r>>>2|r<<30)^(r>>>13|r<<19)^(r>>>22|r<<10))+t|0;u=u+-1838011259+(c[f+156>>2]|0)+((l>>>6|l<<26)^(l>>>11|l<<21)^(l>>>25|l<<7))+((h^b)&l^h)|0;n=n+u|0;u=((p|r)&t|p&r)+((t>>>2|t<<30)^(t>>>13|t<<19)^(t>>>22|t<<10))+u|0;h=h+-1564481375+(c[f+160>>2]|0)+((n>>>6|n<<26)^(n>>>11|n<<21)^(n>>>25|n<<7))+((b^l)&n^b)|0;p=p+h|0;h=((r|t)&u|r&t)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+h|0;b=b+-1474664885+(c[f+164>>2]|0)+((p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7))+((l^n)&p^l)|0;r=r+b|0;b=((t|u)&h|t&u)+((h>>>2|h<<30)^(h>>>13|h<<19)^(h>>>22|h<<10))+b|0;l=l+-1035236496+(c[f+168>>2]|0)+((r>>>6|r<<26)^(r>>>11|r<<21)^(r>>>25|r<<7))+((n^p)&r^n)|0;t=t+l|0;l=((u|h)&b|u&h)+((b>>>2|b<<30)^(b>>>13|b<<19)^(b>>>22|b<<10))+l|0;n=n+-949202525+(c[f+172>>2]|0)+((t>>>6|t<<26)^(t>>>11|t<<21)^(t>>>25|t<<7))+((p^r)&t^p)|0;u=u+n|0;n=((h|b)&l|h&b)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+n|0;p=p+-778901479+(c[f+176>>2]|0)+((u>>>6|u<<26)^(u>>>11|u<<21)^(u>>>25|u<<7))+((r^t)&u^r)|0;h=h+p|0;p=((b|l)&n|b&l)+((n>>>2|n<<30)^(n>>>13|n<<19)^(n>>>22|n<<10))+p|0;r=r+-694614492+(c[f+180>>2]|0)+((h>>>6|h<<26)^(h>>>11|h<<21)^(h>>>25|h<<7))+((t^u)&h^t)|0;b=b+r|0;r=((l|n)&p|l&n)+((p>>>2|p<<30)^(p>>>13|p<<19)^(p>>>22|p<<10))+r|0;t=t+-200395387+(c[f+184>>2]|0)+((b>>>6|b<<26)^(b>>>11|b<<21)^(b>>>25|b<<7))+((u^h)&b^u)|0;l=l+t|0;t=((n|p)&r|n&p)+((r>>>2|r<<30)^(r>>>13|r<<19)^(r>>>22|r<<10))+t|0;u=u+275423344+(c[f+188>>2]|0)+((l>>>6|l<<26)^(l>>>11|l<<21)^(l>>>25|l<<7))+((h^b)&l^h)|0;n=n+u|0;u=((p|r)&t|p&r)+((t>>>2|t<<30)^(t>>>13|t<<19)^(t>>>22|t<<10))+u|0;h=h+430227734+(c[f+192>>2]|0)+((n>>>6|n<<26)^(n>>>11|n<<21)^(n>>>25|n<<7))+((b^l)&n^b)|0;p=p+h|0;h=((r|t)&u|r&t)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+h|0;b=b+506948616+(c[f+196>>2]|0)+((p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7))+((l^n)&p^l)|0;r=r+b|0;b=((t|u)&h|t&u)+((h>>>2|h<<30)^(h>>>13|h<<19)^(h>>>22|h<<10))+b|0;l=l+659060556+(c[f+200>>2]|0)+((r>>>6|r<<26)^(r>>>11|r<<21)^(r>>>25|r<<7))+((n^p)&r^n)|0;t=t+l|0;l=((u|h)&b|u&h)+((b>>>2|b<<30)^(b>>>13|b<<19)^(b>>>22|b<<10))+l|0;n=n+883997877+(c[f+204>>2]|0)+((t>>>6|t<<26)^(t>>>11|t<<21)^(t>>>25|t<<7))+((p^r)&t^p)|0;u=u+n|0;n=((h|b)&l|h&b)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+n|0;p=p+958139571+(c[f+208>>2]|0)+((u>>>6|u<<26)^(u>>>11|u<<21)^(u>>>25|u<<7))+((r^t)&u^r)|0;h=h+p|0;p=((b|l)&n|b&l)+((n>>>2|n<<30)^(n>>>13|n<<19)^(n>>>22|n<<10))+p|0;r=r+1322822218+(c[f+212>>2]|0)+((h>>>6|h<<26)^(h>>>11|h<<21)^(h>>>25|h<<7))+((t^u)&h^t)|0;b=b+r|0;r=((l|n)&p|l&n)+((p>>>2|p<<30)^(p>>>13|p<<19)^(p>>>22|p<<10))+r|0;t=t+1537002063+(c[f+216>>2]|0)+((b>>>6|b<<26)^(b>>>11|b<<21)^(b>>>25|b<<7))+((u^h)&b^u)|0;l=l+t|0;t=((n|p)&r|n&p)+((r>>>2|r<<30)^(r>>>13|r<<19)^(r>>>22|r<<10))+t|0;u=u+1747873779+(c[f+220>>2]|0)+((l>>>6|l<<26)^(l>>>11|l<<21)^(l>>>25|l<<7))+((h^b)&l^h)|0;n=n+u|0;u=((p|r)&t|p&r)+((t>>>2|t<<30)^(t>>>13|t<<19)^(t>>>22|t<<10))+u|0;h=h+1955562222+(c[f+224>>2]|0)+((n>>>6|n<<26)^(n>>>11|n<<21)^(n>>>25|n<<7))+((b^l)&n^b)|0;p=p+h|0;h=((r|t)&u|r&t)+((u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10))+h|0;b=b+2024104815+(c[f+228>>2]|0)+((p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7))+((l^n)&p^l)|0;r=r+b|0;b=((t|u)&h|t&u)+((h>>>2|h<<30)^(h>>>13|h<<19)^(h>>>22|h<<10))+b|0;l=l+-2067236844+(c[f+232>>2]|0)+((r>>>6|r<<26)^(r>>>11|r<<21)^(r>>>25|r<<7))+((n^p)&r^n)|0;t=t+l|0;l=((u|h)&b|u&h)+((b>>>2|b<<30)^(b>>>13|b<<19)^(b>>>22|b<<10))+l|0;n=n+-1933114872+(c[f+236>>2]|0)+((t>>>6|t<<26)^(t>>>11|t<<21)^(t>>>25|t<<7))+((p^r)&t^p)|0;u=u+n|0;n=((h|b)&l|h&b)+((l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10))+n|0;p=p+-1866530822+(c[f+240>>2]|0)+((u>>>6|u<<26)^(u>>>11|u<<21)^(u>>>25|u<<7))+((r^t)&u^r)|0;h=h+p|0;p=((b|l)&n|b&l)+((n>>>2|n<<30)^(n>>>13|n<<19)^(n>>>22|n<<10))+p|0;r=r+-1538233109+(c[f+244>>2]|0)+((h>>>6|h<<26)^(h>>>11|h<<21)^(h>>>25|h<<7))+((t^u)&h^t)|0;b=b+r|0;r=((l|n)&p|l&n)+((p>>>2|p<<30)^(p>>>13|p<<19)^(p>>>22|p<<10))+r|0;t=t+-1090935817+(c[f+248>>2]|0)+((b>>>6|b<<26)^(b>>>11|b<<21)^(b>>>25|b<<7))+((u^h)&b^u)|0;l=l+t|0;t=((n|p)&r|n&p)+((r>>>2|r<<30)^(r>>>13|r<<19)^(r>>>22|r<<10))+t|0;f=u+-965641998+(c[f+252>>2]|0)+((l>>>6|l<<26)^(l>>>11|l<<21)^(l>>>25|l<<7))+((h^b)&l^h)|0;c[a>>2]=(c[a>>2]|0)+(((p|r)&t|p&r)+((t>>>2|t<<30)^(t>>>13|t<<19)^(t>>>22|t<<10))+f);c[s>>2]=(c[s>>2]|0)+t;c[q>>2]=(c[q>>2]|0)+r;c[o>>2]=(c[o>>2]|0)+p;c[m>>2]=(c[m>>2]|0)+(n+f);c[k>>2]=(c[k>>2]|0)+l;c[e>>2]=(c[e>>2]|0)+b;c[j>>2]=(c[j>>2]|0)+h;i=g;return}function Gb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=a+72|0;n=j;p=c[n>>2]|0;n=c[n+4>>2]|0;m=Id(p|0,n|0,3)|0;k=m&127;l=Jd(d|0,e|0,3)|0;o=C;i=Id(d|0,e|0,61)|0;f=C;n=Fd(p|0,n|0,l|0,o|0)|0;p=C;c[j>>2]=n;c[j+4>>2]=p;j=a+64|0;g=j;h=c[g>>2]|0;g=c[g+4>>2]|0;if(p>>>0<o>>>0|(p|0)==(o|0)&n>>>0<l>>>0){h=Fd(h|0,g|0,1,0)|0;g=C;p=j;c[p>>2]=h;c[p+4>>2]=g}i=Fd(h|0,g|0,i|0,f|0)|0;h=j;c[h>>2]=i;c[h+4>>2]=C;h=Ed(128,0,k|0,0)|0;i=C;g=a+80+k|0;if(i>>>0>e>>>0|(i|0)==(e|0)&h>>>0>d>>>0){Kd(g|0,b|0,d|0)|0;return}Kd(g|0,b|0,h|0)|0;l=a+80|0;Ib(a,l);f=b+h|0;g=Ed(d|0,e|0,h|0,i|0)|0;h=C;if(h>>>0>0|(h|0)==0&g>>>0>127){j=Fd(k|0,0,d|0,e|0)|0;j=Fd(j|0,C|0,-256,0)|0;d=j+256|0;i=m&127;while(1){Ib(a,f);g=Fd(g|0,h|0,-128,-1)|0;h=C;if(!(h>>>0>0|(h|0)==0&g>>>0>127))break;else f=f+128|0}g=j&127;f=b+((d&-128)-i)|0}Kd(l|0,f|0,g|0)|0;return}function Hb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;n=i;m=i=i+63&-64;i=i+16|0;e=b+64|0;f=e;h=c[f>>2]|0;f=c[f+4>>2]|0;a[m+7>>0]=h;j=Id(h|0,f|0,8)|0;a[m+6>>0]=j;j=Id(h|0,f|0,16)|0;a[m+5>>0]=j;j=Id(h|0,f|0,24)|0;a[m+4>>0]=j;a[m+3>>0]=f;j=Id(h|0,f|0,40)|0;a[m+2>>0]=j;j=Id(h|0,f|0,48)|0;a[m+1>>0]=j;f=Id(h|0,f|0,56)|0;a[m>>0]=f;f=b+72|0;h=f;j=c[h>>2]|0;h=c[h+4>>2]|0;a[m+15>>0]=j;l=Id(j|0,h|0,8)|0;a[m+14>>0]=l;l=Id(j|0,h|0,16)|0;a[m+13>>0]=l;l=Id(j|0,h|0,24)|0;a[m+12>>0]=l;a[m+11>>0]=h;l=Id(j|0,h|0,40)|0;a[m+10>>0]=l;l=Id(j|0,h|0,48)|0;a[m+9>>0]=l;l=Id(j|0,h|0,56)|0;a[m+8>>0]=l;h=Id(j|0,h|0,3)|0;h=h&127;j=0<0|0==0&h>>>0<112;h=Ed((j?112:240)|0,(j?0:0)|0,h|0,0)|0;Gb(b,32856,h,C);h=f;j=c[h>>2]|0;h=c[h+4>>2]|0;l=Id(j|0,h|0,3)|0;k=l&127;g=Fd(j|0,h|0,128,0)|0;c[f>>2]=g;c[f+4>>2]=C;f=e;g=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0>4294967295|(h|0)==-1&j>>>0>4294967167){g=Fd(g|0,f|0,1,0)|0;f=C;j=e;c[j>>2]=g;c[j+4>>2]=f}h=e;c[h>>2]=g;c[h+4>>2]=f;f=Ed(128,0,k|0,0)|0;h=C;g=b+80+k|0;if(h>>>0>0|(h|0)==0&f>>>0>16){e=m;f=g+16|0;do{a[g>>0]=a[e>>0]|0;g=g+1|0;e=e+1|0}while((g|0)<(f|0))}else{Kd(g|0,m|0,f|0)|0;j=b+80|0;Ib(b,j);e=m+f|0;g=Ed(16,0,f|0,h|0)|0;h=C;if(h>>>0>0|(h|0)==0&g>>>0>127){f=Fd(k|0,0,-240,0)|0;while(1){Ib(b,e);g=Fd(g|0,h|0,-128,-1)|0;h=C;if(!(h>>>0>0|(h|0)==0&g>>>0>127))break;else e=e+128|0}g=f&127;e=m+((f+256&-128)-(l&127))|0}Kd(j|0,e|0,g|0)|0}e=0;do{m=e<<3;l=b+(e<<3)|0;k=c[l>>2]|0;l=c[l+4>>2]|0;a[d+(m|7)>>0]=k;j=Id(k|0,l|0,8)|0;a[d+(m|6)>>0]=j;j=Id(k|0,l|0,16)|0;a[d+(m|5)>>0]=j;j=Id(k|0,l|0,24)|0;a[d+(m|4)>>0]=j;a[d+(m|3)>>0]=l;j=Id(k|0,l|0,40)|0;a[d+(m|2)>>0]=j;j=Id(k|0,l|0,48)|0;a[d+(m|1)>>0]=j;l=Id(k|0,l|0,56)|0;a[d+m>>0]=l;e=e+1|0}while((e|0)!=8);Hd(b|0,0,208)|0;i=n;return}
function qd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;do if(a>>>0<245){q=a>>>0<11?16:a+11&-8;a=q>>>3;k=c[7991]|0;j=k>>>a;if(j&3){e=(j&1^1)+a|0;b=e<<1;d=32004+(b<<2)|0;b=32004+(b+2<<2)|0;f=c[b>>2]|0;g=f+8|0;h=c[g>>2]|0;do if((d|0)==(h|0))c[7991]=k&~(1<<e);else{if(h>>>0>=(c[7995]|0)>>>0?(l=h+12|0,(c[l>>2]|0)==(f|0)):0){c[l>>2]=d;c[b>>2]=h;break}ra()}while(0);Q=e<<3;c[f+4>>2]=Q|3;Q=f+(Q|4)|0;c[Q>>2]=c[Q>>2]|1;break}b=c[7993]|0;if(q>>>0>b>>>0){if(j){f=2<<a;f=j<<a&(f|0-f);f=(f&0-f)+-1|0;g=f>>>12&16;f=f>>>g;e=f>>>5&8;f=f>>>e;d=f>>>2&4;f=f>>>d;h=f>>>1&2;f=f>>>h;i=f>>>1&1;i=(e|g|d|h|i)+(f>>>i)|0;f=i<<1;h=32004+(f<<2)|0;f=32004+(f+2<<2)|0;d=c[f>>2]|0;g=d+8|0;e=c[g>>2]|0;do if((h|0)==(e|0)){c[7991]=k&~(1<<i);n=b}else{if(e>>>0>=(c[7995]|0)>>>0?(m=e+12|0,(c[m>>2]|0)==(d|0)):0){c[m>>2]=h;c[f>>2]=e;n=c[7993]|0;break}ra()}while(0);Q=i<<3;b=Q-q|0;c[d+4>>2]=q|3;j=d+q|0;c[d+(q|4)>>2]=b|1;c[d+Q>>2]=b;if(n){d=c[7996]|0;e=n>>>3;h=e<<1;i=32004+(h<<2)|0;f=c[7991]|0;e=1<<e;if(f&e){f=32004+(h+2<<2)|0;h=c[f>>2]|0;if(h>>>0<(c[7995]|0)>>>0)ra();else{o=f;p=h}}else{c[7991]=f|e;o=32004+(h+2<<2)|0;p=i}c[o>>2]=d;c[p+12>>2]=d;c[d+8>>2]=p;c[d+12>>2]=i}c[7993]=b;c[7996]=j;break}a=c[7992]|0;if(a){b=(a&0-a)+-1|0;P=b>>>12&16;b=b>>>P;O=b>>>5&8;b=b>>>O;Q=b>>>2&4;b=b>>>Q;h=b>>>1&2;b=b>>>h;k=b>>>1&1;k=c[32268+((O|P|Q|h|k)+(b>>>k)<<2)>>2]|0;b=(c[k+4>>2]&-8)-q|0;h=k;while(1){i=c[h+16>>2]|0;if(!i){i=c[h+20>>2]|0;if(!i)break}h=(c[i+4>>2]&-8)-q|0;Q=h>>>0<b>>>0;b=Q?h:b;h=i;k=Q?i:k}a=c[7995]|0;if(k>>>0>=a>>>0?(t=k+q|0,k>>>0<t>>>0):0){j=c[k+24>>2]|0;i=c[k+12>>2]|0;do if((i|0)==(k|0)){h=k+20|0;i=c[h>>2]|0;if(!i){h=k+16|0;i=c[h>>2]|0;if(!i){d=0;break}}while(1){g=i+20|0;f=c[g>>2]|0;if(f){i=f;h=g;continue}g=i+16|0;f=c[g>>2]|0;if(!f)break;else{i=f;h=g}}if(h>>>0<a>>>0)ra();else{c[h>>2]=0;d=i;break}}else{h=c[k+8>>2]|0;if((h>>>0>=a>>>0?(f=h+12|0,(c[f>>2]|0)==(k|0)):0)?(e=i+8|0,(c[e>>2]|0)==(k|0)):0){c[f>>2]=i;c[e>>2]=h;d=i;break}ra()}while(0);do if(j){h=c[k+28>>2]|0;g=32268+(h<<2)|0;if((k|0)==(c[g>>2]|0)){c[g>>2]=d;if(!d){c[7992]=c[7992]&~(1<<h);break}}else{if(j>>>0<(c[7995]|0)>>>0)ra();h=j+16|0;if((c[h>>2]|0)==(k|0))c[h>>2]=d;else c[j+20>>2]=d;if(!d)break}g=c[7995]|0;if(d>>>0<g>>>0)ra();c[d+24>>2]=j;h=c[k+16>>2]|0;do if(h)if(h>>>0<g>>>0)ra();else{c[d+16>>2]=h;c[h+24>>2]=d;break}while(0);h=c[k+20>>2]|0;if(h)if(h>>>0<(c[7995]|0)>>>0)ra();else{c[d+20>>2]=h;c[h+24>>2]=d;break}}while(0);if(b>>>0<16){Q=b+q|0;c[k+4>>2]=Q|3;Q=k+(Q+4)|0;c[Q>>2]=c[Q>>2]|1}else{c[k+4>>2]=q|3;c[k+(q|4)>>2]=b|1;c[k+(b+q)>>2]=b;e=c[7993]|0;if(e){d=c[7996]|0;f=e>>>3;h=f<<1;i=32004+(h<<2)|0;g=c[7991]|0;f=1<<f;if(g&f){h=32004+(h+2<<2)|0;g=c[h>>2]|0;if(g>>>0<(c[7995]|0)>>>0)ra();else{s=h;u=g}}else{c[7991]=g|f;s=32004+(h+2<<2)|0;u=i}c[s>>2]=d;c[u+12>>2]=d;c[d+8>>2]=u;c[d+12>>2]=i}c[7993]=b;c[7996]=t}g=k+8|0;break}ra()}else{u=q;R=154}}else{u=q;R=154}}else if(a>>>0<=4294967231){a=a+11|0;u=a&-8;b=c[7992]|0;if(b){j=0-u|0;a=a>>>8;if(a)if(u>>>0>16777215)k=31;else{t=(a+1048320|0)>>>16&8;R=a<<t;s=(R+520192|0)>>>16&4;R=R<<s;k=(R+245760|0)>>>16&2;k=14-(s|t|k)+(R<<k>>>15)|0;k=u>>>(k+7|0)&1|k<<1}else k=0;a=c[32268+(k<<2)>>2]|0;a:do if(!a){i=0;a=0;R=86}else{f=j;i=0;e=u<<((k|0)==31?0:25-(k>>>1)|0);d=a;a=0;while(1){h=c[d+4>>2]&-8;j=h-u|0;if(j>>>0<f>>>0)if((h|0)==(u|0)){h=d;a=d;R=90;break a}else a=d;else j=f;R=c[d+20>>2]|0;d=c[d+16+(e>>>31<<2)>>2]|0;i=(R|0)==0|(R|0)==(d|0)?i:R;if(!d){R=86;break}else{f=j;e=e<<1}}}while(0);if((R|0)==86){if((i|0)==0&(a|0)==0){a=2<<k;a=b&(a|0-a);if(!a){R=154;break}a=(a&0-a)+-1|0;p=a>>>12&16;a=a>>>p;o=a>>>5&8;a=a>>>o;s=a>>>2&4;a=a>>>s;t=a>>>1&2;a=a>>>t;i=a>>>1&1;i=c[32268+((o|p|s|t|i)+(a>>>i)<<2)>>2]|0;a=0}if(!i){p=j;o=a}else{h=i;R=90}}if((R|0)==90)while(1){R=0;t=(c[h+4>>2]&-8)-u|0;i=t>>>0<j>>>0;j=i?t:j;a=i?h:a;i=c[h+16>>2]|0;if(i){h=i;R=90;continue}h=c[h+20>>2]|0;if(!h){p=j;o=a;break}else R=90}if((o|0)!=0?p>>>0<((c[7993]|0)-u|0)>>>0:0){a=c[7995]|0;if(o>>>0>=a>>>0?(B=o+u|0,o>>>0<B>>>0):0){j=c[o+24>>2]|0;i=c[o+12>>2]|0;do if((i|0)==(o|0)){h=o+20|0;i=c[h>>2]|0;if(!i){h=o+16|0;i=c[h>>2]|0;if(!i){v=0;break}}while(1){g=i+20|0;f=c[g>>2]|0;if(f){i=f;h=g;continue}g=i+16|0;f=c[g>>2]|0;if(!f)break;else{i=f;h=g}}if(h>>>0<a>>>0)ra();else{c[h>>2]=0;v=i;break}}else{h=c[o+8>>2]|0;if((h>>>0>=a>>>0?(q=h+12|0,(c[q>>2]|0)==(o|0)):0)?(r=i+8|0,(c[r>>2]|0)==(o|0)):0){c[q>>2]=i;c[r>>2]=h;v=i;break}ra()}while(0);do if(j){i=c[o+28>>2]|0;h=32268+(i<<2)|0;if((o|0)==(c[h>>2]|0)){c[h>>2]=v;if(!v){c[7992]=c[7992]&~(1<<i);break}}else{if(j>>>0<(c[7995]|0)>>>0)ra();h=j+16|0;if((c[h>>2]|0)==(o|0))c[h>>2]=v;else c[j+20>>2]=v;if(!v)break}i=c[7995]|0;if(v>>>0<i>>>0)ra();c[v+24>>2]=j;h=c[o+16>>2]|0;do if(h)if(h>>>0<i>>>0)ra();else{c[v+16>>2]=h;c[h+24>>2]=v;break}while(0);h=c[o+20>>2]|0;if(h)if(h>>>0<(c[7995]|0)>>>0)ra();else{c[v+20>>2]=h;c[h+24>>2]=v;break}}while(0);b:do if(p>>>0>=16){c[o+4>>2]=u|3;c[o+(u|4)>>2]=p|1;c[o+(p+u)>>2]=p;i=p>>>3;if(p>>>0<256){g=i<<1;e=32004+(g<<2)|0;f=c[7991]|0;h=1<<i;if(f&h){h=32004+(g+2<<2)|0;g=c[h>>2]|0;if(g>>>0<(c[7995]|0)>>>0)ra();else{x=h;y=g}}else{c[7991]=f|h;x=32004+(g+2<<2)|0;y=e}c[x>>2]=B;c[y+12>>2]=B;c[o+(u+8)>>2]=y;c[o+(u+12)>>2]=e;break}d=p>>>8;if(d)if(p>>>0>16777215)i=31;else{P=(d+1048320|0)>>>16&8;Q=d<<P;O=(Q+520192|0)>>>16&4;Q=Q<<O;i=(Q+245760|0)>>>16&2;i=14-(O|P|i)+(Q<<i>>>15)|0;i=p>>>(i+7|0)&1|i<<1}else i=0;h=32268+(i<<2)|0;c[o+(u+28)>>2]=i;c[o+(u+20)>>2]=0;c[o+(u+16)>>2]=0;g=c[7992]|0;f=1<<i;if(!(g&f)){c[7992]=g|f;c[h>>2]=B;c[o+(u+24)>>2]=h;c[o+(u+12)>>2]=B;c[o+(u+8)>>2]=B;break}h=c[h>>2]|0;c:do if((c[h+4>>2]&-8|0)!=(p|0)){i=p<<((i|0)==31?0:25-(i>>>1)|0);while(1){f=h+16+(i>>>31<<2)|0;g=c[f>>2]|0;if(!g)break;if((c[g+4>>2]&-8|0)==(p|0)){z=g;break c}else{i=i<<1;h=g}}if(f>>>0<(c[7995]|0)>>>0)ra();else{c[f>>2]=B;c[o+(u+24)>>2]=h;c[o+(u+12)>>2]=B;c[o+(u+8)>>2]=B;break b}}else z=h;while(0);d=z+8|0;b=c[d>>2]|0;Q=c[7995]|0;if(b>>>0>=Q>>>0&z>>>0>=Q>>>0){c[b+12>>2]=B;c[d>>2]=B;c[o+(u+8)>>2]=b;c[o+(u+12)>>2]=z;c[o+(u+24)>>2]=0;break}else ra()}else{Q=p+u|0;c[o+4>>2]=Q|3;Q=o+(Q+4)|0;c[Q>>2]=c[Q>>2]|1}while(0);g=o+8|0;break}ra()}else R=154}else R=154}else{u=-1;R=154}while(0);d:do if((R|0)==154){a=c[7993]|0;if(a>>>0>=u>>>0){b=a-u|0;d=c[7996]|0;if(b>>>0>15){c[7996]=d+u;c[7993]=b;c[d+(u+4)>>2]=b|1;c[d+a>>2]=b;c[d+4>>2]=u|3}else{c[7993]=0;c[7996]=0;c[d+4>>2]=a|3;R=d+(a+4)|0;c[R>>2]=c[R>>2]|1}g=d+8|0;break}j=c[7994]|0;if(j>>>0>u>>>0){R=j-u|0;c[7994]=R;g=c[7997]|0;c[7997]=g+u;c[g+(u+4)>>2]=R|1;c[g+4>>2]=u|3;g=g+8|0;break}do if(!(c[8109]|0)){j=na(30)|0;if(!(j+-1&j)){c[8111]=j;c[8110]=j;c[8112]=-1;c[8113]=-1;c[8114]=0;c[8102]=0;c[8109]=(ta(0)|0)&-16^1431655768;break}else ra()}while(0);k=u+48|0;h=c[8111]|0;f=u+47|0;i=h+f|0;h=0-h|0;l=i&h;if(l>>>0>u>>>0){a=c[8101]|0;if((a|0)!=0?(z=c[8099]|0,B=z+l|0,B>>>0<=z>>>0|B>>>0>a>>>0):0){g=0;break}e:do if(!(c[8102]&4)){j=c[7997]|0;f:do if(j){g=32412;while(1){a=c[g>>2]|0;if(a>>>0<=j>>>0?(w=g+4|0,(a+(c[w>>2]|0)|0)>>>0>j>>>0):0)break;a=c[g+8>>2]|0;if(!a){R=174;break f}else g=a}a=i-(c[7994]|0)&h;if(a>>>0<2147483647){i=sa(a|0)|0;B=(i|0)==((c[g>>2]|0)+(c[w>>2]|0)|0);j=B?a:0;if(B){if((i|0)!=(-1|0)){y=i;q=j;R=194;break e}}else R=184}else j=0}else R=174;while(0);do if((R|0)==174){h=sa(0)|0;if((h|0)!=(-1|0)){a=h;j=c[8110]|0;i=j+-1|0;if(!(i&a))a=l;else a=l-a+(i+a&0-j)|0;j=c[8099]|0;i=j+a|0;if(a>>>0>u>>>0&a>>>0<2147483647){B=c[8101]|0;if((B|0)!=0?i>>>0<=j>>>0|i>>>0>B>>>0:0){j=0;break}i=sa(a|0)|0;R=(i|0)==(h|0);j=R?a:0;if(R){y=h;q=j;R=194;break e}else R=184}else j=0}else j=0}while(0);g:do if((R|0)==184){h=0-a|0;do if(k>>>0>a>>>0&(a>>>0<2147483647&(i|0)!=(-1|0))?(A=c[8111]|0,A=f-a+A&0-A,A>>>0<2147483647):0)if((sa(A|0)|0)==(-1|0)){sa(h|0)|0;break g}else{a=A+a|0;break}while(0);if((i|0)!=(-1|0)){y=i;q=a;R=194;break e}}while(0);c[8102]=c[8102]|4;R=191}else{j=0;R=191}while(0);if((((R|0)==191?l>>>0<2147483647:0)?(C=sa(l|0)|0,D=sa(0)|0,C>>>0<D>>>0&((C|0)!=(-1|0)&(D|0)!=(-1|0))):0)?(E=D-C|0,F=E>>>0>(u+40|0)>>>0,F):0){y=C;q=F?E:j;R=194}if((R|0)==194){i=(c[8099]|0)+q|0;c[8099]=i;if(i>>>0>(c[8100]|0)>>>0)c[8100]=i;p=c[7997]|0;h:do if(p){g=32412;while(1){a=c[g>>2]|0;j=g+4|0;i=c[j>>2]|0;if((y|0)==(a+i|0)){R=204;break}h=c[g+8>>2]|0;if(!h)break;else g=h}if(((R|0)==204?(c[g+12>>2]&8|0)==0:0)?p>>>0<y>>>0&p>>>0>=a>>>0:0){c[j>>2]=i+q;R=(c[7994]|0)+q|0;Q=p+8|0;Q=(Q&7|0)==0?0:0-Q&7;P=R-Q|0;c[7997]=p+Q;c[7994]=P;c[p+(Q+4)>>2]=P|1;c[p+(R+4)>>2]=40;c[7998]=c[8113];break}j=c[7995]|0;if(y>>>0<j>>>0){c[7995]=y;j=y}h=y+q|0;i=32412;while(1){if((c[i>>2]|0)==(h|0)){R=212;break}i=c[i+8>>2]|0;if(!i){i=32412;break}}if((R|0)==212)if(!(c[i+12>>2]&8)){c[i>>2]=y;n=i+4|0;c[n>>2]=(c[n>>2]|0)+q;n=y+8|0;n=(n&7|0)==0?0:0-n&7;l=y+(q+8)|0;l=(l&7|0)==0?0:0-l&7;i=y+(l+q)|0;o=n+u|0;m=y+o|0;a=i-(y+n)-u|0;c[y+(n+4)>>2]=u|3;i:do if((i|0)!=(p|0)){if((i|0)==(c[7996]|0)){R=(c[7993]|0)+a|0;c[7993]=R;c[7996]=m;c[y+(o+4)>>2]=R|1;c[y+(R+o)>>2]=R;break}b=q+4|0;h=c[y+(b+l)>>2]|0;if((h&3|0)==1){k=h&-8;e=h>>>3;j:do if(h>>>0>=256){d=c[y+((l|24)+q)>>2]|0;g=c[y+(q+12+l)>>2]|0;k:do if((g|0)==(i|0)){g=l|16;f=y+(b+g)|0;h=c[f>>2]|0;if(!h){g=y+(g+q)|0;h=c[g>>2]|0;if(!h){N=0;break}}else g=f;while(1){f=h+20|0;e=c[f>>2]|0;if(e){h=e;g=f;continue}f=h+16|0;e=c[f>>2]|0;if(!e)break;else{h=e;g=f}}if(g>>>0<j>>>0)ra();else{c[g>>2]=0;N=h;break}}else{f=c[y+((l|8)+q)>>2]|0;do if(f>>>0>=j>>>0){j=f+12|0;if((c[j>>2]|0)!=(i|0))break;h=g+8|0;if((c[h>>2]|0)!=(i|0))break;c[j>>2]=g;c[h>>2]=f;N=g;break k}while(0);ra()}while(0);if(!d)break;j=c[y+(q+28+l)>>2]|0;h=32268+(j<<2)|0;do if((i|0)!=(c[h>>2]|0)){if(d>>>0<(c[7995]|0)>>>0)ra();h=d+16|0;if((c[h>>2]|0)==(i|0))c[h>>2]=N;else c[d+20>>2]=N;if(!N)break j}else{c[h>>2]=N;if(N)break;c[7992]=c[7992]&~(1<<j);break j}while(0);j=c[7995]|0;if(N>>>0<j>>>0)ra();c[N+24>>2]=d;i=l|16;h=c[y+(i+q)>>2]|0;do if(h)if(h>>>0<j>>>0)ra();else{c[N+16>>2]=h;c[h+24>>2]=N;break}while(0);i=c[y+(b+i)>>2]|0;if(!i)break;if(i>>>0<(c[7995]|0)>>>0)ra();else{c[N+20>>2]=i;c[i+24>>2]=N;break}}else{h=c[y+((l|8)+q)>>2]|0;g=c[y+(q+12+l)>>2]|0;f=32004+(e<<1<<2)|0;do if((h|0)!=(f|0)){if(h>>>0>=j>>>0?(c[h+12>>2]|0)==(i|0):0)break;ra()}while(0);if((g|0)==(h|0)){c[7991]=c[7991]&~(1<<e);break}do if((g|0)==(f|0))I=g+8|0;else{if(g>>>0>=j>>>0?(J=g+8|0,(c[J>>2]|0)==(i|0)):0){I=J;break}ra()}while(0);c[h+12>>2]=g;c[I>>2]=h}while(0);i=y+((k|l)+q)|0;a=k+a|0}i=i+4|0;c[i>>2]=c[i>>2]&-2;c[y+(o+4)>>2]=a|1;c[y+(a+o)>>2]=a;i=a>>>3;if(a>>>0<256){g=i<<1;e=32004+(g<<2)|0;f=c[7991]|0;h=1<<i;do if(!(f&h)){c[7991]=f|h;O=32004+(g+2<<2)|0;P=e}else{h=32004+(g+2<<2)|0;g=c[h>>2]|0;if(g>>>0>=(c[7995]|0)>>>0){O=h;P=g;break}ra()}while(0);c[O>>2]=m;c[P+12>>2]=m;c[y+(o+8)>>2]=P;c[y+(o+12)>>2]=e;break}d=a>>>8;do if(!d)i=0;else{if(a>>>0>16777215){i=31;break}P=(d+1048320|0)>>>16&8;R=d<<P;O=(R+520192|0)>>>16&4;R=R<<O;i=(R+245760|0)>>>16&2;i=14-(O|P|i)+(R<<i>>>15)|0;i=a>>>(i+7|0)&1|i<<1}while(0);h=32268+(i<<2)|0;c[y+(o+28)>>2]=i;c[y+(o+20)>>2]=0;c[y+(o+16)>>2]=0;g=c[7992]|0;f=1<<i;if(!(g&f)){c[7992]=g|f;c[h>>2]=m;c[y+(o+24)>>2]=h;c[y+(o+12)>>2]=m;c[y+(o+8)>>2]=m;break}h=c[h>>2]|0;l:do if((c[h+4>>2]&-8|0)!=(a|0)){i=a<<((i|0)==31?0:25-(i>>>1)|0);while(1){f=h+16+(i>>>31<<2)|0;g=c[f>>2]|0;if(!g)break;if((c[g+4>>2]&-8|0)==(a|0)){Q=g;break l}else{i=i<<1;h=g}}if(f>>>0<(c[7995]|0)>>>0)ra();else{c[f>>2]=m;c[y+(o+24)>>2]=h;c[y+(o+12)>>2]=m;c[y+(o+8)>>2]=m;break i}}else Q=h;while(0);d=Q+8|0;b=c[d>>2]|0;R=c[7995]|0;if(b>>>0>=R>>>0&Q>>>0>=R>>>0){c[b+12>>2]=m;c[d>>2]=m;c[y+(o+8)>>2]=b;c[y+(o+12)>>2]=Q;c[y+(o+24)>>2]=0;break}else ra()}else{R=(c[7994]|0)+a|0;c[7994]=R;c[7997]=m;c[y+(o+4)>>2]=R|1}while(0);g=y+(n|8)|0;break d}else i=32412;while(1){h=c[i>>2]|0;if(h>>>0<=p>>>0?(G=c[i+4>>2]|0,H=h+G|0,H>>>0>p>>>0):0)break;i=c[i+8>>2]|0}i=h+(G+-39)|0;i=h+(G+-47+((i&7|0)==0?0:0-i&7))|0;j=p+16|0;i=i>>>0<j>>>0?p:i;h=i+8|0;g=y+8|0;g=(g&7|0)==0?0:0-g&7;R=q+-40-g|0;c[7997]=y+g;c[7994]=R;c[y+(g+4)>>2]=R|1;c[y+(q+-36)>>2]=40;c[7998]=c[8113];g=i+4|0;c[g>>2]=27;c[h>>2]=c[8103];c[h+4>>2]=c[8104];c[h+8>>2]=c[8105];c[h+12>>2]=c[8106];c[8103]=y;c[8104]=q;c[8106]=0;c[8105]=h;h=i+28|0;c[h>>2]=7;if((i+32|0)>>>0<H>>>0)do{R=h;h=h+4|0;c[h>>2]=7}while((R+8|0)>>>0<H>>>0);if((i|0)!=(p|0)){a=i-p|0;c[g>>2]=c[g>>2]&-2;c[p+4>>2]=a|1;c[i>>2]=a;f=a>>>3;if(a>>>0<256){h=f<<1;i=32004+(h<<2)|0;g=c[7991]|0;e=1<<f;if(g&e){d=32004+(h+2<<2)|0;b=c[d>>2]|0;if(b>>>0<(c[7995]|0)>>>0)ra();else{K=d;L=b}}else{c[7991]=g|e;K=32004+(h+2<<2)|0;L=i}c[K>>2]=p;c[L+12>>2]=p;c[p+8>>2]=L;c[p+12>>2]=i;break}d=a>>>8;if(d)if(a>>>0>16777215)h=31;else{Q=(d+1048320|0)>>>16&8;R=d<<Q;P=(R+520192|0)>>>16&4;R=R<<P;h=(R+245760|0)>>>16&2;h=14-(P|Q|h)+(R<<h>>>15)|0;h=a>>>(h+7|0)&1|h<<1}else h=0;e=32268+(h<<2)|0;c[p+28>>2]=h;c[p+20>>2]=0;c[j>>2]=0;d=c[7992]|0;b=1<<h;if(!(d&b)){c[7992]=d|b;c[e>>2]=p;c[p+24>>2]=e;c[p+12>>2]=p;c[p+8>>2]=p;break}d=c[e>>2]|0;m:do if((c[d+4>>2]&-8|0)!=(a|0)){h=a<<((h|0)==31?0:25-(h>>>1)|0);while(1){e=d+16+(h>>>31<<2)|0;b=c[e>>2]|0;if(!b)break;if((c[b+4>>2]&-8|0)==(a|0)){M=b;break m}else{h=h<<1;d=b}}if(e>>>0<(c[7995]|0)>>>0)ra();else{c[e>>2]=p;c[p+24>>2]=d;c[p+12>>2]=p;c[p+8>>2]=p;break h}}else M=d;while(0);d=M+8|0;b=c[d>>2]|0;R=c[7995]|0;if(b>>>0>=R>>>0&M>>>0>=R>>>0){c[b+12>>2]=p;c[d>>2]=p;c[p+8>>2]=b;c[p+12>>2]=M;c[p+24>>2]=0;break}else ra()}}else{R=c[7995]|0;if((R|0)==0|y>>>0<R>>>0)c[7995]=y;c[8103]=y;c[8104]=q;c[8106]=0;c[8e3]=c[8109];c[7999]=-1;d=0;do{R=d<<1;Q=32004+(R<<2)|0;c[32004+(R+3<<2)>>2]=Q;c[32004+(R+2<<2)>>2]=Q;d=d+1|0}while((d|0)!=32);R=y+8|0;R=(R&7|0)==0?0:0-R&7;Q=q+-40-R|0;c[7997]=y+R;c[7994]=Q;c[y+(R+4)>>2]=Q|1;c[y+(q+-36)>>2]=40;c[7998]=c[8113]}while(0);b=c[7994]|0;if(b>>>0>u>>>0){R=b-u|0;c[7994]=R;g=c[7997]|0;c[7997]=g+u;c[g+(u+4)>>2]=R|1;c[g+4>>2]=u|3;g=g+8|0;break}}if(!(c[7979]|0))b=32460;else b=c[(oa()|0)+60>>2]|0;c[b>>2]=12;g=0}else g=0}while(0);return g|0}function rd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;a:do if(a){f=a+-8|0;k=c[7995]|0;b:do if(f>>>0>=k>>>0?(e=c[a+-4>>2]|0,d=e&3,(d|0)!=1):0){v=e&-8;w=a+(v+-8)|0;do if(!(e&1)){f=c[f>>2]|0;if(!d)break a;l=-8-f|0;n=a+l|0;o=f+v|0;if(n>>>0<k>>>0)break b;if((n|0)==(c[7996]|0)){g=a+(v+-4)|0;f=c[g>>2]|0;if((f&3|0)!=3){B=n;g=o;break}c[7993]=o;c[g>>2]=f&-2;c[a+(l+4)>>2]=o|1;c[w>>2]=o;break a}d=f>>>3;if(f>>>0<256){e=c[a+(l+8)>>2]|0;g=c[a+(l+12)>>2]|0;f=32004+(d<<1<<2)|0;do if((e|0)!=(f|0)){if(e>>>0>=k>>>0?(c[e+12>>2]|0)==(n|0):0)break;ra()}while(0);if((g|0)==(e|0)){c[7991]=c[7991]&~(1<<d);B=n;g=o;break}do if((g|0)==(f|0))b=g+8|0;else{if(g>>>0>=k>>>0?(h=g+8|0,(c[h>>2]|0)==(n|0)):0){b=h;break}ra()}while(0);c[e+12>>2]=g;c[b>>2]=e;B=n;g=o;break}h=c[a+(l+24)>>2]|0;f=c[a+(l+12)>>2]|0;do if((f|0)==(n|0)){e=a+(l+20)|0;f=c[e>>2]|0;if(!f){e=a+(l+16)|0;f=c[e>>2]|0;if(!f){m=0;break}}while(1){d=f+20|0;b=c[d>>2]|0;if(b){f=b;e=d;continue}d=f+16|0;b=c[d>>2]|0;if(!b)break;else{f=b;e=d}}if(e>>>0<k>>>0)ra();else{c[e>>2]=0;m=f;break}}else{e=c[a+(l+8)>>2]|0;if((e>>>0>=k>>>0?(i=e+12|0,(c[i>>2]|0)==(n|0)):0)?(j=f+8|0,(c[j>>2]|0)==(n|0)):0){c[i>>2]=f;c[j>>2]=e;m=f;break}ra()}while(0);if(h){f=c[a+(l+28)>>2]|0;e=32268+(f<<2)|0;if((n|0)==(c[e>>2]|0)){c[e>>2]=m;if(!m){c[7992]=c[7992]&~(1<<f);B=n;g=o;break}}else{if(h>>>0<(c[7995]|0)>>>0)ra();f=h+16|0;if((c[f>>2]|0)==(n|0))c[f>>2]=m;else c[h+20>>2]=m;if(!m){B=n;g=o;break}}e=c[7995]|0;if(m>>>0<e>>>0)ra();c[m+24>>2]=h;f=c[a+(l+16)>>2]|0;do if(f)if(f>>>0<e>>>0)ra();else{c[m+16>>2]=f;c[f+24>>2]=m;break}while(0);f=c[a+(l+20)>>2]|0;if(f)if(f>>>0<(c[7995]|0)>>>0)ra();else{c[m+20>>2]=f;c[f+24>>2]=m;B=n;g=o;break}else{B=n;g=o}}else{B=n;g=o}}else{B=f;g=v}while(0);if(B>>>0<w>>>0?(p=a+(v+-4)|0,q=c[p>>2]|0,(q&1|0)!=0):0){if(!(q&2)){if((w|0)==(c[7997]|0)){A=(c[7994]|0)+g|0;c[7994]=A;c[7997]=B;c[B+4>>2]=A|1;if((B|0)!=(c[7996]|0))break a;c[7996]=0;c[7993]=0;break a}if((w|0)==(c[7996]|0)){A=(c[7993]|0)+g|0;c[7993]=A;c[7996]=B;c[B+4>>2]=A|1;c[B+A>>2]=A;break a}j=(q&-8)+g|0;d=q>>>3;do if(q>>>0>=256){b=c[a+(v+16)>>2]|0;g=c[a+(v|4)>>2]|0;do if((g|0)==(w|0)){f=a+(v+12)|0;g=c[f>>2]|0;if(!g){f=a+(v+8)|0;g=c[f>>2]|0;if(!g){x=0;break}}while(1){e=g+20|0;d=c[e>>2]|0;if(d){g=d;f=e;continue}e=g+16|0;d=c[e>>2]|0;if(!d)break;else{g=d;f=e}}if(f>>>0<(c[7995]|0)>>>0)ra();else{c[f>>2]=0;x=g;break}}else{f=c[a+v>>2]|0;if((f>>>0>=(c[7995]|0)>>>0?(t=f+12|0,(c[t>>2]|0)==(w|0)):0)?(u=g+8|0,(c[u>>2]|0)==(w|0)):0){c[t>>2]=g;c[u>>2]=f;x=g;break}ra()}while(0);if(b){g=c[a+(v+20)>>2]|0;f=32268+(g<<2)|0;if((w|0)==(c[f>>2]|0)){c[f>>2]=x;if(!x){c[7992]=c[7992]&~(1<<g);break}}else{if(b>>>0<(c[7995]|0)>>>0)ra();g=b+16|0;if((c[g>>2]|0)==(w|0))c[g>>2]=x;else c[b+20>>2]=x;if(!x)break}g=c[7995]|0;if(x>>>0<g>>>0)ra();c[x+24>>2]=b;f=c[a+(v+8)>>2]|0;do if(f)if(f>>>0<g>>>0)ra();else{c[x+16>>2]=f;c[f+24>>2]=x;break}while(0);d=c[a+(v+12)>>2]|0;if(d)if(d>>>0<(c[7995]|0)>>>0)ra();else{c[x+20>>2]=d;c[d+24>>2]=x;break}}}else{e=c[a+v>>2]|0;g=c[a+(v|4)>>2]|0;f=32004+(d<<1<<2)|0;do if((e|0)!=(f|0)){if(e>>>0>=(c[7995]|0)>>>0?(c[e+12>>2]|0)==(w|0):0)break;ra()}while(0);if((g|0)==(e|0)){c[7991]=c[7991]&~(1<<d);break}do if((g|0)==(f|0))r=g+8|0;else{if(g>>>0>=(c[7995]|0)>>>0?(s=g+8|0,(c[s>>2]|0)==(w|0)):0){r=s;break}ra()}while(0);c[e+12>>2]=g;c[r>>2]=e}while(0);c[B+4>>2]=j|1;c[B+j>>2]=j;if((B|0)==(c[7996]|0)){c[7993]=j;break a}else g=j}else{c[p>>2]=q&-2;c[B+4>>2]=g|1;c[B+g>>2]=g}f=g>>>3;if(g>>>0<256){e=f<<1;g=32004+(e<<2)|0;b=c[7991]|0;d=1<<f;if(b&d){d=32004+(e+2<<2)|0;b=c[d>>2]|0;if(b>>>0<(c[7995]|0)>>>0)ra();else{y=d;z=b}}else{c[7991]=b|d;y=32004+(e+2<<2)|0;z=g}c[y>>2]=B;c[z+12>>2]=B;c[B+8>>2]=z;c[B+12>>2]=g;break a}b=g>>>8;if(b)if(g>>>0>16777215)f=31;else{y=(b+1048320|0)>>>16&8;z=b<<y;a=(z+520192|0)>>>16&4;z=z<<a;f=(z+245760|0)>>>16&2;f=14-(a|y|f)+(z<<f>>>15)|0;f=g>>>(f+7|0)&1|f<<1}else f=0;d=32268+(f<<2)|0;c[B+28>>2]=f;c[B+20>>2]=0;c[B+16>>2]=0;b=c[7992]|0;e=1<<f;c:do if(b&e){d=c[d>>2]|0;d:do if((c[d+4>>2]&-8|0)!=(g|0)){f=g<<((f|0)==31?0:25-(f>>>1)|0);while(1){b=d+16+(f>>>31<<2)|0;e=c[b>>2]|0;if(!e)break;if((c[e+4>>2]&-8|0)==(g|0)){A=e;break d}else{f=f<<1;d=e}}if(b>>>0<(c[7995]|0)>>>0)ra();else{c[b>>2]=B;c[B+24>>2]=d;c[B+12>>2]=B;c[B+8>>2]=B;break c}}else A=d;while(0);b=A+8|0;d=c[b>>2]|0;z=c[7995]|0;if(d>>>0>=z>>>0&A>>>0>=z>>>0){c[d+12>>2]=B;c[b>>2]=B;c[B+8>>2]=d;c[B+12>>2]=A;c[B+24>>2]=0;break}else ra()}else{c[7992]=b|e;c[d>>2]=B;c[B+24>>2]=d;c[B+12>>2]=B;c[B+8>>2]=B}while(0);B=(c[7999]|0)+-1|0;c[7999]=B;if(!B)b=32420;else break a;while(1){b=c[b>>2]|0;if(!b)break;else b=b+8|0}c[7999]=-1;break a}}while(0);ra()}while(0);return}function sd(){var a=0;if(!(c[7979]|0))a=32460;else a=c[(oa()|0)+60>>2]|0;return a|0}function td(a){a=a|0;var b=0,d=0;d=i;b=i=i+63&-64;i=i+16|0;c[b>>2]=c[a+60>>2];a=pa(6,b|0)|0;if(a>>>0>4294963200){if(!(c[7979]|0))b=32460;else b=c[(oa()|0)+60>>2]|0;c[b>>2]=0-a;a=-1}i=d;return a|0}function ud(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=i;e=i=i+63&-64;i=i+32|0;h=e;e=e+20|0;c[h>>2]=c[a+60>>2];c[h+4>>2]=0;c[h+8>>2]=b;c[h+12>>2]=e;c[h+16>>2]=d;a=ya(140,h|0)|0;if(a>>>0<=4294963200)if((a|0)<0)f=7;else b=c[e>>2]|0;else{if(!(c[7979]|0))b=32460;else b=c[(oa()|0)+60>>2]|0;c[b>>2]=0-a;f=7}if((f|0)==7){c[e>>2]=-1;b=-1}i=g;return b|0}function vd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;q=i;k=i=i+63&-64;i=i+48|0;n=k+16|0;m=k;k=k+32|0;o=a+28|0;g=c[o>>2]|0;c[k>>2]=g;p=a+20|0;g=(c[p>>2]|0)-g|0;c[k+4>>2]=g;c[k+8>>2]=b;c[k+12>>2]=d;j=a+60|0;l=a+44|0;f=2;g=g+d|0;while(1){if(!(c[7979]|0)){c[n>>2]=c[j>>2];c[n+4>>2]=k;c[n+8>>2]=f;b=Aa(146,n|0)|0;if(b>>>0>4294963200){if(!(c[7979]|0))e=32460;else e=c[(oa()|0)+60>>2]|0;c[e>>2]=0-b;b=-1}}else{ua(18,a|0);c[m>>2]=c[j>>2];c[m+4>>2]=k;c[m+8>>2]=f;b=Aa(146,m|0)|0;if(b>>>0>4294963200){if(!(c[7979]|0))e=32460;else e=c[(oa()|0)+60>>2]|0;c[e>>2]=0-b;b=-1}la(0)}if((g|0)==(b|0)){b=13;break}if((b|0)<0){b=15;break}g=g-b|0;e=c[k+4>>2]|0;if(b>>>0<=e>>>0)if((f|0)==2){c[o>>2]=(c[o>>2]|0)+b;h=e;e=k;f=2}else{h=e;e=k}else{h=c[l>>2]|0;c[o>>2]=h;c[p>>2]=h;h=c[k+12>>2]|0;b=b-e|0;e=k+8|0;f=f+-1|0}c[e>>2]=(c[e>>2]|0)+b;c[e+4>>2]=h-b;k=e}if((b|0)==13){n=c[l>>2]|0;c[a+16>>2]=n+(c[a+48>>2]|0);a=n;c[o>>2]=a;c[p>>2]=a}else if((b|0)==15){c[a+16>>2]=0;c[o>>2]=0;c[p>>2]=0;c[a>>2]=c[a>>2]|32;if((f|0)==2)d=0;else d=d-(c[k+4>>2]|0)|0}i=q;return d|0}function wd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;g=i;h=i=i+63&-64;i=i+80|0;f=h;c[b+36>>2]=20;if((c[b>>2]&64|0)==0?(c[f>>2]=c[b+60>>2],c[f+4>>2]=21505,c[f+8>>2]=h+12,(wa(54,f|0)|0)!=0):0)a[b+75>>0]=-1;h=vd(b,d,e)|0;i=g;return h|0}function xd(a){a=a|0;var b=0;if(!a){if(!(c[7990]|0))a=0;else a=xd(c[7990]|0)|0;ma(31944);b=c[7985]|0;if(b)do{if((c[b+20>>2]|0)>>>0>(c[b+28>>2]|0)>>>0)a=Cd(b)|0|a;b=c[b+56>>2]|0}while((b|0)!=0);xa(31944)}else a=Cd(a)|0;return a|0}function yd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;f=d&255;a:do if(!f)b=b+(zd(b)|0)|0;else{if(b&3){e=d&255;do{g=a[b>>0]|0;if(g<<24>>24==0?1:g<<24>>24==e<<24>>24)break a;b=b+1|0}while((b&3|0)!=0)}f=_(f,16843009)|0;e=c[b>>2]|0;b:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{g=e^f;if((g&-2139062144^-2139062144)&g+-16843009)break b;b=b+4|0;e=c[b>>2]|0}while(((e&-2139062144^-2139062144)&e+-16843009|0)==0);while(0);e=d&255;while(1){g=a[b>>0]|0;if(g<<24>>24==0?1:g<<24>>24==e<<24>>24)break;else b=b+1|0}}while(0);return b|0}function zd(b){b=b|0;var d=0,e=0,f=0;f=b;a:do if(!(f&3))e=4;else{d=f;while(1){if(!(a[b>>0]|0)){b=d;break a}b=b+1|0;d=b;if(!(d&3)){e=4;break}}}while(0);if((e|0)==4){while(1){d=c[b>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))b=b+4|0;else break}if((d&255)<<24>>24)do b=b+1|0;while((a[b>>0]|0)!=0)}return b-f|0}function Ad(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;u=a+b|0;h=c[a+4>>2]|0;do if(!(h&1)){m=c[a>>2]|0;if(h&3){o=a+(0-m)|0;h=m+b|0;l=c[7995]|0;if(o>>>0<l>>>0)ra();if((o|0)==(c[7996]|0)){f=a+(b+4)|0;g=c[f>>2]|0;if((g&3|0)!=3){p=54;break}c[7993]=h;c[f>>2]=g&-2;c[a+(4-m)>>2]=h|1;c[u>>2]=h;break}d=m>>>3;if(m>>>0<256){e=c[a+(8-m)>>2]|0;g=c[a+(12-m)>>2]|0;f=32004+(d<<1<<2)|0;do if((e|0)!=(f|0)){if(e>>>0>=l>>>0?(c[e+12>>2]|0)==(o|0):0)break;ra()}while(0);if((g|0)==(e|0)){c[7991]=c[7991]&~(1<<d);p=54;break}do if((g|0)==(f|0))i=g+8|0;else{if(g>>>0>=l>>>0?(j=g+8|0,(c[j>>2]|0)==(o|0)):0){i=j;break}ra()}while(0);c[e+12>>2]=g;c[i>>2]=e;p=54;break}j=c[a+(24-m)>>2]|0;g=c[a+(12-m)>>2]|0;do if((g|0)==(o|0)){f=16-m|0;e=a+(f+4)|0;g=c[e>>2]|0;if(!g){f=a+f|0;g=c[f>>2]|0;if(!g){n=0;break}}else f=e;while(1){e=g+20|0;d=c[e>>2]|0;if(d){g=d;f=e;continue}e=g+16|0;d=c[e>>2]|0;if(!d)break;else{g=d;f=e}}if(f>>>0<l>>>0)ra();else{c[f>>2]=0;n=g;break}}else{f=c[a+(8-m)>>2]|0;if((f>>>0>=l>>>0?(e=f+12|0,(c[e>>2]|0)==(o|0)):0)?(k=g+8|0,(c[k>>2]|0)==(o|0)):0){c[e>>2]=g;c[k>>2]=f;n=g;break}ra()}while(0);if(j){g=c[a+(28-m)>>2]|0;f=32268+(g<<2)|0;if((o|0)==(c[f>>2]|0)){c[f>>2]=n;if(!n){c[7992]=c[7992]&~(1<<g);p=54;break}}else{if(j>>>0<(c[7995]|0)>>>0)ra();g=j+16|0;if((c[g>>2]|0)==(o|0))c[g>>2]=n;else c[j+20>>2]=n;if(!n){p=54;break}}e=c[7995]|0;if(n>>>0<e>>>0)ra();c[n+24>>2]=j;g=16-m|0;f=c[a+g>>2]|0;do if(f)if(f>>>0<e>>>0)ra();else{c[n+16>>2]=f;c[f+24>>2]=n;break}while(0);g=c[a+(g+4)>>2]|0;if(g)if(g>>>0<(c[7995]|0)>>>0)ra();else{c[n+20>>2]=g;c[g+24>>2]=n;p=54;break}else p=54}else p=54}}else{o=a;h=b;p=54}while(0);a:do if((p|0)==54){j=c[7995]|0;if(u>>>0<j>>>0)ra();g=a+(b+4)|0;f=c[g>>2]|0;if(!(f&2)){if((u|0)==(c[7997]|0)){y=(c[7994]|0)+h|0;c[7994]=y;c[7997]=o;c[o+4>>2]=y|1;if((o|0)!=(c[7996]|0))break;c[7996]=0;c[7993]=0;break}if((u|0)==(c[7996]|0)){y=(c[7993]|0)+h|0;c[7993]=y;c[7996]=o;c[o+4>>2]=y|1;c[o+y>>2]=y;break}i=(f&-8)+h|0;e=f>>>3;do if(f>>>0>=256){k=c[a+(b+24)>>2]|0;h=c[a+(b+12)>>2]|0;do if((h|0)==(u|0)){g=a+(b+20)|0;h=c[g>>2]|0;if(!h){g=a+(b+16)|0;h=c[g>>2]|0;if(!h){v=0;break}}while(1){f=h+20|0;e=c[f>>2]|0;if(e){h=e;g=f;continue}f=h+16|0;e=c[f>>2]|0;if(!e)break;else{h=e;g=f}}if(g>>>0<j>>>0)ra();else{c[g>>2]=0;v=h;break}}else{g=c[a+(b+8)>>2]|0;if((g>>>0>=j>>>0?(s=g+12|0,(c[s>>2]|0)==(u|0)):0)?(t=h+8|0,(c[t>>2]|0)==(u|0)):0){c[s>>2]=h;c[t>>2]=g;v=h;break}ra()}while(0);if(k){h=c[a+(b+28)>>2]|0;g=32268+(h<<2)|0;if((u|0)==(c[g>>2]|0)){c[g>>2]=v;if(!v){c[7992]=c[7992]&~(1<<h);break}}else{if(k>>>0<(c[7995]|0)>>>0)ra();h=k+16|0;if((c[h>>2]|0)==(u|0))c[h>>2]=v;else c[k+20>>2]=v;if(!v)break}h=c[7995]|0;if(v>>>0<h>>>0)ra();c[v+24>>2]=k;g=c[a+(b+16)>>2]|0;do if(g)if(g>>>0<h>>>0)ra();else{c[v+16>>2]=g;c[g+24>>2]=v;break}while(0);e=c[a+(b+20)>>2]|0;if(e)if(e>>>0<(c[7995]|0)>>>0)ra();else{c[v+20>>2]=e;c[e+24>>2]=v;break}}}else{f=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;g=32004+(e<<1<<2)|0;do if((f|0)!=(g|0)){if(f>>>0>=j>>>0?(c[f+12>>2]|0)==(u|0):0)break;ra()}while(0);if((h|0)==(f|0)){c[7991]=c[7991]&~(1<<e);break}do if((h|0)==(g|0))q=h+8|0;else{if(h>>>0>=j>>>0?(r=h+8|0,(c[r>>2]|0)==(u|0)):0){q=r;break}ra()}while(0);c[f+12>>2]=h;c[q>>2]=f}while(0);c[o+4>>2]=i|1;c[o+i>>2]=i;if((o|0)==(c[7996]|0)){c[7993]=i;break}else h=i}else{c[g>>2]=f&-2;c[o+4>>2]=h|1;c[o+h>>2]=h}g=h>>>3;if(h>>>0<256){f=g<<1;h=32004+(f<<2)|0;d=c[7991]|0;e=1<<g;if(d&e){e=32004+(f+2<<2)|0;d=c[e>>2]|0;if(d>>>0<(c[7995]|0)>>>0)ra();else{w=e;x=d}}else{c[7991]=d|e;w=32004+(f+2<<2)|0;x=h}c[w>>2]=o;c[x+12>>2]=o;c[o+8>>2]=x;c[o+12>>2]=h;break}d=h>>>8;if(d)if(h>>>0>16777215)g=31;else{w=(d+1048320|0)>>>16&8;x=d<<w;b=(x+520192|0)>>>16&4;x=x<<b;g=(x+245760|0)>>>16&2;g=14-(b|w|g)+(x<<g>>>15)|0;g=h>>>(g+7|0)&1|g<<1}else g=0;e=32268+(g<<2)|0;c[o+28>>2]=g;c[o+20>>2]=0;c[o+16>>2]=0;d=c[7992]|0;f=1<<g;if(!(d&f)){c[7992]=d|f;c[e>>2]=o;c[o+24>>2]=e;c[o+12>>2]=o;c[o+8>>2]=o;break}e=c[e>>2]|0;b:do if((c[e+4>>2]&-8|0)!=(h|0)){g=h<<((g|0)==31?0:25-(g>>>1)|0);while(1){d=e+16+(g>>>31<<2)|0;f=c[d>>2]|0;if(!f)break;if((c[f+4>>2]&-8|0)==(h|0)){y=f;break b}else{g=g<<1;e=f}}if(d>>>0<(c[7995]|0)>>>0)ra();else{c[d>>2]=o;c[o+24>>2]=e;c[o+12>>2]=o;c[o+8>>2]=o;break a}}else y=e;while(0);d=y+8|0;e=c[d>>2]|0;x=c[7995]|0;if(e>>>0>=x>>>0&y>>>0>=x>>>0){c[e+12>>2]=o;c[d>>2]=o;c[o+8>>2]=e;c[o+12>>2]=y;c[o+24>>2]=0;break}else ra()}while(0);return}function Bd(a){a=a|0;return}function Cd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=a+20|0;g=a+28|0;if((c[b>>2]|0)>>>0>(c[g>>2]|0)>>>0?(Fa[c[a+36>>2]&31](a,0,0)|0,(c[b>>2]|0)==0):0)b=-1;else{h=a+4|0;d=c[h>>2]|0;e=a+8|0;f=c[e>>2]|0;if(d>>>0<f>>>0)Fa[c[a+40>>2]&31](a,d-f|0,1)|0;c[a+16>>2]=0;c[g>>2]=0;c[b>>2]=0;c[e>>2]=0;c[h>>2]=0;b=0}return b|0}function Dd(){}function Ed(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=b-d-(c>>>0>a>>>0|0)>>>0;return (C=d,a-c>>>0|0)|0}function Fd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c=a+c>>>0;return (C=b+d+(c>>>0<a>>>0|0)>>>0,c|0)|0}function Gd(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){C=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}C=(b|0)<0?-1:0;return b>>c-32|0}function Hd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;h=b&3;i=d|d<<8|d<<16|d<<24;g=f&~3;if(h){h=b+4-h|0;while((b|0)<(h|0)){a[b>>0]=d;b=b+1|0}}while((b|0)<(g|0)){c[b>>2]=i;b=b+4|0}}while((b|0)<(f|0)){a[b>>0]=d;b=b+1|0}return b-e|0}function Id(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){C=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}C=0;return b>>>c-32|0}function Jd(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){C=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}C=a<<c-32;return 0}function Kd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return va(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if(!e)return f|0;a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function Ld(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b>>0]=a[c>>0]|0}b=e}else Kd(b,c,d)|0;return b|0}function Md(b){b=b|0;var c=0;c=a[m+(b&255)>>0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (a[m+(b>>>24)>>0]|0)+24|0}function Nd(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=a&65535;e=b&65535;c=_(e,f)|0;d=a>>>16;a=(c>>>16)+(_(e,d)|0)|0;e=b>>>16;b=_(e,f)|0;return (C=(a>>>16)+(_(e,d)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|c&65535|0)|0}function Od(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=b>>31|((b|0)<0?-1:0)<<1;i=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;f=d>>31|((d|0)<0?-1:0)<<1;e=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;h=Ed(j^a,i^b,j,i)|0;g=C;a=f^j;b=e^i;return Ed((Td(h,g,Ed(f^c,e^d,f,e)|0,C,0)|0)^a,C^b,a,b)|0}function Pd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;j=f|0;h=b>>31|((b|0)<0?-1:0)<<1;g=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;l=e>>31|((e|0)<0?-1:0)<<1;k=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;a=Ed(h^a,g^b,h,g)|0;b=C;Td(a,b,Ed(l^d,k^e,l,k)|0,C,j)|0;e=Ed(c[j>>2]^h,c[j+4>>2]^g,h,g)|0;d=C;i=f;return (C=d,e)|0}function Qd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;f=c;c=Nd(e,f)|0;a=C;return (C=(_(b,f)|0)+(_(d,e)|0)+a|a&0,c|0|0)|0}function Rd(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Td(a,b,c,d,0)|0}function Sd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;g=i;i=i+16|0;f=g|0;Td(a,b,d,e,f)|0;i=g;return (C=c[f+4>>2]|0,c[f>>2]|0)|0}function Td(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;n=a;l=b;m=l;k=d;o=e;i=o;if(!m){g=(f|0)!=0;if(!i){if(g){c[f>>2]=(n>>>0)%(k>>>0);c[f+4>>2]=0}o=0;f=(n>>>0)/(k>>>0)>>>0;return (C=o,f)|0}else{if(!g){o=0;f=0;return (C=o,f)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;o=0;f=0;return (C=o,f)|0}}j=(i|0)==0;do if(k){if(!j){h=(aa(i|0)|0)-(aa(m|0)|0)|0;if(h>>>0<=31){g=h+1|0;l=31-h|0;k=h-31>>31;i=g;j=n>>>(g>>>0)&k|m<<l;k=m>>>(g>>>0)&k;g=0;h=n<<l;break}if(!f){o=0;f=0;return (C=o,f)|0}c[f>>2]=a|0;c[f+4>>2]=l|b&0;o=0;f=0;return (C=o,f)|0}j=k-1|0;if(j&k){h=(aa(k|0)|0)+33-(aa(m|0)|0)|0;p=64-h|0;l=32-h|0;a=l>>31;b=h-32|0;k=b>>31;i=h;j=l-1>>31&m>>>(b>>>0)|(m<<l|n>>>(h>>>0))&k;k=k&m>>>(h>>>0);g=n<<p&a;h=(m<<p|n>>>(b>>>0))&a|n<<l&h-33>>31;break}if(f){c[f>>2]=j&n;c[f+4>>2]=0}if((k|0)==1){f=l|b&0;p=a|0|0;return (C=f,p)|0}else{p=Md(k|0)|0;f=m>>>(p>>>0)|0;p=m<<32-p|n>>>(p>>>0)|0;return (C=f,p)|0}}else{if(j){if(f){c[f>>2]=(m>>>0)%(k>>>0);c[f+4>>2]=0}f=0;p=(m>>>0)/(k>>>0)>>>0;return (C=f,p)|0}if(!n){if(f){c[f>>2]=0;c[f+4>>2]=(m>>>0)%(i>>>0)}f=0;p=(m>>>0)/(i>>>0)>>>0;return (C=f,p)|0}j=i-1|0;if(!(j&i)){if(f){c[f>>2]=a|0;c[f+4>>2]=j&m|b&0}f=0;p=m>>>((Md(i|0)|0)>>>0);return (C=f,p)|0}h=(aa(i|0)|0)-(aa(m|0)|0)|0;if(h>>>0<=30){k=h+1|0;h=31-h|0;i=k;j=m<<h|n>>>(k>>>0);k=m>>>(k>>>0);g=0;h=n<<h;break}if(!f){f=0;p=0;return (C=f,p)|0}c[f>>2]=a|0;c[f+4>>2]=l|b&0;f=0;p=0;return (C=f,p)|0}while(0);if(!i){l=h;i=0;h=0}else{m=d|0|0;l=o|e&0;b=Fd(m|0,l|0,-1,-1)|0;a=C;d=h;h=0;do{n=d;d=g>>>31|d<<1;g=h|g<<1;n=j<<1|n>>>31|0;e=j>>>31|k<<1|0;Ed(b,a,n,e)|0;p=C;o=p>>31|((p|0)<0?-1:0)<<1;h=o&1;j=Ed(n,e,o&m,(((p|0)<0?-1:0)>>31|((p|0)<0?-1:0)<<1)&l)|0;k=C;i=i-1|0}while((i|0)!=0);l=d;i=0}d=0;if(f){c[f>>2]=j;c[f+4>>2]=k}f=(g|0)>>>31|(l|d)<<1|(d<<1|g>>>31)&0|i;p=(g<<1|0>>>31)&-2|h;return (C=f,p)|0}function Ud(a){a=a|0;return Da[a&31]()|0}function Vd(){return ea(0)|0}function Wd(){return ea(1)|0}function Xd(){return ea(2)|0}function Yd(){return ea(3)|0}function Zd(){return ea(4)|0}function _d(){return ea(5)|0}function $d(){return ea(6)|0}function ae(){return ea(7)|0}function be(a,b){a=a|0;b=b|0;return Ea[a&31](b|0)|0}function ce(a){a=a|0;return ga(0,a|0)|0}function de(a){a=a|0;return ga(1,a|0)|0}function ee(a){a=a|0;return ga(2,a|0)|0}function fe(a){a=a|0;return ga(3,a|0)|0}function ge(a){a=a|0;return ga(4,a|0)|0}function he(a){a=a|0;return ga(5,a|0)|0}function ie(a){a=a|0;return ga(6,a|0)|0}function je(a){a=a|0;return ga(7,a|0)|0}function ke(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Fa[a&31](b|0,c|0,d|0)|0}function le(a,b,c){a=a|0;b=b|0;c=c|0;return ia(0,a|0,b|0,c|0)|0}function me(a,b,c){a=a|0;b=b|0;c=c|0;return ia(1,a|0,b|0,c|0)|0}function ne(a,b,c){a=a|0;b=b|0;c=c|0;return ia(2,a|0,b|0,c|0)|0}function oe(a,b,c){a=a|0;b=b|0;c=c|0;return ia(3,a|0,b|0,c|0)|0}function pe(a,b,c){a=a|0;b=b|0;c=c|0;return ia(4,a|0,b|0,c|0)|0}function qe(a,b,c){a=a|0;b=b|0;c=c|0;return ia(5,a|0,b|0,c|0)|0}function re(a,b,c){a=a|0;b=b|0;c=c|0;return ia(6,a|0,b|0,c|0)|0}function se(a,b,c){a=a|0;b=b|0;c=c|0;return ia(7,a|0,b|0,c|0)|0}function te(a,b){a=a|0;b=b|0;Ga[a&31](b|0)}function ue(a){a=a|0;ka(0,a|0)}function ve(a){a=a|0;ka(1,a|0)}function we(a){a=a|0;ka(2,a|0)}function xe(a){a=a|0;ka(3,a|0)}function ye(a){a=a|0;ka(4,a|0)}function ze(a){a=a|0;ka(5,a|0)}function Ae(a){a=a|0;ka(6,a|0)}function Be(a){a=a|0;ka(7,a|0)}function Ce(){ba(0);return 0}function De(a){a=a|0;ba(1);return 0}function Ee(a,b,c){a=a|0;b=b|0;c=c|0;ba(2);return 0}function Fe(a){a=a|0;ba(3)}

// EMSCRIPTEN_END_FUNCS
var Da=[Ce,Ce,Vd,Ce,Wd,Ce,Xd,Ce,Yd,Ce,Zd,Ce,_d,Ce,$d,Ce,ae,Ce,Ce,Ce,Ce,Ce,Ce,Ce,Ce,Ce,Ce,Ce,Ce,Ce,Ce,Ce];var Ea=[De,De,ce,De,de,De,ee,De,fe,De,ge,De,he,De,ie,De,je,De,td,De,De,De,De,De,De,De,De,De,De,De,De,De];var Fa=[Ee,Ee,le,Ee,me,Ee,ne,Ee,oe,Ee,pe,Ee,qe,Ee,re,Ee,se,Ee,wd,ud,vd,Ee,Ee,Ee,Ee,Ee,Ee,Ee,Ee,Ee,Ee,Ee];var Ga=[Fe,Fe,ue,Fe,ve,Fe,we,Fe,xe,Fe,ye,Fe,ze,Fe,Ae,Fe,Be,Fe,Bd,Fe,Fe,Fe,Fe,Fe,Fe,Fe,Fe,Fe,Fe,Fe,Fe,Fe];return{_sodium_library_version_minor:ld,_crypto_onetimeauth_bytes:Kb,_sodium_version_string:jd,_sodium_hex2bin:id,_crypto_pwhash_scryptsalsa208sha256_memlimit_sensitive:ec,_bitshift64Lshr:Id,_crypto_pwhash_scryptsalsa208sha256:fc,_crypto_box_noncebytes:Za,_crypto_box_beforenm:bb,_crypto_scalarmult_base:nc,_crypto_auth_bytes:Qa,_crypto_sign_open:Gc,_memcpy:Kd,_crypto_box_seed_keypair:$a,_crypto_pwhash_scryptsalsa208sha256_memlimit_interactive:cc,_crypto_box_open_easy_afternm:ib,_crypto_sign_ed25519_sk_to_curve25519:Vc,_sodium_memzero:fd,_crypto_box_seal:kb,_free:rd,_crypto_shorthash:yc,_crypto_auth_keybytes:Ra,_crypto_pwhash_scryptsalsa208sha256_saltbytes:_b,_crypto_sign_seedbytes:Ac,_crypto_box_detached_afternm:cb,_crypto_auth:Sa,_randombytes_random:$c,_crypto_sign_keypair:Ec,_crypto_shorthash_keybytes:xc,_crypto_generichash_statebytes:vb,_crypto_pwhash_scryptsalsa208sha256_str_verify:hc,_crypto_generichash_init:xb,_crypto_generichash_keybytes_max:tb,_crypto_sign_ed25519_pk_to_curve25519:Uc,_crypto_box_beforenmbytes:Ya,_crypto_generichash:wb,_sodium_library_version_major:kd,_randombytes_stir:ad,_randombytes_close:dd,_crypto_onetimeauth_keybytes:Lb,_crypto_onetimeauth:Mb,_crypto_shorthash_bytes:wc,_crypto_box_secretkeybytes:Xa,_crypto_onetimeauth_update:Pb,_crypto_pwhash_scryptsalsa208sha256_ll:Xb,_crypto_box_detached:db,_randombytes_buf:cd,_crypto_pwhash_scryptsalsa208sha256_str:gc,_bitshift64Ashr:Gd,_crypto_box_open_detached:hb,_crypto_scalarmult_bytes:lc,_crypto_auth_verify:Ta,_crypto_box_seal_open:lb,_crypto_secretbox_detached:sc,_crypto_secretbox_easy:tc,_crypto_pwhash_scryptsalsa208sha256_strbytes:$b,_memset:Hd,_crypto_box_open_detached_afternm:gb,_crypto_box_sealbytes:mb,_i64Subtract:Ed,_crypto_pwhash_scryptsalsa208sha256_strprefix:ac,_crypto_box_seedbytes:Va,_crypto_hash:Cb,_crypto_box_easy_afternm:eb,_crypto_box_macbytes:_a,_crypto_box_publickeybytes:Wa,_sodium_bin2hex:hd,_crypto_sign_secretkeybytes:Cc,_crypto_scalarmult_scalarbytes:mc,_crypto_onetimeauth_statebytes:Jb,_crypto_generichash_keybytes_min:sb,_malloc:qd,_memmove:Ld,_crypto_sign:Fc,_crypto_secretbox_noncebytes:qc,_randombytes_set_implementation:_c,_crypto_box_keypair:ab,_crypto_generichash_keybytes:ub,_crypto_generichash_bytes_min:pb,_sodium_init:ed,_crypto_secretbox_macbytes:rc,_crypto_secretbox_keybytes:pc,_bitshift64Shl:Jd,_crypto_hash_bytes:Bb,_fflush:xd,_crypto_generichash_bytes:rb,_crypto_generichash_bytes_max:qb,_crypto_secretbox_open_detached:uc,_sodium_memcmp:gd,_crypto_sign_verify_detached:Ic,_crypto_onetimeauth_verify:Nb,_crypto_box_open_easy:jb,_crypto_pwhash_scryptsalsa208sha256_opslimit_sensitive:dc,_crypto_sign_publickeybytes:Bc,_i64Add:Fd,_crypto_sign_bytes:zc,_crypto_generichash_update:yb,_crypto_scalarmult:oc,_crypto_sign_detached:Hc,_crypto_box_easy:fb,___errno_location:sd,_crypto_onetimeauth_final:Qb,_crypto_secretbox_open_easy:vc,_crypto_generichash_final:zb,_randombytes_uniform:bd,_crypto_sign_seed_keypair:Dc,_crypto_pwhash_scryptsalsa208sha256_opslimit_interactive:bc,_crypto_onetimeauth_init:Ob,runPostSets:Dd,stackAlloc:Ha,stackSave:Ia,stackRestore:Ja,establishStackSpace:Ka,setThrew:La,setTempRet0:Oa,getTempRet0:Pa,dynCall_i:Ud,dynCall_ii:be,dynCall_iiii:ke,dynCall_vi:te}})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var _sodium_library_version_minor=Module["_sodium_library_version_minor"]=asm["_sodium_library_version_minor"];var _crypto_onetimeauth_bytes=Module["_crypto_onetimeauth_bytes"]=asm["_crypto_onetimeauth_bytes"];var _crypto_pwhash_scryptsalsa208sha256_memlimit_sensitive=Module["_crypto_pwhash_scryptsalsa208sha256_memlimit_sensitive"]=asm["_crypto_pwhash_scryptsalsa208sha256_memlimit_sensitive"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var _crypto_pwhash_scryptsalsa208sha256=Module["_crypto_pwhash_scryptsalsa208sha256"]=asm["_crypto_pwhash_scryptsalsa208sha256"];var _crypto_box_noncebytes=Module["_crypto_box_noncebytes"]=asm["_crypto_box_noncebytes"];var _crypto_box_beforenm=Module["_crypto_box_beforenm"]=asm["_crypto_box_beforenm"];var _crypto_scalarmult_base=Module["_crypto_scalarmult_base"]=asm["_crypto_scalarmult_base"];var _crypto_auth_bytes=Module["_crypto_auth_bytes"]=asm["_crypto_auth_bytes"];var _crypto_sign_open=Module["_crypto_sign_open"]=asm["_crypto_sign_open"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var _crypto_box_seed_keypair=Module["_crypto_box_seed_keypair"]=asm["_crypto_box_seed_keypair"];var _crypto_pwhash_scryptsalsa208sha256_memlimit_interactive=Module["_crypto_pwhash_scryptsalsa208sha256_memlimit_interactive"]=asm["_crypto_pwhash_scryptsalsa208sha256_memlimit_interactive"];var _crypto_box_open_easy_afternm=Module["_crypto_box_open_easy_afternm"]=asm["_crypto_box_open_easy_afternm"];var _crypto_sign_ed25519_sk_to_curve25519=Module["_crypto_sign_ed25519_sk_to_curve25519"]=asm["_crypto_sign_ed25519_sk_to_curve25519"];var _sodium_memzero=Module["_sodium_memzero"]=asm["_sodium_memzero"];var _crypto_box_seal=Module["_crypto_box_seal"]=asm["_crypto_box_seal"];var _free=Module["_free"]=asm["_free"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var _crypto_shorthash=Module["_crypto_shorthash"]=asm["_crypto_shorthash"];var _crypto_auth_keybytes=Module["_crypto_auth_keybytes"]=asm["_crypto_auth_keybytes"];var _crypto_pwhash_scryptsalsa208sha256_saltbytes=Module["_crypto_pwhash_scryptsalsa208sha256_saltbytes"]=asm["_crypto_pwhash_scryptsalsa208sha256_saltbytes"];var _crypto_sign_seedbytes=Module["_crypto_sign_seedbytes"]=asm["_crypto_sign_seedbytes"];var _crypto_box_detached_afternm=Module["_crypto_box_detached_afternm"]=asm["_crypto_box_detached_afternm"];var _crypto_auth=Module["_crypto_auth"]=asm["_crypto_auth"];var _randombytes_random=Module["_randombytes_random"]=asm["_randombytes_random"];var _crypto_sign_keypair=Module["_crypto_sign_keypair"]=asm["_crypto_sign_keypair"];var _crypto_generichash_keybytes_min=Module["_crypto_generichash_keybytes_min"]=asm["_crypto_generichash_keybytes_min"];var _crypto_generichash_statebytes=Module["_crypto_generichash_statebytes"]=asm["_crypto_generichash_statebytes"];var _crypto_pwhash_scryptsalsa208sha256_str_verify=Module["_crypto_pwhash_scryptsalsa208sha256_str_verify"]=asm["_crypto_pwhash_scryptsalsa208sha256_str_verify"];var _sodium_version_string=Module["_sodium_version_string"]=asm["_sodium_version_string"];var _crypto_generichash_keybytes_max=Module["_crypto_generichash_keybytes_max"]=asm["_crypto_generichash_keybytes_max"];var _crypto_sign_ed25519_pk_to_curve25519=Module["_crypto_sign_ed25519_pk_to_curve25519"]=asm["_crypto_sign_ed25519_pk_to_curve25519"];var _crypto_sign_publickeybytes=Module["_crypto_sign_publickeybytes"]=asm["_crypto_sign_publickeybytes"];var _crypto_box_beforenmbytes=Module["_crypto_box_beforenmbytes"]=asm["_crypto_box_beforenmbytes"];var _crypto_generichash=Module["_crypto_generichash"]=asm["_crypto_generichash"];var _sodium_library_version_major=Module["_sodium_library_version_major"]=asm["_sodium_library_version_major"];var _randombytes_stir=Module["_randombytes_stir"]=asm["_randombytes_stir"];var _crypto_shorthash_keybytes=Module["_crypto_shorthash_keybytes"]=asm["_crypto_shorthash_keybytes"];var _randombytes_close=Module["_randombytes_close"]=asm["_randombytes_close"];var _crypto_onetimeauth_keybytes=Module["_crypto_onetimeauth_keybytes"]=asm["_crypto_onetimeauth_keybytes"];var _crypto_onetimeauth=Module["_crypto_onetimeauth"]=asm["_crypto_onetimeauth"];var _crypto_shorthash_bytes=Module["_crypto_shorthash_bytes"]=asm["_crypto_shorthash_bytes"];var _crypto_box_secretkeybytes=Module["_crypto_box_secretkeybytes"]=asm["_crypto_box_secretkeybytes"];var _crypto_onetimeauth_update=Module["_crypto_onetimeauth_update"]=asm["_crypto_onetimeauth_update"];var _crypto_pwhash_scryptsalsa208sha256_ll=Module["_crypto_pwhash_scryptsalsa208sha256_ll"]=asm["_crypto_pwhash_scryptsalsa208sha256_ll"];var _crypto_box_detached=Module["_crypto_box_detached"]=asm["_crypto_box_detached"];var _randombytes_buf=Module["_randombytes_buf"]=asm["_randombytes_buf"];var _crypto_pwhash_scryptsalsa208sha256_strbytes=Module["_crypto_pwhash_scryptsalsa208sha256_strbytes"]=asm["_crypto_pwhash_scryptsalsa208sha256_strbytes"];var _bitshift64Ashr=Module["_bitshift64Ashr"]=asm["_bitshift64Ashr"];var _crypto_box_open_detached=Module["_crypto_box_open_detached"]=asm["_crypto_box_open_detached"];var _crypto_scalarmult_bytes=Module["_crypto_scalarmult_bytes"]=asm["_crypto_scalarmult_bytes"];var _crypto_auth_verify=Module["_crypto_auth_verify"]=asm["_crypto_auth_verify"];var _crypto_sign_detached=Module["_crypto_sign_detached"]=asm["_crypto_sign_detached"];var _crypto_secretbox_detached=Module["_crypto_secretbox_detached"]=asm["_crypto_secretbox_detached"];var _crypto_secretbox_easy=Module["_crypto_secretbox_easy"]=asm["_crypto_secretbox_easy"];var _crypto_pwhash_scryptsalsa208sha256_str=Module["_crypto_pwhash_scryptsalsa208sha256_str"]=asm["_crypto_pwhash_scryptsalsa208sha256_str"];var _memset=Module["_memset"]=asm["_memset"];var _crypto_box_open_detached_afternm=Module["_crypto_box_open_detached_afternm"]=asm["_crypto_box_open_detached_afternm"];var _crypto_box_sealbytes=Module["_crypto_box_sealbytes"]=asm["_crypto_box_sealbytes"];var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var _crypto_pwhash_scryptsalsa208sha256_strprefix=Module["_crypto_pwhash_scryptsalsa208sha256_strprefix"]=asm["_crypto_pwhash_scryptsalsa208sha256_strprefix"];var _crypto_box_seedbytes=Module["_crypto_box_seedbytes"]=asm["_crypto_box_seedbytes"];var _crypto_hash=Module["_crypto_hash"]=asm["_crypto_hash"];var _crypto_box_easy_afternm=Module["_crypto_box_easy_afternm"]=asm["_crypto_box_easy_afternm"];var _crypto_box_macbytes=Module["_crypto_box_macbytes"]=asm["_crypto_box_macbytes"];var _crypto_box_publickeybytes=Module["_crypto_box_publickeybytes"]=asm["_crypto_box_publickeybytes"];var _sodium_bin2hex=Module["_sodium_bin2hex"]=asm["_sodium_bin2hex"];var _crypto_sign_secretkeybytes=Module["_crypto_sign_secretkeybytes"]=asm["_crypto_sign_secretkeybytes"];var _crypto_scalarmult_scalarbytes=Module["_crypto_scalarmult_scalarbytes"]=asm["_crypto_scalarmult_scalarbytes"];var _crypto_onetimeauth_statebytes=Module["_crypto_onetimeauth_statebytes"]=asm["_crypto_onetimeauth_statebytes"];var _crypto_generichash_bytes_min=Module["_crypto_generichash_bytes_min"]=asm["_crypto_generichash_bytes_min"];var _malloc=Module["_malloc"]=asm["_malloc"];var _crypto_secretbox_open_easy=Module["_crypto_secretbox_open_easy"]=asm["_crypto_secretbox_open_easy"];var _crypto_sign=Module["_crypto_sign"]=asm["_crypto_sign"];var _crypto_secretbox_noncebytes=Module["_crypto_secretbox_noncebytes"]=asm["_crypto_secretbox_noncebytes"];var _randombytes_set_implementation=Module["_randombytes_set_implementation"]=asm["_randombytes_set_implementation"];var _crypto_box_keypair=Module["_crypto_box_keypair"]=asm["_crypto_box_keypair"];var _crypto_generichash_keybytes=Module["_crypto_generichash_keybytes"]=asm["_crypto_generichash_keybytes"];var _sodium_hex2bin=Module["_sodium_hex2bin"]=asm["_sodium_hex2bin"];var _sodium_init=Module["_sodium_init"]=asm["_sodium_init"];var _crypto_secretbox_macbytes=Module["_crypto_secretbox_macbytes"]=asm["_crypto_secretbox_macbytes"];var _crypto_secretbox_keybytes=Module["_crypto_secretbox_keybytes"]=asm["_crypto_secretbox_keybytes"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var _crypto_hash_bytes=Module["_crypto_hash_bytes"]=asm["_crypto_hash_bytes"];var _fflush=Module["_fflush"]=asm["_fflush"];var _crypto_generichash_bytes=Module["_crypto_generichash_bytes"]=asm["_crypto_generichash_bytes"];var _crypto_generichash_bytes_max=Module["_crypto_generichash_bytes_max"]=asm["_crypto_generichash_bytes_max"];var _crypto_secretbox_open_detached=Module["_crypto_secretbox_open_detached"]=asm["_crypto_secretbox_open_detached"];var _sodium_memcmp=Module["_sodium_memcmp"]=asm["_sodium_memcmp"];var _crypto_sign_verify_detached=Module["_crypto_sign_verify_detached"]=asm["_crypto_sign_verify_detached"];var _crypto_onetimeauth_verify=Module["_crypto_onetimeauth_verify"]=asm["_crypto_onetimeauth_verify"];var _crypto_box_open_easy=Module["_crypto_box_open_easy"]=asm["_crypto_box_open_easy"];var _crypto_pwhash_scryptsalsa208sha256_opslimit_sensitive=Module["_crypto_pwhash_scryptsalsa208sha256_opslimit_sensitive"]=asm["_crypto_pwhash_scryptsalsa208sha256_opslimit_sensitive"];var _crypto_generichash_init=Module["_crypto_generichash_init"]=asm["_crypto_generichash_init"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var _crypto_sign_bytes=Module["_crypto_sign_bytes"]=asm["_crypto_sign_bytes"];var _crypto_generichash_update=Module["_crypto_generichash_update"]=asm["_crypto_generichash_update"];var _crypto_scalarmult=Module["_crypto_scalarmult"]=asm["_crypto_scalarmult"];var _crypto_box_seal_open=Module["_crypto_box_seal_open"]=asm["_crypto_box_seal_open"];var _crypto_box_easy=Module["_crypto_box_easy"]=asm["_crypto_box_easy"];var ___errno_location=Module["___errno_location"]=asm["___errno_location"];var _crypto_onetimeauth_final=Module["_crypto_onetimeauth_final"]=asm["_crypto_onetimeauth_final"];var _memmove=Module["_memmove"]=asm["_memmove"];var _crypto_generichash_final=Module["_crypto_generichash_final"]=asm["_crypto_generichash_final"];var _randombytes_uniform=Module["_randombytes_uniform"]=asm["_randombytes_uniform"];var _crypto_sign_seed_keypair=Module["_crypto_sign_seed_keypair"]=asm["_crypto_sign_seed_keypair"];var _crypto_pwhash_scryptsalsa208sha256_opslimit_interactive=Module["_crypto_pwhash_scryptsalsa208sha256_opslimit_interactive"]=asm["_crypto_pwhash_scryptsalsa208sha256_opslimit_interactive"];var _crypto_onetimeauth_init=Module["_crypto_onetimeauth_init"]=asm["_crypto_onetimeauth_init"];var dynCall_i=Module["dynCall_i"]=asm["dynCall_i"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];Runtime.stackAlloc=asm["stackAlloc"];Runtime.stackSave=asm["stackSave"];Runtime.stackRestore=asm["stackRestore"];Runtime.establishStackSpace=asm["establishStackSpace"];Runtime.setTempRet0=asm["setTempRet0"];Runtime.getTempRet0=asm["getTempRet0"];function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){assert(runDependencies==0,"cannot call main when async dependencies remain! (listen on __ATMAIN__)");assert(__ATPRERUN__.length==0,"cannot call main when preRun functions remain to be called");args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);initialStackTop=Runtime.stackSave();try{var ret=Module["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;Runtime.stackRestore(initialStackTop);return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status,implicit){if(implicit&&Module["noExitRuntime"]){return}if(Module["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["stdout"]["once"]("drain",(function(){process["exit"](status)}));console.log(" ");setTimeout((function(){process["exit"](status)}),500)}else if(ENVIRONMENT_IS_SHELL&&typeof quit==="function"){quit(status)}throw new ExitStatus(status)}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=true;if(Module["noInitialRun"]){shouldRunNow=false}run()




    return Module;
});
